/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/base/common/path","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/network","vs/base/common/errors","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/types","vs/platform/log/common/log","vs/base/common/async","vs/base/common/strings","vs/base/common/buffer","vs/base/common/arrays","vs/platform/files/common/files","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/objects","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","vs/platform/product/common/productService","vs/base/common/process","vs/base/common/uuid","os","vs/base/common/map","fs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/base/common/extpath","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/errorMessage","vs/base/common/codicons","child_process","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/server/node/serverEnvironmentService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/performance","vs/editor/common/core/range","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/request/common/request","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/processes","vs/platform/environment/node/argv","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/base/parts/ipc/node/ipc.net","vs/base/common/functional","vs/base/common/json","vs/base/common/mime","vs/base/common/severity","vs/base/common/glob","vs/base/common/uriIpc","net","vs/platform/extensions/common/extensionValidator","vs/platform/credentials/common/credentials","vs/platform/download/common/download","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/remote/common/remoteHosts","crypto","url","vs/platform/shell/node/shellEnv","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/base/common/decorators","vs/base/common/observableValue","vs/base/common/normalization","vs/base/common/console","vs/base/common/htmlContent","vs/base/common/labels","path","vs/base/node/id","vs/base/node/powershell","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/position","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/common/environmentService","vs/platform/contextkey/common/contextkey","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/languagePacks/node/languagePacks","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/server/node/extensionHostStatusService","vs/server/node/remoteLanguagePacks","vs/server/node/extensionsScannerService","vs/workbench/api/common/extHostTypes","vs/workbench/common/editor","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostTypeConverters","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/remote/common/remoteAgentService","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/amd","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/marked/marked","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/hash","vs/base/common/filters","vs/base/common/iconLabels","vs/base/node/decoder","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/extpath","vs/base/node/ports","vs/base/parts/storage/common/storage","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteAgentEnvironmentImpl","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/editor/common/editor","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/credentials/common/credentialsMainService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/markers/common/markers","vs/platform/credentials/node/credentialsMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/server/node/webClientServer","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostTestItem","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/services/extensions/common/remoteConsoleUtil","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionManagementUtil","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","string_decoder","util","minimist","assert","graceful-fs","yauzl","yazl","http","vs/server/node/server.main"],ye=function(ie){for(var e=[],I=0,t=ie.length;I<t;I++)e[I]=we[ie[I]];return e};define(we[128],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class I{static get(){const b=new Map,P=new Map,k=new Map,E=new Map;function v(y,d){y.has(d.detail)||y.set(d.detail,-d.timestamp)}function D(y,d){let S=y.get(d.detail);!S||S>=0||y.set(d.detail,S+d.timestamp)}const T=ie.getStats().slice(0).sort((y,d)=>y.timestamp-d.timestamp);for(const y of T)switch(y.type){case 10:v(b,y);break;case 11:case 12:D(b,y);break;case 21:v(P,y);break;case 22:D(P,y);break;case 33:v(k,y);break;case 34:D(k,y);break;case 31:v(E,y);break;case 32:D(E,y);break}let R=0;k.forEach(y=>R+=y);function C(y){let d=[];return y.forEach((S,h)=>d.push([h,S])),d}return{amdLoad:C(b),amdInvoke:C(P),nodeRequire:C(k),nodeEval:C(E),nodeRequireTotal:R}}static toMarkdownTable(b,P){let k="",E=[];return b.forEach((v,D)=>{E[D]=v.length}),P.forEach(v=>{v.forEach((D,T)=>{typeof D=="undefined"&&(D=v[T]="-");const R=D.toString().length;E[T]=Math.max(R,E[T])})}),b.forEach((v,D)=>{k+=`| ${v+" ".repeat(E[D]-v.toString().length)} `}),k+=`|
`,b.forEach((v,D)=>{k+=`| ${"-".repeat(E[D])} `}),k+=`|
`,P.forEach(v=>{v.forEach((D,T)=>{typeof D!="undefined"&&(k+=`| ${D+" ".repeat(E[T]-D.toString().length)} `)}),k+=`|
`}),k}}e.LoaderStats=I}),define(we[129],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function I(t,b){if(!t)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=I}),define(we[37],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function I(k){return k?k.replace(/\$\((.*?)\)/g,(E,v)=>` ${v} `).trim():""}e.getCodiconAriaLabel=I;class t{constructor(E,v,D){this.id=E,this.definition=v,this.description=D,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function b(k,E){const v=["codicon","codicon-"+k];return E&&v.push("codicon-modifier-"+E),v}e.getClassNamesArray=b;var P;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const E=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function v(R){if(R instanceof t)return["codicon","codicon-"+R.id];const C=E.exec(R.id);if(!C)return v(t.error);let[,y,d]=C;const S=["codicon","codicon-"+y];return d&&S.push("codicon-modifier-"+d.substr(1)),S}k.asClassNameArray=v;function D(R){return v(R).join(" ")}k.asClassName=D;function T(R){return"."+v(R).join(".")}k.asCSSSelector=T})(P=e.CSSIcon||(e.CSSIcon={}))}),define(we[80],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function I(k){return(E,v,D)=>{let T=null,R=null;if(typeof D.value=="function"?(T="value",R=D.value):typeof D.get=="function"&&(T="get",R=D.get),!R)throw new Error("not supported");D[T]=k(R,v)}}e.createDecorator=I;function t(k,E,v){let D=null,T=null;if(typeof v.value=="function"?(D="value",T=v.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(D="get",T=v.get),!T)throw new Error("not supported");const R=`$memoize$${E}`;v[D]=function(...C){return this.hasOwnProperty(R)||Object.defineProperty(this,R,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,C)}),this[R]}}e.memoize=t;function b(k,E,v){return I((D,T)=>{const R=`$debounce$${T}`,C=`$debounce$result$${T}`;return function(...y){this[C]||(this[C]=v?v():void 0),clearTimeout(this[R]),E&&(this[C]=E(this[C],...y),y=[this[C]]),this[R]=setTimeout(()=>{D.apply(this,y),this[C]=v?v():void 0},k)}})}e.debounce=b;function P(k,E,v){return I((D,T)=>{const R=`$throttle$timer$${T}`,C=`$throttle$result$${T}`,y=`$throttle$lastRun$${T}`,d=`$throttle$pending$${T}`;return function(...S){if(this[C]||(this[C]=v?v():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),E&&(this[C]=E(this[C],...S)),this[d])return;const h=this[y]+k;h<=Date.now()?(this[y]=Date.now(),D.apply(this,[this[C]]),this[C]=v?v():void 0):(this[d]=!0,this[R]=setTimeout(()=>{this[d]=!1,this[y]=Date.now(),D.apply(this,[this[C]]),this[C]=v?v():void 0},h-Date.now()))}})}e.throttle=P}),define(we[9],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class I{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(s=>{s(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=I,e.errorHandler=new I;function t(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=t;function b(u){v(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=b;function P(u){v(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=P;function k(u){if(u instanceof Error){let{name:n,message:s}=u;const i=u.stacktrace||u.stack;return{$isError:!0,name:n,message:s,stack:i}}return u}e.transformErrorForSerialization=k;const E="Canceled";function v(u){return u instanceof D?!0:u instanceof Error&&u.name===E&&u.message===E}e.isCancellationError=v;class D extends Error{constructor(){super(E);this.name=this.message}}e.CancellationError=D;function T(){const u=new Error(E);return u.name=u.message,u}e.canceled=T;function R(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=R;function C(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=C;function y(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function d(u){const n=new Error(`${u} has been disposed`);return n.name="DISPOSED",n}e.disposed=d;function S(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=S;class h extends Error{constructor(n){super("NotImplemented");n&&(this.message=n)}}e.NotImplementedError=h;class g extends Error{constructor(n){super("NotSupported");n&&(this.message=n)}}e.NotSupportedError=g;class p extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=p;class m extends Error{constructor(){super(...arguments);this.logTelemetry=!1}static fromError(n){if(n&&n instanceof m)return n;if(n&&n instanceof Error){const s=new m;return s.name=n.name,s.message=n.message,s.stack=n.stack,s}return new m(n)}}e.ErrorNoTelemetry=m;class l extends Error{constructor(n){super(n||"An unexpected bug occurred.");Object.setPrototypeOf(this,l.prototype);debugger}}e.BugIndicatingError=l}),define(we[17],ye([0,1,9]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function t(z,te=0){return z[z.length-(1+te)]}e.tail=t;function b(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.tail2=b;function P(z,te,ce=(J,se)=>J===se){if(z===te)return!0;if(!z||!te||z.length!==te.length)return!1;for(let J=0,se=z.length;J<se;J++)if(!ce(z[J],te[J]))return!1;return!0}e.equals=P;function k(z,te,ce){return E(z.length,J=>ce(z[J],te))}e.binarySearch=k;function E(z,te){let ce=0,J=z-1;for(;ce<=J;){const se=(ce+J)/2|0,me=te(se);if(me<0)ce=se+1;else if(me>0)J=se-1;else return se}return-(ce+1)}e.binarySearch2=E;function v(z,te){let ce=0,J=z.length;if(J===0)return 0;for(;ce<J;){const se=Math.floor((ce+J)/2);te(z[se])?J=se:ce=se+1}return ce}e.findFirstInSorted=v;function D(z,te,ce){if(z=z|0,z>=te.length)throw new TypeError("invalid index");let J=te[Math.floor(te.length*Math.random())],se=[],me=[],X=[];for(let re of te){const W=ce(re,J);W<0?se.push(re):W>0?me.push(re):X.push(re)}return z<se.length?D(z,se,ce):z<se.length+X.length?X[0]:D(z-(se.length+X.length),me,ce)}e.quickSelect=D;function T(z,te){const ce=[];let J;for(const se of z.slice(0).sort(te))!J||te(J[0],se)!==0?(J=[se],ce.push(J)):J.push(se);return ce}e.groupBy=T;function R(z,te,ce){const J=[];function se(re,W,K){if(W===0&&K.length===0)return;const le=J[J.length-1];le&&le.start+le.deleteCount===re?(le.deleteCount+=W,le.toInsert.push(...K)):J.push({start:re,deleteCount:W,toInsert:K})}let me=0,X=0;for(;;){if(me===z.length){se(me,0,te.slice(X));break}if(X===te.length){se(me,z.length-me,[]);break}const re=z[me],W=te[X],K=ce(re,W);K===0?(me+=1,X+=1):K<0?(se(me,1,[]),me+=1):K>0&&(se(me,0,[W]),X+=1)}return J}e.sortedDiff=R;function C(z,te,ce){const J=R(z,te,ce),se=[],me=[];for(const X of J)se.push(...z.slice(X.start,X.start+X.deleteCount)),me.push(...X.toInsert);return{removed:se,added:me}}e.delta=C;function y(z,te,ce){if(ce===0)return[];const J=z.slice(0,ce).sort(te);return S(z,te,J,ce,z.length),J}e.top=y;function d(z,te,ce,J,se){return ce===0?Promise.resolve([]):new Promise((me,X)=>{(async()=>{const re=z.length,W=z.slice(0,ce).sort(te);for(let K=ce,le=Math.min(ce+J,re);K<re;K=le,le=Math.min(le+J,re)){if(K>ce&&await new Promise(ve=>setTimeout(ve)),se&&se.isCancellationRequested)throw new I.CancellationError;S(z,te,W,K,le)}return W})().then(me,X)})}e.topAsync=d;function S(z,te,ce,J,se){for(const me=ce.length;J<se;J++){const X=z[J];if(te(X,ce[me-1])<0){ce.pop();const re=v(ce,W=>te(X,W)<0);ce.splice(re,0,X)}}}function h(z){return z.filter(te=>!!te)}e.coalesce=h;function g(z){let te=0;for(let ce=0;ce<z.length;ce++)z[ce]&&(z[te]=z[ce],te+=1);z.length=te}e.coalesceInPlace=g;function p(z,te,ce){z.splice(ce,0,z.splice(te,1)[0])}e.move=p;function m(z){return!Array.isArray(z)||z.length===0}e.isFalsyOrEmpty=m;function l(z){return Array.isArray(z)&&z.length>0}e.isNonEmptyArray=l;function u(z,te=ce=>ce){const ce=new Set;return z.filter(J=>{const se=te(J);return ce.has(se)?!1:(ce.add(se),!0)})}e.distinct=u;function n(z){const te=new Set;return ce=>{const J=z(ce);return te.has(J)?!1:(te.add(J),!0)}}e.uniqueFilter=n;function s(z,te){const ce=i(z,te);if(ce!==-1)return z[ce]}e.findLast=s;function i(z,te){for(let ce=z.length-1;ce>=0;ce--){const J=z[ce];if(te(J))return ce}return-1}e.lastIndex=i;function o(z,te){return z.length>0?z[0]:te}e.firstOrDefault=o;function r(z,te){return z.length>0?z[z.length-1]:te}e.lastOrDefault=r;function a(z,te,ce=(J,se)=>J===se){let J=0;for(let se=0,me=Math.min(z.length,te.length);se<me&&ce(z[se],te[se]);se++)J++;return J}e.commonPrefixLength=a;function c(z){return[].concat(...z)}e.flatten=c;function f(z,te){let ce=typeof te=="number"?z:0;typeof te=="number"?ce=z:(ce=0,te=z);const J=[];if(ce<=te)for(let se=ce;se<te;se++)J.push(se);else for(let se=ce;se>te;se--)J.push(se);return J}e.range=f;function w(z,te,ce){return z.reduce((J,se)=>(J[te(se)]=ce?ce(se):se,J),Object.create(null))}e.index=w;function A(z,te){return z.push(te),()=>U(z,te)}e.insert=A;function U(z,te){const ce=z.indexOf(te);if(ce>-1)return z.splice(ce,1),te}e.remove=U;function x(z,te,ce){const J=z.slice(0,te),se=z.slice(te);return J.concat(ce,se)}e.arrayInsert=x;function Q(z,te){let ce;if(typeof te=="number"){let J=te;ce=()=>{const se=Math.sin(J++)*179426549;return se-Math.floor(se)}}else ce=Math.random;for(let J=z.length-1;J>0;J-=1){const se=Math.floor(ce()*(J+1)),me=z[J];z[J]=z[se],z[se]=me}}e.shuffle=Q;function _(z,te){const ce=z.indexOf(te);ce>-1&&(z.splice(ce,1),z.unshift(te))}e.pushToStart=_;function Y(z,te){const ce=z.indexOf(te);ce>-1&&(z.splice(ce,1),z.push(te))}e.pushToEnd=Y;function O(z,te){for(const ce of te)z.push(ce)}e.pushMany=O;function B(z,te){return Array.isArray(z)?z.map(te):te(z)}e.mapArrayOrNot=B;function ue(z){return Array.isArray(z)?z:[z]}e.asArray=ue;function V(z){return z[Math.floor(Math.random()*z.length)]}e.getRandomElement=V;function $(z,te){for(const ce of z){const J=te(ce);if(J!==void 0)return J}}e.mapFind=$;function F(z,te,ce){const J=j(z,te),se=z.length,me=ce.length;z.length=se+me;for(let X=se-1;X>=J;X--)z[X+me]=z[X];for(let X=0;X<me;X++)z[X+J]=ce[X]}e.insertInto=F;function M(z,te,ce,J){const se=j(z,te),me=z.splice(se,ce);return F(z,se,J),me}e.splice=M;function j(z,te){return te<0?Math.max(te+z.length,0):Math.min(te,z.length)}var Z;(function(z){function te(se){return se<0}z.isLessThan=te;function ce(se){return se>0}z.isGreaterThan=ce;function J(se){return se===0}z.isNeitherLessOrGreaterThan=J,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(Z=e.CompareResult||(e.CompareResult={}));function oe(z,te){return(ce,J)=>te(z(ce),z(J))}e.compareBy=oe;const ge=(z,te)=>z-te;e.numberComparator=ge;function he(z,te){if(z.length===0)return;let ce=z[0];for(let J=1;J<z.length;J++){const se=z[J];te(se,ce)>0&&(ce=se)}return ce}e.findMaxBy=he;function q(z,te){if(z.length===0)return;let ce=z[0];for(let J=1;J<z.length;J++){const se=z[J];te(se,ce)>=0&&(ce=se)}return ce}e.findLastMaxBy=q;function ee(z,te){return he(z,(ce,J)=>-te(ce,J))}e.findMinBy=ee;class G{constructor(te){this.items=te,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(te){let ce=this.firstIdx;for(;ce<this.items.length&&te(this.items[ce]);)ce++;const J=ce===this.firstIdx?null:this.items.slice(this.firstIdx,ce);return this.firstIdx=ce,J}takeFromEndWhile(te){let ce=this.lastIdx;for(;ce>=0&&te(this.items[ce]);)ce--;const J=ce===this.lastIdx?null:this.items.slice(ce+1,this.lastIdx+1);return this.lastIdx=ce,J}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const te=this.items[this.firstIdx];return this.firstIdx++,te}removeLast(){const te=this.items[this.lastIdx];return this.lastIdx--,te}takeCount(te){const ce=this.items.slice(this.firstIdx,this.firstIdx+te);return this.firstIdx+=te,ce}}e.ArrayQueue=G}),define(we[62],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function I(t){const b=this;let P=!1,k;return function(){return P||(P=!0,k=t.apply(b,arguments)),k}}e.once=I}),define(we[43],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(t){function b(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}t.is=b;const P=Object.freeze([]);function k(){return P}t.empty=k;function*E(s){yield s}t.single=E;function v(s){return s||P}t.from=v;function D(s){return!s||s[Symbol.iterator]().next().done===!0}t.isEmpty=D;function T(s){return s[Symbol.iterator]().next().value}t.first=T;function R(s,i){for(const o of s)if(i(o))return!0;return!1}t.some=R;function C(s,i){for(const o of s)if(i(o))return o}t.find=C;function*y(s,i){for(const o of s)i(o)&&(yield o)}t.filter=y;function*d(s,i){let o=0;for(const r of s)yield i(r,o++)}t.map=d;function*S(...s){for(const i of s)for(const o of i)yield o}t.concat=S;function*h(s){for(const i of s)for(const o of i)yield o}t.concatNested=h;function g(s,i,o){let r=o;for(const a of s)r=i(r,a);return r}t.reduce=g;function p(s,i){let o=0;for(const r of s)i(r,o++)}t.forEach=p;function*m(s,i,o=s.length){for(i<0&&(i+=s.length),o<0?o+=s.length:o>s.length&&(o=s.length);i<o;i++)yield s[i]}t.slice=m;function l(s,i=Number.POSITIVE_INFINITY){const o=[];if(i===0)return[o,s];const r=s[Symbol.iterator]();for(let a=0;a<i;a++){const c=r.next();if(c.done)return[o,t.empty()];o.push(c.value)}return[o,{[Symbol.iterator](){return r}}]}t.consume=l;function u(s){return l(s)[0]}t.collect=u;function n(s,i,o=(r,a)=>r===a){const r=s[Symbol.iterator](),a=i[Symbol.iterator]();for(;;){const c=r.next(),f=a.next();if(c.done!==f.done)return!1;if(c.done)return!0;if(!o(c.value,f.value))return!1}}t.equals=n})(I=e.Iterable||(e.Iterable={}))}),define(we[63],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(I=e.ScanError||(e.ScanError={}));var t;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var b;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(b=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(n){n.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function k(n,s=!1){let i=0,o=n.length,r="",a=0,c=16,f=0;function w(O){let B=0,ue=0;for(;B<O;){const V=n.charCodeAt(i);if(V>=48&&V<=57)ue=ue*16+V-48;else if(V>=65&&V<=70)ue=ue*16+V-65+10;else if(V>=97&&V<=102)ue=ue*16+V-97+10;else break;i++,B++}return B<O&&(ue=-1),ue}function A(O){i=O,r="",a=0,c=16,f=0}function U(){const O=i;if(n.charCodeAt(i)===48)i++;else for(i++;i<n.length&&D(n.charCodeAt(i));)i++;if(i<n.length&&n.charCodeAt(i)===46)if(i++,i<n.length&&D(n.charCodeAt(i)))for(i++;i<n.length&&D(n.charCodeAt(i));)i++;else return f=3,n.substring(O,i);let B=i;if(i<n.length&&(n.charCodeAt(i)===69||n.charCodeAt(i)===101))if(i++,(i<n.length&&n.charCodeAt(i)===43||n.charCodeAt(i)===45)&&i++,i<n.length&&D(n.charCodeAt(i))){for(i++;i<n.length&&D(n.charCodeAt(i));)i++;B=i}else f=3;return n.substring(O,B)}function x(){let O="",B=i;for(;;){if(i>=o){O+=n.substring(B,i),f=2;break}const ue=n.charCodeAt(i);if(ue===34){O+=n.substring(B,i),i++;break}if(ue===92){if(O+=n.substring(B,i),i++,i>=o){f=2;break}switch(n.charCodeAt(i++)){case 34:O+='"';break;case 92:O+="\\";break;case 47:O+="/";break;case 98:O+="\b";break;case 102:O+="\f";break;case 110:O+=`
`;break;case 114:O+="\r";break;case 116:O+="	";break;case 117:{const $=w(4);$>=0?O+=String.fromCharCode($):f=4;break}default:f=5}B=i;continue}if(ue>=0&&ue<=31)if(v(ue)){O+=n.substring(B,i),f=2;break}else f=6;i++}return O}function Q(){if(r="",f=0,a=i,i>=o)return a=o,c=17;let O=n.charCodeAt(i);if(E(O)){do i++,r+=String.fromCharCode(O),O=n.charCodeAt(i);while(E(O));return c=15}if(v(O))return i++,r+=String.fromCharCode(O),O===13&&n.charCodeAt(i)===10&&(i++,r+=`
`),c=14;switch(O){case 123:return i++,c=1;case 125:return i++,c=2;case 91:return i++,c=3;case 93:return i++,c=4;case 58:return i++,c=6;case 44:return i++,c=5;case 34:return i++,r=x(),c=10;case 47:{const B=i-1;if(n.charCodeAt(i+1)===47){for(i+=2;i<o&&!v(n.charCodeAt(i));)i++;return r=n.substring(B,i),c=12}if(n.charCodeAt(i+1)===42){i+=2;const ue=o-1;let V=!1;for(;i<ue;){if(n.charCodeAt(i)===42&&n.charCodeAt(i+1)===47){i+=2,V=!0;break}i++}return V||(i++,f=1),r=n.substring(B,i),c=13}return r+=String.fromCharCode(O),i++,c=16}case 45:if(r+=String.fromCharCode(O),i++,i===o||!D(n.charCodeAt(i)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=U(),c=11;default:for(;i<o&&_(O);)i++,O=n.charCodeAt(i);if(a!==i){switch(r=n.substring(a,i),r){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return r+=String.fromCharCode(O),i++,c=16}}function _(O){if(E(O)||v(O))return!1;switch(O){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Y(){let O;do O=Q();while(O>=12&&O<=15);return O}return{setPosition:A,getPosition:()=>i,scan:s?Y:Q,getToken:()=>c,getTokenValue:()=>r,getTokenOffset:()=>a,getTokenLength:()=>i-a,getTokenError:()=>f}}e.createScanner=k;function E(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function v(n){return n===10||n===13||n===8232||n===8233}function D(n){return n>=48&&n<=57}var T;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(T||(T={}));function R(n,s){const i=[],o=new Object;let r;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function f(w,A,U,x){a.value=w,a.offset=A,a.length=U,a.type=x,a.colonOffset=void 0,r=a}try{m(n,{onObjectBegin:(w,A)=>{if(s<=w)throw o;r=void 0,c=s>w,i.push("")},onObjectProperty:(w,A,U)=>{if(s<A||(f(w,A,U,"property"),i[i.length-1]=w,s<=A+U))throw o},onObjectEnd:(w,A)=>{if(s<=w)throw o;r=void 0,i.pop()},onArrayBegin:(w,A)=>{if(s<=w)throw o;r=void 0,i.push(0)},onArrayEnd:(w,A)=>{if(s<=w)throw o;r=void 0,i.pop()},onLiteralValue:(w,A,U)=>{if(s<A||(f(w,A,U,u(w)),s<=A+U))throw o},onSeparator:(w,A,U)=>{if(s<=A)throw o;if(w===":"&&r&&r.type==="property")r.colonOffset=A,c=!1,r=void 0;else if(w===","){const x=i[i.length-1];typeof x=="number"?i[i.length-1]=x+1:(c=!0,i[i.length-1]=""),r=void 0}}})}catch(w){if(w!==o)throw w}return{path:i,previousNode:r,isAtPropertyKey:c,matches:w=>{let A=0;for(let U=0;A<w.length&&U<i.length;U++)if(w[A]===i[U]||w[A]==="*")A++;else if(w[A]!=="**")return!1;return A===w.length}}}e.getLocation=R;function C(n,s=[],i=P.DEFAULT){let o=null,r=[];const a=[];function c(w){Array.isArray(r)?r.push(w):o!==null&&(r[o]=w)}return m(n,{onObjectBegin:()=>{const w={};c(w),a.push(r),r=w,o=null},onObjectProperty:w=>{o=w},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const w=[];c(w),a.push(r),r=w,o=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:c,onError:(w,A,U)=>{s.push({error:w,offset:A,length:U})}},i),r[0]}e.parse=C;function y(n,s=[],i=P.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(w){o.type==="property"&&(o.length=w-o.offset,o=o.parent)}function a(w){return o.children.push(w),w}m(n,{onObjectBegin:w=>{o=a({type:"object",offset:w,length:-1,parent:o,children:[]})},onObjectProperty:(w,A,U)=>{o=a({type:"property",offset:A,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:w,offset:A,length:U,parent:o})},onObjectEnd:(w,A)=>{o.length=w+A-o.offset,o=o.parent,r(w+A)},onArrayBegin:(w,A)=>{o=a({type:"array",offset:w,length:-1,parent:o,children:[]})},onArrayEnd:(w,A)=>{o.length=w+A-o.offset,o=o.parent,r(w+A)},onLiteralValue:(w,A,U)=>{a({type:u(w),offset:A,length:U,parent:o,value:w}),r(A+U)},onSeparator:(w,A,U)=>{o.type==="property"&&(w===":"?o.colonOffset=A:w===","&&r(A))},onError:(w,A,U)=>{s.push({error:w,offset:A,length:U})}},i);const f=o.children[0];return f&&delete f.parent,f}e.parseTree=y;function d(n,s){if(!n)return;let i=n;for(let o of s)if(typeof o=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const a of i.children)if(Array.isArray(a.children)&&a.children[0].value===o){i=a.children[1],r=!0;break}if(!r)return}else{const r=o;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}e.findNodeAtLocation=d;function S(n){if(!n.parent||!n.parent.children)return[];const s=S(n.parent);if(n.parent.type==="property"){const i=n.parent.children[0].value;s.push(i)}else if(n.parent.type==="array"){const i=n.parent.children.indexOf(n);i!==-1&&s.push(i)}return s}e.getNodePath=S;function h(n){switch(n.type){case"array":return n.children.map(h);case"object":{const s=Object.create(null);for(let i of n.children){const o=i.children[1];o&&(s[i.children[0].value]=h(o))}return s}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=h;function g(n,s,i=!1){return s>=n.offset&&s<n.offset+n.length||i&&s===n.offset+n.length}e.contains=g;function p(n,s,i=!1){if(g(n,s,i)){const o=n.children;if(Array.isArray(o))for(let r=0;r<o.length&&o[r].offset<=s;r++){const a=p(o[r],s,i);if(a)return a}return n}}e.findNodeAtOffset=p;function m(n,s,i=P.DEFAULT){const o=k(n,!1);function r(ge){return ge?()=>ge(o.getTokenOffset(),o.getTokenLength()):()=>!0}function a(ge){return ge?he=>ge(he,o.getTokenOffset(),o.getTokenLength()):()=>!0}const c=r(s.onObjectBegin),f=a(s.onObjectProperty),w=r(s.onObjectEnd),A=r(s.onArrayBegin),U=r(s.onArrayEnd),x=a(s.onLiteralValue),Q=a(s.onSeparator),_=r(s.onComment),Y=a(s.onError),O=i&&i.disallowComments,B=i&&i.allowTrailingComma;function ue(){for(;;){const ge=o.scan();switch(o.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:O||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(ge){case 12:case 13:O?V(10):_();break;case 16:V(1);break;case 15:case 14:break;default:return ge}}}function V(ge,he=[],q=[]){if(Y(ge),he.length+q.length>0){let ee=o.getToken();for(;ee!==17;){if(he.indexOf(ee)!==-1){ue();break}else if(q.indexOf(ee)!==-1)break;ee=ue()}}}function $(ge){const he=o.getTokenValue();return ge?x(he):f(he),ue(),!0}function F(){switch(o.getToken()){case 11:{let ge=0;try{ge=JSON.parse(o.getTokenValue()),typeof ge!="number"&&(V(2),ge=0)}catch{V(2)}x(ge);break}case 7:x(null);break;case 8:x(!0);break;case 9:x(!1);break;default:return!1}return ue(),!0}function M(){return o.getToken()!==10?(V(3,[],[2,5]),!1):($(!1),o.getToken()===6?(Q(":"),ue(),oe()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function j(){c(),ue();let ge=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(ge||V(4,[],[]),Q(","),ue(),o.getToken()===2&&B)break}else ge&&V(6,[],[]);M()||V(4,[],[2,5]),ge=!0}return w(),o.getToken()!==2?V(7,[2],[]):ue(),!0}function Z(){A(),ue();let ge=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(ge||V(4,[],[]),Q(","),ue(),o.getToken()===4&&B)break}else ge&&V(6,[],[]);oe()||V(4,[],[4,5]),ge=!0}return U(),o.getToken()!==4?V(8,[4],[]):ue(),!0}function oe(){switch(o.getToken()){case 3:return Z();case 1:return j();case 10:return $(!0);default:return F()}}return ue(),o.getToken()===17?i.allowEmptyContent?!0:(V(4,[],[]),!1):oe()?(o.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.visit=m;function l(n,s){let i=k(n),o=[],r,a=0,c;do switch(c=i.getPosition(),r=i.scan(),r){case 12:case 13:case 17:a!==c&&o.push(n.substring(a,c)),s!==void 0&&o.push(i.getTokenValue().replace(/[^\r\n]/g,s)),a=i.getPosition();break}while(r!==17);return o.join("")}e.stripComments=l;function u(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(we[130],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class I{constructor(b){this.executor=b,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(b){this._error=b}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(b){return new I(()=>b(this.getValue()))}}e.Lazy=I}),define(we[2],ye([0,1,62,43]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const b=!1;let P=null;function k(r){P=r}if(e.setDisposableTracker=k,b){const r="__is_disposable_tracked__";k(new class{trackDisposable(a){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[r]||console.log(c)},3e3)}setParent(a,c){if(a&&a!==p.None)try{a[r]=!0}catch{}}markAsDisposed(a){if(a&&a!==p.None)try{a[r]=!0}catch{}}markAsSingleton(a){}})}function E(r){return P?.trackDisposable(r),r}function v(r){P?.markAsDisposed(r)}function D(r,a){P?.setParent(r,a)}function T(r,a){if(!!P)for(const c of r)P.setParent(c,a)}function R(r){return P?.markAsSingleton(r),r}e.markAsSingleton=R;class C extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=C;function y(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=y;function d(r){if(t.Iterable.is(r)){let a=[];for(const c of r)if(c)try{c.dispose()}catch(f){a.push(f)}if(a.length===1)throw a[0];if(a.length>1)throw new C(a);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=d;function S(...r){const a=h(()=>d(r));return T(r,a),a}e.combinedDisposable=S;function h(r){const a=E({dispose:(0,I.once)(()=>{v(a),r()})});return a}e.toDisposable=h;class g{constructor(){this._toDispose=new Set,this._isDisposed=!1,E(this)}dispose(){this._isDisposed||(v(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return D(a,this),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class p{constructor(){this._store=new g,E(this),D(this._store,this)}dispose(){v(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=p,p.None=Object.freeze({dispose(){}});class m{constructor(){this._isDisposed=!1,E(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&D(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,v(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&D(a,null),a}}e.MutableDisposable=m;class l{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=l;class u{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(a){let c=a;return this.unset=()=>c=void 0,this.isset=()=>c!==void 0,this.dispose=()=>{c&&(c(),c=void 0,v(this))},this}}e.SafeDisposable=u;class n{constructor(){this.references=new Map}acquire(a,...c){let f=this.references.get(a);f||(f={counter:0,object:this.createReferencedObject(a,...c)},this.references.set(a,f));const{object:w}=f,A=(0,I.once)(()=>{--f.counter==0&&(this.destroyReferencedObject(a,f.object),this.references.delete(a))});return f.counter++,{object:w,dispose:A}}}e.ReferenceCollection=n;class s{constructor(a){this.referenceCollection=a}async acquire(a,...c){const f=this.referenceCollection.acquire(a,...c);try{return{object:await f.object,dispose:()=>f.dispose()}}catch(w){throw f.dispose(),w}}}e.AsyncReferenceCollection=s;class i{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=i;function o(r){const a=new g;try{r(a)}finally{a.dispose()}}e.disposeOnReturn=o}),define(we[131],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class I{constructor(P){this.element=P,this.next=I.Undefined,this.prev=I.Undefined}}I.Undefined=new I(void 0);class t{constructor(){this._first=I.Undefined,this._last=I.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===I.Undefined}clear(){let P=this._first;for(;P!==I.Undefined;){const k=P.next;P.prev=I.Undefined,P.next=I.Undefined,P=k}this._first=I.Undefined,this._last=I.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,k){const E=new I(P);if(this._first===I.Undefined)this._first=E,this._last=E;else if(k){const D=this._last;this._last=E,E.prev=D,D.next=E}else{const D=this._first;this._first=E,E.next=D,D.prev=E}this._size+=1;let v=!1;return()=>{v||(v=!0,this._remove(E))}}shift(){if(this._first!==I.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==I.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==I.Undefined&&P.next!==I.Undefined){const k=P.prev;k.next=P.next,P.next.prev=k}else P.prev===I.Undefined&&P.next===I.Undefined?(this._first=I.Undefined,this._last=I.Undefined):P.next===I.Undefined?(this._last=this._last.prev,this._last.next=I.Undefined):P.prev===I.Undefined&&(this._first=this._first.next,this._first.prev=I.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==I.Undefined;)yield P.element,P=P.next}}e.LinkedList=t}),function(ie,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(we[132],ye([1]),e):(ie=typeof globalThis!="undefined"?globalThis:ie||self,e(ie.marked={}))}(this,function(ie){"use strict";function e(J,se){for(var me=0;me<se.length;me++){var X=se[me];X.enumerable=X.enumerable||!1,X.configurable=!0,"value"in X&&(X.writable=!0),Object.defineProperty(J,X.key,X)}}function I(J,se,me){return se&&e(J.prototype,se),me&&e(J,me),Object.defineProperty(J,"prototype",{writable:!1}),J}function t(J,se){if(!!J){if(typeof J=="string")return b(J,se);var me=Object.prototype.toString.call(J).slice(8,-1);if(me==="Object"&&J.constructor&&(me=J.constructor.name),me==="Map"||me==="Set")return Array.from(J);if(me==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(me))return b(J,se)}}function b(J,se){(se==null||se>J.length)&&(se=J.length);for(var me=0,X=new Array(se);me<se;me++)X[me]=J[me];return X}function P(J,se){var me=typeof Symbol!="undefined"&&J[Symbol.iterator]||J["@@iterator"];if(me)return(me=me.call(J)).next.bind(me);if(Array.isArray(J)||(me=t(J))||se&&J&&typeof J.length=="number"){me&&(J=me);var X=0;return function(){return X>=J.length?{done:!0}:{done:!1,value:J[X++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function k(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ie.defaults=k();function E(J){ie.defaults=J}var v=/[&<>"']/,D=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,R=/[<>"']|&(?!#?\w+;)/g,C={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(se){return C[se]};function d(J,se){if(se){if(v.test(J))return J.replace(D,y)}else if(T.test(J))return J.replace(R,y);return J}var S=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(J){return J.replace(S,function(se,me){return me=me.toLowerCase(),me==="colon"?":":me.charAt(0)==="#"?me.charAt(1)==="x"?String.fromCharCode(parseInt(me.substring(2),16)):String.fromCharCode(+me.substring(1)):""})}var g=/(^|[^\[])\^/g;function p(J,se){J=typeof J=="string"?J:J.source,se=se||"";var me={replace:function(re,W){return W=W.source||W,W=W.replace(g,"$1"),J=J.replace(re,W),me},getRegex:function(){return new RegExp(J,se)}};return me}var m=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(J,se,me){if(J){var X;try{X=decodeURIComponent(h(me)).replace(m,"").toLowerCase()}catch{return null}if(X.indexOf("javascript:")===0||X.indexOf("vbscript:")===0||X.indexOf("data:")===0)return null}se&&!l.test(me)&&(me=r(se,me));try{me=encodeURI(me).replace(/%25/g,"%")}catch{return null}return me}var n={},s=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(J,se){n[" "+J]||(s.test(J)?n[" "+J]=J+"/":n[" "+J]=w(J,"/",!0)),J=n[" "+J];var me=J.indexOf(":")===-1;return se.substring(0,2)==="//"?me?se:J.replace(i,"$1")+se:se.charAt(0)==="/"?me?se:J.replace(o,"$1")+se:J+se}var a={exec:function(){}};function c(J){for(var se=1,me,X;se<arguments.length;se++){me=arguments[se];for(X in me)Object.prototype.hasOwnProperty.call(me,X)&&(J[X]=me[X])}return J}function f(J,se){var me=J.replace(/\|/g,function(W,K,le){for(var ve=!1,De=K;--De>=0&&le[De]==="\\";)ve=!ve;return ve?"|":" |"}),X=me.split(/ \|/),re=0;if(X[0].trim()||X.shift(),X.length>0&&!X[X.length-1].trim()&&X.pop(),X.length>se)X.splice(se);else for(;X.length<se;)X.push("");for(;re<X.length;re++)X[re]=X[re].trim().replace(/\\\|/g,"|");return X}function w(J,se,me){var X=J.length;if(X===0)return"";for(var re=0;re<X;){var W=J.charAt(X-re-1);if(W===se&&!me)re++;else if(W!==se&&me)re++;else break}return J.slice(0,X-re)}function A(J,se){if(J.indexOf(se[1])===-1)return-1;for(var me=J.length,X=0,re=0;re<me;re++)if(J[re]==="\\")re++;else if(J[re]===se[0])X++;else if(J[re]===se[1]&&(X--,X<0))return re;return-1}function U(J){J&&J.sanitize&&!J.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function x(J,se){if(se<1)return"";for(var me="";se>1;)se&1&&(me+=J),se>>=1,J+=J;return me+J}function Q(J,se,me,X){var re=se.href,W=se.title?d(se.title):null,K=J[1].replace(/\\([\[\]])/g,"$1");if(J[0].charAt(0)!=="!"){X.state.inLink=!0;var le={type:"link",raw:me,href:re,title:W,text:K,tokens:X.inlineTokens(K,[])};return X.state.inLink=!1,le}return{type:"image",raw:me,href:re,title:W,text:d(K)}}function _(J,se){var me=J.match(/^(\s+)(?:```)/);if(me===null)return se;var X=me[1];return se.split(`
`).map(function(re){var W=re.match(/^\s+/);if(W===null)return re;var K=W[0];return K.length>=X.length?re.slice(X.length):re}).join(`
`)}var Y=function(){function J(me){this.options=me||ie.defaults}var se=J.prototype;return se.space=function(X){var re=this.rules.block.newline.exec(X);if(re&&re[0].length>0)return{type:"space",raw:re[0]}},se.code=function(X){var re=this.rules.block.code.exec(X);if(re){var W=re[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:re[0],codeBlockStyle:"indented",text:this.options.pedantic?W:w(W,`
`)}}},se.fences=function(X){var re=this.rules.block.fences.exec(X);if(re){var W=re[0],K=_(W,re[3]||"");return{type:"code",raw:W,lang:re[2]?re[2].trim():re[2],text:K}}},se.heading=function(X){var re=this.rules.block.heading.exec(X);if(re){var W=re[2].trim();if(/#$/.test(W)){var K=w(W,"#");(this.options.pedantic||!K||/ $/.test(K))&&(W=K.trim())}var le={type:"heading",raw:re[0],depth:re[1].length,text:W,tokens:[]};return this.lexer.inline(le.text,le.tokens),le}},se.hr=function(X){var re=this.rules.block.hr.exec(X);if(re)return{type:"hr",raw:re[0]}},se.blockquote=function(X){var re=this.rules.block.blockquote.exec(X);if(re){var W=re[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:re[0],tokens:this.lexer.blockTokens(W,[]),text:W}}},se.list=function(X){var re=this.rules.block.list.exec(X);if(re){var W,K,le,ve,De,Te,Oe,Ue,de,be,pe,_e,Ne=re[1].trim(),qe=Ne.length>1,ze={type:"list",raw:"",ordered:qe,start:qe?+Ne.slice(0,-1):"",loose:!1,items:[]};Ne=qe?"\\d{1,9}\\"+Ne.slice(-1):"\\"+Ne,this.options.pedantic&&(Ne=qe?Ne:"[*+-]");for(var He=new RegExp("^( {0,3}"+Ne+")((?:[	 ][^\\n]*)?(?:\\n|$))");X&&(_e=!1,!(!(re=He.exec(X))||this.rules.block.hr.test(X)));){if(W=re[0],X=X.substring(W.length),Ue=re[2].split(`
`,1)[0],de=X.split(`
`,1)[0],this.options.pedantic?(ve=2,pe=Ue.trimLeft()):(ve=re[2].search(/[^ ]/),ve=ve>4?1:ve,pe=Ue.slice(ve),ve+=re[1].length),Te=!1,!Ue&&/^ *$/.test(de)&&(W+=de+`
`,X=X.substring(de.length+1),_e=!0),!_e)for(var Qe=new RegExp("^ {0,"+Math.min(3,ve-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ve=new RegExp("^ {0,"+Math.min(3,ve-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)");X&&(be=X.split(`
`,1)[0],Ue=be,this.options.pedantic&&(Ue=Ue.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Qe.test(Ue)||Ve.test(X)));){if(Ue.search(/[^ ]/)>=ve||!Ue.trim())pe+=`
`+Ue.slice(ve);else if(!Te)pe+=`
`+Ue;else break;!Te&&!Ue.trim()&&(Te=!0),W+=be+`
`,X=X.substring(be.length+1)}ze.loose||(Oe?ze.loose=!0:/\n *\n *$/.test(W)&&(Oe=!0)),this.options.gfm&&(K=/^\[[ xX]\] /.exec(pe),K&&(le=K[0]!=="[ ] ",pe=pe.replace(/^\[[ xX]\] +/,""))),ze.items.push({type:"list_item",raw:W,task:!!K,checked:le,loose:!1,text:pe}),ze.raw+=W}ze.items[ze.items.length-1].raw=W.trimRight(),ze.items[ze.items.length-1].text=pe.trimRight(),ze.raw=ze.raw.trimRight();var ae=ze.items.length;for(De=0;De<ae;De++){this.lexer.state.top=!1,ze.items[De].tokens=this.lexer.blockTokens(ze.items[De].text,[]);var Ce=ze.items[De].tokens.filter(function(Le){return Le.type==="space"}),ke=Ce.every(function(Le){for(var Be=Le.raw.split(""),Me=0,je=P(Be),Ke;!(Ke=je()).done;){var Xe=Ke.value;if(Xe===`
`&&(Me+=1),Me>1)return!0}return!1});!ze.loose&&Ce.length&&ke&&(ze.loose=!0,ze.items[De].loose=!0)}return ze}},se.html=function(X){var re=this.rules.block.html.exec(X);if(re){var W={type:"html",raw:re[0],pre:!this.options.sanitizer&&(re[1]==="pre"||re[1]==="script"||re[1]==="style"),text:re[0]};return this.options.sanitize&&(W.type="paragraph",W.text=this.options.sanitizer?this.options.sanitizer(re[0]):d(re[0]),W.tokens=[],this.lexer.inline(W.text,W.tokens)),W}},se.def=function(X){var re=this.rules.block.def.exec(X);if(re){re[3]&&(re[3]=re[3].substring(1,re[3].length-1));var W=re[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:W,raw:re[0],href:re[2],title:re[3]}}},se.table=function(X){var re=this.rules.block.table.exec(X);if(re){var W={type:"table",header:f(re[1]).map(function(Oe){return{text:Oe}}),align:re[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:re[3]&&re[3].trim()?re[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(W.header.length===W.align.length){W.raw=re[0];var K=W.align.length,le,ve,De,Te;for(le=0;le<K;le++)/^ *-+: *$/.test(W.align[le])?W.align[le]="right":/^ *:-+: *$/.test(W.align[le])?W.align[le]="center":/^ *:-+ *$/.test(W.align[le])?W.align[le]="left":W.align[le]=null;for(K=W.rows.length,le=0;le<K;le++)W.rows[le]=f(W.rows[le],W.header.length).map(function(Oe){return{text:Oe}});for(K=W.header.length,ve=0;ve<K;ve++)W.header[ve].tokens=[],this.lexer.inline(W.header[ve].text,W.header[ve].tokens);for(K=W.rows.length,ve=0;ve<K;ve++)for(Te=W.rows[ve],De=0;De<Te.length;De++)Te[De].tokens=[],this.lexer.inline(Te[De].text,Te[De].tokens);return W}}},se.lheading=function(X){var re=this.rules.block.lheading.exec(X);if(re){var W={type:"heading",raw:re[0],depth:re[2].charAt(0)==="="?1:2,text:re[1],tokens:[]};return this.lexer.inline(W.text,W.tokens),W}},se.paragraph=function(X){var re=this.rules.block.paragraph.exec(X);if(re){var W={type:"paragraph",raw:re[0],text:re[1].charAt(re[1].length-1)===`
`?re[1].slice(0,-1):re[1],tokens:[]};return this.lexer.inline(W.text,W.tokens),W}},se.text=function(X){var re=this.rules.block.text.exec(X);if(re){var W={type:"text",raw:re[0],text:re[0],tokens:[]};return this.lexer.inline(W.text,W.tokens),W}},se.escape=function(X){var re=this.rules.inline.escape.exec(X);if(re)return{type:"escape",raw:re[0],text:d(re[1])}},se.tag=function(X){var re=this.rules.inline.tag.exec(X);if(re)return!this.lexer.state.inLink&&/^<a /i.test(re[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(re[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(re[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(re[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:re[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(re[0]):d(re[0]):re[0]}},se.link=function(X){var re=this.rules.inline.link.exec(X);if(re){var W=re[2].trim();if(!this.options.pedantic&&/^</.test(W)){if(!/>$/.test(W))return;var K=w(W.slice(0,-1),"\\");if((W.length-K.length)%2==0)return}else{var le=A(re[2],"()");if(le>-1){var ve=re[0].indexOf("!")===0?5:4,De=ve+re[1].length+le;re[2]=re[2].substring(0,le),re[0]=re[0].substring(0,De).trim(),re[3]=""}}var Te=re[2],Oe="";if(this.options.pedantic){var Ue=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Te);Ue&&(Te=Ue[1],Oe=Ue[3])}else Oe=re[3]?re[3].slice(1,-1):"";return Te=Te.trim(),/^</.test(Te)&&(this.options.pedantic&&!/>$/.test(W)?Te=Te.slice(1):Te=Te.slice(1,-1)),Q(re,{href:Te&&Te.replace(this.rules.inline._escapes,"$1"),title:Oe&&Oe.replace(this.rules.inline._escapes,"$1")},re[0],this.lexer)}},se.reflink=function(X,re){var W;if((W=this.rules.inline.reflink.exec(X))||(W=this.rules.inline.nolink.exec(X))){var K=(W[2]||W[1]).replace(/\s+/g," ");if(K=re[K.toLowerCase()],!K||!K.href){var le=W[0].charAt(0);return{type:"text",raw:le,text:le}}return Q(W,K,W[0],this.lexer)}},se.emStrong=function(X,re,W){W===void 0&&(W="");var K=this.rules.inline.emStrong.lDelim.exec(X);if(!!K&&!(K[3]&&W.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var le=K[1]||K[2]||"";if(!le||le&&(W===""||this.rules.inline.punctuation.exec(W))){var ve=K[0].length-1,De,Te,Oe=ve,Ue=0,de=K[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(de.lastIndex=0,re=re.slice(-1*X.length+ve);(K=de.exec(re))!=null;)if(De=K[1]||K[2]||K[3]||K[4]||K[5]||K[6],!!De){if(Te=De.length,K[3]||K[4]){Oe+=Te;continue}else if((K[5]||K[6])&&ve%3&&!((ve+Te)%3)){Ue+=Te;continue}if(Oe-=Te,!(Oe>0)){if(Te=Math.min(Te,Te+Oe+Ue),Math.min(ve,Te)%2){var be=X.slice(1,ve+K.index+Te);return{type:"em",raw:X.slice(0,ve+K.index+Te+1),text:be,tokens:this.lexer.inlineTokens(be,[])}}var pe=X.slice(2,ve+K.index+Te-1);return{type:"strong",raw:X.slice(0,ve+K.index+Te+1),text:pe,tokens:this.lexer.inlineTokens(pe,[])}}}}}},se.codespan=function(X){var re=this.rules.inline.code.exec(X);if(re){var W=re[2].replace(/\n/g," "),K=/[^ ]/.test(W),le=/^ /.test(W)&&/ $/.test(W);return K&&le&&(W=W.substring(1,W.length-1)),W=d(W,!0),{type:"codespan",raw:re[0],text:W}}},se.br=function(X){var re=this.rules.inline.br.exec(X);if(re)return{type:"br",raw:re[0]}},se.del=function(X){var re=this.rules.inline.del.exec(X);if(re)return{type:"del",raw:re[0],text:re[2],tokens:this.lexer.inlineTokens(re[2],[])}},se.autolink=function(X,re){var W=this.rules.inline.autolink.exec(X);if(W){var K,le;return W[2]==="@"?(K=d(this.options.mangle?re(W[1]):W[1]),le="mailto:"+K):(K=d(W[1]),le=K),{type:"link",raw:W[0],text:K,href:le,tokens:[{type:"text",raw:K,text:K}]}}},se.url=function(X,re){var W;if(W=this.rules.inline.url.exec(X)){var K,le;if(W[2]==="@")K=d(this.options.mangle?re(W[0]):W[0]),le="mailto:"+K;else{var ve;do ve=W[0],W[0]=this.rules.inline._backpedal.exec(W[0])[0];while(ve!==W[0]);K=d(W[0]),W[1]==="www."?le="http://"+K:le=K}return{type:"link",raw:W[0],text:K,href:le,tokens:[{type:"text",raw:K,text:K}]}}},se.inlineText=function(X,re){var W=this.rules.inline.text.exec(X);if(W){var K;return this.lexer.state.inRawBlock?K=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(W[0]):d(W[0]):W[0]:K=d(this.options.smartypants?re(W[0]):W[0]),{type:"text",raw:W[0],text:K}}},J}(),O={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:a,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};O._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,O._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,O.def=p(O.def).replace("label",O._label).replace("title",O._title).getRegex(),O.bullet=/(?:[*+-]|\d{1,9}[.)])/,O.listItemStart=p(/^( *)(bull) */).replace("bull",O.bullet).getRegex(),O.list=p(O.list).replace(/bull/g,O.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+O.def.source+")").getRegex(),O._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",O._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,O.html=p(O.html,"i").replace("comment",O._comment).replace("tag",O._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),O.paragraph=p(O._paragraph).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.blockquote=p(O.blockquote).replace("paragraph",O.paragraph).getRegex(),O.normal=c({},O),O.gfm=c({},O.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),O.gfm.table=p(O.gfm.table).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.gfm.paragraph=p(O._paragraph).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",O.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.pedantic=c({},O.normal,{html:p(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",O._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:a,paragraph:p(O.normal._paragraph).replace("hr",O.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",O.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var B={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:a,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:a,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};B._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",B.punctuation=p(B.punctuation).replace(/punctuation/g,B._punctuation).getRegex(),B.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,B.escapedEmSt=/\\\*|\\_/g,B._comment=p(O._comment).replace("(?:-->|$)","-->").getRegex(),B.emStrong.lDelim=p(B.emStrong.lDelim).replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimAst=p(B.emStrong.rDelimAst,"g").replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimUnd=p(B.emStrong.rDelimUnd,"g").replace(/punct/g,B._punctuation).getRegex(),B._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,B._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,B._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,B.autolink=p(B.autolink).replace("scheme",B._scheme).replace("email",B._email).getRegex(),B._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,B.tag=p(B.tag).replace("comment",B._comment).replace("attribute",B._attribute).getRegex(),B._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,B._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,B._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,B.link=p(B.link).replace("label",B._label).replace("href",B._href).replace("title",B._title).getRegex(),B.reflink=p(B.reflink).replace("label",B._label).replace("ref",O._label).getRegex(),B.nolink=p(B.nolink).replace("ref",O._label).getRegex(),B.reflinkSearch=p(B.reflinkSearch,"g").replace("reflink",B.reflink).replace("nolink",B.nolink).getRegex(),B.normal=c({},B),B.pedantic=c({},B.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:p(/^!?\[(label)\]\((.*?)\)/).replace("label",B._label).getRegex(),reflink:p(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",B._label).getRegex()}),B.gfm=c({},B.normal,{escape:p(B.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),B.gfm.url=p(B.gfm.url,"i").replace("email",B.gfm._extended_email).getRegex(),B.breaks=c({},B.gfm,{br:p(B.br).replace("{2,}","*").getRegex(),text:p(B.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ue(J){return J.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function V(J){var se="",me,X,re=J.length;for(me=0;me<re;me++)X=J.charCodeAt(me),Math.random()>.5&&(X="x"+X.toString(16)),se+="&#"+X+";";return se}var $=function(){function J(me){this.tokens=[],this.tokens.links=Object.create(null),this.options=me||ie.defaults,this.options.tokenizer=this.options.tokenizer||new Y,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var X={block:O.normal,inline:B.normal};this.options.pedantic?(X.block=O.pedantic,X.inline=B.pedantic):this.options.gfm&&(X.block=O.gfm,this.options.breaks?X.inline=B.breaks:X.inline=B.gfm),this.tokenizer.rules=X}J.lex=function(X,re){var W=new J(re);return W.lex(X)},J.lexInline=function(X,re){var W=new J(re);return W.inlineTokens(X)};var se=J.prototype;return se.lex=function(X){X=X.replace(/\r\n|\r/g,`
`),this.blockTokens(X,this.tokens);for(var re;re=this.inlineQueue.shift();)this.inlineTokens(re.src,re.tokens);return this.tokens},se.blockTokens=function(X,re){var W=this;re===void 0&&(re=[]),this.options.pedantic?X=X.replace(/\t/g,"    ").replace(/^ +$/gm,""):X=X.replace(/^( *)(\t+)/gm,function(Oe,Ue,de){return Ue+"    ".repeat(de.length)});for(var K,le,ve,De;X;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Oe){return(K=Oe.call({lexer:W},X,re))?(X=X.substring(K.raw.length),re.push(K),!0):!1}))){if(K=this.tokenizer.space(X)){X=X.substring(K.raw.length),K.raw.length===1&&re.length>0?re[re.length-1].raw+=`
`:re.push(K);continue}if(K=this.tokenizer.code(X)){X=X.substring(K.raw.length),le=re[re.length-1],le&&(le.type==="paragraph"||le.type==="text")?(le.raw+=`
`+K.raw,le.text+=`
`+K.text,this.inlineQueue[this.inlineQueue.length-1].src=le.text):re.push(K);continue}if(K=this.tokenizer.fences(X)){X=X.substring(K.raw.length),re.push(K);continue}if(K=this.tokenizer.heading(X)){X=X.substring(K.raw.length),re.push(K);continue}if(K=this.tokenizer.hr(X)){X=X.substring(K.raw.length),re.push(K);continue}if(K=this.tokenizer.blockquote(X)){X=X.substring(K.raw.length),re.push(K);continue}if(K=this.tokenizer.list(X)){X=X.substring(K.raw.length),re.push(K);continue}if(K=this.tokenizer.html(X)){X=X.substring(K.raw.length),re.push(K);continue}if(K=this.tokenizer.def(X)){X=X.substring(K.raw.length),le=re[re.length-1],le&&(le.type==="paragraph"||le.type==="text")?(le.raw+=`
`+K.raw,le.text+=`
`+K.raw,this.inlineQueue[this.inlineQueue.length-1].src=le.text):this.tokens.links[K.tag]||(this.tokens.links[K.tag]={href:K.href,title:K.title});continue}if(K=this.tokenizer.table(X)){X=X.substring(K.raw.length),re.push(K);continue}if(K=this.tokenizer.lheading(X)){X=X.substring(K.raw.length),re.push(K);continue}if(ve=X,this.options.extensions&&this.options.extensions.startBlock&&function(){var Oe=1/0,Ue=X.slice(1),de=void 0;W.options.extensions.startBlock.forEach(function(be){de=be.call({lexer:this},Ue),typeof de=="number"&&de>=0&&(Oe=Math.min(Oe,de))}),Oe<1/0&&Oe>=0&&(ve=X.substring(0,Oe+1))}(),this.state.top&&(K=this.tokenizer.paragraph(ve))){le=re[re.length-1],De&&le.type==="paragraph"?(le.raw+=`
`+K.raw,le.text+=`
`+K.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=le.text):re.push(K),De=ve.length!==X.length,X=X.substring(K.raw.length);continue}if(K=this.tokenizer.text(X)){X=X.substring(K.raw.length),le=re[re.length-1],le&&le.type==="text"?(le.raw+=`
`+K.raw,le.text+=`
`+K.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=le.text):re.push(K);continue}if(X){var Te="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(Te);break}else throw new Error(Te)}}return this.state.top=!0,re},se.inline=function(X,re){this.inlineQueue.push({src:X,tokens:re})},se.inlineTokens=function(X,re){var W=this;re===void 0&&(re=[]);var K,le,ve,De=X,Te,Oe,Ue;if(this.tokens.links){var de=Object.keys(this.tokens.links);if(de.length>0)for(;(Te=this.tokenizer.rules.inline.reflinkSearch.exec(De))!=null;)de.includes(Te[0].slice(Te[0].lastIndexOf("[")+1,-1))&&(De=De.slice(0,Te.index)+"["+x("a",Te[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Te=this.tokenizer.rules.inline.blockSkip.exec(De))!=null;)De=De.slice(0,Te.index)+"["+x("a",Te[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Te=this.tokenizer.rules.inline.escapedEmSt.exec(De))!=null;)De=De.slice(0,Te.index)+"++"+De.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;X;)if(Oe||(Ue=""),Oe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(pe){return(K=pe.call({lexer:W},X,re))?(X=X.substring(K.raw.length),re.push(K),!0):!1}))){if(K=this.tokenizer.escape(X)){X=X.substring(K.raw.length),re.push(K);continue}if(K=this.tokenizer.tag(X)){X=X.substring(K.raw.length),le=re[re.length-1],le&&K.type==="text"&&le.type==="text"?(le.raw+=K.raw,le.text+=K.text):re.push(K);continue}if(K=this.tokenizer.link(X)){X=X.substring(K.raw.length),re.push(K);continue}if(K=this.tokenizer.reflink(X,this.tokens.links)){X=X.substring(K.raw.length),le=re[re.length-1],le&&K.type==="text"&&le.type==="text"?(le.raw+=K.raw,le.text+=K.text):re.push(K);continue}if(K=this.tokenizer.emStrong(X,De,Ue)){X=X.substring(K.raw.length),re.push(K);continue}if(K=this.tokenizer.codespan(X)){X=X.substring(K.raw.length),re.push(K);continue}if(K=this.tokenizer.br(X)){X=X.substring(K.raw.length),re.push(K);continue}if(K=this.tokenizer.del(X)){X=X.substring(K.raw.length),re.push(K);continue}if(K=this.tokenizer.autolink(X,V)){X=X.substring(K.raw.length),re.push(K);continue}if(!this.state.inLink&&(K=this.tokenizer.url(X,V))){X=X.substring(K.raw.length),re.push(K);continue}if(ve=X,this.options.extensions&&this.options.extensions.startInline&&function(){var pe=1/0,_e=X.slice(1),Ne=void 0;W.options.extensions.startInline.forEach(function(qe){Ne=qe.call({lexer:this},_e),typeof Ne=="number"&&Ne>=0&&(pe=Math.min(pe,Ne))}),pe<1/0&&pe>=0&&(ve=X.substring(0,pe+1))}(),K=this.tokenizer.inlineText(ve,ue)){X=X.substring(K.raw.length),K.raw.slice(-1)!=="_"&&(Ue=K.raw.slice(-1)),Oe=!0,le=re[re.length-1],le&&le.type==="text"?(le.raw+=K.raw,le.text+=K.text):re.push(K);continue}if(X){var be="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(be);break}else throw new Error(be)}}return re},I(J,null,[{key:"rules",get:function(){return{block:O,inline:B}}}]),J}(),F=function(){function J(me){this.options=me||ie.defaults}var se=J.prototype;return se.code=function(X,re,W){var K=(re||"").match(/\S*/)[0];if(this.options.highlight){var le=this.options.highlight(X,K);le!=null&&le!==X&&(W=!0,X=le)}return X=X.replace(/\n$/,"")+`
`,K?'<pre><code class="'+this.options.langPrefix+d(K,!0)+'">'+(W?X:d(X,!0))+`</code></pre>
`:"<pre><code>"+(W?X:d(X,!0))+`</code></pre>
`},se.blockquote=function(X){return`<blockquote>
`+X+`</blockquote>
`},se.html=function(X){return X},se.heading=function(X,re,W,K){if(this.options.headerIds){var le=this.options.headerPrefix+K.slug(W);return"<h"+re+' id="'+le+'">'+X+"</h"+re+`>
`}return"<h"+re+">"+X+"</h"+re+`>
`},se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},se.list=function(X,re,W){var K=re?"ol":"ul",le=re&&W!==1?' start="'+W+'"':"";return"<"+K+le+`>
`+X+"</"+K+`>
`},se.listitem=function(X){return"<li>"+X+`</li>
`},se.checkbox=function(X){return"<input "+(X?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},se.paragraph=function(X){return"<p>"+X+`</p>
`},se.table=function(X,re){return re&&(re="<tbody>"+re+"</tbody>"),`<table>
<thead>
`+X+`</thead>
`+re+`</table>
`},se.tablerow=function(X){return`<tr>
`+X+`</tr>
`},se.tablecell=function(X,re){var W=re.header?"th":"td",K=re.align?"<"+W+' align="'+re.align+'">':"<"+W+">";return K+X+("</"+W+`>
`)},se.strong=function(X){return"<strong>"+X+"</strong>"},se.em=function(X){return"<em>"+X+"</em>"},se.codespan=function(X){return"<code>"+X+"</code>"},se.br=function(){return this.options.xhtml?"<br/>":"<br>"},se.del=function(X){return"<del>"+X+"</del>"},se.link=function(X,re,W){if(X=u(this.options.sanitize,this.options.baseUrl,X),X===null)return W;var K='<a href="'+d(X)+'"';return re&&(K+=' title="'+re+'"'),K+=">"+W+"</a>",K},se.image=function(X,re,W){if(X=u(this.options.sanitize,this.options.baseUrl,X),X===null)return W;var K='<img src="'+X+'" alt="'+W+'"';return re&&(K+=' title="'+re+'"'),K+=this.options.xhtml?"/>":">",K},se.text=function(X){return X},J}(),M=function(){function J(){}var se=J.prototype;return se.strong=function(X){return X},se.em=function(X){return X},se.codespan=function(X){return X},se.del=function(X){return X},se.html=function(X){return X},se.text=function(X){return X},se.link=function(X,re,W){return""+W},se.image=function(X,re,W){return""+W},se.br=function(){return""},J}(),j=function(){function J(){this.seen={}}var se=J.prototype;return se.serialize=function(X){return X.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},se.getNextSafeSlug=function(X,re){var W=X,K=0;if(this.seen.hasOwnProperty(W)){K=this.seen[X];do K++,W=X+"-"+K;while(this.seen.hasOwnProperty(W))}return re||(this.seen[X]=K,this.seen[W]=0),W},se.slug=function(X,re){re===void 0&&(re={});var W=this.serialize(X);return this.getNextSafeSlug(W,re.dryrun)},J}(),Z=function(){function J(me){this.options=me||ie.defaults,this.options.renderer=this.options.renderer||new F,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new M,this.slugger=new j}J.parse=function(X,re){var W=new J(re);return W.parse(X)},J.parseInline=function(X,re){var W=new J(re);return W.parseInline(X)};var se=J.prototype;return se.parse=function(X,re){re===void 0&&(re=!0);var W="",K,le,ve,De,Te,Oe,Ue,de,be,pe,_e,Ne,qe,ze,He,Qe,Ve,ae,Ce,ke=X.length;for(K=0;K<ke;K++){if(pe=X[K],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[pe.type]&&(Ce=this.options.extensions.renderers[pe.type].call({parser:this},pe),Ce!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(pe.type))){W+=Ce||"";continue}switch(pe.type){case"space":continue;case"hr":{W+=this.renderer.hr();continue}case"heading":{W+=this.renderer.heading(this.parseInline(pe.tokens),pe.depth,h(this.parseInline(pe.tokens,this.textRenderer)),this.slugger);continue}case"code":{W+=this.renderer.code(pe.text,pe.lang,pe.escaped);continue}case"table":{for(de="",Ue="",De=pe.header.length,le=0;le<De;le++)Ue+=this.renderer.tablecell(this.parseInline(pe.header[le].tokens),{header:!0,align:pe.align[le]});for(de+=this.renderer.tablerow(Ue),be="",De=pe.rows.length,le=0;le<De;le++){for(Oe=pe.rows[le],Ue="",Te=Oe.length,ve=0;ve<Te;ve++)Ue+=this.renderer.tablecell(this.parseInline(Oe[ve].tokens),{header:!1,align:pe.align[ve]});be+=this.renderer.tablerow(Ue)}W+=this.renderer.table(de,be);continue}case"blockquote":{be=this.parse(pe.tokens),W+=this.renderer.blockquote(be);continue}case"list":{for(_e=pe.ordered,Ne=pe.start,qe=pe.loose,De=pe.items.length,be="",le=0;le<De;le++)He=pe.items[le],Qe=He.checked,Ve=He.task,ze="",He.task&&(ae=this.renderer.checkbox(Qe),qe?He.tokens.length>0&&He.tokens[0].type==="paragraph"?(He.tokens[0].text=ae+" "+He.tokens[0].text,He.tokens[0].tokens&&He.tokens[0].tokens.length>0&&He.tokens[0].tokens[0].type==="text"&&(He.tokens[0].tokens[0].text=ae+" "+He.tokens[0].tokens[0].text)):He.tokens.unshift({type:"text",text:ae}):ze+=ae),ze+=this.parse(He.tokens,qe),be+=this.renderer.listitem(ze,Ve,Qe);W+=this.renderer.list(be,_e,Ne);continue}case"html":{W+=this.renderer.html(pe.text);continue}case"paragraph":{W+=this.renderer.paragraph(this.parseInline(pe.tokens));continue}case"text":{for(be=pe.tokens?this.parseInline(pe.tokens):pe.text;K+1<ke&&X[K+1].type==="text";)pe=X[++K],be+=`
`+(pe.tokens?this.parseInline(pe.tokens):pe.text);W+=re?this.renderer.paragraph(be):be;continue}default:{var Le='Token with "'+pe.type+'" type was not found.';if(this.options.silent){console.error(Le);return}else throw new Error(Le)}}}return W},se.parseInline=function(X,re){re=re||this.renderer;var W="",K,le,ve,De=X.length;for(K=0;K<De;K++){if(le=X[K],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[le.type]&&(ve=this.options.extensions.renderers[le.type].call({parser:this},le),ve!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(le.type))){W+=ve||"";continue}switch(le.type){case"escape":{W+=re.text(le.text);break}case"html":{W+=re.html(le.text);break}case"link":{W+=re.link(le.href,le.title,this.parseInline(le.tokens,re));break}case"image":{W+=re.image(le.href,le.title,le.text);break}case"strong":{W+=re.strong(this.parseInline(le.tokens,re));break}case"em":{W+=re.em(this.parseInline(le.tokens,re));break}case"codespan":{W+=re.codespan(le.text);break}case"br":{W+=re.br();break}case"del":{W+=re.del(this.parseInline(le.tokens,re));break}case"text":{W+=re.text(le.text);break}default:{var Te='Token with "'+le.type+'" type was not found.';if(this.options.silent){console.error(Te);return}else throw new Error(Te)}}}return W},J}();function oe(J,se,me){if(typeof J=="undefined"||J===null)throw new Error("marked(): input parameter is undefined or null");if(typeof J!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(J)+", string expected");if(typeof se=="function"&&(me=se,se=null),se=c({},oe.defaults,se||{}),U(se),me){var X=se.highlight,re;try{re=$.lex(J,se)}catch(ve){return me(ve)}var W=function(De){var Te;if(!De)try{se.walkTokens&&oe.walkTokens(re,se.walkTokens),Te=Z.parse(re,se)}catch(Oe){De=Oe}return se.highlight=X,De?me(De):me(null,Te)};if(!X||X.length<3||(delete se.highlight,!re.length))return W();var K=0;oe.walkTokens(re,function(ve){ve.type==="code"&&(K++,setTimeout(function(){X(ve.text,ve.lang,function(De,Te){if(De)return W(De);Te!=null&&Te!==ve.text&&(ve.text=Te,ve.escaped=!0),K--,K===0&&W()})},0))}),K===0&&W();return}try{var le=$.lex(J,se);return se.walkTokens&&oe.walkTokens(le,se.walkTokens),Z.parse(le,se)}catch(ve){if(ve.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+d(ve.message+"",!0)+"</pre>";throw ve}}oe.options=oe.setOptions=function(J){return c(oe.defaults,J),E(oe.defaults),oe},oe.getDefaults=k,oe.defaults=ie.defaults,oe.use=function(){for(var J=arguments.length,se=new Array(J),me=0;me<J;me++)se[me]=arguments[me];var X=c.apply(void 0,[{}].concat(se)),re=oe.defaults.extensions||{renderers:{},childTokens:{}},W;se.forEach(function(K){if(K.extensions&&(W=!0,K.extensions.forEach(function(ve){if(!ve.name)throw new Error("extension name required");if(ve.renderer){var De=re.renderers?re.renderers[ve.name]:null;De?re.renderers[ve.name]=function(){for(var Te=arguments.length,Oe=new Array(Te),Ue=0;Ue<Te;Ue++)Oe[Ue]=arguments[Ue];var de=ve.renderer.apply(this,Oe);return de===!1&&(de=De.apply(this,Oe)),de}:re.renderers[ve.name]=ve.renderer}if(ve.tokenizer){if(!ve.level||ve.level!=="block"&&ve.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");re[ve.level]?re[ve.level].unshift(ve.tokenizer):re[ve.level]=[ve.tokenizer],ve.start&&(ve.level==="block"?re.startBlock?re.startBlock.push(ve.start):re.startBlock=[ve.start]:ve.level==="inline"&&(re.startInline?re.startInline.push(ve.start):re.startInline=[ve.start]))}ve.childTokens&&(re.childTokens[ve.name]=ve.childTokens)})),K.renderer&&function(){var ve=oe.defaults.renderer||new F,De=function(Ue){var de=ve[Ue];ve[Ue]=function(){for(var be=arguments.length,pe=new Array(be),_e=0;_e<be;_e++)pe[_e]=arguments[_e];var Ne=K.renderer[Ue].apply(ve,pe);return Ne===!1&&(Ne=de.apply(ve,pe)),Ne}};for(var Te in K.renderer)De(Te);X.renderer=ve}(),K.tokenizer&&function(){var ve=oe.defaults.tokenizer||new Y,De=function(Ue){var de=ve[Ue];ve[Ue]=function(){for(var be=arguments.length,pe=new Array(be),_e=0;_e<be;_e++)pe[_e]=arguments[_e];var Ne=K.tokenizer[Ue].apply(ve,pe);return Ne===!1&&(Ne=de.apply(ve,pe)),Ne}};for(var Te in K.tokenizer)De(Te);X.tokenizer=ve}(),K.walkTokens){var le=oe.defaults.walkTokens;X.walkTokens=function(ve){K.walkTokens.call(this,ve),le&&le.call(this,ve)}}W&&(X.extensions=re),oe.setOptions(X)})},oe.walkTokens=function(J,se){for(var me=function(){var K=re.value;switch(se.call(oe,K),K.type){case"table":{for(var le=P(K.header),ve;!(ve=le()).done;){var De=ve.value;oe.walkTokens(De.tokens,se)}for(var Te=P(K.rows),Oe;!(Oe=Te()).done;)for(var Ue=Oe.value,de=P(Ue),be;!(be=de()).done;){var pe=be.value;oe.walkTokens(pe.tokens,se)}break}case"list":{oe.walkTokens(K.items,se);break}default:oe.defaults.extensions&&oe.defaults.extensions.childTokens&&oe.defaults.extensions.childTokens[K.type]?oe.defaults.extensions.childTokens[K.type].forEach(function(_e){oe.walkTokens(K[_e],se)}):K.tokens&&oe.walkTokens(K.tokens,se)}},X=P(J),re;!(re=X()).done;)me()},oe.parseInline=function(J,se){if(typeof J=="undefined"||J===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof J!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(J)+", string expected");se=c({},oe.defaults,se||{}),U(se);try{var me=$.lexInline(J,se);return se.walkTokens&&oe.walkTokens(me,se.walkTokens),Z.parseInline(me,se)}catch(X){if(X.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+d(X.message+"",!0)+"</pre>";throw X}},oe.Parser=Z,oe.parser=Z.parse,oe.Renderer=F,oe.TextRenderer=M,oe.Lexer=$,oe.lexer=$.lex,oe.Tokenizer=Y,oe.Slugger=j,oe.parse=oe;var ge=oe.options,he=oe.setOptions,q=oe.use,ee=oe.walkTokens,G=oe.parseInline,z=oe,te=Z.parse,ce=$.lex;ie.Lexer=$,ie.Parser=Z,ie.Renderer=F,ie.Slugger=j,ie.TextRenderer=M,ie.Tokenizer=Y,ie.getDefaults=k,ie.lexer=ce,ie.marked=oe,ie.options=ge,ie.parse=z,ie.parseInline=G,ie.parser=te,ie.setOptions=he,ie.use=q,ie.walkTokens=ee,Object.defineProperty(ie,"__esModule",{value:!0})}),function(){function ie(b){const P=[];typeof b=="number"&&P.push("code/timeOrigin",b);function k(v){P.push(v,Date.now())}function E(){const v=[];for(let D=0;D<P.length;D+=2)v.push({name:P[D],startTime:P[D+1]});return v}return{mark:k,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const k of performance.getEntriesByType("mark"))P.push({name:k.name,startTime:Math.round(b+k.startTime)});return P}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function I(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=e()),b.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=I(t))}(),define(we[3],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const I="en";let t=!1,b=!1,P=!1,k=!1,E=!1,v=!1,D=!1,T=!1,R=!1,C,y=I,d,S;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const g=typeof h?.versions?.electron=="string",p=g&&h?.type==="renderer";if(typeof navigator=="object"&&!p)S=navigator.userAgent,t=S.indexOf("Windows")>=0,b=S.indexOf("Macintosh")>=0,T=(S.indexOf("Macintosh")>=0||S.indexOf("iPad")>=0||S.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=S.indexOf("Linux")>=0,v=!0,C=navigator.language,y=C;else if(typeof h=="object"){t=h.platform==="win32",b=h.platform==="darwin",P=h.platform==="linux",k=P&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,D=g,R=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,C=I,y=I;const a=h.env.VSCODE_NLS_CONFIG;if(a)try{const c=JSON.parse(a),f=c.availableLanguages["*"];C=c.locale,y=f||I,d=c._translationsConfigFile}catch{}E=!0}else console.error("Unable to resolve platform.");var m;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(m=e.Platform||(e.Platform={}));function l(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=l;let u=0;b?u=1:t?u=3:P&&(u=2),e.isWindows=t,e.isMacintosh=b,e.isLinux=P,e.isLinuxSnap=k,e.isNative=E,e.isElectron=D,e.isWeb=v,e.isWebWorker=v&&typeof e.globals.importScripts=="function",e.isIOS=T,e.isCI=R,e.platform=u,e.userAgent=S,e.language=y;var n;(function(a){function c(){return e.language}a.value=c;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=f;function w(){return e.language==="en"}a.isDefault=w})(n=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=d,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){let a=[];e.globals.addEventListener("message",f=>{if(f.data&&f.data.vscodeScheduleAsyncWork)for(let w=0,A=a.length;w<A;w++){const U=a[w];if(U.id===f.data.vscodeScheduleAsyncWork){a.splice(w,1),U.callback();return}}});let c=0;return f=>{const w=++c;a.push({id:w,callback:f}),e.globals.postMessage({vscodeScheduleAsyncWork:w},"*")}}return a=>setTimeout(a)})();var s;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=b||T?2:t?1:3;let i=!0,o=!1;function r(){if(!o){o=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,i=new Uint16Array(a.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=r,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(we[26],ye([0,1,3]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof I.globals.vscode!="undefined"&&typeof I.globals.vscode.process!="undefined"){const b=I.globals.vscode.process;t={get platform(){return b.platform},get arch(){return b.arch},get env(){return b.env},cwd(){return b.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return I.isWindows?"win32":I.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(we[5],ye([0,1,26]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,b=97,P=90,k=122,E=46,v=47,D=92,T=58,R=63;class C extends Error{constructor(l,u,n){let s;typeof u=="string"&&u.indexOf("not ")===0?(s="must not be",u=u.replace(/^not /,"")):s="must be";const i=l.indexOf(".")!==-1?"property":"argument";let o=`The "${l}" ${i} ${s} of type ${u}`;o+=`. Received type ${typeof n}`;super(o);this.code="ERR_INVALID_ARG_TYPE"}}function y(m,l){if(typeof m!="string")throw new C(l,"string",m)}function d(m){return m===v||m===D}function S(m){return m===v}function h(m){return m>=t&&m<=P||m>=b&&m<=k}function g(m,l,u,n){let s="",i=0,o=-1,r=0,a=0;for(let c=0;c<=m.length;++c){if(c<m.length)a=m.charCodeAt(c);else{if(n(a))break;a=v}if(n(a)){if(!(o===c-1||r===1))if(r===2){if(s.length<2||i!==2||s.charCodeAt(s.length-1)!==E||s.charCodeAt(s.length-2)!==E){if(s.length>2){const f=s.lastIndexOf(u);f===-1?(s="",i=0):(s=s.slice(0,f),i=s.length-1-s.lastIndexOf(u)),o=c,r=0;continue}else if(s.length!==0){s="",i=0,o=c,r=0;continue}}l&&(s+=s.length>0?`${u}..`:"..",i=2)}else s.length>0?s+=`${u}${m.slice(o+1,c)}`:s=m.slice(o+1,c),i=c-o-1;o=c,r=0}else a===E&&r!==-1?++r:r=-1}return s}function p(m,l){if(l===null||typeof l!="object")throw new C("pathObject","Object",l);const u=l.dir||l.root,n=l.base||`${l.name||""}${l.ext||""}`;return u?u===l.root?`${u}${n}`:`${u}${m}${n}`:n}e.win32={resolve(...m){let l="",u="",n=!1;for(let s=m.length-1;s>=-1;s--){let i;if(s>=0){if(i=m[s],y(i,"path"),i.length===0)continue}else l.length===0?i=I.cwd():(i=I.env[`=${l}`]||I.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==l.toLowerCase()&&i.charCodeAt(2)===D)&&(i=`${l}\\`));const o=i.length;let r=0,a="",c=!1;const f=i.charCodeAt(0);if(o===1)d(f)&&(r=1,c=!0);else if(d(f))if(c=!0,d(i.charCodeAt(1))){let w=2,A=w;for(;w<o&&!d(i.charCodeAt(w));)w++;if(w<o&&w!==A){const U=i.slice(A,w);for(A=w;w<o&&d(i.charCodeAt(w));)w++;if(w<o&&w!==A){for(A=w;w<o&&!d(i.charCodeAt(w));)w++;(w===o||w!==A)&&(a=`\\\\${U}\\${i.slice(A,w)}`,r=w)}}}else r=1;else h(f)&&i.charCodeAt(1)===T&&(a=i.slice(0,2),r=2,o>2&&d(i.charCodeAt(2))&&(c=!0,r=3));if(a.length>0)if(l.length>0){if(a.toLowerCase()!==l.toLowerCase())continue}else l=a;if(n){if(l.length>0)break}else if(u=`${i.slice(r)}\\${u}`,n=c,c&&l.length>0)break}return u=g(u,!n,"\\",d),n?`${l}\\${u}`:`${l}${u}`||"."},normalize(m){y(m,"path");const l=m.length;if(l===0)return".";let u=0,n,s=!1;const i=m.charCodeAt(0);if(l===1)return S(i)?"\\":m;if(d(i))if(s=!0,d(m.charCodeAt(1))){let r=2,a=r;for(;r<l&&!d(m.charCodeAt(r));)r++;if(r<l&&r!==a){const c=m.slice(a,r);for(a=r;r<l&&d(m.charCodeAt(r));)r++;if(r<l&&r!==a){for(a=r;r<l&&!d(m.charCodeAt(r));)r++;if(r===l)return`\\\\${c}\\${m.slice(a)}\\`;r!==a&&(n=`\\\\${c}\\${m.slice(a,r)}`,u=r)}}}else u=1;else h(i)&&m.charCodeAt(1)===T&&(n=m.slice(0,2),u=2,l>2&&d(m.charCodeAt(2))&&(s=!0,u=3));let o=u<l?g(m.slice(u),!s,"\\",d):"";return o.length===0&&!s&&(o="."),o.length>0&&d(m.charCodeAt(l-1))&&(o+="\\"),n===void 0?s?`\\${o}`:o:s?`${n}\\${o}`:`${n}${o}`},isAbsolute(m){y(m,"path");const l=m.length;if(l===0)return!1;const u=m.charCodeAt(0);return d(u)||l>2&&h(u)&&m.charCodeAt(1)===T&&d(m.charCodeAt(2))},join(...m){if(m.length===0)return".";let l,u;for(let i=0;i<m.length;++i){const o=m[i];y(o,"path"),o.length>0&&(l===void 0?l=u=o:l+=`\\${o}`)}if(l===void 0)return".";let n=!0,s=0;if(typeof u=="string"&&d(u.charCodeAt(0))){++s;const i=u.length;i>1&&d(u.charCodeAt(1))&&(++s,i>2&&(d(u.charCodeAt(2))?++s:n=!1))}if(n){for(;s<l.length&&d(l.charCodeAt(s));)s++;s>=2&&(l=`\\${l.slice(s)}`)}return e.win32.normalize(l)},relative(m,l){if(y(m,"from"),y(l,"to"),m===l)return"";const u=e.win32.resolve(m),n=e.win32.resolve(l);if(u===n||(m=u.toLowerCase(),l=n.toLowerCase(),m===l))return"";let s=0;for(;s<m.length&&m.charCodeAt(s)===D;)s++;let i=m.length;for(;i-1>s&&m.charCodeAt(i-1)===D;)i--;const o=i-s;let r=0;for(;r<l.length&&l.charCodeAt(r)===D;)r++;let a=l.length;for(;a-1>r&&l.charCodeAt(a-1)===D;)a--;const c=a-r,f=o<c?o:c;let w=-1,A=0;for(;A<f;A++){const x=m.charCodeAt(s+A);if(x!==l.charCodeAt(r+A))break;x===D&&(w=A)}if(A!==f){if(w===-1)return n}else{if(c>f){if(l.charCodeAt(r+A)===D)return n.slice(r+A+1);if(A===2)return n.slice(r+A)}o>f&&(m.charCodeAt(s+A)===D?w=A:A===2&&(w=3)),w===-1&&(w=0)}let U="";for(A=s+w+1;A<=i;++A)(A===i||m.charCodeAt(A)===D)&&(U+=U.length===0?"..":"\\..");return r+=w,U.length>0?`${U}${n.slice(r,a)}`:(n.charCodeAt(r)===D&&++r,n.slice(r,a))},toNamespacedPath(m){if(typeof m!="string")return m;if(m.length===0)return"";const l=e.win32.resolve(m);if(l.length<=2)return m;if(l.charCodeAt(0)===D){if(l.charCodeAt(1)===D){const u=l.charCodeAt(2);if(u!==R&&u!==E)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(h(l.charCodeAt(0))&&l.charCodeAt(1)===T&&l.charCodeAt(2)===D)return`\\\\?\\${l}`;return m},dirname(m){y(m,"path");const l=m.length;if(l===0)return".";let u=-1,n=0;const s=m.charCodeAt(0);if(l===1)return d(s)?m:".";if(d(s)){if(u=n=1,d(m.charCodeAt(1))){let r=2,a=r;for(;r<l&&!d(m.charCodeAt(r));)r++;if(r<l&&r!==a){for(a=r;r<l&&d(m.charCodeAt(r));)r++;if(r<l&&r!==a){for(a=r;r<l&&!d(m.charCodeAt(r));)r++;if(r===l)return m;r!==a&&(u=n=r+1)}}}}else h(s)&&m.charCodeAt(1)===T&&(u=l>2&&d(m.charCodeAt(2))?3:2,n=u);let i=-1,o=!0;for(let r=l-1;r>=n;--r)if(d(m.charCodeAt(r))){if(!o){i=r;break}}else o=!1;if(i===-1){if(u===-1)return".";i=u}return m.slice(0,i)},basename(m,l){l!==void 0&&y(l,"ext"),y(m,"path");let u=0,n=-1,s=!0,i;if(m.length>=2&&h(m.charCodeAt(0))&&m.charCodeAt(1)===T&&(u=2),l!==void 0&&l.length>0&&l.length<=m.length){if(l===m)return"";let o=l.length-1,r=-1;for(i=m.length-1;i>=u;--i){const a=m.charCodeAt(i);if(d(a)){if(!s){u=i+1;break}}else r===-1&&(s=!1,r=i+1),o>=0&&(a===l.charCodeAt(o)?--o==-1&&(n=i):(o=-1,n=r))}return u===n?n=r:n===-1&&(n=m.length),m.slice(u,n)}for(i=m.length-1;i>=u;--i)if(d(m.charCodeAt(i))){if(!s){u=i+1;break}}else n===-1&&(s=!1,n=i+1);return n===-1?"":m.slice(u,n)},extname(m){y(m,"path");let l=0,u=-1,n=0,s=-1,i=!0,o=0;m.length>=2&&m.charCodeAt(1)===T&&h(m.charCodeAt(0))&&(l=n=2);for(let r=m.length-1;r>=l;--r){const a=m.charCodeAt(r);if(d(a)){if(!i){n=r+1;break}continue}s===-1&&(i=!1,s=r+1),a===E?u===-1?u=r:o!==1&&(o=1):u!==-1&&(o=-1)}return u===-1||s===-1||o===0||o===1&&u===s-1&&u===n+1?"":m.slice(u,s)},format:p.bind(null,"\\"),parse(m){y(m,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return l;const u=m.length;let n=0,s=m.charCodeAt(0);if(u===1)return d(s)?(l.root=l.dir=m,l):(l.base=l.name=m,l);if(d(s)){if(n=1,d(m.charCodeAt(1))){let w=2,A=w;for(;w<u&&!d(m.charCodeAt(w));)w++;if(w<u&&w!==A){for(A=w;w<u&&d(m.charCodeAt(w));)w++;if(w<u&&w!==A){for(A=w;w<u&&!d(m.charCodeAt(w));)w++;w===u?n=w:w!==A&&(n=w+1)}}}}else if(h(s)&&m.charCodeAt(1)===T){if(u<=2)return l.root=l.dir=m,l;if(n=2,d(m.charCodeAt(2))){if(u===3)return l.root=l.dir=m,l;n=3}}n>0&&(l.root=m.slice(0,n));let i=-1,o=n,r=-1,a=!0,c=m.length-1,f=0;for(;c>=n;--c){if(s=m.charCodeAt(c),d(s)){if(!a){o=c+1;break}continue}r===-1&&(a=!1,r=c+1),s===E?i===-1?i=c:f!==1&&(f=1):i!==-1&&(f=-1)}return r!==-1&&(i===-1||f===0||f===1&&i===r-1&&i===o+1?l.base=l.name=m.slice(o,r):(l.name=m.slice(o,i),l.base=m.slice(o,r),l.ext=m.slice(i,r))),o>0&&o!==n?l.dir=m.slice(0,o-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...m){let l="",u=!1;for(let n=m.length-1;n>=-1&&!u;n--){const s=n>=0?m[n]:I.cwd();y(s,"path"),s.length!==0&&(l=`${s}/${l}`,u=s.charCodeAt(0)===v)}return l=g(l,!u,"/",S),u?`/${l}`:l.length>0?l:"."},normalize(m){if(y(m,"path"),m.length===0)return".";const l=m.charCodeAt(0)===v,u=m.charCodeAt(m.length-1)===v;return m=g(m,!l,"/",S),m.length===0?l?"/":u?"./":".":(u&&(m+="/"),l?`/${m}`:m)},isAbsolute(m){return y(m,"path"),m.length>0&&m.charCodeAt(0)===v},join(...m){if(m.length===0)return".";let l;for(let u=0;u<m.length;++u){const n=m[u];y(n,"path"),n.length>0&&(l===void 0?l=n:l+=`/${n}`)}return l===void 0?".":e.posix.normalize(l)},relative(m,l){if(y(m,"from"),y(l,"to"),m===l||(m=e.posix.resolve(m),l=e.posix.resolve(l),m===l))return"";const u=1,n=m.length,s=n-u,i=1,o=l.length-i,r=s<o?s:o;let a=-1,c=0;for(;c<r;c++){const w=m.charCodeAt(u+c);if(w!==l.charCodeAt(i+c))break;w===v&&(a=c)}if(c===r)if(o>r){if(l.charCodeAt(i+c)===v)return l.slice(i+c+1);if(c===0)return l.slice(i+c)}else s>r&&(m.charCodeAt(u+c)===v?a=c:c===0&&(a=0));let f="";for(c=u+a+1;c<=n;++c)(c===n||m.charCodeAt(c)===v)&&(f+=f.length===0?"..":"/..");return`${f}${l.slice(i+a)}`},toNamespacedPath(m){return m},dirname(m){if(y(m,"path"),m.length===0)return".";const l=m.charCodeAt(0)===v;let u=-1,n=!0;for(let s=m.length-1;s>=1;--s)if(m.charCodeAt(s)===v){if(!n){u=s;break}}else n=!1;return u===-1?l?"/":".":l&&u===1?"//":m.slice(0,u)},basename(m,l){l!==void 0&&y(l,"ext"),y(m,"path");let u=0,n=-1,s=!0,i;if(l!==void 0&&l.length>0&&l.length<=m.length){if(l===m)return"";let o=l.length-1,r=-1;for(i=m.length-1;i>=0;--i){const a=m.charCodeAt(i);if(a===v){if(!s){u=i+1;break}}else r===-1&&(s=!1,r=i+1),o>=0&&(a===l.charCodeAt(o)?--o==-1&&(n=i):(o=-1,n=r))}return u===n?n=r:n===-1&&(n=m.length),m.slice(u,n)}for(i=m.length-1;i>=0;--i)if(m.charCodeAt(i)===v){if(!s){u=i+1;break}}else n===-1&&(s=!1,n=i+1);return n===-1?"":m.slice(u,n)},extname(m){y(m,"path");let l=-1,u=0,n=-1,s=!0,i=0;for(let o=m.length-1;o>=0;--o){const r=m.charCodeAt(o);if(r===v){if(!s){u=o+1;break}continue}n===-1&&(s=!1,n=o+1),r===E?l===-1?l=o:i!==1&&(i=1):l!==-1&&(i=-1)}return l===-1||n===-1||i===0||i===1&&l===n-1&&l===u+1?"":m.slice(l,n)},format:p.bind(null,"/"),parse(m){y(m,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return l;const u=m.charCodeAt(0)===v;let n;u?(l.root="/",n=1):n=0;let s=-1,i=0,o=-1,r=!0,a=m.length-1,c=0;for(;a>=n;--a){const f=m.charCodeAt(a);if(f===v){if(!r){i=a+1;break}continue}o===-1&&(r=!1,o=a+1),f===E?s===-1?s=a:c!==1&&(c=1):s!==-1&&(c=-1)}if(o!==-1){const f=i===0&&u?1:i;s===-1||c===0||c===1&&s===o-1&&s===i+1?l.base=l.name=m.slice(f,o):(l.name=m.slice(f,s),l.base=m.slice(f,o),l.ext=m.slice(s,o))}return i>0?l.dir=m.slice(0,i-1):u&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=I.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=I.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=I.platform==="win32"?e.win32.join:e.posix.join,e.resolve=I.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=I.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=I.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=I.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=I.platform==="win32"?e.win32.extname:e.posix.extname,e.format=I.platform==="win32"?e.win32.format:e.posix.format,e.parse=I.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=I.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=I.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=I.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(we[64],ye([0,1,5]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var t;(function(R){R.text="text/plain",R.binary="application/octet-stream",R.unknown="application/unknown",R.markdown="text/markdown",R.latex="text/latex",R.uriList="text/uri-list"})(t=e.Mimes||(e.Mimes={}));const b={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function k(R){const C=(0,I.extname)(R),y=b[C.toLowerCase()];return y!==void 0?y:E(R)}e.getMediaOrTextMime=k;function E(R){const C=(0,I.extname)(R);return P[C.toLowerCase()]}e.getMediaMime=E;function v(R){for(const C in P)if(P[C]===R)return C}e.getExtensionForMimeType=v;const D=/^(.+)\/(.+?)(;.+)?$/;function T(R,C){const y=D.exec(R);return y?`${y[1].toLowerCase()}/${y[2].toLowerCase()}${y[3]??""}`:C?void 0:R}e.normalizeMimeType=T}),define(we[53],ye([0,1,3]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var b;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(b=e.TerminateResponseCode||(e.TerminateResponseCode={}));function P(E,...v){const D=v.reduce((C,y)=>(C[y]=!0,C),{}),T=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(C=>!D[C]).forEach(C=>{for(let y=0;y<T.length;y++)if(C.search(T[y])!==-1){delete E[C];break}})}e.sanitizeProcessEnvironment=P;function k(E){!E||(delete E.DEBUG,I.isMacintosh&&delete E.DYLD_LIBRARY_PATH,I.isLinux&&delete E.LD_PRELOAD)}e.removeDangerousEnvVariables=k}),function(ie,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var t in I)(typeof exports=="object"?exports:ie)[t]=I[t]}}(typeof self!="undefined"?self:this,function(){return function(ie){var e={};function I(t){if(e[t])return e[t].exports;var b=e[t]={i:t,l:!1,exports:{}};return ie[t].call(b.exports,b,b.exports,I),b.l=!0,b.exports}return I.m=ie,I.c=e,I.d=function(t,b,P){I.o(t,b)||Object.defineProperty(t,b,{enumerable:!0,get:P})},I.r=function(t){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},I.t=function(t,b){if(1&b&&(t=I(t)),8&b||4&b&&typeof t=="object"&&t&&t.__esModule)return t;var P=Object.create(null);if(I.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:t}),2&b&&typeof t!="string")for(var k in t)I.d(P,k,function(E){return t[E]}.bind(null,k));return P},I.n=function(t){var b=t&&t.__esModule?function(){return t.default}:function(){return t};return I.d(b,"a",b),b},I.o=function(t,b){return Object.prototype.hasOwnProperty.call(t,b)},I.p="",I(I.s=0)}([function(ie,e,I){(function(t){var b;e=ie.exports=q,b=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var de=Array.prototype.slice.call(arguments,0);de.unshift("SEMVER"),console.log.apply(console,de)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],v=e.src=[],D=0,T=D++;v[T]="0|[1-9]\\d*";var R=D++;v[R]="[0-9]+";var C=D++;v[C]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=D++;v[y]="("+v[T]+")\\.("+v[T]+")\\.("+v[T]+")";var d=D++;v[d]="("+v[R]+")\\.("+v[R]+")\\.("+v[R]+")";var S=D++;v[S]="(?:"+v[T]+"|"+v[C]+")";var h=D++;v[h]="(?:"+v[R]+"|"+v[C]+")";var g=D++;v[g]="(?:-("+v[S]+"(?:\\."+v[S]+")*))";var p=D++;v[p]="(?:-?("+v[h]+"(?:\\."+v[h]+")*))";var m=D++;v[m]="[0-9A-Za-z-]+";var l=D++;v[l]="(?:\\+("+v[m]+"(?:\\."+v[m]+")*))";var u=D++,n="v?"+v[y]+v[g]+"?"+v[l]+"?";v[u]="^"+n+"$";var s="[v=\\s]*"+v[d]+v[p]+"?"+v[l]+"?",i=D++;v[i]="^"+s+"$";var o=D++;v[o]="((?:<|>)?=?)";var r=D++;v[r]=v[R]+"|x|X|\\*";var a=D++;v[a]=v[T]+"|x|X|\\*";var c=D++;v[c]="[v=\\s]*("+v[a]+")(?:\\.("+v[a]+")(?:\\.("+v[a]+")(?:"+v[g]+")?"+v[l]+"?)?)?";var f=D++;v[f]="[v=\\s]*("+v[r]+")(?:\\.("+v[r]+")(?:\\.("+v[r]+")(?:"+v[p]+")?"+v[l]+"?)?)?";var w=D++;v[w]="^"+v[o]+"\\s*"+v[c]+"$";var A=D++;v[A]="^"+v[o]+"\\s*"+v[f]+"$";var U=D++;v[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var x=D++;v[x]="(?:~>?)";var Q=D++;v[Q]="(\\s*)"+v[x]+"\\s+",E[Q]=new RegExp(v[Q],"g");var _=D++;v[_]="^"+v[x]+v[c]+"$";var Y=D++;v[Y]="^"+v[x]+v[f]+"$";var O=D++;v[O]="(?:\\^)";var B=D++;v[B]="(\\s*)"+v[O]+"\\s+",E[B]=new RegExp(v[B],"g");var ue=D++;v[ue]="^"+v[O]+v[c]+"$";var V=D++;v[V]="^"+v[O]+v[f]+"$";var $=D++;v[$]="^"+v[o]+"\\s*("+s+")$|^$";var F=D++;v[F]="^"+v[o]+"\\s*("+n+")$|^$";var M=D++;v[M]="(\\s*)"+v[o]+"\\s*("+s+"|"+v[c]+")",E[M]=new RegExp(v[M],"g");var j=D++;v[j]="^\\s*("+v[c]+")\\s+-\\s+("+v[c]+")\\s*$";var Z=D++;v[Z]="^\\s*("+v[f]+")\\s+-\\s+("+v[f]+")\\s*$";var oe=D++;v[oe]="(<|>)?=?\\s*\\*";for(var ge=0;ge<35;ge++)b(ge,v[ge]),E[ge]||(E[ge]=new RegExp(v[ge]));function he(de,be){if(de instanceof q)return de;if(typeof de!="string"||de.length>P||!(be?E[i]:E[u]).test(de))return null;try{return new q(de,be)}catch{return null}}function q(de,be){if(de instanceof q){if(de.loose===be)return de;de=de.version}else if(typeof de!="string")throw new TypeError("Invalid Version: "+de);if(de.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof q))return new q(de,be);b("SemVer",de,be),this.loose=be;var pe=de.trim().match(be?E[i]:E[u]);if(!pe)throw new TypeError("Invalid Version: "+de);if(this.raw=de,this.major=+pe[1],this.minor=+pe[2],this.patch=+pe[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");pe[4]?this.prerelease=pe[4].split(".").map(function(_e){if(/^[0-9]+$/.test(_e)){var Ne=+_e;if(Ne>=0&&Ne<k)return Ne}return _e}):this.prerelease=[],this.build=pe[5]?pe[5].split("."):[],this.format()}e.parse=he,e.valid=function(de,be){var pe=he(de,be);return pe?pe.version:null},e.clean=function(de,be){var pe=he(de.trim().replace(/^[=v]+/,""),be);return pe?pe.version:null},e.SemVer=q,q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},q.prototype.toString=function(){return this.version},q.prototype.compare=function(de){return b("SemVer.compare",this.version,this.loose,de),de instanceof q||(de=new q(de,this.loose)),this.compareMain(de)||this.comparePre(de)},q.prototype.compareMain=function(de){return de instanceof q||(de=new q(de,this.loose)),G(this.major,de.major)||G(this.minor,de.minor)||G(this.patch,de.patch)},q.prototype.comparePre=function(de){if(de instanceof q||(de=new q(de,this.loose)),this.prerelease.length&&!de.prerelease.length)return-1;if(!this.prerelease.length&&de.prerelease.length)return 1;if(!this.prerelease.length&&!de.prerelease.length)return 0;var be=0;do{var pe=this.prerelease[be],_e=de.prerelease[be];if(b("prerelease compare",be,pe,_e),pe===void 0&&_e===void 0)return 0;if(_e===void 0)return 1;if(pe===void 0)return-1;if(pe!==_e)return G(pe,_e)}while(++be)},q.prototype.inc=function(de,be){switch(de){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",be);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",be);break;case"prepatch":this.prerelease.length=0,this.inc("patch",be),this.inc("pre",be);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",be),this.inc("pre",be);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var pe=this.prerelease.length;--pe>=0;)typeof this.prerelease[pe]=="number"&&(this.prerelease[pe]++,pe=-2);pe===-1&&this.prerelease.push(0)}be&&(this.prerelease[0]===be?isNaN(this.prerelease[1])&&(this.prerelease=[be,0]):this.prerelease=[be,0]);break;default:throw new Error("invalid increment argument: "+de)}return this.format(),this.raw=this.version,this},e.inc=function(de,be,pe,_e){typeof pe=="string"&&(_e=pe,pe=void 0);try{return new q(de,pe).inc(be,_e).version}catch{return null}},e.diff=function(de,be){if(J(de,be))return null;var pe=he(de),_e=he(be);if(pe.prerelease.length||_e.prerelease.length){for(var Ne in pe)if((Ne==="major"||Ne==="minor"||Ne==="patch")&&pe[Ne]!==_e[Ne])return"pre"+Ne;return"prerelease"}for(var Ne in pe)if((Ne==="major"||Ne==="minor"||Ne==="patch")&&pe[Ne]!==_e[Ne])return Ne},e.compareIdentifiers=G;var ee=/^[0-9]+$/;function G(de,be){var pe=ee.test(de),_e=ee.test(be);return pe&&_e&&(de=+de,be=+be),pe&&!_e?-1:_e&&!pe?1:de<be?-1:de>be?1:0}function z(de,be,pe){return new q(de,pe).compare(new q(be,pe))}function te(de,be,pe){return z(de,be,pe)>0}function ce(de,be,pe){return z(de,be,pe)<0}function J(de,be,pe){return z(de,be,pe)===0}function se(de,be,pe){return z(de,be,pe)!==0}function me(de,be,pe){return z(de,be,pe)>=0}function X(de,be,pe){return z(de,be,pe)<=0}function re(de,be,pe,_e){var Ne;switch(be){case"===":typeof de=="object"&&(de=de.version),typeof pe=="object"&&(pe=pe.version),Ne=de===pe;break;case"!==":typeof de=="object"&&(de=de.version),typeof pe=="object"&&(pe=pe.version),Ne=de!==pe;break;case"":case"=":case"==":Ne=J(de,pe,_e);break;case"!=":Ne=se(de,pe,_e);break;case">":Ne=te(de,pe,_e);break;case">=":Ne=me(de,pe,_e);break;case"<":Ne=ce(de,pe,_e);break;case"<=":Ne=X(de,pe,_e);break;default:throw new TypeError("Invalid operator: "+be)}return Ne}function W(de,be){if(de instanceof W){if(de.loose===be)return de;de=de.value}if(!(this instanceof W))return new W(de,be);b("comparator",de,be),this.loose=be,this.parse(de),this.semver===K?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}e.rcompareIdentifiers=function(de,be){return G(be,de)},e.major=function(de,be){return new q(de,be).major},e.minor=function(de,be){return new q(de,be).minor},e.patch=function(de,be){return new q(de,be).patch},e.compare=z,e.compareLoose=function(de,be){return z(de,be,!0)},e.rcompare=function(de,be,pe){return z(be,de,pe)},e.sort=function(de,be){return de.sort(function(pe,_e){return e.compare(pe,_e,be)})},e.rsort=function(de,be){return de.sort(function(pe,_e){return e.rcompare(pe,_e,be)})},e.gt=te,e.lt=ce,e.eq=J,e.neq=se,e.gte=me,e.lte=X,e.cmp=re,e.Comparator=W;var K={};function le(de,be){if(de instanceof le)return de.loose===be?de:new le(de.raw,be);if(de instanceof W)return new le(de.value,be);if(!(this instanceof le))return new le(de,be);if(this.loose=be,this.raw=de,this.set=de.split(/\s*\|\|\s*/).map(function(pe){return this.parseRange(pe.trim())},this).filter(function(pe){return pe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+de);this.format()}function ve(de){return!de||de.toLowerCase()==="x"||de==="*"}function De(de,be,pe,_e,Ne,qe,ze,He,Qe,Ve,ae,Ce,ke){return((be=ve(pe)?"":ve(_e)?">="+pe+".0.0":ve(Ne)?">="+pe+"."+_e+".0":">="+be)+" "+(He=ve(Qe)?"":ve(Ve)?"<"+(+Qe+1)+".0.0":ve(ae)?"<"+Qe+"."+(+Ve+1)+".0":Ce?"<="+Qe+"."+Ve+"."+ae+"-"+Ce:"<="+He)).trim()}function Te(de,be){for(var pe=0;pe<de.length;pe++)if(!de[pe].test(be))return!1;if(be.prerelease.length){for(pe=0;pe<de.length;pe++)if(b(de[pe].semver),de[pe].semver!==K&&de[pe].semver.prerelease.length>0){var _e=de[pe].semver;if(_e.major===be.major&&_e.minor===be.minor&&_e.patch===be.patch)return!0}return!1}return!0}function Oe(de,be,pe){try{be=new le(be,pe)}catch{return!1}return be.test(de)}function Ue(de,be,pe,_e){var Ne,qe,ze,He,Qe;switch(de=new q(de,_e),be=new le(be,_e),pe){case">":Ne=te,qe=X,ze=ce,He=">",Qe=">=";break;case"<":Ne=ce,qe=me,ze=te,He="<",Qe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Oe(de,be,_e))return!1;for(var Ve=0;Ve<be.set.length;++Ve){var ae=be.set[Ve],Ce=null,ke=null;if(ae.forEach(function(Le){Le.semver===K&&(Le=new W(">=0.0.0")),Ce=Ce||Le,ke=ke||Le,Ne(Le.semver,Ce.semver,_e)?Ce=Le:ze(Le.semver,ke.semver,_e)&&(ke=Le)}),Ce.operator===He||Ce.operator===Qe||(!ke.operator||ke.operator===He)&&qe(de,ke.semver)||ke.operator===Qe&&ze(de,ke.semver))return!1}return!0}W.prototype.parse=function(de){var be=this.loose?E[$]:E[F],pe=de.match(be);if(!pe)throw new TypeError("Invalid comparator: "+de);this.operator=pe[1],this.operator==="="&&(this.operator=""),pe[2]?this.semver=new q(pe[2],this.loose):this.semver=K},W.prototype.toString=function(){return this.value},W.prototype.test=function(de){return b("Comparator.test",de,this.loose),this.semver===K||(typeof de=="string"&&(de=new q(de,this.loose)),re(de,this.operator,this.semver,this.loose))},W.prototype.intersects=function(de,be){if(!(de instanceof W))throw new TypeError("a Comparator is required");var pe;if(this.operator==="")return pe=new le(de.value,be),Oe(this.value,pe,be);if(de.operator==="")return pe=new le(this.value,be),Oe(de.semver,pe,be);var _e=!(this.operator!==">="&&this.operator!==">"||de.operator!==">="&&de.operator!==">"),Ne=!(this.operator!=="<="&&this.operator!=="<"||de.operator!=="<="&&de.operator!=="<"),qe=this.semver.version===de.semver.version,ze=!(this.operator!==">="&&this.operator!=="<="||de.operator!==">="&&de.operator!=="<="),He=re(this.semver,"<",de.semver,be)&&(this.operator===">="||this.operator===">")&&(de.operator==="<="||de.operator==="<"),Qe=re(this.semver,">",de.semver,be)&&(this.operator==="<="||this.operator==="<")&&(de.operator===">="||de.operator===">");return _e||Ne||qe&&ze||He||Qe},e.Range=le,le.prototype.format=function(){return this.range=this.set.map(function(de){return de.join(" ").trim()}).join("||").trim(),this.range},le.prototype.toString=function(){return this.range},le.prototype.parseRange=function(de){var be=this.loose;de=de.trim(),b("range",de,be);var pe=be?E[Z]:E[j];de=de.replace(pe,De),b("hyphen replace",de),de=de.replace(E[M],"$1$2$3"),b("comparator trim",de,E[M]),de=(de=(de=de.replace(E[Q],"$1~")).replace(E[B],"$1^")).split(/\s+/).join(" ");var _e=be?E[$]:E[F],Ne=de.split(" ").map(function(qe){return function(ze,He){return b("comp",ze),ze=function(Qe,Ve){return Qe.trim().split(/\s+/).map(function(ae){return function(Ce,ke){b("caret",Ce,ke);var Le=ke?E[V]:E[ue];return Ce.replace(Le,function(Be,Me,je,Ke,Xe){var xe;return b("caret",Ce,Be,Me,je,Ke,Xe),ve(Me)?xe="":ve(je)?xe=">="+Me+".0.0 <"+(+Me+1)+".0.0":ve(Ke)?xe=Me==="0"?">="+Me+"."+je+".0 <"+Me+"."+(+je+1)+".0":">="+Me+"."+je+".0 <"+(+Me+1)+".0.0":Xe?(b("replaceCaret pr",Xe),Xe.charAt(0)!=="-"&&(Xe="-"+Xe),xe=Me==="0"?je==="0"?">="+Me+"."+je+"."+Ke+Xe+" <"+Me+"."+je+"."+(+Ke+1):">="+Me+"."+je+"."+Ke+Xe+" <"+Me+"."+(+je+1)+".0":">="+Me+"."+je+"."+Ke+Xe+" <"+(+Me+1)+".0.0"):(b("no pr"),xe=Me==="0"?je==="0"?">="+Me+"."+je+"."+Ke+" <"+Me+"."+je+"."+(+Ke+1):">="+Me+"."+je+"."+Ke+" <"+Me+"."+(+je+1)+".0":">="+Me+"."+je+"."+Ke+" <"+(+Me+1)+".0.0"),b("caret return",xe),xe})}(ae,Ve)}).join(" ")}(ze,He),b("caret",ze),ze=function(Qe,Ve){return Qe.trim().split(/\s+/).map(function(ae){return function(Ce,ke){var Le=ke?E[Y]:E[_];return Ce.replace(Le,function(Be,Me,je,Ke,Xe){var xe;return b("tilde",Ce,Be,Me,je,Ke,Xe),ve(Me)?xe="":ve(je)?xe=">="+Me+".0.0 <"+(+Me+1)+".0.0":ve(Ke)?xe=">="+Me+"."+je+".0 <"+Me+"."+(+je+1)+".0":Xe?(b("replaceTilde pr",Xe),Xe.charAt(0)!=="-"&&(Xe="-"+Xe),xe=">="+Me+"."+je+"."+Ke+Xe+" <"+Me+"."+(+je+1)+".0"):xe=">="+Me+"."+je+"."+Ke+" <"+Me+"."+(+je+1)+".0",b("tilde return",xe),xe})}(ae,Ve)}).join(" ")}(ze,He),b("tildes",ze),ze=function(Qe,Ve){return b("replaceXRanges",Qe,Ve),Qe.split(/\s+/).map(function(ae){return function(Ce,ke){Ce=Ce.trim();var Le=ke?E[A]:E[w];return Ce.replace(Le,function(Be,Me,je,Ke,Xe,xe){b("xRange",Ce,Be,Me,je,Ke,Xe,xe);var tt=ve(je),nt=tt||ve(Ke),st=nt||ve(Xe);return Me==="="&&st&&(Me=""),tt?Be=Me===">"||Me==="<"?"<0.0.0":"*":Me&&st?(nt&&(Ke=0),st&&(Xe=0),Me===">"?(Me=">=",nt?(je=+je+1,Ke=0,Xe=0):st&&(Ke=+Ke+1,Xe=0)):Me==="<="&&(Me="<",nt?je=+je+1:Ke=+Ke+1),Be=Me+je+"."+Ke+"."+Xe):nt?Be=">="+je+".0.0 <"+(+je+1)+".0.0":st&&(Be=">="+je+"."+Ke+".0 <"+je+"."+(+Ke+1)+".0"),b("xRange return",Be),Be})}(ae,Ve)}).join(" ")}(ze,He),b("xrange",ze),ze=function(Qe,Ve){return b("replaceStars",Qe,Ve),Qe.trim().replace(E[oe],"")}(ze,He),b("stars",ze),ze}(qe,be)}).join(" ").split(/\s+/);return this.loose&&(Ne=Ne.filter(function(qe){return!!qe.match(_e)})),Ne=Ne.map(function(qe){return new W(qe,be)})},le.prototype.intersects=function(de,be){if(!(de instanceof le))throw new TypeError("a Range is required");return this.set.some(function(pe){return pe.every(function(_e){return de.set.some(function(Ne){return Ne.every(function(qe){return _e.intersects(qe,be)})})})})},e.toComparators=function(de,be){return new le(de,be).set.map(function(pe){return pe.map(function(_e){return _e.value}).join(" ").trim().split(" ")})},le.prototype.test=function(de){if(!de)return!1;typeof de=="string"&&(de=new q(de,this.loose));for(var be=0;be<this.set.length;be++)if(Te(this.set[be],de))return!0;return!1},e.satisfies=Oe,e.maxSatisfying=function(de,be,pe){var _e=null,Ne=null;try{var qe=new le(be,pe)}catch{return null}return de.forEach(function(ze){qe.test(ze)&&(_e&&Ne.compare(ze)!==-1||(Ne=new q(_e=ze,pe)))}),_e},e.minSatisfying=function(de,be,pe){var _e=null,Ne=null;try{var qe=new le(be,pe)}catch{return null}return de.forEach(function(ze){qe.test(ze)&&(_e&&Ne.compare(ze)!==1||(Ne=new q(_e=ze,pe)))}),_e},e.validRange=function(de,be){try{return new le(de,be).range||"*"}catch{return null}},e.ltr=function(de,be,pe){return Ue(de,be,"<",pe)},e.gtr=function(de,be,pe){return Ue(de,be,">",pe)},e.outside=Ue,e.prerelease=function(de,be){var pe=he(de,be);return pe&&pe.prerelease.length?pe.prerelease:null},e.intersects=function(de,be,pe){return de=new le(de,pe),be=new le(be,pe),de.intersects(be)},e.coerce=function(de){if(de instanceof q)return de;if(typeof de!="string")return null;var be=de.match(E[U]);return be==null?null:he((be[1]||"0")+"."+(be[2]||"0")+"."+(be[3]||"0"))}}).call(this,I(1))},function(ie,e){var I,t,b=ie.exports={};function P(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function E(h){if(I===setTimeout)return setTimeout(h,0);if((I===P||!I)&&setTimeout)return I=setTimeout,setTimeout(h,0);try{return I(h,0)}catch{try{return I.call(null,h,0)}catch{return I.call(this,h,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:P}catch{I=P}try{t=typeof clearTimeout=="function"?clearTimeout:k}catch{t=k}})();var v,D=[],T=!1,R=-1;function C(){T&&v&&(T=!1,v.length?D=v.concat(D):R=-1,D.length&&y())}function y(){if(!T){var h=E(C);T=!0;for(var g=D.length;g;){for(v=D,D=[];++R<g;)v&&v[R].run();R=-1,g=D.length}v=null,T=!1,function(p){if(t===clearTimeout)return clearTimeout(p);if((t===k||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(p);try{t(p)}catch{try{return t.call(null,p)}catch{return t.call(this,p)}}}(h)}}function d(h,g){this.fun=h,this.array=g}function S(){}b.nextTick=function(h){var g=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)g[p-1]=arguments[p];D.push(new d(h,g)),D.length!==1||T||E(y)},d.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=S,b.addListener=S,b.once=S,b.off=S,b.removeListener=S,b.removeAllListeners=S,b.emit=S,b.prependListener=S,b.prependOnceListener=S,b.listeners=function(h){return[]},b.binding=function(h){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(h){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(we[133],ye([0,1]),function(ie,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(E,v,D){this.level=E,this.key=v,this.value=D,this.forward=[]}}const b=void 0;class P{constructor(E,v=2**16){this.comparator=E,this[I]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(v)|0),this._header=new t(this._maxLevel,b,b)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,b,b)}has(E){return Boolean(P._search(this,E,this.comparator))}get(E){return P._search(this,E,this.comparator)?.value}set(E,v){return P._insert(this,E,v,this.comparator)&&(this._size+=1),this}delete(E){const v=P._delete(this,E,this.comparator);return v&&(this._size-=1),v}forEach(E,v){let D=this._header.forward[0];for(;D;)E.call(v,D.value,D.key,this),D=D.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this._header.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this._header.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this._header.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",v=this._header.forward[0];for(;v;)E+=`node(${v.key}, ${v.value}, lvl:${v.level})`,v=v.forward[0];return E}static _search(E,v,D){let T=E._header;for(let R=E._level-1;R>=0;R--)for(;T.forward[R]&&D(T.forward[R].key,v)<0;)T=T.forward[R];if(T=T.forward[0],T&&D(T.key,v)===0)return T}static _insert(E,v,D,T){let R=[],C=E._header;for(let y=E._level-1;y>=0;y--){for(;C.forward[y]&&T(C.forward[y].key,v)<0;)C=C.forward[y];R[y]=C}if(C=C.forward[0],C&&T(C.key,v)===0)return C.value=D,!1;{let y=P._randomLevel(E);if(y>E._level){for(let d=E._level;d<y;d++)R[d]=E._header;E._level=y}C=new t(y,v,D);for(let d=0;d<y;d++)C.forward[d]=R[d].forward[d],R[d].forward[d]=C;return!0}}static _randomLevel(E,v=.5){let D=1;for(;Math.random()<v&&D<E._maxLevel;)D+=1;return D}static _delete(E,v,D){let T=[],R=E._header;for(let C=E._level-1;C>=0;C--){for(;R.forward[C]&&D(R.forward[C].key,v)<0;)R=R.forward[C];T[C]=R}if(R=R.forward[0],!R||D(R.key,v)!==0)return!1;for(let C=0;C<E._level&&T[C].forward[C]===R;C++)T[C].forward[C]=R.forward[C];for(;E._level>0&&E._header.forward[E._level-1]===b;)E._level-=1;return!0}}e.SkipList=P}),define(we[134],ye([0,1,3]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=I.globals.performance&&typeof I.globals.performance.now=="function";class b{constructor(k){this._highResolution=t&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new b(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?I.globals.performance.now():Date.now()}}e.StopWatch=b}),define(we[6],ye([0,1,9,62,2,131,134]),function(ie,e,I,t,b,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;let E=!1,v=!1;var D;(function(a){a.None=()=>b.Disposable.None;function c(he){if(v){const{onListenerDidAdd:q}=he,ee=d.create();let G=0;he.onListenerDidAdd=()=>{++G==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ee.print()),q?.()}}}function f(he){return(q,ee=null,G)=>{let z=!1,te;return te=he(ce=>{if(!z)return te?te.dispose():z=!0,q.call(ee,ce)},null,G),z&&te.dispose(),te}}a.once=f;function w(he,q,ee){return Y((G,z=null,te)=>he(ce=>G.call(z,q(ce)),null,te),ee)}a.map=w;function A(he,q,ee){return Y((G,z=null,te)=>he(ce=>{q(ce),G.call(z,ce)},null,te),ee)}a.forEach=A;function U(he,q,ee){return Y((G,z=null,te)=>he(ce=>q(ce)&&G.call(z,ce),null,te),ee)}a.filter=U;function x(he){return he}a.signal=x;function Q(...he){return(q,ee=null,G)=>(0,b.combinedDisposable)(...he.map(z=>z(te=>q.call(ee,te),null,G)))}a.any=Q;function _(he,q,ee,G){let z=ee;return w(he,te=>(z=q(z,te),z),G)}a.reduce=_;function Y(he,q){let ee;const G={onFirstListenerAdd(){ee=he(z.fire,z)},onLastListenerRemove(){ee.dispose()}};q||c(G);const z=new h(G);return q&&q.add(z),z.event}function O(he,q,ee=100,G=!1,z,te){let ce,J,se,me=0;const X={leakWarningThreshold:z,onFirstListenerAdd(){ce=he(W=>{me++,J=q(J,W),G&&!se&&(re.fire(J),J=void 0),clearTimeout(se),se=setTimeout(()=>{const K=J;J=void 0,se=void 0,(!G||me>1)&&re.fire(K),me=0},ee)})},onLastListenerRemove(){ce.dispose()}};te||c(X);const re=new h(X);return te&&te.add(re),re.event}a.debounce=O;function B(he,q=(G,z)=>G===z,ee){let G=!0,z;return U(he,te=>{const ce=G||!q(te,z);return G=!1,z=te,ce},ee)}a.latch=B;function ue(he,q,ee){return[a.filter(he,q,ee),a.filter(he,G=>!q(G),ee)]}a.split=ue;function V(he,q=!1,ee=[]){let G=ee.slice(),z=he(J=>{G?G.push(J):ce.fire(J)});const te=()=>{G&&G.forEach(J=>ce.fire(J)),G=null},ce=new h({onFirstListenerAdd(){z||(z=he(J=>ce.fire(J)))},onFirstListenerDidAdd(){G&&(q?setTimeout(te):te())},onLastListenerRemove(){z&&z.dispose(),z=null}});return ce.event}a.buffer=V;class ${constructor(q){this.event=q}map(q){return new $(w(this.event,q))}forEach(q){return new $(A(this.event,q))}filter(q){return new $(U(this.event,q))}reduce(q,ee){return new $(_(this.event,q,ee))}latch(){return new $(B(this.event))}debounce(q,ee=100,G=!1,z){return new $(O(this.event,q,ee,G,z))}on(q,ee,G){return this.event(q,ee,G)}once(q,ee,G){return f(this.event)(q,ee,G)}}function F(he){return new $(he)}a.chain=F;function M(he,q,ee=G=>G){const G=(...J)=>ce.fire(ee(...J)),z=()=>he.on(q,G),te=()=>he.removeListener(q,G),ce=new h({onFirstListenerAdd:z,onLastListenerRemove:te});return ce.event}a.fromNodeEventEmitter=M;function j(he,q,ee=G=>G){const G=(...J)=>ce.fire(ee(...J)),z=()=>he.addEventListener(q,G),te=()=>he.removeEventListener(q,G),ce=new h({onFirstListenerAdd:z,onLastListenerRemove:te});return ce.event}a.fromDOMEventEmitter=j;function Z(he){return new Promise(q=>f(he)(q))}a.toPromise=Z;function oe(he,q){return q(void 0),he(ee=>q(ee))}a.runAndSubscribe=oe;function ge(he,q){let ee=null;function G(te){ee?.dispose(),ee=new b.DisposableStore,q(te,ee)}G(void 0);const z=he(te=>G(te));return(0,b.toDisposable)(()=>{z.dispose(),ee?.dispose()})}a.runAndSubscribeWithStore=ge})(D=e.Event||(e.Event={}));class T{constructor(c){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${c}_${T._idPool++}`}start(c){this._stopWatch=new k.StopWatch(!0),this._listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this._elapsedOverall+=c,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${c.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}T._idPool=0;let R=-1;function C(a){const c=R;return R=a,{dispose(){R=c}}}e.setGlobalLeakWarningThreshold=C;class y{constructor(c,f=Math.random().toString(18).slice(2,5)){this.customThreshold=c,this.name=f,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(c,f){let w=R;if(typeof this.customThreshold=="number"&&(w=this.customThreshold),w<=0||f<w)return;this._stacks||(this._stacks=new Map);const A=this._stacks.get(c.value)||0;if(this._stacks.set(c.value,A+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=w*.5;let U,x=0;for(const[Q,_]of this._stacks)(!U||x<_)&&(U=Q,x=_);console.warn(`[${this.name}] potential listener LEAK detected, having ${f} listeners already. MOST frequent listener (${x}):`),console.warn(U)}return()=>{const U=this._stacks.get(c.value)||0;this._stacks.set(c.value,U-1)}}}class d{constructor(c){this.value=c}static create(){return new d(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class S{constructor(c,f,w){this.callback=c,this.callbackThis=f,this.stack=w,this.subscription=new b.SafeDisposable}invoke(c){this.callback.call(this.callbackThis,c)}}class h{constructor(c){this._disposed=!1,this._options=c,this._leakageMon=R>0?new y(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new T(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(E){const c=Array.from(this._listeners);queueMicrotask(()=>{for(const f of c)f.subscription.isset()&&(f.subscription.unset(),f.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(c,f,w)=>{this._listeners||(this._listeners=new P.LinkedList);const A=this._listeners.isEmpty();A&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let U,x;this._leakageMon&&this._listeners.size>=30&&(x=d.create(),U=this._leakageMon.check(x,this._listeners.size+1)),E&&(x=x??d.create());const Q=new S(c,f,x),_=this._listeners.push(Q);A&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,c,f);const Y=Q.subscription.set(()=>{U&&U(),this._disposed||(_(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return w instanceof b.DisposableStore?w.add(Y):Array.isArray(w)&&w.push(Y),Y}),this._event}fire(c){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new p);for(let f of this._listeners)this._deliveryQueue.push(this,f,c);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=h;class g{constructor(){this._queue=new P.LinkedList}get size(){return this._queue.size}push(c,f,w){this._queue.push(new m(c,f,w))}clear(c){const f=new P.LinkedList;for(const w of this._queue)w.emitter!==c&&f.push(w);this._queue=f}deliver(){for(;this._queue.size>0;){const c=this._queue.shift();try{c.listener.invoke(c.event)}catch(f){(0,I.onUnexpectedError)(f)}}}}e.EventDeliveryQueue=g;class p extends g{clear(c){this._queue.clear()}}class m{constructor(c,f,w){this.emitter=c,this.listener=f,this.event=w}}class l extends h{async fireAsync(c,f,w){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new P.LinkedList);for(const A of this._listeners)this._asyncDeliveryQueue.push([A,c]);for(;this._asyncDeliveryQueue.size>0&&!f.isCancellationRequested;){const[A,U]=this._asyncDeliveryQueue.shift(),x=[],Q={...U,token:f,waitUntil:_=>{if(Object.isFrozen(x))throw new Error("waitUntil can NOT be called asynchronous");w&&(_=w(_,A.callback)),x.push(_)}};try{A.invoke(Q)}catch(_){(0,I.onUnexpectedError)(_);continue}Object.freeze(x),await Promise.allSettled(x).then(_=>{for(const Y of _)Y.status==="rejected"&&(0,I.onUnexpectedError)(Y.reason)})}}}}e.AsyncEmitter=l;class u extends h{constructor(c){super(c);this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=c?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=u;class n extends u{constructor(c){super(c);this._delay=c.delay??100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=n;class s extends h{constructor(c){super(c);this._queuedEvents=[],this._mergeFn=c?.merge}fire(c){this._queuedEvents.push(c),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(f=>super.fire(f)),this._queuedEvents=[]})}}e.MicrotaskEmitter=s;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new h({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const f={event:c,listener:null};this.events.push(f),this.hasListeners&&this.hook(f);const w=()=>{this.hasListeners&&this.unhook(f);const A=this.events.indexOf(f);this.events.splice(A,1)};return(0,b.toDisposable)((0,t.once)(w))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(f=>this.emitter.fire(f))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class o{constructor(){this.buffers=[]}wrapEvent(c){return(f,w,A)=>c(U=>{const x=this.buffers[this.buffers.length-1];x?x.push(()=>f.call(w,U)):f.call(w,U)},void 0,A)}bufferEvents(c){const f=[];this.buffers.push(f);const w=c();return this.buffers.pop(),f.forEach(A=>A()),w}}e.EventBufferer=o;class r{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=b.Disposable.None,this.emitter=new h({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=r}),define(we[20],ye([0,1,6]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(E,v){const D=setTimeout(E.bind(v),0);return{dispose(){clearTimeout(D)}}});var b;(function(E){function v(D){return D===E.None||D===E.Cancelled||D instanceof P?!0:!D||typeof D!="object"?!1:typeof D.isCancellationRequested=="boolean"&&typeof D.onCancellationRequested=="function"}E.isCancellationToken=v,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(b=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new I.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(v){this._token=void 0,this._parentListener=void 0,this._parentListener=v&&v.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=b.Cancelled}dispose(v=!1){v&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=b.None}}e.CancellationTokenSource=k}),define(we[135],ye([0,1,20]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(E){this.task=E,this.result=null}get(){if(this.result)return this.result;const E=new I.CancellationTokenSource,v=this.task(E.token);return this.result={promise:v,dispose:()=>{this.result=null,E.cancel(),E.dispose()}},this.result}}e.Cache=t;class b{constructor(E){this.fn=E,this.lastCache=void 0,this.lastArgKey=void 0}get(E){const v=JSON.stringify(E);return this.lastArgKey!==v&&(this.lastArgKey=v,this.lastCache=this.fn(E)),this.lastCache}}e.LRUCachedFunction=b;class P{constructor(E){this.fn=E,this._map=new Map}get cachedValues(){return this._map}get(E){if(this._map.has(E))return this._map.get(E);const v=this.fn(E);return this._map.set(E,v),v}}e.CachedFunction=P}),define(we[81],ye([0,1,6,2]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const b=k=>({onDidChange:I.Event.None,value:k});e.staticObservableValue=b;class P extends t.Disposable{constructor(E){super();this._value=E,this.changeEmitter=this._register(new I.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(E){E!==this._value&&(this._value=E,this.changeEmitter.fire(E))}}e.MutableObservableValue=P}),define(we[44],ye([0,1,9,2]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function b(l){const u=l;return u?typeof u.read=="function":!1}e.isReadable=b;function P(l){const u=l;return u?[u.on,u.pause,u.resume,u.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=P;function k(l){const u=l;return u?P(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.isReadableBufferedStream=k;function E(l,u){return new v(l,u)}e.newWriteableStream=E;class v{constructor(u,n){this.reducer=u,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(u){if(!this.state.destroyed){if(this.state.flowing)this.emitData(u);else if(this.buffer.data.push(u),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(u){this.state.destroyed||(this.state.flowing?this.emitError(u):this.buffer.error.push(u))}end(u){this.state.destroyed||(typeof u!="undefined"&&this.write(u),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(u){this.listeners.data.slice(0).forEach(n=>n(u))}emitError(u){this.listeners.error.length===0?(0,I.onUnexpectedError)(u):this.listeners.error.slice(0).forEach(n=>n(u))}emitEnd(){this.listeners.end.slice(0).forEach(u=>u())}on(u,n){if(!this.state.destroyed)switch(u){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(u,n){if(this.state.destroyed)return;let s;switch(u){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const i=s.indexOf(n);i>=0&&s.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const u=this.reducer(this.buffer.data);this.emitData(u),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const u of this.buffer.error)this.emitError(u);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(l,u){const n=[];let s;for(;(s=l.read())!==null;)n.push(s);return u(n)}e.consumeReadable=D;function T(l,u,n){const s=[];let i;for(;(i=l.read())!==null&&s.length<n;)s.push(i);return i===null&&s.length>0?u(s):{read:()=>{if(s.length>0)return s.shift();if(typeof i!="undefined"){const o=i;return i=void 0,o}return l.read()}}}e.peekReadable=T;function R(l,u){return new Promise((n,s)=>{const i=[];C(l,{onData:o=>{u&&i.push(o)},onError:o=>{u?s(o):n(void 0)},onEnd:()=>{n(u?u(i):void 0)}})})}e.consumeStream=R;function C(l,u){let n=!1;return l.on("error",s=>{n||u.onError(s)}),l.on("end",()=>{n||u.onEnd()}),l.on("data",s=>{n||u.onData(s)}),(0,t.toDisposable)(()=>n=!0)}e.listenStream=C;function y(l,u){return new Promise((n,s)=>{const i=new t.DisposableStore,o=[],r=f=>{if(o.push(f),o.length>u)return i.dispose(),l.pause(),n({stream:l,buffer:o,ended:!1})},a=f=>s(f),c=()=>n({stream:l,buffer:o,ended:!0});i.add((0,t.toDisposable)(()=>l.removeListener("error",a))),l.on("error",a),i.add((0,t.toDisposable)(()=>l.removeListener("end",c))),l.on("end",c),i.add((0,t.toDisposable)(()=>l.removeListener("data",r))),l.on("data",r)})}e.peekStream=y;function d(l,u){const n=E(u);return n.end(l),n}e.toStream=d;function S(){const l=E(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=S;function h(l){let u=!1;return{read:()=>u?null:(u=!0,l)}}e.toReadable=h;function g(l,u,n){const s=E(n);return C(l,{onData:i=>s.write(u.data(i)),onError:i=>s.error(u.error?u.error(i):i),onEnd:()=>s.end()}),s}e.transform=g;function p(l,u,n){let s=!1;return{read:()=>{const i=u.read();return s?i:(s=!0,i!==null?n([l,i]):l)}}}e.prefixedReadable=p;function m(l,u,n){let s=!1;const i=E(n);return C(u,{onData:o=>s?i.write(o):(s=!0,i.write(n([l,o]))),onError:o=>i.error(o),onEnd:()=>{s||(s=!0,i.write(l)),i.end()}}),i}e.prefixedStream=m}),define(we[16],ye([0,1,44]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let b,P;class k{constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}static alloc(f){return t?new k(Buffer.allocUnsafe(f)):new k(new Uint8Array(f))}static wrap(f){return t&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new k(f)}static fromString(f,w){return!(w?.dontUseNodeBuffer||!1)&&t?new k(Buffer.from(f)):(b||(b=new TextEncoder),new k(b.encode(f)))}static fromByteArray(f){const w=k.alloc(f.length);for(let A=0,U=f.length;A<U;A++)w.buffer[A]=f[A];return w}static concat(f,w){if(typeof w=="undefined"){w=0;for(let x=0,Q=f.length;x<Q;x++)w+=f[x].byteLength}const A=k.alloc(w);let U=0;for(let x=0,Q=f.length;x<Q;x++){const _=f[x];A.set(_,U),U+=_.byteLength}return A}clone(){const f=k.alloc(this.byteLength);return f.set(this),f}toString(){return t?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(f,w){return new k(this.buffer.subarray(f,w))}set(f,w){if(f instanceof k)this.buffer.set(f.buffer,w);else if(f instanceof Uint8Array)this.buffer.set(f,w);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),w);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return D(this.buffer,f)}writeUInt32BE(f,w){T(this.buffer,f,w)}readUInt32LE(f){return R(this.buffer,f)}writeUInt32LE(f,w){C(this.buffer,f,w)}readUInt8(f){return y(this.buffer,f)}writeUInt8(f,w){d(this.buffer,f,w)}}e.VSBuffer=k;function E(c,f){return c[f+0]<<0>>>0|c[f+1]<<8>>>0}e.readUInt16LE=E;function v(c,f,w){c[w+0]=f&255,f=f>>>8,c[w+1]=f&255}e.writeUInt16LE=v;function D(c,f){return c[f]*2**24+c[f+1]*2**16+c[f+2]*2**8+c[f+3]}e.readUInt32BE=D;function T(c,f,w){c[w+3]=f,f=f>>>8,c[w+2]=f,f=f>>>8,c[w+1]=f,f=f>>>8,c[w]=f}e.writeUInt32BE=T;function R(c,f){return c[f+0]<<0>>>0|c[f+1]<<8>>>0|c[f+2]<<16>>>0|c[f+3]<<24>>>0}e.readUInt32LE=R;function C(c,f,w){c[w+0]=f&255,f=f>>>8,c[w+1]=f&255,f=f>>>8,c[w+2]=f&255,f=f>>>8,c[w+3]=f&255}e.writeUInt32LE=C;function y(c,f){return c[f]}e.readUInt8=y;function d(c,f,w){c[w]=f}e.writeUInt8=d;function S(c){return I.consumeReadable(c,f=>k.concat(f))}e.readableToBuffer=S;function h(c){return I.toReadable(c)}e.bufferToReadable=h;function g(c){return I.consumeStream(c,f=>k.concat(f))}e.streamToBuffer=g;async function p(c){return c.ended?k.concat(c.buffer):k.concat([...c.buffer,await g(c.stream)])}e.bufferedStreamToBuffer=p;function m(c){return I.toStream(c,f=>k.concat(f))}e.bufferToStream=m;function l(c){return I.transform(c,{data:f=>typeof f=="string"?k.fromString(f):k.wrap(f)},f=>k.concat(f))}e.streamToBufferReadableStream=l;function u(c){return I.newWriteableStream(f=>k.concat(f),c)}e.newWriteableBufferStream=u;function n(c,f){return I.prefixedReadable(c,f,w=>k.concat(w))}e.prefixedBufferReadable=n;function s(c,f){return I.prefixedStream(c,f,w=>k.concat(w))}e.prefixedBufferStream=s;function i(c){let f=0,w=0,A=0;const U=new Uint8Array(Math.floor(c.length/4*3)),x=_=>{switch(w){case 3:U[A++]=f|_,w=0;break;case 2:U[A++]=f|_>>>2,f=_<<6,w=3;break;case 1:U[A++]=f|_>>>4,f=_<<4,w=2;break;default:f=_<<2,w=1}};for(let _=0;_<c.length;_++){const Y=c.charCodeAt(_);if(Y>=65&&Y<=90)x(Y-65);else if(Y>=97&&Y<=122)x(Y-97+26);else if(Y>=48&&Y<=57)x(Y-48+52);else if(Y===43||Y===45)x(62);else if(Y===47||Y===95)x(63);else{if(Y===61)break;throw new SyntaxError(`Unexpected base64 character ${c[_]}`)}}const Q=A;for(;w>0;)x(0);return k.wrap(U).slice(0,Q)}e.decodeBase64=i;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:c},f=!0,w=!1){const A=w?r:o;let U="";const x=c.byteLength%3;let Q=0;for(;Q<c.byteLength-x;Q+=3){const _=c[Q+0],Y=c[Q+1],O=c[Q+2];U+=A[_>>>2],U+=A[(_<<4|Y>>>4)&63],U+=A[(Y<<2|O>>>6)&63],U+=A[O&63]}if(x===1){const _=c[Q+0];U+=A[_>>>2],U+=A[_<<4&63],f&&(U+="==")}else if(x===2){const _=c[Q+0],Y=c[Q+1];U+=A[_>>>2],U+=A[(_<<4|Y>>>4)&63],U+=A[Y<<2&63],f&&(U+="=")}return U}e.encodeBase64=a}),define(we[15],ye([0,1,135,130]),function(ie,e,I,t){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function P(ae){return!ae||typeof ae!="string"?!0:ae.trim().length===0}e.isFalsyOrWhitespace=P;const k=/{(\d+)}/g;function E(ae,...Ce){return Ce.length===0?ae:ae.replace(k,function(ke,Le){const Be=parseInt(Le,10);return isNaN(Be)||Be<0||Be>=Ce.length?ke:Ce[Be]})}e.format=E;const v=/{([^}]+)}/g;function D(ae,Ce){return ae.replace(v,(ke,Le)=>Ce[Le]??ke)}e.format2=D;function T(ae){return ae.replace(/[<>&]/g,function(Ce){switch(Ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ce}})}e.escape=T;function R(ae){return ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=R;function C(ae,Ce){let ke=0;const Le=Ce.charCodeAt(0);for(let Be=ae.length-1;Be>=0;Be--)ae.charCodeAt(Be)===Le&&ke++;return ke}e.count=C;function y(ae,Ce,ke="\u2026"){return ae.length<=Ce?ae:`${ae.substr(0,Ce)}${ke}`}e.truncate=y;function d(ae,Ce=" "){const ke=S(ae,Ce);return h(ke,Ce)}e.trim=d;function S(ae,Ce){if(!ae||!Ce)return ae;const ke=Ce.length;if(ke===0||ae.length===0)return ae;let Le=0;for(;ae.indexOf(Ce,Le)===Le;)Le=Le+ke;return ae.substring(Le)}e.ltrim=S;function h(ae,Ce){if(!ae||!Ce)return ae;const ke=Ce.length,Le=ae.length;if(ke===0||Le===0)return ae;let Be=Le,Me=-1;for(;Me=ae.lastIndexOf(Ce,Be-1),!(Me===-1||Me+ke!==Be);){if(Me===0)return"";Be=Me}return ae.substring(0,Be)}e.rtrim=h;function g(ae){return ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function p(ae){return ae.replace(/\*/g,"")}e.stripWildcards=p;function m(ae,Ce,ke={}){if(!ae)throw new Error("Cannot create regex from empty string");Ce||(ae=R(ae)),ke.wholeWord&&(/\B/.test(ae.charAt(0))||(ae="\\b"+ae),/\B/.test(ae.charAt(ae.length-1))||(ae=ae+"\\b"));let Le="";return ke.global&&(Le+="g"),ke.matchCase||(Le+="i"),ke.multiline&&(Le+="m"),ke.unicode&&(Le+="u"),new RegExp(ae,Le)}e.createRegExp=m;function l(ae){return ae.source==="^"||ae.source==="^$"||ae.source==="$"||ae.source==="^\\s*$"?!1:!!(ae.exec("")&&ae.lastIndex===0)}e.regExpLeadsToEndlessLoop=l;function u(ae){return!!ae.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=u;function n(ae){return(ae.global?"g":"")+(ae.ignoreCase?"i":"")+(ae.multiline?"m":"")+(ae.unicode?"u":"")}e.regExpFlags=n;function s(ae){return ae.split(/\r\n|\r|\n/)}e.splitLines=s;function i(ae){for(let Ce=0,ke=ae.length;Ce<ke;Ce++){const Le=ae.charCodeAt(Ce);if(Le!==32&&Le!==9)return Ce}return-1}e.firstNonWhitespaceIndex=i;function o(ae,Ce=0,ke=ae.length){for(let Le=Ce;Le<ke;Le++){const Be=ae.charCodeAt(Le);if(Be!==32&&Be!==9)return ae.substring(Ce,Le)}return ae.substring(Ce,ke)}e.getLeadingWhitespace=o;function r(ae,Ce=ae.length-1){for(let ke=Ce;ke>=0;ke--){const Le=ae.charCodeAt(ke);if(Le!==32&&Le!==9)return ke}return-1}e.lastNonWhitespaceIndex=r;function a(ae,Ce,ke){let Le=[],Be=0;for(const Me of ae.matchAll(Ce)){if(Le.push(ae.slice(Be,Me.index)),Me.index===void 0)throw new Error("match.index should be defined");Be=Me.index+Me[0].length,Le.push(ke(Me[0],...Me.slice(1),Me.index,ae,Me.groups))}return Le.push(ae.slice(Be)),Promise.all(Le).then(Me=>Me.join(""))}e.replaceAsync=a;function c(ae,Ce){return ae<Ce?-1:ae>Ce?1:0}e.compare=c;function f(ae,Ce,ke=0,Le=ae.length,Be=0,Me=Ce.length){for(;ke<Le&&Be<Me;ke++,Be++){let Xe=ae.charCodeAt(ke),xe=Ce.charCodeAt(Be);if(Xe<xe)return-1;if(Xe>xe)return 1}const je=Le-ke,Ke=Me-Be;return je<Ke?-1:je>Ke?1:0}e.compareSubstring=f;function w(ae,Ce){return A(ae,Ce,0,ae.length,0,Ce.length)}e.compareIgnoreCase=w;function A(ae,Ce,ke=0,Le=ae.length,Be=0,Me=Ce.length){for(;ke<Le&&Be<Me;ke++,Be++){let Xe=ae.charCodeAt(ke),xe=Ce.charCodeAt(Be);if(Xe===xe)continue;if(Xe>=128||xe>=128)return f(ae.toLowerCase(),Ce.toLowerCase(),ke,Le,Be,Me);U(Xe)&&(Xe-=32),U(xe)&&(xe-=32);const tt=Xe-xe;if(tt!==0)return tt}const je=Le-ke,Ke=Me-Be;return je<Ke?-1:je>Ke?1:0}e.compareSubstringIgnoreCase=A;function U(ae){return ae>=97&&ae<=122}e.isLowerAsciiLetter=U;function x(ae){return ae>=65&&ae<=90}e.isUpperAsciiLetter=x;function Q(ae,Ce){return ae.length===Ce.length&&A(ae,Ce)===0}e.equalsIgnoreCase=Q;function _(ae,Ce){const ke=Ce.length;return Ce.length>ae.length?!1:A(ae,Ce,0,ke)===0}e.startsWithIgnoreCase=_;function Y(ae,Ce){let ke,Le=Math.min(ae.length,Ce.length);for(ke=0;ke<Le;ke++)if(ae.charCodeAt(ke)!==Ce.charCodeAt(ke))return ke;return Le}e.commonPrefixLength=Y;function O(ae,Ce){let ke,Le=Math.min(ae.length,Ce.length);const Be=ae.length-1,Me=Ce.length-1;for(ke=0;ke<Le;ke++)if(ae.charCodeAt(Be-ke)!==Ce.charCodeAt(Me-ke))return ke;return Le}e.commonSuffixLength=O;function B(ae){return 55296<=ae&&ae<=56319}e.isHighSurrogate=B;function ue(ae){return 56320<=ae&&ae<=57343}e.isLowSurrogate=ue;function V(ae,Ce){return(ae-55296<<10)+(Ce-56320)+65536}e.computeCodePoint=V;function $(ae,Ce,ke){const Le=ae.charCodeAt(ke);if(B(Le)&&ke+1<Ce){const Be=ae.charCodeAt(ke+1);if(ue(Be))return V(Le,Be)}return Le}e.getNextCodePoint=$;function F(ae,Ce){const ke=ae.charCodeAt(Ce-1);if(ue(ke)&&Ce>1){const Le=ae.charCodeAt(Ce-2);if(B(Le))return V(Le,ke)}return ke}class M{constructor(Ce,ke=0){this._str=Ce,this._len=Ce.length,this._offset=ke}get offset(){return this._offset}setOffset(Ce){this._offset=Ce}prevCodePoint(){const Ce=F(this._str,this._offset);return this._offset-=Ce>=65536?2:1,Ce}nextCodePoint(){const Ce=$(this._str,this._len,this._offset);return this._offset+=Ce>=65536?2:1,Ce}eol(){return this._offset>=this._len}}e.CodePointIterator=M;class j{constructor(Ce,ke=0){this._iterator=new M(Ce,ke)}get offset(){return this._iterator.offset}nextGraphemeLength(){const Ce=pe.getInstance(),ke=this._iterator,Le=ke.offset;let Be=Ce.getGraphemeBreakType(ke.nextCodePoint());for(;!ke.eol();){const Me=ke.offset,je=Ce.getGraphemeBreakType(ke.nextCodePoint());if(de(Be,je)){ke.setOffset(Me);break}Be=je}return ke.offset-Le}prevGraphemeLength(){const Ce=pe.getInstance(),ke=this._iterator,Le=ke.offset;let Be=Ce.getGraphemeBreakType(ke.prevCodePoint());for(;ke.offset>0;){const Me=ke.offset,je=Ce.getGraphemeBreakType(ke.prevCodePoint());if(de(je,Be)){ke.setOffset(Me);break}Be=je}return Le-ke.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=j;function Z(ae,Ce){return new j(ae,Ce).nextGraphemeLength()}e.nextCharLength=Z;function oe(ae,Ce){return new j(ae,Ce).prevGraphemeLength()}e.prevCharLength=oe;function ge(ae,Ce){Ce>0&&ue(ae.charCodeAt(Ce))&&Ce--;const ke=Ce+Z(ae,Ce);return[ke-oe(ae,ke),ke]}e.getCharContainingOffset=ge;const he=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function q(ae){return he.test(ae)}e.containsRTL=q;const ee=/^[\t\n\r\x20-\x7E]*$/;function G(ae){return ee.test(ae)}e.isBasicASCII=G,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function z(ae){return e.UNUSUAL_LINE_TERMINATORS.test(ae)}e.containsUnusualLineTerminators=z;function te(ae){return ae>=11904&&ae<=55215||ae>=63744&&ae<=64255||ae>=65281&&ae<=65374}e.isFullWidthCharacter=te;function ce(ae){return ae>=127462&&ae<=127487||ae===8986||ae===8987||ae===9200||ae===9203||ae>=9728&&ae<=10175||ae===11088||ae===11093||ae>=127744&&ae<=128591||ae>=128640&&ae<=128764||ae>=128992&&ae<=129008||ae>=129280&&ae<=129535||ae>=129648&&ae<=129782}e.isEmojiImprecise=ce;function J(ae,Ce){if(ae.length<Ce)return ae;const ke=/\b/g;let Le=0;for(;ke.test(ae)&&!(ae.length-ke.lastIndex<Ce);)Le=ke.lastIndex,ke.lastIndex+=1;return ae.substring(Le).replace(/^\s/,"")}e.lcut=J;const se=/\x1B\x5B[12]?K/g,me=/\x1b\[\d+m/g,X=/\x1b\[0?m/g;function re(ae){return ae&&(ae=ae.replace(se,""),ae=ae.replace(me,""),ae=ae.replace(X,"")),ae}e.removeAnsiEscapeCodes=re,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function W(ae){return!!(ae&&ae.length>0&&ae.charCodeAt(0)===65279)}e.startsWithUTF8BOM=W;function K(ae){return W(ae)?ae.substr(1):ae}e.stripUTF8BOM=K;function le(ae,Ce){if(!ae||!Ce||ae.length<Ce.length)return!1;const ke=Ce.length,Le=ae.toLowerCase();let Be=0,Me=-1;for(;Be<ke;){const je=Le.indexOf(Ce[Be],Me+1);if(je<0)return!1;Me=je,Be++}return!0}e.fuzzyContains=le;function ve(ae,Ce=!1){return ae?(Ce&&(ae=ae.replace(/\\./g,"")),ae.toLowerCase()!==ae):!1}e.containsUppercaseCharacter=ve;function De(ae){return ae.charAt(0).toUpperCase()+ae.slice(1)}e.uppercaseFirstLetter=De;function Te(ae,Ce=1){if(Ce===0)return"";let ke=-1;do ke=ae.indexOf(`
`,ke+1),Ce--;while(Ce>0&&ke>=0);return ke===-1?ae:(ae[ke-1]==="\r"&&ke--,ae.substr(0,ke))}e.getNLines=Te;function Oe(ae){const Ce=90-65+1;return ae=ae%(2*Ce),ae<Ce?String.fromCharCode(97+ae):String.fromCharCode(65+ae-Ce)}e.singleLetterHash=Oe;function Ue(ae){return pe.getInstance().getGraphemeBreakType(ae)}e.getGraphemeBreakType=Ue;function de(ae,Ce){return ae===0?Ce!==5&&Ce!==7:ae===2&&Ce===3?!1:ae===4||ae===2||ae===3||Ce===4||Ce===2||Ce===3?!0:!(ae===8&&(Ce===8||Ce===9||Ce===11||Ce===12)||(ae===11||ae===9)&&(Ce===9||Ce===10)||(ae===12||ae===10)&&Ce===10||Ce===5||Ce===13||Ce===7||ae===1||ae===13&&Ce===14||ae===6&&Ce===6)}var be;(function(ae){ae[ae.Other=0]="Other",ae[ae.Prepend=1]="Prepend",ae[ae.CR=2]="CR",ae[ae.LF=3]="LF",ae[ae.Control=4]="Control",ae[ae.Extend=5]="Extend",ae[ae.Regional_Indicator=6]="Regional_Indicator",ae[ae.SpacingMark=7]="SpacingMark",ae[ae.L=8]="L",ae[ae.V=9]="V",ae[ae.T=10]="T",ae[ae.LV=11]="LV",ae[ae.LVT=12]="LVT",ae[ae.ZWJ=13]="ZWJ",ae[ae.Extended_Pictographic=14]="Extended_Pictographic"})(be=e.GraphemeBreakType||(e.GraphemeBreakType={}));class pe{constructor(){this._data=_e()}static getInstance(){return pe._INSTANCE||(pe._INSTANCE=new pe),pe._INSTANCE}getGraphemeBreakType(Ce){if(Ce<32)return Ce===10?3:Ce===13?2:4;if(Ce<127)return 0;const ke=this._data,Le=ke.length/3;let Be=1;for(;Be<=Le;)if(Ce<ke[3*Be])Be=2*Be;else if(Ce>ke[3*Be+1])Be=2*Be+1;else return ke[3*Be+2];return 0}}pe._INSTANCE=null;function _e(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ne(ae,Ce){if(ae===0)return 0;const ke=qe(ae,Ce);if(ke!==void 0)return ke;const Le=new M(Ce,ae);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=Ne;function qe(ae,Ce){const ke=new M(Ce,ae);let Le=ke.prevCodePoint();for(;ze(Le)||Le===65039||Le===8419;){if(ke.offset===0)return;Le=ke.prevCodePoint()}if(!ce(Le))return;let Be=ke.offset;return Be>0&&ke.prevCodePoint()===8205&&(Be=ke.offset),Be}function ze(ae){return 127995<=ae&&ae<=127999}var He;(function(ae){ae[ae.zwj=8205]="zwj",ae[ae.emojiVariantSelector=65039]="emojiVariantSelector",ae[ae.enclosingKeyCap=8419]="enclosingKeyCap"})(He||(He={})),e.noBreakWhitespace="\xA0";class Qe{constructor(Ce){this.confusableDictionary=Ce}static getInstance(Ce){return Qe.cache.get(Array.from(Ce))}static getLocales(){return Qe._locales.getValue()}isAmbiguous(Ce){return this.confusableDictionary.has(Ce)}getPrimaryConfusable(Ce){return this.confusableDictionary.get(Ce)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Qe,b=Qe,Qe.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Qe.cache=new I.LRUCachedFunction(ae=>{function Ce(xe){const tt=new Map;for(let nt=0;nt<xe.length;nt+=2)tt.set(xe[nt],xe[nt+1]);return tt}function ke(xe,tt){const nt=new Map(xe);for(const[st,pt]of tt)nt.set(st,pt);return nt}function Le(xe,tt){if(!xe)return tt;const nt=new Map;for(const[st,pt]of xe)tt.has(st)&&nt.set(st,pt);return nt}const Be=b.ambiguousCharacterData.getValue();let Me=ae.filter(xe=>!xe.startsWith("_")&&xe in Be);Me.length===0&&(Me=["_default"]);let je;for(const xe of Me){const tt=Ce(Be[xe]);je=Le(je,tt)}const Ke=Ce(Be._common),Xe=ke(Ke,je);return new Qe(Xe)}),Qe._locales=new t.Lazy(()=>Object.keys(Qe.ambiguousCharacterData.getValue()).filter(ae=>!ae.startsWith("_")));class Ve{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ve.getRawData())),this._data}static isInvisibleCharacter(Ce){return Ve.getData().has(Ce)}static get codePoints(){return Ve.getData()}}e.InvisibleCharacters=Ve,Ve._data=void 0}),define(we[136],ye([0,1,15]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(g){return b(g,0)}e.hash=t;function b(g,p){switch(typeof g){case"object":return g===null?P(349,p):Array.isArray(g)?v(g,p):D(g,p);case"string":return E(g,p);case"boolean":return k(g,p);case"number":return P(g,p);case"undefined":return P(937,p);default:return P(617,p)}}e.doHash=b;function P(g,p){return(p<<5)-p+g|0}e.numberHash=P;function k(g,p){return P(g?433:863,p)}function E(g,p){p=P(149417,p);for(let m=0,l=g.length;m<l;m++)p=P(g.charCodeAt(m),p);return p}e.stringHash=E;function v(g,p){return p=P(104579,p),g.reduce((m,l)=>b(l,m),p)}function D(g,p){return p=P(181387,p),Object.keys(g).sort().reduce((m,l)=>(m=E(l,m),b(g[l],m)),p)}class T{constructor(){this._value=0}get value(){return this._value}hash(p){return this._value=b(p,this._value),this._value}}e.Hasher=T;var R;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(R||(R={}));function C(g,p,m=32){const l=m-p,u=~((1<<l)-1);return(g<<p|(u&g)>>>l)>>>0}function y(g,p=0,m=g.byteLength,l=0){for(let u=0;u<m;u++)g[p+u]=l}function d(g,p,m="0"){for(;g.length<p;)g=m+g;return g}function S(g,p=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(m=>m.toString(16).padStart(2,"0")).join(""):d((g>>>0).toString(16),p/4)}e.toHexString=S;class h{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(p){const m=p.length;if(m===0)return;const l=this._buff;let u=this._buffLen,n=this._leftoverHighSurrogate,s,i;for(n!==0?(s=n,i=-1,n=0):(s=p.charCodeAt(0),i=0);;){let o=s;if(I.isHighSurrogate(s))if(i+1<m){const r=p.charCodeAt(i+1);I.isLowSurrogate(r)?(i++,o=I.computeCodePoint(s,r)):o=65533}else{n=s;break}else I.isLowSurrogate(s)&&(o=65533);if(u=this._push(l,u,o),i++,i<m)s=p.charCodeAt(i);else break}this._buffLen=u,this._leftoverHighSurrogate=n}_push(p,m,l){return l<128?p[m++]=l:l<2048?(p[m++]=192|(l&1984)>>>6,p[m++]=128|(l&63)>>>0):l<65536?(p[m++]=224|(l&61440)>>>12,p[m++]=128|(l&4032)>>>6,p[m++]=128|(l&63)>>>0):(p[m++]=240|(l&1835008)>>>18,p[m++]=128|(l&258048)>>>12,p[m++]=128|(l&4032)>>>6,p[m++]=128|(l&63)>>>0),m>=64&&(this._step(),m-=64,this._totalLen+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),m}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),S(this._h0)+S(this._h1)+S(this._h2)+S(this._h3)+S(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const p=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(p/4294967296),!1),this._buffDV.setUint32(60,p%4294967296,!1),this._step()}_step(){const p=h._bigBlock32,m=this._buffDV;for(let c=0;c<64;c+=4)p.setUint32(c,m.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)p.setUint32(c,C(p.getUint32(c-12,!1)^p.getUint32(c-32,!1)^p.getUint32(c-56,!1)^p.getUint32(c-64,!1),1),!1);let l=this._h0,u=this._h1,n=this._h2,s=this._h3,i=this._h4,o,r,a;for(let c=0;c<80;c++)c<20?(o=u&n|~u&s,r=1518500249):c<40?(o=u^n^s,r=1859775393):c<60?(o=u&n|u&s|n&s,r=2400959708):(o=u^n^s,r=3395469782),a=C(l,5)+o+i+r+p.getUint32(c*4,!1)&4294967295,i=s,s=n,n=C(u,30),u=l,l=a;this._h0=this._h0+l&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=h,h._bigBlock32=new DataView(new ArrayBuffer(320))});var St=this&&this.__classPrivateFieldSet||function(ie,e,I,t,b){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!b:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?b.call(ie,I):b?b.value=I:e.set(ie,I),I},et=this&&this.__classPrivateFieldGet||function(ie,e,I,t){if(I==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!t:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return I==="m"?t:I==="a"?t.call(ie):t?t.value:e.get(ie)};define(we[29],ye([0,1,17,15]),function(ie,e,I,t){"use strict";var b,P,k,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function v(r,a,c){let f=r.get(a);return f===void 0&&(f=c,r.set(a,f)),f}e.getOrSet=v;function D(r){const a=[];return r.forEach((c,f)=>{a.push(`${f} => ${c}`)}),`Map(${r.size}) {${a.join(", ")}}`}e.mapToString=D;function T(r){const a=[];return r.forEach(c=>{a.push(c)}),`Set(${r.size}) {${a.join(", ")}}`}e.setToString=T;class R{constructor(){this._value="",this._pos=0}reset(a){return this._value=a,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(a){const c=a.charCodeAt(0),f=this._value.charCodeAt(this._pos);return c-f}value(){return this._value[this._pos]}}e.StringIterator=R;class C{constructor(a=!0){this._caseSensitive=a}reset(a){return this._value=a,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let a=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(a)this._from++;else break;else a=!1;return this}cmp(a){return this._caseSensitive?(0,t.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class y{constructor(a=!0,c=!0){this._splitOnBackslash=a,this._caseSensitive=c}reset(a){this._from=0,this._to=0,this._value=a,this._valueLen=a.length;for(let c=a.length-1;c>=0;c--,this._valueLen--){const f=this._value.charCodeAt(c);if(!(f===47||this._splitOnBackslash&&f===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let a=!0;for(;this._to<this._valueLen;this._to++){const c=this._value.charCodeAt(this._to);if(c===47||this._splitOnBackslash&&c===92)if(a)this._from++;else break;else a=!1}return this}cmp(a){return this._caseSensitive?(0,t.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=y;var d;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(d||(d={}));class S{constructor(a,c){this._ignorePathCasing=a,this._ignoreQueryAndFragment=c,this._states=[],this._stateIdx=0}reset(a){return this._value=a,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new y(!1,!this._ignorePathCasing(a)),this._pathIterator.reset(a.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(a)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(a){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(a,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(a,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(a);if(this._states[this._stateIdx]===4)return(0,t.compare)(a,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(a,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=S;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(g||(g={}));class p{constructor(a){this._iter=a}static forUris(a=()=>!1,c=()=>!1){return new p(new S(a,c))}static forPaths(a=!1){return new p(new y(void 0,!a))}static forStrings(){return new p(new R)}static forConfigKeys(){return new p(new C)}clear(){this._root=void 0}fill(a,c){if(c){const f=c.slice(0);(0,I.shuffle)(f);for(let w of f)this.set(w,a)}else{const f=a.slice(0);(0,I.shuffle)(f);for(let w of f)this.set(w[0],w[1])}}set(a,c){const f=this._iter.reset(a);let w;this._root||(this._root=new h,this._root.segment=f.value());const A=[];for(w=this._root;;){const x=f.cmp(w.segment);if(x>0)w.left||(w.left=new h,w.left.segment=f.value()),A.push([-1,w]),w=w.left;else if(x<0)w.right||(w.right=new h,w.right.segment=f.value()),A.push([1,w]),w=w.right;else if(f.hasNext())f.next(),w.mid||(w.mid=new h,w.mid.segment=f.value()),A.push([0,w]),w=w.mid;else break}const U=w.value;w.value=c,w.key=a;for(let x=A.length-1;x>=0;x--){const Q=A[x][1];Q.updateHeight();const _=Q.balanceFactor();if(_<-1||_>1){const Y=A[x][0],O=A[x+1][0];if(Y===1&&O===1)A[x][1]=Q.rotateLeft();else if(Y===-1&&O===-1)A[x][1]=Q.rotateRight();else if(Y===1&&O===-1)Q.right=A[x+1][1]=A[x+1][1].rotateRight(),A[x][1]=Q.rotateLeft();else if(Y===-1&&O===1)Q.left=A[x+1][1]=A[x+1][1].rotateLeft(),A[x][1]=Q.rotateRight();else throw new Error;if(x>0)switch(A[x-1][0]){case-1:A[x-1][1].left=A[x][1];break;case 1:A[x-1][1].right=A[x][1];break;case 0:A[x-1][1].mid=A[x][1];break}else this._root=A[0][1]}}return U}get(a){return this._getNode(a)?.value}_getNode(a){const c=this._iter.reset(a);let f=this._root;for(;f;){const w=c.cmp(f.segment);if(w>0)f=f.left;else if(w<0)f=f.right;else if(c.hasNext())c.next(),f=f.mid;else break}return f}has(a){const c=this._getNode(a);return!(c?.value===void 0&&c?.mid===void 0)}delete(a){return this._delete(a,!1)}deleteSuperstr(a){return this._delete(a,!0)}_delete(a,c){const f=this._iter.reset(a),w=[];let A=this._root;for(;A;){const U=f.cmp(A.segment);if(U>0)w.push([-1,A]),A=A.left;else if(U<0)w.push([1,A]),A=A.right;else if(f.hasNext())f.next(),w.push([0,A]),A=A.mid;else break}if(!!A){if(c?(A.left=void 0,A.mid=void 0,A.right=void 0,A.height=1):(A.key=void 0,A.value=void 0),!A.mid&&!A.value)if(A.left&&A.right){const U=this._min(A.right),{key:x,value:Q,segment:_}=U;this._delete(U.key,!1),A.key=x,A.value=Q,A.segment=_}else{const U=A.left??A.right;if(w.length>0){const[x,Q]=w[w.length-1];switch(x){case-1:Q.left=U;break;case 0:Q.mid=U;break;case 1:Q.right=U;break}}else this._root=U}for(let U=w.length-1;U>=0;U--){const x=w[U][1];x.updateHeight();const Q=x.balanceFactor();if(Q>1?(x.right.balanceFactor()>=0||(x.right=x.right.rotateRight()),w[U][1]=x.rotateLeft()):Q<-1&&(x.left.balanceFactor()<=0||(x.left=x.left.rotateLeft()),w[U][1]=x.rotateRight()),U>0)switch(w[U-1][0]){case-1:w[U-1][1].left=w[U][1];break;case 1:w[U-1][1].right=w[U][1];break;case 0:w[U-1][1].mid=w[U][1];break}else this._root=w[0][1]}}}_min(a){for(;a.left;)a=a.left;return a}findSubstr(a){const c=this._iter.reset(a);let f=this._root,w;for(;f;){const A=c.cmp(f.segment);if(A>0)f=f.left;else if(A<0)f=f.right;else if(c.hasNext())c.next(),w=f.value||w,f=f.mid;else break}return f&&f.value||w}findSuperstr(a){const c=this._iter.reset(a);let f=this._root;for(;f;){const w=c.cmp(f.segment);if(w>0)f=f.left;else if(w<0)f=f.right;else if(c.hasNext())c.next(),f=f.mid;else return f.mid?this._entries(f.mid):void 0}}forEach(a){for(const[c,f]of this)a(f,c)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(a){!a||(a.left&&(yield*this._entries(a.left)),a.value&&(yield[a.key,a.value]),a.mid&&(yield*this._entries(a.mid)),a.right&&(yield*this._entries(a.right)))}_isBalanced(){const a=c=>{if(!c)return!0;const f=c.balanceFactor();return f<-1||f>1?!1:a(c.left)&&a(c.right)};return a(this._root)}}e.TernarySearchTree=p;class m{constructor(a,c){this.uri=a,this.value=c}}class l{constructor(a,c){this[b]="ResourceMap",a instanceof l?(this.map=new Map(a.map),this.toKey=c??l.defaultToKey):(this.map=new Map,this.toKey=a??l.defaultToKey)}set(a,c){return this.map.set(this.toKey(a),new m(a,c)),this}get(a){return this.map.get(this.toKey(a))?.value}has(a){return this.map.has(this.toKey(a))}get size(){return this.map.size}clear(){this.map.clear()}delete(a){return this.map.delete(this.toKey(a))}forEach(a,c){typeof c!="undefined"&&(a=a.bind(c));for(let[f,w]of this.map)a(w.value,w.uri,this)}*values(){for(let a of this.map.values())yield a.value}*keys(){for(let a of this.map.values())yield a.uri}*entries(){for(let a of this.map.values())yield[a.uri,a.value]}*[(b=Symbol.toStringTag,Symbol.iterator)](){for(let[,a]of this.map)yield[a.uri,a.value]}}e.ResourceMap=l,l.defaultToKey=r=>r.toString();class u{constructor(a,c){this[P]="ResourceSet",!a||typeof a=="function"?this._map=new l(a):(this._map=new l(c),a.forEach(this.add,this))}get size(){return this._map.size}add(a){return this._map.set(a,a),this}clear(){this._map.clear()}delete(a){return this._map.delete(a)}forEach(a,c){this._map.forEach((f,w)=>a.call(c,w,w,this))}has(a){return this._map.has(a)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=u;var n;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(n=e.Touch||(e.Touch={}));class s{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(a){return this._map.has(a)}get(a,c=0){const f=this._map.get(a);if(!!f)return c!==0&&this.touch(f,c),f.value}set(a,c,f=0){let w=this._map.get(a);if(w)w.value=c,f!==0&&this.touch(w,f);else{switch(w={key:a,value:c,next:void 0,previous:void 0},f){case 0:this.addItemLast(w);break;case 1:this.addItemFirst(w);break;case 2:this.addItemLast(w);break;default:this.addItemLast(w);break}this._map.set(a,w),this._size++}return this}delete(a){return!!this.remove(a)}remove(a){const c=this._map.get(a);if(!!c)return this._map.delete(a),this.removeItem(c),this._size--,c.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const a=this._head;return this._map.delete(a.key),this.removeItem(a),this._size--,a.value}forEach(a,c){const f=this._state;let w=this._head;for(;w;){if(c?a.bind(c)(w.value,w.key,this):a(w.value,w.key,this),this._state!==f)throw new Error("LinkedMap got modified during iteration.");w=w.next}}keys(){const a=this,c=this._state;let f=this._head;const w={[Symbol.iterator](){return w},next(){if(a._state!==c)throw new Error("LinkedMap got modified during iteration.");if(f){const A={value:f.key,done:!1};return f=f.next,A}else return{value:void 0,done:!0}}};return w}values(){const a=this,c=this._state;let f=this._head;const w={[Symbol.iterator](){return w},next(){if(a._state!==c)throw new Error("LinkedMap got modified during iteration.");if(f){const A={value:f.value,done:!1};return f=f.next,A}else return{value:void 0,done:!0}}};return w}entries(){const a=this,c=this._state;let f=this._head;const w={[Symbol.iterator](){return w},next(){if(a._state!==c)throw new Error("LinkedMap got modified during iteration.");if(f){const A={value:[f.key,f.value],done:!1};return f=f.next,A}else return{value:void 0,done:!0}}};return w}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(a){if(a>=this.size)return;if(a===0){this.clear();return}let c=this._head,f=this.size;for(;c&&f>a;)this._map.delete(c.key),c=c.next,f--;this._head=c,this._size=f,c&&(c.previous=void 0),this._state++}addItemFirst(a){if(!this._head&&!this._tail)this._tail=a;else if(this._head)a.next=this._head,this._head.previous=a;else throw new Error("Invalid list");this._head=a,this._state++}addItemLast(a){if(!this._head&&!this._tail)this._head=a;else if(this._tail)a.previous=this._tail,this._tail.next=a;else throw new Error("Invalid list");this._tail=a,this._state++}removeItem(a){if(a===this._head&&a===this._tail)this._head=void 0,this._tail=void 0;else if(a===this._head){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this._head=a.next}else if(a===this._tail){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this._tail=a.previous}else{const c=a.next,f=a.previous;if(!c||!f)throw new Error("Invalid list");c.previous=f,f.next=c}a.next=void 0,a.previous=void 0,this._state++}touch(a,c){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(a===this._head)return;const f=a.next,w=a.previous;a===this._tail?(w.next=void 0,this._tail=w):(f.previous=w,w.next=f),a.previous=void 0,a.next=this._head,this._head.previous=a,this._head=a,this._state++}else if(c===2){if(a===this._tail)return;const f=a.next,w=a.previous;a===this._head?(f.previous=void 0,this._head=f):(f.previous=w,w.next=f),a.next=void 0,a.previous=this._tail,this._tail.next=a,this._tail=a,this._state++}}}toJSON(){const a=[];return this.forEach((c,f)=>{a.push([f,c])}),a}fromJSON(a){this.clear();for(const[c,f]of a)this.set(c,f)}}e.LinkedMap=s;class i extends s{constructor(a,c=1){super();this._limit=a,this._ratio=Math.min(Math.max(0,c),1)}get limit(){return this._limit}set limit(a){this._limit=a,this.checkTrim()}get ratio(){return this._ratio}set ratio(a){this._ratio=Math.min(Math.max(0,a),1),this.checkTrim()}get(a,c=2){return super.get(a,c)}peek(a){return super.get(a,0)}set(a,c){return super.set(a,c,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class o{constructor(a){E.set(this,void 0),St(this,E,a,"f")}get size(){return et(this,E,"f").size}forEach(a,c){et(this,E,"f").forEach(a,c)}get(a){return et(this,E,"f").get(a)}has(a){return et(this,E,"f").has(a)}entries(){return et(this,E,"f").entries()}keys(){return et(this,E,"f").keys()}values(){return et(this,E,"f").values()}[(E=new WeakMap,Symbol.iterator)](){return et(this,E,"f").entries()}}e.ReadonlyMapView=o}),define(we[137],ye([0,1,29,15]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function b(...W){return function(K,le){for(let ve=0,De=W.length;ve<De;ve++){const Te=W[ve](K,le);if(Te)return Te}return null}}e.or=b,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(W,K,le){if(!le||le.length<K.length)return null;let ve;return W?ve=t.startsWithIgnoreCase(le,K):ve=le.indexOf(K)===0,ve?K.length>0?[{start:0,end:K.length}]:[]:null}function k(W,K){const le=K.toLowerCase().indexOf(W.toLowerCase());return le===-1?null:[{start:le,end:le+W.length}]}e.matchesContiguousSubString=k;function E(W,K){return v(W.toLowerCase(),K.toLowerCase(),0,0)}e.matchesSubString=E;function v(W,K,le,ve){if(le===W.length)return[];if(ve===K.length)return null;if(W[le]===K[ve]){let De=null;return(De=v(W,K,le+1,ve+1))?g({start:ve,end:ve+1},De):null}return v(W,K,le,ve+1)}function D(W){return 97<=W&&W<=122}function T(W){return 65<=W&&W<=90}e.isUpper=T;function R(W){return 48<=W&&W<=57}function C(W){return W===32||W===9||W===10||W===13}const y=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(W=>y.add(W.charCodeAt(0)));function d(W){return C(W)||y.has(W)}function S(W,K){return W===K||d(W)&&d(K)}function h(W){return D(W)||T(W)||R(W)}function g(W,K){return K.length===0?K=[W]:W.end===K[0].start?K[0].start=W.start:K.unshift(W),K}function p(W,K){for(let le=K;le<W.length;le++){const ve=W.charCodeAt(le);if(T(ve)||R(ve)||le>0&&!h(W.charCodeAt(le-1)))return le}return W.length}function m(W,K,le,ve){if(le===W.length)return[];if(ve===K.length)return null;if(W[le]!==K[ve].toLowerCase())return null;{let De=null,Te=ve+1;for(De=m(W,K,le+1,ve+1);!De&&(Te=p(K,Te))<K.length;)De=m(W,K,le+1,Te),Te++;return De===null?null:g({start:ve,end:ve+1},De)}}function l(W){let K=0,le=0,ve=0,De=0,Te=0;for(let pe=0;pe<W.length;pe++)Te=W.charCodeAt(pe),T(Te)&&K++,D(Te)&&le++,h(Te)&&ve++,R(Te)&&De++;const Oe=K/W.length,Ue=le/W.length,de=ve/W.length,be=De/W.length;return{upperPercent:Oe,lowerPercent:Ue,alphaPercent:de,numericPercent:be}}function u(W){const{upperPercent:K,lowerPercent:le}=W;return le===0&&K>.6}function n(W){const{upperPercent:K,lowerPercent:le,alphaPercent:ve,numericPercent:De}=W;return le>.2&&K<.8&&ve>.6&&De<.2}function s(W){let K=0,le=0,ve=0,De=0;for(let Te=0;Te<W.length;Te++)ve=W.charCodeAt(Te),T(ve)&&K++,D(ve)&&le++,C(ve)&&De++;return(K===0||le===0)&&De===0?W.length<=30:K<=5}function i(W,K){if(!K||(K=K.trim(),K.length===0)||!s(W)||K.length>60)return null;const le=l(K);if(!n(le)){if(!u(le))return null;K=K.toLowerCase()}let ve=null,De=0;for(W=W.toLowerCase();De<K.length&&(ve=m(W,K,0,De))===null;)De=p(K,De+1);return ve}e.matchesCamelCase=i;function o(W,K,le=!1){if(!K||K.length===0)return null;let ve=null,De=0;for(W=W.toLowerCase(),K=K.toLowerCase();De<K.length&&(ve=r(W,K,0,De,le))===null;)De=a(K,De+1);return ve}e.matchesWords=o;function r(W,K,le,ve,De){if(le===W.length)return[];if(ve===K.length)return null;if(S(W.charCodeAt(le),K.charCodeAt(ve))){let Te=null,Oe=ve+1;if(Te=r(W,K,le+1,ve+1,De),!De)for(;!Te&&(Oe=a(K,Oe))<K.length;)Te=r(W,K,le+1,Oe,De),Oe++;return Te===null?null:g({start:ve,end:ve+1},Te)}else return null}function a(W,K){for(let le=K;le<W.length;le++)if(d(W.charCodeAt(le))||le>0&&d(W.charCodeAt(le-1)))return le;return W.length}const c=b(e.matchesPrefix,i,k),f=b(e.matchesPrefix,i,E),w=new I.LRUCache(1e4);function A(W,K,le=!1){if(typeof W!="string"||typeof K!="string")return null;let ve=w.get(W);ve||(ve=new RegExp(t.convertSimple2RegExpPattern(W),"i"),w.set(W,ve));const De=ve.exec(K);return De?[{start:De.index,end:De.index+De[0].length}]:le?f(W,K):c(W,K)}e.matchesFuzzy=A;function U(W,K){const le=te(W,W.toLowerCase(),0,K,K.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return le?Q(le):null}e.matchesFuzzy2=U;function x(W,K,le,ve,De,Te){const Oe=Math.min(13,W.length);for(;le<Oe;le++){const Ue=te(W,K,le,ve,De,Te,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(Ue)return Ue}return[0,Te]}e.anyScore=x;function Q(W){if(typeof W=="undefined")return[];const K=[],le=W[1];for(let ve=W.length-1;ve>1;ve--){const De=W[ve]+le,Te=K[K.length-1];Te&&Te.end===De?Te.end=De+1:K.push({start:De,end:De+1})}return K}e.createMatches=Q;const _=128;function Y(){const W=[],K=[];for(let le=0;le<=_;le++)K[le]=0;for(let le=0;le<=_;le++)W.push(K.slice(0));return W}function O(W){const K=[];for(let le=0;le<=W;le++)K[le]=0;return K}const B=O(2*_),ue=O(2*_),V=Y(),$=Y(),F=Y(),M=!1;function j(W,K,le,ve,De){function Te(Ue,de,be=" "){for(;Ue.length<de;)Ue=be+Ue;return Ue}let Oe=` |   |${ve.split("").map(Ue=>Te(Ue,3)).join("|")}
`;for(let Ue=0;Ue<=le;Ue++)Ue===0?Oe+=" |":Oe+=`${K[Ue-1]}|`,Oe+=W[Ue].slice(0,De+1).map(de=>Te(de.toString(),3)).join("|")+`
`;return Oe}function Z(W,K,le,ve){W=W.substr(K),le=le.substr(ve),console.log(j($,W,W.length,le,le.length)),console.log(j(F,W,W.length,le,le.length)),console.log(j(V,W,W.length,le,le.length))}function oe(W,K){if(K<0||K>=W.length)return!1;const le=W.codePointAt(K);switch(le){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(le)}}function ge(W,K){if(K<0||K>=W.length)return!1;switch(W.charCodeAt(K)){case 32:case 9:return!0;default:return!1}}function he(W,K,le){return K[W]!==le[W]}function q(W,K,le,ve,De,Te,Oe=!1){for(;K<le&&De<Te;)W[K]===ve[De]&&(Oe&&(B[K]=De),K+=1),De+=1;return K===le}e.isPatternInWord=q;var ee;(function(W){W[W.Diag=1]="Diag",W[W.Left=2]="Left",W[W.LeftLeft=3]="LeftLeft"})(ee||(ee={}));var G;(function(W){W.Default=[-100,0];function K(le){return!le||le.length===2&&le[0]===-100&&le[1]===0}W.isDefault=K})(G=e.FuzzyScore||(e.FuzzyScore={}));class z{constructor(K,le){this.firstMatchCanBeWeak=K,this.boostFullMatch=le}}e.FuzzyScoreOptions=z,z.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function te(W,K,le,ve,De,Te,Oe=z.default){const Ue=W.length>_?_:W.length,de=ve.length>_?_:ve.length;if(le>=Ue||Te>=de||Ue-le>de-Te||!q(K,le,Ue,De,Te,de,!0))return;ce(Ue,de,le,Te,K,De);let be=1,pe=1,_e=le,Ne=Te;const qe=[!1];for(be=1,_e=le;_e<Ue;be++,_e++){const ae=B[_e],Ce=ue[_e],ke=_e+1<Ue?ue[_e+1]:de;for(pe=ae-Te+1,Ne=ae;Ne<ke;pe++,Ne++){let Le=Number.MIN_SAFE_INTEGER,Be=!1;Ne<=Ce&&(Le=J(W,K,_e,le,ve,De,Ne,de,Te,V[be-1][pe-1]===0,qe));let Me=0;Le!==Number.MAX_SAFE_INTEGER&&(Be=!0,Me=Le+$[be-1][pe-1]);const je=Ne>ae,Ke=je?$[be][pe-1]+(V[be][pe-1]>0?-5:0):0,Xe=Ne>ae+1&&V[be][pe-1]>0,xe=Xe?$[be][pe-2]+(V[be][pe-2]>0?-5:0):0;if(Xe&&(!je||xe>=Ke)&&(!Be||xe>=Me))$[be][pe]=xe,F[be][pe]=3,V[be][pe]=0;else if(je&&(!Be||Ke>=Me))$[be][pe]=Ke,F[be][pe]=2,V[be][pe]=0;else if(Be)$[be][pe]=Me,F[be][pe]=1,V[be][pe]=V[be-1][pe-1]+1;else throw new Error("not possible")}}if(M&&Z(W,le,ve,Te),!qe[0]&&!Oe.firstMatchCanBeWeak)return;be--,pe--;const ze=[$[be][pe],Te];let He=0,Qe=0;for(;be>=1;){let ae=pe;do{const Ce=F[be][ae];if(Ce===3)ae=ae-2;else if(Ce===2)ae=ae-1;else break}while(ae>=1);He>1&&K[le+be-1]===De[Te+pe-1]&&!he(ae+Te-1,ve,De)&&He+1>V[be][ae]&&(ae=pe),ae===pe?He++:He=1,Qe||(Qe=ae),be--,pe=ae-1,ze.push(pe)}de===Ue&&Oe.boostFullMatch&&(ze[0]+=2);const Ve=Qe-Ue;return ze[0]-=Ve,ze}e.fuzzyScore=te;function ce(W,K,le,ve,De,Te){let Oe=W-1,Ue=K-1;for(;Oe>=le&&Ue>=ve;)De[Oe]===Te[Ue]&&(ue[Oe]=Ue,Oe--),Ue--}function J(W,K,le,ve,De,Te,Oe,Ue,de,be,pe){if(K[le]!==Te[Oe])return Number.MIN_SAFE_INTEGER;let _e=1,Ne=!1;return Oe===le-ve?_e=W[le]===De[Oe]?7:5:he(Oe,De,Te)&&(Oe===0||!he(Oe-1,De,Te))?(_e=W[le]===De[Oe]?7:5,Ne=!0):oe(Te,Oe)&&(Oe===0||!oe(Te,Oe-1))?_e=5:(oe(Te,Oe-1)||ge(Te,Oe-1))&&(_e=5,Ne=!0),_e>1&&le===ve&&(pe[0]=!0),Ne||(Ne=he(Oe,De,Te)||oe(Te,Oe-1)||ge(Te,Oe-1)),le===ve?Oe>de&&(_e-=Ne?3:5):be?_e+=Ne?2:0:_e+=Ne?0:1,Oe+1===Ue&&(_e-=Ne?3:5),_e}function se(W,K,le,ve,De,Te,Oe){return X(W,K,le,ve,De,Te,!0,Oe)}e.fuzzyScoreGracefulAggressive=se;function me(W,K,le,ve,De,Te,Oe){return X(W,K,le,ve,De,Te,!1,Oe)}e.fuzzyScoreGraceful=me;function X(W,K,le,ve,De,Te,Oe,Ue){let de=te(W,K,le,ve,De,Te,Ue);if(de&&!Oe)return de;if(W.length>=3){const be=Math.min(7,W.length-1);for(let pe=le+1;pe<be;pe++){const _e=re(W,pe);if(_e){const Ne=te(_e,_e.toLowerCase(),le,ve,De,Te,Ue);Ne&&(Ne[0]-=3,(!de||Ne[0]>de[0])&&(de=Ne))}}}return de}function re(W,K){if(K+1>=W.length)return;const le=W[K],ve=W[K+1];if(le!==ve)return W.slice(0,K)+ve+le+W.slice(K+2)}}),define(we[138],ye([0,1,37,137,15]),function(ie,e,I,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${I.CSSIcon.iconNameExpression}(?:${I.CSSIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(I.CSSIcon.iconNameCharacter),E=new RegExp(`(\\\\)?${P.source}`,"g");function v(h){return h.replace(E,(g,p)=>p?g:`\\${g}`)}e.escapeIcons=v;const D=new RegExp(`\\\\${P.source}`,"g");function T(h){return h.replace(D,g=>`\\${g}`)}e.markdownEscapeEscapedIcons=T;const R=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function C(h){return h.indexOf(e.iconStartMarker)===-1?h:h.replace(R,(g,p,m,l)=>m?g:p||l||"")}e.stripIcons=C;function y(h){const g=h.indexOf(e.iconStartMarker);return g===-1?{text:h}:d(h,g)}e.parseLabelWithIcons=y;function d(h,g){const p=[];let m="";function l(c){if(c){m+=c;for(const f of c)p.push(s)}}let u=-1,n="",s=0,i,o,r=g;const a=h.length;for(l(h.substr(0,g));r<a;)i=h[r],o=h[r+1],i===e.iconStartMarker[0]&&o===e.iconStartMarker[1]?(u=r,l(n),n=e.iconStartMarker,r++):i===")"&&u!==-1?(s+=r-u+1,u=-1,n=""):u!==-1?k.test(i)?n+=i:(l(n),u=-1,n=""):l(i),r++;return l(n),{text:m,iconOffsets:p}}function S(h,g,p=!1){const{text:m,iconOffsets:l}=g;if(!l||l.length===0)return(0,t.matchesFuzzy)(h,m,p);const u=(0,b.ltrim)(m," "),n=m.length-u.length,s=(0,t.matchesFuzzy)(h,u,p);if(s)for(const i of s){const o=l[i.start+n]+n;i.start+=o,i.end+=o}return s}e.matchesFuzzyIconAware=S}),define(we[82],ye([0,1,29]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new I.LRUCache(1e4);function b(D){return v(D,"NFC",t)}e.normalizeNFC=b;const P=new I.LRUCache(1e4);function k(D){return v(D,"NFD",P)}e.normalizeNFD=k;const E=/[^\u0000-\u0080]/;function v(D,T,R){if(!D)return D;const C=R.get(D);if(C)return C;let y;return E.test(D)?y=D.normalize(T):y=D,R.set(D,y),y}e.removeAccents=function(){const D=/[\u0300-\u036f]/g;return function(T){return k(T).replace(D,"")}}()}),define(we[65],ye([0,1,15]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(b){b[b.Ignore=0]="Ignore",b[b.Info=1]="Info",b[b.Warning=2]="Warning",b[b.Error=3]="Error"})(t||(t={})),function(b){const P="error",k="warning",E="warn",v="info",D="ignore";function T(C){return C?I.equalsIgnoreCase(P,C)?b.Error:I.equalsIgnoreCase(k,C)||I.equalsIgnoreCase(E,C)?b.Warning:I.equalsIgnoreCase(v,C)?b.Info:b.Ignore:b.Ignore}b.fromValue=T;function R(C){switch(C){case b.Error:return P;case b.Warning:return k;case b.Info:return v;default:return D}}b.toString=R}(t||(t={})),e.default=t}),define(we[12],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function I(c){return Array.isArray(c)}e.isArray=I;function t(c){return typeof c=="string"}e.isString=t;function b(c){return Array.isArray(c)&&c.every(f=>t(f))}e.isStringArray=b;function P(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.isObject=P;function k(c){return typeof c=="object"&&(c instanceof Uint8Array||c instanceof Uint16Array||c instanceof Uint32Array||c instanceof Float32Array||c instanceof Float64Array||c instanceof Int8Array||c instanceof Int16Array||c instanceof Int32Array||c instanceof BigInt64Array||c instanceof BigUint64Array||c instanceof Uint8ClampedArray)}e.isTypedArray=k;function E(c){return typeof c=="number"&&!isNaN(c)}e.isNumber=E;function v(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.isIterable=v;function D(c){return c===!0||c===!1}e.isBoolean=D;function T(c){return typeof c=="undefined"}e.isUndefined=T;function R(c){return!C(c)}e.isDefined=R;function C(c){return T(c)||c===null}e.isUndefinedOrNull=C;function y(c,f){if(!c)throw new Error(f?`Unexpected type, expected '${f}'`:"Unexpected type")}e.assertType=y;function d(c){if(C(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.assertIsDefined=d;function S(...c){const f=[];for(let w=0;w<c.length;w++){const A=c[w];if(C(A))throw new Error(`Assertion Failed: argument at index ${w} is undefined or null`);f.push(A)}return f}e.assertAllDefined=S;const h=Object.prototype.hasOwnProperty;function g(c){if(!P(c))return!1;for(let f in c)if(h.call(c,f))return!1;return!0}e.isEmptyObject=g;function p(c){return typeof c=="function"}e.isFunction=p;function m(...c){return c.length>0&&c.every(p)}e.areFunctions=m;function l(c,f){const w=Math.min(c.length,f.length);for(let A=0;A<w;A++)u(c[A],f[A])}e.validateConstraints=l;function u(c,f){if(t(f)){if(typeof c!==f)throw new Error(`argument does not match constraint: typeof ${f}`)}else if(p(f)){try{if(c instanceof f)return}catch{}if(!C(c)&&c.constructor===f||f.length===1&&f.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=u;function n(c){let f=[],w=Object.getPrototypeOf(c);for(;Object.prototype!==w;)f=f.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return f}e.getAllPropertyNames=n;function s(c){const f=[];for(const w of n(c))typeof c[w]=="function"&&f.push(w);return f}e.getAllMethodNames=s;function i(c,f){const w=U=>function(){const x=Array.prototype.slice.call(arguments,0);return f(U,x)};let A={};for(const U of c)A[U]=w(U);return A}e.createProxyObject=i;function o(c){return c===null?void 0:c}e.withNullAsUndefined=o;function r(c){return typeof c=="undefined"?null:c}e.withUndefinedAsNull=r;function a(c,f="Unreachable"){throw new Error(f)}e.assertNever=a}),define(we[33],ye([0,1,5,3,15,12]),function(ie,e,I,t,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(r){return r===47||r===92}e.isPathSeparator=k;function E(r){return r.replace(/[\\/]/g,I.posix.sep)}e.toSlashes=E;function v(r){return r.indexOf("/")===-1&&(r=E(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=v;function D(r,a=I.posix.sep){if(!r)return"";const c=r.length,f=r.charCodeAt(0);if(k(f)){if(k(r.charCodeAt(1))&&!k(r.charCodeAt(2))){let A=3;const U=A;for(;A<c&&!k(r.charCodeAt(A));A++);if(U!==A&&!k(r.charCodeAt(A+1))){for(A+=1;A<c;A++)if(k(r.charCodeAt(A)))return r.slice(0,A+1).replace(/[\\/]/g,a)}}return a}else if(g(f)&&r.charCodeAt(1)===58)return k(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let w=r.indexOf("://");if(w!==-1){for(w+=3;w<c;w++)if(k(r.charCodeAt(w)))return r.slice(0,w+1)}return""}e.getRoot=D;function T(r){if(!t.isWindows||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let c=2;const f=c;for(;c<r.length&&(a=r.charCodeAt(c),a!==92);c++);return!(f===c||(a=r.charCodeAt(c+1),isNaN(a)||a===92))}e.isUNC=T;const R=/[\\/:\*\?"<>\|]/g,C=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(r,a=t.isWindows){const c=a?R:C;return!(!r||r.length===0||/^\s+$/.test(r)||(c.lastIndex=0,c.test(r))||a&&y.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=d;function S(r,a,c){const f=r===a;return!c||f?f:!r||!a?!1:(0,b.equalsIgnoreCase)(r,a)}e.isEqual=S;function h(r,a,c,f=I.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(c){if(!(0,b.startsWithIgnoreCase)(r,a))return!1;if(a.length===r.length)return!0;let A=a.length;return a.charAt(a.length-1)===f&&A--,r.charAt(A)===f}return a.charAt(a.length-1)!==f&&(a+=f),r.indexOf(a)===0}e.isEqualOrParent=h;function g(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=g;function p(r,a){return t.isWindows&&r.endsWith(":")&&(r+=I.sep),(0,I.isAbsolute)(r)||(r=(0,I.join)(a,r)),r=(0,I.normalize)(r),t.isWindows?(r=(0,b.rtrim)(r,I.sep),r.endsWith(":")&&(r+=I.sep)):(r=(0,b.rtrim)(r,I.sep),r||(r=I.sep)),r}e.sanitizeFilePath=p;function m(r){const a=(0,I.normalize)(r);return t.isWindows?r.length>3?!1:l(a)&&(r.length===2||a.charCodeAt(2)===92):a===I.posix.sep}e.isRootOrDriveLetter=m;function l(r,a=t.isWindows){return a?g(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function u(r){return l(r)?r[0]:void 0}e.getDriveLetter=u;function n(r,a,c){return a.length>r.length?-1:r===a?0:(c&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.indexOfPath=n;function s(r){const a=r.split(":");let c,f,w;for(const A of a){const U=Number(A);(0,P.isNumber)(U)?f===void 0?f=U:w===void 0&&(w=U):c=c?[c,A].join(":"):A}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:f!==void 0?f:void 0,column:w!==void 0?w:f!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function o(r,a,c=8){let f="";for(let A=0;A<c;A++)f+=i.charAt(Math.floor(Math.random()*i.length));let w;return a?w=`${a}-${f}`:w=f,r?(0,I.join)(r,w):w}e.randomPath=o}),define(we[21],ye([0,1,12]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(S){if(!S||typeof S!="object"||S instanceof RegExp)return S;const h=Array.isArray(S)?[]:{};return Object.keys(S).forEach(g=>{S[g]&&typeof S[g]=="object"?h[g]=t(S[g]):h[g]=S[g]}),h}e.deepClone=t;function b(S){if(!S||typeof S!="object")return S;const h=[S];for(;h.length>0;){const g=h.shift();Object.freeze(g);for(const p in g)if(P.call(g,p)){const m=g[p];typeof m=="object"&&!Object.isFrozen(m)&&!(0,I.isTypedArray)(m)&&h.push(m)}}return S}e.deepFreeze=b;const P=Object.prototype.hasOwnProperty;function k(S,h){return E(S,h,new Set)}e.cloneAndChange=k;function E(S,h,g){if((0,I.isUndefinedOrNull)(S))return S;const p=h(S);if(typeof p!="undefined")return p;if((0,I.isArray)(S)){const m=[];for(const l of S)m.push(E(l,h,g));return m}if((0,I.isObject)(S)){if(g.has(S))throw new Error("Cannot clone recursive data-structure");g.add(S);const m={};for(let l in S)P.call(S,l)&&(m[l]=E(S[l],h,g));return g.delete(S),m}return S}function v(S,h,g=!0){return(0,I.isObject)(S)?((0,I.isObject)(h)&&Object.keys(h).forEach(p=>{p in S?g&&((0,I.isObject)(S[p])&&(0,I.isObject)(h[p])?v(S[p],h[p],g):S[p]=h[p]):S[p]=h[p]}),S):h}e.mixin=v;function D(S,h){if(S===h)return!0;if(S==null||h===null||h===void 0||typeof S!=typeof h||typeof S!="object"||Array.isArray(S)!==Array.isArray(h))return!1;let g,p;if(Array.isArray(S)){if(S.length!==h.length)return!1;for(g=0;g<S.length;g++)if(!D(S[g],h[g]))return!1}else{const m=[];for(p in S)m.push(p);m.sort();const l=[];for(p in h)l.push(p);if(l.sort(),!D(m,l))return!1;for(g=0;g<m.length;g++)if(!D(S[m[g]],h[m[g]]))return!1}return!0}e.equals=D;function T(S){const h=new Set;return JSON.stringify(S,(g,p)=>{if((0,I.isObject)(p)||Array.isArray(p)){if(h.has(p))return"[Circular]";h.add(p)}return p})}e.safeStringify=T;function R(S,h,g){const p=h(S);return typeof p=="undefined"?g:p}e.getOrDefault=R;function C(S,h){const g=Object.create(null);return!S||!h||Object.keys(h).forEach(m=>{const l=S[m],u=h[m];D(l,u)||(g[m]=u)}),g}e.distinct=C;function y(S,h){const g=h.toLowerCase(),p=Object.keys(S).find(m=>m.toLowerCase()===g);return p?S[p]:S[h]}e.getCaseInsensitive=y;function d(S,h){const g=Object.create(null);for(const[p,m]of Object.entries(S))h(p,m)&&(g[p]=m);return g}e.filter=d}),define(we[4],ye([0,1,5,3]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const b=/^\w[\w\d+.-]*$/,P=/^\//,k=/^\/\//;function E(i,o){if(!i.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!b.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!P.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function v(i,o){return!i&&!o?"file":i}function D(i,o){switch(i){case"https":case"http":case"file":o?o[0]!==R&&(o=R+o):o=R;break}return o}const T="",R="/",C=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{constructor(o,r,a,c,f,w=!1){typeof o=="object"?(this.scheme=o.scheme||T,this.authority=o.authority||T,this.path=o.path||T,this.query=o.query||T,this.fragment=o.fragment||T):(this.scheme=v(o,w),this.authority=r||T,this.path=D(this.scheme,a||T),this.query=c||T,this.fragment=f||T,E(this,w))}static isUri(o){return o instanceof y?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return m(this,!1)}with(o){if(!o)return this;let{scheme:r,authority:a,path:c,query:f,fragment:w}=o;return r===void 0?r=this.scheme:r===null&&(r=T),a===void 0?a=this.authority:a===null&&(a=T),c===void 0?c=this.path:c===null&&(c=T),f===void 0?f=this.query:f===null&&(f=T),w===void 0?w=this.fragment:w===null&&(w=T),r===this.scheme&&a===this.authority&&c===this.path&&f===this.query&&w===this.fragment?this:new S(r,a,c,f,w)}static parse(o,r=!1){const a=C.exec(o);return a?new S(a[2]||T,s(a[4]||T),s(a[5]||T),s(a[7]||T),s(a[9]||T),r):new S(T,T,T,T,T)}static file(o){let r=T;if(t.isWindows&&(o=o.replace(/\\/g,R)),o[0]===R&&o[1]===R){const a=o.indexOf(R,2);a===-1?(r=o.substring(2),o=R):(r=o.substring(2,a),o=o.substring(a)||R)}return new S("file",r,o,T,T)}static from(o){const r=new S(o.scheme,o.authority,o.path,o.query,o.fragment);return E(r,!0),r}static joinPath(o,...r){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return t.isWindows&&o.scheme==="file"?a=y.file(I.win32.join(m(o,!0),...r)).path:a=I.posix.join(o.path,...r),o.with({path:a})}toString(o=!1){return l(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof y)return o;{const r=new S(o);return r._formatted=o.external,r._fsPath=o._sep===d?o.fsPath:null,r}}else return o}}e.URI=y;const d=t.isWindows?1:void 0;class S extends y{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(o=!1){return o?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=d),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(i,o){let r,a=-1;for(let c=0;c<i.length;c++){const f=i.charCodeAt(c);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||o&&f===47)a!==-1&&(r+=encodeURIComponent(i.substring(a,c)),a=-1),r!==void 0&&(r+=i.charAt(c));else{r===void 0&&(r=i.substr(0,c));const w=h[f];w!==void 0?(a!==-1&&(r+=encodeURIComponent(i.substring(a,c)),a=-1),r+=w):a===-1&&(a=c)}}return a!==-1&&(r+=encodeURIComponent(i.substring(a))),r!==void 0?r:i}function p(i){let o;for(let r=0;r<i.length;r++){const a=i.charCodeAt(r);a===35||a===63?(o===void 0&&(o=i.substr(0,r)),o+=h[a]):o!==void 0&&(o+=i[r])}return o!==void 0?o:i}function m(i,o){let r;return i.authority&&i.path.length>1&&i.scheme==="file"?r=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?o?r=i.path.substr(1):r=i.path[1].toLowerCase()+i.path.substr(2):r=i.path,t.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=m;function l(i,o){const r=o?p:g;let a="",{scheme:c,authority:f,path:w,query:A,fragment:U}=i;if(c&&(a+=c,a+=":"),(f||c==="file")&&(a+=R,a+=R),f){let x=f.indexOf("@");if(x!==-1){const Q=f.substr(0,x);f=f.substr(x+1),x=Q.indexOf(":"),x===-1?a+=r(Q,!1):(a+=r(Q.substr(0,x),!1),a+=":",a+=r(Q.substr(x+1),!1)),a+="@"}f=f.toLowerCase(),x=f.indexOf(":"),x===-1?a+=r(f,!1):(a+=r(f.substr(0,x),!1),a+=f.substr(x))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const x=w.charCodeAt(1);x>=65&&x<=90&&(w=`/${String.fromCharCode(x+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const x=w.charCodeAt(0);x>=65&&x<=90&&(w=`${String.fromCharCode(x+32)}:${w.substr(2)}`)}a+=r(w,!0)}return A&&(a+="?",a+=r(A,!1)),U&&(a+="#",a+=o?U:g(U,!1)),a}function u(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+u(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(i){return i.match(n)?i.replace(n,o=>u(o)):i}}),define(we[83],ye([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(D){const T=D;return T&&typeof T.type=="string"&&typeof T.severity=="string"}e.isRemoteConsoleLog=t;function b(D){const T=[];let R;try{const C=JSON.parse(D.arguments),y=C[C.length-1];y&&y.__$stack&&(C.pop(),R=y.__$stack),T.push(...C)}catch{T.push("Unable to log remote console arguments",D.arguments)}return{args:T,stack:R}}e.parse=b;function P(D){if(typeof D!="string")return P(b(D).stack);const T=D;if(T){const R=k(T),C=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(R||"");if(C&&C.length===4)return{uri:I.URI.file(C[1]),line:Number(C[2]),column:Number(C[3])}}}e.getFirstFrame=P;function k(D){if(!D)return D;const T=D.indexOf(`
`);return T===-1?D:D.substring(0,T)}function E(D,T){const{args:R,stack:C}=b(D),y=typeof R[0]=="string"&&R.length===1;let d=k(C);d&&(d=`(${d.trim()})`);let S=[];if(typeof R[0]=="string"?d&&y?S=[`%c[${T}] %c${R[0]} %c${d}`,v("blue"),v(""),v("grey")]:S=[`%c[${T}] %c${R[0]}`,v("blue"),v(""),...R.slice(1)]:S=[`%c[${T}]%`,v("blue"),...R],d&&!y&&S.push(d),typeof console[D.severity]!="function")throw new Error("Unknown console method");console[D.severity].apply(console,S)}e.log=E;function v(D){return`color: ${D}`}}),define(we[45],ye([0,1,16,15,4]),function(ie,e,I,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(D){return JSON.stringify(D,E)}e.stringify=P;function k(D){let T=JSON.parse(D);return T=v(T),T}e.parse=k;function E(D,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,t.regExpFlags)(T)}:T}function v(D,T=0){if(!D||T>200)return D;if(typeof D=="object"){switch(D.$mid){case 1:return b.URI.revive(D);case 2:return new RegExp(D.source,D.flags);case 14:return new Date(D.source)}if(D instanceof I.VSBuffer||D instanceof Uint8Array)return D;if(Array.isArray(D))for(let R=0;R<D.length;++R)D[R]=v(D[R],T+1);else for(const R in D)Object.hasOwnProperty.call(D,R)&&(D[R]=v(D[R],T+1))}return D}e.revive=v}),define(we[8],ye([0,1,3,4]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var b;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.vscodeUserData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp",E.vsls="vsls"})(b=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${b.vscodeRemoteResource}`}setPreferredWebSchema(v){this._preferredWebSchema=v}setDelegate(v){this._delegate=v}setServerRootPath(v){this._remoteResourcesPath=`${v}/${b.vscodeRemoteResource}`}set(v,D,T){this._hosts[v]=D,this._ports[v]=T}setConnectionToken(v,D){this._connectionTokens[v]=D}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(v){if(this._delegate)return this._delegate(v);const D=v.authority;let T=this._hosts[D];T&&T.indexOf(":")!==-1&&(T=`[${T}]`);const R=this._ports[D],C=this._connectionTokens[D];let y=`path=${encodeURIComponent(v.path)}`;return typeof C=="string"&&(y+=`&${e.connectionTokenQueryName}=${encodeURIComponent(C)}`),t.URI.from({scheme:I.isWeb?this._preferredWebSchema:b.vscodeRemoteResource,authority:`${T}:${R}`,path:this._remoteResourcesPath,query:y})}}e.RemoteAuthorities=new P;class k{asBrowserUri(v,D){const T=this.toUri(v,D);return T.scheme===b.vscodeRemote?e.RemoteAuthorities.rewrite(T):T.scheme===b.file&&(I.isNative||I.isWebWorker&&I.globals.origin===`${b.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?T.with({scheme:b.vscodeFileResource,authority:T.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):T}asFileUri(v,D){const T=this.toUri(v,D);return T.scheme===b.vscodeFileResource?T.with({scheme:b.file,authority:T.authority!==k.FALLBACK_AUTHORITY?T.authority:null,query:null,fragment:null}):T}toUri(v,D){return t.URI.isUri(v)?v:t.URI.parse(D.toUrl(v))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(we[19],ye([0,1,33,8,5,3,15,4]),function(ie,e,I,t,b,P,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function v(y){return(0,E.uriToFsPath)(y,!0)}e.originalFSPath=v;class D{constructor(d){this._ignorePathCasing=d}compare(d,S,h=!1){return d===S?0:(0,k.compare)(this.getComparisonKey(d,h),this.getComparisonKey(S,h))}isEqual(d,S,h=!1){return d===S?!0:!d||!S?!1:this.getComparisonKey(d,h)===this.getComparisonKey(S,h)}getComparisonKey(d,S=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,S,h=!1){if(d.scheme===S.scheme){if(d.scheme===t.Schemas.file)return I.isEqualOrParent(v(d),v(S),this._ignorePathCasing(d))&&d.query===S.query&&(h||d.fragment===S.fragment);if((0,e.isEqualAuthority)(d.authority,S.authority))return I.isEqualOrParent(d.path,S.path,this._ignorePathCasing(d),"/")&&d.query===S.query&&(h||d.fragment===S.fragment)}return!1}joinPath(d,...S){return E.URI.joinPath(d,...S)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return b.posix.basename(d.path)}extname(d){return b.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let S;return d.scheme===t.Schemas.file?S=E.URI.file(b.dirname(v(d))).path:(S=b.posix.dirname(d.path),d.authority&&S.length&&S.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),S="/")),d.with({path:S})}normalizePath(d){if(!d.path.length)return d;let S;return d.scheme===t.Schemas.file?S=E.URI.file(b.normalize(v(d))).path:S=b.posix.normalize(d.path),d.with({path:S})}relativePath(d,S){if(d.scheme!==S.scheme||!(0,e.isEqualAuthority)(d.authority,S.authority))return;if(d.scheme===t.Schemas.file){const p=b.relative(v(d),v(S));return P.isWindows?I.toSlashes(p):p}let h=d.path||"/",g=S.path||"/";if(this._ignorePathCasing(d)){let p=0;for(const m=Math.min(h.length,g.length);p<m&&!(h.charCodeAt(p)!==g.charCodeAt(p)&&h.charAt(p).toLowerCase()!==g.charAt(p).toLowerCase());p++);h=g.substr(0,p)+h.substr(p)}return b.posix.relative(h,g)}resolvePath(d,S){if(d.scheme===t.Schemas.file){const h=E.URI.file(b.resolve(v(d),S));return d.with({authority:h.authority,path:h.path})}return S=I.toPosixPath(S),d.with({path:b.posix.resolve(d.path,S)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,S){return d===S||d!==void 0&&S!==void 0&&(0,k.equalsIgnoreCase)(d,S)}hasTrailingPathSeparator(d,S=b.sep){if(d.scheme===t.Schemas.file){const h=v(d);return h.length>I.getRoot(h).length&&h[h.length-1]===S}else{const h=d.path;return h.length>1&&h.charCodeAt(h.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,S=b.sep){return(0,e.hasTrailingPathSeparator)(d,S)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,S=b.sep){let h=!1;if(d.scheme===t.Schemas.file){const g=v(d);h=g!==void 0&&g.length===I.getRoot(g).length&&g[g.length-1]===S}else{S="/";const g=d.path;h=g.length===1&&g.charCodeAt(g.length-1)===47}return!h&&!(0,e.hasTrailingPathSeparator)(d,S)?d.with({path:d.path+"/"}):d}}e.ExtUri=D,e.extUri=new D(()=>!1),e.extUriBiasedIgnorePathCase=new D(y=>y.scheme===t.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new D(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(y,d){const S=[];for(let h=0;h<y.length;h++){const g=d(y[h]);y.some((p,m)=>m===h?!1:(0,e.isEqualOrParent)(g,d(p)))||S.push(y[h])}return S}e.distinctParents=T;var R;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function d(S){const h=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(m=>{const[l,u]=m.split(":");l&&u&&h.set(l,u)});const p=S.path.substring(0,S.path.indexOf(";"));return p&&h.set(y.META_DATA_MIME,p),h}y.parseMetaData=d})(R=e.DataUri||(e.DataUri={}));function C(y,d,S){if(d){let h=y.path;return h&&h[0]!==b.posix.sep&&(h=b.posix.sep+h),y.with({scheme:S,authority:d,path:h})}return y.with({scheme:S})}e.toLocalResource=C}),define(we[14],ye([0,1,20,9,6,2,19,3]),function(ie,e,I,t,b,P,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function v(he){return!!he&&typeof he.then=="function"}e.isThenable=v;function D(he){const q=new I.CancellationTokenSource,ee=he(q.token),G=new Promise((z,te)=>{const ce=q.token.onCancellationRequested(()=>{ce.dispose(),q.dispose(),te(new t.CancellationError)});Promise.resolve(ee).then(J=>{ce.dispose(),q.dispose(),z(J)},J=>{ce.dispose(),q.dispose(),te(J)})});return new class{cancel(){q.cancel()}then(z,te){return G.then(z,te)}catch(z){return this.then(void 0,z)}finally(z){return G.finally(z)}}}e.createCancelablePromise=D;function T(he,q,ee){return new Promise((G,z)=>{const te=q.onCancellationRequested(()=>{te.dispose(),G(ee)});he.then(G,z).finally(()=>te.dispose())})}e.raceCancellation=T;function R(he,q){return new Promise((ee,G)=>{const z=q.onCancellationRequested(()=>{z.dispose(),G(new t.CancellationError)});he.then(ee,G).finally(()=>z.dispose())})}e.raceCancellationError=R;async function C(he){let q=-1;const ee=he.map((z,te)=>z.then(ce=>(q=te,ce))),G=await Promise.race(ee);return he.forEach((z,te)=>{te!==q&&z.cancel()}),G}e.raceCancellablePromises=C;function y(he,q,ee){let G;const z=setTimeout(()=>{G?.(void 0),ee?.()},q);return Promise.race([he.finally(()=>clearTimeout(z)),new Promise(te=>G=te)])}e.raceTimeout=y;function d(he){return new Promise((q,ee)=>{const G=he();v(G)?G.then(q,ee):q(G)})}e.asPromise=d;class S{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(q){if(this.activePromise){if(this.queuedPromiseFactory=q,!this.queuedPromise){const ee=()=>{this.queuedPromise=null;const G=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,G};this.queuedPromise=new Promise(G=>{this.activePromise.then(ee,ee).then(G)})}return new Promise((ee,G)=>{this.queuedPromise.then(ee,G)})}return this.activePromise=q(),new Promise((ee,G)=>{this.activePromise.then(z=>{this.activePromise=null,ee(z)},z=>{this.activePromise=null,G(z)})})}}e.Throttler=S;class h{constructor(){this.current=Promise.resolve(null)}queue(q){return this.current=this.current.then(()=>q(),()=>q())}}e.Sequencer=h;class g{constructor(){this.promiseMap=new Map}queue(q,ee){const z=(this.promiseMap.get(q)??Promise.resolve()).catch(()=>{}).then(ee).finally(()=>{this.promiseMap.get(q)===z&&this.promiseMap.delete(q)});return this.promiseMap.set(q,z),z}}e.SequencerByKey=g;const p=(he,q)=>{let ee=!0;const G=setTimeout(()=>{ee=!1,q()},he);return{isTriggered:()=>ee,dispose:()=>{clearTimeout(G),ee=!1}}},m=he=>{let q=!0;return queueMicrotask(()=>{q&&(q=!1,he())}),{isTriggered:()=>q,dispose:()=>{q=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class l{constructor(q){this.defaultDelay=q,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(q,ee=this.defaultDelay){this.task=q,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((z,te)=>{this.doResolve=z,this.doReject=te}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const z=this.task;return this.task=null,z()}}));const G=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ee===e.MicrotaskDelay?m(G):p(ee,G),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=l;class u{constructor(q){this.delayer=new l(q),this.throttler=new S}trigger(q,ee){return this.delayer.trigger(()=>this.throttler.queue(q),ee)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=u;class n{constructor(){this._isOpen=!1,this._promise=new Promise((q,ee)=>{this._completePromise=q})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class s extends n{constructor(q){super();this._timeout=setTimeout(()=>this.open(),q)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function i(he,q){return q?new Promise((ee,G)=>{const z=setTimeout(()=>{te.dispose(),ee()},he),te=q.onCancellationRequested(()=>{clearTimeout(z),te.dispose(),G(new t.CancellationError)})}):D(ee=>i(he,ee))}e.timeout=i;function o(he,q=0){const ee=setTimeout(he,q);return(0,P.toDisposable)(()=>clearTimeout(ee))}e.disposableTimeout=o;function r(he){const q=[];let ee=0;const G=he.length;function z(){return ee<G?he[ee++]():null}function te(ce){ce!=null&&q.push(ce);const J=z();return J?J.then(te):Promise.resolve(q)}return Promise.resolve(null).then(te)}e.sequence=r;function a(he,q=G=>!!G,ee=null){let G=0;const z=he.length,te=()=>{if(G>=z)return Promise.resolve(ee);const ce=he[G++];return Promise.resolve(ce()).then(se=>q(se)?Promise.resolve(se):te())};return te()}e.first=a;function c(he,q=G=>!!G,ee=null){if(he.length===0)return Promise.resolve(ee);let G=he.length;const z=()=>{G=-1;for(const te of he)te.cancel?.()};return new Promise((te,ce)=>{for(const J of he)J.then(se=>{--G>=0&&q(se)?(z(),te(se)):G===0&&te(ee)}).catch(se=>{--G>=0&&(z(),ce(se))})})}e.firstParallel=c;class f{constructor(q){this._size=0,this.maxDegreeOfParalellism=q,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new b.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(q){return this._size++,new Promise((ee,G)=>{this.outstandingPromises.push({factory:q,c:ee,e:G}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const q=this.outstandingPromises.shift();this.runningPromises++;const ee=q.factory();ee.then(q.c,q.e),ee.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=f;class w extends f{constructor(){super(1)}}e.Queue=w;class A{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const q=new F;return this.drainers.add(q),q.p}isDrained(){for(const[,q]of this.queues)if(q.size>0)return!1;return!0}queueFor(q,ee=k.extUri){const G=ee.getComparisonKey(q);let z=this.queues.get(G);return z||(z=new w,b.Event.once(z.onDrained)(()=>{z?.dispose(),this.queues.delete(G),this.onDidQueueDrain()}),this.queues.set(G,z)),z}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const q of this.drainers)q.complete();this.drainers.clear()}dispose(){for(const[,q]of this.queues)q.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=A;class U{constructor(q,ee){this._token=-1,typeof q=="function"&&typeof ee=="number"&&this.setIfNotSet(q,ee)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(q,ee){this.cancel(),this._token=setTimeout(()=>{this._token=-1,q()},ee)}setIfNotSet(q,ee){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,q()},ee))}}e.TimeoutTimer=U;class x{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(q,ee){this.cancel(),this._token=setInterval(()=>{q()},ee)}}e.IntervalTimer=x;class Q{constructor(q,ee){this.timeoutToken=-1,this.runner=q,this.timeout=ee,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(q=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,q)}get delay(){return this.timeout}set delay(q){this.timeout=q}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=Q;class _{constructor(q,ee){ee%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.runner=q,this.timeout=ee,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(q=this.timeout){q%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(q/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=_;class Y extends Q{constructor(q,ee){super(q,ee);this.units=[]}work(q){this.units.push(q),this.isScheduled()||this.schedule()}doRun(){const q=this.units;this.units=[],this.runner&&this.runner(q)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=Y;class O extends P.Disposable{constructor(q,ee){super();this.options=q,this.handler=ee,this.pendingWork=[],this.throttler=this._register(new P.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(q){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+q.length>this.options.maxBufferedWork)return!1}else if(this.pending+q.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...q),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new Q(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=O,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=he=>{(0,E.setTimeout0)(()=>{if(q)return;const ee=Date.now()+15;he(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ee-Date.now())}}))});let q=!1;return{dispose(){q||(q=!0)}}}:e.runWhenIdle=(he,q)=>{const ee=requestIdleCallback(he,typeof q=="number"?{timeout:q}:void 0);let G=!1;return{dispose(){G||(G=!0,cancelIdleCallback(ee))}}}}();class B{constructor(q){this._didRun=!1,this._executor=()=>{try{this._value=q()}catch(ee){this._error=ee}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=B;async function ue(he,q,ee){let G;for(let z=0;z<ee;z++)try{return await he()}catch(te){G=te,await i(q)}throw G}e.retry=ue;class V{hasPending(q){return this._pending?typeof q=="number"?this._pending.taskId===q:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(q,ee,G){return this._pending={taskId:q,cancel:()=>G?.(),promise:ee},ee.then(()=>this.donePending(q),()=>this.donePending(q)),ee}donePending(q){this._pending&&q===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const q=this._next;this._next=void 0,q.run().then(q.promiseResolve,q.promiseReject)}}setNext(q){if(this._next)this._next.run=q;else{let ee,G;const z=new Promise((te,ce)=>{ee=te,G=ce});this._next={run:q,promise:z,promiseResolve:ee,promiseReject:G}}return this._next.promise}}e.TaskSequentializer=V;class ${constructor(q,ee=()=>Date.now()){this.interval=q,this.nowFn=ee,this.lastIncrementTime=0,this.value=0}increment(){const q=this.nowFn();return q-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=q,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class F{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((q,ee)=>{this.completeCallback=q,this.errorCallback=ee})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(q){return new Promise(ee=>{this.completeCallback(q),this.resolved=!0,ee()})}error(q){return new Promise(ee=>{this.errorCallback(q),this.rejected=!0,ee()})}cancel(){new Promise(q=>{this.errorCallback(new t.CancellationError),this.rejected=!0,q()})}}e.DeferredPromise=F;var M;(function(he){async function q(G){let z;const te=await Promise.all(G.map(ce=>ce.then(J=>J,J=>{z||(z=J)})));if(typeof z!="undefined")throw z;return te}he.settled=q;function ee(G){return new Promise(async(z,te)=>{try{await G(z,te)}catch(ce){te(ce)}})}he.withAsyncBody=ee})(M=e.Promises||(e.Promises={}));var j;(function(he){he[he.Initial=0]="Initial",he[he.DoneOK=1]="DoneOK",he[he.DoneError=2]="DoneError"})(j||(j={}));class Z{constructor(q){this._state=0,this._results=[],this._error=null,this._onStateChanged=new b.Emitter,queueMicrotask(async()=>{const ee={emitOne:G=>this.emitOne(G),emitMany:G=>this.emitMany(G),reject:G=>this.reject(G)};try{await Promise.resolve(q(ee)),this.resolve()}catch(G){this.reject(G)}finally{ee.emitOne=void 0,ee.emitMany=void 0,ee.reject=void 0}})}static fromArray(q){return new Z(ee=>{ee.emitMany(q)})}static fromPromise(q){return new Z(async ee=>{ee.emitMany(await q)})}static fromPromises(q){return new Z(async ee=>{await Promise.all(q.map(async G=>ee.emitOne(await G)))})}static merge(q){return new Z(async ee=>{await Promise.all(q.map(async G=>{for await(const z of G)ee.emitOne(z)}))})}[Symbol.asyncIterator](){let q=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(q<this._results.length)return{done:!1,value:this._results[q++]};if(this._state===1)return{done:!0,value:void 0};await b.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(q,ee){return new Z(async G=>{for await(const z of q)G.emitOne(ee(z))})}map(q){return Z.map(this,q)}static filter(q,ee){return new Z(async G=>{for await(const z of q)ee(z)&&G.emitOne(z)})}filter(q){return Z.filter(this,q)}static coalesce(q){return Z.filter(q,ee=>!!ee)}coalesce(){return Z.coalesce(this)}static async toPromise(q){const ee=[];for await(const G of q)ee.push(G);return ee}toPromise(){return Z.toPromise(this)}emitOne(q){this._state===0&&(this._results.push(q),this._onStateChanged.fire())}emitMany(q){this._state===0&&(this._results=this._results.concat(q),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(q){this._state===0&&(this._state=2,this._error=q,this._onStateChanged.fire())}}e.AsyncIterableObject=Z,Z.EMPTY=Z.fromArray([]);class oe extends Z{constructor(q,ee){super(ee);this._source=q}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=oe;function ge(he){const q=new I.CancellationTokenSource,ee=he(q.token);return new oe(q,async G=>{const z=q.token.onCancellationRequested(()=>{z.dispose(),q.dispose(),G.reject(new t.CancellationError)});try{for await(const te of ee){if(q.token.isCancellationRequested)return;G.emitOne(te)}z.dispose(),q.dispose()}catch(te){z.dispose(),q.dispose(),G.reject(te)}})}e.createCancelableAsyncIterable=ge}),define(we[66],ye([0,1,17,14,33,29,5,3,15]),function(ie,e,I,t,b,P,k,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const T="[/\\\\]",R="[^/\\\\]",C=/\//g;function y(F,M){switch(F){case 0:return"";case 1:return`${R}*?`;default:return`(?:${T}|${R}+${T}${M?`|${T}${R}+`:""})*?`}}function d(F,M){if(!F)return[];const j=[];let Z=!1,oe=!1,ge="";for(const he of F){switch(he){case M:if(!Z&&!oe){j.push(ge),ge="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}ge+=he}return ge&&j.push(ge),j}e.splitGlobAware=d;function S(F){if(!F)return"";let M="";const j=d(F,e.GLOB_SPLIT);if(j.every(Z=>Z===e.GLOBSTAR))M=".*";else{let Z=!1;j.forEach((oe,ge)=>{if(oe===e.GLOBSTAR){if(Z)return;M+=y(2,ge===j.length-1)}else{let he=!1,q="",ee=!1,G="";for(const z of oe){if(z!=="}"&&he){q+=z;continue}if(ee&&(z!=="]"||!G)){let te;z==="-"?te=z:(z==="^"||z==="!")&&!G?te="^":z===e.GLOB_SPLIT?te="":te=(0,v.escapeRegExpCharacters)(z),G+=te;continue}switch(z){case"{":he=!0;continue;case"[":ee=!0;continue;case"}":{M+=`(?:${d(q,",").map(J=>S(J)).join("|")})`,he=!1,q="";break}case"]":{M+="["+G+"]",ee=!1,G="";break}case"?":M+=R;continue;case"*":M+=y(1);continue;default:M+=(0,v.escapeRegExpCharacters)(z)}}ge<j.length-1&&(j[ge+1]!==e.GLOBSTAR||ge+2<j.length)&&(M+=T)}Z=oe===e.GLOBSTAR})}return M}const h=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new P.LRUCache(1e4),s=function(){return!1},i=function(){return null};function o(F,M){if(!F)return i;let j;typeof F!="string"?j=F.pattern:j=F,j=j.trim();const Z=`${j}_${!!M.trimForExclusions}`;let oe=n.get(Z);if(oe)return r(oe,F);let ge;return h.test(j)?oe=c(j.substr(4),j):(ge=g.exec(a(j,M)))?oe=f(ge[1],j):(M.trimForExclusions?m:p).test(j)?oe=w(j,M):(ge=l.exec(a(j,M)))?oe=A(ge[1].substr(1),j,!0):(ge=u.exec(a(j,M)))?oe=A(ge[1],j,!1):oe=U(j),n.set(Z,oe),r(oe,F)}function r(F,M){if(typeof M=="string")return F;const j=function(Z,oe){return(0,b.isEqualOrParent)(Z,M.base,!E.isLinux)?F(Z.substr(M.base.length+1),oe):null};return j.allBasenames=F.allBasenames,j.allPaths=F.allPaths,j.basenames=F.basenames,j.patterns=F.patterns,j}function a(F,M){return M.trimForExclusions&&F.endsWith("/**")?F.substr(0,F.length-2):F}function c(F,M){return function(j,Z){return typeof j=="string"&&j.endsWith(F)?M:null}}function f(F,M){const j=`/${F}`,Z=`\\${F}`,oe=function(he,q){return typeof he!="string"?null:q?q===F?M:null:he===F||he.endsWith(j)||he.endsWith(Z)?M:null},ge=[F];return oe.basenames=ge,oe.patterns=[M],oe.allBasenames=ge,oe}function w(F,M){const j=V(F.slice(1,-1).split(",").map(q=>o(q,M)).filter(q=>q!==i),F),Z=j.length;if(!Z)return i;if(Z===1)return j[0];const oe=function(q,ee){for(let G=0,z=j.length;G<z;G++)if(j[G](q,ee))return F;return null},ge=j.find(q=>!!q.allBasenames);ge&&(oe.allBasenames=ge.allBasenames);const he=j.reduce((q,ee)=>ee.allPaths?q.concat(ee.allPaths):q,[]);return he.length&&(oe.allPaths=he),oe}function A(F,M,j){const Z=k.sep===k.posix.sep,oe=Z?F:F.replace(C,k.sep),ge=k.sep+oe,he=k.posix.sep+F;let q;return j?q=function(ee,G){return typeof ee=="string"&&(ee===oe||ee.endsWith(ge)||!Z&&(ee===F||ee.endsWith(he)))?M:null}:q=function(ee,G){return typeof ee=="string"&&(ee===oe||!Z&&ee===F)?M:null},q.allPaths=[(j?"*/":"./")+F],q}function U(F){try{const M=new RegExp(`^${S(F)}$`);return function(j){return M.lastIndex=0,typeof j=="string"&&M.test(j)?F:null}}catch{return i}}function x(F,M,j){return!F||typeof M!="string"?!1:Q(F)(M,void 0,j)}e.match=x;function Q(F,M={}){if(!F)return s;if(typeof F=="string"||_(F)){const j=o(F,M);if(j===i)return s;const Z=function(oe,ge){return!!j(oe,ge)};return j.allBasenames&&(Z.allBasenames=j.allBasenames),j.allPaths&&(Z.allPaths=j.allPaths),Z}return B(F,M)}e.parse=Q;function _(F){const M=F;return M?typeof M.base=="string"&&typeof M.pattern=="string":!1}e.isRelativePattern=_;function Y(F){return F.allBasenames||[]}e.getBasenameTerms=Y;function O(F){return F.allPaths||[]}e.getPathTerms=O;function B(F,M){const j=V(Object.getOwnPropertyNames(F).map(q=>ue(q,F[q],M)).filter(q=>q!==i)),Z=j.length;if(!Z)return i;if(!j.some(q=>!!q.requiresSiblings)){if(Z===1)return j[0];const q=function(z,te){let ce;for(let J=0,se=j.length;J<se;J++){const me=j[J](z,te);if(typeof me=="string")return me;(0,t.isThenable)(me)&&(ce||(ce=[]),ce.push(me))}return ce?(async()=>{for(const J of ce){const se=await J;if(typeof se=="string")return se}return null})():null},ee=j.find(z=>!!z.allBasenames);ee&&(q.allBasenames=ee.allBasenames);const G=j.reduce((z,te)=>te.allPaths?z.concat(te.allPaths):z,[]);return G.length&&(q.allPaths=G),q}const oe=function(q,ee,G){let z,te;for(let ce=0,J=j.length;ce<J;ce++){const se=j[ce];se.requiresSiblings&&G&&(ee||(ee=(0,k.basename)(q)),z||(z=ee.substr(0,ee.length-(0,k.extname)(q).length)));const me=se(q,ee,z,G);if(typeof me=="string")return me;(0,t.isThenable)(me)&&(te||(te=[]),te.push(me))}return te?(async()=>{for(const ce of te){const J=await ce;if(typeof J=="string")return J}return null})():null},ge=j.find(q=>!!q.allBasenames);ge&&(oe.allBasenames=ge.allBasenames);const he=j.reduce((q,ee)=>ee.allPaths?q.concat(ee.allPaths):q,[]);return he.length&&(oe.allPaths=he),oe}function ue(F,M,j){if(M===!1)return i;const Z=o(F,j);if(Z===i)return i;if(typeof M=="boolean")return Z;if(M){const oe=M.when;if(typeof oe=="string"){const ge=(he,q,ee,G)=>{if(!G||!Z(he,q))return null;const z=oe.replace("$(basename)",ee),te=G(z);return(0,t.isThenable)(te)?te.then(ce=>ce?F:null):te?F:null};return ge.requiresSiblings=!0,ge}}return Z}function V(F,M){const j=F.filter(q=>!!q.basenames);if(j.length<2)return F;const Z=j.reduce((q,ee)=>{const G=ee.basenames;return G?q.concat(G):q},[]);let oe;if(M){oe=[];for(let q=0,ee=Z.length;q<ee;q++)oe.push(M)}else oe=j.reduce((q,ee)=>{const G=ee.patterns;return G?q.concat(G):q},[]);const ge=function(q,ee){if(typeof q!="string")return null;if(!ee){let z;for(z=q.length;z>0;z--){const te=q.charCodeAt(z-1);if(te===47||te===92)break}ee=q.substr(z)}const G=Z.indexOf(ee);return G!==-1?oe[G]:null};ge.basenames=Z,ge.patterns=oe,ge.allBasenames=Z;const he=F.filter(q=>!q.basenames);return he.push(ge),he}function $(F,M){return(0,I.equals)(F,M,(j,Z)=>typeof j=="string"&&typeof Z=="string"?j===Z:typeof j!="string"&&typeof Z!="string"?j.base===Z.base&&j.pattern===Z.pattern:!1)}e.patternsEquals=$}),define(we[84],ye([0,1,9,138,19,15,4]),function(ie,e,I,t,b,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var E;(function(S){S[S.Paragraph=0]="Paragraph",S[S.Break=1]="Break"})(E=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class v{constructor(h="",g=!1){if(this.value=h,typeof this.value!="string")throw(0,I.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(h,g=0){return this.value+=C(this.supportThemeIcons?(0,t.escapeIcons)(h):h).replace(/([ \t]+)/g,(p,m)=>"&nbsp;".repeat(m.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,g){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}appendLink(h,g,p){return this.value+="[",this.value+=this._escape(g,"]"),this.value+="](",this.value+=this._escape(String(h),")"),p&&(this.value+=` "${this._escape(this._escape(p,'"'),")")}"`),this.value+=")",this}_escape(h,g){const p=new RegExp((0,P.escapeRegExpCharacters)(g),"g");return h.replace(p,(m,l)=>h.charAt(l-1)!=="\\"?`\\${m}`:m)}}e.MarkdownString=v;function D(S){return T(S)?!S.value:Array.isArray(S)?S.every(D):!0}e.isEmptyMarkdownString=D;function T(S){return S instanceof v?!0:S&&typeof S=="object"?typeof S.value=="string"&&(typeof S.isTrusted=="boolean"||S.isTrusted===void 0)&&(typeof S.supportThemeIcons=="boolean"||S.supportThemeIcons===void 0):!1}e.isMarkdownString=T;function R(S,h){return S===h?!0:!S||!h?!1:S.value===h.value&&S.isTrusted===h.isTrusted&&S.supportThemeIcons===h.supportThemeIcons&&S.supportHtml===h.supportHtml&&(S.baseUri===h.baseUri||!!S.baseUri&&!!h.baseUri&&(0,b.isEqual)(k.URI.from(S.baseUri),k.URI.from(h.baseUri)))}e.markdownStringEqual=R;function C(S){return S.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function y(S){return S&&S.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=y;function d(S){const h=[],g=S.split("|").map(m=>m.trim());S=g[0];const p=g[1];if(p){const m=/height=(\d+)/.exec(p),l=/width=(\d+)/.exec(p),u=m?m[1]:"",n=l?l[1]:"",s=isFinite(parseInt(n)),i=isFinite(parseInt(u));s&&h.push(`width="${n}"`),i&&h.push(`height="${u}"`)}return{href:S,dimensions:h}}e.parseHrefAndDimensions=d}),define(we[85],ye([0,1,17,33,8,5,3,19,15,4]),function(ie,e,I,t,b,P,k,E,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function T(a,c){const{os:f,tildify:w,relative:A}=c;if(A){const Q=R(a,A,f);if(typeof Q=="string")return Q}let U=a.fsPath;if(f===1&&!k.isWindows?U=U.replace(/\//g,"\\"):f!==1&&k.isWindows&&(U=U.replace(/\\/g,"/")),f!==1&&w?.userHome){let Q=w.userHome.fsPath,_;a.scheme!==w.userHome.scheme&&a.path.startsWith(P.posix.sep)?_=w.userHome.with({path:a.path}).fsPath:_=a.fsPath,U=S(_,Q,f)}return(f===1?P.win32:P.posix).normalize(y(U,f===1))}e.getPathLabel=T;function R(a,c,f){const w=f===1?P.win32:P.posix,A=f===3?E.extUri:E.extUriIgnorePathCase,U=c.getWorkspace(),x=(0,I.firstOrDefault)(U.folders);if(!x)return;a.scheme!==x.uri.scheme&&a.path.startsWith(P.posix.sep)&&(a=x.uri.with({path:a.path}));const Q=c.getWorkspaceFolder(a);if(!Q)return;let _;if(A.isEqual(Q.uri,a)?_="":_=A.relativePath(Q.uri,a)??"",_&&(_=w.normalize(_)),U.folders.length>1&&!c.noPrefix){const Y=Q.name?Q.name:A.basenameOrAuthority(Q.uri);_=_?`${Y} \u2022 ${_}`:Y}return _}function C(a){if(!a)return;typeof a=="string"&&(a=D.URI.file(a));const c=(0,E.basename)(a)||(a.scheme===b.Schemas.file?a.fsPath:a.path);return k.isWindows&&(0,t.isRootOrDriveLetter)(c)?y(c):c}e.getBaseLabel=C;function y(a,c=k.isWindows){return(0,t.hasDriveLetter)(a,c)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=y;let d=Object.create(null);function S(a,c,f=k.OS){if(f===1||!a||!c)return a;let w=d.original===c?d.normalized:void 0;w||(w=c,k.isWindows&&(w=(0,t.toSlashes)(w)),w=`${(0,v.rtrim)(w,P.posix.sep)}${P.posix.sep}`,d={original:c,normalized:w});let A=a;return k.isWindows&&(A=(0,t.toSlashes)(A)),(f===3?A.startsWith(w):(0,v.startsWithIgnoreCase)(A,w))?`~/${A.substr(w.length)}`:a}e.tildify=S;function h(a,c){return a.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=h;const g="\u2026",p="\\\\",m="~";function l(a,c=P.sep){const f=new Array(a.length);let w=!1;for(let A=0;A<a.length;A++){let U=a[A];if(U===""){f[A]=`.${c}`;continue}if(!U){f[A]=U;continue}w=!0;let x="",Q=U;Q.indexOf(p)===0?(x=Q.substr(0,Q.indexOf(p)+p.length),Q=Q.substr(Q.indexOf(p)+p.length)):Q.indexOf(c)===0?(x=Q.substr(0,Q.indexOf(c)+c.length),Q=Q.substr(Q.indexOf(c)+c.length)):Q.indexOf(m)===0&&(x=Q.substr(0,Q.indexOf(m)+m.length),Q=Q.substr(Q.indexOf(m)+m.length));const _=Q.split(c);for(let Y=1;w&&Y<=_.length;Y++)for(let O=_.length-Y;w&&O>=0;O--){w=!1;let B=_.slice(O,O+Y).join(c);for(let ue=0;!w&&ue<a.length;ue++)if(ue!==A&&a[ue]&&a[ue].indexOf(B)>-1){const V=O+Y===_.length,$=O>0&&a[ue].indexOf(c)>-1?c+B:B,F=a[ue].endsWith($);w=!V||F}if(!w){let ue="";(_[0].endsWith(":")||x!=="")&&(O===1&&(O=0,Y++,B=_[0]+c+B),O>0&&(ue=_[0]+c),ue=x+ue),O>0&&(ue=ue+g+c),ue=ue+B,O+Y<_.length&&(ue=ue+c+g),f[A]=ue}}w&&(f[A]=U)}return f}e.shorten=l;var u;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function n(a,c=Object.create(null)){const f=[];let w=!1,A="";for(const U of a)if(U==="$"||w&&U==="{")A&&f.push({value:A,type:u.TEXT}),A="",w=!0;else if(U==="}"&&w){const x=c[A];if(typeof x=="string")x.length&&f.push({value:x,type:u.VARIABLE});else if(x){const Q=f[f.length-1];(!Q||Q.type!==u.SEPARATOR)&&f.push({value:x.label,type:u.SEPARATOR})}A="",w=!1}else A+=U;return A&&!w&&f.push({value:A,type:u.TEXT}),f.filter((U,x)=>{if(U.type===u.SEPARATOR){const Q=f[x-1],_=f[x+1];return[Q,_].every(Y=>Y&&(Y.type===u.VARIABLE||Y.type===u.TEXT)&&Y.value.length>0)}return!0}).map(U=>U.value).join("")}e.template=n;function s(a,c){return k.isMacintosh||c?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):a.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=s;function i(a,c){return k.isMacintosh||c?a.replace(/\(&&\w\)|&&/g,""):k.isWindows?a.replace(/&&|&/g,f=>f==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function o(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=o;function r(a){const c=a.indexOf("/")!==-1?P.posix:P.win32,f=c.basename(a),w=c.dirname(a);return f.length?{name:f,parentPath:w}:{name:w,parentPath:""}}e.splitName=r}),define(we[67],ye([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(T){return T.toJSON()}class b{constructor(R){this._uriTransformer=R}transformIncoming(R){const C=this._uriTransformer.transformIncoming(R);return C===R?R:t(I.URI.from(C))}transformOutgoing(R){const C=this._uriTransformer.transformOutgoing(R);return C===R?R:t(I.URI.from(C))}transformOutgoingURI(R){const C=this._uriTransformer.transformOutgoing(R);return C===R?R:I.URI.from(C)}transformOutgoingScheme(R){return this._uriTransformer.transformOutgoingScheme(R)}}e.URITransformer=b,e.DefaultURITransformer=new class{transformIncoming(T){return T}transformOutgoing(T){return T}transformOutgoingURI(T){return T}transformOutgoingScheme(T){return T}};function P(T,R,C){if(!T||C>200)return null;if(typeof T=="object"){if(T instanceof I.URI)return R.transformOutgoing(T);for(let y in T)if(Object.hasOwnProperty.call(T,y)){const d=P(T[y],R,C+1);d!==null&&(T[y]=d)}}return null}function k(T,R){const C=P(T,R,0);return C===null?T:C}e.transformOutgoingURIs=k;function E(T,R,C,y){if(!T||y>200)return null;if(typeof T=="object"){if(T.$mid===1)return C?I.URI.revive(R.transformIncoming(T)):R.transformIncoming(T);for(let d in T)if(Object.hasOwnProperty.call(T,d)){const S=E(T[d],R,C,y+1);S!==null&&(T[d]=S)}}return null}function v(T,R){const C=E(T,R,!1,0);return C===null?T:C}e.transformIncomingURIs=v;function D(T,R){const C=E(T,R,!0,0);return C===null?T:C}e.transformAndReviveIncomingURIs=D}),define(we[27],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(b){return I.test(b)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let b;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?b=crypto.getRandomValues.bind(crypto):b=function(E){for(let v=0;v<E.length;v++)E[v]=Math.floor(Math.random()*256);return E};const P=new Uint8Array(16),k=[];for(let E=0;E<256;E++)k.push(E.toString(16).padStart(2,"0"));return function(){b(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let v=0,D="";return D+=k[P[v++]],D+=k[P[v++]],D+=k[P[v++]],D+=k[P[v++]],D+="-",D+=k[P[v++]],D+=k[P[v++]],D+="-",D+=k[P[v++]],D+=k[P[v++]],D+="-",D+=k[P[v++]],D+=k[P[v++]],D+="-",D+=k[P[v++]],D+=k[P[v++]],D+=k[P[v++]],D+=k[P[v++]],D+=k[P[v++]],D+=k[P[v++]],D}}()}),define(we[139],ye([0,1,260]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(P="utf8"){this.stringDecoder=new I.StringDecoder(P),this.remaining=null}write(P){const k=[],E=this.remaining?this.remaining+this.stringDecoder.write(P):this.stringDecoder.write(P);if(E.length<1)return k;let v=0,D,T=v;for(;T<E.length;)if(D=E.charCodeAt(T),D===13||D===10){if(k.push(E.substring(v,T)),T++,T<E.length){const R=D;D=E.charCodeAt(T),(R===13&&D===10||R===10&&D===13)&&T++}v=T}else T++;return this.remaining=v<E.length?E.substr(v):null,k}end(){return this.remaining}}e.LineDecoder=t}),function(){"use strict";function ie(e,I,t,b){function P(d){return new Promise(S=>t.exists(d,S))}function k(d){return new Promise((S,h)=>{const g=new Date;t.utimes(d,g,g,p=>p?h(p):S())})}function E(d){return new Promise((S,h)=>t.mkdir(d,{recursive:!0},g=>g&&g.code!=="EEXIST"?h(g):S(d)))}function v(d){return new Promise((S,h)=>t.rm(d,{recursive:!0,force:!0,maxRetries:3},g=>g?h(g):S()))}function D(d){return new Promise((S,h)=>t.readFile(d,"utf8",(g,p)=>g?h(g):S(p)))}function T(d,S){return new Promise((h,g)=>t.writeFile(d,S,"utf8",p=>p?g(p):h()))}function R(d){const S=I.join(d,"languagepacks.json");try{return e(S)}catch{}}function C(d,S){try{for(;S;){if(d[S])return S;{const h=S.lastIndexOf("-");if(h>0)S=S.substring(0,h);else return}}}catch(h){console.error("Resolving language pack configuration failed.",h)}}function y(d,S,h,g){if(g==="pseudo")return Promise.resolve({locale:g,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:g,availableLanguages:{}});if(g&&(g==="en"||g==="en-us"))return Promise.resolve({locale:g,availableLanguages:{}});const p=g;b.mark("code/willGenerateNls");const m=function(l){return b.mark("code/didGenerateNls"),Promise.resolve({locale:l,availableLanguages:{}})};try{if(!d)return m(p);const l=R(S);if(!l||(g=C(l,g),!g))return m(p);const u=l[g];let n;return!u||typeof u.hash!="string"||!u.translations||typeof(n=u.translations.vscode)!="string"?m(p):P(n).then(s=>{if(!s)return m(p);const i=u.hash+"."+g,o=I.join(S,"clp",i),r=I.join(o,d),a=I.join(o,"tcf.json"),c=I.join(o,"corrupted.info"),f={locale:p,availableLanguages:{"*":g},_languagePackId:i,_translationsConfigFile:a,_cacheRoot:o,_resolvedLanguagePackCoreLocation:r,_corruptedFile:c};return P(c).then(w=>{let A;return w?A=v(o):A=Promise.resolve(void 0),A.then(()=>P(r).then(U=>U?(k(r).catch(()=>{}),b.mark("code/didGenerateNls"),f):E(r).then(()=>Promise.all([D(h),D(n)])).then(x=>{const Q=JSON.parse(x[0]),_=JSON.parse(x[1]).contents,Y=Object.keys(Q.bundles),O=[];for(const B of Y){const ue=Q.bundles[B],V=Object.create(null);for(const $ of ue){const F=Q.keys[$],M=Q.messages[$],j=_[$];let Z;if(j){Z=[];for(let oe=0;oe<F.length;oe++){const ge=F[oe],he=typeof ge=="string"?ge:ge.key;let q=j[he];q===void 0&&(q=M[oe]),Z.push(q)}}else Z=M;V[$]=Z}O.push(T(I.join(r,B.replace(/\//g,"!")+".nls.json"),JSON.stringify(V)))}return O.push(T(a,JSON.stringify(u.translations))),Promise.all(O)}).then(()=>(b.mark("code/didGenerateNls"),f)).catch(x=>(console.error("Generating translation files failed.",x),m(g)))))})})}catch(l){return console.error("Generating translation files failed.",l),m(g)}}return{getNLSConfiguration:y}}if(typeof define=="function")define(we[140],ye([0,86,30,46]),function(e,I,t,b){return ie(e.__$__nodeRequire,I,t,b)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("fs"),t=require("../common/performance");module.exports=ie(require,e,I,t)}else throw new Error("Unknown context")}(),define(we[141],ye([0,1,28]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function b(k){const E=k.replace(/\-/g,":").toLowerCase();return!t.has(E)}function P(){const k=(0,I.networkInterfaces)();for(let E in k){const v=k[E];if(v){for(const{mac:D}of v)if(b(D))return D}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=P}),define(we[87],ye([0,1,28,9,29,27,141]),function(ie,e,I,t,b,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(T){return this._virtualMachineOUIs||(this._virtualMachineOUIs=b.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(T)}value(){if(this._value===void 0){let T=0,R=0;const C=(0,I.networkInterfaces)();for(let y in C){const d=C[y];if(d)for(const{mac:S,internal:h}of d)h||(R+=1,this._isVirtualMachineMacAddress(S.toUpperCase())&&(T+=1))}this._value=R>0?T/R:0}return this._value}};let E;async function v(){return E||(E=(async()=>await D()||P.generateUuid())()),E}e.getMachineId=v;async function D(){try{const T=await new Promise((C,y)=>{ie(["crypto"],C,y)}),R=(0,k.getMac)();return T.createHash("sha256").update(R,"utf8").digest("hex")}catch(T){t.onUnexpectedError(T);return}}}),define(we[22],ye([0,1,30,28,261,14,33,82,5,3,19,4]),function(ie,e,I,t,b,P,k,E,v,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var C;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(C=e.RimRafMode||(e.RimRafMode={}));async function y(O,B=C.UNLINK){if((0,k.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return B===C.UNLINK?S(O):d(O)}async function d(O){try{const B=(0,k.randomPath)((0,t.tmpdir)());try{await I.promises.rename(O,B)}catch{return S(O)}S(B).catch(ue=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function S(O){return(0,b.promisify)(I.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function h(O){if((0,k.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=h;async function g(O,B){return l(await(B?p(O):(0,b.promisify)(I.readdir)(O)))}async function p(O){try{return await(0,b.promisify)(I.readdir)(O,{withFileTypes:!0})}catch(V){console.warn("[node.js fs] readdir with filetypes failed with error: ",V)}const B=[],ue=await g(O);for(const V of ue){let $=!1,F=!1,M=!1;try{const j=await e.Promises.lstat((0,v.join)(O,V));$=j.isFile(),F=j.isDirectory(),M=j.isSymbolicLink()}catch(j){console.warn("[node.js fs] unexpected error from lstat after readdir: ",j)}B.push({name:V,isFile:()=>$,isDirectory:()=>F,isSymbolicLink:()=>M})}return B}function m(O){return l(I.readdirSync(O))}e.readdirSync=m;function l(O){return O.map(B=>typeof B=="string"?D.isMacintosh?(0,E.normalizeNFC)(B):B:(B.name=D.isMacintosh?(0,E.normalizeNFC)(B.name):B.name,B))}async function u(O){const B=await g(O),ue=[];for(const V of B)await s.existsDirectory((0,v.join)(O,V))&&ue.push(V);return ue}function n(O,B=1e3){return new Promise(ue=>{let V=!1;const $=setInterval(()=>{V||(V=!0,I.access(O,F=>{V=!1,F&&(clearInterval($),ue(void 0))}))},B)})}e.whenDeleted=n;var s;(function(O){async function B($){let F;try{if(F=await e.Promises.lstat($),!F.isSymbolicLink())return{stat:F}}catch{}try{return{stat:await e.Promises.stat($),symbolicLink:F?.isSymbolicLink()?{dangling:!1}:void 0}}catch(M){if(M.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(D.isWindows&&M.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink($)),symbolicLink:{dangling:!1}}}catch(j){if(j.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw j}throw M}}O.stat=B;async function ue($){try{const{stat:F,symbolicLink:M}=await O.stat($);return F.isFile()&&M?.dangling!==!0}catch{}return!1}O.existsFile=ue;async function V($){try{const{stat:F,symbolicLink:M}=await O.stat($);return F.isDirectory()&&M?.dangling!==!0}catch{}return!1}O.existsDirectory=V})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new P.ResourceQueue;function o(O,B,ue){return i.queueFor(R.URI.file(O),T.extUriBiasedIgnorePathCase).queue(()=>{const V=f(ue);return new Promise(($,F)=>a(O,B,V,M=>M?F(M):$()))})}let r=!0;function a(O,B,ue,V){if(!r)return I.writeFile(O,B,{mode:ue.mode,flag:ue.flag},V);I.open(O,ue.flag,ue.mode,($,F)=>{if($)return V($);I.writeFile(F,B,M=>{if(M)return I.close(F,()=>V(M));I.fdatasync(F,j=>(j&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",j),r=!1),I.close(F,Z=>V(Z))))})})}function c(O,B,ue){const V=f(ue);if(!r)return I.writeFileSync(O,B,{mode:V.mode,flag:V.flag});const $=I.openSync(O,V.flag,V.mode);try{I.writeFileSync($,B);try{I.fdatasyncSync($)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),r=!1}}finally{I.closeSync($)}}e.writeFileSync=c;function f(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function w(O,B){if(O!==B)try{await e.Promises.rename(O,B)}catch(ue){if(O.toLowerCase()!==B.toLowerCase()&&ue.code==="EXDEV"||O.endsWith("."))await A(O,B,{preserveSymlinks:!1}),await y(O,C.MOVE);else throw ue}}async function A(O,B,ue){return x(O,B,{root:{source:O,target:B},options:ue,handledSourcePaths:new Set})}const U=511;async function x(O,B,ue){if(ue.handledSourcePaths.has(O))return;ue.handledSourcePaths.add(O);const{stat:V,symbolicLink:$}=await s.stat(O);if($){if(ue.options.preserveSymlinks)try{return await Y(O,B,ue)}catch(F){console.warn("[node.js fs] copy of symlink failed: ",F)}if($.dangling)return}return V.isDirectory()?Q(O,B,V.mode&U,ue):_(O,B,V.mode&U)}async function Q(O,B,ue,V){await e.Promises.mkdir(B,{recursive:!0,mode:ue});const $=await g(O);for(const F of $)await x((0,v.join)(O,F),(0,v.join)(B,F),V)}async function _(O,B,ue){await e.Promises.copyFile(O,B),await e.Promises.chmod(B,ue)}async function Y(O,B,ue){let V=await e.Promises.readlink(O);(0,k.isEqualOrParent)(V,ue.root.source,!D.isLinux)&&(V=(0,v.join)(ue.root.target,V.substr(ue.root.source.length+1))),await e.Promises.symlink(V,B)}e.Promises=new class{get access(){return(0,b.promisify)(I.access)}get stat(){return(0,b.promisify)(I.stat)}get lstat(){return(0,b.promisify)(I.lstat)}get utimes(){return(0,b.promisify)(I.utimes)}get read(){return(O,B,ue,V,$)=>new Promise((F,M)=>{I.read(O,B,ue,V,$,(j,Z,oe)=>j?M(j):F({bytesRead:Z,buffer:oe}))})}get readFile(){return(0,b.promisify)(I.readFile)}get write(){return(O,B,ue,V,$)=>new Promise((F,M)=>{I.write(O,B,ue,V,$,(j,Z,oe)=>j?M(j):F({bytesWritten:Z,buffer:oe}))})}get appendFile(){return(0,b.promisify)(I.appendFile)}get fdatasync(){return(0,b.promisify)(I.fdatasync)}get truncate(){return(0,b.promisify)(I.truncate)}get rename(){return(0,b.promisify)(I.rename)}get copyFile(){return(0,b.promisify)(I.copyFile)}get open(){return(0,b.promisify)(I.open)}get close(){return(0,b.promisify)(I.close)}get symlink(){return(0,b.promisify)(I.symlink)}get readlink(){return(0,b.promisify)(I.readlink)}get chmod(){return(0,b.promisify)(I.chmod)}get mkdir(){return(0,b.promisify)(I.mkdir)}get unlink(){return(0,b.promisify)(I.unlink)}get rmdir(){return(0,b.promisify)(I.rmdir)}get realpath(){return(0,b.promisify)(I.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return u}get writeFile(){return o}get rm(){return y}get move(){return w}get copy(){return A}}}),define(we[142],ye([0,1,30,5,3,15,22]),function(ie,e,I,t,b,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function E(C){if(b.isLinux)return C;const y=(0,t.dirname)(C);if(C===y)return C;const d=((0,t.basename)(C)||C).toLowerCase();try{const h=(0,k.readdirSync)(y).filter(g=>g.toLowerCase()===d);if(h.length===1){const g=E(y);if(g)return(0,t.join)(g,h[0])}else if(h.length>1){const g=h.indexOf(d);if(g>=0){const p=E(y);if(p)return(0,t.join)(p,h[g])}}}catch{}return null}e.realcaseSync=E;async function v(C){if(b.isLinux)return C;const y=(0,t.dirname)(C);if(C===y)return C;const d=((0,t.basename)(C)||C).toLowerCase();try{const h=(await k.Promises.readdir(y)).filter(g=>g.toLowerCase()===d);if(h.length===1){const g=await v(y);if(g)return(0,t.join)(g,h[0])}else if(h.length>1){const g=h.indexOf(d);if(g>=0){const p=await v(y);if(p)return(0,t.join)(p,h[g])}}}catch{}return null}e.realcase=v;async function D(C){try{return await k.Promises.realpath(C)}catch{const d=R(C);return await k.Promises.access(d,I.constants.R_OK),d}}e.realpath=D;function T(C){try{return I.realpathSync(C)}catch{const d=R(C);return I.accessSync(d,I.constants.R_OK),d}}e.realpathSync=T;function R(C){return(0,P.rtrim)((0,t.normalize)(C),t.sep)}}),define(we[143],ye([0,1,68]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(E,v,D,T=1){let R=!1;return new Promise(C=>{const y=setTimeout(()=>{if(!R)return R=!0,C(0)},D);b(E,v,T,d=>{if(!R)return R=!0,clearTimeout(y),C(d)})})}e.findFreePort=t;function b(E,v,D,T){if(v===0)return T(0);const R=new I.Socket;R.once("connect",()=>(k(R),b(E+D,v-1,D,T))),R.once("data",()=>{}),R.once("error",C=>(k(R),C.code!=="ECONNREFUSED"?b(E+D,v-1,D,T):T(E))),R.connect(E,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function P(E,v,D){let T=!1,R,C=1;const y=I.createServer({pauseOnConnect:!0});function d(S,h){T||(T=!0,y.removeAllListeners(),y.close(),R&&clearTimeout(R),h(S))}return new Promise(S=>{R=setTimeout(()=>{d(0,S)},D),y.on("listening",()=>{d(E,S)}),y.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&C<v?(E++,C++,y.listen(E,"127.0.0.1")):d(0,S)}),y.on("close",()=>{d(0,S)}),y.listen(E,"127.0.0.1")})}e.findFreePortFaster=P;function k(E){try{E.removeAllListeners("connect"),E.removeAllListeners("error"),E.end(),E.destroy(),E.unref()}catch(v){console.error(v)}}}),define(we[88],ye([0,1,28,5,22]),function(ie,e,I,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const P=/^\d+$/,k=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var v;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(v||(v={}));let D;switch(process.arch){case"ia32":case"x32":D=1;break;case"arm":case"arm64":D=2;break;default:D=0;break}let T;process.env.PROCESSOR_ARCHITEW6432?T=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?T=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?T=1:T=0;class R{constructor(u,n,s){this.exePath=u,this.displayName=n,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await b.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function C({useAlternateBitness:l=!1}={}){return l?D===0?process.env["ProgramFiles(x86)"]||null:T===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:l=!1,findPreview:u=!1}={}){const n=C({useAlternateBitness:l});if(!n)return null;const s=t.join(n,"PowerShell");if(!await b.SymlinkSupport.existsDirectory(s))return null;let i=-1,o=null;for(const c of await b.Promises.readdir(s)){let f=-1;if(u){const A=c.indexOf("-");if(A<0)continue;const U=c.substring(0,A);if(!P.test(U)||c.substring(A+1)!=="preview")continue;f=parseInt(U,10)}else{if(!P.test(c))continue;f=parseInt(c,10)}if(f<=i)continue;const w=t.join(s,c,"pwsh.exe");!await b.SymlinkSupport.existsFile(w)||(o=w,i=f)}if(!o)return null;const r=n.includes("x86")?" (x86)":"",a=u?" Preview":"";return new R(o,`PowerShell${a}${r}`,!0)}async function d({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const u=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await b.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:n,pwshMsixName:s}=l?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const i of await b.Promises.readdir(u))if(n.test(i)){const o=t.join(u,i,"pwsh.exe");return new R(o,s)}return null}function S(){const l=t.join(I.homedir(),".dotnet","tools","pwsh.exe");return new R(l,".NET Core PowerShell Global Tool")}function h(){const l=t.join(process.env.windir,D===1&&T!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new R(l,"Windows PowerShell",!0)}async function*g(){let l=await y();l&&(yield l),l=await y({useAlternateBitness:!0}),l&&(yield l),l=await d(),l&&(yield l),l=S(),l&&(yield l),l=await y({findPreview:!0}),l&&(yield l),l=await d({findPreview:!0}),l&&(yield l),l=await y({useAlternateBitness:!0,findPreview:!0}),l&&(yield l),l=h(),l&&(yield l)}async function*p(){for await(const l of g())await l.exists()&&(yield l)}e.enumeratePowerShellInstallations=p;async function m(){for await(const l of p())return l;return null}e.getFirstAvailablePowerShellInstallation=m}),define(we[89],ye([0,1,38,8]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function b(k){return new Promise((E,v)=>{let D;const T=new Map;function R(y,d,S,h,g){const p=T.get(d);if(y===k||p){const m={name:C(S),cmd:S,pid:y,ppid:d,load:h,mem:g};T.set(y,m),y===k&&(D=m),p&&(p.children||(p.children=[]),p.children.push(m),p.children.length>1&&(p.children=p.children.sort((l,u)=>l.pid-u.pid)))}}function C(y){const d=/--vscode-window-kind=shared-process/,S=/--vscode-window-kind=issue-reporter/,h=/--vscode-window-kind=process-explorer/,g=/--utility-sub-type=network/,p=/--crashes-directory/,m=/\\pipe\\winpty-control/,l=/conhost\.exe/,u=/--type=([a-zA-Z-]+)/;if(p.exec(y))return"electron-crash-reporter";if(m.exec(y))return"winpty-process";if(l.exec(y))return"console-window-host (Windows internal process)";let n=u.exec(y);if(n&&n.length===2)return n[1]==="renderer"?d.exec(y)?"shared-process":S.exec(y)?"issue-reporter":h.exec(y)?"process-explorer":"window":n[1]==="utility"&&g.exec(y)?"utility-network-service":n[1];const s=/[a-zA-Z-]+\.js/g;let i="";do n=s.exec(y),n&&(i+=n+" ");while(n);return i&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${i}`:y}if(process.platform==="win32"){const y=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,S)=>{ie(["windows-process-tree"],d,S)}).then(d=>{d.getProcessList(k,S=>{if(!S){v(new Error(`Root process ${k} not found`));return}d.getProcessCpuUsage(S,h=>{const g=new Map;h.forEach(p=>{const m=y(p.commandLine||"");g.set(p.pid,{name:C(m),cmd:m,pid:p.pid,ppid:p.ppid,load:p.cpu||0,mem:p.memory||0})}),D=g.get(k),D?(g.forEach(p=>{const m=g.get(p.ppid);m&&(m.children||(m.children=[]),m.children.push(p))}),g.forEach(p=>{p.children&&(p.children=p.children.sort((m,l)=>m.pid-l.pid))}),E(D)):v(new Error(`Root process ${k} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let y=function(){let d=[D];const S=[];for(;d.length;){const g=d.shift();g&&(S.push(g.pid),g.children&&(d=d.concat(g.children)))}let h=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",ie).fsPath);h+=" "+S.join(" "),(0,I.exec)(h,{},(g,p,m)=>{if(g||m)v(g||new Error(m.toString()));else{const l=p.toString().split(`
`);for(let u=0;u<S.length;u++){const n=T.get(S[u]);n.load=parseFloat(l[u])}if(!D){v(new Error(`Root process ${k} not found`));return}E(D)}})};(0,I.exec)("which ps",{},(d,S,h)=>{if(d||h)if(process.platform!=="linux")v(d||new Error(h.toString()));else{const g=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",ie).fsPath);(0,I.exec)(g,{},(p,m,l)=>{p||l?v(p||new Error(l.toString())):(P(m,R),y())})}else{const g=S.toString().trim(),p="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,I.exec)(`${g} ${p}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(m,l,u)=>{m||u&&!u.includes("screen size is bogus")?v(m||new Error(u.toString())):(P(l,R),process.platform==="linux"?y():D?E(D):v(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=b;function P(k,E){const v=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,D=k.toString().split(`
`);for(const T of D){const R=v.exec(T.trim());R&&R.length===6&&E(parseInt(R[1]),parseInt(R[2]),R[5],parseFloat(R[3]),parseFloat(R[4]))}}});var Re=this&&this.__decorate||function(ie,e,I,t){var b=arguments.length,P=b<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,I):t,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(ie,e,I,t);else for(var E=ie.length-1;E>=0;E--)(k=ie[E])&&(P=(b<3?k(P):b>3?k(e,I,P):k(e,I))||P);return b>3&&P&&Object.defineProperty(e,I,P),P};define(we[39],ye([0,1,17,14,16,20,80,9,6,2,45,15,12]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function d(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(S=e.ResponseType||(e.ResponseType={}));function h(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(g||(g={}));class p{constructor(M){this.buffer=M,this.pos=0}read(M){const j=this.buffer.slice(this.pos,this.pos+M);return this.pos+=j.byteLength,j}}class m{constructor(){this.buffers=[]}get buffer(){return b.VSBuffer.concat(this.buffers)}write(M){this.buffers.push(M)}}var l;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(l||(l={}));function u(F){const M=b.VSBuffer.alloc(4);return M.writeUInt32BE(F,0),M}function n(F){return F.read(4).readUInt32BE(0)}function s(F){const M=b.VSBuffer.alloc(1);return M.writeUInt8(F,0),M}const i={Undefined:s(l.Undefined),String:s(l.String),Buffer:s(l.Buffer),VSBuffer:s(l.VSBuffer),Array:s(l.Array),Object:s(l.Object)},o=typeof Buffer!="undefined";function r(F,M){if(typeof M=="undefined")F.write(i.Undefined);else if(typeof M=="string"){const j=b.VSBuffer.fromString(M);F.write(i.String),F.write(u(j.byteLength)),F.write(j)}else if(o&&Buffer.isBuffer(M)){const j=b.VSBuffer.wrap(M);F.write(i.Buffer),F.write(u(j.byteLength)),F.write(j)}else if(M instanceof b.VSBuffer)F.write(i.VSBuffer),F.write(u(M.byteLength)),F.write(M);else if(Array.isArray(M)){F.write(i.Array),F.write(u(M.length));for(const j of M)r(F,j)}else{const j=b.VSBuffer.fromString(JSON.stringify(M));F.write(i.Object),F.write(u(j.byteLength)),F.write(j)}}function a(F){switch(F.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return F.read(n(F)).toString();case l.Buffer:return F.read(n(F)).buffer;case l.VSBuffer:return F.read(n(F));case l.Array:{const j=n(F),Z=[];for(let oe=0;oe<j;oe++)Z.push(a(F));return Z}case l.Object:return JSON.parse(F.read(n(F)).toString())}}class c{constructor(M,j,Z=null,oe=1e3){this.protocol=M,this.ctx=j,this.logger=Z,this.timeoutDelay=oe,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ge=>this.onRawMessage(ge)),this.sendResponse({type:200})}registerChannel(M,j){this.channels.set(M,j),setTimeout(()=>this.flushPendingRequests(M),0)}sendResponse(M){switch(M.type){case 200:{const j=this.send([M.type]);this.logger?.logOutgoing(j,0,1,h(M.type));return}case 201:case 202:case 204:case 203:{const j=this.send([M.type,M.id],M.data);this.logger?.logOutgoing(j,M.id,1,h(M.type),M.data);return}}}send(M,j=void 0){const Z=new m;return r(Z,M),r(Z,j),this.sendBuffer(Z.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch{return 0}}onRawMessage(M){const j=new p(M),Z=a(j),oe=a(j),ge=Z[0];switch(ge){case 100:return this.logger?.logIncoming(M.byteLength,Z[1],1,`${d(ge)}: ${Z[2]}.${Z[3]}`,oe),this.onPromise({type:ge,id:Z[1],channelName:Z[2],name:Z[3],arg:oe});case 102:return this.logger?.logIncoming(M.byteLength,Z[1],1,`${d(ge)}: ${Z[2]}.${Z[3]}`,oe),this.onEventListen({type:ge,id:Z[1],channelName:Z[2],name:Z[3],arg:oe});case 101:return this.logger?.logIncoming(M.byteLength,Z[1],1,`${d(ge)}`),this.disposeActiveRequest({type:ge,id:Z[1]});case 103:return this.logger?.logIncoming(M.byteLength,Z[1],1,`${d(ge)}`),this.disposeActiveRequest({type:ge,id:Z[1]})}}onPromise(M){const j=this.channels.get(M.channelName);if(!j){this.collectPendingRequest(M);return}const Z=new P.CancellationTokenSource;let oe;try{oe=j.call(this.ctx,M.name,M.arg,Z.token)}catch(q){oe=Promise.reject(q)}const ge=M.id;oe.then(q=>{this.sendResponse({id:ge,data:q,type:201}),this.activeRequests.delete(M.id)},q=>{q instanceof Error?this.sendResponse({id:ge,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.sendResponse({id:ge,data:q,type:203}),this.activeRequests.delete(M.id)});const he=(0,D.toDisposable)(()=>Z.cancel());this.activeRequests.set(M.id,he)}onEventListen(M){const j=this.channels.get(M.channelName);if(!j){this.collectPendingRequest(M);return}const Z=M.id,ge=j.listen(this.ctx,M.name,M.arg)(he=>this.sendResponse({id:Z,data:he,type:204}));this.activeRequests.set(M.id,ge)}disposeActiveRequest(M){const j=this.activeRequests.get(M.id);j&&(j.dispose(),this.activeRequests.delete(M.id))}collectPendingRequest(M){let j=this.pendingRequests.get(M.channelName);j||(j=[],this.pendingRequests.set(M.channelName,j));const Z=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.sendResponse({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:M,timeoutTimer:Z})}flushPendingRequests(M){const j=this.pendingRequests.get(M);if(j){for(const Z of j)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case 100:this.onPromise(Z.request);break;case 102:this.onEventListen(Z.request);break}this.pendingRequests.delete(M)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,D.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=c;var f;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));class w{constructor(M,j=null){this.protocol=M,this.isDisposed=!1,this.state=g.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Z=>this.onBuffer(Z)),this.logger=j}getChannel(M){const j=this;return{call(Z,oe,ge){return j.isDisposed?Promise.reject(E.canceled()):j.requestPromise(M,Z,oe,ge)},listen(Z,oe){return j.isDisposed?v.Event.None:j.requestEvent(M,Z,oe)}}}requestPromise(M,j,Z,oe=P.CancellationToken.None){const ge=this.lastRequestId++,q={id:ge,type:100,channelName:M,name:j,arg:Z};if(oe.isCancellationRequested)return Promise.reject(E.canceled());let ee;return new Promise((z,te)=>{if(oe.isCancellationRequested)return te(E.canceled());const ce=()=>{const X=re=>{switch(re.type){case 201:this.handlers.delete(ge),z(re.data);break;case 202:{this.handlers.delete(ge);const W=new Error(re.data.message);W.stack=re.data.stack,W.name=re.data.name,te(W);break}case 203:this.handlers.delete(ge),te(re.data);break}};this.handlers.set(ge,X),this.sendRequest(q)};let J=null;this.state===g.Idle?ce():(J=(0,t.createCancelablePromise)(X=>this.whenInitialized()),J.then(()=>{J=null,ce()}));const se=()=>{J?(J.cancel(),J=null):this.sendRequest({id:ge,type:101}),te(E.canceled())},me=oe.onCancellationRequested(se);ee=(0,D.combinedDisposable)((0,D.toDisposable)(se),me),this.activeRequests.add(ee)}).finally(()=>{this.activeRequests.delete(ee)})}requestEvent(M,j,Z){const oe=this.lastRequestId++,he={id:oe,type:102,channelName:M,name:j,arg:Z};let q=null;const ee=new v.Emitter({onFirstListenerAdd:()=>{q=(0,t.createCancelablePromise)(z=>this.whenInitialized()),q.then(()=>{q=null,this.activeRequests.add(ee),this.sendRequest(he)})},onLastListenerRemove:()=>{q?(q.cancel(),q=null):(this.activeRequests.delete(ee),this.sendRequest({id:oe,type:103}))}}),G=z=>ee.fire(z.data);return this.handlers.set(oe,G),ee.event}sendRequest(M){switch(M.type){case 100:case 102:{const j=this.send([M.type,M.id,M.channelName,M.name],M.arg);this.logger&&this.logger.logOutgoing(j,M.id,0,`${d(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const j=this.send([M.type,M.id]);this.logger&&this.logger.logOutgoing(j,M.id,0,d(M.type));return}}}send(M,j=void 0){const Z=new m;return r(Z,M),r(Z,j),this.sendBuffer(Z.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch{return 0}}onBuffer(M){const j=new p(M),Z=a(j),oe=a(j),ge=Z[0];switch(ge){case 200:return this.logger&&this.logger.logIncoming(M.byteLength,0,0,h(ge)),this.onResponse({type:Z[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(M.byteLength,Z[1],0,h(ge),oe),this.onResponse({type:Z[0],id:Z[1],data:oe})}}onResponse(M){if(M.type===200){this.state=g.Idle,this._onDidInitialize.fire();return}const j=this.handlers.get(M.id);j&&j(M)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,D.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Re([k.memoize],w.prototype,"onDidInitializePromise",null),e.ChannelClient=w;class A{constructor(M){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,M(({protocol:j,onDidClientDisconnect:Z})=>{v.Event.once(j.onMessage)(ge=>{const he=new p(ge),q=a(he),ee=new c(j,q),G=new w(j);this.channels.forEach((te,ce)=>ee.registerChannel(ce,te));const z={channelServer:ee,channelClient:G,ctx:q};this._connections.add(z),this._onDidAddConnection.fire(z),Z(()=>{ee.dispose(),G.dispose(),this._connections.delete(z),this._onDidRemoveConnection.fire(z)})})})}get connections(){const M=[];return this._connections.forEach(j=>M.push(j)),M}getChannel(M,j){const Z=this;return{call(oe,ge,he){let q;if((0,C.isFunction)(j)){let G=(0,I.getRandomElement)(Z.connections.filter(j));q=G?Promise.resolve(G):v.Event.toPromise(v.Event.filter(Z.onDidAddConnection,j))}else q=j.routeCall(Z,oe,ge);const ee=q.then(G=>G.channelClient.getChannel(M));return x(ee).call(oe,ge,he)},listen(oe,ge){if((0,C.isFunction)(j))return Z.getMulticastEvent(M,j,oe,ge);const he=j.routeEvent(Z,oe,ge).then(q=>q.channelClient.getChannel(M));return x(he).listen(oe,ge)}}}getMulticastEvent(M,j,Z,oe){const ge=this;let he=new D.DisposableStore;const q=new v.Emitter({onFirstListenerAdd:()=>{he=new D.DisposableStore;const ee=new v.EventMultiplexer,G=new Map,z=ce=>{const se=ce.channelClient.getChannel(M).listen(Z,oe),me=ee.add(se);G.set(ce,me)},te=ce=>{const J=G.get(ce);!J||(J.dispose(),G.delete(ce))};ge.connections.filter(j).forEach(z),v.Event.filter(ge.onDidAddConnection,j)(z,void 0,he),ge.onDidRemoveConnection(te,void 0,he),ee.event(q.fire,q,he),he.add(ee)},onLastListenerRemove:()=>{he.dispose()}});return q.event}registerChannel(M,j){this.channels.set(M,j),this._connections.forEach(Z=>{Z.channelServer.registerChannel(M,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class U{constructor(M,j,Z=null){const oe=new m;r(oe,j),M.send(oe.buffer),this.channelClient=new w(M,Z),this.channelServer=new c(M,j,Z)}getChannel(M){return this.channelClient.getChannel(M)}registerChannel(M,j){this.channelServer.registerChannel(M,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=U;function x(F){return{call(M,j,Z){return F.then(oe=>oe.call(M,j,Z))},listen(M,j){const Z=new v.Relay;return F.then(oe=>Z.input=oe.listen(M,j)),Z.event}}}e.getDelayedChannel=x;function Q(F){let M=!1;return{call(j,Z,oe){return M?F.call(j,Z,oe):(0,t.timeout)(0).then(()=>M=!0).then(()=>F.call(j,Z,oe))},listen(j,Z){if(M)return F.listen(j,Z);const oe=new v.Relay;return(0,t.timeout)(0).then(()=>M=!0).then(()=>oe.input=F.listen(j,Z)),oe.event}}}e.getNextTickChannel=Q;class _{constructor(M){this.fn=M}routeCall(M){return this.route(M)}routeEvent(M){return this.route(M)}async route(M){for(const j of M.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await v.Event.toPromise(M.onDidAddConnection),await this.route(M)}}e.StaticRouter=_;var Y;(function(F){function M(ge,he){const q=ge,ee=he&&he.disableMarshalling,G=new Map;for(const z in q)Z(z)&&G.set(z,v.Event.buffer(q[z],!0));return new class{listen(z,te,ce){const J=G.get(te);if(J)return J;if(oe(te)){const se=q[te];if(typeof se=="function")return se.call(q,ce)}throw new Error(`Event not found: ${te}`)}call(z,te,ce){const J=q[te];if(typeof J=="function"){if(!ee&&Array.isArray(ce))for(let se=0;se<ce.length;se++)ce[se]=(0,T.revive)(ce[se]);return J.apply(q,ce)}throw new Error(`Method not found: ${te}`)}}}F.fromService=M;function j(ge,he){const q=he&&he.disableMarshalling;return new Proxy({},{get(ee,G){if(typeof G=="string")return he?.properties?.has(G)?he.properties.get(G):oe(G)?function(z){return ge.listen(G,z)}:Z(G)?ge.listen(G):async function(...z){let te;he&&!(0,C.isUndefinedOrNull)(he.context)?te=[he.context,...z]:te=z;const ce=await ge.call(G,te);return q?ce:(0,T.revive)(ce)};throw new Error(`Property not found: ${String(G)}`)}})}F.toService=j;function Z(ge){return ge[0]==="o"&&ge[1]==="n"&&R.isUpperAsciiLetter(ge.charCodeAt(2))}function oe(ge){return/^onDynamic/.test(ge)&&R.isUpperAsciiLetter(ge.charCodeAt(9))}})(Y=e.ProxyChannel||(e.ProxyChannel={}));const O=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function B(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let M=F.toString();if(M!=="[object Object]")return M}return F}function ue(F){return Array.isArray(F)?F.map(B):B(F)}function V(F,M,j,Z,oe,ge,he){he=ue(he);const q=O[oe],ee=q[Z%q.length];let G=[`%c[${F}]%c[${String(M).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${ge}`,"color: darkgreen","color: grey","color: grey",`color: ${ee}`];/\($/.test(ge)?(G=G.concat(he),G.push(")")):G.push(he),console.log.apply(console,G)}e.logWithColors=V;class ${constructor(M,j){this._outgoingPrefix=M,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(M,j,Z,oe,ge){this._totalOutgoing+=M,V(this._outgoingPrefix,this._totalOutgoing,M,j,Z,oe,ge)}logIncoming(M,j,Z,oe,ge){this._totalIncoming+=M,V(this._incomingPrefix,this._totalIncoming,M,j,Z,oe,ge)}}e.IPCLogger=$}),define(we[90],ye([0,1,16,6,2,39]),function(ie,e,I,t,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(o){o.Created="created",o.Read="read",o.Write="write",o.Open="open",o.Error="error",o.Close="close",o.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",o.NodeEndReceived="nodeEndReceived",o.NodeEndSent="nodeEndSent",o.NodeDrainBegin="nodeDrainBegin",o.NodeDrainEnd="nodeDrainEnd",o.zlibInflateError="zlibInflateError",o.zlibInflateData="zlibInflateData",o.zlibInflateInitialWrite="zlibInflateInitialWrite",o.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",o.zlibInflateWrite="zlibInflateWrite",o.zlibInflateFlushFired="zlibInflateFlushFired",o.zlibDeflateError="zlibDeflateError",o.zlibDeflateData="zlibDeflateData",o.zlibDeflateWrite="zlibDeflateWrite",o.zlibDeflateFlushFired="zlibDeflateFlushFired",o.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",o.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",o.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",o.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",o.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",o.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",o.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",o.ProtocolHeaderRead="protocolHeaderRead",o.ProtocolMessageRead="protocolMessageRead",o.ProtocolHeaderWrite="protocolHeaderWrite",o.ProtocolMessageWrite="protocolMessageWrite",o.ProtocolWrite="protocolWrite"})(k=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var E;(function(o){o.enableDiagnostics=!1,o.records=[];const r=new WeakMap;let a=0;function c(w,A){if(!r.has(w)){const U=String(++a);r.set(w,U)}return r.get(w)}function f(w,A,U,x){if(!o.enableDiagnostics)return;const Q=c(w,A);if(x instanceof I.VSBuffer||x instanceof Uint8Array||x instanceof ArrayBuffer||ArrayBuffer.isView(x)){const _=I.VSBuffer.alloc(x.byteLength);_.set(x),o.records.push({timestamp:Date.now(),id:Q,label:A,type:U,buff:_})}else o.records.push({timestamp:Date.now(),id:Q,label:A,type:U,data:x})}o.traceSocketEvent=f})(E=e.SocketDiagnostics||(e.SocketDiagnostics={}));var v;(function(o){o[o.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",o[o.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(v=e.SocketCloseEventType||(e.SocketCloseEventType={}));let D=null;function T(){return D||(D=I.VSBuffer.alloc(0)),D}class R{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,a){if(r===0)return T();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const A=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=r),A}if(this._chunks[0].byteLength>r){const A=this._chunks[0].slice(0,r);return a&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),A}let c=I.VSBuffer.alloc(r),f=0,w=0;for(;r>0;){const A=this._chunks[w];if(A.byteLength>r){const U=A.slice(0,r);c.set(U,f),f+=r,a&&(this._chunks[w]=A.slice(r),this._totalLength-=r),r-=r}else c.set(A,f),f+=A.byteLength,a?(this._chunks.shift(),this._totalLength-=A.byteLength):w++,r-=A.byteLength}return c}}e.ChunkStream=R;var C;(function(o){o[o.None=0]="None",o[o.Regular=1]="Regular",o[o.Control=2]="Control",o[o.Ack=3]="Ack",o[o.Disconnect=5]="Disconnect",o[o.ReplayRequest=6]="ReplayRequest",o[o.Pause=7]="Pause",o[o.Resume=8]="Resume"})(C||(C={}));function y(o){switch(o){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var d;(function(o){o[o.HeaderLength=13]="HeaderLength",o[o.AcknowledgeTime=2e3]="AcknowledgeTime",o[o.TimeoutTime=2e4]="TimeoutTime",o[o.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",o[o.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class S{constructor(r,a,c,f){this.type=r,this.id=a,this.ack=c,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends b.Disposable{constructor(r){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new R,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:y(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const c=this._state.messageType,f=this._state.id,w=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",a),this._onMessage.fire(new S(c,f,w,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class g{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=I.VSBuffer.alloc(13);a.writeUInt8(r.type,0),a.writeUInt32BE(r.id,1),a.writeUInt32BE(r.ack,5),a.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:y(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(a,r.data)}_bufferAdd(r,a){const c=this._totalLength===0;return this._data.push(r,a),this._totalLength+=r.byteLength+a.byteLength,c}_bufferTake(){const r=I.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,a){this._bufferAdd(r,a)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class p extends b.Disposable{constructor(r){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new g(this._socket)),this._socketReader=this._register(new h(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new S(1,0,0,r))}}e.Protocol=p;class m extends P.IPCClient{constructor(r,a,c=null){super(r,a,c);this.protocol=r}static fromSocket(r,a){return new m(new p(r),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=m;class l{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=l;class u{constructor(r){this.data=r,this.next=null}}class n{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],a=0,c=this._first;for(;c;)r[a++]=c.data,c=c.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const a=new u(r);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class s{constructor(){this.lastRuns=[];const r=Date.now();for(let a=0;a<s._HISTORY_LENGTH;a++)this.lastRuns[a]=r-1e3*a;setInterval(()=>{for(let a=s._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return s._INSTANCE||(s._INSTANCE=new s),s._INSTANCE}load(){const r=Date.now(),a=(1+s._HISTORY_LENGTH)*1e3;let c=0;for(let f=0;f<s._HISTORY_LENGTH;f++)r-this.lastRuns[f]<=a&&c++;return 1-c/s._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}s._HISTORY_LENGTH=10,s._INSTANCE=null;class i{constructor(r,a=null,c=s.getInstance()){this._onControlMessage=new l,this.onControlMessage=this._onControlMessage.event,this._onMessage=new l,this.onMessage=this._onMessage.event,this._onDidDispose=new l,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new l,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new l,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new n,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new h(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),a&&this._socketReader.acceptChunk(a)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,b.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new S(5,0,0,T());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new S(7,0,0,T());this._socketWriter.write(r)}sendResume(){const r=new S(8,0,0,T());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,a){this._isReconnecting=!0,this._socketDisposables=(0,b.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new h(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new S(3,0,this._incomingAckId,T());this._socketWriter.write(r);const a=this._outgoingUnackMsg.toArray();for(let c=0,f=a.length;c<f;c++)this._socketWriter.write(a[c]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new S(6,0,0,T())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const a=this._outgoingUnackMsg.toArray();for(let c=0,f=a.length;c<f;c++)this._socketWriter.write(a[c]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new S(1,a,this._incomingAckId,r);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(r){const a=new S(2,0,0,r);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),a=Date.now()-r.writtenTime,c=Date.now()-this._socketReader.lastReadTime,f=Date.now()-this._lastSocketTimeoutTime;if(a>=2e4&&c>=2e4&&f>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const w=Math.max(2e4-a,2e4-c,2e4-f,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},w)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new S(3,0,this._incomingAckId,T());this._socketWriter.write(r)}}e.PersistentProtocol=i}),define(we[144],ye([0,1,14,6,2,12]),function(ie,e,I,t,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(R){R[R.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));function E(R){const C=R;return C?.changed instanceof Map||C?.deleted instanceof Set}e.isStorageItemsChangeEvent=E;var v;(function(R){R[R.None=0]="None",R[R.Initialized=1]="Initialized",R[R.Closed=2]="Closed"})(v=e.StorageState||(e.StorageState={}));class D extends b.Disposable{constructor(C,y=Object.create(null)){super();this.database=C,this.options=y,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=v.None,this.cache=new Map,this.flushDelayer=new I.ThrottledDelayer(D.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(C=>this.onDidChangeItemsExternal(C)))}onDidChangeItemsExternal(C){C.changed?.forEach((y,d)=>this.accept(d,y)),C.deleted?.forEach(y=>this.accept(y,void 0))}accept(C,y){if(this.state===v.Closed)return;let d=!1;(0,P.isUndefinedOrNull)(y)?d=this.cache.delete(C):this.cache.get(C)!==y&&(this.cache.set(C,y),d=!0),d&&this._onDidChangeStorage.fire(C)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===v.None&&(this.state=v.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(C,y){const d=this.cache.get(C);return(0,P.isUndefinedOrNull)(d)?y:d}getBoolean(C,y){const d=this.get(C);return(0,P.isUndefinedOrNull)(d)?y:d==="true"}getNumber(C,y){const d=this.get(C);return(0,P.isUndefinedOrNull)(d)?y:parseInt(d,10)}async set(C,y){if(this.state===v.Closed)return;if((0,P.isUndefinedOrNull)(y))return this.delete(C);const d=String(y);if(this.cache.get(C)!==d)return this.cache.set(C,d),this.pendingInserts.set(C,d),this.pendingDeletes.delete(C),this._onDidChangeStorage.fire(C),this.doFlush()}async delete(C){if(!(this.state===v.Closed||!this.cache.delete(C)))return this.pendingDeletes.has(C)||this.pendingDeletes.add(C),this.pendingInserts.delete(C),this._onDidChangeStorage.fire(C),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=v.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const C={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(C).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(C){if(!!this.hasPending)return this.doFlush(C)}async doFlush(C){return this.flushDelayer.trigger(()=>this.flushPending(),C)}async whenFlushed(){if(!!this.hasPending)return new Promise(C=>this.whenFlushedCallbacks.push(C))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=D,D.DEFAULT_FLUSH_DELAY=100;class T{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(C){C.insert&&C.insert.forEach((y,d)=>this.items.set(d,y)),C.delete&&C.delete.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=T}),define(we[91],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class I{constructor(b,P){this.lineNumber=b,this.column=P}with(b=this.lineNumber,P=this.column){return b===this.lineNumber&&P===this.column?this:new I(b,P)}delta(b=0,P=0){return this.with(this.lineNumber+b,this.column+P)}equals(b){return I.equals(this,b)}static equals(b,P){return!b&&!P?!0:!!b&&!!P&&b.lineNumber===P.lineNumber&&b.column===P.column}isBefore(b){return I.isBefore(this,b)}static isBefore(b,P){return b.lineNumber<P.lineNumber?!0:P.lineNumber<b.lineNumber?!1:b.column<P.column}isBeforeOrEqual(b){return I.isBeforeOrEqual(this,b)}static isBeforeOrEqual(b,P){return b.lineNumber<P.lineNumber?!0:P.lineNumber<b.lineNumber?!1:b.column<=P.column}static compare(b,P){const k=b.lineNumber|0,E=P.lineNumber|0;if(k===E){const v=b.column|0,D=P.column|0;return v-D}return k-E}clone(){return new I(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(b){return new I(b.lineNumber,b.column)}static isIPosition(b){return b&&typeof b.lineNumber=="number"&&typeof b.column=="number"}}e.Position=I}),define(we[47],ye([0,1,91]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(P,k,E,v){P>E||P===E&&k>v?(this.startLineNumber=E,this.startColumn=v,this.endLineNumber=P,this.endColumn=k):(this.startLineNumber=P,this.startColumn=k,this.endLineNumber=E,this.endColumn=v)}isEmpty(){return t.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return t.containsPosition(this,P)}static containsPosition(P,k){return!(k.lineNumber<P.startLineNumber||k.lineNumber>P.endLineNumber||k.lineNumber===P.startLineNumber&&k.column<P.startColumn||k.lineNumber===P.endLineNumber&&k.column>P.endColumn)}static strictContainsPosition(P,k){return!(k.lineNumber<P.startLineNumber||k.lineNumber>P.endLineNumber||k.lineNumber===P.startLineNumber&&k.column<=P.startColumn||k.lineNumber===P.endLineNumber&&k.column>=P.endColumn)}containsRange(P){return t.containsRange(this,P)}static containsRange(P,k){return!(k.startLineNumber<P.startLineNumber||k.endLineNumber<P.startLineNumber||k.startLineNumber>P.endLineNumber||k.endLineNumber>P.endLineNumber||k.startLineNumber===P.startLineNumber&&k.startColumn<P.startColumn||k.endLineNumber===P.endLineNumber&&k.endColumn>P.endColumn)}strictContainsRange(P){return t.strictContainsRange(this,P)}static strictContainsRange(P,k){return!(k.startLineNumber<P.startLineNumber||k.endLineNumber<P.startLineNumber||k.startLineNumber>P.endLineNumber||k.endLineNumber>P.endLineNumber||k.startLineNumber===P.startLineNumber&&k.startColumn<=P.startColumn||k.endLineNumber===P.endLineNumber&&k.endColumn>=P.endColumn)}plusRange(P){return t.plusRange(this,P)}static plusRange(P,k){let E,v,D,T;return k.startLineNumber<P.startLineNumber?(E=k.startLineNumber,v=k.startColumn):k.startLineNumber===P.startLineNumber?(E=k.startLineNumber,v=Math.min(k.startColumn,P.startColumn)):(E=P.startLineNumber,v=P.startColumn),k.endLineNumber>P.endLineNumber?(D=k.endLineNumber,T=k.endColumn):k.endLineNumber===P.endLineNumber?(D=k.endLineNumber,T=Math.max(k.endColumn,P.endColumn)):(D=P.endLineNumber,T=P.endColumn),new t(E,v,D,T)}intersectRanges(P){return t.intersectRanges(this,P)}static intersectRanges(P,k){let E=P.startLineNumber,v=P.startColumn,D=P.endLineNumber,T=P.endColumn,R=k.startLineNumber,C=k.startColumn,y=k.endLineNumber,d=k.endColumn;return E<R?(E=R,v=C):E===R&&(v=Math.max(v,C)),D>y?(D=y,T=d):D===y&&(T=Math.min(T,d)),E>D||E===D&&v>T?null:new t(E,v,D,T)}equalsRange(P){return t.equalsRange(this,P)}static equalsRange(P,k){return!!P&&!!k&&P.startLineNumber===k.startLineNumber&&P.startColumn===k.startColumn&&P.endLineNumber===k.endLineNumber&&P.endColumn===k.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(P){return new I.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(P){return new I.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,k){return new t(this.startLineNumber,this.startColumn,P,k)}setStartPosition(P,k){return new t(P,k,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(P){return new t(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}static fromPositions(P,k=P){return new t(P.lineNumber,P.column,k.lineNumber,k.column)}static lift(P){return P?new t(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,k){return!(P.endLineNumber<k.startLineNumber||P.endLineNumber===k.startLineNumber&&P.endColumn<k.startColumn||k.endLineNumber<P.startLineNumber||k.endLineNumber===P.startLineNumber&&k.endColumn<P.startColumn)}static areIntersecting(P,k){return!(P.endLineNumber<k.startLineNumber||P.endLineNumber===k.startLineNumber&&P.endColumn<=k.startColumn||k.endLineNumber<P.startLineNumber||k.endLineNumber===P.startLineNumber&&k.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,k){if(P&&k){const D=P.startLineNumber|0,T=k.startLineNumber|0;if(D===T){const R=P.startColumn|0,C=k.startColumn|0;if(R===C){const y=P.endLineNumber|0,d=k.endLineNumber|0;if(y===d){const S=P.endColumn|0,h=k.endColumn|0;return S-h}return y-d}return R-C}return D-T}return(P?1:0)-(k?1:0)}static compareRangesUsingEnds(P,k){return P.endLineNumber===k.endLineNumber?P.endColumn===k.endColumn?P.startLineNumber===k.startLineNumber?P.startColumn-k.startColumn:P.startLineNumber-k.startLineNumber:P.endColumn-k.endColumn:P.endLineNumber-k.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.Range=t}),define(we[145],ye([0,1,6,2]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class b{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(E){this._onDidChange.fire({changedLanguages:E,changedColorMap:!1})}register(E,v){return this._map.set(E,v),this.fire([E]),(0,t.toDisposable)(()=>{this._map.get(E)===v&&(this._map.delete(E),this.fire([E]))})}registerFactory(E,v){this._factories.get(E)?.dispose();const D=new P(this,E,v);return this._factories.set(E,D),(0,t.toDisposable)(()=>{const T=this._factories.get(E);!T||T!==D||(this._factories.delete(E),T.dispose())})}async getOrCreate(E){const v=this.get(E);if(v)return v;const D=this._factories.get(E);return!D||D.isResolved?null:(await D.resolve(),this.get(E))}get(E){return this._map.get(E)||null}isResolved(E){if(this.get(E))return!0;const D=this._factories.get(E);return!!(!D||D.isResolved)}setColorMap(E){this._colorMap=E,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=b;class P extends t.Disposable{constructor(E,v,D){super();this._registry=E,this._languageId=v,this._factory=D,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const E=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,E&&!this._isDisposed&&this._register(this._registry.register(this._languageId,E))}}}),define(we[146],ye([0,1,37,4,47,145]),function(ie,e,I,t,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class k{constructor(w,A,U){this._tokenBrand=void 0,this.offset=w,this.type=A,this.language=U}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=k;class E{constructor(w,A){this._tokenizationResultBrand=void 0,this.tokens=w,this.endState=A}}e.TokenizationResult=E;class v{constructor(w,A){this._encodedTokenizationResultBrand=void 0,this.tokens=w,this.endState=A}}e.EncodedTokenizationResult=v;var D;(function(f){f[f.Method=0]="Method",f[f.Function=1]="Function",f[f.Constructor=2]="Constructor",f[f.Field=3]="Field",f[f.Variable=4]="Variable",f[f.Class=5]="Class",f[f.Struct=6]="Struct",f[f.Interface=7]="Interface",f[f.Module=8]="Module",f[f.Property=9]="Property",f[f.Event=10]="Event",f[f.Operator=11]="Operator",f[f.Unit=12]="Unit",f[f.Value=13]="Value",f[f.Constant=14]="Constant",f[f.Enum=15]="Enum",f[f.EnumMember=16]="EnumMember",f[f.Keyword=17]="Keyword",f[f.Text=18]="Text",f[f.Color=19]="Color",f[f.File=20]="File",f[f.Reference=21]="Reference",f[f.Customcolor=22]="Customcolor",f[f.Folder=23]="Folder",f[f.TypeParameter=24]="TypeParameter",f[f.User=25]="User",f[f.Issue=26]="Issue",f[f.Snippet=27]="Snippet"})(D=e.CompletionItemKind||(e.CompletionItemKind={}));var T;(function(f){const w=new Map;w.set(0,I.Codicon.symbolMethod),w.set(1,I.Codicon.symbolFunction),w.set(2,I.Codicon.symbolConstructor),w.set(3,I.Codicon.symbolField),w.set(4,I.Codicon.symbolVariable),w.set(5,I.Codicon.symbolClass),w.set(6,I.Codicon.symbolStruct),w.set(7,I.Codicon.symbolInterface),w.set(8,I.Codicon.symbolModule),w.set(9,I.Codicon.symbolProperty),w.set(10,I.Codicon.symbolEvent),w.set(11,I.Codicon.symbolOperator),w.set(12,I.Codicon.symbolUnit),w.set(13,I.Codicon.symbolValue),w.set(15,I.Codicon.symbolEnum),w.set(14,I.Codicon.symbolConstant),w.set(15,I.Codicon.symbolEnum),w.set(16,I.Codicon.symbolEnumMember),w.set(17,I.Codicon.symbolKeyword),w.set(27,I.Codicon.symbolSnippet),w.set(18,I.Codicon.symbolText),w.set(19,I.Codicon.symbolColor),w.set(20,I.Codicon.symbolFile),w.set(21,I.Codicon.symbolReference),w.set(22,I.Codicon.symbolCustomColor),w.set(23,I.Codicon.symbolFolder),w.set(24,I.Codicon.symbolTypeParameter),w.set(25,I.Codicon.account),w.set(26,I.Codicon.issues);function A(Q){let _=w.get(Q);return _||(console.info("No codicon found for CompletionItemKind "+Q),_=I.Codicon.symbolProperty),_}f.toIcon=A;const U=new Map;U.set("method",0),U.set("function",1),U.set("constructor",2),U.set("field",3),U.set("variable",4),U.set("class",5),U.set("struct",6),U.set("interface",7),U.set("module",8),U.set("property",9),U.set("event",10),U.set("operator",11),U.set("unit",12),U.set("value",13),U.set("constant",14),U.set("enum",15),U.set("enum-member",16),U.set("enumMember",16),U.set("keyword",17),U.set("snippet",27),U.set("text",18),U.set("color",19),U.set("file",20),U.set("reference",21),U.set("customcolor",22),U.set("folder",23),U.set("type-parameter",24),U.set("typeParameter",24),U.set("account",25),U.set("issue",26);function x(Q,_){let Y=U.get(Q);return typeof Y=="undefined"&&!_&&(Y=9),Y}f.fromString=x})(T=e.CompletionItemKinds||(e.CompletionItemKinds={}));var R;(function(f){f[f.Deprecated=1]="Deprecated"})(R=e.CompletionItemTag||(e.CompletionItemTag={}));var C;(function(f){f[f.KeepWhitespace=1]="KeepWhitespace",f[f.InsertAsSnippet=4]="InsertAsSnippet"})(C=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var y;(function(f){f[f.Invoke=0]="Invoke",f[f.TriggerCharacter=1]="TriggerCharacter",f[f.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(y=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var d;(function(f){f[f.Automatic=0]="Automatic",f[f.Explicit=1]="Explicit"})(d=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var S;(function(f){f[f.Invoke=1]="Invoke",f[f.Auto=2]="Auto"})(S=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var h;(function(f){f[f.Invoke=1]="Invoke",f[f.TriggerCharacter=2]="TriggerCharacter",f[f.ContentChange=3]="ContentChange"})(h=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var g;(function(f){f[f.Text=0]="Text",f[f.Read=1]="Read",f[f.Write=2]="Write"})(g=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function p(f){return f&&t.URI.isUri(f.uri)&&b.Range.isIRange(f.range)&&(b.Range.isIRange(f.originSelectionRange)||b.Range.isIRange(f.targetSelectionRange))}e.isLocationLink=p;var m;(function(f){f[f.File=0]="File",f[f.Module=1]="Module",f[f.Namespace=2]="Namespace",f[f.Package=3]="Package",f[f.Class=4]="Class",f[f.Method=5]="Method",f[f.Property=6]="Property",f[f.Field=7]="Field",f[f.Constructor=8]="Constructor",f[f.Enum=9]="Enum",f[f.Interface=10]="Interface",f[f.Function=11]="Function",f[f.Variable=12]="Variable",f[f.Constant=13]="Constant",f[f.String=14]="String",f[f.Number=15]="Number",f[f.Boolean=16]="Boolean",f[f.Array=17]="Array",f[f.Object=18]="Object",f[f.Key=19]="Key",f[f.Null=20]="Null",f[f.EnumMember=21]="EnumMember",f[f.Struct=22]="Struct",f[f.Event=23]="Event",f[f.Operator=24]="Operator",f[f.TypeParameter=25]="TypeParameter"})(m=e.SymbolKind||(e.SymbolKind={}));var l;(function(f){f[f.Deprecated=1]="Deprecated"})(l=e.SymbolTag||(e.SymbolTag={}));var u;(function(f){const w=new Map;w.set(0,I.Codicon.symbolFile),w.set(1,I.Codicon.symbolModule),w.set(2,I.Codicon.symbolNamespace),w.set(3,I.Codicon.symbolPackage),w.set(4,I.Codicon.symbolClass),w.set(5,I.Codicon.symbolMethod),w.set(6,I.Codicon.symbolProperty),w.set(7,I.Codicon.symbolField),w.set(8,I.Codicon.symbolConstructor),w.set(9,I.Codicon.symbolEnum),w.set(10,I.Codicon.symbolInterface),w.set(11,I.Codicon.symbolFunction),w.set(12,I.Codicon.symbolVariable),w.set(13,I.Codicon.symbolConstant),w.set(14,I.Codicon.symbolString),w.set(15,I.Codicon.symbolNumber),w.set(16,I.Codicon.symbolBoolean),w.set(17,I.Codicon.symbolArray),w.set(18,I.Codicon.symbolObject),w.set(19,I.Codicon.symbolKey),w.set(20,I.Codicon.symbolNull),w.set(21,I.Codicon.symbolEnumMember),w.set(22,I.Codicon.symbolStruct),w.set(23,I.Codicon.symbolEvent),w.set(24,I.Codicon.symbolOperator),w.set(25,I.Codicon.symbolTypeParameter);function A(U){let x=w.get(U);return x||(console.info("No codicon found for SymbolKind "+U),x=I.Codicon.symbolProperty),x}f.toIcon=A})(u=e.SymbolKinds||(e.SymbolKinds={}));class n{constructor(w){this.value=w}}e.FoldingRangeKind=n,n.Comment=new n("comment"),n.Imports=new n("imports"),n.Region=new n("region");var s;(function(f){function w(A){return!A||typeof A!="object"?!1:typeof A.id=="string"&&typeof A.title=="string"}f.is=w})(s=e.Command||(e.Command={}));var i;(function(f){f[f.Collapsed=0]="Collapsed",f[f.Expanded=1]="Expanded"})(i=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var o;(function(f){f[f.Unresolved=0]="Unresolved",f[f.Resolved=1]="Resolved"})(o=e.CommentThreadState||(e.CommentThreadState={}));var r;(function(f){f[f.Editing=0]="Editing",f[f.Preview=1]="Preview"})(r=e.CommentMode||(e.CommentMode={}));var a;(function(f){f[f.Type=1]="Type",f[f.Parameter=2]="Parameter"})(a=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new P.TokenizationRegistry;var c;(function(f){f[f.None=0]="None",f[f.Option=1]="Option",f[f.Default=2]="Default",f[f.Preferred=3]="Preferred"})(c=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[147],ye([10,11]),function(ie,e){return ie.create("vs/base/common/date",e)}),define(we[148],ye([0,1,147]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,b=t*60,P=b*24,k=P*7,E=P*30,v=P*365;function D(R,C,y){typeof R!="number"&&(R=R.getTime());const d=Math.round((new Date().getTime()-R)/1e3);if(d<-30)return(0,I.localize)(0,null,D(new Date().getTime()+d*1e3,!1));if(d<30)return(0,I.localize)(1,null);let S;return d<t?(S=d,C?S===1?y?(0,I.localize)(2,null,S):(0,I.localize)(3,null,S):y?(0,I.localize)(4,null,S):(0,I.localize)(5,null,S):S===1?y?(0,I.localize)(6,null,S):(0,I.localize)(7,null,S):y?(0,I.localize)(8,null,S):(0,I.localize)(9,null,S)):d<b?(S=Math.floor(d/t),C?S===1?y?(0,I.localize)(10,null,S):(0,I.localize)(11,null,S):y?(0,I.localize)(12,null,S):(0,I.localize)(13,null,S):S===1?y?(0,I.localize)(14,null,S):(0,I.localize)(15,null,S):y?(0,I.localize)(16,null,S):(0,I.localize)(17,null,S)):d<P?(S=Math.floor(d/b),C?S===1?y?(0,I.localize)(18,null,S):(0,I.localize)(19,null,S):y?(0,I.localize)(20,null,S):(0,I.localize)(21,null,S):S===1?y?(0,I.localize)(22,null,S):(0,I.localize)(23,null,S):y?(0,I.localize)(24,null,S):(0,I.localize)(25,null,S)):d<k?(S=Math.floor(d/P),C?S===1?(0,I.localize)(26,null,S):(0,I.localize)(27,null,S):S===1?(0,I.localize)(28,null,S):(0,I.localize)(29,null,S)):d<E?(S=Math.floor(d/k),C?S===1?y?(0,I.localize)(30,null,S):(0,I.localize)(31,null,S):y?(0,I.localize)(32,null,S):(0,I.localize)(33,null,S):S===1?y?(0,I.localize)(34,null,S):(0,I.localize)(35,null,S):y?(0,I.localize)(36,null,S):(0,I.localize)(37,null,S)):d<v?(S=Math.floor(d/E),C?S===1?y?(0,I.localize)(38,null,S):(0,I.localize)(39,null,S):y?(0,I.localize)(40,null,S):(0,I.localize)(41,null,S):S===1?y?(0,I.localize)(42,null,S):(0,I.localize)(43,null,S):y?(0,I.localize)(44,null,S):(0,I.localize)(45,null,S)):(S=Math.floor(d/v),C?S===1?y?(0,I.localize)(46,null,S):(0,I.localize)(47,null,S):y?(0,I.localize)(48,null,S):(0,I.localize)(49,null,S):S===1?y?(0,I.localize)(50,null,S):(0,I.localize)(51,null,S):y?(0,I.localize)(52,null,S):(0,I.localize)(53,null,S))}e.fromNow=D;function T(R){return R.getFullYear()+"-"+String(R.getMonth()+1).padStart(2,"0")+"-"+String(R.getDate()).padStart(2,"0")+"T"+String(R.getHours()).padStart(2,"0")+":"+String(R.getMinutes()).padStart(2,"0")+":"+String(R.getSeconds()).padStart(2,"0")+"."+(R.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=T}),define(we[149],ye([10,11]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(we[36],ye([0,1,17,12,149]),function(ie,e,I,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function P(R,C){return C&&(R.stack||R.stacktrace)?b.localize(0,null,E(R),k(R.stack)||k(R.stacktrace)):E(R)}function k(R){return Array.isArray(R)?R.join(`
`):R}function E(R){return typeof R.code=="string"&&typeof R.errno=="number"&&typeof R.syscall=="string"?b.localize(1,null,R.message):R.message||b.localize(2,null)}function v(R=null,C=!1){if(!R)return b.localize(3,null);if(Array.isArray(R)){const y=I.coalesce(R),d=v(y[0],C);return y.length>1?b.localize(4,null,d,y.length):d}if(t.isString(R))return R;if(R.detail){const y=R.detail;if(y.error)return P(y.error,C);if(y.exception)return P(y.exception,C)}return R.stack?P(R,C):R.message?R.message:b.localize(5,null)}e.toErrorMessage=v;function D(R){const C=R;return C instanceof Error&&Array.isArray(C.actions)}e.isErrorWithActions=D;function T(R,C){let y;return typeof R=="string"?y=new Error(R):y=R,y.actions=C,y}e.createErrorWithActions=T}),define(we[150],ye([10,11]),function(ie,e){return ie.create("vs/base/common/jsonErrorMessages",e)}),define(we[151],ye([0,1,150]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(b){switch(b){case 1:return(0,I.localize)(0,null);case 2:return(0,I.localize)(1,null);case 3:return(0,I.localize)(2,null);case 4:return(0,I.localize)(3,null);case 5:return(0,I.localize)(4,null);case 6:return(0,I.localize)(5,null);case 7:return(0,I.localize)(6,null);case 8:return(0,I.localize)(7,null);case 9:return(0,I.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(we[152],ye([10,11]),function(ie,e){return ie.create("vs/base/node/processes",e)}),define(we[92],ye([0,1,38,33,8,21,5,3,26,53,12,139,22,152]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function d(u){switch(u){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function S(u,n){if(E.isWindows)try{const s={stdio:["pipe","pipe","ignore"]};n&&(s.cwd=n);const i=I.execFile("taskkill",["/T","/F","/PID",u.pid.toString()],s);return new Promise(o=>{i.once("error",r=>{o({success:!1,error:r})}),i.once("exit",(r,a)=>{o(r===0?{success:!0}:{success:!1,code:r!==null?r:1})})})}catch(s){return Promise.resolve({success:!1,error:s,code:s.status?d(s.status):1})}else if(E.isLinux||E.isMacintosh)try{const s=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",ie).fsPath;return new Promise(i=>{I.execFile(s,[u.pid.toString()],{encoding:"utf8",shell:!0},(o,r,a)=>{i(o?{success:!1,error:o}:{success:!0})})})}catch(s){return Promise.resolve({success:!1,error:s})}else u.kill("SIGKILL");return Promise.resolve({success:!0})}function h(u=v.env){return u.comspec||"cmd.exe"}e.getWindowsShell=h;class g{constructor(n,s,i,o){if(s!==void 0&&i!==void 0&&o!==void 0)this.cmd=n,this.args=s,this.shell=i,this.options=o;else{const r=n;this.cmd=r.command,this.shell=r.isShellCommand,this.args=r.args.slice(0),this.options=r.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const r=Object.create(null);Object.keys(v.env).forEach(a=>{r[a]=v.env[a]}),Object.keys(this.options.env).forEach(a=>{r[a]=this.options.env[a]}),this.options.env=r}}getSanitizedCommand(){let n=this.cmd.toLowerCase();const s=n.lastIndexOf(k.sep);return s!==-1&&(n=n.substring(s+1)),g.WellKnowCommands[n]?n:"other"}start(n){return E.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(v.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(s=>{let i,o;const r=new Promise((a,c)=>{i=a,o=c});if(s){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=I.exec(a,this.options,(c,f,w)=>{this.childProcess=null;const A=c;A&&A.killed?o({killed:this.terminateRequested,stdout:f.toString(),stderr:w.toString()}):this.handleExec(i,n,c,f,w)})}else{let a=null;const c=f=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(f,i,n,o);const w={terminated:this.terminateRequested};T.isNumber(f)&&(w.cmdCode=f),i(w)};if(this.shell&&E.isWindows){const f=P.deepClone(this.options);f.windowsVerbatimArguments=!0,f.detached=!1;let w=!1,A=!1;const U=[];let x=this.ensureQuotes(this.cmd);U.push(x.value),w=x.quoted,this.args&&this.args.forEach(_=>{x=this.ensureQuotes(_),U.push(x.value),A=A&&x.quoted});const Q=["/s","/c"];w?A?Q.push('"'+U.join(" ")+'"'):U.length>1?Q.push('"'+U[0]+'" '+U.slice(1).join(" ")):Q.push('"'+U[0]+'"'):Q.push(U.join(" ")),a=I.spawn(h(),Q,f)}else this.cmd&&(a=I.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(T.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",f=>{this.childProcess=null,o({terminated:this.terminateRequested,error:f})}),a.pid&&(this.childProcess.on("close",c),this.handleSpawn(a,i,n,o,!0)))}return r})}handleClose(n,s,i,o){}ensureQuotes(n){return g.regexp.test(n)?{value:'"'+n+'"',quoted:!0}:{value:n,quoted:n.length>0&&n[0]==='"'&&n[n.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(n=>n.pid,n=>-1):new Promise(n=>{this.pidResolve=n})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(n=>(this.terminateRequested=!0,S(n,this.options.cwd).then(s=>(s.success&&(this.childProcess=null),s))),n=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(n=>{if(!this.shell||!E.isWindows)return n(!1);const s=I.spawn(h(),["/s","/c"]);s.on("error",i=>n(!0)),s.on("exit",i=>n(!1))})}}e.AbstractProcess=g,g.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},g.regexp=/^[^"].* .*[^"]/;class p extends g{constructor(n,s,i,o){super(n,s,i,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(n,s,i,o,r){[o,r].forEach((a,c)=>{const f=new R.LineDecoder;f.write(a).forEach(U=>{s({line:U,source:c===0?0:1})});const A=f.end();A&&s({line:A,source:c===0?0:1})}),n({terminated:this.terminateRequested,error:i})}handleSpawn(n,s,i,o,r){const a=new R.LineDecoder,c=new R.LineDecoder;n.stdout.on("data",f=>{a.write(f).forEach(A=>i({line:A,source:0}))}),n.stderr.on("data",f=>{c.write(f).forEach(A=>i({line:A,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=c}handleClose(n,s,i,o){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&i({line:r,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&i({line:a,source:1})}}e.LineProcess=p;function m(u){let n=[],s=!1;const i=function(o){if(s){n.push(o);return}(!u.send(o,a=>{if(a&&console.error(a),s=!1,n.length>0){const c=n.slice(0);n=[],c.forEach(f=>i(f))}})||E.isWindows)&&(s=!0)};return{send:i}}e.createQueuedSender=m;var l;(function(u){async function n(s,i,o){if(k.isAbsolute(s))return s;if(i===void 0&&(i=v.cwd()),k.dirname(s)!=="."||(o===void 0&&T.isString(v.env.PATH)&&(o=v.env.PATH.split(k.delimiter)),o===void 0||o.length===0))return k.join(i,s);async function a(c){if(await C.Promises.exists(c)){let f;try{f=await C.Promises.stat(c)}catch(w){w.message.startsWith("EACCES")&&(f=await C.Promises.lstat(c))}return f?!f.isDirectory():!1}return!1}for(let c of o){let f;if(k.isAbsolute(c)?f=k.join(c,s):f=k.join(i,c,s),await a(f))return f;let w=f+".com";if(await a(w)||(w=f+".exe",await a(w)))return w}return k.join(i,s)}u.findExecutable=n})(l=e.win32||(e.win32={}))}),define(we[153],ye([0,1,28,3,88,92]),function(ie,e,I,t,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(y,d){return y===1?t.isWindows?R():P.getWindowsShell(d):D(y,d)}e.getSystemShell=k;function E(y,d){return y===1?t.isWindows?C(d):P.getWindowsShell(d):D(y,d)}e.getSystemShellSync=E;let v=null;function D(y,d){if(t.isLinux&&y===2||t.isMacintosh&&y===3)return"/bin/bash";if(!v){let S;if(t.isWindows)S="/bin/bash";else{if(S=d.SHELL,!S)try{S=(0,I.userInfo)().shell}catch{}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}v=S}return v}let T=null;async function R(){return T||(T=(await(0,b.getFirstAvailablePowerShellInstallation)()).exePath),T}function C(y){if(T)return T;const d=t.isWindows&&parseFloat((0,I.release)())>=10,S=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),h=`${y.windir}\\${S?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?h:P.getWindowsShell(y)}}),define(we[93],ye([0,1,38,14,16,20,83,9,6,2,21,92,53,39]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends y.ChannelServer{constructor(g){super({send:p=>{try{process.send&&process.send(p.buffer.toString("base64"))}catch{}},onMessage:v.Event.fromNodeEventEmitter(process,"message",p=>b.VSBuffer.wrap(Buffer.from(p,"base64")))},g);process.once("disconnect",()=>this.dispose())}}e.Server=d;class S{constructor(g,p){this.modulePath=g,this.options=p,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new v.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const m=p&&p.timeout?p.timeout:6e4;this.disposeDelayer=new t.Delayer(m),this.child=null,this._client=null}getChannel(g){const p=this;return{call(m,l,u){return p.requestPromise(g,m,l,u)},listen(m,l){return p.requestEvent(g,m,l)}}}requestPromise(g,p,m,l=P.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(E.canceled());this.disposeDelayer.cancel();const u=this.getCachedChannel(g),n=(0,t.createCancelablePromise)(o=>u.call(p,m,o)),s=l.onCancellationRequested(()=>n.cancel()),i=(0,D.toDisposable)(()=>n.cancel());return this.activeRequests.add(i),n.finally(()=>{s.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),n}requestEvent(g,p,m){if(!this.disposeDelayer)return v.Event.None;this.disposeDelayer.cancel();let l;const u=new v.Emitter({onFirstListenerAdd:()=>{l=this.getCachedChannel(g).listen(p,m)(u.fire,u),this.activeRequests.add(l)},onLastListenerRemove:()=>{this.activeRequests.delete(l),l.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return u.event}get client(){if(!this._client){const g=this.options&&this.options.args?this.options.args:[],p=Object.create(null);p.env={...(0,T.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(p.env={...p.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(p.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,C.removeDangerousEnvVariables)(p.env),this.child=(0,I.fork)(this.modulePath,g,p);const m=new v.Emitter;v.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,k.isRemoteConsoleLog)(r)){(0,k.log)(r,`IPC Library: ${this.options.serverName}`);return}m.fire(b.VSBuffer.wrap(Buffer.from(r,"base64")))});const u=this.options.useQueue?(0,R.createQueuedSender)(this.child):this.child,n=r=>this.child&&this.child.connected&&u.send(r.buffer.toString("base64")),s=m.event,i={send:n,onMessage:s};this._client=new y.ChannelClient(i);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,a)=>{process.removeListener("exit",o),this.activeRequests.forEach(c=>(0,D.dispose)(c)),this.activeRequests.clear(),r!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+a),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:a})})}return this._client}getCachedChannel(g){let p=this.channels.get(g);return p||(p=this.client.getChannel(g),this.channels.set(g,p)),p}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=S}),define(we[154],ye([10,11]),function(ie,e){return ie.create("vs/base/node/zip",e)}),define(we[155],ye([10,11]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[156],ye([10,11]),function(ie,e){return ie.create("vs/platform/environment/node/argv",e)}),define(we[157],ye([10,11]),function(ie,e){return ie.create("vs/platform/environment/node/argvHelper",e)}),define(we[158],ye([10,11]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(we[159],ye([10,11]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(we[160],ye([10,11]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagementCLIService",e)}),define(we[161],ye([10,11]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(we[162],ye([10,11]),function(ie,e){return ie.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(we[163],ye([10,11]),function(ie,e){return ie.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(we[164],ye([10,11]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[165],ye([10,11]),function(ie,e){return ie.create("vs/platform/files/common/fileService",e)}),define(we[166],ye([10,11]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(we[167],ye([10,11]),function(ie,e){return ie.create("vs/platform/files/common/io",e)}),define(we[168],ye([10,11]),function(ie,e){return ie.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(we[169],ye([10,11]),function(ie,e){return ie.create("vs/platform/languagePacks/common/languagePacks",e)}),define(we[170],ye([10,11]),function(ie,e){return ie.create("vs/platform/markers/common/markers",e)}),define(we[171],ye([10,11]),function(ie,e){return ie.create("vs/platform/request/common/request",e)}),define(we[172],ye([10,11]),function(ie,e){return ie.create("vs/platform/shell/node/shellEnv",e)}),define(we[173],ye([10,11]),function(ie,e){return ie.create("vs/platform/telemetry/common/telemetryService",e)}),define(we[174],ye([10,11]),function(ie,e){return ie.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(we[175],ye([10,11]),function(ie,e){return ie.create("vs/platform/terminal/common/terminalProfiles",e)}),define(we[176],ye([10,11]),function(ie,e){return ie.create("vs/platform/workspace/common/workspace",e)}),define(we[177],ye([10,11]),function(ie,e){return ie.create("vs/server/node/remoteAgentEnvironmentImpl",e)}),define(we[178],ye([10,11]),function(ie,e){return ie.create("vs/server/node/serverEnvironmentService",e)}),define(we[179],ye([10,11]),function(ie,e){return ie.create("vs/workbench/common/editor",e)}),define(we[180],ye([10,11]),function(ie,e){return ie.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[181],ye([0,1,6,2]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class b{constructor(){this._onCloseEmitter=new I.Emitter,this._onReloadEmitter=new I.Emitter,this._onTerminateEmitter=new I.Emitter,this._onAttachEmitter=new I.Emitter}call(E,v,D){switch(v){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:D[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:D[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:D[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:D[0],port:D[1],subId:D[2]}))}throw new Error("Method not implemented.")}listen(E,v,D){switch(v){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=b,b.ChannelName="extensionhostdebugservice";class P extends t.Disposable{constructor(E){super();this.channel=E}reload(E){this.channel.call("reload",[E])}get onReload(){return this.channel.listen("reload")}close(E){this.channel.call("close",[E])}get onClose(){return this.channel.listen("close")}attachSession(E,v,D){this.channel.call("attach",[E,v,D])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(E,v){this.channel.call("terminate",[E,v])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(E,v){return this.channel.call("openExtensionDevelopmentHostWindow",[E,v])}}e.ExtensionHostDebugChannelClient=P}),define(we[182],ye([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class t{constructor(k){this.service=k}listen(k,E,v){throw new Error("Invalid listen")}call(k,E,v){switch(E){case"download":return this.service.download(I.URI.revive(v[0]),I.URI.revive(v[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=t;class b{constructor(k,E){this.channel=k,this.getUriTransformer=E}async download(k,E){const v=this.getUriTransformer();v&&(k=v.transformOutgoingURI(k),E=v.transformOutgoingURI(E)),await this.channel.call("download",[k,E])}}e.DownloadServiceChannelClient=b}),define(we[183],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var I;(function(E){E[E.ACTIVATE=1]="ACTIVATE",E[E.RESTORE=2]="RESTORE",E[E.PRESERVE=3]="PRESERVE"})(I=e.EditorActivation||(e.EditorActivation={}));var t;(function(E){E[E.PICK=0]="PICK",E[E.DISABLED=1]="DISABLED",E[E.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var b;(function(E){E[E.API=0]="API",E[E.USER=1]="USER"})(b=e.EditorOpenSource||(e.EditorOpenSource={}));var P;(function(E){E[E.Center=0]="Center",E[E.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",E[E.NearTop=2]="NearTop",E[E.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(P=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var k;(function(E){E.PROGRAMMATIC="api",E.NAVIGATION="code.navigation",E.JUMP="code.jump"})(k=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(we[184],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class I{constructor(b){this.machineId=b}encryption(){return new Promise((b,P)=>ie(["vscode-encrypt"],b,P))}async encrypt(b){try{return(await this.encryption()).encrypt(this.machineId,b)}catch{return b}}async decrypt(b){try{return(await this.encryption()).decrypt(this.machineId,b)}catch{return b}}}e.EncryptionMainService=I}),define(we[94],ye([0,1,148,80,8,5,26,19,4]),function(ie,e,I,t,b,P,k,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class D{constructor(S,h,g){this._args=S,this.paths=h,this.productService=g}get appRoot(){return(0,P.dirname)(b.FileAccess.asFileUri("",ie).fsPath)}get userHome(){return v.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return v.URI.file((0,P.join)(this.userDataPath,"User"))}get tmpDir(){return v.URI.file(this.paths.tmpDir)}get cacheHome(){return v.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,E.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,E.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const S=(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,P.join)(this.userDataPath,"logs",S)}return this.args.logsPath}get userDataSyncLogResource(){return v.URI.file((0,P.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.joinPath)(v.URI.file((0,P.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return(0,E.joinPath)(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return(0,E.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.joinPath)(this.appSettingsHome,"History")}get keybindingsResource(){return(0,E.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,E.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=k.env.VSCODE_PORTABLE;return S?v.URI.file((0,P.join)(S,"argv.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,E.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return v.URI.file((0,P.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,P.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,P.resolve)(S):(0,P.normalize)((0,P.join)(b.FileAccess.asFileUri("",ie).fsPath,"..","extensions"))}get extensionsDownloadPath(){const S=this.args["extensions-download-dir"];return S?(0,P.resolve)(S):(0,P.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,P.resolve)(S);const h=k.env.VSCODE_EXTENSIONS;if(h)return h;const g=k.env.VSCODE_PORTABLE;return g?(0,P.join)(g,"extensions"):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(h=>/^[^:/?#]+?:\/\//.test(h)?v.URI.parse(h):v.URI.file((0,P.normalize)(h)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?v.URI.parse(S):v.URI.file((0,P.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return T(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,E.joinPath)(v.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return v.URI.file((0,P.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const S=k.env.VSCODE_PORTABLE;return S?v.URI.file((0,P.join)(S,"policy.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}Re([t.memoize],D.prototype,"appRoot",null),Re([t.memoize],D.prototype,"userHome",null),Re([t.memoize],D.prototype,"userDataPath",null),Re([t.memoize],D.prototype,"appSettingsHome",null),Re([t.memoize],D.prototype,"tmpDir",null),Re([t.memoize],D.prototype,"cacheHome",null),Re([t.memoize],D.prototype,"userRoamingDataHome",null),Re([t.memoize],D.prototype,"settingsResource",null),Re([t.memoize],D.prototype,"userDataSyncHome",null),Re([t.memoize],D.prototype,"userDataSyncLogResource",null),Re([t.memoize],D.prototype,"sync",null),Re([t.memoize],D.prototype,"machineSettingsResource",null),Re([t.memoize],D.prototype,"globalStorageHome",null),Re([t.memoize],D.prototype,"workspaceStorageHome",null),Re([t.memoize],D.prototype,"localHistoryHome",null),Re([t.memoize],D.prototype,"keybindingsResource",null),Re([t.memoize],D.prototype,"keyboardLayoutResource",null),Re([t.memoize],D.prototype,"argvResource",null),Re([t.memoize],D.prototype,"snippetsHome",null),Re([t.memoize],D.prototype,"isExtensionDevelopment",null),Re([t.memoize],D.prototype,"untitledWorkspacesHome",null),Re([t.memoize],D.prototype,"installSourcePath",null),Re([t.memoize],D.prototype,"builtinExtensionsPath",null),Re([t.memoize],D.prototype,"extensionsPath",null),Re([t.memoize],D.prototype,"extensionDevelopmentLocationURI",null),Re([t.memoize],D.prototype,"extensionDevelopmentKind",null),Re([t.memoize],D.prototype,"extensionTestsLocationURI",null),Re([t.memoize],D.prototype,"debugExtensionHost",null),Re([t.memoize],D.prototype,"serviceMachineIdResource",null),Re([t.memoize],D.prototype,"telemetryLogResource",null),Re([t.memoize],D.prototype,"disableWorkspaceTrust",null),Re([t.memoize],D.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=D;function T(d,S){return y(d["inspect-extensions"],d["inspect-brk-extensions"],5870,S,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=T;function R(d,S){return y(d["inspect-search"],d["inspect-brk-search"],5876,S,d.extensionEnvironment)}e.parseSearchPort=R;function C(d,S){return y(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,S,d.extensionEnvironment)}e.parsePtyHostPort=C;function y(d,S,h,g,p,m){const u=Number(S||d)||(g?null:h),n=u?Boolean(!!S):!1;let s;if(m)try{s=JSON.parse(m)}catch{}return{port:u,break:n,debugId:p,env:s}}}),define(we[54],ye([0,1,262,3,156]),function(ie,e,I,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const P={o:(0,b.localize)(0,null),e:(0,b.localize)(1,null),t:(0,b.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,b.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,b.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,b.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,b.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,b.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,b.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,b.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,b.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,b.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,b.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,b.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,b.localize)(14,null)},category:{type:"string",cat:"e",description:(0,b.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,b.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,b.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,b.localize)(18,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,b.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,b.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,b.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,b.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,b.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,b.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,b.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,b.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,b.localize)(27,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,b.localize)(28,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,b.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,b.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,b.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,b.localize)(32,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function E(d,S,h=k){const g={},p=["_"],m=[];for(let s in S){const i=S[s];i.alias&&(g[s]=i.alias),i.type==="string"||i.type==="string[]"?(p.push(s),i.deprecates&&p.push(...i.deprecates)):i.type==="boolean"&&(m.push(s),i.deprecates&&m.push(...i.deprecates))}const l=I(d,{string:p,boolean:m,alias:g}),u={},n=l;u._=l._.map(s=>String(s)).filter(s=>s.length>0),delete n._;for(let s in S){const i=S[s];i.alias&&delete n[i.alias];let o=n[s];if(i.deprecates)for(const r of i.deprecates)n.hasOwnProperty(r)&&(o||(o=n[r],o&&h.onDeprecatedOption(r,i.deprecationMessage||(0,b.localize)(33,null,s))),delete n[r]);if(typeof o!="undefined"){if(i.type==="string[]"){if(Array.isArray(o)||(o=[o]),!i.allowEmptyValue){const r=o.filter(a=>a.length>0);r.length!==o.length&&(h.onEmptyValue(s),o=r.length>0?r:void 0)}}else i.type==="string"&&(Array.isArray(o)?(o=o.pop(),h.onMultipleValues(s,o)):!o&&!i.allowEmptyValue&&(h.onEmptyValue(s),o=void 0));u[s]=o,i.deprecationMessage&&h.onDeprecatedOption(s,i.deprecationMessage)}delete n[s]}for(let s in n)h.onUnknownOption(s);return u}e.parseArgs=E;function v(d,S){let h="";return S.args&&(Array.isArray(S.args)?h=` <${S.args.join("> <")}>`:h=` <${S.args}>`),S.alias?`-${S.alias} --${d}${h}`:`--${d}${h}`}function D(d,S){let h=0,g=[];for(const u in d){const n=d[u],s=v(u,n);h=Math.max(h,s.length),g.push([s,n.description])}let p=h+2+1;if(S-p<25)return g.reduce((u,n)=>u.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);let m=S-p-1,l=[];for(const u of g){let n=u[0],s=R(u[1],m),i=T(p-n.length-2);l.push("  "+n+i+s[0]);for(let o=1;o<s.length;o++)l.push(T(p)+s[o])}return l}e.formatOptions=D;function T(d){return" ".repeat(d)}function R(d,S){let h=[];for(;d.length;){let g=d.length<S?d.length:d.lastIndexOf(" ",S),p=d.slice(0,g).trim();d=d.slice(g),h.push(p)}return h}function C(d,S,h,g,p){const m=process.stdout.isTTY&&process.stdout.columns||80,l=p?.noInputFiles!==!0?`[${(0,b.localize)(34,null)}...]`:"",u=[`${d} ${h}`];u.push(""),u.push(`${(0,b.localize)(35,null)}: ${S} [${(0,b.localize)(36,null)}]${l}`),u.push(""),p?.noPipe!==!0&&(t.isWindows?u.push((0,b.localize)(37,null,S)):u.push((0,b.localize)(38,null,S)),u.push(""));const n={};for(const s in g){const i=g[s];if(i.description&&i.cat){let o=n[i.cat];o||(n[i.cat]=o={}),o[s]=i}}for(let s in n){const i=s;let o=n[i];o&&(u.push(P[i]),u.push(...D(o,m)),u.push(""))}return u.join(`
`)}e.buildHelpMessage=C;function y(d,S){return`${d||(0,b.localize)(39,null)}
${S||(0,b.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=y}),define(we[185],ye([0,1,263,157,54]),function(ie,e,I,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const P=2048;function k(C,y){const d={onUnknownOption:h=>{console.warn((0,t.localize)(0,null,h))},onMultipleValues:(h,g)=>{console.warn((0,t.localize)(1,null,h,g))},onEmptyValue:h=>{console.warn((0,t.localize)(2,null,h))},onDeprecatedOption:(h,g)=>{console.warn((0,t.localize)(3,null,h,g))}},S=(0,b.parseArgs)(C,b.OPTIONS,y?d:void 0);return S.goto&&S._.forEach(h=>I(/^(\w:)?[^:]+(:\d*){0,2}$/.test(h),(0,t.localize)(4,null))),S["max-memory"]&&I(parseInt(S["max-memory"])>=P,`The max-memory argument cannot be specified lower than ${P} MB.`),S}function E(C){const y=C.findIndex(d=>!/^-/.test(d));if(y>-1)return[...C.slice(0,y),...C.slice(y+1)]}function v(C){let[,...y]=C;process.env.VSCODE_DEV&&(y=E(y)||[]);const d=!R(process.env);return k(y,d)}e.parseMainProcessArgv=v;function D(C){const[,,...y]=C;return k(y,!0)}e.parseCLIProcessArgv=D;function T(C,...y){const d=C.indexOf("--");return d===-1?C.push(...y):C.splice(d,0,...y),C}e.addArg=T;function R(C){return C.VSCODE_CLI==="1"}e.isLaunchedFromCli=R}),function(){"use strict";function ie(e,I,t,b){function P(E){const v=k(E),D=[v];return e.isAbsolute(v)||D.unshift(b),e.resolve(...D)}function k(E){const v=process.env.VSCODE_PORTABLE;if(v)return e.join(v,"user-data");let D=process.env.VSCODE_APPDATA;if(D)return e.join(D,t);const T=E["user-data-dir"];if(T)return T;switch(process.platform){case"win32":if(D=process.env.APPDATA,!D){const R=process.env.USERPROFILE;if(typeof R!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");D=e.join(R,"AppData","Roaming")}break;case"darwin":D=e.join(I.homedir(),"Library","Application Support");break;case"linux":D=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(D,t)}return{getUserDataPath:P}}if(typeof define=="function")define(we[186],ye([0,86,28,8,19,26]),function(e,I,t,b,P,k){const E=P.dirname(b.FileAccess.asFileUri("",e)),v=e.__$__nodeRequire(P.joinPath(E,"package.json").fsPath);return ie(I,t,v.name,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),I=require("path"),t=require("os");module.exports=ie(I,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(we[187],ye([0,1,28,94,186]),function(ie,e,I,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class P extends t.AbstractNativeEnvironmentService{constructor(E,v){super(E,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,b.getUserDataPath)(E)},v)}}e.NativeEnvironmentService=P}),define(we[69],ye([0,1,19,65,164,55]),function(ie,e,I,t,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function v(g){return g=g.trim(),g==="*"||k.test(g)}e.isValidVersionStr=v;function D(g){if(!v(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=g.match(k);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=D;function T(g){if(!g)return null;let p=g.majorBase,m=g.majorMustEqual,l=g.minorBase,u=g.minorMustEqual,n=g.patchBase,s=g.patchMustEqual;g.hasCaret&&(p===0||(u=!1),s=!1);let i=0;if(g.preRelease){const o=E.exec(g.preRelease);if(o){const[,r,a,c]=o;i=Date.UTC(Number(r),Number(a)-1,Number(c))}}return{majorBase:p,majorMustEqual:m,minorBase:l,minorMustEqual:u,patchBase:n,patchMustEqual:s,isMinimum:g.hasGreaterEquals,notBefore:i}}e.normalizeVersion=T;function R(g,p,m){let l;typeof g=="string"?l=T(D(g)):l=g;let u;p instanceof Date?u=p.getTime():typeof p=="string"&&(u=new Date(p).getTime());let n;if(typeof m=="string"?n=T(D(m)):n=m,!l||!n)return!1;let s=l.majorBase,i=l.minorBase,o=l.patchBase,r=n.majorBase,a=n.minorBase,c=n.patchBase,f=n.notBefore,w=n.majorMustEqual,A=n.minorMustEqual,U=n.patchMustEqual;return n.isMinimum?s>r?!0:s<r?!1:i>a?!0:i<a||u&&u<f?!1:o>=c:(s===1&&r===0&&(!w||!A||!U)&&(r=1,a=0,c=0,w=!0,A=!1,U=!1),s<r?!1:s>r?!w:i<a?!1:i>a?!A:o<c?!1:o>c?!U:!(u&&u<f))}e.isValidVersion=R;function C(g,p,m,l,u){const n=[];if(typeof l.publisher!="undefined"&&typeof l.publisher!="string")return n.push([t.default.Error,b.localize(0,null)]),n;if(typeof l.name!="string")return n.push([t.default.Error,b.localize(1,null,"name")]),n;if(typeof l.version!="string")return n.push([t.default.Error,b.localize(2,null,"version")]),n;if(!l.engines)return n.push([t.default.Error,b.localize(3,null,"engines")]),n;if(typeof l.engines.vscode!="string")return n.push([t.default.Error,b.localize(4,null,"engines.vscode")]),n;if(typeof l.extensionDependencies!="undefined"&&!h(l.extensionDependencies))return n.push([t.default.Error,b.localize(5,null,"extensionDependencies")]),n;if(typeof l.activationEvents!="undefined"){if(!h(l.activationEvents))return n.push([t.default.Error,b.localize(6,null,"activationEvents")]),n;if(typeof l.main=="undefined"&&typeof l.browser=="undefined")return n.push([t.default.Error,b.localize(7,null,"activationEvents","main")]),n}if(typeof l.extensionKind!="undefined"&&typeof l.main=="undefined"&&n.push([t.default.Warning,b.localize(8,null,"extensionKind")]),typeof l.main!="undefined"){if(typeof l.main!="string")return n.push([t.default.Error,b.localize(9,null,"main")]),n;{const o=(0,I.joinPath)(m,l.main);(0,I.isEqualOrParent)(o,m)||n.push([t.default.Warning,b.localize(10,null,o.path,m.path)])}if(typeof l.activationEvents=="undefined")return n.push([t.default.Error,b.localize(11,null,"activationEvents","main")]),n}if(typeof l.browser!="undefined"){if(typeof l.browser!="string")return n.push([t.default.Error,b.localize(12,null,"browser")]),n;{const o=(0,I.joinPath)(m,l.browser);(0,I.isEqualOrParent)(o,m)||n.push([t.default.Warning,b.localize(13,null,o.path,m.path)])}if(typeof l.activationEvents=="undefined")return n.push([t.default.Error,b.localize(14,null,"activationEvents","browser")]),n}if(!P.valid(l.version))return n.push([t.default.Error,b.localize(15,null)]),n;const s=[];if(!y(g,p,l,u,s))for(const o of s)n.push([t.default.Error,o]);return n}e.validateExtensionManifest=C;function y(g,p,m,l,u){return l||typeof m.main=="undefined"&&typeof m.browser=="undefined"?!0:S(g,p,m.engines.vscode,u)}e.isValidExtensionVersion=y;function d(g,p,m){return g==="*"||S(p,m,g)}e.isEngineValid=d;function S(g,p,m,l=[]){let u=T(D(m));if(!u)return l.push(b.localize(16,null,m)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return l.push(b.localize(17,null,m)),!1}else if(!u.majorMustEqual)return l.push(b.localize(18,null,m)),!1;return R(g,p,u)?!0:(l.push(b.localize(19,null,g,m)),!1)}function h(g){if(!Array.isArray(g))return!1;for(let p=0,m=g.length;p<m;p++)if(typeof g[p]!="string")return!1;return!0}}),define(we[188],ye([0,1,16,27]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function b(P,k,E){let v=E&&E.get("storage.serviceMachineId",0)||null;if(v)return v;try{const T=(await k.readFile(P.serviceMachineIdResource)).value.toString();v=(0,t.isUUID)(T)?T:null}catch{v=null}if(!v){v=(0,t.generateUuid)();try{await k.writeFile(P.serviceMachineIdResource,I.VSBuffer.fromString(v))}catch{}}return E&&E.store("storage.serviceMachineId",v,0,1),v}e.getServiceMachineId=b}),define(we[56],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class I{constructor(b,P=[],k=!1){this.ctor=b,this.staticArguments=P,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=I}),define(we[189],ye([0,1,56]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function b(k,E,v){E instanceof I.SyncDescriptor||(E=new I.SyncDescriptor(E,[],v)),t.push([k,E])}e.registerSingleton=b;function P(){return t}e.getSingletonServiceDescriptors=P}),define(we[190],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class I{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}e.Node=I;class t{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(let k of this._nodes.values())k.outgoing.size===0&&P.push(k);return P}insertEdge(P,k){const E=this.lookupOrInsertNode(P),v=this.lookupOrInsertNode(k);E.outgoing.set(this._hashFn(k),v),v.incoming.set(this._hashFn(P),E)}removeNode(P){const k=this._hashFn(P);this._nodes.delete(k);for(let E of this._nodes.values())E.outgoing.delete(k),E.incoming.delete(k)}lookupOrInsertNode(P){const k=this._hashFn(P);let E=this._nodes.get(k);return E||(E=new I(P),this._nodes.set(k,E)),E}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){let P=[];for(let[k,E]of this._nodes)P.push(`${k}, (incoming)[${[...E.incoming.keys()].join(", ")}], (outgoing)[${[...E.outgoing.keys()].join(",")}]`);return P.join(`
`)}findCycleSlow(){for(let[P,k]of this._nodes){const E=new Set([P]),v=this._findCycle(k,E);if(v)return v}}_findCycle(P,k){for(let[E,v]of P.outgoing){if(k.has(E))return[...k,E].join(" -> ");k.add(E);const D=this._findCycle(v,k);if(D)return D;k.delete(E)}}}e.Graph=t}),define(we[7],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var I;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function E(v){return v[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=E})(I=e._util||(e._util={})),e.IInstantiationService=b("instantiationService");function t(k,E,v){E[I.DI_TARGET]===E?E[I.DI_DEPENDENCIES].push({id:k,index:v}):(E[I.DI_DEPENDENCIES]=[{id:k,index:v}],E[I.DI_TARGET]=E)}function b(k){if(I.serviceIds.has(k))return I.serviceIds.get(k);const E=function(v,D,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(E,v,T)};return E.toString=()=>k,I.serviceIds.set(k,E),E}e.createDecorator=b;function P(k){return k}e.refineServiceDecorator=P}),define(we[23],ye([0,1,12,4,7]),function(ie,e,I,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,b.createDecorator)("configurationService");function P(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof t.URI)}e.isConfigurationOverrides=P;function k(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||I.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=k;var E;(function(g){g[g.USER=1]="USER",g[g.USER_LOCAL=2]="USER_LOCAL",g[g.USER_REMOTE=3]="USER_REMOTE",g[g.WORKSPACE=4]="WORKSPACE",g[g.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",g[g.DEFAULT=6]="DEFAULT",g[g.MEMORY=7]="MEMORY"})(E=e.ConfigurationTarget||(e.ConfigurationTarget={}));function v(g){switch(g){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=v;function D(g,p){const m=Object.create(null);for(let l in g)T(m,l,g[l],p);return m}e.toValuesTree=D;function T(g,p,m,l){const u=p.split("."),n=u.pop();let s=g;for(let i=0;i<u.length;i++){let o=u[i],r=s[o];switch(typeof r){case"undefined":r=s[o]=Object.create(null);break;case"object":break;default:l(`Ignoring ${p} as ${u.slice(0,i+1).join(".")} is ${JSON.stringify(r)}`);return}s=r}if(typeof s=="object"&&s!==null)try{s[n]=m}catch{l(`Ignoring ${p} as ${u.join(".")} is ${JSON.stringify(s)}`)}else l(`Ignoring ${p} as ${u.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=T;function R(g,p){const m=p.split(".");C(g,m)}e.removeFromValueTree=R;function C(g,p){const m=p.shift();if(p.length===0){delete g[m];return}if(Object.keys(g).indexOf(m)!==-1){const l=g[m];typeof l=="object"&&!Array.isArray(l)&&(C(l,p),Object.keys(l).length===0&&delete g[m])}}function y(g,p,m){function l(s,i){let o=s;for(const r of i){if(typeof o!="object"||o===null)return;o=o[r]}return o}const u=p.split("."),n=l(g,u);return typeof n=="undefined"?m:n}e.getConfigurationValue=y;function d(g,p,m){Object.keys(p).forEach(l=>{l!=="__proto__"&&(l in g?I.isObject(g[l])&&I.isObject(p[l])?d(g[l],p[l],m):m&&(g[l]=p[l]):g[l]=p[l])})}e.merge=d;function S(g,p,m){const l=g.inspect(p),u=g.inspect(m);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:l.defaultValue}e.getMigratedSettingValue=S;function h(g){return g.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=h}),define(we[95],ye([0,1,3,15,7]),function(ie,e,I,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",I.isMacintosh),P.set("isLinux",I.isLinux),P.set("isWindows",I.isWindows),P.set("isWeb",I.isWeb),P.set("isMacNative",I.isMacintosh&&!I.isWeb),P.set("isEdge",I.isEdge),P.set("isFirefox",I.isFirefox),P.set("isChrome",I.isChrome),P.set("isSafari",I.isSafari);const k=Object.prototype.hasOwnProperty;var E;(function(Q){Q[Q.False=0]="False",Q[Q.True=1]="True",Q[Q.Defined=2]="Defined",Q[Q.Not=3]="Not",Q[Q.Equals=4]="Equals",Q[Q.NotEquals=5]="NotEquals",Q[Q.And=6]="And",Q[Q.Regex=7]="Regex",Q[Q.NotRegex=8]="NotRegex",Q[Q.Or=9]="Or",Q[Q.In=10]="In",Q[Q.NotIn=11]="NotIn",Q[Q.Greater=12]="Greater",Q[Q.GreaterEquals=13]="GreaterEquals",Q[Q.Smaller=14]="Smaller",Q[Q.SmallerEquals=15]="SmallerEquals"})(E=e.ContextKeyExprType||(e.ContextKeyExprType={}));class v{static false(){return R.INSTANCE}static true(){return C.INSTANCE}static has(_){return y.create(_)}static equals(_,Y){return d.create(_,Y)}static notEquals(_,Y){return g.create(_,Y)}static regex(_,Y){return i.create(_,Y)}static in(_,Y){return S.create(_,Y)}static not(_){return p.create(_)}static and(..._){return a.create(_,null)}static or(..._){return c.create(_,null,!0)}static greater(_,Y){return l.create(_,Y)}static greaterEquals(_,Y){return u.create(_,Y)}static smaller(_,Y){return n.create(_,Y)}static smallerEquals(_,Y){return s.create(_,Y)}static deserialize(_,Y=!1){if(!!_)return this._deserializeOrExpression(_,Y)}static _deserializeOrExpression(_,Y){let O=_.split("||");return c.create(O.map(B=>this._deserializeAndExpression(B,Y)),null,!0)}static _deserializeAndExpression(_,Y){let O=_.split("&&");return a.create(O.map(B=>this._deserializeOne(B,Y)),null)}static _deserializeOne(_,Y){if(_=_.trim(),_.indexOf("!=")>=0){let O=_.split("!=");return g.create(O[0].trim(),this._deserializeValue(O[1],Y))}if(_.indexOf("==")>=0){let O=_.split("==");return d.create(O[0].trim(),this._deserializeValue(O[1],Y))}if(_.indexOf("=~")>=0){let O=_.split("=~");return i.create(O[0].trim(),this._deserializeRegexValue(O[1],Y))}if(_.indexOf(" in ")>=0){let O=_.split(" in ");return S.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(_)){const O=_.split(">=");return u.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(_)){const O=_.split(">");return l.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(_)){const O=_.split("<=");return s.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(_)){const O=_.split("<");return n.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(_)?p.create(_.substr(1).trim()):y.create(_)}static _deserializeValue(_,Y){if(_=_.trim(),_==="true")return!0;if(_==="false")return!1;let O=/^'([^']*)'$/.exec(_);return O?O[1].trim():_}static _deserializeRegexValue(_,Y){if((0,t.isFalsyOrWhitespace)(_)){if(Y)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=_.indexOf("/"),B=_.lastIndexOf("/");if(O===B||O<0){if(Y)throw new Error(`bad regexp-value '${_}', missing /-enclosure`);return console.warn(`bad regexp-value '${_}', missing /-enclosure`),null}let ue=_.slice(O+1,B),V=_[B+1]==="i"?"i":"";try{return new RegExp(ue,V)}catch($){if(Y)throw new Error(`bad regexp-value '${_}', parse error: ${$}`);return console.warn(`bad regexp-value '${_}', parse error: ${$}`),null}}}e.ContextKeyExpr=v;function D(Q,_){const Y=Q?Q.substituteConstants():void 0,O=_?_.substituteConstants():void 0;return!Y&&!O?!0:!Y||!O?!1:Y.equals(O)}e.expressionsAreEqualWithConstantSubstitution=D;function T(Q,_){return Q.cmp(_)}class R{constructor(){this.type=0}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}substituteConstants(){return this}evaluate(_){return!1}serialize(){return"false"}keys(){return[]}map(_){return this}negate(){return C.INSTANCE}}e.ContextKeyFalseExpr=R,R.INSTANCE=new R;class C{constructor(){this.type=1}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}substituteConstants(){return this}evaluate(_){return!0}serialize(){return"true"}keys(){return[]}map(_){return this}negate(){return R.INSTANCE}}e.ContextKeyTrueExpr=C,C.INSTANCE=new C;class y{constructor(_,Y){this.key=_,this.negated=Y,this.type=2}static create(_,Y=null){const O=P.get(_);return typeof O=="boolean"?O?C.INSTANCE:R.INSTANCE:new y(_,Y)}cmp(_){return _.type!==this.type?this.type-_.type:w(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}substituteConstants(){const _=P.get(this.key);return typeof _=="boolean"?_?C.INSTANCE:R.INSTANCE:this}evaluate(_){return!!_.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(_){return _.mapDefined(this.key)}negate(){return this.negated||(this.negated=p.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=y;class d{constructor(_,Y,O){this.key=_,this.value=Y,this.negated=O,this.type=4}static create(_,Y,O=null){if(typeof Y=="boolean")return Y?y.create(_,O):p.create(_,O);const B=P.get(_);return typeof B=="boolean"?Y===(B?"true":"false")?C.INSTANCE:R.INSTANCE:new d(_,Y,O)}cmp(_){return _.type!==this.type?this.type-_.type:A(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){const _=P.get(this.key);if(typeof _=="boolean"){const Y=_?"true":"false";return this.value===Y?C.INSTANCE:R.INSTANCE}return this}evaluate(_){return _.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(_){return _.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=d;class S{constructor(_,Y){this.key=_,this.valueKey=Y,this.type=10,this.negated=null}static create(_,Y){return new S(_,Y)}cmp(_){return _.type!==this.type?this.type-_.type:A(this.key,this.valueKey,_.key,_.valueKey)}equals(_){return _.type===this.type?this.key===_.key&&this.valueKey===_.valueKey:!1}substituteConstants(){return this}evaluate(_){const Y=_.getValue(this.valueKey),O=_.getValue(this.key);return Array.isArray(Y)?Y.includes(O):typeof O=="string"&&typeof Y=="object"&&Y!==null?k.call(Y,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(_){return _.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=h.create(this)),this.negated}}e.ContextKeyInExpr=S;class h{constructor(_){this._actual=_,this.type=11}static create(_){return new h(_)}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}substituteConstants(){return this}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new h(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotInExpr=h;class g{constructor(_,Y,O){this.key=_,this.value=Y,this.negated=O,this.type=5}static create(_,Y,O=null){if(typeof Y=="boolean")return Y?p.create(_,O):y.create(_,O);const B=P.get(_);return typeof B=="boolean"?Y===(B?"true":"false")?R.INSTANCE:C.INSTANCE:new g(_,Y,O)}cmp(_){return _.type!==this.type?this.type-_.type:A(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){const _=P.get(this.key);if(typeof _=="boolean"){const Y=_?"true":"false";return this.value===Y?R.INSTANCE:C.INSTANCE}return this}evaluate(_){return _.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(_){return _.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=g;class p{constructor(_,Y){this.key=_,this.negated=Y,this.type=3}static create(_,Y=null){const O=P.get(_);return typeof O=="boolean"?O?R.INSTANCE:C.INSTANCE:new p(_,Y)}cmp(_){return _.type!==this.type?this.type-_.type:w(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}substituteConstants(){const _=P.get(this.key);return typeof _=="boolean"?_?R.INSTANCE:C.INSTANCE:this}evaluate(_){return!_.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(_){return _.mapNot(this.key)}negate(){return this.negated||(this.negated=y.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=p;function m(Q,_){if(typeof Q=="string"){const Y=parseFloat(Q);isNaN(Y)||(Q=Y)}return typeof Q=="string"||typeof Q=="number"?_(Q):R.INSTANCE}class l{constructor(_,Y,O){this.key=_,this.value=Y,this.negated=O,this.type=12}static create(_,Y,O=null){return m(Y,B=>new l(_,B,O))}cmp(_){return _.type!==this.type?this.type-_.type:A(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class u{constructor(_,Y,O){this.key=_,this.value=Y,this.negated=O,this.type=13}static create(_,Y,O=null){return m(Y,B=>new u(_,B,O))}cmp(_){return _.type!==this.type?this.type-_.type:A(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=u;class n{constructor(_,Y,O){this.key=_,this.value=Y,this.negated=O,this.type=14}static create(_,Y,O=null){return m(Y,B=>new n(_,B,O))}cmp(_){return _.type!==this.type?this.type-_.type:A(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=n;class s{constructor(_,Y,O){this.key=_,this.value=Y,this.negated=O,this.type=15}static create(_,Y,O=null){return m(Y,B=>new s(_,B,O))}cmp(_){return _.type!==this.type?this.type-_.type:A(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=s;class i{constructor(_,Y){this.key=_,this.regexp=Y,this.type=7,this.negated=null}static create(_,Y){return new i(_,Y)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.key<_.key)return-1;if(this.key>_.key)return 1;const Y=this.regexp?this.regexp.source:"",O=_.regexp?_.regexp.source:"";return Y<O?-1:Y>O?1:0}equals(_){if(_.type===this.type){const Y=this.regexp?this.regexp.source:"",O=_.regexp?_.regexp.source:"";return this.key===_.key&&Y===O}return!1}substituteConstants(){return this}evaluate(_){let Y=_.getValue(this.key);return this.regexp?this.regexp.test(Y):!1}serialize(){const _=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${_}`}keys(){return[this.key]}map(_){return _.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=o.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class o{constructor(_){this._actual=_,this.type=8}static create(_){return new o(_)}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}substituteConstants(){return this}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new o(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;function r(Q){let _=null;for(let Y=0,O=Q.length;Y<O;Y++){const B=Q[Y].substituteConstants();if(Q[Y]!==B&&_===null){_=[];for(let ue=0;ue<Y;ue++)_[ue]=Q[ue]}_!==null&&(_[Y]=B)}return _===null?Q:_}class a{constructor(_,Y){this.expr=_,this.negated=Y,this.type=6}static create(_,Y){return a._normalizeArr(_,Y)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let Y=0,O=this.expr.length;Y<O;Y++){const B=T(this.expr[Y],_.expr[Y]);if(B!==0)return B}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let Y=0,O=this.expr.length;Y<O;Y++)if(!this.expr[Y].equals(_.expr[Y]))return!1;return!0}return!1}substituteConstants(){const _=r(this.expr);return _===this.expr?this:a.create(_,this.negated)}evaluate(_){for(let Y=0,O=this.expr.length;Y<O;Y++)if(!this.expr[Y].evaluate(_))return!1;return!0}static _normalizeArr(_,Y){const O=[];let B=!1;for(const ue of _)if(!!ue){if(ue.type===1){B=!0;continue}if(ue.type===0)return R.INSTANCE;if(ue.type===6){O.push(...ue.expr);continue}O.push(ue)}if(O.length===0&&B)return C.INSTANCE;if(O.length!==0){if(O.length===1)return O[0];O.sort(T);for(let ue=1;ue<O.length;ue++)O[ue-1].equals(O[ue])&&(O.splice(ue,1),ue--);if(O.length===1)return O[0];for(;O.length>1;){const ue=O[O.length-1];if(ue.type!==9)break;O.pop();const V=O.pop(),$=O.length===0,F=c.create(ue.expr.map(M=>a.create([M,V],null)),null,$);F&&(O.push(F),O.sort(T))}return O.length===1?O[0]:new a(O,Y)}}serialize(){return this.expr.map(_=>_.serialize()).join(" && ")}keys(){const _=[];for(let Y of this.expr)_.push(...Y.keys());return _}map(_){return new a(this.expr.map(Y=>Y.map(_)),null)}negate(){if(!this.negated){const _=[];for(let Y of this.expr)_.push(Y.negate());this.negated=c.create(_,this,!0)}return this.negated}}class c{constructor(_,Y){this.expr=_,this.negated=Y,this.type=9}static create(_,Y,O){return c._normalizeArr(_,Y,O)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let Y=0,O=this.expr.length;Y<O;Y++){const B=T(this.expr[Y],_.expr[Y]);if(B!==0)return B}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let Y=0,O=this.expr.length;Y<O;Y++)if(!this.expr[Y].equals(_.expr[Y]))return!1;return!0}return!1}substituteConstants(){const _=r(this.expr);return _===this.expr?this:c.create(_,this.negated,!1)}evaluate(_){for(let Y=0,O=this.expr.length;Y<O;Y++)if(this.expr[Y].evaluate(_))return!0;return!1}static _normalizeArr(_,Y,O){let B=[],ue=!1;if(_){for(let V=0,$=_.length;V<$;V++){const F=_[V];if(!!F){if(F.type===0){ue=!0;continue}if(F.type===1)return C.INSTANCE;if(F.type===9){B=B.concat(F.expr);continue}B.push(F)}}if(B.length===0&&ue)return R.INSTANCE;B.sort(T)}if(B.length!==0){if(B.length===1)return B[0];for(let V=1;V<B.length;V++)B[V-1].equals(B[V])&&(B.splice(V,1),V--);if(B.length===1)return B[0];if(O){for(let V=0;V<B.length;V++)for(let $=V+1;$<B.length;$++)U(B[V],B[$])&&(B.splice($,1),$--);if(B.length===1)return B[0]}return new c(B,Y)}}serialize(){return this.expr.map(_=>_.serialize()).join(" || ")}keys(){const _=[];for(let Y of this.expr)_.push(...Y.keys());return _}map(_){return new c(this.expr.map(Y=>Y.map(_)),null)}negate(){if(!this.negated){let _=[];for(let Y of this.expr)_.push(Y.negate());for(;_.length>1;){const Y=_.shift(),O=_.shift(),B=[];for(const V of x(Y))for(const $ of x(O))B.push(a.create([V,$],null));const ue=_.length===0;_.unshift(c.create(B,null,ue))}this.negated=_[0]}return this.negated}}class f extends y{constructor(_,Y,O){super(_,null);this._defaultValue=Y,typeof O=="object"?f._info.push({...O,key:_}):O!==!0&&f._info.push({key:_,description:O,type:Y!=null?typeof Y:void 0})}static all(){return f._info.values()}bindTo(_){return _.createKey(this.key,this._defaultValue)}getValue(_){return _.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(_){return d.create(this.key,_)}notEqualsTo(_){return g.create(this.key,_)}}e.RawContextKey=f,f._info=[],e.IContextKeyService=(0,b.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function w(Q,_){return Q<_?-1:Q>_?1:0}function A(Q,_,Y,O){return Q<Y?-1:Q>Y?1:_<O?-1:_>O?1:0}function U(Q,_){if(_.type===6&&Q.type!==9&&Q.type!==6){for(const B of _.expr)if(Q.equals(B))return!0}const Y=Q.negate(),O=x(Y).concat(x(_));O.sort(T);for(let B=0;B<O.length;B++){const V=O[B].negate();for(let $=B+1;$<O.length;$++){const F=O[$];if(V.equals(F))return!0}}return!1}e.implies=U;function x(Q){return Q.type===9?Q.expr:[Q]}}),define(we[70],ye([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,I.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,I.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(P,k){return this.secretVault[P]?.[k]??null}async setPassword(P,k,E){this.secretVault[P]=this.secretVault[P]??{},this.secretVault[P][k]=E}async deletePassword(P,k){return this.secretVault[P]?.[k]?(delete this.secretVault[P][k],Object.keys(this.secretVault[P]).length===0&&delete this.secretVault[P],!0):!1}async findPassword(P){return JSON.stringify(this.secretVault[P])??null}async findCredentials(P){const k=[];for(const E of Object.keys(this.secretVault[P]||{}))k.push({account:E,password:this.secretVault[P][E]});return k}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(we[191],ye([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,I.createDecorator)(e.ID);function t(P){return!!P.hostName&&!!P.errorMessage}e.isRemoteDiagnosticError=t;class b{async getPerformanceInfo(k,E){return{}}async getSystemInfo(k,E){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(k,E){return""}async getWorkspaceFileExtensions(k){return{extensions:[]}}async reportWorkspaceStats(k){}}e.NullDiagnosticsService=b}),define(we[71],ye([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,I.createDecorator)("downloadService")}),define(we[192],ye([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,I.createDecorator)("encryptionMainService")}),define(we[24],ye([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,I.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,I.refineServiceDecorator)(e.IEnvironmentService)}),define(we[31],ye([0,1,159,7]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function b(g){switch(g){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=b;function P(g){switch(g){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function k(g,p){switch(g){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=k;function E(g,p){return p==="web"&&!g.includes("web")}e.isNotWebExtensionInWebTargetPlatform=E;function v(g,p,m){return E(p,m)?!1:g==="undefined"||g==="universal"?!0:g==="unknown"?!1:g===m?!0:D(m).includes(g)}e.isTargetPlatformCompatible=v;function D(g){switch(g){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=D;function T(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=T;var R;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=10]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(R=e.SortBy||(e.SortBy={}));var C;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(C=e.SortOrder||(e.SortOrder={}));var y;(function(g){g.Install="install",g.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var d;(function(g){g[g.None=1]="None",g[g.Install=2]="Install",g[g.Update=3]="Update",g[g.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var S;(function(g){g.Unsupported="Unsupported",g.Deprecated="Deprecated",g.Malicious="Malicious",g.Incompatible="Incompatible",g.IncompatiblePreRelease="IncompatiblePreRelease",g.IncompatibleTargetPlatform="IncompatibleTargetPlatform",g.ReleaseVersionNotFound="ReleaseVersionNotFound",g.Invalid="Invalid",g.Download="Download",g.Extract="Extract",g.Delete="Delete",g.Rename="Rename",g.CorruptZip="CorruptZip",g.IncompleteZip="IncompleteZip",g.Internal="Internal"})(S=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class h extends Error{constructor(p,m){super(p);this.code=m,this.name=m}}e.ExtensionManagementError=h,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,I.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,I.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,t.createDecorator)("IExtensionManagementCLIService")}),define(we[193],ye([0,1,6,2,21,4,67,31]),function(ie,e,I,t,b,P,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function v(S,h){return P.URI.revive(h?h.transformIncoming(S):S)}function D(S,h){return h?h.transformOutgoingURI(S):S}function T(S,h){h=h||k.DefaultURITransformer;const g=S.manifest;return{...(0,k.transformAndReviveIncomingURIs)({...S,manifest:void 0},h),manifest:g}}function R(S,h){return h?(0,b.cloneAndChange)(S,g=>g instanceof P.URI?h.transformOutgoingURI(g):void 0):S}class C{constructor(h,g){this.service=h,this.getUriTransformer=g,this.onInstallExtension=I.Event.buffer(h.onInstallExtension,!0),this.onDidInstallExtensions=I.Event.buffer(h.onDidInstallExtensions,!0),this.onUninstallExtension=I.Event.buffer(h.onUninstallExtension,!0),this.onDidUninstallExtension=I.Event.buffer(h.onDidUninstallExtension,!0)}listen(h,g){const p=this.getUriTransformer(h);switch(g){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return I.Event.map(this.onDidInstallExtensions,m=>m.map(l=>({...l,local:l.local?R(l.local,p):l.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(h,g,p){const m=this.getUriTransformer(h);switch(g){case"zip":return this.service.zip(T(p[0],m)).then(l=>D(l,m));case"unzip":return this.service.unzip(v(p[0],m));case"install":return this.service.install(v(p[0],m),p[1]);case"getManifest":return this.service.getManifest(v(p[0],m));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(p[0]);case"installFromGallery":return this.service.installFromGallery(p[0],p[1]);case"uninstall":return this.service.uninstall(T(p[0],m),p[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(T(p[0],m));case"getInstalled":return this.service.getInstalled(p[0]).then(l=>l.map(u=>R(u,m)));case"updateMetadata":return this.service.updateMetadata(T(p[0],m),p[1]).then(l=>R(l,m));case"updateExtensionScope":return this.service.updateExtensionScope(T(p[0],m),p[1]).then(l=>R(l,m));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=C;class y extends t.Disposable{constructor(h){super();this.channel=h,this._onInstallExtension=this._register(new I.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new I.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new I.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new I.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(g=>this._onInstallExtension.fire({identifier:g.identifier,source:this.isUriComponents(g.source)?P.URI.revive(g.source):g.source}))),this._register(this.channel.listen("onDidInstallExtensions")(g=>this._onDidInstallExtensions.fire(g.map(p=>({...p,local:p.local?T(p.local,null):p.local,source:this.isUriComponents(p.source)?P.URI.revive(p.source):p.source}))))),this._register(this.channel.listen("onUninstallExtension")(g=>this._onUninstallExtension.fire(g))),this._register(this.channel.listen("onDidUninstallExtension")(g=>this._onDidUninstallExtension.fire(g)))}isUriComponents(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(h){const g=await this.getTargetPlatform();return h.allTargetPlatforms.some(p=>(0,E.isTargetPlatformCompatible)(p,h.allTargetPlatforms,g))}zip(h){return Promise.resolve(this.channel.call("zip",[h]).then(g=>P.URI.revive(g)))}unzip(h){return Promise.resolve(this.channel.call("unzip",[h]))}install(h,g){return Promise.resolve(this.channel.call("install",[h,g])).then(p=>T(p,null))}getManifest(h){return Promise.resolve(this.channel.call("getManifest",[h]))}installFromGallery(h,g){return Promise.resolve(this.channel.call("installFromGallery",[h,g])).then(p=>T(p,null))}uninstall(h,g){return Promise.resolve(this.channel.call("uninstall",[h,g]))}reinstallFromGallery(h){return Promise.resolve(this.channel.call("reinstallFromGallery",[h]))}getInstalled(h=null){return Promise.resolve(this.channel.call("getInstalled",[h])).then(g=>g.map(p=>T(p,null)))}updateMetadata(h,g){return Promise.resolve(this.channel.call("updateMetadata",[h,g])).then(p=>T(p,null))}updateExtensionScope(h,g){return Promise.resolve(this.channel.call("updateExtensionScope",[h,g])).then(p=>T(p,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=y;class d{constructor(h){this.service=h}listen(h,g){throw new Error("Invalid listen")}call(h,g,p){switch(g){case"getConfigBasedTips":return this.service.getConfigBasedTips(P.URI.revive(p[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=d}),define(we[18],ye([0,1,9,29,5,15,12,4,166,7]),function(ie,e,I,t,b,P,k,E,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,D.createDecorator)("fileService");function T($){return $.create===!0}e.isFileOpenForWriteOptions=T;var R;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var C;(function($){$[$.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var y;(function($){$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock",$[$.FileAtomicRead=16384]="FileAtomicRead",$[$.FileClone=32768]="FileClone"})(y=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d($){return!!($.capabilities&2)}e.hasReadWriteCapability=d;function S($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=S;function h($){return!!($.capabilities&32768)}e.hasFileCloneCapability=h;function g($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function p($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=p;function m($){return d($)?!!($.capabilities&16384):!1}e.hasFileAtomicReadCapability=m;var l;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(l=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class u extends Error{constructor(F,M){super(F);this.code=M}}e.FileSystemProviderError=u;function n($,F){const M=new u($.toString(),F);return i(M,F),M}e.createFileSystemProviderError=n;function s($){return $||n((0,v.localize)(0,null),l.Unknown)}e.ensureFileSystemProviderError=s;function i($,F){return $.name=F?`${F} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=i;function o($){if(!$)return l.Unknown;if($ instanceof u)return $.code;const F=/^(.+) \(FileSystemError\)$/.exec($.name);if(!F)return l.Unknown;switch(F[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileExceedsMemoryLimit:return l.FileExceedsMemoryLimit;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}e.toFileSystemProviderErrorCode=o;function r($){if($ instanceof U)return $.fileOperationResult;switch(o($)){case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 10;case l.FileWriteLocked:return 5;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileExceedsMemoryLimit:return 9;case l.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var a;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY",$[$.WRITE=4]="WRITE"})(a=e.FileOperation||(e.FileOperation={}));class c{constructor(F,M,j){this.resource=F,this.operation=M,this.target=j}isOperation(F){return this.operation===F}}e.FileOperationEvent=c;var f;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(f=e.FileChangeType||(e.FileChangeType={}));class w{constructor(F,M){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=F;const j=new Map;for(const Z of F){const oe=j.get(Z.type);switch(oe?oe.push([Z.resource,Z]):j.set(Z.type,[[Z.resource,Z]]),Z.type){case 1:this.rawAdded.push(Z.resource);break;case 0:this.rawUpdated.push(Z.resource);break;case 2:this.rawDeleted.push(Z.resource);break}}for(const[Z,oe]of j)switch(Z){case 1:this.added=t.TernarySearchTree.forUris(()=>M),this.added.fill(oe);break;case 0:this.updated=t.TernarySearchTree.forUris(()=>M),this.updated.fill(oe);break;case 2:this.deleted=t.TernarySearchTree.forUris(()=>M),this.deleted.fill(oe);break}}contains(F,...M){return this.doContains(F,{includeChildren:!1},...M)}affects(F,...M){return this.doContains(F,{includeChildren:!0},...M)}doContains(F,M,...j){if(!F)return!1;const Z=j.length>0;return!!((!Z||j.includes(1))&&(this.added?.get(F)||M.includeChildren&&this.added?.findSuperstr(F))||(!Z||j.includes(0))&&(this.updated?.get(F)||M.includeChildren&&this.updated?.findSuperstr(F))||(!Z||j.includes(2))&&(this.deleted?.findSubstr(F)||M.includeChildren&&this.deleted?.findSuperstr(F)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=w;function A($,F,M){return!$||!F||$===F||F.length>$.length?!1:(F.charAt(F.length-1)!==b.sep&&(F+=b.sep),M?(0,P.startsWithIgnoreCase)($,F):$.indexOf(F)===0)}e.isParent=A;class U extends I.ErrorNoTelemetry{constructor(F,M,j){super(F);this.fileOperationResult=M,this.options=j}}e.FileOperationError=U;class x extends U{constructor(F,M,j){super(F,2,j);this.stat=M}}e.NotModifiedSinceFileOperationError=x;var Q;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",$[$.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(Q=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var _;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(_=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function Y($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=Y;async function O($,F){if(!F.hasProvider(E.URI.from({scheme:$.scheme})))return new Promise(M=>{const j=F.onDidChangeFileSystemProviderRegistrations(Z=>{Z.scheme===$.scheme&&Z.added&&(j.dispose(),M())})})}e.whenProviderRegistered=O,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class B{static formatSize(F){return(0,k.isNumber)(F)||(F=0),F<B.KB?(0,v.localize)(1,null,F.toFixed(0)):F<B.MB?(0,v.localize)(2,null,(F/B.KB).toFixed(2)):F<B.GB?(0,v.localize)(3,null,(F/B.MB).toFixed(2)):F<B.TB?(0,v.localize)(4,null,(F/B.GB).toFixed(2)):(0,v.localize)(5,null,(F/B.TB).toFixed(2))}}e.ByteSize=B,B.KB=1024,B.MB=B.KB*B.KB,B.GB=B.MB*B.KB,B.TB=B.GB*B.KB;var ue;(function($){$[$.IA32=0]="IA32",$[$.OTHER=1]="OTHER"})(ue=e.Arch||(e.Arch={}));function V($){return{maxFileSize:$===0?300*B.MB:16*B.GB,maxHeapSize:$===0?700*B.MB:2*700*B.MB}}e.getPlatformLimits=V}),define(we[194],ye([0,1,16,36,9,6,2,44,4,27,18]),function(ie,e,I,t,b,P,k,E,v,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class R extends k.Disposable{constructor(y,d){super();this.channel=y,this.extraCapabilities=d,this.onDidChangeCapabilities=P.Event.None,this._onDidChange=this._register(new P.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new P.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,D.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(y){return this.channel.call("stat",[y])}readdir(y){return this.channel.call("readdir",[y])}async readFile(y,d){const{buffer:S}=await this.channel.call("readFile",[y,d]);return S}readFileStream(y,d,S){const h=(0,E.newWriteableStream)(p=>I.VSBuffer.concat(p.map(m=>I.VSBuffer.wrap(m))).buffer),g=this.channel.listen("readFileStream",[y,d])(p=>{if(p instanceof I.VSBuffer)h.write(p.buffer);else{if(p==="end")h.end();else{let m=p;m instanceof Error||(m=(0,T.createFileSystemProviderError)((0,t.toErrorMessage)(m),T.FileSystemProviderErrorCode.Unknown)),h.error(m),h.end()}g.dispose()}});return S.onCancellationRequested(()=>{h.error((0,b.canceled)()),h.end(),g.dispose()}),h}writeFile(y,d,S){return this.channel.call("writeFile",[y,I.VSBuffer.wrap(d),S])}open(y,d){return this.channel.call("open",[y,d])}close(y){return this.channel.call("close",[y])}async read(y,d,S,h,g){const[p,m]=await this.channel.call("read",[y,d,g]);return S.set(p.buffer.slice(0,m),h),m}write(y,d,S,h,g){return this.channel.call("write",[y,d,I.VSBuffer.wrap(S),h,g])}mkdir(y){return this.channel.call("mkdir",[y])}delete(y,d){return this.channel.call("delete",[y,d])}rename(y,d,S){return this.channel.call("rename",[y,d,S])}copy(y,d,S){return this.channel.call("copy",[y,d,S])}cloneFile(y,d){return this.channel.call("cloneFile",[y,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(y=>{if(Array.isArray(y)){const d=y;this._onDidChange.fire(d.map(S=>({resource:v.URI.revive(S.resource),type:S.type})))}else{const d=y;this._onDidWatchError.fire(d)}}))}watch(y,d){const S=(0,D.generateUuid)();return this.channel.call("watch",[this.sessionId,S,y,d]),(0,k.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,S]))}}e.DiskFileSystemProviderClient=R}),define(we[96],ye([0,1,16,9,167,18]),function(ie,e,I,t,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(T,R,C,y,d,S){let h;try{await E(T,R,C,y,d,S)}catch(g){h=g}finally{h&&d.errorTransformer&&(h=d.errorTransformer(h)),typeof h!="undefined"&&C.error(h),C.end()}}e.readFileIntoStream=k;async function E(T,R,C,y,d,S){v(S);const h=await T.open(R,{create:!1});try{v(S);let g=0,p=0,m=d&&typeof d.length=="number"?d.length:void 0,l=I.VSBuffer.alloc(Math.min(d.bufferSize,typeof m=="number"?m:d.bufferSize)),u=d&&typeof d.position=="number"?d.position:0,n=0;do p=await T.read(h,u,l.buffer,n,l.byteLength-n),u+=p,n+=p,g+=p,typeof m=="number"&&(m-=p),n===l.byteLength&&(await C.write(y(l)),l=I.VSBuffer.alloc(Math.min(d.bufferSize,typeof m=="number"?m:d.bufferSize)),n=0);while(p>0&&(typeof m!="number"||m>0)&&v(S)&&D(g,d));if(n>0){let s=n;typeof m=="number"&&(s=Math.min(n,m)),C.write(y(l.slice(0,s)))}}catch(g){throw(0,P.ensureFileSystemProviderError)(g)}finally{await T.close(h)}}function v(T){if(T.isCancellationRequested)throw(0,t.canceled)();return!0}function D(T,R){if(R?.limits){if(typeof R.limits.memory=="number"&&T>R.limits.memory)throw(0,P.createFileSystemProviderError)((0,b.localize)(0,null),P.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof R.limits.size=="number"&&T>R.limits.size)throw(0,P.createFileSystemProviderError)((0,b.localize)(1,null),P.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(we[57],ye([0,1,66,2,5,3,4,18]),function(ie,e,I,t,b,P,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function v(h){return h.recursive===!0}e.isRecursiveWatchRequest=v;class D extends t.Disposable{constructor(g,p,m,l){super();this.onFileChanges=g,this.onLogMessage=p,this.verboseLogging=m,this.options=l,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const g=new t.DisposableStore;this.watcherDisposables.value=g,this.watcher=this.createWatcher(g),this.watcher.setVerboseLogging(this.verboseLogging),g.add(this.watcher.onDidChangeFile(p=>this.onFileChanges(p))),g.add(this.watcher.onDidLogMessage(p=>this.onLogMessage(p))),g.add(this.watcher.onDidError(p=>this.onError(p)))}onError(g){this.options.restartOnError?this.restartCounter<D.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${g}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${g}`):this.error(g)}restart(g){this.restartCounter++,this.init(),this.watch(g)}async watch(g){this.requests=g,await this.watcher?.watch(g)}async setVerboseLogging(g){this.verboseLogging=g,await this.watcher?.setVerboseLogging(g)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${g}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=D,D.MAX_RESTARTS=5;class T extends D{constructor(g,p,m){super(g,p,m,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=T;class R extends D{constructor(g,p,m){super(g,p,m,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=R;function C(h){return h.map(g=>({type:g.type,resource:k.URI.file(g.path)}))}e.toFileChanges=C;function y(h){const g=new S;for(const p of h)g.processEvent(p);return g.coalesce()}e.coalesceEvents=y;function d(h,g){const p=[];for(const m of g){let l=m;typeof l=="string"&&!l.startsWith(I.GLOBSTAR)&&!(0,b.isAbsolute)(l)&&(l={base:h,pattern:l}),p.push((0,I.parse)(l))}return p}e.parseWatcherPatterns=d;class S{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(g){return P.isLinux?g.path:g.path.toLowerCase()}processEvent(g){const p=this.mapPathToChange.get(this.toKey(g));let m=!1;if(p){const l=p.type,u=g.type;p.path!==g.path&&(g.type===2||g.type===1)?m=!0:l===1&&u===2?(this.mapPathToChange.delete(this.toKey(g)),this.coalesced.delete(p)):l===2&&u===1?p.type=0:l===1&&u===0||(p.type=u)}else m=!0;m&&(this.coalesced.add(g),this.mapPathToChange.set(this.toKey(g),g))}coalesce(){const g=[],p=[];return Array.from(this.coalesced).filter(m=>m.type!==2?(g.push(m),!1):!0).sort((m,l)=>m.path.length-l.path.length).filter(m=>p.some(l=>(0,E.isParent)(m.path,l,!P.isLinux))?!1:(p.push(m.path),!0)).concat(g)}}}),define(we[195],ye([0,1,30,14,20,33,2,82,5,3,142,22,57]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class y extends k.Disposable{constructor(h,g,p,m){super();this.request=h,this.onDidFilesChange=g,this.onLogMessage=p,this.verboseLogging=m,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},l=>this.onDidFilesChange(l)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(y.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,C.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,C.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new b.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const h=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const g=await R.Promises.stat(h);this._register(await this.doWatch(h,g.isDirectory()))}catch(h){h.code!=="ENOENT"?this.error(h):this.trace(h)}}async normalizePath(h){let g=h.path;try{g=await R.Promises.realpath(h.path),h.path===g&&(g=await(0,T.realcase)(h.path)??h.path),h.path!==g&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${h.path}, real: ${g})`)}catch{}return g}async doWatch(h,g){if(D.isMacintosh&&(0,P.isEqualOrParent)(h,"/Volumes/",!0))return this.error(`Refusing to watch ${h} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),k.Disposable.None;const p=new b.CancellationTokenSource(this.cts.token);let m=new k.DisposableStore;try{const l=(0,v.basename)(h),u=(0,I.watch)(h);m.add((0,k.toDisposable)(()=>{u.removeAllListeners(),u.close()})),this.trace(`Started watching: '${h}'`);const n=new Set;if(g)try{for(const i of await R.Promises.readdir(h))n.add(i)}catch(i){this.error(i)}const s=new Map;m.add((0,k.toDisposable)(()=>{for(const[,i]of s)i.dispose();s.clear()})),u.on("error",(i,o)=>{this.error(`Failed to watch ${h} for changes using fs.watch() (${i}, ${o})`),this.dispose()}),u.on("change",(i,o)=>{if(p.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${o}`);let r="";if(o&&(r=o.toString(),D.isMacintosh&&(r=(0,E.normalizeNFC)(r))),!(!r||i!=="change"&&i!=="rename"))if(g)if(i==="rename"){s.get(r)?.dispose();const a=setTimeout(async()=>{if(s.delete(r),r===l&&!await R.Promises.exists(h)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const c=await this.existsChildStrictCase((0,v.join)(h,r));if(p.token.isCancellationRequested)return;let f;c?n.has(r)?f=0:(f=1,n.add(r)):(n.delete(r),f=2),this.onFileChange({path:(0,v.join)(this.request.path,r),type:f})},y.FILE_DELETE_HANDLER_DELAY);s.set(r,(0,k.toDisposable)(()=>clearTimeout(a)))}else{let a;n.has(r)?a=0:(a=1,n.add(r)),this.onFileChange({path:(0,v.join)(this.request.path,r),type:a})}else if(i==="rename"||r!==l){const a=setTimeout(async()=>{const c=await R.Promises.exists(h);p.token.isCancellationRequested||(c?(this.onFileChange({path:this.request.path,type:0},!0),m.add(await this.doWatch(h,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},y.FILE_DELETE_HANDLER_DELAY);m.clear(),m.add((0,k.toDisposable)(()=>clearTimeout(a)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(l){await R.Promises.exists(h)&&!p.token.isCancellationRequested&&this.error(`Failed to watch ${h} for changes using fs.watch() (${l.toString()})`)}return(0,k.toDisposable)(()=>{p.dispose(!0),m.dispose()})}async onFileChange(h,g=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`),!g&&this.excludes.some(p=>p(h.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${h.path}`):!g&&this.includes&&this.includes.length>0&&!this.includes.some(p=>p(h.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${h.path}`):this.fileChangesBuffer.push(h);try{await this.fileChangesDelayer.trigger(async()=>{const p=this.fileChangesBuffer;this.fileChangesBuffer=[];const m=(0,C.coalesceEvents)(p);if(m.length>0){if(this.verboseLogging)for(const u of m)this.trace(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);this.throttledFileChangesWorker.work(m)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${m[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${m.length}, most recent change: ${m[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(h){if(D.isLinux)return R.Promises.exists(h);try{const g=(0,v.basename)(h);return(await R.Promises.readdir((0,v.dirname)(h))).some(m=>m===g)}catch(g){return this.trace(g),!1}}setVerboseLogging(h){this.verboseLogging=h}error(h){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${h}`})}warn(h){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${h}`})}trace(h){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${h}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=y,y.FILE_DELETE_HANDLER_DELAY=100,y.FILE_CHANGES_HANDLER_DELAY=50;async function d(S,h,g,p,m=512){const l=await R.Promises.open(S,"r"),u=Buffer.allocUnsafe(m),n=new b.CancellationTokenSource(p);let s,i=!1;const o={path:S,excludes:[],recursive:!1},r=new y(o,a=>{(async()=>{for(const{type:c}of a)if(c===0){if(i)return;i=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:f}=await R.Promises.read(l,u,0,m,null);if(!f||n.token.isCancellationRequested)break;h(u.slice(0,f))}}catch(f){s=new Error(f),n.dispose(!0)}finally{i=!1}}})()});return await r.ready,g(),new Promise((a,c)=>{n.token.onCancellationRequested(async()=>{r.dispose();try{await R.Promises.close(l)}catch(f){s=new Error(f)}s?c(s):a()})})}e.watchFileContents=d}),define(we[196],ye([0,1,6,66,2,3,195]),function(ie,e,I,t,b,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class E extends b.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new I.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=I.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(D){const T=this.normalizeRequests(D),R=T.filter(y=>{const d=this.watchers.get(y.path);return d?!(0,t.patternsEquals)(d.request.excludes,y.excludes)||!(0,t.patternsEquals)(d.request.includes,y.includes):!0}),C=Array.from(this.watchers.values()).filter(({request:y})=>!T.find(d=>d.path===y.path&&(0,t.patternsEquals)(d.excludes,y.excludes)&&(0,t.patternsEquals)(d.includes,y.includes))).map(({request:y})=>y.path);R.length&&this.trace(`Request to start watching: ${R.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?y.includes:"<all>"})`).join(",")}`),C.length&&this.trace(`Request to stop watching: ${C.join(",")}`);for(const y of C)this.stopWatching(y);for(const y of R)this.startWatching(y)}startWatching(D){const T=new k.NodeJSFileWatcherLibrary(D,C=>this._onDidChangeFile.fire(C),C=>this._onDidLogMessage.fire(C),this.verboseLogging),R={request:D,instance:T};this.watchers.set(D.path,R)}async stop(){for(const[D]of this.watchers)this.stopWatching(D);this.watchers.clear()}stopWatching(D){const T=this.watchers.get(D);T&&(this.watchers.delete(D),T.instance.dispose())}normalizeRequests(D){const T=new Map;for(const R of D){const C=P.isLinux?R.path:R.path.toLowerCase();T.set(C,R)}return Array.from(T.values())}async setVerboseLogging(D){this.verboseLogging=D;for(const[,T]of this.watchers)T.instance.setVerboseLogging(D)}trace(D){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(D)})}toMessage(D,T){return T?`[File Watcher (node.js)] ${D} (path: ${T.request.path})`:`[File Watcher (node.js)] ${D}`}}e.NodeJSWatcher=E}),define(we[197],ye([0,1,57,196]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class b extends I.AbstractNonRecursiveWatcherClient{constructor(k,E,v){super(k,E,v);this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=b}),define(we[198],ye([0,1,8,39,93,57]),function(ie,e,I,t,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class k extends P.AbstractUniversalWatcherClient{constructor(v,D,T){super(v,D,T);this.init()}createWatcher(v){const D=v.add(new b.Client(I.FileAccess.asFileUri("bootstrap-fork",ie).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return v.add(D.onDidProcessExit(({code:T,signal:R})=>this.onError(`terminated by itself with code ${T}, signal: ${R}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(D.getChannel("watcher")))}}e.UniversalWatcherClient=k}),define(we[72],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class I{constructor(...b){this._entries=new Map;for(let[P,k]of b)this.set(P,k)}set(b,P){const k=this._entries.get(b);return this._entries.set(b,P),k}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}e.ServiceCollection=I}),define(we[97],ye([0,1,14,9,56,190,7,72]),function(ie,e,I,t,b,P,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const v=!1;class D extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class T{constructor(d=new E.ServiceCollection,S=!1,h){this._activeInstantiations=new Set,this._services=d,this._strict=S,this._parent=h,this._services.set(k.IInstantiationService,this)}createChild(d){return new T(d,this._strict,this)}invokeFunction(d,...S){let h=C.traceInvocation(d),g=!1;try{return d({get:m=>{if(g)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(m,h);if(!l)throw new Error(`[invokeFunction] unknown service '${m}'`);return l}},...S)}finally{g=!0,h.stop()}}createInstance(d,...S){let h,g;return d instanceof b.SyncDescriptor?(h=C.traceCreation(d.ctor),g=this._createInstance(d.ctor,d.staticArguments.concat(S),h)):(h=C.traceCreation(d),g=this._createInstance(d,S,h)),h.stop(),g}_createInstance(d,S=[],h){let g=k._util.getServiceDependencies(d).sort((l,u)=>l.index-u.index),p=[];for(const l of g){let u=this._getOrCreateServiceInstance(l.id,h);u||this._throwIfStrict(`[createInstance] ${d.name} depends on UNKNOWN service ${l.id}.`,!1),p.push(u)}let m=g.length>0?g[0].index:S.length;if(S.length!==m){console.trace(`[createInstance] First service dependency of ${d.name} at position ${m+1} conflicts with ${S.length} static arguments`);let l=m-S.length;l>0?S=S.concat(new Array(l)):S=S.slice(0,m)}return new d(...[...S,...p])}_setServiceInstance(d,S){if(this._services.get(d)instanceof b.SyncDescriptor)this._services.set(d,S);else if(this._parent)this._parent._setServiceInstance(d,S);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let S=this._services.get(d);return!S&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):S}_getOrCreateServiceInstance(d,S){let h=this._getServiceInstanceOrDescriptor(d);return h instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,h,S.branch(d,!0)):(S.branch(d,!1),h)}_safeCreateAndCacheServiceInstance(d,S,h){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,S,h)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,S,h){const g=new P.Graph(l=>l.id.toString());let p=0;const m=[{id:d,desc:S,_trace:h}];for(;m.length;){const l=m.pop();if(g.lookupOrInsertNode(l),p++>1e3)throw new D(g);for(let u of k._util.getServiceDependencies(l.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(u.id);if(n||this._throwIfStrict(`[createInstance] ${d} depends on ${u.id} which is NOT registered.`,!0),n instanceof b.SyncDescriptor){const s={id:u.id,desc:n,_trace:l._trace.branch(u.id,!0)};g.insertEdge(l,s),m.push(s)}}}for(;;){const l=g.roots();if(l.length===0){if(!g.isEmpty())throw new D(g);break}for(const{data:u}of l){if(this._getServiceInstanceOrDescriptor(u.id)instanceof b.SyncDescriptor){const s=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,s)}g.removeNode(u)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,S,h=[],g,p){if(this._services.get(d)instanceof b.SyncDescriptor)return this._createServiceInstance(S,h,g,p);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,S,h,g,p);throw new Error(`illegalState - creating UNKNOWN service instance ${S.name}`)}_createServiceInstance(d,S=[],h,g){if(h){const p=new I.IdleValue(()=>this._createInstance(d,S,g));return new Proxy(Object.create(null),{get(m,l){if(l in m)return m[l];let u=p.value,n=u[l];return typeof n!="function"||(n=n.bind(u),m[l]=n),n},set(m,l,u){return p.value[l]=u,!0}})}else return this._createInstance(d,S,g)}_throwIfStrict(d,S){if(S&&console.warn(S),this._strict)throw new Error(d)}}e.InstantiationService=T;var R;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(R||(R={}));class C{constructor(d,S){this.type=d,this.name=S,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return v?new C(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):C._None}static traceCreation(d){return v?new C(0,d.name):C._None}branch(d,S){let h=new C(2,d.toString());return this._dep.push([d,S,h]),h}stop(){let d=Date.now()-this._start;C._totals+=d;let S=!1;function h(p,m){let l=[],u=new Array(p+1).join("	");for(const[n,s,i]of m._dep)if(s&&i){S=!0,l.push(`${u}CREATES -> ${n}`);let o=h(p+1,i);o&&l.push(o)}else l.push(`${u}uses -> ${n}`);return l.join(`
`)}let g=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${C._totals.toFixed(2)}ms)`];(d>2||S)&&console.log(g.join(`
`))}}e.Trace=C,C._None=new class extends C{constructor(){super(-1,null)}stop(){}branch(){return this}},C._totals=0}),define(we[199],ye([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILabelService=void 0,e.ILabelService=(0,I.createDecorator)("labelService")});var Fe=this&&this.__param||function(ie,e){return function(I,t){e(I,t,ie)}};define(we[73],ye([0,1,20,2,3,169,31,7]),function(ie,e,I,t,b,P,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,E.createDecorator)("languagePackService");let v=class extends t.Disposable{constructor(T){super();this.extensionGalleryService=T}async getAvailableLanguages(){const T=new I.CancellationTokenSource;setTimeout(()=>T.cancel(),1e3);let R;try{R=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},T.token)}catch{return[]}const y=R.firstPage.filter(d=>d.properties.localizedLanguages?.length&&d.tags.some(S=>S.startsWith("lp-"))).map(d=>{const S=d.properties.localizedLanguages?.[0],h=d.tags.find(p=>p.startsWith("lp-")).split("lp-")[1];return{...this.createQuickPickItem({locale:h,label:S}),extensionId:d.identifier.id,galleryExtension:d}});return y.push({...this.createQuickPickItem({locale:"en",label:"English"}),extensionId:"default"}),y}createQuickPickItem(T){const R=T.label??T.locale;let C=T.locale!==T.label?T.locale:void 0;return T.locale.toLowerCase()===b.language.toLowerCase()&&(C||(C=""),C+=(0,P.localize)(0,null)),{id:T.locale,label:R,description:C}}};v=Re([Fe(0,k.IExtensionGalleryService)],v),e.LanguagePackBaseService=v}),define(we[13],ye([0,1,36,6,2,3,7]),function(ie,e,I,t,b,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function E(){return new Date().toISOString()}var v;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(v=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=v.Info;function D(s,i,o){switch(i){case v.Trace:s.trace(o);break;case v.Debug:s.debug(o);break;case v.Info:s.info(o);break;case v.Warning:s.warn(o);break;case v.Error:s.error(o);break;case v.Critical:s.critical(o);break;default:throw new Error("Invalid log level")}}e.log=D;function T(s){let i="";for(let o=0;o<s.length;o++){let r=s[o];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}i+=(o>0?" ":"")+r}return i}e.format=T;class R extends b.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=R;class C extends R{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...o){this.checkLogLevel(v.Trace)&&this.log(v.Trace,T([i,...o]))}debug(i,...o){this.checkLogLevel(v.Debug)&&this.log(v.Debug,T([i,...o]))}info(i,...o){this.checkLogLevel(v.Info)&&this.log(v.Info,T([i,...o]))}warn(i,...o){this.checkLogLevel(v.Warning)&&this.log(v.Warning,T([i,...o]))}error(i,...o){if(this.checkLogLevel(v.Error))if(i instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=i.stack,this.log(v.Error,T(r))}else this.log(v.Error,T([i,...o]))}critical(i,...o){this.checkLogLevel(v.Critical)&&this.log(v.Critical,T([i,...o]))}flush(){}}e.AbstractMessageLogger=C;class y extends R{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!P.isWindows}trace(i,...o){this.getLevel()<=v.Trace&&(this.useColors?console.log(`[90m[main ${E()}][0m`,i,...o):console.log(`[main ${E()}]`,i,...o))}debug(i,...o){this.getLevel()<=v.Debug&&(this.useColors?console.log(`[90m[main ${E()}][0m`,i,...o):console.log(`[main ${E()}]`,i,...o))}info(i,...o){this.getLevel()<=v.Info&&(this.useColors?console.log(`[90m[main ${E()}][0m`,i,...o):console.log(`[main ${E()}]`,i,...o))}warn(i,...o){this.getLevel()<=v.Warning&&(this.useColors?console.warn(`[93m[main ${E()}][0m`,i,...o):console.warn(`[main ${E()}]`,i,...o))}error(i,...o){this.getLevel()<=v.Error&&(this.useColors?console.error(`[91m[main ${E()}][0m`,i,...o):console.error(`[main ${E()}]`,i,...o))}critical(i,...o){this.getLevel()<=v.Critical&&(this.useColors?console.error(`[90m[main ${E()}][0m`,i,...o):console.error(`[main ${E()}]`,i,...o))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class d extends R{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...o){this.getLevel()<=v.Trace&&console.log("%cTRACE","color: #888",i,...o)}debug(i,...o){this.getLevel()<=v.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...o)}info(i,...o){this.getLevel()<=v.Info&&console.log("%c INFO","color: #33f",i,...o)}warn(i,...o){this.getLevel()<=v.Warning&&console.log("%c WARN","color: #993",i,...o)}error(i,...o){this.getLevel()<=v.Error&&console.log("%c  ERR","color: #f33",i,...o)}critical(i,...o){this.getLevel()<=v.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...o)}dispose(){}flush(){}}e.ConsoleLogger=d;class S extends R{constructor(i,o=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(o)}trace(i,...o){this.getLevel()<=v.Trace&&this.adapter.log(v.Trace,[this.extractMessage(i),...o])}debug(i,...o){this.getLevel()<=v.Debug&&this.adapter.log(v.Debug,[this.extractMessage(i),...o])}info(i,...o){this.getLevel()<=v.Info&&this.adapter.log(v.Info,[this.extractMessage(i),...o])}warn(i,...o){this.getLevel()<=v.Warning&&this.adapter.log(v.Warning,[this.extractMessage(i),...o])}error(i,...o){this.getLevel()<=v.Error&&this.adapter.log(v.Error,[this.extractMessage(i),...o])}critical(i,...o){this.getLevel()<=v.Critical&&this.adapter.log(v.Critical,[this.extractMessage(i),...o])}extractMessage(i){return typeof i=="string"?i:(0,I.toErrorMessage)(i,this.getLevel()<=v.Trace)}dispose(){}flush(){}}e.AdapterLogger=S;class h extends R{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const o of this.logServices)o.setLevel(i);super.setLevel(i)}trace(i,...o){for(const r of this.logServices)r.trace(i,...o)}debug(i,...o){for(const r of this.logServices)r.debug(i,...o)}info(i,...o){for(const r of this.logServices)r.info(i,...o)}warn(i,...o){for(const r of this.logServices)r.warn(i,...o)}error(i,...o){for(const r of this.logServices)r.error(i,...o)}critical(i,...o){for(const r of this.logServices)r.critical(i,...o)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=h;class g extends b.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...o){this.logger.trace(i,...o)}debug(i,...o){this.logger.debug(i,...o)}info(i,...o){this.logger.info(i,...o)}warn(i,...o){this.logger.warn(i,...o)}error(i,...o){this.logger.error(i,...o)}critical(i,...o){this.logger.critical(i,...o)}flush(){this.logger.flush()}}e.LogService=g;class p extends b.Disposable{constructor(i,o){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(o(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(r))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,o){let r=this.loggers.get(i.toString());return r||(r=this.doCreateLogger(i,o?.always?v.Trace:this.logLevel,o),this.loggers.set(i.toString(),r),o?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class m{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(i){}getLevel(){return v.Info}trace(i,...o){}debug(i,...o){}info(i,...o){}warn(i,...o){}error(i,...o){}critical(i,...o){}dispose(){}flush(){}}e.NullLogService=m;function l(s){if(s.verbose)return v.Trace;if(typeof s.logLevel=="string"){const i=u(s.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function u(s){switch(s){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Critical;case"off":return v.Off}}e.parseLogLevel=u;function n(s){switch(s){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Critical:return"critical";case v.Off:return"off"}}e.LogLevelToString=n}),define(we[200],ye([0,1,70,6,2,13,3]),function(ie,e,I,t,b,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let E=class zt extends b.Disposable{constructor(D){super();this.logService=D,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(D,T){let R;try{R=await this.withKeytar()}catch{return null}const C=await R.getPassword(D,T);if(C)try{let{content:y,hasNextChunk:d}=JSON.parse(C);if(!y||!d)return C;let S=1;for(;d;){const h=await R.getPassword(D,`${T}-${S}`),g=JSON.parse(h);y+=g.content,d=g.hasNextChunk,S++}return y}catch{return C}return C}async setPassword(D,T,R){let C;try{C=await this.withKeytar()}catch(S){throw this.surfaceKeytarLoadError?.(S),S}const y=3,d=async(S,h,g)=>{let p=0,m;for(;p<y;)try{await C.setPassword(S,h,g);return}catch(l){m=l,this.logService.warn("Error attempting to set a password: ",l?.message??l),p++,await new Promise(u=>setTimeout(u,200))}throw m};if(k.isWindows&&R.length>zt.MAX_PASSWORD_LENGTH){let S=0,h=0,g=!0;for(;g;){const p=R.substring(S,S+zt.PASSWORD_CHUNK_SIZE);S+=zt.PASSWORD_CHUNK_SIZE,g=R.length-S>0;const m={content:p,hasNextChunk:g};await d(D,h?`${T}-${h}`:T,JSON.stringify(m)),h++}}else await d(D,T,R);this._onDidChangePassword.fire({service:D,account:T})}async deletePassword(D,T){let R;try{R=await this.withKeytar()}catch(d){throw this.surfaceKeytarLoadError?.(d),d}const C=await R.getPassword(D,T);if(!C)return!1;const y=await R.deletePassword(D,T);try{let{content:d,hasNextChunk:S}=JSON.parse(C);if(d&&S){let h=1;for(;S;){const g=`${T}-${h}`,p=await R.getPassword(D,g);await R.deletePassword(D,g),S=JSON.parse(p).hasNextChunk,h++}}}catch{}return y&&this._onDidChangePassword.fire({service:D,account:T}),y}async findPassword(D){let T;try{T=await this.withKeytar()}catch{return null}return T.findPassword(D)}async findCredentials(D){let T;try{T=await this.withKeytar()}catch{return[]}return T.findCredentials(D)}clear(){return this._keytarCache instanceof I.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};E.MAX_PASSWORD_LENGTH=2500,E.PASSWORD_CHUNK_SIZE=E.MAX_PASSWORD_LENGTH-100,E=Re([Fe(0,P.ILogService)],E),e.BaseCredentialsMainService=E}),define(we[201],ye([0,1,38,14,36,6,2,8,5,22,24,13]),function(ie,e,I,t,b,P,k,E,v,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let C=class extends k.Disposable{constructor(d,S){super();this.environmentService=d,this.logService=S,this.processesLimiter=new t.Limiter(5)}async postUninstall(d){const S=this.parseScript(d,"uninstall");return S&&(this.logService.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(S.script,"uninstall",S.args,!0,d).then(()=>this.logService.info(d.identifier.id,d.manifest.version,"Finished running post uninstall script"),h=>this.logService.error(d.identifier.id,d.manifest.version,`Failed to run post uninstall script: ${h}`)))),D.Promises.rm(this.getExtensionStoragePath(d)).then(void 0,h=>this.logService.error("Error while removing extension storage path",h))}parseScript(d,S){const h=`vscode:${S}`;if(d.location.scheme===E.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[h]=="string"){const g=d.manifest.scripts[h].split(" ");return g.length<2||g[0]!=="node"||!g[1]?(this.logService.warn(d.identifier.id,d.manifest.version,`${h} should be a node script`),null):{script:(0,v.join)(d.location.fsPath,g[1]),args:g.slice(2)||[]}}return null}runLifecycleHook(d,S,h,g,p){return new Promise((m,l)=>{const u=this.start(d,S,h,p);let n;const s=i=>{n&&(clearTimeout(n),n=null),i?l(i):m(void 0)};u.on("error",i=>{s((0,b.toErrorMessage)(i)||"Unknown")}),u.on("exit",(i,o)=>{s(i?`post-${S} process exited with code ${i}`:void 0)}),g&&(n=setTimeout(()=>{n=null,u.kill(),l("timed out")},5e3))})}start(d,S,h,g){const p={silent:!0,execArgv:void 0},m=(0,I.fork)(d,[`--type=extension-post-${S}`,...h],p);m.stdout.setEncoding("utf8"),m.stderr.setEncoding("utf8");const l=P.Event.fromNodeEventEmitter(m.stdout,"data"),u=P.Event.fromNodeEventEmitter(m.stderr,"data");l(i=>this.logService.info(g.identifier.id,g.manifest.version,`post-${S}`,i)),u(i=>this.logService.error(g.identifier.id,g.manifest.version,`post-${S}`,i));const n=P.Event.any(P.Event.map(l,i=>({data:`%c${i}`,format:[""]})),P.Event.map(u,i=>({data:`%c${i}`,format:["color: red"]})));return P.Event.debounce(n,(i,o)=>i?{data:i.data+o.data,format:[...i.format,...o.format]}:{data:o.data,format:o.format},100)(i=>{console.group(g.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),m}getExtensionStoragePath(d){return(0,v.join)(this.environmentService.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};C=Re([Fe(0,T.IEnvironmentService),Fe(1,R.ILogService)],C),e.ExtensionsLifecycle=C}),define(we[202],ye([0,1,17,14,9,6,2,5,57,13]),function(ie,e,I,t,b,P,k,E,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class T extends k.Disposable{constructor(C,y){super();this.logService=C,this.options=y,this._onDidChangeFile=this._register(new P.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new P.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(C,y){return y.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(C,y):this.watchNonRecursive(C,y)}watchUniversal(C,y){const d={path:this.toFilePath(C),excludes:y.excludes,includes:y.includes,recursive:y.recursive},S=(0,I.insert)(this.universalPathsToWatch,d);return this.refreshUniversalWatchers(),(0,k.toDisposable)(()=>{S(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(C=>(0,b.onUnexpectedError)(C))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(y=>this._onDidChangeFile.fire((0,v.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===D.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===D.LogLevel.Trace)})));const C=this.options?.watcher?.recursive?.usePolling;if(C===!0)for(const y of this.universalPathsToWatch)(0,v.isRecursiveWatchRequest)(y)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(C))for(const y of this.universalPathsToWatch)(0,v.isRecursiveWatchRequest)(y)&&C.includes(y.path)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(C,y){const d={path:this.toFilePath(C),excludes:y.excludes,includes:y.includes,recursive:!1},S=(0,I.insert)(this.nonRecursivePathsToWatch,d);return this.refreshNonRecursiveWatchers(),(0,k.toDisposable)(()=>{S(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(C=>(0,b.onUnexpectedError)(C))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(C=>this._onDidChangeFile.fire((0,v.toFileChanges)(C)),C=>this.onWatcherLogMessage(C),this.logService.getLevel()===D.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===D.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(C){C.type==="error"&&this._onDidWatchError.fire(C.message),this.logService[C.type](C.message)}toFilePath(C){return(0,E.normalize)(C.fsPath)}}e.AbstractDiskFileSystemProvider=T}),define(we[98],ye([0,1,17,14,16,20,6,136,43,2,29,8,46,19,44,165,18,96,13]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C,y,d,S,h,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let m=class extends D.Disposable{constructor(u){super();this.logService=u,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(u,n){if(this.provider.has(u))throw new Error(`A filesystem provider for the scheme '${u}' is already registered.`);(0,C.mark)(`code/registerFilesystem/${u}`);const s=new D.DisposableStore;return this.provider.set(u,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:u,provider:n}),s.add(n.onDidChangeFile(i=>this._onDidFilesChange.fire(new h.FileChangesEvent(i,!this.isPathCaseSensitive(n))))),typeof n.onDidWatchError=="function"&&s.add(n.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),s.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:u}))),(0,D.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:u,provider:n}),this.provider.delete(u),(0,D.dispose)(s)})}getProvider(u){return this.provider.get(u)}async activateProvider(u){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:u,join(s){n.push(s)}}),!this.provider.has(u)&&await t.Promises.settled(n)}async canHandleResource(u){return await this.activateProvider(u.scheme),this.hasProvider(u)}hasProvider(u){return this.provider.has(u.scheme)}hasCapability(u,n){const s=this.provider.get(u.scheme);return!!(s&&s.capabilities&n)}listCapabilities(){return v.Iterable.map(this.provider,([u,n])=>({scheme:u,capabilities:n.capabilities}))}async withProvider(u){if(!(0,y.isAbsolutePath)(u))throw new h.FileOperationError((0,S.localize)(0,null,this.resourceForError(u)),8);await this.activateProvider(u.scheme);const n=this.provider.get(u.scheme);if(!n){const s=new Error;throw s.name="ENOPRO",s.message=(0,S.localize)(1,null,u.toString()),s}return n}async withReadProvider(u){const n=await this.withProvider(u);if((0,h.hasOpenReadWriteCloseCapability)(n)||(0,h.hasReadWriteCapability)(n)||(0,h.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${u.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(u){const n=await this.withProvider(u);if((0,h.hasOpenReadWriteCloseCapability)(n)||(0,h.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${u.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(u,n){try{return await this.doResolveFile(u,n)}catch(s){throw(0,h.toFileSystemProviderErrorCode)(s)===h.FileSystemProviderErrorCode.FileNotFound?new h.FileOperationError((0,S.localize)(2,null,this.resourceForError(u)),1):(0,h.ensureFileSystemProviderError)(s)}}async doResolveFile(u,n){const s=await this.withProvider(u),i=this.isPathCaseSensitive(s),o=n?.resolveTo,r=n?.resolveSingleChildDescendants,a=n?.resolveMetadata,c=await s.stat(u);let f;return this.toFileStat(s,u,c,void 0,!!a,(w,A)=>(f||(f=T.TernarySearchTree.forUris(()=>!i),f.set(u,!0),o&&f.fill(!0,o)),f.get(w.resource)||f.findSuperstr(w.resource.with({query:null,fragment:null}))?!0:w.isDirectory&&r?A===1:!1))}async toFileStat(u,n,s,i,o,r){const{providerExtUri:a}=this.getExtUri(u),c={resource:n,name:a.basename(n),isFile:(s.type&h.FileType.File)!=0,isDirectory:(s.type&h.FileType.Directory)!=0,isSymbolicLink:(s.type&h.FileType.SymbolicLink)!=0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:Boolean((s.permissions??0)&h.FilePermission.Readonly)||Boolean(u.capabilities&2048),etag:(0,h.etag)({mtime:s.mtime,size:s.size}),children:void 0};if(c.isDirectory&&r(c,i)){try{const f=await u.readdir(n),w=await t.Promises.settled(f.map(async([A,U])=>{try{const x=a.joinPath(n,A),Q=o?await u.stat(x):{type:U};return await this.toFileStat(u,x,Q,f.length,o,r)}catch(x){return this.logService.trace(x),null}}));c.children=(0,I.coalesce)(w)}catch(f){this.logService.trace(f),c.children=[]}return c}return c}async resolveAll(u){return t.Promises.settled(u.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(s){return this.logService.trace(s),{stat:void 0,success:!1}}}))}async stat(u){const n=await this.withProvider(u),s=await n.stat(u);return this.toFileStat(n,u,s,void 0,!0,()=>!1)}async exists(u){const n=await this.withProvider(u);try{return!!await n.stat(u)}catch{return!1}}async canCreateFile(u,n){try{await this.doValidateCreateFile(u,n)}catch(s){return s}return!0}async doValidateCreateFile(u,n){if(!n?.overwrite&&await this.exists(u))throw new h.FileOperationError((0,S.localize)(3,null,this.resourceForError(u)),3,n)}async createFile(u,n=b.VSBuffer.fromString(""),s){await this.doValidateCreateFile(u,s);const i=await this.writeFile(u,n);return this._onDidRunOperation.fire(new h.FileOperationEvent(u,0,i)),i}async writeFile(u,n,s){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),{providerExtUri:o}=this.getExtUri(i);try{await this.validateWriteFile(i,u,s)||await this.mkdirp(i,o.dirname(u));let a;if((0,h.hasReadWriteCapability)(i)&&!(n instanceof b.VSBuffer))if((0,d.isReadableStream)(n)){const c=await(0,d.peekStream)(n,3);c.ended?a=b.VSBuffer.concat(c.buffer):a=c}else a=(0,d.peekReadable)(n,c=>b.VSBuffer.concat(c),3);else a=n;!(0,h.hasOpenReadWriteCloseCapability)(i)||(0,h.hasReadWriteCapability)(i)&&a instanceof b.VSBuffer?await this.doWriteUnbuffered(i,u,s,a):await this.doWriteBuffered(i,u,s,a instanceof b.VSBuffer?(0,b.bufferToReadable)(a):a),this._onDidRunOperation.fire(new h.FileOperationEvent(u,4))}catch(r){throw new h.FileOperationError((0,S.localize)(4,null,this.resourceForError(u),(0,h.ensureFileSystemProviderError)(r).toString()),(0,h.toFileOperationResult)(r),s)}return this.resolve(u,{resolveMetadata:!0})}async validateWriteFile(u,n,s){if(!!s?.unlock&&!(u.capabilities&8192))throw new Error((0,S.localize)(5,null,this.resourceForError(n)));let o;try{o=await u.stat(n)}catch{return}if((o.type&h.FileType.Directory)!=0)throw new h.FileOperationError((0,S.localize)(6,null,this.resourceForError(n)),0,s);if(this.throwIfFileIsReadonly(n,o),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==h.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&s.mtime<o.mtime&&s.etag!==(0,h.etag)({mtime:s.mtime,size:o.size}))throw new h.FileOperationError((0,S.localize)(7,null),3,s);return o}async readFile(u,n,s){const i=await this.withReadProvider(u);return n?.atomic?this.doReadFileAtomic(i,u,n,s):this.doReadFile(i,u,n,s)}async doReadFileAtomic(u,n,s,i){return new Promise((o,r)=>{this.writeQueue.queueFor(n,this.getExtUri(u).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(u,n,s,i);o(a)}catch(a){r(a)}})})}async doReadFile(u,n,s,i){const o=await this.doReadFileStream(u,n,{...s,preferUnbuffered:!0},i);return{...o,value:await(0,b.streamToBuffer)(o.value)}}async readFileStream(u,n,s){const i=await this.withReadProvider(u);return this.doReadFileStream(i,u,n,s)}async doReadFileStream(u,n,s,i){const o=new P.CancellationTokenSource(i),r=this.validateReadFile(n,s).then(c=>c,c=>{throw o.cancel(),c});let a;try{return typeof s?.etag=="string"&&s.etag!==h.ETAG_DISABLED&&await r,s?.atomic&&(0,h.hasFileAtomicReadCapability)(u)||!((0,h.hasOpenReadWriteCloseCapability)(u)||(0,h.hasFileReadStreamCapability)(u))||(0,h.hasReadWriteCapability)(u)&&s?.preferUnbuffered?a=this.readFileUnbuffered(u,n,s):(0,h.hasFileReadStreamCapability)(u)?a=this.readFileStreamed(u,n,o.token,s):a=this.readFileBuffered(u,n,o.token,s),{...await r,value:a}}catch(c){a&&await(0,d.consumeStream)(a);const f=(0,S.localize)(8,null,this.resourceForError(n),(0,h.ensureFileSystemProviderError)(c).toString());throw c instanceof h.NotModifiedSinceFileOperationError?new h.NotModifiedSinceFileOperationError(f,c.stat,s):new h.FileOperationError(f,(0,h.toFileOperationResult)(c),s)}}readFileStreamed(u,n,s,i=Object.create(null)){const o=u.readFileStream(n,i,s);return(0,d.transform)(o,{data:r=>r instanceof b.VSBuffer?r:b.VSBuffer.wrap(r),error:r=>new h.FileOperationError((0,S.localize)(9,null,this.resourceForError(n),(0,h.ensureFileSystemProviderError)(r).toString()),(0,h.toFileOperationResult)(r),i)},r=>b.VSBuffer.concat(r))}readFileBuffered(u,n,s,i=Object.create(null)){const o=(0,b.newWriteableBufferStream)();return(0,g.readFileIntoStream)(u,n,o,r=>r,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new h.FileOperationError((0,S.localize)(10,null,this.resourceForError(n),(0,h.ensureFileSystemProviderError)(r).toString()),(0,h.toFileOperationResult)(r),i)},s),o}readFileUnbuffered(u,n,s){const i=(0,d.newWriteableStream)(o=>b.VSBuffer.concat(o));return(async()=>{try{let o;s?.atomic&&(0,h.hasFileAtomicReadCapability)(u)?o=await u.readFile(n,{atomic:!0}):o=await u.readFile(n),typeof s?.position=="number"&&(o=o.slice(s.position)),typeof s?.length=="number"&&(o=o.slice(0,s.length)),this.validateReadFileLimits(n,o.byteLength,s),i.end(b.VSBuffer.wrap(o))}catch(o){i.error(o),i.end()}})(),i}async validateReadFile(u,n){const s=await this.resolve(u,{resolveMetadata:!0});if(s.isDirectory)throw new h.FileOperationError((0,S.localize)(11,null,this.resourceForError(u)),0,n);if(typeof n?.etag=="string"&&n.etag!==h.ETAG_DISABLED&&n.etag===s.etag)throw new h.NotModifiedSinceFileOperationError((0,S.localize)(12,null),s,n);return this.validateReadFileLimits(u,s.size,n),s}validateReadFileLimits(u,n,s){if(s?.limits){let i;if(typeof s.limits.memory=="number"&&n>s.limits.memory&&(i=9),typeof s.limits.size=="number"&&n>s.limits.size&&(i=7),typeof i=="number")throw new h.FileOperationError((0,S.localize)(13,null,this.resourceForError(u)),i)}}async canMove(u,n,s){return this.doCanMoveCopy(u,n,"move",s)}async canCopy(u,n,s){return this.doCanMoveCopy(u,n,"copy",s)}async doCanMoveCopy(u,n,s,i){if(u.toString()!==n.toString())try{const o=s==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u):await this.withReadProvider(u),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(o,u,r,n,s,i)}catch(o){return o}return!0}async move(u,n,s){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),r=await this.doMoveCopy(i,u,o,n,"move",!!s),a=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new h.FileOperationEvent(u,r==="move"?2:3,a)),a}async copy(u,n,s){const i=await this.withReadProvider(u),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),r=await this.doMoveCopy(i,u,o,n,"copy",!!s),a=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new h.FileOperationEvent(u,r==="copy"?3:2,a)),a}async doMoveCopy(u,n,s,i,o,r){if(n.toString()===i.toString())return o;const{exists:a,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(u,n,s,i,o,r);if(a&&!c&&r&&await this.del(i,{recursive:!0}),await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(i)),o==="copy"){if(u===s&&(0,h.hasFileFolderCopyCapability)(u))await u.copy(n,i,{overwrite:r});else{const f=await this.resolve(n);f.isDirectory?await this.doCopyFolder(u,f,s,i):await this.doCopyFile(u,n,s,i)}return o}else return u===s?(await u.rename(n,i,{overwrite:r}),o):(await this.doMoveCopy(u,n,s,i,"copy",r),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(u,n,s,i){if((0,h.hasOpenReadWriteCloseCapability)(u)&&(0,h.hasOpenReadWriteCloseCapability)(s))return this.doPipeBuffered(u,n,s,i);if((0,h.hasOpenReadWriteCloseCapability)(u)&&(0,h.hasReadWriteCapability)(s))return this.doPipeBufferedToUnbuffered(u,n,s,i);if((0,h.hasReadWriteCapability)(u)&&(0,h.hasOpenReadWriteCloseCapability)(s))return this.doPipeUnbufferedToBuffered(u,n,s,i);if((0,h.hasReadWriteCapability)(u)&&(0,h.hasReadWriteCapability)(s))return this.doPipeUnbuffered(u,n,s,i)}async doCopyFolder(u,n,s,i){await s.mkdir(i),Array.isArray(n.children)&&await t.Promises.settled(n.children.map(async o=>{const r=this.getExtUri(s).providerExtUri.joinPath(i,o.name);return o.isDirectory?this.doCopyFolder(u,await this.resolve(o.resource),s,r):this.doCopyFile(u,o.resource,s,r)}))}async doValidateMoveCopy(u,n,s,i,o,r){let a=!1;if(u===s){const{providerExtUri:f,isPathCaseSensitive:w}=this.getExtUri(u);if(w||(a=f.isEqual(n,i)),a&&o==="copy")throw new Error((0,S.localize)(14,null,this.resourceForError(n),this.resourceForError(i)));if(!a&&f.isEqualOrParent(i,n))throw new Error((0,S.localize)(15,null,this.resourceForError(n),this.resourceForError(i)))}const c=await this.exists(i);if(c&&!a){if(!r)throw new h.FileOperationError((0,S.localize)(16,null,this.resourceForError(n),this.resourceForError(i)),4);if(u===s){const{providerExtUri:f}=this.getExtUri(u);if(f.isEqualOrParent(n,i))throw new Error((0,S.localize)(17,null,this.resourceForError(n),this.resourceForError(i)))}}return{exists:c,isSameResourceWithDifferentPathCase:a}}getExtUri(u){const n=this.isPathCaseSensitive(u);return{providerExtUri:n?y.extUri:y.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(u){return!!(u.capabilities&1024)}async createFolder(u){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(u),u);await this.mkdirp(n,u);const s=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new h.FileOperationEvent(u,0,s)),s}async mkdirp(u,n){const s=[],{providerExtUri:i}=this.getExtUri(u);for(;!i.isEqual(n,i.dirname(n));)try{if(((await u.stat(n)).type&h.FileType.Directory)==0)throw new Error((0,S.localize)(18,null,this.resourceForError(n)));break}catch(o){if((0,h.toFileSystemProviderErrorCode)(o)!==h.FileSystemProviderErrorCode.FileNotFound)throw o;s.push(i.basename(n)),n=i.dirname(n)}for(let o=s.length-1;o>=0;o--){n=i.joinPath(n,s[o]);try{await u.mkdir(n)}catch(r){if((0,h.toFileSystemProviderErrorCode)(r)!==h.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(u,n){try{await this.doValidateDelete(u,n)}catch(s){return s}return!0}async doValidateDelete(u,n){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(u),u);if(!!n?.useTrash&&!(s.capabilities&4096))throw new Error((0,S.localize)(19,null,this.resourceForError(u)));let o;try{o=await s.stat(u)}catch{}if(o)this.throwIfFileIsReadonly(u,o);else throw new h.FileOperationError((0,S.localize)(20,null,this.resourceForError(u)),1);if(!!!n?.recursive){const a=await this.resolve(u);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,S.localize)(21,null,this.resourceForError(u)))}return s}async del(u,n){const s=await this.doValidateDelete(u,n),i=!!n?.useTrash,o=!!n?.recursive;await s.delete(u,{recursive:o,useTrash:i}),this._onDidRunOperation.fire(new h.FileOperationEvent(u,1))}async cloneFile(u,n){const s=await this.withProvider(u),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);if(s===i&&this.getExtUri(s).providerExtUri.isEqual(u,n))return;if(s===i&&(0,h.hasFileCloneCapability)(s))return s.cloneFile(u,n);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(n));const o=this.writeQueue.queueFor(u,this.getExtUri(s).providerExtUri);return s===i&&(0,h.hasFileFolderCopyCapability)(s)?o.queue(()=>s.copy(u,n,{overwrite:!0})):o.queue(()=>this.doCopyFile(s,u,i,n))}watch(u,n={recursive:!1,excludes:[]}){const s=new D.DisposableStore;let i=!1,o=()=>{i=!0};return s.add((0,D.toDisposable)(()=>o())),(async()=>{try{const r=await this.doWatch(u,n);i?(0,D.dispose)(r):o=()=>(0,D.dispose)(r)}catch(r){this.logService.error(r)}})(),s}async doWatch(u,n){const s=await this.withProvider(u),i=(0,E.hash)([this.getExtUri(s).providerExtUri.getComparisonKey(u),n]);let o=this.activeWatchers.get(i);return o||(o={count:0,disposable:s.watch(u,n)},this.activeWatchers.set(i,o)),o.count+=1,(0,D.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,D.dispose)(o.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,u]of this.activeWatchers)(0,D.dispose)(u.disposable);this.activeWatchers.clear()}async doWriteBuffered(u,n,s,i){return this.writeQueue.queueFor(n,this.getExtUri(u).providerExtUri).queue(async()=>{const o=await u.open(n,{create:!0,unlock:s?.unlock??!1});try{(0,d.isReadableStream)(i)||(0,d.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(u,o,i):await this.doWriteReadableBufferedQueued(u,o,i)}catch(r){throw(0,h.ensureFileSystemProviderError)(r)}finally{await u.close(o)}})}async doWriteStreamBufferedQueued(u,n,s){let i=0,o;if((0,d.isReadableBufferedStream)(s)){if(s.buffer.length>0){const r=b.VSBuffer.concat(s.buffer);await this.doWriteBuffer(u,n,r,r.byteLength,i,0),i+=r.byteLength}if(s.ended)return;o=s.stream}else o=s;return new Promise((r,a)=>{(0,d.listenStream)(o,{onData:async c=>{o.pause();try{await this.doWriteBuffer(u,n,c,c.byteLength,i,0)}catch(f){return a(f)}i+=c.byteLength,setTimeout(()=>o.resume())},onError:c=>a(c),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(u,n,s){let i=0,o;for(;(o=s.read())!==null;)await this.doWriteBuffer(u,n,o,o.byteLength,i,0),i+=o.byteLength}async doWriteBuffer(u,n,s,i,o,r){let a=0;for(;a<i;)a+=await u.write(n,o+a,s.buffer,r+a,i-a)}async doWriteUnbuffered(u,n,s,i){return this.writeQueue.queueFor(n,this.getExtUri(u).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(u,n,s,i))}async doWriteUnbufferedQueued(u,n,s,i){let o;i instanceof b.VSBuffer?o=i:(0,d.isReadableStream)(i)?o=await(0,b.streamToBuffer)(i):(0,d.isReadableBufferedStream)(i)?o=await(0,b.bufferedStreamToBuffer)(i):o=(0,b.readableToBuffer)(i),await u.writeFile(n,o.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1})}async doPipeBuffered(u,n,s,i){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeBufferedQueued(u,n,s,i))}async doPipeBufferedQueued(u,n,s,i){let o,r;try{o=await u.open(n,{create:!1}),r=await s.open(i,{create:!0,unlock:!1});const a=b.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,f=0,w=0;do w=await u.read(o,c,a.buffer,f,a.byteLength-f),await this.doWriteBuffer(s,r,a,w,c,f),c+=w,f+=w,f===a.byteLength&&(f=0);while(w>0)}catch(a){throw(0,h.ensureFileSystemProviderError)(a)}finally{await t.Promises.settled([typeof o=="number"?u.close(o):Promise.resolve(),typeof r=="number"?s.close(r):Promise.resolve()])}}async doPipeUnbuffered(u,n,s,i){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(u,n,s,i))}async doPipeUnbufferedQueued(u,n,s,i){return s.writeFile(i,await u.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(u,n,s,i){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(u,n,s,i))}async doPipeUnbufferedToBufferedQueued(u,n,s,i){const o=await s.open(i,{create:!0,unlock:!1});try{const r=await u.readFile(n);await this.doWriteBuffer(s,o,b.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,h.ensureFileSystemProviderError)(r)}finally{await s.close(o)}}async doPipeBufferedToUnbuffered(u,n,s,i){const o=await(0,b.streamToBuffer)(this.readFileBuffered(u,n,P.CancellationToken.None));await this.doWriteUnbuffered(s,i,void 0,o)}throwIfFileSystemIsReadonly(u,n){if(u.capabilities&2048)throw new h.FileOperationError((0,S.localize)(22,null,this.resourceForError(n)),6);return u}throwIfFileIsReadonly(u,n){if((n.permissions??0)&h.FilePermission.Readonly)throw new h.FileOperationError((0,S.localize)(23,null,this.resourceForError(u)),6)}resourceForError(u){return u.scheme===R.Schemas.file?u.fsPath:u.toString(!0)}};m=Re([Fe(0,p.ILogService)],m),e.FileService=m}),define(we[58],ye([0,1,30,264,14,29,16,6,33,2,5,3,19,44,22,168,18,96,202,36,198,197]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C,y,d,S,h,g,p,m,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(I)}catch(s){console.error(`Error enabling graceful-fs: ${(0,m.toErrorMessage)(s)}`)}})();class n extends p.AbstractDiskFileSystemProvider{constructor(i,o){super(i,o);this.onDidChangeCapabilities=E.Event.None,this.resourceLocks=new P.ResourceMap(r=>C.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,R.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:o,symbolicLink:r}=await d.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(o,r),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.toFileSystemProviderError(o)}}async readdir(i){try{const o=await d.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),r=[];return await Promise.all(o.map(async a=>{try{let c;a.isSymbolicLink()?c=(await this.stat((0,C.joinPath)(i,a.name))).type:c=this.toType(a),r.push([a.name,c])}catch(c){this.logService.trace(c)}})),r}catch(o){throw this.toFileSystemProviderError(o)}}toType(i,o){let r;return o?.dangling?r=h.FileType.Unknown:i.isFile()?r=h.FileType.File:i.isDirectory()?r=h.FileType.Directory:r=h.FileType.Unknown,o&&(r|=h.FileType.SymbolicLink),r}async createResourceLock(i){const o=this.toFilePath(i);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${o})`);let r;for(;r=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${o})`),await r.wait();const a=new b.Barrier;return this.resourceLocks.set(i,a),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${o})`),(0,D.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${o})`),this.resourceLocks.get(i)===a&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${o})`),this.resourceLocks.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${o})`),a.open()})}async readFile(i,o){let r;try{o?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),r=await this.createResourceLock(i));const a=this.toFilePath(i);return await d.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{r?.dispose()}}readFileStream(i,o,r){const a=(0,y.newWriteableStream)(c=>k.VSBuffer.concat(c.map(f=>k.VSBuffer.wrap(f))).buffer);return(0,g.readFileIntoStream)(this,i,a,c=>c.buffer,{...o,bufferSize:256*1024},r),a}async writeFile(i,o,r){let a;try{const c=this.toFilePath(i);if(!r.create||!r.overwrite){if(await d.Promises.exists(c)){if(!r.overwrite)throw(0,h.createFileSystemProviderError)((0,S.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,h.createFileSystemProviderError)((0,S.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(i,{create:!0,unlock:r.unlock}),await this.write(a,0,o,0,o.byteLength)}catch(c){throw await this.toFileSystemProviderWriteError(i,c)}finally{typeof a=="number"&&await this.close(a)}}async open(i,o){const r=this.toFilePath(i);let a;(0,h.isFileOpenForWriteOptions)(o)&&(a=await this.createResourceLock(i));let c;try{if((0,h.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:w}=await d.SymlinkSupport.stat(r);w.mode&128||await d.Promises.chmod(r,w.mode|128)}catch(w){this.logService.trace(w)}let f;if((0,h.isFileOpenForWriteOptions)(o)){if(R.isWindows)try{await d.Promises.truncate(r,0),f="r+"}catch(w){w.code!=="ENOENT"&&this.logService.trace(w)}f||(f="w")}else f="r";c=await d.Promises.open(r,f)}catch(f){throw a?.dispose(),(0,h.isFileOpenForWriteOptions)(o)?await this.toFileSystemProviderWriteError(i,f):this.toFileSystemProviderError(f)}if(this.mapHandleToPos.set(c,0),(0,h.isFileOpenForWriteOptions)(o)&&this.writeHandles.set(c,i),a){const f=this.mapHandleToLock.get(c);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${r})`),this.mapHandleToLock.set(c,a),f&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${r})`),f.dispose())}return c}async close(i){const o=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await d.Promises.fdatasync(i)}catch(r){this.canFlush=!1,this.logService.error(r)}return await d.Promises.close(i)}catch(r){throw this.toFileSystemProviderError(r)}finally{o&&(this.mapHandleToLock.get(i)===o&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),o.dispose())}}async read(i,o,r,a,c){const f=this.normalizePos(i,o);let w=null;try{w=(await d.Promises.read(i,r,a,c,f)).bytesRead}catch(A){throw this.toFileSystemProviderError(A)}finally{this.updatePos(i,f,w)}return w}normalizePos(i,o){return o===this.mapHandleToPos.get(i)?null:o}updatePos(i,o,r){const a=this.mapHandleToPos.get(i);typeof a=="number"&&(typeof o=="number"||(typeof r=="number"?this.mapHandleToPos.set(i,a+r):this.mapHandleToPos.delete(i)))}async write(i,o,r,a,c){return(0,b.retry)(()=>this.doWrite(i,o,r,a,c),100,3)}async doWrite(i,o,r,a,c){const f=this.normalizePos(i,o);let w=null;try{w=(await d.Promises.write(i,r,a,c,f)).bytesWritten}catch(A){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),A)}finally{this.updatePos(i,f,w)}return w}async mkdir(i){try{await d.Promises.mkdir(this.toFilePath(i))}catch(o){throw this.toFileSystemProviderError(o)}}async delete(i,o){try{const r=this.toFilePath(i);o.recursive?await d.Promises.rm(r,d.RimRafMode.MOVE):await d.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(i,o,r){const a=this.toFilePath(i),c=this.toFilePath(o);if(a!==c)try{await this.validateTargetDeleted(i,o,"move",r.overwrite),await d.Promises.move(a,c)}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,S.localize)(2,null,(0,T.basename)(a),(0,T.basename)((0,T.dirname)(c)),f.toString()))),this.toFileSystemProviderError(f)}}async copy(i,o,r){const a=this.toFilePath(i),c=this.toFilePath(o);if(a!==c)try{await this.validateTargetDeleted(i,o,"copy",r.overwrite),await d.Promises.copy(a,c,{preserveSymlinks:!0})}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,S.localize)(3,null,(0,T.basename)(a),(0,T.basename)((0,T.dirname)(c)),f.toString()))),this.toFileSystemProviderError(f)}}async validateTargetDeleted(i,o,r,a){const c=this.toFilePath(i),f=this.toFilePath(o);let w=!1;if(!!(this.capabilities&1024)||(w=(0,v.isEqual)(c,f,!0)),w&&r==="copy")throw(0,h.createFileSystemProviderError)((0,S.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!w&&await d.Promises.exists(f)){if(!a)throw(0,h.createFileSystemProviderError)((0,S.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}async cloneFile(i,o){return this.doCloneFile(i,o,!1)}async doCloneFile(i,o,r){const a=this.toFilePath(i),c=this.toFilePath(o),f=!!(this.capabilities&1024);if((0,v.isEqual)(a,c,!f))return;const w=new D.DisposableStore;try{const[A,U]=await Promise.all([this.createResourceLock(i),this.createResourceLock(o)]);w.add(A),w.add(U),r&&await d.Promises.mkdir((0,T.dirname)(c),{recursive:!0}),await d.Promises.copyFile(a,c)}catch(A){if(A.code==="ENOENT"&&!r)return this.doCloneFile(i,o,!0);throw this.toFileSystemProviderError(A)}finally{w.dispose()}}createUniversalWatcher(i,o,r){return new l.UniversalWatcherClient(a=>i(a),a=>o(a),r)}createNonRecursiveWatcher(i,o,r){return new u.NodeJSWatcherClient(a=>i(a),a=>o(a),r)}toFileSystemProviderError(i){if(i instanceof h.FileSystemProviderError)return i;let o;switch(i.code){case"ENOENT":o=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=h.FileSystemProviderErrorCode.NoPermissions;break;default:o=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(i,o)}async toFileSystemProviderWriteError(i,o){let r=this.toFileSystemProviderError(o);if(i&&r.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await d.SymlinkSupport.stat(this.toFilePath(i));a.mode&128||(r=(0,h.createFileSystemProviderError)(o,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return r}}e.DiskFileSystemProvider=n}),define(we[203],ye([0,1,6,58,2,16,44,20]),function(ie,e,I,t,b,P,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class v extends b.Disposable{constructor(R,C){super();this.provider=R,this.logService=C,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(R,C,y){const d=this.getUriTransformer(R);switch(C){case"stat":return this.stat(d,y[0]);case"readdir":return this.readdir(d,y[0]);case"open":return this.open(d,y[0],y[1]);case"close":return this.close(y[0]);case"read":return this.read(y[0],y[1],y[2]);case"readFile":return this.readFile(d,y[0],y[1]);case"write":return this.write(y[0],y[1],y[2],y[3],y[4]);case"writeFile":return this.writeFile(d,y[0],y[1],y[2]);case"rename":return this.rename(d,y[0],y[1],y[2]);case"copy":return this.copy(d,y[0],y[1],y[2]);case"cloneFile":return this.cloneFile(d,y[0],y[1]);case"mkdir":return this.mkdir(d,y[0]);case"delete":return this.delete(d,y[0],y[1]);case"watch":return this.watch(d,y[0],y[1],y[2],y[3]);case"unwatch":return this.unwatch(y[0],y[1])}throw new Error(`IPC Command ${C} not found`)}listen(R,C,y){const d=this.getUriTransformer(R);switch(C){case"fileChange":return this.onFileChange(d,y[0]);case"readFileStream":return this.onReadFileStream(d,y[0],y[1])}throw new Error(`Unknown event ${C}`)}stat(R,C){const y=this.transformIncoming(R,C,!0);return this.provider.stat(y)}readdir(R,C){const y=this.transformIncoming(R,C);return this.provider.readdir(y)}async readFile(R,C,y){const d=this.transformIncoming(R,C,!0),S=await this.provider.readFile(d,y);return P.VSBuffer.wrap(S)}onReadFileStream(R,C,y){const d=this.transformIncoming(R,C,!0),S=new E.CancellationTokenSource,h=new I.Emitter({onLastListenerRemove:()=>{S.cancel()}}),g=this.provider.readFileStream(d,y,S.token);return(0,k.listenStream)(g,{onData:p=>h.fire(P.VSBuffer.wrap(p)),onError:p=>h.fire(p),onEnd:()=>{h.fire("end"),h.dispose(),S.dispose()}}),h.event}writeFile(R,C,y,d){const S=this.transformIncoming(R,C);return this.provider.writeFile(S,y.buffer,d)}open(R,C,y){const d=this.transformIncoming(R,C,!0);return this.provider.open(d,y)}close(R){return this.provider.close(R)}async read(R,C,y){const d=P.VSBuffer.alloc(y),S=0,h=await this.provider.read(R,C,d.buffer,S,y);return[d,h]}write(R,C,y,d,S){return this.provider.write(R,C,y.buffer,d,S)}mkdir(R,C){const y=this.transformIncoming(R,C);return this.provider.mkdir(y)}delete(R,C,y){const d=this.transformIncoming(R,C);return this.provider.delete(d,y)}rename(R,C,y,d){const S=this.transformIncoming(R,C),h=this.transformIncoming(R,y);return this.provider.rename(S,h,d)}copy(R,C,y,d){const S=this.transformIncoming(R,C),h=this.transformIncoming(R,y);return this.provider.copy(S,h,d)}cloneFile(R,C,y){const d=this.transformIncoming(R,C),S=this.transformIncoming(R,y);return this.provider.cloneFile(d,S)}onFileChange(R,C){const y=new I.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(C,this.createSessionFileWatcher(R,y))},onLastListenerRemove:()=>{(0,b.dispose)(this.sessionToWatcher.get(C)),this.sessionToWatcher.delete(C)}});return y.event}async watch(R,C,y,d,S){const h=this.sessionToWatcher.get(C);if(h){const g=this.transformIncoming(R,d),p=h.watch(y,g,S);this.watchRequests.set(C+y,p)}}async unwatch(R,C){const y=R+C,d=this.watchRequests.get(y);d&&((0,b.dispose)(d),this.watchRequests.delete(y))}dispose(){super.dispose();for(const[,R]of this.watchRequests)R.dispose();this.watchRequests.clear();for(const[,R]of this.sessionToWatcher)R.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=v;class D extends b.Disposable{constructor(R,C,y,d){super();this.uriTransformer=R,this.logService=y,this.environmentService=d,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(C)}registerListeners(R){const C=this._register(new I.Emitter);this._register(C.event(y=>{R.fire(y.map(d=>({resource:this.uriTransformer.transformOutgoingURI(d.resource),type:d.type})))})),this._register(this.fileWatcher.onDidChangeFile(y=>C.fire(y))),this._register(this.fileWatcher.onDidWatchError(y=>R.fire(y)))}getRecursiveWatcherOptions(R){}getExtraExcludes(R){}watch(R,C,y){const d=this.getExtraExcludes(this.environmentService);return Array.isArray(d)&&(y.excludes=[...y.excludes,...d]),this.watcherRequests.set(R,this.fileWatcher.watch(C,y)),(0,b.toDisposable)(()=>{(0,b.dispose)(this.watcherRequests.get(R)),this.watcherRequests.delete(R)})}dispose(){super.dispose();for(const[,R]of this.watcherRequests)R.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=D}),define(we[99],ye([0,1,6,4,13]),function(ie,e,I,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class P{constructor(C){this.service=C,this.onDidChangeLogLevel=I.Event.buffer(C.onDidChangeLogLevel,!0)}listen(C,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(C,y,d){switch(y){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=P;class k{constructor(C){this.channel=C}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(C){k.setLevel(this.channel,C)}static setLevel(C,y){return C.call("setLevel",y)}}e.LogLevelChannelClient=k;class E{constructor(C){this.loggerService=C,this.loggers=new Map}listen(C,y){throw new Error(`Event not found: ${y}`)}async call(C,y,d){switch(y){case"createLogger":this.createLogger(t.URI.revive(d[0]),d[1]);return;case"log":return this.log(t.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${y}`)}createLogger(C,y){this.loggers.set(C.toString(),this.loggerService.createLogger(C,y))}consoleLog(C,y){let d=console.log;switch(C){case b.LogLevel.Error:d=console.error;break;case b.LogLevel.Warning:d=console.warn;break;case b.LogLevel.Info:d=console.info;break}d.call(console,...y)}log(C,y){const d=this.loggers.get(C.toString());if(!d)throw new Error("Create the logger before logging");for(const[S,h]of y)(0,b.log)(d,S,h)}}e.LoggerChannel=E;class v extends b.AbstractLoggerService{constructor(C,y,d){super(C,y);this.channel=d}createConsoleMainLogger(){return new b.AdapterLogger({log:(C,y)=>{this.channel.call("consoleLog",[C,y])}})}doCreateLogger(C,y,d){return new D(this.channel,C,y,d)}}e.LoggerChannelClient=v;class D extends b.AbstractMessageLogger{constructor(C,y,d,S){super(S?.always);this.channel=C,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[y,S]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(C,y){const d=[[C,y]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(C){this.channel.call("log",[this.file,C])}}class T extends b.LogService{constructor(C,y){super(y);this.parent=C,this._register(C.onDidChangeLogLevel(d=>y.setLevel(d)))}setLevel(C){super.setLevel(C),this.parent.setLevel(C)}}e.FollowerLogService=T}),define(we[100],ye([0,1,18,13]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function b(E,v,D,T,R){try{const C=await new Promise((d,S)=>{ie(["spdlog"],d,S)});C.setFlushOn(t.LogLevel.Trace);const y=await C.createAsyncRotatingLogger(E,v,D,T);return R&&y.clearFormatters(),y}catch(C){console.error(C)}return null}function P(E,v,D){switch(v){case t.LogLevel.Trace:E.trace(D);break;case t.LogLevel.Debug:E.debug(D);break;case t.LogLevel.Info:E.info(D);break;case t.LogLevel.Warning:E.warn(D);break;case t.LogLevel.Error:E.error(D);break;case t.LogLevel.Critical:E.critical(D);break;default:throw new Error("Invalid log level")}}class k extends t.AbstractMessageLogger{constructor(v,D,T,R,C){super();this.buffer=[],this.setLevel(C),this._loggerCreationPromise=this._createSpdLogLogger(v,D,T,R),this._register(this.onDidChangeLogLevel(y=>{this._logger&&this._logger.setLevel(y)}))}async _createSpdLogLogger(v,D,T,R){const C=T?6:1,y=30/C*I.ByteSize.MB,d=await b(v,D,y,C,R);if(d){this._logger=d,this._logger.setLevel(this.getLevel());for(const{level:S,message:h}of this.buffer)P(this._logger,S,h);this.buffer=[]}}log(v,D){this._logger?P(this._logger,v,D):this.getLevel()<=v&&this.buffer.push({level:v,message:D})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=k}),define(we[204],ye([0,1,65,170,7]),function(ie,e,I,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(v){v[v.Unnecessary=1]="Unnecessary",v[v.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var k;(function(v){v[v.Hint=1]="Hint",v[v.Info=2]="Info",v[v.Warning=4]="Warning",v[v.Error=8]="Error"})(k=e.MarkerSeverity||(e.MarkerSeverity={})),function(v){function D(d,S){return S-d}v.compare=D;const T=Object.create(null);T[v.Error]=(0,t.localize)(0,null),T[v.Warning]=(0,t.localize)(1,null),T[v.Info]=(0,t.localize)(2,null);function R(d){return T[d]||""}v.toString=R;function C(d){switch(d){case I.default.Error:return v.Error;case I.default.Warning:return v.Warning;case I.default.Info:return v.Info;case I.default.Ignore:return v.Hint}}v.fromSeverity=C;function y(d){switch(d){case v.Error:return I.default.Error;case v.Warning:return I.default.Warning;case v.Info:return I.default.Info;case v.Hint:return I.default.Ignore}}v.toSeverity=y}(k=e.MarkerSeverity||(e.MarkerSeverity={}));var E;(function(v){const D="";function T(C){return R(C,!0)}v.makeKey=T;function R(C,y){let d=[D];return C.source?d.push(C.source.replace("\xA6","\\\xA6")):d.push(D),C.code?typeof C.code=="string"?d.push(C.code.replace("\xA6","\\\xA6")):d.push(C.code.value.replace("\xA6","\\\xA6")):d.push(D),C.severity!==void 0&&C.severity!==null?d.push(k.toString(C.severity)):d.push(D),C.message&&y?d.push(C.message.replace("\xA6","\\\xA6")):d.push(D),C.startLineNumber!==void 0&&C.startLineNumber!==null?d.push(C.startLineNumber.toString()):d.push(D),C.startColumn!==void 0&&C.startColumn!==null?d.push(C.startColumn.toString()):d.push(D),C.endLineNumber!==void 0&&C.endLineNumber!==null?d.push(C.endLineNumber.toString()):d.push(D),C.endColumn!==void 0&&C.endColumn!==null?d.push(C.endColumn.toString()):d.push(D),d.push(D),d.join("\xA6")}v.makeKeyOptionalMessage=R})(E=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,b.createDecorator)("markerService")}),define(we[59],ye([0,1,6,43,2,7]),function(ie,e,I,t,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,P.createDecorator)("policy");class k extends b.Disposable{constructor(){super(...arguments);this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(D){const T=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...D,...this.policyDefinitions},T!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(D),t.Iterable.reduce(this.policies.entries(),(R,[C,y])=>({...R,[C]:y}),{})}getPolicyValue(D){return this.policies.get(D)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(D,[T,R])=>({...D,[T]:{definition:R,value:this.policies.get(T)}}),{})}}e.AbstractPolicyService=k;class E{constructor(){this.onDidChange=I.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=E}),define(we[48],ye([0,1,8,3,26,19]),function(ie,e,I,t,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const E=t.globals.vscode.context.configuration();if(E)k=E.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof ie?.__$__nodeRequire=="function"){const E=(0,P.dirname)(I.FileAccess.asFileUri("",ie));k=ie.__$__nodeRequire((0,P.joinPath)(E,"product.json").fsPath);const v=ie.__$__nodeRequire((0,P.joinPath)(E,"package.json").fsPath);b.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`,serverDataFolderName:k.serverDataFolderName?`${k.serverDataFolderName}-dev`:void 0}),Object.assign(k,{version:v.version})}else k={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32AppId:"{{F8A2A208-72B3-4D61-95FC-8A65D340689B}",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32UserAppId:"{{D628A17A-9713-46BF-8D57-E671B46A741E}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"com.visualstudio.code",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",serverLicense:["*","* Visual Studio Code Server","*","* By using the software, you agree to","* the Visual Studio Code Server License Terms (https://aka.ms/vscode-server-license) and","* the Microsoft Privacy Statement (https://privacy.microsoft.com/en-US/privacystatement).","*"],serverLicensePrompt:"Do you accept the terms in the License Agreement (Y/n)?",serverApplicationName:"code-server",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webEndpointUrl:"https://main.vscode-cdn.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",quality:"stable",extensionsGallery:{nlsBaseUrl:"https://www.vscode-unpkg.net/_nls/",serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",cacheUrl:"https://vscode.blob.core.windows.net/gallery/index",itemUrl:"https://marketplace.visualstudio.com/items",publisherUrl:"https://marketplace.visualstudio.com/publishers",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json",recommendationsUrl:"https://az764295.vo.msecnd.net/extensions/workspaceRecommendations.json.gz"},extensionTips:{"ms-dotnettools.csharp":"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json}","firefox-devtools.vscode-firefox-debug":"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}","ms-edgedevtools.vscode-edge-devtools":"{**/*.ts,**/*.tsx,**/*.js,**/*.css,**/*.html}","golang.Go":"**/*.go","ms-vscode.PowerShell":"{**/*.ps1,**/*.psd1,**/*.psm1,**/*.ps.config,**/*.ps1.config}","Ionide.Ionide-fsharp":"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}","dbaeumer.vscode-eslint":"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}","ms-vscode.vscode-typescript-tslint-plugin":"{**/tslint.json}","bmewburn.vscode-intelephense-client":"{**/*.php,**/php.ini}","xdebug.php-debug":"{**/*.php,**/php.ini}","rust-lang.rust-analyzer":"{**/*.rs,**/*.rslib}","ms-vscode.cpptools-extension-pack":"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}","DavidAnson.vscode-markdownlint":"{**/*.md}","ms-azuretools.vscode-docker":"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml,**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}","EditorConfig.EditorConfig":"{**/.editorconfig}","HookyQR.beautify":"{**/.jsbeautifyrc}","donjayamanne.githistory":"{**/.gitignore,**/.git}","felipecaputo.git-project-manager":"{**/.gitignore,**/.git}","eamodio.gitlens":"{**/.gitignore,**/.git}","rebornix.Ruby":"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}","DotJoshJohnson.xml":"{**/*.xml}","stylelint.vscode-stylelint":"{**/.stylelintrc,**/stylelint.config.js}","eg2.vscode-npm-script":"{**/package.json}","ms-mssql.mssql":"{**/*.sql}","mtxr.sqltools":"{**/*.sql}","usqlextpublisher.usql-vscode-ext":"{**/*.usql}","ms-vscode.sublime-keybindings":"{**/.sublime-project,**/.sublime-workspace}","k--kato.intellij-idea-keybindings":"{**/.idea}","christian-kohler.npm-intellisense":"{**/package.json}","vue.volar":"{**/*.vue}","ms-python.python":"{**/*.py,**/*.ipynb}","ms-toolsai.jupyter":"{**/*.ipynb}","cake-build.cake-vscode":"{**/build.cake}","Angular.ng-template":"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}","vscjava.vscode-maven":"**/pom.xml","ms-azuretools.vscode-azureterraform":"**/*.tf","HashiCorp.terraform":"**/*.tf","vsciot-vscode.vscode-arduino":"**/*.ino","ms-kubernetes-tools.vscode-kubernetes-tools":"{**/Chart.yaml}","GoogleCloudTools.cloudcode":"{**/skaffold.yaml}","Oracle.oracledevtools":"{**/*.sql}","ms-vscode.vscode-github-issue-notebooks":"{**/*.github-issues}","REditorSupport.r":"**/*.r"},extensionImportantTips:{"ms-dotnettools.csharp":{name:"C#",languages:["csharp"],pattern:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}"},"ms-python.python":{name:"Python",languages:["python"],pattern:"{**/*.py}"},"ms-toolsai.jupyter":{name:"Jupyter",pattern:"{**/*.ipynb}"},"golang.Go":{name:"Go",languages:["go"],pattern:"**/*.go"},"vscjava.vscode-java-pack":{name:"Java",languages:["java"],pattern:"{**/*.java}",isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"ms-vscode.PowerShell":{name:"PowerShell",languages:["powershell"],pattern:"{**/*.ps1,**/*.psd1,**/*.psm1}"},"ms-vscode.cpptools-extension-pack":{name:"C/C++",languages:["c","cpp"],pattern:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}"},"ms-azuretools.vscode-docker":{name:"Docker",languages:["dockerfile"],pattern:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}"},"vue.volar":{name:"Vetur",languages:["vue"],pattern:"{**/*.vue}"},"ms-vscode.makefile-tools":{name:"Makefile Tools",languages:["makefile"],pattern:"{**/makefile,**/Makefile}"},"ms-vscode.cmake-tools":{name:"CMake Tools",pattern:"{**/CMakeLists.txt}"},"ms-azure-devops.azure-pipelines":{name:"Azure Pipelines",pattern:"{**/azure-pipelines.yaml}"},"msazurermtools.azurerm-vscode-tools":{name:"Azure Resource Manager",pattern:"{**/azuredeploy.json}"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",pattern:"{**/devcontainer.json}"},"ms-azuretools.vscode-bicep":{name:"Bicep",pattern:"{**/*.bicep}"},"svelte.svelte-vscode":{name:"Svelte",pattern:"{**/*.svelte}"},"ms-vscode.vscode-github-issue-notebooks":{name:"GitHub Issue Notebooks",pattern:"{**/*.github-issues}"},"ms-playwright.playwright":{name:"Playwright",pattern:"{**/*playwright*.config.ts,**/*playwright*.config.js,**/*playwright*.config.mjs}"},"REditorSupport.r":{name:"R",languages:["r"],pattern:"{**/*.r}"}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","lfs.vscode-emacs-friendly","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools-extension-pack","ms-dotnettools.csharp","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","vue.volar","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust-analyzer","rebornix.ruby"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",remotes:["github.com"]},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"Pivotal.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"github-pull-request":{configPath:".vscode/.github-pull-request.rec",configName:"GitHub",configScheme:"vscode-vfs",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",important:!0}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},git:{friendlyName:"Git",windowsPath:"%ProgramFiles%\\Git\\git-bash.exe",recommendations:{"eamodio.gitlens":{name:"GitLens"}}},svn:{friendlyName:"Subversion",windowsPath:"%ProgramFiles%\\TortoiseSVN\\bin\\TortoiseProc.exe",recommendations:{"johnstoncode.svn-scm":{name:"SVN"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"Remote - WSL",important:!0}}}},webExtensionTips:["tyriar.luna-paint","codespaces-contrib.codeswing","ms-vscode.vscode-github-issue-notebooks","esbenp.prettier-vscode","hediet.vscode-drawio"],remoteExtensionTips:{wsl:{friendlyName:"Remote - WSL",extensionId:"ms-vscode-remote.remote-wsl"},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh"},"dev-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},"attached-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},vsonline:{friendlyName:"Visual Studio Online",extensionId:"ms-vsonline.vsonline"}},extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/(actions\\/)?workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-ia32":"appcenter://code?aid=f4289815-a66e-4ad9-b74f-d8e5bc093e41","win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{asimovKey:"AIF-444c3af9-8e69-4462-ab49-4191e6ad1916"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],sendASmile:{reportIssueUrl:"https://go.microsoft.com/fwlink/?LinkId=534872",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482"},documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",twitterUrl:"https://go.microsoft.com/fwlink/?LinkID=533687",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=786907",showTelemetryOptOut:!0,npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05}],extensionEnabledApiProposals:{"ms-vscode.vscode-selfhost-test-provider":["testObserver"],"VisualStudioExptTeam.vscodeintellicode-completions":["inlineCompletionsNew","inlineCompletionsAdditions"],"ms-vsliveshare.vsliveshare":["contribMenuBarHome","diffCommand","documentFiltersExclusive","fileSearchProvider","findTextInFiles","notebookCellExecutionState","notebookContentProvider","notebookEditor","notebookEditorEdit","notebookLiveShare","notebookWorkspaceEdit","terminalDimensions","terminalDataWriteEvent","textSearchProvider"],"ms-vscode.js-debug":["portsAttributes","findTextInFiles","workspaceTrust","resolvers"],"ms-toolsai.vscode-ai-remote":["resolvers","notebookEditor"],"ms-python.python":["quickPickSortByLabel","testObserver","notebookEditor"],"ms-dotnettools.dotnet-interactive-vscode":["notebookCellExecutionState","notebookControllerKind","notebookDebugOptions","notebookEditor","notebookEditorEdit","notebookLiveShare","notebookMessaging","notebookMime","notebookWorkspaceEdit"],"GitHub.codespaces":["contribMenuBarHome","contribRemoteHelp","contribViewsRemote","notebookEditor","resolvers","terminalDataWriteEvent","treeViewReveal"],"ms-vscode.azure-repos":["extensionRuntime","fileSearchProvider","textSearchProvider"],"ms-vscode.remote-repositories":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline","notebookEditor"],"tanhakabir.rest-book":["notebookEditor"],"ms-vscode.remote-server":["resolvers"],"ms-vscode-remote.remote-wsl":["resolvers","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-ssh":["resolvers","terminalDataWriteEvent","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-containers":["resolvers","workspaceTrust","terminalDimensions","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","resolvers"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"GitHub.vscode-pull-request-github":["tokenInformation","commentsResolvedState"],"GitHub.copilot":["inlineCompletionsNew","inlineCompletionsAdditions"],"GitHub.copilot-nightly":["inlineCompletionsNew","inlineCompletionsAdditions"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline","notebookEditor"],"GitHub.remotehub-insiders":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline","notebookEditor"],"ms-python.gather":["notebookEditor","notebookCellExecutionState"],"ms-python.vscode-pylance":["notebookEditor","notebookCellExecutionState"],"ms-toolsai.jupyter":["notebookControllerKind","notebookDebugOptions","notebookDeprecated","notebookEditor","notebookEditorDecorationType","notebookWorkspaceEdit","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","quickPickSortByLabel"],"ms-toolsai.vscode-jupyter-powertoys":["notebookEditor","notebookEditorEdit","notebookWorkspaceEdit"],"dbaeumer.vscode-eslint":["notebookEditor","notebookCellExecutionState"],"ms-vscode.azure-sphere-tools-ui":["resolvers"],"ms-azuretools.vscode-azureappservice":["terminalDataWriteEvent"],"ms-vscode.anycode":["extensionsAny"]},tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",featuresTelemetryPropertyName:"VSCode.ABExp.Features",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},experimentsUrl:"https://vscodeexperiments.azureedge.net/experiments/vscode-experiments.json",extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://*.gallerycdn.vsassets.io","https://github.com/microsoft/","https://github.com/MicrosoftDocs/","https://login.microsoftonline.com"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.0.18",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.68.0",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.2",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode-remote.remote-wsl-recommender",version:"0.0.15",repo:"https://github.com/microsoft/vscode-remote-wsl-recommender",metadata:{id:"cb296d3c-017a-4dee-83af-ebb5a5a16e9a",publisherId:{publisherId:"ac9410a2-0d75-40ec-90de-b59bb705801d",publisherName:"ms-vscode-remote",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"},platforms:["win32"],clientOnly:!0}],version:"1.68.1",commit:"30d9c6cd9483b2cc586687151bcbcd635f373630",date:"2022-06-14T12:36:21.545Z"},Object.keys(k).length===0&&Object.assign(k,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=k}),define(we[25],ye([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,I.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(we[205],ye([0,1,70,13,24,25,200]),function(ie,e,I,t,b,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsWebMainService=void 0;let E=class extends k.BaseCredentialsMainService{constructor(D,T,R){super(D);this.environmentMainService=T,this.productService=R}async getSecretStoragePrefix(){return Promise.resolve(`${this.productService.urlProtocol}-server`)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new I.InMemoryCredentialsProvider,this._keytarCache;try{this._keytarCache=await new Promise((D,T)=>{ie(["keytar"],D,T)}),await this._keytarCache.findCredentials("test-keytar-loads")}catch(D){this.logService.warn(`Using the in-memory credential store as the operating system's credential store could not be accessed. Please see https://aka.ms/vscode-server-keyring on how to set this up. Details: ${D.message??D}`),this._keytarCache=new I.InMemoryCredentialsProvider}return this._keytarCache}};E=Re([Fe(0,t.ILogService),Fe(1,b.INativeEnvironmentService),Fe(2,P.IProductService)],E),e.CredentialsWebMainService=E}),define(we[34],ye([0,1,129,12]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class b{constructor(){this.data=new Map}add(k,E){I.ok(t.isString(k)),I.ok(t.isObject(E)),I.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,E)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new b}),define(we[206],ye([0,1,6,34]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function b(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class P{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(v,D){this.schemasById[b(v)]=D,this._onDidChangeSchema.fire(v)}notifySchemaChanged(v){this._onDidChangeSchema.fire(v)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new P;t.Registry.add(e.Extensions.JSONContribution,k)}),define(we[49],ye([0,1,17,6,12,155,23,206,34]),function(ie,e,I,t,b,P,k,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var D;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(D=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const R=v.Registry.as(E.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,s=!0){this.registerConfigurations([n],s)}registerConfigurations(n,s=!0){const i=this.doRegisterConfigurations(n,s);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(n){const s=this.doDeregisterConfigurations(n);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:n,remove:s}){const i=[];i.push(...this.doDeregisterConfigurations(s)),i.push(...this.doRegisterConfigurations(n,!1)),R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,I.distinct)(i)})}registerDefaultConfigurations(n){const s=[],i=[];for(const{overrides:o,source:r}of n)for(const a in o)if(s.push(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const c=this.configurationDefaultsOverrides.get(a),f=c?.valuesSources??new Map;if(r)for(const x of Object.keys(o[a]))f.set(x,r);const w={...c?.value||{},...o[a]};this.configurationDefaultsOverrides.set(a,{source:r,value:w,valuesSources:f});const A=(0,k.getLanguageTagSettingPlainKey)(a),U={type:"object",default:w,description:P.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:w,source:b.isString(r)?void 0:r,defaultValueSource:r};i.push(...S(a)),this.configurationProperties[a]=U,this.defaultLanguageConfigurationOverridesNode.properties[a]=U}else{this.configurationDefaultsOverrides.set(a,{value:o[a],source:r});const c=this.configurationProperties[a];c&&(this.updatePropertyDefaultValue(a,c),this.updateSchema(a,c))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const s=[];for(const{overrides:i,source:o}of n)for(const r in i){const a=this.configurationDefaultsOverrides.get(r),c=b.isString(o)?o:o?.id,f=b.isString(a?.source)?a?.source:a?.source?.id;if(c===f)if(s.push(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const w=this.configurationProperties[r];w&&(this.updatePropertyDefaultValue(r,w),this.updateSchema(r,w))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){for(const s of n)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,s){const i=[];return n.forEach(o=>{i.push(...this.validateAndRegisterProperties(o,s,o.extensionInfo,o.restrictedProperties)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),i}doDeregisterConfigurations(n){const s=[],i=o=>{if(o.properties)for(const r in o.properties){s.push(r);const a=this.configurationProperties[r];a?.policy?.name&&this.policyConfigurations.delete(a.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,o.properties[r])}o.allOf&&o.allOf.forEach(r=>i(r))};for(const o of n){i(o);const r=this.configurationContributors.indexOf(o);r!==-1&&this.configurationContributors.splice(r,1)}return s}validateAndRegisterProperties(n,s=!0,i,o,r=3){r=b.isUndefinedOrNull(n.scope)?r:n.scope;let a=[],c=n.properties;if(c)for(let w in c){const A=c[w];if(s&&m(w,A)){delete c[w];continue}if(A.source=i,A.defaultDefaultValue=c[w].default,this.updatePropertyDefaultValue(w,A),e.OVERRIDE_PROPERTY_REGEX.test(w)?A.scope=void 0:(A.scope=b.isUndefinedOrNull(A.scope)?r:A.scope,A.restricted=b.isUndefinedOrNull(A.restricted)?!!o?.includes(w):A.restricted),c[w].hasOwnProperty("included")&&!c[w].included){this.excludedConfigurationProperties[w]=c[w],delete c[w];continue}else this.configurationProperties[w]=c[w],c[w].policy?.name&&this.policyConfigurations.set(c[w].policy.name,w);!c[w].deprecationMessage&&c[w].markdownDeprecationMessage&&(c[w].deprecationMessage=c[w].markdownDeprecationMessage),a.push(w)}let f=n.allOf;if(f)for(let w of f)a.push(...this.validateAndRegisterProperties(w,s,i,o,r));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const s=i=>{let o=i.properties;if(o)for(const a in o)this.updateSchema(a,o[a]);let r=i.allOf;r&&r.forEach(s)};s(n)}updateSchema(n,s){switch(e.allSettings.properties[n]=s,s.scope){case 1:e.applicationSettings.properties[n]=s;break;case 2:e.machineSettings.properties[n]=s;break;case 6:e.machineOverridableSettings.properties[n]=s;break;case 3:e.windowSettings.properties[n]=s;break;case 4:e.resourceSettings.properties[n]=s;break;case 5:e.resourceSettings.properties[n]=s,this.resourceLanguageSettingsSchema.properties[n]=s;break}}removeFromSchema(n,s){switch(delete e.allSettings.properties[n],s.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const s=`[${n}]`,i={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,i),e.allSettings.properties[s]=i,e.applicationSettings.properties[s]=i,e.machineSettings.properties[s]=i,e.machineOverridableSettings.properties[s]=i,e.windowSettings.properties[s]=i,e.resourceSettings.properties[s]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const n={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,s){const i=this.configurationDefaultsOverrides.get(n);let o=i?.value,r=i?.source;b.isUndefined(o)&&(o=s.defaultDefaultValue,r=void 0),b.isUndefined(o)&&(o=g(s.type)),s.default=o,s.defaultValueSource=r}}const y="\\[([^\\]]+)\\]",d=new RegExp(y,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${y})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function S(u){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(u)){let s=d.exec(u);for(;s?.length;){const i=s[1].trim();i&&n.push(i),s=d.exec(u)}}return(0,I.distinct)(n)}e.overrideIdentifiersFromKey=S;function h(u){return u.reduce((n,s)=>`${n}[${s}]`,"")}e.keyFromOverrideIdentifiers=h;function g(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const p=new C;v.Registry.add(e.Extensions.Configuration,p);function m(u,n){return u.trim()?e.OVERRIDE_PROPERTY_REGEX.test(u)?P.localize(7,null,u):p.getConfigurationProperties()[u]!==void 0?P.localize(8,null,u):n.policy?.name&&p.getPolicyConfigurations().get(n.policy?.name)!==void 0?P.localize(9,null,u,n.policy?.name,p.getPolicyConfigurations().get(n.policy?.name)):null:P.localize(6,null)}e.validateProperty=m;function l(){const u=[],n=p.getConfigurationProperties();for(const s of Object.keys(n))u.push([s,n[s].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.getScopes=l}),define(we[101],ye([0,1,17,6,63,2,29,21,12,4,23,49,34]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class y{constructor(s={},i=[],o=[]){this._contents=s,this._keys=i,this._overrides=o,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(s){return s?(0,T.getConfigurationValue)(this.contents,s):this.contents}getOverrideValue(s,i){const o=this.getContentsForOverrideIdentifer(i);return o?s?(0,T.getConfigurationValue)(o,s):o:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const o of this.overrides)o.identifiers.includes(s)&&i.push(...o.keys);return I.distinct(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return I.distinct(s)}override(s){let i=this.overrideConfigurations.get(s);return i||(i=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,i)),i}merge(...s){const i=E.deepClone(this.contents),o=E.deepClone(this.overrides),r=[...this.keys];for(const a of s){this.mergeContents(i,a.contents);for(const c of a.overrides){const[f]=o.filter(w=>I.equals(w.identifiers,c.identifiers));f?(this.mergeContents(f.contents,c.contents),f.keys.push(...c.keys),f.keys=I.distinct(f.keys)):o.push(E.deepClone(c))}for(const c of a.keys)r.indexOf(c)===-1&&r.push(c)}return new y(i,r,o)}freeze(){return this.frozen=!0,this}clone(){return new y(E.deepClone(this.contents),[...this.keys],E.deepClone(this.overrides))}createOverrideConfigurationModel(s){const i=this.getContentsForOverrideIdentifer(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let o={};for(const r of I.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[r],c=i[r];c&&(typeof a=="object"&&typeof c=="object"?(a=E.deepClone(a),this.mergeContents(a,c)):a=c),o[r]=a}return new y(o,this.keys,this.overrides)}mergeContents(s,i){for(const o of Object.keys(i)){if(o in s&&v.isObject(s[o])&&v.isObject(i[o])){this.mergeContents(s[o],i[o]);continue}s[o]=E.deepClone(i[o])}}checkAndFreeze(s){return this.frozen&&!Object.isFrozen(s)?E.deepFreeze(s):s}getContentsForOverrideIdentifer(s){let i=null,o=null;const r=a=>{a&&(o?this.mergeContents(o,a):o=E.deepClone(a))};for(const a of this.overrides)I.equals(a.identifiers,[s])?i=a.contents:a.identifiers.includes(s)&&r(a.contents);return r(i),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,i){this.addKey(s),(0,T.addToValueTree)(this.contents,s,i,o=>{throw new Error(o)})}removeValue(s){this.removeKey(s)&&(0,T.removeFromValueTree)(this.contents,s)}addKey(s){let i=this.keys.length;for(let o=0;o<i;o++)s.indexOf(this.keys[o])===0&&(i=o);this.keys.splice(i,1,s)}removeKey(s){let i=this.keys.indexOf(s);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=y;class d{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,i){if(!v.isUndefinedOrNull(s)){const o=this.doParseContent(s);this.parseRaw(o,i)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,i){this._raw=s;const{contents:o,keys:r,overrides:a,restricted:c}=this.doParseRaw(s,i);this._configurationModel=new y(o,r,a),this._restrictedConfigurations=c||[]}doParseContent(s){let i={},o=null,r=[],a=[],c=[];function f(A){Array.isArray(r)?r.push(A):o!==null&&(r[o]=A)}let w={onObjectBegin:()=>{let A={};f(A),a.push(r),r=A,o=null},onObjectProperty:A=>{o=A},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{let A=[];f(A),a.push(r),r=A,o=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:f,onError:(A,U,x)=>{c.push({error:A,offset:U,length:x})}};if(s)try{b.visit(s,w),i=r[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return i}doParseRaw(s,i){const o=C.Registry.as(R.Extensions.Configuration).getConfigurationProperties(),r=this.filter(s,o,!0,i);s=r.raw;const a=(0,T.toValuesTree)(s,w=>console.error(`Conflict in settings file ${this._name}: ${w}`)),c=Object.keys(s),f=this.toOverrides(s,w=>console.error(`Conflict in settings file ${this._name}: ${w}`));return{contents:a,keys:c,overrides:f,restricted:r.restricted}}filter(s,i,o,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:s,restricted:[]};const a={},c=[];for(let f in s)if(R.OVERRIDE_PROPERTY_REGEX.test(f)&&o){const w=this.filter(s[f],i,!1,r);a[f]=w.raw,c.push(...w.restricted)}else{const w=i[f],A=w?typeof w.scope!="undefined"?w.scope:3:void 0;w?.restricted&&c.push(f),(A===void 0||r.scopes===void 0||r.scopes.includes(A))&&(r.skipRestricted&&w?.restricted||(a[f]=s[f]))}return{raw:a,restricted:c}}toOverrides(s,i){const o=[];for(const r of Object.keys(s))if(R.OVERRIDE_PROPERTY_REGEX.test(r)){const a={};for(const c in s[r])a[c]=s[r][c];o.push({identifiers:(0,R.overrideIdentifiersFromKey)(r),keys:Object.keys(a),contents:(0,T.toValuesTree)(a,i)})}return o}}e.ConfigurationModelParser=d;class S extends P.Disposable{constructor(s,i,o,r){super();this.userSettingsResource=s,this.scopes=i,this.fileService=r,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&o.isEqual(a.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class h{constructor(s,i,o,r=new y,a=new y,c=new k.ResourceMap,f=new y,w=new k.ResourceMap,A=!0){this._defaultConfiguration=s,this._policyConfiguration=i,this._localUserConfiguration=o,this._remoteUserConfiguration=r,this._workspaceConfiguration=a,this._folderConfigurations=c,this._memoryConfiguration=f,this._memoryConfigurationByResource=w,this._freeze=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(s,i,o){return this.getConsolidatedConfigurationModel(s,i,o).getValue(s)}updateValue(s,i,o={}){let r;o.resource?(r=this._memoryConfigurationByResource.get(o.resource),r||(r=new y,this._memoryConfigurationByResource.set(o.resource,r))):r=this._memoryConfiguration,i===void 0?r.removeValue(s):r.setValue(s,i),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,i,o){const r=this.getConsolidatedConfigurationModel(s,i,o),a=this.getFolderConfigurationModelForResource(i.resource,o),c=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,f=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this._defaultConfiguration.freeze().getValue(s),w=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(s),A=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.userConfiguration.freeze().getValue(s),U=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.localUserConfiguration.freeze().getValue(s),x=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.remoteUserConfiguration.freeze().getValue(s),Q=o?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this._workspaceConfiguration.freeze().getValue(s):void 0,_=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(s):a.freeze().getValue(s):void 0,Y=i.overrideIdentifier?c.override(i.overrideIdentifier).getValue(s):c.getValue(s),O=r.getValue(s),B=I.distinct(r.overrides.map(ue=>ue.identifiers).flat()).filter(ue=>r.getOverrideValue(s,ue)!==void 0);return{defaultValue:f,policyValue:w,userValue:A,userLocalValue:U,userRemoteValue:x,workspaceValue:Q,workspaceFolderValue:_,memoryValue:Y,value:O,default:f!==void 0?{value:this._defaultConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,policy:w!==void 0?{value:w}:void 0,user:A!==void 0?{value:this.userConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,userLocal:U!==void 0?{value:this.localUserConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,userRemote:x!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,workspace:Q!==void 0?{value:this._workspaceConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,workspaceFolder:_!==void 0?{value:a?.freeze().getValue(s),override:i.overrideIdentifier?a?.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,memory:Y!==void 0?{value:c.getValue(s),override:i.overrideIdentifier?c.getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:B.length?B:void 0}}keys(s){const i=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(s){this._policyConfiguration=s}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,i){this._folderConfigurations.set(s,i),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const o=[];if(!i){const{added:r,updated:a,removed:c}=l(this._defaultConfiguration,s);i=[...r,...a,...c]}for(const r of i)for(const a of(0,R.overrideIdentifiersFromKey)(r)){const c=this._defaultConfiguration.getKeysForOverrideIdentifier(a),f=s.getKeysForOverrideIdentifier(a),w=[...f.filter(A=>c.indexOf(A)===-1),...c.filter(A=>f.indexOf(A)===-1),...c.filter(A=>!E.equals(this._defaultConfiguration.override(a).getValue(A),s.override(a).getValue(A)))];o.push([a,w])}return this.updateDefaultConfiguration(s),{keys:i,overrides:o}}compareAndUpdatePolicyConfiguration(s){const{added:i,updated:o,removed:r}=l(this._policyConfiguration,s),a=[...i,...o,...r];return a.length&&this.updatePolicyConfiguration(s),{keys:a,overrides:[]}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:o,removed:r,overrides:a}=l(this.localUserConfiguration,s),c=[...i,...o,...r];return c.length&&this.updateLocalUserConfiguration(s),{keys:c,overrides:a}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:o,removed:r,overrides:a}=l(this.remoteUserConfiguration,s);let c=[...i,...o,...r];return c.length&&this.updateRemoteUserConfiguration(s),{keys:c,overrides:a}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:o,removed:r,overrides:a}=l(this.workspaceConfiguration,s);let c=[...i,...o,...r];return c.length&&this.updateWorkspaceConfiguration(s),{keys:c,overrides:a}}compareAndUpdateFolderConfiguration(s,i){const o=this.folderConfigurations.get(s),{added:r,updated:a,removed:c,overrides:f}=l(o,i);let w=[...r,...a,...c];return(w.length||!o)&&this.updateFolderConfiguration(s,i),{keys:w,overrides:f}}compareAndDeleteFolderConfiguration(s){const i=this.folderConfigurations.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:o,updated:r,removed:a,overrides:c}=l(i,void 0);return{keys:[...o,...r,...a],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(s,i,o){let r=this.getConsolidatedConfigurationModelForResource(i,o);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(s)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:s},i){let o=this.getWorkspaceConsolidatedConfiguration();if(i&&s){const r=i.getFolder(s);r&&(o=this.getFolderConsolidatedConfiguration(r.uri)||o);const a=this._memoryConfigurationByResource.get(s);a&&(o=o.merge(a))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let i=this._foldersConsolidatedConfigurations.get(s);if(!i){const o=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(s);r?(i=o.merge(r),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(s,i)):i=o}return i}getFolderConfigurationModelForResource(s,i){if(i&&s){const o=i.getFolder(s);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,i)=>{const{contents:o,overrides:r,keys:a}=this._folderConfigurations.get(i);return s.push([i,{contents:o,overrides:r,keys:a}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>s.add(i)),this.userConfiguration.freeze().keys.forEach(i=>s.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(o=>s.add(o))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(o=>s.add(o))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(o=>i.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(o=>i.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r))),[...i.values()]}static parse(s){const i=this.parseConfigurationModel(s.defaults),o=this.parseConfigurationModel(s.policy),r=this.parseConfigurationModel(s.user),a=this.parseConfigurationModel(s.workspace),c=s.folders.reduce((f,w)=>(f.set(D.URI.revive(w[0]),this.parseConfigurationModel(w[1])),f),new k.ResourceMap);return new h(i,o,r,new y,a,c,new y,new k.ResourceMap,!1)}static parseConfigurationModel(s){return new y(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=h;function g(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const s=new Set,i=new Map;for(const r of n)r.keys.forEach(a=>s.add(a)),r.overrides.forEach(([a,c])=>{const f=(0,k.getOrSet)(i,a,new Set);c.forEach(w=>f.add(w))});const o=[];return i.forEach((r,a)=>o.push([a,[...r.values()]])),{keys:[...s.values()],overrides:o}}e.mergeChanges=g;class p{constructor(s,i,o,r){this.change=s,this.previous=i,this.currentConfiguraiton=o,this.currentWorkspace=r,this._previousConfiguration=void 0;const a=new Set;s.keys.forEach(f=>a.add(f)),s.overrides.forEach(([,f])=>f.forEach(w=>a.add(w))),this.affectedKeys=[...a.values()];const c=new y;this.affectedKeys.forEach(f=>c.setValue(f,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=h.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,s)){if(i){const o=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(s,i,this.currentWorkspace);return!E.equals(o,r)}return!0}return!1}doesAffectedKeysTreeContains(s,i){let o=(0,T.toValuesTree)({[i]:!0},()=>{}),r;for(;typeof o=="object"&&(r=Object.keys(o)[0]);){if(s=s[r],!s)return!1;o=o[r]}return!0}}e.ConfigurationChangeEvent=p;class m extends p{constructor(s,i,o,r){super({keys:s.allKeys(),overrides:[]},void 0,s,i);this.source=o,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=m;function l(n,s){const{added:i,removed:o,updated:r}=u(s,n),a=[],c=n?.getAllOverrideIdentifiers()||[],f=s?.getAllOverrideIdentifiers()||[];if(s){const w=f.filter(A=>!c.includes(A));for(const A of w)a.push([A,s.getKeysForOverrideIdentifier(A)])}if(n){const w=c.filter(A=>!f.includes(A));for(const A of w)a.push([A,n.getKeysForOverrideIdentifier(A)])}if(s&&n){for(const w of c)if(f.includes(w)){const A=u({contents:n.getOverrideValue(void 0,w)||{},keys:n.getKeysForOverrideIdentifier(w)},{contents:s.getOverrideValue(void 0,w)||{},keys:s.getKeysForOverrideIdentifier(w)});a.push([w,[...A.added,...A.removed,...A.updated]])}}return{added:i,removed:o,updated:r,overrides:a}}function u(n,s){const i=n?s?n.keys.filter(a=>s.keys.indexOf(a)===-1):[...n.keys]:[],o=s?n?s.keys.filter(a=>n.keys.indexOf(a)===-1):[...s.keys]:[],r=[];if(n&&s){for(const a of s.keys)if(n.keys.indexOf(a)!==-1){const c=(0,T.getConfigurationValue)(s.contents,a),f=(0,T.getConfigurationValue)(n.contents,a);E.equals(c,f)||r.push(a)}}return{added:i,removed:o,updated:r}}}),define(we[207],ye([0,1,17,6,2,21,12,23,101,49,13,59,34]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class y extends b.Disposable{constructor(){super(...arguments);this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new d(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(C.Registry.as(D.Extensions.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:m})=>this.onDidUpdateConfiguration(p,m))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(p,m){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:p})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=y;class d extends v.ConfigurationModel{constructor(p={}){const m=C.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(m),u=Object.create(null),n=[];for(const s in m){const i=p[s],o=i!==void 0?i:m[s].default;(0,E.addToValueTree)(u,s,o,r=>console.error(`Conflict in default settings: ${r}`))}for(const s of Object.keys(u))D.OVERRIDE_PROPERTY_REGEX.test(s)&&n.push({identifiers:(0,D.overrideIdentifiersFromKey)(s),keys:Object.keys(u[s]),contents:(0,E.toValuesTree)(u[s],i=>console.error(`Conflict in default settings file: ${i}`))});super(u,l,n)}}e.DefaultConfigurationModel=d;class S{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new v.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=S;let h=class extends b.Disposable{constructor(p,m,l){super();this.defaultConfiguration=p,this.policyService=m,this.logService=l,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new v.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(p=>this.onDidChangePolicies(p))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:p})=>this.update(await this.registerPolicyDefinitions(p),!0))),this._configurationModel}async registerPolicyDefinitions(p){const m={},l=[],u=C.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(const n of p){const s=u[n];if(!s){l.push(n);continue}if(s.policy){if(s.type!=="string"&&s.type!=="number"){this.logService.warn(`Policy ${s.policy.name} has unsupported type ${s.type}`);continue}l.push(n),m[s.policy.name]={type:s.type}}}return(0,k.isEmptyObject)(m)||await this.policyService.registerPolicyDefinitions(m),l}onDidChangePolicies(p){const m=C.Registry.as(D.Extensions.Configuration).getPolicyConfigurations(),l=(0,I.coalesce)(p.map(u=>m.get(u)));this.update(l,!0)}update(p,m){const l=C.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),u=[],n=this._configurationModel.isEmpty();for(const s of p){const i=l[s]?.policy?.name;if(i){const o=this.policyService.getPolicyValue(i);(n?o!==void 0:!(0,P.equals)(this._configurationModel.getValue(s),o))&&u.push([s,o])}else this._configurationModel.getValue(s)!==void 0&&u.push([s,void 0])}if(u.length){const s=this._configurationModel;this._configurationModel=new v.ConfigurationModel;for(const i of s.keys)this._configurationModel.setValue(i,s.getValue(i));for(const[i,o]of u)o===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,o);m&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};h=Re([Fe(1,R.IPolicyService),Fe(2,T.ILogService)],h),e.PolicyConfiguration=h}),define(we[102],ye([0,1,14,6,2,19,23,101,207,59]),function(ie,e,I,t,b,P,k,E,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class T extends b.Disposable{constructor(C,y,d,S){super();this.settingsResource=C,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new v.DefaultConfiguration),this.policyConfiguration=d instanceof D.NullPolicyService?new v.NullPolicyConfiguration:this._register(new v.PolicyConfiguration(this.defaultConfiguration,d,S)),this.userConfiguration=this._register(new E.UserSettings(this.settingsResource,void 0,P.extUriBiasedIgnorePathCase,y)),this.configuration=new E.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new E.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new I.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:h,properties:g})=>this.onDidDefaultConfigurationChange(h,g))),this._register(this.policyConfiguration.onDidChangeConfiguration(h=>this.onDidPolicyConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[C,y,d]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new E.Configuration(C,y,d)}getConfigurationData(){return this.configuration.toData()}getValue(C,y){const d=typeof C=="string"?C:void 0,S=(0,k.isConfigurationOverrides)(C)?C:(0,k.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(d,S,void 0)}updateValue(C,y,d,S){return Promise.reject(new Error("not supported"))}inspect(C){return this.configuration.inspect(C,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const C=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(C)}onDidChangeUserConfiguration(C){const y=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(C);this.trigger(d,y,1)}onDidDefaultConfigurationChange(C,y){const d=this.configuration.toData(),S=this.configuration.compareAndUpdateDefaultConfiguration(C,y);this.trigger(S,d,6)}onDidPolicyConfigurationChange(C){const y=this.configuration.toData(),d=this.configuration.compareAndUpdatePolicyConfiguration(C);this.trigger(d,y,6)}trigger(C,y,d){const S=new E.ConfigurationChangeEvent(C,{data:y},this.configuration);S.source=d,S.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(S)}getTargetConfiguration(C){switch(C){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=T}),define(we[103],ye([0,1,9,7]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var b;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(b=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class P extends I.ErrorNoTelemetry{constructor(E,v=b.Unknown,D){super(E);this._message=E,this._code=v,this._detail=D,this.isHandled=v===b.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,P.prototype)}static isTemporarilyNotAvailable(E){return E instanceof P&&E._code===b.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof P&&E._code===b.NoResolverFound}static isHandled(E){return E instanceof P&&E.isHandled}}e.RemoteAuthorityResolverError=P}),define(we[74],ye([0,1,8]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(k){return k.scheme===I.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=t;function b(k){if(!k)return;const E=k.indexOf("+");return E<0?k:k.substr(0,E)}e.getRemoteName=b;function P(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.getRemoteServerRootPath=P}),define(we[40],ye([0,1,15,7,74]),function(ie,e,I,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function P(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.getWorkspaceSupportTypeMessage=P;function k(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(E=e.ExtensionType||(e.ExtensionType={}));var v;(function(y){y.WIN32_X64="win32-x64",y.WIN32_IA32="win32-ia32",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(v=e.TargetPlatform||(e.TargetPlatform={}));class D{constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,S){if(typeof d=="undefined"||d===null)return typeof S=="undefined"||S===null;if(typeof S=="undefined"||S===null)return!1;if(typeof d=="string"||typeof S=="string"){let h=typeof d=="string"?d:d.value,g=typeof S=="string"?S:S.value;return I.equalsIgnoreCase(h,g)}return d._lower===S._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.ExtensionIdentifier=D;function T(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.isLanguagePackExtension=T;function R(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=R;function C(y,d){if(d){const S=`onResolveRemoteAuthority:${(0,b.getRemoteName)(d)}`;return y.activationEvents?.indexOf(S)!==-1}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[35],ye([0,1,15,31,40,3,4,9,26]),function(ie,e,I,t,b,P,k,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function D(i,o){return i.uuid&&o.uuid?i.uuid===o.uuid:i.id===o.id?!0:(0,I.compareIgnoreCase)(i.id,o.id)===0}e.areSameExtensions=D;const T=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class R{constructor(o,r,a="undefined"){this.version=r,this.targetPlatform=a,this.id=o.id}static create(o){const r=o.manifest?o.manifest.version:o.version,a=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new R(o.identifier,r,a)}static parse(o){const r=T.exec(o);return r&&r[1]&&r[2]?new R({id:r[1]},r[2],r[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof R?D(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.ExtensionKey=R;const C=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(i){const o=C.exec(i);return o&&o[1]?[S(o[1]),o[2]]:[S(i),void 0]}e.getIdAndVersion=y;function d(i,o){return`${i}.${o}`}e.getExtensionId=d;function S(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=S;function h(i,o){return S(d(i,o))}e.getGalleryExtensionId=h;function g(i,o){const r=[],a=c=>{for(const f of r)if(f.some(w=>D(o(w),o(c))))return f;return null};for(const c of i){const f=a(c);f?f.push(c):r.push([c])}return r}e.groupByExtension=g;function p(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=p;function m(i){return{id:i.identifier.id,name:i.name,galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),...i.telemetryData}}e.getGalleryExtensionTelemetryData=m,e.BetterMergeId=new b.ExtensionIdentifier("pprice.better-merge");function l(i){const o=new Set;if(i.malicious)for(const r of i.malicious)o.add(r.id);return o}e.getMaliciousExtensionsSet=l;function u(i,o){const r=[],a=o.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const c=a.shift();if(c&&r.every(f=>!D(f.identifier,{id:c}))){const f=i.filter(w=>D(w.identifier,{id:c}));f.length===1&&(r.push(f[0]),a.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=u;async function n(i,o){if(!P.isLinux)return!1;let r;try{r=(await i.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await i.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){o.debug("Error while getting the os-release file.",(0,E.getErrorMessage)(c))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=n;async function s(i,o){const r=await n(i,o),a=(0,t.getTargetPlatform)(r?"alpine":P.platform,v.arch);return o.debug("ComputeTargetPlatform:",a),a}e.computeTargetPlatform=s}),define(we[104],ye([0,1,20,9,85,8,55,4,160,31,35,40]),function(ie,e,I,t,b,P,k,E,v,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLIService=void 0;const C=h=>(0,v.localize)(0,null,h),y=(0,v.localize)(1,null,"ms-dotnettools.csharp");function d(h,g){return g?`${h.publisher}.${h.name}@${h.version}`:`${h.publisher}.${h.name}`}let S=class{constructor(g,p){this.extensionManagementService=g,this.extensionGalleryService=p}get location(){}async listExtensions(g,p,m=console){let l=await this.extensionManagementService.getInstalled(1);const u=R.EXTENSION_CATEGORIES.map(s=>s.toLowerCase());if(p&&p!==""){if(u.indexOf(p.toLowerCase())<0){m.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}l=l.filter(s=>s.manifest.categories?s.manifest.categories.map(o=>o.toLowerCase()).indexOf(p.toLowerCase())>-1:!1)}else if(p===""){m.log("Possible Categories: "),u.forEach(s=>{m.log(s)});return}this.location&&m.log((0,v.localize)(2,null,this.location)),l=l.sort((s,i)=>s.identifier.id.localeCompare(i.identifier.id));let n;for(let s of l)n!==s.identifier.id&&(n=s.identifier.id,m.log(d(s.manifest,g)))}async installExtensions(g,p,m,l,u=console){const n=[],s=[];g.length&&u.log(this.location?(0,v.localize)(3,null,this.location):(0,v.localize)(4,null));const i=await this.extensionManagementService.getInstalled(1),o=(f,w)=>{const A=i.find(U=>(0,T.areSameExtensions)(U.identifier,{id:f}));if(A){if(!l&&(!w||w==="prerelease"&&A.preRelease))return u.log((0,v.localize)(5,null,f,A.manifest.version,f)),!1;if(w&&A.manifest.version===w)return u.log((0,v.localize)(6,null,`${f}@${w}`)),!1}return!0},r=(f,w,A)=>{c.push({id:f,version:w!=="prerelease"?w:void 0,installOptions:{...m,isBuiltin:A,installPreReleaseVersion:w==="prerelease"||m.installPreReleaseVersion}})},a=[],c=[];for(const f of g)if(f instanceof E.URI)a.push(f);else{const[w,A]=(0,T.getIdAndVersion)(f);o(w,A)&&r(w,A,!1)}for(const f of p){const[w,A]=(0,T.getIdAndVersion)(f);o(w,A)&&r(w,A,!0)}if(a.length&&await Promise.all(a.map(async f=>{try{const w=await this.installVSIX(f,{...m,isBuiltin:!1},l,u);w&&s.push(w)}catch(w){u.error(w.message||w.stack||w),n.push(f.toString())}})),c.length){const f=await this.getGalleryExtensions(c);await Promise.all(c.map(async w=>{const A=f.get(w.id.toLowerCase());if(A)try{const U=await this.installFromGallery(w,A,i,l,u);U&&s.push(U)}catch(U){u.error(U.message||U.stack||U),n.push(w.id)}else u.error(`${C(w.version?`${w.id}@${w.version}`:w.id)}
${y}`),n.push(w.id)}))}if(n.length)throw new Error((0,v.localize)(7,null,n.join(", ")))}async installVSIX(g,p,m,l){const u=await this.extensionManagementService.getManifest(g);if(!u)throw new Error("Invalid vsix");if(await this.validateVSIX(u,m,l))try{return await this.extensionManagementService.install(g,p),l.log((0,v.localize)(8,null,(0,b.getBaseLabel)(g))),u}catch(s){if((0,t.isCancellationError)(s))return l.log((0,v.localize)(9,null,(0,b.getBaseLabel)(g))),null;throw s}return null}async getGalleryExtensions(g){const p=new Map,m=g.some(u=>u.installOptions.installPreReleaseVersion),l=await this.extensionGalleryService.getExtensions(g.map(u=>({...u,preRelease:m})),I.CancellationToken.None);for(const u of l)p.set(u.identifier.id.toLowerCase(),u);return p}async installFromGallery({id:g,version:p,installOptions:m},l,u,n,s){const i=await this.extensionGalleryService.getManifest(l,I.CancellationToken.None);if(i&&!this.validateExtensionKind(i,s))return null;const o=u.find(r=>(0,T.areSameExtensions)(r.identifier,l.identifier));if(o){if(l.version===o.manifest.version)return s.log((0,v.localize)(10,null,p?`${g}@${p}`:g)),null;s.log((0,v.localize)(11,null,g,l.version))}try{return m.isBuiltin?s.log(p?(0,v.localize)(12,null,g,p):(0,v.localize)(13,null,g)):s.log(p?(0,v.localize)(14,null,g,p):(0,v.localize)(15,null,g)),await this.extensionManagementService.installFromGallery(l,{...m,installGivenVersion:!!p}),s.log((0,v.localize)(16,null,g,l.version)),i}catch(r){if((0,t.isCancellationError)(r))return s.log((0,v.localize)(17,null,g)),null;throw r}}validateExtensionKind(g,p){return!0}async validateVSIX(g,p,m){const l={id:(0,T.getGalleryExtensionId)(g.publisher,g.name)},n=(await this.extensionManagementService.getInstalled(1)).find(s=>(0,T.areSameExtensions)(l,s.identifier)&&(0,k.gt)(s.manifest.version,g.version));return n&&!p?(m.log((0,v.localize)(18,null,n.identifier.id,n.manifest.version,g.version)),!1):this.validateExtensionKind(g,m)}async uninstallExtensions(g,p,m=console){const l=async n=>{if(n instanceof E.URI){const s=await this.extensionManagementService.getManifest(n);return d(s)}return n},u=[];for(const n of g){const s=await l(n),o=(await this.extensionManagementService.getInstalled()).filter(r=>(0,T.areSameExtensions)(r.identifier,{id:s}));if(!o.length)throw new Error(`${this.notInstalled(s)}
${y}`);if(o.some(r=>r.type===0)){m.log((0,v.localize)(19,null,s));return}if(!p&&o.some(r=>r.isBuiltin)){m.log((0,v.localize)(20,null,s));return}m.log((0,v.localize)(21,null,s));for(const r of o)await this.extensionManagementService.uninstall(r),u.push(r);this.location?m.log((0,v.localize)(22,null,s,this.location)):m.log((0,v.localize)(23,null,s))}}async locateExtension(g,p=console){const m=await this.extensionManagementService.getInstalled();g.forEach(l=>{m.forEach(u=>{if(u.identifier.id===l&&u.location.scheme===P.Schemas.file){p.log(u.location.fsPath);return}})})}notInstalled(g){return this.location?(0,v.localize)(24,null,g,this.location):(0,v.localize)(25,null,g)}};S=Re([Fe(0,D.IExtensionManagementService),Fe(1,D.IExtensionGalleryService)],S),e.ExtensionManagementCLIService=S}),define(we[50],ye([0,1,17,14,21,16,9,63,151,2,8,5,3,19,55,65,12,4,161,24,35,40,69,18,7,13,25,6,45]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C,y,d,S,h,g,p,m,l,u,n,s,i,o,r,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var f;(function(Y){function O(B,ue){if(B===ue)return!0;let V=Object.keys(B),$=new Set;for(let F of Object.keys(ue))$.add(F);if(V.length!==$.size)return!1;for(let F of V){if(B[F]!==ue[F])return!1;$.delete(F)}return $.size===0}Y.equals=O})(f=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let w=class extends D.Disposable{constructor(O,B,ue,V,$,F,M,j){super();this.systemExtensionsLocation=O,this.userExtensionsLocation=B,this.extensionsControlLocation=ue,this.cacheLocation=V,this.fileService=$,this.logService=F,this.environmentService=M,this.productService=j,this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.systemExtensionsCachedScanner=this._register(new x((0,y.joinPath)(this.cacheLocation,u.BUILTIN_MANIFEST_CACHE_FILE),this.fileService,this.logService)),this.userExtensionsCachedScanner=this._register(new x((0,y.joinPath)(this.cacheLocation,u.USER_MANIFEST_CACHE_FILE),this.fileService,this.logService)),this.extensionsScanner=this._register(new U(this.fileService,this.logService)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,l.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(O){const[B,ue]=await Promise.all([this.scanSystemExtensions(O),this.scanUserExtensions(O)]),V=await this.scanExtensionsUnderDevelopment(O,[...B,...ue]);return this.dedupExtensions([...B,...ue,...V],await this.getTargetPlatform(),!0)}async scanSystemExtensions(O){const B=[];B.push(this.scanDefaultSystemExtensions(!!O.useCache,O.language)),B.push(this.scanDevSystemExtensions(O.language,!!O.checkControlFile));const[ue,V]=await Promise.all(B);return this.applyScanOptions([...ue,...V],O,!1)}async scanUserExtensions(O){this.logService.trace("Started scanning user extensions");const B=await this.createExtensionScannerInput(this.userExtensionsLocation,1,!O.includeUninstalled,O.language);let V=await(O.useCache&&!B.devMode&&B.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(B);return V=await this.applyScanOptions(V,O,!0),this.logService.trace("Scanned user extensions:",V.length),V}async scanExtensionsUnderDevelopment(O,B){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const ue=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(V=>V.scheme===T.Schemas.file).map(async V=>{const $=await this.createExtensionScannerInput(V,1,!0,O.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions($)).map(M=>(M.type=B.find(j=>(0,l.areSameExtensions)(j.identifier,M.identifier))?.type??M.type,this.extensionsScanner.validate(M,$)))}))).flat();return this.applyScanOptions(ue,O,!0)}return[]}async scanExistingExtension(O,B,ue){const V=await this.createExtensionScannerInput(O,B,!0,ue.language),$=await this.extensionsScanner.scanExtension(V);return!$||!ue.includeInvalid&&!$.isValid?null:$}async scanOneOrMultipleExtensions(O,B,ue){const V=await this.createExtensionScannerInput(O,B,!0,ue.language),$=await this.extensionsScanner.scanOneOrMultipleExtensions(V);return this.applyScanOptions($,ue,!0)}async updateMetadata(O,B){const ue=(0,y.joinPath)(O,"package.json"),V=(await this.fileService.readFile(ue)).value.toString(),$=JSON.parse(V);B.isMachineScoped=B.isMachineScoped||void 0,B.isBuiltin=B.isBuiltin||void 0,B.installedTimestamp=B.installedTimestamp||void 0,$.__metadata={...$.__metadata,...B},await this.fileService.writeFile((0,y.joinPath)(O,"package.json"),P.VSBuffer.fromString(JSON.stringify($,null,"	")))}async applyScanOptions(O,B,ue){return B.includeAllVersions||(O=this.dedupExtensions(O,await this.getTargetPlatform(),ue)),B.includeInvalid||(O=O.filter(V=>V.isValid)),O.sort((V,$)=>{const F=R.basename(V.location.fsPath),M=R.basename($.location.fsPath);return F<M?-1:F>M?1:0})}dedupExtensions(O,B,ue){const V=new Map;for(const $ of O){const F=u.ExtensionIdentifier.toKey($.identifier.id),M=V.get(F);if(M){if(M.isValid&&!$.isValid)continue;if(M.isValid===$.isValid){if(ue&&d.gt(M.manifest.version,$.manifest.version)){this.logService.debug(`Skipping extension ${$.location.path} with lower version ${$.manifest.version}.`);continue}if(d.eq(M.manifest.version,$.manifest.version)&&M.targetPlatform===B){this.logService.debug(`Skipping extension ${$.location.path} from different target platform ${$.targetPlatform}`);continue}}M.type===0?this.logService.debug(`Overwriting system extension ${M.location.path} with ${$.location.path}.`):this.logService.warn(`Overwriting user extension ${M.location.path} with ${$.location.path}.`)}V.set(F,$)}return[...V.values()]}async scanDefaultSystemExtensions(O,B){this.logService.trace("Started scanning system extensions");const ue=await this.createExtensionScannerInput(this.systemExtensionsLocation,0,!0,B),$=await(O&&!ue.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(ue);return this.logService.trace("Scanned system extensions:",$.length),$}async scanDevSystemExtensions(O,B){const ue=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!ue?.length)return[];this.logService.trace("Started scanning dev system extensions");const V=B?await this.getBuiltInExtensionControl():{},$=[],F=g.URI.file(R.normalize(R.join(T.FileAccess.asFileUri("",ie).fsPath,"..",".build","builtInExtensions")));for(const j of ue){const Z=V[j.name]||"marketplace";switch(Z){case"disabled":break;case"marketplace":$.push((0,y.joinPath)(F,j.name));break;default:$.push(g.URI.file(Z));break}}const M=await Promise.all($.map(async j=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(j,0,!0,O))));return this.logService.trace("Scanned dev system extensions:",M.length),(0,I.coalesce)(M)}async getBuiltInExtensionControl(){try{const O=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(O.value.toString())}catch{return{}}}async createExtensionScannerInput(O,B,ue,V,$=!0){const F=await this.getTranslations(V??C.language);let M;try{const j=await this.fileService.stat(O);typeof j.mtime=="number"&&(M=j.mtime)}catch{}return new A(O,M,B,ue,$,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,V,F)}};w=Re([Fe(4,s.IFileService),Fe(5,o.ILogService),Fe(6,m.IEnvironmentService),Fe(7,r.IProductService)],w),e.AbstractExtensionsScannerService=w;class A{constructor(O,B,ue,V,$,F,M,j,Z,oe,ge){this.location=O,this.mtime=B,this.type=ue,this.excludeObsolete=V,this.validate=$,this.productVersion=F,this.productDate=M,this.productCommit=j,this.devMode=Z,this.language=oe,this.translations=ge}static createNlsConfiguration(O){return{language:O.language,pseudo:O.language==="pseudo",devMode:O.devMode,translations:O.translations}}static equals(O,B){return(0,y.isEqual)(O.location,B.location)&&O.mtime===B.mtime&&O.type===B.type&&O.excludeObsolete===B.excludeObsolete&&O.validate===B.validate&&O.productVersion===B.productVersion&&O.productDate===B.productDate&&O.productCommit===B.productCommit&&O.devMode===B.devMode&&O.language===B.language&&f.equals(O.translations,B.translations)}}class U extends D.Disposable{constructor(O,B){super();this.fileService=O,this.logService=B}async scanExtensions(O){const B=await this.fileService.resolve(O.location);if(B.children){let ue={};if(O.excludeObsolete&&O.type===1)try{const $=(await this.fileService.readFile((0,y.joinPath)(O.location,".obsolete"))).value.toString();ue=JSON.parse($)}catch{}const V=await Promise.all(B.children.map(async $=>{if(!$.isDirectory||O.type===1&&(0,y.basename)($.resource).indexOf(".")===0)return null;const F=new A($.resource,O.mtime,O.type,O.excludeObsolete,O.validate,O.productVersion,O.productDate,O.productCommit,O.devMode,O.language,O.translations),M=await this.scanExtension(F);return M&&!ue[l.ExtensionKey.create(M).toString()]?M:null}));return(0,I.coalesce)(V)}return[]}async scanOneOrMultipleExtensions(O){try{if(await this.fileService.exists((0,y.joinPath)(O.location,"package.json"))){const B=await this.scanExtension(O);return B?[B]:[]}else return await this.scanExtensions(O)}catch(B){return this.logService.error(`Error scanning extensions at ${O.location.path}:`,(0,k.getErrorMessage)(B)),[]}}async scanExtension(O){try{let B=await this.scanExtensionManifest(O.location);if(B){B.publisher||(B.publisher=u.UNDEFINED_PUBLISHER);const ue=B.__metadata;delete B.__metadata;const V=(0,l.getGalleryExtensionId)(B.publisher,B.name),$=ue?.id?{id:V,uuid:ue.id}:{id:V},F=ue?.isSystem?0:O.type,M=F===0||!!ue?.isBuiltin;B=await this.translateManifest(O.location,B,A.createNlsConfiguration(O));const j={type:F,identifier:$,manifest:B,location:O.location,isBuiltin:M,targetPlatform:ue?.targetPlatform??"undefined",metadata:ue,isValid:!0,validations:[]};return O.validate?this.validate(j,O):j}}catch(B){O.type!==0&&this.logService.error(B)}return null}validate(O,B){let ue=!0;const V=(0,n.validateExtensionManifest)(B.productVersion,B.productDate,B.location,O.manifest,O.isBuiltin);for(const[$,F]of V)$===S.default.Error&&(ue=!1,this.logService.error(this.formatMessage(B.location,F)));return O.isValid=ue,O.validations=V,O}async scanExtensionManifest(O){const B=(0,y.joinPath)(O,"package.json");let ue;try{ue=(await this.fileService.readFile(B)).value.toString()}catch($){return(0,s.toFileOperationResult)($)!==1&&this.logService.error(this.formatMessage(O,(0,p.localize)(0,null,B.path,$.message))),null}let V;try{V=JSON.parse(ue)}catch{const F=[];(0,E.parse)(ue,F);for(const M of F)this.logService.error(this.formatMessage(O,(0,p.localize)(1,null,B.path,M.offset,M.length,(0,v.getParseErrorMessage)(M.error))));return null}return(0,E.getNodeType)(V)!=="object"?(this.logService.error(this.formatMessage(O,(0,p.localize)(2,null,B.path))),null):V}async translateManifest(O,B,ue){const V=await this.getLocalizedMessages(O,B,ue);if(V)try{const $=[],F=await this.resolveOriginalMessageBundle(V.default,$);if($.length>0)return $.forEach(j=>{this.logService.error(this.formatMessage(O,(0,p.localize)(3,null,V.default?.path,(0,v.getParseErrorMessage)(j.error))))}),B;if((0,E.getNodeType)(V)!=="object")return this.logService.error(this.formatMessage(O,(0,p.localize)(4,null,V.default?.path))),B;const M=V.values||Object.create(null);this.replaceNLStrings(ue.pseudo,B,M,F,O)}catch{}return B}async getLocalizedMessages(O,B,ue){const V=(0,y.joinPath)(O,"package.nls.json"),$=(Z,oe)=>{oe.forEach(ge=>{this.logService.error(this.formatMessage(O,(0,p.localize)(5,null,Z?.path,(0,v.getParseErrorMessage)(ge.error))))})},F=Z=>{this.logService.error(this.formatMessage(O,(0,p.localize)(6,null,Z?.path)))},M=`${B.publisher}.${B.name}`,j=ue.translations[M];if(j)try{const Z=g.URI.file(j),oe=(await this.fileService.readFile(Z)).value.toString();let ge=[],he=(0,E.parse)(oe,ge);return ge.length>0?($(Z,ge),{values:void 0,default:V}):(0,E.getNodeType)(he)!=="object"?(F(Z),{values:void 0,default:V}):{values:he.contents?he.contents.package:void 0,default:V}}catch{return{values:void 0,default:V}}else{if(!await this.fileService.exists(V))return;let oe;try{oe=await this.findMessageBundles(O,ue)}catch{return}if(!oe.localized)return{values:void 0,default:oe.original};try{const ge=(await this.fileService.readFile(oe.localized)).value.toString();let he=[],q=(0,E.parse)(ge,he);return he.length>0?($(oe.localized,he),{values:void 0,default:oe.original}):(0,E.getNodeType)(q)!=="object"?(F(oe.localized),{values:void 0,default:oe.original}):{values:q,default:oe.original}}catch{return{values:void 0,default:oe.original}}}}async resolveOriginalMessageBundle(O,B){if(O)try{const ue=(await this.fileService.readFile(O)).value.toString();return(0,E.parse)(ue,B)}catch{return null}else return null}findMessageBundles(O,B){return new Promise((ue,V)=>{const $=F=>{let M=(0,y.joinPath)(O,`package.nls.${F}.json`);this.fileService.exists(M).then(j=>{j&&ue({localized:M,original:(0,y.joinPath)(O,"package.nls.json")});let Z=F.lastIndexOf("-");Z===-1?ue({localized:(0,y.joinPath)(O,"package.nls.json"),original:null}):(F=F.substring(0,Z),$(F))})};if(B.devMode||B.pseudo||!B.language)return ue({localized:(0,y.joinPath)(O,"package.nls.json"),original:null});$(B.language)})}replaceNLStrings(O,B,ue,V,$){const F=(M,j,Z)=>{const oe=M[j];if((0,h.isString)(oe)){const ge=oe,he=ge.length;if(he>1&&ge[0]==="%"&&ge[he-1]==="%"){const q=ge.substr(1,he-2);let ee=ue[q];ee===void 0&&V&&(ee=V[q]);let G=typeof ee=="string"?ee:typeof ee?.message=="string"?ee.message:void 0;G!==void 0?(O&&(G="\uFF3B"+G.replace(/[aouei]/g,"$&$&")+"\uFF3D"),M[j]=Z&&(j==="title"||j==="category")&&V?{value:G,original:V[q]}:G):this.logService.warn(this.formatMessage($,(0,p.localize)(7,null,q)))}}else if((0,h.isObject)(oe))for(let ge in oe)oe.hasOwnProperty(ge)&&(ge==="commands"?F(oe,ge,!0):F(oe,ge,Z));else if((0,h.isArray)(oe))for(let ge=0;ge<oe.length;ge++)F(oe,ge,Z)};for(let M in B)B.hasOwnProperty(M)&&F(B,M)}formatMessage(O,B){return`[${O.path}]: ${B}`}}class x extends U{constructor(O,B,ue){super(B,ue);this.cacheFile=O,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(O){const B=await this.readExtensionCache();if(this.input=O,B&&B.input&&A.equals(B.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),B.result.map(V=>(V.location=g.URI.revive(V.location),V));const ue=await super.scanExtensions(O);return await this.writeExtensionCache({input:O,result:ue}),ue}async readExtensionCache(){try{const O=await this.fileService.readFile(this.cacheFile),B=JSON.parse(O.value.toString());return{result:B.result,input:(0,c.revive)(B.input)}}catch(O){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,k.getErrorMessage)(O))}return null}async writeExtensionCache(O){try{await this.fileService.writeFile(this.cacheFile,P.VSBuffer.fromString(JSON.stringify(O)))}catch(B){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,k.getErrorMessage)(B))}}async validateCache(){if(!this.input)return;const O=await this.readExtensionCache();if(!O)return;const B=O.result,ue=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!b.equals(ue,B))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(V){this.logService.error(V)}}}function Q(Y,O){const B=(0,l.getExtensionId)(Y.manifest.publisher,Y.manifest.name);return{id:B,identifier:new u.ExtensionIdentifier(B),isBuiltin:Y.type===0,isUserBuiltin:Y.type===1&&Y.isBuiltin,isUnderDevelopment:O,extensionLocation:Y.location,uuid:Y.identifier.uuid,targetPlatform:Y.targetPlatform,...Y.manifest}}e.toExtensionDescription=Q;class _ extends w{constructor(O,B,ue,V,$,F,M,j){super(O,B,(0,y.joinPath)(ue,".vscode-oss-dev","extensions","control.json"),(0,y.joinPath)(V,u.MANIFEST_CACHE_FOLDER),$,F,M,j);this.translationsPromise=(async()=>{if(C.translationsConfigFile)try{const Z=await this.fileService.readFile(g.URI.file(C.translationsConfigFile));return JSON.parse(Z.value.toString())}catch{}return Object.create(null)})()}getTranslations(O){return this.translationsPromise}}e.NativeExtensionsScannerService=_}),define(we[208],ye([0,1,14,9,2,3,19,55,4,27,22,24,31,35,18,13]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C,y,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let h=class extends b.Disposable{constructor(p,m,l,u){super();this.fileService=m,this.extensionGalleryService=l,this.logService=u,this.extensionsDownloadDir=v.URI.file(p.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(p,m){await this.cleanUpPromise;const l=this.getName(p),u=(0,k.joinPath)(this.extensionsDownloadDir,l);if(!await this.fileService.exists(u)){const n=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,D.generateUuid)()}`);await this.fileService.exists(n)||await this.extensionGalleryService.download(p,n,m);try{await this.rename(n,u,Date.now()+2*60*1e3)}catch(s){try{await this.fileService.del(n)}catch{}if(s.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",p.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(s)}. Deleted the vsix from downloaded location`,n.path),s}}return u}async delete(p){await this.cleanUpPromise,await this.fileService.del(p)}async rename(p,m,l){try{await T.Promises.rename(p.fsPath,m.fsPath)}catch(u){if(P.isWindows&&u&&u.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${p} to ${m} with 'EPERM' error. Trying again...`),this.rename(p,m,l);throw u}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const p=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(p.children){const m=[],l=[];for(const s of p.children){const i=y.ExtensionKey.parse(s.name);i&&l.push([i,s])}const u=(0,y.groupByExtension)(l,([s])=>s),n=[];for(const s of u)s.sort((i,o)=>E.rcompare(i[0].version,o[0].version)),m.push(...s.slice(1).map(i=>i[1].resource)),n.push(s[0][1]);n.sort((s,i)=>s.mtime-i.mtime),m.push(...n.slice(0,Math.max(0,n.length-this.cache)).map(s=>s.resource)),await I.Promises.settled(m.map(s=>(this.logService.trace("Deleting vsix from cache",s.path),this.fileService.del(s))))}}catch(p){this.logService.error(p)}}getName(p){return this.cache?y.ExtensionKey.create(p).toString().toLowerCase():(0,D.generateUuid)()}};h=Re([Fe(0,R.INativeEnvironmentService),Fe(1,d.IFileService),Fe(2,C.IExtensionGalleryService),Fe(3,S.ILogService)],h),e.ExtensionsDownloader=h}),define(we[209],ye([0,1,2,5,22,40]),function(ie,e,I,t,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class k extends I.Disposable{constructor(v,D){super();this.environmentService=v,this.extensionsManifestCache=(0,t.join)(this.environmentService.userDataPath,P.MANIFEST_CACHE_FOLDER,P.USER_MANIFEST_CACHE_FILE),this._register(D.onDidInstallExtensions(T=>this.onDidInstallExtensions(T))),this._register(D.onDidUninstallExtension(T=>this.onDidUnInstallExtension(T)))}onDidInstallExtensions(v){v.some(D=>!!D.local)&&this.invalidate()}onDidUnInstallExtension(v){v.error||this.invalidate()}invalidate(){b.Promises.rm(this.extensionsManifestCache,b.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=k}),define(we[105],ye([0,1,75,17,14,2,8,5,22,24,31,35,13,73]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let d=class extends y.LanguagePackBaseService{constructor(p,m,l,u){super(l);this.extensionManagementService=p,this.logService=u,this.cache=this._register(new S(m,u)),this.extensionManagementService.registerParticipant({postInstall:async n=>this.postInstallExtension(n),postUninstall:async n=>this.postUninstallExtension(n)})}async getInstalledLanguages(){const p=await this.cache.getLanguagePacks(),m=Object.keys(p).map(l=>{const u=p[l];return{...this.createQuickPickItem({locale:l,label:u.label}),extensionId:u.extensions[0].extensionIdentifier.id}});return m.push({...this.createQuickPickItem({locale:"en",label:"English"}),extensionId:"default"}),m}async postInstallExtension(p){p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",p.identifier.id),await this.update())}async postUninstallExtension(p){const m=await this.cache.getLanguagePacks();Object.keys(m).some(l=>m[l]&&m[l].extensions.some(u=>(0,R.areSameExtensions)(u.extensionIdentifier,p.identifier)))&&(this.logService.info("Removing language packs from the extension",p.identifier.id),await this.update())}async update(){const[p,m]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),l=await this.cache.update(m);return!(0,t.equals)(Object.keys(p),Object.keys(l))}};d=Re([Fe(0,T.IExtensionManagementService),Fe(1,D.INativeEnvironmentService),Fe(2,T.IExtensionGalleryService),Fe(3,C.ILogService)],d),e.NativeLanguagePackService=d;let S=class extends P.Disposable{constructor(p,m){super();this.logService=m,this.languagePacks={},this.languagePacksFilePath=(0,E.join)(p.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new b.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(p){return this.withLanguagePacks(m=>{Object.keys(m).forEach(l=>delete m[l]),this.createLanguagePacksFromExtensions(m,...p)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(p,...m){for(const l of m)l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(p,l);Object.keys(p).forEach(l=>this.updateHash(p[l]))}createLanguagePacksFromExtension(p,m){const l=m.identifier,u=m.manifest.contributes&&m.manifest.contributes.localizations?m.manifest.contributes.localizations:[];for(const n of u)if(m.location.scheme===k.Schemas.file&&h(n)){let s=p[n.languageId];s||(s={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},p[n.languageId]=s);let i=s.extensions.filter(o=>(0,R.areSameExtensions)(o.extensionIdentifier,l))[0];i?i.version=m.manifest.version:s.extensions.push({extensionIdentifier:l,version:m.manifest.version});for(const o of n.translations)s.translations[o.id]=(0,E.join)(m.location.fsPath,o.path)}}updateHash(p){if(p){const m=(0,I.createHash)("md5");for(const l of p.extensions)m.update(l.extensionIdentifier.uuid||l.extensionIdentifier.id).update(l.version);p.hash=m.digest("hex")}}withLanguagePacks(p=()=>null){return this.languagePacksFileLimiter.queue(()=>{let m=null;return v.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,l=>l.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(l)).then(l=>{try{return JSON.parse(l)}catch{return{}}}).then(l=>(m=p(l),l)).then(l=>{for(const n of Object.keys(l))l[n]||delete l[n];this.languagePacks=l,this.initializedCache=!0;const u=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",u),v.Promises.writeFile(this.languagePacksFilePath,u)}).then(()=>m,l=>this.logService.error(l))})}};S=Re([Fe(0,D.INativeEnvironmentService),Fe(1,C.ILogService)],S);function h(g){if(typeof g.languageId!="string"||!Array.isArray(g.translations)||g.translations.length===0)return!1;for(const p of g.translations)if(typeof p.id!="string"||typeof p.path!="string")return!1;return!(g.languageName&&typeof g.languageName!="string"||g.localizedLanguageName&&typeof g.localizedLanguageName!="string")}}),define(we[51],ye([0,1,16,171,49,7,34]),function(ie,e,I,t,b,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,P.createDecorator)("requestService");function E(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}e.isSuccess=E;function v(S){return S.res.statusCode===204}async function D(S){return v(S)?null:(await(0,I.streamToBuffer)(S.stream)).toString()}e.asText=D;async function T(S){if(!E(S))throw new Error("Server returned "+S.res.statusCode);return D(S)}e.asTextOrError=T;async function R(S){if(!E(S))throw new Error("Server returned "+S.res.statusCode);if(v(S))return null;const g=(await(0,I.streamToBuffer)(S.stream)).toString();try{return JSON.parse(g)}catch(p){throw p.message+=`:
`+g,p}}e.asJson=R;function C(S){d(S)}e.updateProxyConfigurationsScope=C;let y;function d(S){const h=k.Registry.as(b.Extensions.Configuration),g=y;y={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},h.updateConfigurations({add:[y],remove:g?[g]:[]})}d(2)}),define(we[210],ye([0,1,20,8,18,51]),function(ie,e,I,t,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(v,D){this.requestService=v,this.fileService=D}async download(v,D,T=I.CancellationToken.None){if(v.scheme===t.Schemas.file||v.scheme===t.Schemas.vscodeRemote){await this.fileService.copy(v,D);return}const R={type:"GET",url:v.toString()},C=await this.requestService.request(R,T);if(C.res.statusCode===200)await this.fileService.writeFile(D,C.stream);else{const y=await(0,P.asTextOrError)(C);throw new Error(`Expected 200, got back ${C.res.statusCode} instead.

${y}`)}}};k=Re([Fe(0,P.IRequestService),Fe(1,b.IFileService)],k),e.DownloadService=k}),define(we[211],ye([0,1,16,20]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class b{constructor(E){this.service=E}listen(E,v){throw new Error("Invalid listen")}call(E,v,D){switch(v){case"request":return this.service.request(D[0],t.CancellationToken.None).then(async({res:T,stream:R})=>{const C=await(0,I.streamToBuffer)(R);return[{statusCode:T.statusCode,headers:T.headers},C]})}throw new Error("Invalid call")}}e.RequestChannel=b;class P{constructor(E){this.channel=E}async request(E,v){return P.request(this.channel,E,v)}static async request(E,v,D){const[T,R]=await E.call("request",[v]);return{res:T,stream:(0,I.bufferToStream)(R)}}}e.RequestChannelClient=P}),define(we[212],ye([0,1,76,12]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function b(k,E){return k.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:k.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function P(k,E,v={}){const D=(0,I.parse)(k),T=v.proxyUrl||b(D,E);if(!T)return null;const R=(0,I.parse)(T);if(!/^https?:$/.test(R.protocol||""))return null;const C={host:R.hostname||"",port:R.port||(R.protocol==="https"?"443":"80"),auth:R.auth,rejectUnauthorized:(0,t.isBoolean)(v.strictSSL)?v.strictSSL:!0};return D.protocol==="http:"?new(await new Promise((y,d)=>{ie(["http-proxy-agent"],y,d)}))(C):new(await new Promise((y,d)=>{ie(["https-proxy-agent"],y,d)}))(C)}e.getProxyAgent=P}),define(we[77],ye([0,1,38,5,172,20,36,9,3,27,153,185,14]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const y=1e4;let d;async function S(g,p,m){return p["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):v.isWindows?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,R.isLaunchedFromCli)(m)&&!p["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,R.isLaunchedFromCli)(m)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=C.Promises.withAsyncBody(async(l,u)=>{const n=new P.CancellationTokenSource,s=setTimeout(()=>{n.dispose(!0),u(new Error((0,b.localize)(0,null)))},y);try{l(await h(g,n.token))}catch(i){!(0,E.isCancellationError)(i)&&!n.token.isCancellationRequested?u(new Error((0,b.localize)(1,null,(0,k.toErrorMessage)(i)))):l({})}finally{clearTimeout(s),n.dispose()}})),d)}e.getResolvedShellEnv=S;async function h(g,p){const m=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",m);const l=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",l);const u=(0,D.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(u+"(.*)"+u),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};g.trace("getUnixShellEnvironment#env",s);const i=await(0,T.getSystemShell)(v.OS,s);return g.trace("getUnixShellEnvironment#shell",i),new Promise((o,r)=>{if(p.isCancellationRequested)return r((0,E.canceled)());const a=(0,t.basename)(i);let c,f;const w=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(c=`& '${process.execPath}' ${w} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,f=["-Login","-Command"]):(c=`'${process.execPath}' ${w} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,a==="tcsh"?f=["-ic"]:f=["-ilc"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(f),c);const A=(0,I.spawn)(i,[...f,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});p.onCancellationRequested(()=>(A.kill(),r((0,E.canceled)()))),A.on("error",Q=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(Q)),r(Q)});const U=[];A.stdout.on("data",Q=>U.push(Q));const x=[];A.stderr.on("data",Q=>x.push(Q)),A.on("close",(Q,_)=>{const Y=Buffer.concat(U).toString("utf8");g.trace("getUnixShellEnvironment#raw",Y);const O=Buffer.concat(x).toString("utf8");if(O.trim()&&g.trace("getUnixShellEnvironment#stderr",O),Q||_)return r(new Error((0,b.localize)(2,null,Q,_)));const B=n.exec(Y),ue=B?B[1]:"{}";try{const V=JSON.parse(ue);m?V.ELECTRON_RUN_AS_NODE=m:delete V.ELECTRON_RUN_AS_NODE,l?V.ELECTRON_NO_ATTACH_CONSOLE=l:delete V.ELECTRON_NO_ATTACH_CONSOLE,delete V.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",V),o(V)}catch(V){g.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(V)),r(V)}})})}}),define(we[213],ye([0,1,14,6,2,46,12,144,7]),function(ie,e,I,t,b,P,k,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const D="__$__targetStorageMarker";e.IStorageService=(0,v.createDecorator)("storageService");var T;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(T=e.WillSaveStateReason||(e.WillSaveStateReason={}));var R;(function(h){h[h.GLOBAL=0]="GLOBAL",h[h.WORKSPACE=1]="WORKSPACE"})(R=e.StorageScope||(e.StorageScope={}));var C;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(C=e.StorageTarget||(e.StorageTarget={}));class y extends b.Disposable{constructor(g={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super();this.options=g,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new I.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new b.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,I.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,b.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,P.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,P.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(g,p){p===D?(g===0?this._globalKeyTargets=void 0:g===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:g})):this._onDidChangeValue.fire({scope:g,key:p,target:this.getKeyTargets(g)[p]})}emitWillSaveState(g){this._onWillSaveState.fire({reason:g})}get(g,p,m){return this.getStorage(p)?.get(g,m)}getBoolean(g,p,m){return this.getStorage(p)?.getBoolean(g,m)}getNumber(g,p,m){return this.getStorage(p)?.getNumber(g,m)}store(g,p,m,l){if((0,k.isUndefinedOrNull)(p)){this.remove(g,m);return}this.withPausedEmitters(()=>{this.updateKeyTarget(g,m,l),this.getStorage(m)?.set(g,p)})}remove(g,p){this.withPausedEmitters(()=>{this.updateKeyTarget(g,p,void 0),this.getStorage(p)?.delete(g)})}withPausedEmitters(g){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{g()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(g,p){const m=[],l=this.getKeyTargets(g);for(const u of Object.keys(l))l[u]===p&&m.push(u);return m}updateKeyTarget(g,p,m){const l=this.getKeyTargets(p);typeof m=="number"?l[g]!==m&&(l[g]=m,this.getStorage(p)?.set(D,JSON.stringify(l))):typeof l[g]=="number"&&(delete l[g],this.getStorage(p)?.set(D,JSON.stringify(l)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(g){return g===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(g){const p=this.get(D,g);if(p)try{return JSON.parse(p)}catch{}return Object.create(null)}isNew(g){return this.getBoolean(e.IS_NEW_KEY,g)===!0}async flush(g=T.NONE){this._onWillSaveState.fire({reason:g});const p=this.getStorage(0),m=this.getStorage(1);switch(g){case T.NONE:await I.Promises.settled([p?.whenFlushed()??Promise.resolve(),m?.whenFlushed()??Promise.resolve()]);break;case T.SHUTDOWN:await I.Promises.settled([p?.flush(0)??Promise.resolve(),m?.flush(0)??Promise.resolve()]);break}}async logStorage(){const g=this.getStorage(0)?.items??new Map,p=this.getStorage(1)?.items??new Map;return S(g,p,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;class d extends y{constructor(){super();this.globalStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(g=>this.emitDidChangeValue(1,g))),this._register(this.globalStorage.onDidChangeStorage(g=>this.emitDidChangeValue(0,g)))}getStorage(g){return g===0?this.globalStorage:this.workspaceStorage}getLogDetails(g){return g===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(g){}}e.InMemoryStorageService=d;async function S(h,g,p,m){const l=a=>{try{return JSON.parse(a)}catch{return a}},u=new Map,n=new Map;h.forEach((a,c)=>{u.set(c,a),n.set(c,l(a))});const s=new Map,i=new Map;g.forEach((a,c)=>{s.set(c,a),i.set(c,l(a))}),console.group(`Storage: Global (path: ${p})`);let o=[];u.forEach((a,c)=>{o.push({key:c,value:a})}),console.table(o),console.groupEnd(),console.log(n),console.group(`Storage: Workspace (path: ${m})`);let r=[];s.forEach((a,c)=>{r.push({key:c,value:a})}),console.table(r),console.groupEnd(),console.log(i)}e.logStorage=S}),define(we[214],ye([0,1,3,26,4,27]),function(ie,e,I,t,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(D){if(I.platform===2&&/^penguin(\.|$)/i.test(D))return"chromebook"}async function E(D,T,R,C,y,d,S,h,g,p){const m=Object.create(null);m["common.machineId"]=S,m.sessionID=(0,P.generateUuid)()+Date.now(),m.commitHash=y,m.version=d,m["common.platformVersion"]=(T||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,I.PlatformToString)(I.platform),m["common.nodePlatform"]=t.platform,m["common.nodeArch"]=C,m["common.product"]=p||"desktop";const l=v(h||[]);l&&(m["common.msftInternal"]=l);let u=0;const n=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),I.isLinuxSnap&&(m["common.snap"]="true");const s=k(R);s&&(m["common.platformDetail"]=s);try{const i=await D.readFile(b.URI.file(g));m["common.source"]=i.value.toString().slice(0,30)}catch{}return m}e.resolveCommonProperties=E;function v(D){const T=t.env.USERDNSDOMAIN;if(!T)return!1;const R=T.toLowerCase();return D.some(C=>R===C)}e.verifyMicrosoftInternalDomain=v}),define(we[215],ye([0,1,17,9,2,21]),function(ie,e,I,t,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var k;(function(v){function D(T,R){return T.callstack<R.callstack?-1:T.callstack>R.callstack?1:0}v.compare=D})(k=e.ErrorEvent||(e.ErrorEvent={}));class E{constructor(D,T=E.ERROR_FLUSH_TIMEOUT){this._flushHandle=-1,this._buffer=[],this._disposables=new b.DisposableStore,this._telemetryService=D,this._flushDelay=T;const R=t.errorHandler.addListener(C=>this._onErrorEvent(C));this._disposables.add((0,b.toDisposable)(R)),this.installErrorListeners()}dispose(){clearTimeout(this._flushHandle),this._flushBuffer(),this._disposables.dispose()}installErrorListeners(){}_onErrorEvent(D){if(!D||(D.detail&&D.detail.stack&&(D=D.detail),D instanceof t.ErrorNoTelemetry))return;let T=Array.isArray(D.stack)?D.stack.join(`
`):D.stack,R=D.message?D.message:(0,P.safeStringify)(D);!T||this._enqueue({msg:R,callstack:T})}_enqueue(D){const T=(0,I.binarySearch)(this._buffer,D,k.compare);T<0?(D.count=1,this._buffer.splice(~T,0,D)):(this._buffer[T].count||(this._buffer[T].count=0),this._buffer[T].count+=1),this._flushHandle===-1&&(this._flushHandle=setTimeout(()=>{this._flushBuffer(),this._flushHandle=-1},this._flushDelay))}_flushBuffer(){for(let D of this._buffer)this._telemetryService.publicLogError2("UnhandledError",D);this._buffer.length=0}}e.default=E,E.ERROR_FLUSH_TIMEOUT=5*1e3}),define(we[216],ye([0,1,2]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerTelemetryChannel=void 0;class t extends I.Disposable{constructor(P,k){super();this.telemetryService=P,this.telemetryAppender=k}async call(P,k,E){switch(k){case"updateTelemetryLevel":{const{telemetryLevel:v}=E;return this.telemetryService.updateInjectedTelemetryLevel(v)}case"logTelemetry":{const{eventName:v,data:D}=E;return this.telemetryAppender?this.telemetryAppender.log(v,D):Promise.resolve()}case"flushTelemetry":return this.telemetryAppender?this.telemetryAppender.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${k} not found`)}listen(P,k,E){throw new Error("Not supported")}dispose(){this.telemetryService.updateInjectedTelemetryLevel(0),super.dispose()}}e.ServerTelemetryChannel=t}),define(we[32],ye([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,I.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,I.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(P){P[P.NONE=0]="NONE",P[P.CRASH=1]="CRASH",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var b;(function(P){P.OFF="off",P.CRASH="crash",P.ERROR="error",P.ON="all"})(b=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(we[217],ye([0,1,28,43,14,63,8,5,3,4,87,22,89,191,18,25,32]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C,y,d,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const g=new Map;async function p(s,i){const o=`${s}::${i.join(":")}`,r=g.get(o);if(r)return r;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,f=new Map,w=2e4;function A(x,Q,_,Y){const O=Q.substring(x.length+1);return b.Promises.withAsyncBody(async B=>{let ue;try{ue=await R.Promises.readdir(Q,{withFileTypes:!0})}catch{B();return}if(Y.count>=w){Y.count+=ue.length,Y.maxReached=!0,B();return}let V=ue.length;if(V===0){B();return}let $=ue;Y.count+ue.length>w&&(Y.maxReached=!0,V=w-Y.count,$=ue.slice(0,V)),Y.count+=ue.length;for(const F of $)if(F.isDirectory()){if(_.includes(F.name)||await A(x,(0,E.join)(Q,F.name),_,Y),--V==0){B();return}}else{const M=F.name.lastIndexOf(".");if(M>=0){const j=F.name.substring(M+1);j&&c.set(j,(c.get(j)??0)+1)}for(const j of a)j.relativePathPattern?.test(O)!==!1&&j.filePattern.test(F.name)&&f.set(j.tag,(f.get(j.tag)??0)+1);if(--V==0){B();return}}})}const U=b.Promises.withAsyncBody(async x=>{const Q={count:0,maxReached:!1};await A(s,s,i,Q);const _=await u(s);x({configFiles:m(f),fileTypes:m(c),fileCount:Q.count,maxFilesReached:Q.maxReached,launchConfigFiles:_})});return g.set(o,U),U}e.collectWorkspaceStats=p;function m(s){return[...t.Iterable.map(s.entries(),([i,o])=>({name:i,count:o}))].sort((i,o)=>o.count-i.count)}function l(){const s={os:`${I.type()} ${I.arch()} ${I.release()}`,memory:`${(I.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(T.virtualMachineHint.value()*100)}%`},i=I.cpus();return i&&i.length>0&&(s.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),s}e.getMachineInfo=l;async function u(s){try{const i=new Map,o=(0,E.join)(s,".vscode","launch.json"),r=await R.Promises.readFile(o),a=[],c=(0,P.parse)(r.toString(),a);if(a.length)return console.log(`Unable to parse ${o}`),[];if((0,P.getNodeType)(c)==="object"&&c.configurations)for(const f of c.configurations){const w=f.type;w&&(i.has(w)?i.set(w,i.get(w)+1):i.set(w,1))}return m(i)}catch{return[]}}e.collectLaunchConfigs=u;let n=class{constructor(i,o){this.telemetryService=i,this.productService=o}formatMachineInfo(i){const o=[];return o.push(`OS Version:       ${i.os}`),o.push(`CPUs:             ${i.cpus}`),o.push(`Memory (System):  ${i.memory}`),o.push(`VM:               ${i.vmHint}`),o.join(`
`)}formatEnvironment(i){const o=[];o.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),o.push(`OS Version:       ${I.type()} ${I.arch()} ${I.release()}`);const r=I.cpus();return r&&r.length>0&&o.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),o.push(`Memory (System):  ${(I.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),v.isWindows||o.push(`Load (avg):       ${I.loadavg().map(a=>Math.round(a)).join(", ")}`),o.push(`VM:               ${Math.round(T.virtualMachineHint.value()*100)}%`),o.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),o.push(`Process Argv:     ${i.mainArguments.join(" ")}`),o.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),o.join(`
`)}async getPerformanceInfo(i,o){return Promise.all([(0,C.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async r=>{let[a,c]=r,f=this.formatProcessList(i,a);return o.forEach(w=>{if((0,y.isRemoteDiagnosticError)(w))f+=`
${w.errorMessage}`,c+=`
${w.errorMessage}`;else if(f+=`

Remote: ${w.hostName}`,w.processes&&(f+=`
${this.formatProcessList(i,w.processes)}`),w.workspaceMetadata){c+=`
|  Remote: ${w.hostName}`;for(const A of Object.keys(w.workspaceMetadata)){const U=w.workspaceMetadata[A];let x=`${U.fileCount} files`;U.maxFilesReached&&(x=`more than ${x}`),c+=`|    Folder (${A}): ${x}`,c+=this.formatWorkspaceStats(U)}}}),{processInfo:f,workspaceInfo:c}})}async getSystemInfo(i,o){const{memory:r,vmHint:a,os:c,cpus:f}=l(),w={os:c,memory:r,cpus:f,vmHint:a,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:o};return v.isWindows||(w.load=`${I.loadavg().map(A=>Math.round(A)).join(", ")}`),v.isLinux&&(w.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(w)}async getDiagnostics(i,o){const r=[];return(0,C.listProcesses)(i.mainPID).then(async a=>(r.push(""),r.push(this.formatEnvironment(i)),r.push(""),r.push(this.formatProcessList(i,a)),i.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(i))),o.forEach(c=>{if((0,y.isRemoteDiagnosticError)(c))r.push(`
${c.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${c.hostName}`),r.push(this.formatMachineInfo(c.machineInfo)),c.processes&&r.push(this.formatProcessList(i,c.processes)),c.workspaceMetadata)for(const f of Object.keys(c.workspaceMetadata)){const w=c.workspaceMetadata[f];let A=`${w.fileCount} files`;w.maxFilesReached&&(A=`more than ${A}`),r.push(`Folder (${f}): ${A}`),r.push(this.formatWorkspaceStats(w))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(i){const o=[],r=60;let a=0;const c=(U,x)=>{const Q=` ${U}(${x})`;a+Q.length>r?(o.push(f),f="|                 ",a=f.length):a+=Q.length,f+=Q};let f="|      File types:";const w=10;let A=i.fileTypes.length>w?w:i.fileTypes.length;for(let U=0;U<A;U++){const x=i.fileTypes[U];c(x.name,x.count)}if(o.push(f),i.configFiles.length>=0&&(f="|      Conf files:",a=0,i.configFiles.forEach(U=>{c(U.name,U.count)}),o.push(f)),i.launchConfigFiles.length>0){let U="|      Launch Configs:";i.launchConfigFiles.forEach(x=>{U+=x.count>1?` ${x.name}(${x.count})`:` ${x.name}`}),o.push(U)}return o.join(`
`)}expandGPUFeatures(i){const o=Math.max(...Object.keys(i).map(r=>r.length));return Object.keys(i).map(r=>`${r}:  ${" ".repeat(o-r.length)}  ${i[r]}`).join(`
                  `)}formatWorkspaceMetadata(i){const o=[],r=[];return i.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(o.push(`|  Window (${a.title})`),a.folderURIs.forEach(c=>{const f=D.URI.revive(c);if(f.scheme===k.Schemas.file){const w=f.fsPath;r.push(p(w,["node_modules",".git"]).then(A=>{let U=`${A.fileCount} files`;A.maxFilesReached&&(U=`more than ${U}`),o.push(`|    Folder (${(0,E.basename)(w)}): ${U}`),o.push(this.formatWorkspaceStats(A))}).catch(A=>{o.push(`|      Error: Unable to collect workspace stats for folder ${w} (${A.toString()})`)}))}else o.push(`|    Folder (${f.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(a=>o.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(i,o){const r=new Map;i.windows.forEach(c=>r.set(c.pid,c.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),o&&this.formatProcessItem(i.mainPID,r,a,o,0),a.join(`
`)}formatProcessItem(i,o,r,a,c){const f=c===0;let w;f?w=a.pid===i?`${this.productService.applicationName} main`:"remote agent":(w=`${"  ".repeat(c)} ${a.name}`,a.name==="window"&&(w=`${w} (${o.get(a.pid)})`));const A=process.platform==="win32"?a.mem:I.totalmem()*(a.mem/100);r.push(`${a.load.toFixed(0).padStart(5," ")}	${(A/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${w}`),Array.isArray(a.children)&&a.children.forEach(U=>this.formatProcessItem(i,o,r,U,c+1))}async getWorkspaceFileExtensions(i){const o=new Set;for(const{uri:r}of i.folders){const a=D.URI.revive(r);if(a.scheme!==k.Schemas.file)continue;const c=a.fsPath;try{(await p(c,["node_modules",".git"])).fileTypes.forEach(w=>o.add(w.name))}catch{}}return{extensions:[...o]}}async reportWorkspaceStats(i){for(const{uri:o}of i.folders){const r=D.URI.revive(o);if(r.scheme!==k.Schemas.file)continue;const a=r.fsPath;try{const c=await p(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),c.fileTypes.forEach(f=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:f.name,count:f.count})}),c.launchConfigFiles.forEach(f=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:f.name,count:f.count})}),c.configFiles.forEach(f=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:f.name,count:f.count})})}catch{}}}};n=Re([Fe(0,h.ITelemetryService),Fe(1,S.IProductService)],n),e.DiagnosticsService=n}),define(we[218],ye([0,1,17,14,20,9,6,2,3,4,158,31,35,13,25,32]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C,y,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let h=class extends E.Disposable{constructor(n,s,i,o){super();this.galleryService=n,this.telemetryService=s,this.logService=i,this.productService=o,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,E.toDisposable)(()=>{this.installingExtensions.forEach(r=>r.cancel()),this.uninstallingExtensions.forEach(r=>r.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(n){const s=await this.getTargetPlatform();return n.allTargetPlatforms.some(i=>(0,R.isTargetPlatformCompatible)(i,n.allTargetPlatforms,s))}async installFromGallery(n,s={}){try{if(!this.galleryService.isEnabled())throw new R.ExtensionManagementError(T.localize(0,null),R.ExtensionManagementErrorCode.Internal);const i=await this.checkAndGetCompatibleVersion(n,!!s.installGivenVersion,!!s.installPreReleaseVersion);return await this.installExtension(i.manifest,i.extension,s)}catch(i){throw m(this.telemetryService,"extensionGallery:install",{extensionData:(0,C.getGalleryExtensionTelemetryData)(n),error:i}),this.logService.error("Failed to install extension.",n.identifier.id),this.logService.error(i),p(i)}}async uninstall(n,s={}){return this.logService.trace("ExtensionManagementService#uninstall",n.identifier.id),this.unininstallExtension(n,s)}async reinstallFromGallery(n){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",n.identifier.id),!this.galleryService.isEnabled())throw new Error(T.localize(1,null));const s=await this.getTargetPlatform(),[i]=await this.galleryService.getExtensions([{...n.identifier,preRelease:n.preRelease}],{targetPlatform:s,compatible:!0},b.CancellationToken.None);if(!i)throw new Error(T.localize(2,null));await this.createUninstallExtensionTask(n,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(i)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.extensionsControlManifest||n-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=n),this.extensionsControlManifest}registerParticipant(n){this.participants.push(n)}async installExtension(n,s,i){if(!D.URI.isUri(s)){let f=this.installingExtensions.get(C.ExtensionKey.create(s).toString());if(f)return this.logService.info("Extensions is already requested to install",s.identifier.id),f.waitUntilTaskIsFinished();i={...i,installOnlyNewlyAddedFromExtensionPack:!0}}const o=[],r=[],a=this.createInstallExtensionTask(n,s,i);D.URI.isUri(s)||this.installingExtensions.set(C.ExtensionKey.create(s).toString(),a),this._onInstallExtension.fire({identifier:a.identifier,source:s}),this.logService.info("Installing extension:",a.identifier.id),o.push({task:a,manifest:n});let c=!1;try{if(i.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const w=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,n,!!i.installOnlyNewlyAddedFromExtensionPack,!!i.installPreReleaseVersion);for(const{gallery:A,manifest:U}of w){c=c||!!U.extensionDependencies?.some(Q=>(0,C.areSameExtensions)({id:Q},a.identifier));const x=C.ExtensionKey.create(A).toString();if(this.installingExtensions.has(x))this.logService.info("Extension is already requested to install",A.identifier.id);else{const Q=this.createInstallExtensionTask(U,A,{...i,donotIncludePackAndDependencies:!0});this.installingExtensions.set(x,Q),this._onInstallExtension.fire({identifier:Q.identifier,source:A}),this.logService.info("Installing extension:",Q.identifier.id),o.push({task:Q,manifest:U})}}}catch(w){if(D.URI.isUri(a.source))(0,I.isNonEmptyArray)(n.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,w.message),(0,I.isNonEmptyArray)(n.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,w.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),w}const f=o.reduce((w,{task:A,manifest:U})=>(w.set(A.identifier.id.toLowerCase(),{task:A,manifest:U}),w),new Map);for(;f.size;){let w;const A=[...f.values()].filter(({manifest:U})=>!U.extensionDependencies?.some(x=>f.has(x.toLowerCase())));A.length?w=f.size===1?A:A.filter(({task:U})=>!(U===a&&!c)):(this.logService.info("Found extensions with circular dependencies",A.map(({task:U})=>U.identifier.id)),w=[...f.values()]),await this.joinAllSettled(w.map(async({task:U})=>{const x=new Date().getTime();try{const Q=await U.run();if(await this.joinAllSettled(this.participants.map(_=>_.postInstall(Q,U.source,i,b.CancellationToken.None))),!D.URI.isUri(U.source)){const _=U.operation===3;if(m(this.telemetryService,_?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,C.getGalleryExtensionTelemetryData)(U.source),duration:new Date().getTime()-x,durationSinceUpdate:_?void 0:new Date().getTime()-U.source.lastUpdated}),v.isWeb&&U.operation!==3)try{await this.galleryService.reportStatistic(Q.manifest.publisher,Q.manifest.name,Q.manifest.version,"install")}catch{}}r.push({local:Q,identifier:U.identifier,operation:U.operation,source:U.source})}catch(Q){throw D.URI.isUri(U.source)||m(this.telemetryService,U.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,C.getGalleryExtensionTelemetryData)(U.source),duration:new Date().getTime()-x,error:Q}),this.logService.error("Error while installing the extension:",U.identifier.id),Q}finally{f.delete(U.identifier.id.toLowerCase())}}))}return r.forEach(({identifier:w})=>this.logService.info("Extension installed successfully:",w.id)),this._onDidInstallExtensions.fire(r),r.filter(({identifier:w})=>(0,C.areSameExtensions)(w,a.identifier))[0].local}catch(f){if(o.forEach(({task:w})=>w.cancel()),r.length)try{const w=await Promise.allSettled(r.map(({local:A})=>this.createUninstallExtensionTask(A,{versionOnly:!0}).run()));for(let A=0;A<w.length;A++){const U=w[A],{identifier:x}=r[A];U.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",x.id):this.logService.warn("Rollback: Error while uninstalling extension",x.id,(0,P.getErrorMessage)(U.reason))}}catch(w){this.logService.warn("Error while rolling back extensions",(0,P.getErrorMessage)(w),r.map(({identifier:A})=>A.id))}throw this._onDidInstallExtensions.fire(o.map(({task:w})=>({identifier:w.identifier,operation:2,source:w.source}))),f}finally{for(const{task:f}of o)if(!D.URI.isUri(f.source)){const w=C.ExtensionKey.create(f.source).toString();this.installingExtensions.delete(w)||this.logService.warn("Installation task is not found in the cache",w)}}}async joinAllSettled(n){const s=[],i=[],o=await Promise.allSettled(n);for(const r of o)r.status==="fulfilled"?s.push(r.value):i.push(r.reason);if(i.length)throw g(i);return s}async getAllDepsAndPackExtensionsToInstall(n,s,i,o){if(!this.galleryService.isEnabled())return[];let r=await this.getInstalled();const a=[n,...r.map(w=>w.identifier)],c=[],f=async(w,A)=>{const U=A.extensionDependencies||[],x=[...U];if(A.extensionPack){const Q=i?r.find(_=>(0,C.areSameExtensions)(_.identifier,w)):void 0;for(const _ of A.extensionPack)Q&&Q.manifest.extensionPack&&Q.manifest.extensionPack.some(Y=>(0,C.areSameExtensions)({id:Y},{id:_}))||x.every(Y=>!(0,C.areSameExtensions)({id:Y},{id:_}))&&x.push(_)}if(x.length){const Q=[...a,...c.map(Y=>Y.gallery.identifier)],_=x.filter(Y=>Q.every(O=>!(0,C.areSameExtensions)(O,{id:Y})));if(_.length){const Y=await this.galleryService.getExtensions(_.map(O=>({id:O,preRelease:o})),b.CancellationToken.None);for(const O of Y){if(Q.find(V=>(0,C.areSameExtensions)(V,O.identifier)))continue;const B=U.some(V=>(0,C.areSameExtensions)({id:V},O.identifier));let ue;try{ue=await this.checkAndGetCompatibleVersion(O,!1,o)}catch(V){if(V instanceof R.ExtensionManagementError&&V.code===R.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!B){this.logService.info("Skipping the packed extension as it cannot be installed",O.identifier.id);continue}else throw V}c.push({gallery:ue.extension,manifest:ue.manifest}),await f(ue.extension.identifier,ue.manifest)}}}};return await f(n,s),r=await this.getInstalled(),c.filter(w=>!r.some(A=>(0,C.areSameExtensions)(A.identifier,w.gallery.identifier)))}async checkAndGetCompatibleVersion(n,s,i){const o=await this.getExtensionsControlManifest();if((0,C.getMaliciousExtensionsSet)(o).has(n.identifier.id))throw new R.ExtensionManagementError(T.localize(3,null,n.identifier.id),R.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const c=await this.getTargetPlatform();throw new R.ExtensionManagementError(T.localize(4,null,n.identifier.id,this.productService.nameLong,(0,R.TargetPlatformToString)(c)),R.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const r=await this.getCompatibleVersion(n,s,i);if(r){if(i&&!s&&n.hasPreReleaseVersion&&!r.properties.isPreReleaseVersion)throw new R.ExtensionManagementError(T.localize(5,null,n.identifier.id,this.productService.nameLong,this.productService.version),R.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!i&&n.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([n.identifier],b.CancellationToken.None))[0]?new R.ExtensionManagementError(T.localize(6,null,n.identifier.id),R.ExtensionManagementErrorCode.ReleaseVersionNotFound):new R.ExtensionManagementError(T.localize(7,null,n.identifier.id,this.productService.nameLong,this.productService.version),R.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",r.identifier.id);const a=await this.galleryService.getManifest(r,b.CancellationToken.None);if(a===null)throw new R.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,R.ExtensionManagementErrorCode.Invalid);if(a.version!==r.version)throw new R.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,R.ExtensionManagementErrorCode.Invalid);return{extension:r,manifest:a}}async getCompatibleVersion(n,s,i){const o=await this.getTargetPlatform();let r=null;return!s&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==i&&(r=(await this.galleryService.getExtensions([{...n.identifier,preRelease:i}],{targetPlatform:o,compatible:!0},b.CancellationToken.None))[0]||null),!r&&await this.galleryService.isExtensionCompatible(n,i,o)&&(r=n),r||(s?r=(await this.galleryService.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:o,compatible:!0},b.CancellationToken.None))[0]||null:r=await this.galleryService.getCompatibleExtension(n,i,o)),r}async unininstallExtension(n,s){const i=this.uninstallingExtensions.get(n.identifier.id.toLowerCase());if(i)return this.logService.info("Extensions is already requested to uninstall",n.identifier.id),i.waitUntilTaskIsFinished();const o=(f,w)=>{const A=this.createUninstallExtensionTask(f,w);return this.uninstallingExtensions.set(A.extension.identifier.id.toLowerCase(),A),this.logService.info("Uninstalling extension:",f.identifier.id),this._onUninstallExtension.fire(f.identifier),A},r=(f,w)=>{w?this.logService.error("Failed to uninstall extension:",f.identifier.id,w.message):this.logService.info("Successfully uninstalled extension:",f.identifier.id),m(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,C.getLocalExtensionTelemetryData)(f),error:w}),this._onDidUninstallExtension.fire({identifier:f.identifier,error:w?.code})},a=[],c=[];try{a.push(o(n,{}));const f=await this.getInstalled(1);if(s.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",n.identifier.id);else{const w=this.getAllPackExtensionsToUninstall(n,f);for(const A of w)this.uninstallingExtensions.has(A.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",A.identifier.id):a.push(o(A,{}))}s.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",n.identifier.id):this.checkForDependents(a.map(w=>w.extension),f,n),await this.joinAllSettled(a.map(async w=>{try{if(await w.run(),await this.joinAllSettled(this.participants.map(A=>A.postUninstall(w.extension,s,b.CancellationToken.None))),w.extension.identifier.uuid)try{await this.galleryService.reportStatistic(w.extension.manifest.publisher,w.extension.manifest.name,w.extension.manifest.version,"uninstall")}catch{}r(w.extension)}catch(A){const U=A instanceof R.ExtensionManagementError?A:new R.ExtensionManagementError((0,P.getErrorMessage)(A),R.ExtensionManagementErrorCode.Internal);throw r(w.extension,U),U}finally{c.push(w)}}))}catch(f){const w=f instanceof R.ExtensionManagementError?f:new R.ExtensionManagementError((0,P.getErrorMessage)(f),R.ExtensionManagementErrorCode.Internal);for(const A of a){try{A.cancel()}catch{}c.includes(A)||r(A.extension,w)}throw w}finally{for(const f of a)this.uninstallingExtensions.delete(f.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",f.extension.identifier.id)}}checkForDependents(n,s,i){for(const o of n){const r=this.getDependents(o,s);if(r.length){const a=r.filter(c=>!n.some(f=>(0,C.areSameExtensions)(f.identifier,c.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(o,a,i))}}}getDependentsErrorMessage(n,s,i){return i===n?s.length===1?T.localize(8,null,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?T.localize(9,null,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):T.localize(10,null,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?T.localize(11,null,i.manifest.displayName||i.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?T.localize(12,null,i.manifest.displayName||i.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):T.localize(13,null,i.manifest.displayName||i.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}getAllPackExtensionsToUninstall(n,s,i=[]){if(i.indexOf(n)!==-1)return[];i.push(n);const o=n.manifest.extensionPack?n.manifest.extensionPack:[];if(o.length){const r=s.filter(c=>!c.isBuiltin&&o.some(f=>(0,C.areSameExtensions)({id:f},c.identifier))),a=[];for(const c of r)a.push(...this.getAllPackExtensionsToUninstall(c,s,i));return[...r,...a]}return[]}getDependents(n,s){return s.filter(i=>i.manifest.extensionDependencies&&i.manifest.extensionDependencies.some(o=>(0,C.areSameExtensions)({id:o},n.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const n=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};h=Re([Fe(0,R.IExtensionGalleryService),Fe(1,S.ITelemetryService),Fe(2,y.ILogService),Fe(3,d.IProductService)],h),e.AbstractExtensionManagementService=h;function g(u){const n=Array.isArray(u)?u:[u];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((s,i)=>new Error(`${s.message}${s.message?",":""}${i instanceof Error?i.message:i}`),new Error(""))}e.joinErrors=g;function p(u){if(u instanceof R.ExtensionManagementError)return u;const n=new R.ExtensionManagementError(u.message,R.ExtensionManagementErrorCode.Internal);return n.stack=u.stack,n}function m(u,n,{extensionData:s,duration:i,error:o,durationSinceUpdate:r}){const a=o?o instanceof R.ExtensionManagementError?o.code:R.ExtensionManagementErrorCode.Internal:void 0;u.publicLog(n,{...s,success:!o,duration:i,errorcode:a,durationSinceUpdate:r})}e.reportTelemetry=m;class l{constructor(){this.barrier=new t.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(n=>this.doRun(n))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(n=>new Promise((s,i)=>{const o=n.onCancellationRequested(()=>{o.dispose(),i(new P.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=l}),define(we[41],ye([0,1,21,81,12,23,32]),function(ie,e,I,t,b,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class E{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(l,u){return Promise.resolve(void 0)}publicLog2(l,u){return this.publicLog(l,u)}publicLogError(l,u){return Promise.resolve(void 0)}publicLogError2(l,u){return this.publicLogError(l,u)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=E,e.NullTelemetryService=new E;class v{async publicLog(l,u,n){}async publicLogError(l,u,n){}}e.NullEndpointTelemetryService=v,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function D(m,l){return l.onDidChangeConfiguration(u=>{u.source!==6&&m.publicLog2("updateConfiguration",{configurationSource:(0,P.ConfigurationTargetToString)(u.source),configurationKeys:h(u.sourceConfig)})})}e.configurationTelemetry=D;function T(m,l){return!(l.disableTelemetry||!m.enableTelemetry||l.extensionTestsLocationURI)}e.supportsTelemetry=T;function R(m){const l=m.getValue(k.TELEMETRY_SETTING_ID),u=m.getValue("telemetry.enableCrashReporter");if(m.getValue(k.TELEMETRY_OLD_SETTING_ID)===!1||u===!1)return 0;switch(l??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=R;function C(m){const l=Object.create(null),u=Object.create(null),n=Object.create(null);S(m,n);for(let s in n){s=s.length>150?s.substr(s.length-149):s;const i=n[s];typeof i=="number"?u[s]=i:typeof i=="boolean"?u[s]=i?1:0:typeof i=="string"?(i.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${i.length}`),l[s]=i.substring(0,8191)):typeof i!="undefined"&&i!==null&&(l[s]=i)}return{properties:l,measurements:u}}e.validateTelemetryData=C;const y=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function d(m){if(!m)return"none";for(const l of y)if(m.startsWith(`${l}+`))return l;return"other"}e.cleanRemoteAuthority=d;function S(m,l,u=0,n){if(!!m)for(let s of Object.getOwnPropertyNames(m)){const i=m[s],o=n?n+s:s;Array.isArray(i)?l[o]=(0,I.safeStringify)(i):i instanceof Date?l[o]=i.toISOString():(0,b.isObject)(i)?u<2?S(i,l,u+1,o+"."):l[o]=(0,I.safeStringify)(i):l[o]=i}}function h(m){if(!m)return[];const l=[];return g(l,"",m),l}function g(m,l,u){u&&typeof u=="object"&&!Array.isArray(u)?Object.keys(u).forEach(n=>g(m,l?`${l}.${n}`:n,u[n])):m.push(l)}function p(m){return[m.appRoot,m.extensionsPath,m.userHome.fsPath,m.tmpDir.fsPath,m.userDataPath]}e.getPiiPathsFromEnvironment=p}),define(we[219],ye([0,1,188,41]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function b(P,k,E,v,D,T){const R={"X-Market-Client-Id":`VSCode ${P}`,"User-Agent":`VSCode ${P} (${k.nameShort})`},C=await(0,I.getServiceMachineId)(E,D,T);return(0,t.supportsTelemetry)(k,E)&&(0,t.getTelemetryLevel)(v)===3&&(R["X-Market-User-Id"]=C),R}e.resolveMarketplaceHeaders=b}),define(we[106],ye([0,1,17,20,9,21,3,26,12,4,23,24,31,35,69,18,13,25,51,219,213,32]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C,y,d,S,h,g,p,m,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const n=k.isWeb?"web":(0,C.getTargetPlatform)(k.platform,E.arch);var s;(function(ee){ee[ee.None=0]="None",ee[ee.IncludeVersions=1]="IncludeVersions",ee[ee.IncludeFiles=2]="IncludeFiles",ee[ee.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",ee[ee.IncludeSharedAccounts=8]="IncludeSharedAccounts",ee[ee.IncludeVersionProperties=16]="IncludeVersionProperties",ee[ee.ExcludeNonValidated=32]="ExcludeNonValidated",ee[ee.IncludeInstallationTargets=64]="IncludeInstallationTargets",ee[ee.IncludeAssetUri=128]="IncludeAssetUri",ee[ee.IncludeStatistics=256]="IncludeStatistics",ee[ee.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",ee[ee.Unpublished=4096]="Unpublished",ee[ee.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function i(...ee){return String(ee.reduce((G,z)=>G|z,0))}var o;(function(ee){ee[ee.Tag=1]="Tag",ee[ee.ExtensionId=4]="ExtensionId",ee[ee.Category=5]="Category",ee[ee.ExtensionName=7]="ExtensionName",ee[ee.Target=8]="Target",ee[ee.Featured=9]="Featured",ee[ee.SearchText=10]="SearchText",ee[ee.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},f={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class w{constructor(G=f){this.state=G}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(G,z=this.state.pageSize){return new w({...this.state,pageNumber:G,pageSize:z})}withFilter(G,...z){const te=[...this.state.criteria,...z.length?z.map(ce=>({filterType:G,value:ce})):[{filterType:G}]];return new w({...this.state,criteria:te})}withSortBy(G){return new w({...this.state,sortBy:G})}withSortOrder(G){return new w({...this.state,sortOrder:G})}withFlags(...G){return new w({...this.state,flags:G.reduce((z,te)=>z|te,0)})}withAssetTypes(...G){return new w({...this.state,assetTypes:G})}withSource(G){return new w({...this.state,source:G})}get raw(){const{criteria:G,pageNumber:z,pageSize:te,sortBy:ce,sortOrder:J,flags:se,assetTypes:me}=this.state;return{filters:[{criteria:G,pageNumber:z,pageSize:te,sortBy:ce,sortOrder:J}],assetTypes:me,flags:se}}get searchText(){const G=this.state.criteria.filter(z=>z.filterType===o.SearchText)[0];return G&&G.value?G.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(G=>String(G.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function A(ee,G){const z=(ee||[]).filter(te=>te.statisticName===G)[0];return z?z.value:0}function U(ee){const G="Microsoft.VisualStudio.Code.Translation.";return ee.files.filter(te=>te.assetType.indexOf(G)===0).reduce((te,ce)=>{const J=_(ee,ce.assetType);return J&&te.push([ce.assetType.substring(G.length),J]),te},[])}function x(ee){if(ee.properties){const G=ee.properties.filter(ce=>ce.key===r.Repository),z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),te=G.filter(ce=>z.test(ce.value))[0];return te?{uri:te.value,fallbackUri:te.value}:null}return _(ee,r.Repository)}function Q(ee){return{uri:`${ee.fallbackAssetUri}/${r.VSIX}?redirect=true${ee.targetPlatform?`&targetPlatform=${ee.targetPlatform}`:""}`,fallbackUri:`${ee.fallbackAssetUri}/${r.VSIX}${ee.targetPlatform?`?targetPlatform=${ee.targetPlatform}`:""}`}}function _(ee,G){return ee.files.filter(te=>te.assetType===G)[0]?{uri:`${ee.assetUri}/${G}${ee.targetPlatform?`?targetPlatform=${ee.targetPlatform}`:""}`,fallbackUri:`${ee.fallbackAssetUri}/${G}${ee.targetPlatform?`?targetPlatform=${ee.targetPlatform}`:""}`}:null}function Y(ee,G){const z=ee.properties?ee.properties.filter(ce=>ce.key===G):[],te=z.length>0&&z[0].value;return te?te.split(",").map(ce=>(0,y.adoptToGalleryExtensionId)(ce)):[]}function O(ee){const G=ee.properties?ee.properties.filter(z=>z.key===a.Engine):[];return G.length>0&&G[0].value||""}function B(ee){const G=ee.properties?ee.properties.filter(z=>z.key===a.PreRelease):[];return G.length>0&&G[0].value==="true"}function ue(ee){const G=ee.properties?ee.properties.filter(te=>te.key===a.LocalizedLanguages):[],z=G.length>0&&G[0].value||"";return z?z.split(","):[]}function V(ee){return ee.properties?.find(G=>G.key===a.SponsorLink)?.value}function $(ee){return ee.indexOf("preview")!==-1}function F(ee){return ee.targetPlatform?(0,C.toTargetPlatform)(ee.targetPlatform):"undefined"}function M(ee){const G=(0,I.distinct)(ee.versions.map(F)),z=!!ee.tags?.includes(C.WEB_EXTENSION_TAG),te=G.indexOf("web");return z?te===-1&&G.push("web"):te!==-1&&G.splice(te,1),G}function j(ee,G){const z=(0,C.getFallbackTargetPlarforms)(G);for(let te=0;te<ee.length;te++){const ce=ee[te];if(ce.version===ee[te-1]?.version){let J=te;const se=F(ce);if(se===G)for(;J>0&&ee[J-1].version===ce.version;)J--;else if(z.includes(se))for(;J>0&&ee[J-1].version===ce.version&&F(ee[J-1])!==G;)J--;J!==te&&(ee.splice(te,1),ee.splice(J,0,ce))}}return ee}e.sortExtensionVersions=j;function Z(ee,G,z){ee.telemetryData={index:G,querySource:z}}function oe(ee,G,z){const te=ee.versions[0],ce={manifest:_(G,r.Manifest),readme:_(G,r.Details),changelog:_(G,r.Changelog),license:_(G,r.License),repository:x(G),download:Q(G),icon:_(G,r.Icon),coreTranslations:U(G)};return{identifier:{id:(0,y.getGalleryExtensionId)(ee.publisher.publisherName,ee.extensionName),uuid:ee.extensionId},name:ee.extensionName,version:G.version,displayName:ee.displayName,publisherId:ee.publisher.publisherId,publisher:ee.publisher.publisherName,publisherDisplayName:ee.publisher.displayName,publisherDomain:ee.publisher.domain?{link:ee.publisher.domain,verified:!!ee.publisher.isDomainVerified}:void 0,publisherSponsorLink:V(te),description:ee.shortDescription||"",installCount:A(ee.statistics,"install"),rating:A(ee.statistics,"averagerating"),ratingCount:A(ee.statistics,"ratingcount"),categories:ee.categories||[],tags:ee.tags||[],releaseDate:Date.parse(ee.releaseDate),lastUpdated:Date.parse(ee.lastUpdated),allTargetPlatforms:z,assets:ce,properties:{dependencies:Y(G,a.Dependency),extensionPack:Y(G,a.ExtensionPack),engine:O(G),localizedLanguages:ue(G),targetPlatform:F(G),isPreReleaseVersion:B(G)},hasPreReleaseVersion:B(te),hasReleaseVersion:!0,preview:$(ee.flags)}}let ge=class{constructor(G,z,te,ce,J,se,me,X){this.requestService=z,this.logService=te,this.environmentService=ce,this.telemetryService=J,this.fileService=se,this.productService=me,this.configurationService=X;const re=me.extensionsGallery;this.extensionsGalleryUrl=re&&re.serviceUrl,this.extensionsControlUrl=re&&re.controlUrl,this.commonHeadersPromise=(0,m.resolveMarketplaceHeaders)(me.version,me,this.environmentService,this.configurationService,this.fileService,G)}api(G=""){return`${this.extensionsGalleryUrl}${G}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(G,z,te){const ce=t.CancellationToken.isCancellationToken(z)?{}:z,J=t.CancellationToken.isCancellationToken(z)?z:te,se=[],me=[],X=[],re=[];let W=!0;for(const ve of G){ve.uuid?me.push(ve.uuid):se.push(ve.id);const De=!!(ve.version||ve.preRelease);X.push({id:ve.id,uuid:ve.uuid,includePreRelease:De}),ve.version&&re.push({id:ve.id,uuid:ve.uuid,version:ve.version}),W=W&&!!ve.hasPreRelease&&!De}if(!me.length&&!se.length)return[];let K=new w().withPage(1,G.length);me.length&&(K=K.withFilter(o.ExtensionId,...me)),se.length&&(K=K.withFilter(o.ExtensionName,...se)),(ce.queryAllVersions||W)&&(K=K.withFlags(K.flags,s.IncludeVersions)),ce.source&&(K=K.withSource(ce.source));const{extensions:le}=await this.queryGalleryExtensions(K,{targetPlatform:ce.targetPlatform??n,includePreRelease:X,versions:re,compatible:!!ce.compatible},J);return ce.source&&le.forEach((ve,De)=>Z(ve,De,ce.source)),le}async getCompatibleExtension(G,z,te){if((0,C.isNotWebExtensionInWebTargetPlatform)(G.allTargetPlatforms,te))return null;if(await this.isExtensionCompatible(G,z,te))return G;const ce=new w().withFlags(s.IncludeVersions).withPage(1,1).withFilter(o.ExtensionId,G.identifier.uuid),{extensions:J}=await this.queryGalleryExtensions(ce,{targetPlatform:te,compatible:!0,includePreRelease:z},t.CancellationToken.None);return J[0]||null}async isExtensionCompatible(G,z,te){if(!(0,C.isTargetPlatformCompatible)(G.properties.targetPlatform,G.allTargetPlatforms,te)||!z&&G.properties.isPreReleaseVersion)return!1;let ce=G.properties.engine;if(!ce){const J=await this.getManifest(G,t.CancellationToken.None);if(!J)throw new Error("Manifest was not found");ce=J.engines.vscode}return(0,d.isEngineValid)(ce,this.productService.version,this.productService.date)}async isValidVersion(G,z,te,ce,J){if(!(0,C.isTargetPlatformCompatible)(F(G),ce,J)||z!=="any"&&B(G)!==(z==="prerelease"))return!1;if(te)try{const se=await this.getEngine(G);if(!(0,d.isEngineValid)(se,this.productService.version,this.productService.date))return!1}catch(se){return this.logService.error(`Error while getting the engine for the version ${G.version}.`,(0,b.getErrorMessage)(se)),!1}return!0}async query(G,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let te=G.text||"";const ce=(0,P.getOrDefault)(G,W=>W.pageSize,50);let J=new w().withPage(1,ce);te?(te=te.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(W,K,le)=>(J=J.withFilter(o.Category,le||K),"")),te=te.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(W,K,le)=>(J=J.withFilter(o.Tag,le||K),"")),te=te.replace(/\bfeatured(\s+|\b|$)/g,()=>(J=J.withFilter(o.Featured),"")),te=te.trim(),te&&(te=te.length<200?te:te.substring(0,200),J=J.withFilter(o.SearchText,te)),J=J.withSortBy(0)):G.ids?J=J.withFilter(o.ExtensionId,...G.ids):G.names?J=J.withFilter(o.ExtensionName,...G.names):J=J.withSortBy(4),typeof G.sortBy=="number"&&(J=J.withSortBy(G.sortBy)),typeof G.sortOrder=="number"&&(J=J.withSortOrder(G.sortOrder)),G.source&&(J=J.withSource(G.source));const se=async(W,K)=>{const{extensions:le,total:ve}=await this.queryGalleryExtensions(W,{targetPlatform:n,compatible:!1,includePreRelease:!!G.includePreRelease},K);return le.forEach((De,Te)=>Z(De,(W.pageNumber-1)*W.pageSize+Te,G.source)),{extensions:le,total:ve}},{extensions:me,total:X}=await se(J,z),re=async(W,K)=>{if(K.isCancellationRequested)throw new b.CancellationError;const{extensions:le}=await se(J.withPage(W+1),K);return le};return{firstPage:me,total:X,pageSize:J.pageSize,getPage:re}}async queryGalleryExtensions(G,z,te){const ce=G.flags;!!(G.flags&s.IncludeLatestVersionOnly)&&!!(G.flags&s.IncludeVersions)&&(G=G.withFlags(G.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(G.flags&s.IncludeLatestVersionOnly)&&!(G.flags&s.IncludeVersions)&&(G=G.withFlags(G.flags,s.IncludeLatestVersionOnly)),z.versions?.length&&(G=G.withFlags(G.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),G=G.withFlags(G.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:J,total:se}=await this.queryRawGalleryExtensions(G,te);if(!(G.flags&s.IncludeLatestVersionOnly)){const W=[];for(const K of J){const le=await this.toGalleryExtensionWithCriteria(K,z);le&&W.push(le)}return{extensions:W,total:se}}const X=[],re=new Map;for(let W=0;W<J.length;W++){const K=J[W],le={id:(0,y.getGalleryExtensionId)(K.publisher.publisherName,K.extensionName),uuid:K.extensionId},ve=(0,v.isBoolean)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(Te=>(0,y.areSameExtensions)(Te,le))?.includePreRelease;if(z.compatible&&(0,C.isNotWebExtensionInWebTargetPlatform)(M(K),z.targetPlatform))continue;const De=await this.toGalleryExtensionWithCriteria(K,z);!De||De.properties.isPreReleaseVersion&&(!ve||!De.hasReleaseVersion)||!De.properties.isPreReleaseVersion&&De.properties.targetPlatform!==z.targetPlatform&&De.hasPreReleaseVersion?re.set(K.extensionId,W):X.push([W,De])}if(re.size){const W=new Date().getTime(),K=new w().withFlags(ce&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,re.size).withFilter(o.ExtensionId,...re.keys()),{extensions:le}=await this.queryGalleryExtensions(K,z,te);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-W,count:re.size});for(const ve of le){const De=re.get(ve.identifier.uuid);X.push([De,ve])}}return{extensions:X.sort((W,K)=>W[0]-K[0]).map(([,W])=>W),total:se}}async toGalleryExtensionWithCriteria(G,z){const te={id:(0,y.getGalleryExtensionId)(G.publisher.publisherName,G.extensionName),uuid:G.extensionId},ce=z.versions?.find(X=>(0,y.areSameExtensions)(X,te))?.version,J=(0,v.isBoolean)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(X=>(0,y.areSameExtensions)(X,te))?.includePreRelease,se=M(G),me=j(G.versions,z.targetPlatform);if(z.compatible&&(0,C.isNotWebExtensionInWebTargetPlatform)(se,z.targetPlatform))return null;for(let X=0;X<me.length;X++){const re=me[X];if(!(ce&&re.version!==ce)){if(await this.isValidVersion(re,J?"any":"release",z.compatible,se,z.targetPlatform))return oe(G,re,se);if(ce&&re.version===ce)return null}}return ce||z.compatible?null:oe(G,G.versions[0],se)}async queryRawGalleryExtensions(G,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");G=G.withFlags(G.flags,s.ExcludeNonValidated).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExcludeWithFlags,i(s.Unpublished));const te=await this.commonHeadersPromise,ce=JSON.stringify(G.raw),J={...te,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ce.length)},se=new Date().getTime();let me,X,re=0;try{if(me=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:ce,headers:J},z),me.res.statusCode&&me.res.statusCode>=400&&me.res.statusCode<500)return{galleryExtensions:[],total:re};const W=await(0,p.asJson)(me);if(W){const K=W.results[0],le=K.extensions,ve=K.resultMetadata&&K.resultMetadata.filter(De=>De.metadataType==="ResultCount")[0];return re=ve&&ve.metadataItems.filter(De=>De.name==="TotalCount")[0].count||0,{galleryExtensions:le,total:re}}return{galleryExtensions:[],total:re}}catch(W){throw X=W,W}finally{this.telemetryService.publicLog2("galleryService:query",{...G.telemetryData,requestBodySize:String(ce.length),duration:new Date().getTime()-se,success:!!me&&(0,p.isSuccess)(me),responseBodySize:me?.res.headers["Content-Length"],statusCode:me?String(me.res.statusCode):void 0,errorCode:X?(0,b.isCancellationError)(X)?"canceled":(0,b.getErrorMessage)(X).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(re)})}}async reportStatistic(G,z,te,ce){if(!this.isEnabled())return;const J=k.isWeb?this.api(`/itemName/${G}.${z}/version/${te}/statType/${ce==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${G}/extensions/${z}/${te}/stats?statType=${ce}`),se=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",X={...await this.commonHeadersPromise,Accept:se};try{await this.requestService.request({type:"POST",url:J,headers:X},t.CancellationToken.None)}catch{}}async download(G,z,te){this.logService.trace("ExtensionGalleryService#download",G.identifier.id);const ce=(0,y.getGalleryExtensionTelemetryData)(G),J=new Date().getTime(),se=W=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ce,duration:W}),me=te===2?"install":te===3?"update":"",X=me?{uri:`${G.assets.download.uri}${D.URI.parse(G.assets.download.uri).query?"&":"?"}${me}=true`,fallbackUri:`${G.assets.download.fallbackUri}${D.URI.parse(G.assets.download.fallbackUri).query?"&":"?"}${me}=true`}:G.assets.download,re=await this.getAsset(X);await this.fileService.writeFile(z,re.stream),se(new Date().getTime()-J)}async getReadme(G,z){if(G.assets.readme){const te=await this.getAsset(G.assets.readme,{},z);return await(0,p.asTextOrError)(te)||""}return""}async getManifest(G,z){if(G.assets.manifest){const te=await this.getAsset(G.assets.manifest,{},z),ce=await(0,p.asTextOrError)(te);return ce?JSON.parse(ce):null}return null}async getManifestFromRawExtensionVersion(G,z){const te=_(G,r.Manifest);if(!te)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},J=await this.getAsset(te,{headers:ce});return await(0,p.asJson)(J)}async getCoreTranslation(G,z){const te=G.assets.coreTranslations.filter(ce=>ce[0]===z.toUpperCase())[0];if(te){const ce=await this.getAsset(te[1]),J=await(0,p.asTextOrError)(ce);return J?JSON.parse(J):null}return null}async getChangelog(G,z){if(G.assets.changelog){const te=await this.getAsset(G.assets.changelog,{},z);return await(0,p.asTextOrError)(te)||""}return""}async getAllCompatibleVersions(G,z,te){let ce=new w().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);G.identifier.uuid?ce=ce.withFilter(o.ExtensionId,G.identifier.uuid):ce=ce.withFilter(o.ExtensionName,G.identifier.id);const{galleryExtensions:J}=await this.queryRawGalleryExtensions(ce,t.CancellationToken.None);if(!J.length)return[];const se=M(J[0]);if((0,C.isNotWebExtensionInWebTargetPlatform)(se,te))return[];const me=[];await Promise.all(J[0].versions.map(async W=>{try{await this.isValidVersion(W,z?"any":"release",!0,se,te)&&me.push(W)}catch{}}));const X=[],re=new Set;for(const W of j(me,te))re.has(W.version)||(re.add(W.version),X.push({version:W.version,date:W.lastUpdated,isPreReleaseVersion:B(W)}));return X}async getAsset(G,z={},te=t.CancellationToken.None){const ce=await this.commonHeadersPromise,J={type:"GET"},se={...ce,...z.headers||{}};z={...z,...J,headers:se};const me=G.uri,X=G.fallbackUri,re={...z,url:me};try{const W=await this.requestService.request(re,te);if(W.res.statusCode===200)return W;const K=await(0,p.asTextOrError)(W);throw new Error(`Expected 200, got back ${W.res.statusCode} instead.

${K}`)}catch(W){if((0,b.isCancellationError)(W))throw W;const K=(0,b.getErrorMessage)(W);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:me,message:K});const le={...z,url:X};return this.requestService.request(le,te)}}async getEngine(G){let z=O(G);if(!z){const te=await this.getManifestFromRawExtensionVersion(G,t.CancellationToken.None);if(!te)throw new Error("Manifest was not found");z=te.engines.vscode}return z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const G=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},t.CancellationToken.None);if(G.res.statusCode!==200)throw new Error("Could not get extensions report.");const z=await(0,p.asJson)(G),te=[],ce={};if(z){for(const J of z.malicious)te.push({id:J});if(z.migrateToPreRelease)for(const[J,se]of Object.entries(z.migrateToPreRelease))(!se.engine||(0,d.isEngineValid)(se.engine,this.productService.version,this.productService.date))&&(ce[J.toLowerCase()]={disallowInstall:!0,extension:{id:se.id,displayName:se.displayName,autoMigrate:{storage:!!se.migrateStorage},preRelease:!0}});if(z.deprecated)for(const[J,se]of Object.entries(z.deprecated))se&&(ce[J.toLowerCase()]=(0,v.isBoolean)(se)?{}:se)}return{malicious:te,deprecated:ce}}};ge=Re([Fe(1,p.IRequestService),Fe(2,h.ILogService),Fe(3,R.IEnvironmentService),Fe(4,u.ITelemetryService),Fe(5,S.IFileService),Fe(6,g.IProductService),Fe(7,T.IConfigurationService)],ge);let he=class extends ge{constructor(G,z,te,ce,J,se,me,X){super(G,z,te,ce,J,se,me,X)}};he=Re([Fe(0,l.IStorageService),Fe(1,p.IRequestService),Fe(2,h.ILogService),Fe(3,R.IEnvironmentService),Fe(4,u.ITelemetryService),Fe(5,S.IFileService),Fe(6,g.IProductService),Fe(7,T.IConfigurationService)],he),e.ExtensionGalleryService=he;let q=class extends ge{constructor(G,z,te,ce,J,se,me){super(void 0,G,z,te,ce,J,se,me)}};q=Re([Fe(0,p.IRequestService),Fe(1,h.ILogService),Fe(2,R.IEnvironmentService),Fe(3,u.ITelemetryService),Fe(4,S.IFileService),Fe(5,g.IProductService),Fe(6,T.IConfigurationService)],q),e.ExtensionGalleryServiceWithNoStorageService=q}),define(we[220],ye([0,1,2,21,81,3,15,173,23,49,48,25,34,32,41]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{constructor(p,m,l){this._configurationService=m,this._productService=l,this._experimentProperties={},this.telemetryLevel=new b.MutableObservableValue(3),this._disposables=new I.DisposableStore,this._cleanupPatterns=[],this._appenders=p.appenders,this._commonProperties=p.commonProperties||Promise.resolve({}),this._piiPaths=p.piiPaths||[],this._sendErrorTelemetry=!!p.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let u of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(u),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(p,m){this._experimentProperties[p]=m}_updateTelemetryLevel(){let p=(0,d.getTelemetryLevel)(this._configurationService);const m=this._productService.enabledTelemetryLevels;if(m){this._sendErrorTelemetry=this.sendErrorTelemetry?m.error:!1;const l=m.usage?3:m.error?2:0;p=Math.min(p,l)}this.telemetryLevel.value=p}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const p=await this._commonProperties;let m=p.sessionID,l=p["common.machineId"],u=p["common.firstSessionDate"],n=p["common.msftInternal"];return{sessionId:m,machineId:l,firstSessionDate:u,msftInternal:n}}dispose(){this._disposables.dispose()}_log(p,m,l,u){return this.telemetryLevel.value<m?Promise.resolve(void 0):this._commonProperties.then(n=>{l=(0,t.mixin)(l,n),l=(0,t.mixin)(l,this._experimentProperties),l=(0,t.cloneAndChange)(l,s=>{if(typeof s=="string")return this._cleanupInfo(s,u)}),this._appenders.forEach(s=>s.log(p,l))},n=>{console.error(n)})}publicLog(p,m,l){return this._log(p,3,m,l)}publicLog2(p,m,l){return this.publicLog(p,m,l)}publicLogError(p,m){return this._sendErrorTelemetry?this._log(p,2,m,!0):Promise.resolve(void 0)}publicLogError2(p,m){return this.publicLogError(p,m)}_anonymizeFilePaths(p){let m=p;const l=[];for(let i of this._cleanupPatterns)for(;;){const o=i.exec(p);if(!o)break;l.push([o.index,i.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,n=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(m="";;){const i=n.exec(p);if(!i)break;!u.test(i[0])&&l.every(([o,r])=>i.index<o||i.index>=r)&&(m+=p.substring(s,i.index)+"<REDACTED: user-file-path>",s=n.lastIndex)}return s<p.length&&(m+=p.substr(s)),m}_removePropertiesWithPossibleUserInfo(p){if(!p)return p;const m=p.toLowerCase(),l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const u of l)if(u.regex.test(m))return`<REDACTED: ${u.label}>`;return p}_cleanupInfo(p,m){let l=p;m&&(l=this._anonymizeFilePaths(l));for(let u of this._cleanupPatterns)l=l.replace(u,"");return l=this._removePropertiesWithPossibleUserInfo(l),l}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=Re([Fe(1,v.IConfigurationService),Fe(2,R.IProductService)],S),e.TelemetryService=S;function h(){const g=(0,E.localize)(0,null,T.default.nameLong),p=T.default.privacyStatementUrl?(0,E.localize)(2,null,"https://aka.ms/vscode-telemetry",T.default.privacyStatementUrl):(0,E.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=P.isWeb?"":(0,E.localize)(3,null),l=(0,E.localize)(4,null),u=(0,E.localize)(5,null),n=(0,E.localize)(6,null),s=(0,E.localize)(7,null),i=`
|       | ${l} | ${u} | ${n} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,E.localize)(8,null);return`
${g} ${p} ${m}

&nbsp;

${s}
${i}

&nbsp;

${o}
`}C.Registry.as(D.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,E.localize)(9,null),properties:{[y.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,E.localize)(10,null),(0,E.localize)(11,null),(0,E.localize)(12,null),(0,E.localize)(13,null)],markdownDescription:h(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),C.Registry.as(D.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,E.localize)(14,null),properties:{[y.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:T.default.privacyStatementUrl?(0,E.localize)(16,null,T.default.nameLong,T.default.privacyStatementUrl):(0,E.localize)(15,null,T.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,E.localize)(17,null,`\`#${y.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(we[221],ye([0,1,23,7,25,32,220,41]),function(ie,e,I,t,b,P,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IServerTelemetryService=e.ServerNullTelemetryService=e.ServerTelemetryService=void 0;let v=class extends k.TelemetryService{constructor(T,R,C,y){super(T,C,y);this._injectedTelemetryLevel=R}publicLog(T,R,C){return this._injectedTelemetryLevel<3?Promise.resolve(void 0):super.publicLog(T,R,C)}publicLog2(T,R,C){return this.publicLog(T,R,C)}publicLogError(T,R){return this._injectedTelemetryLevel<2?Promise.resolve(void 0):super.publicLogError(T,R)}publicLogError2(T,R){return this.publicLogError(T,R)}async updateInjectedTelemetryLevel(T){if(T===void 0)throw this._injectedTelemetryLevel=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this._injectedTelemetryLevel=this._injectedTelemetryLevel?Math.min(this._injectedTelemetryLevel,T):T,this._injectedTelemetryLevel===0&&this.dispose()}};v=Re([Fe(2,I.IConfigurationService),Fe(3,b.IProductService)],v),e.ServerTelemetryService=v,e.ServerNullTelemetryService=new class extends E.NullTelemetryServiceShape{async updateInjectedTelemetryLevel(){}},e.IServerTelemetryService=(0,t.refineServiceDecorator)(P.ITelemetryService)}),define(we[222],ye([0,1,9,21,41]),function(ie,e,I,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function P(E){const v=await new Promise((T,R)=>{ie(["applicationinsights"],T,R)});let D;return v.defaultClient?(D=new v.TelemetryClient(E),D.channel.setUseDiskRetryCaching(!0)):(v.setup(E).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),D=v.defaultClient),E.indexOf("AIF-")===0&&(D.config.endpointUrl="https://mobile.events.data.microsoft.com/collect/v1"),D}class k{constructor(v,D,T){this._eventPrefix=v,this._defaultData=D,this._defaultData||(this._defaultData=Object.create(null)),typeof T=="function"?this._aiClient=T():this._aiClient=T,this._asyncAIClient=null}_withAIClient(v){if(!!this._aiClient){if(typeof this._aiClient!="string"){v(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=P(this._aiClient)),this._asyncAIClient.then(D=>{v(D)},D=>{(0,I.onUnexpectedError)(D),console.error(D)})}}log(v,D){if(!!this._aiClient){D=(0,t.mixin)(D,this._defaultData),D=(0,b.validateTelemetryData)(D);try{this._withAIClient(T=>T.trackEvent({name:this._eventPrefix+"/"+v,properties:D.properties,measurements:D.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(v=>{this._withAIClient(D=>{try{D.flush({callback:()=>{this._aiClient=void 0,v(void 0)}})}catch{}})}):Promise.resolve(void 0)}}e.AppInsightsAppender=k}),define(we[223],ye([0,1,9,215]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class b extends t.default{installErrorListeners(){(0,I.setUnexpectedErrorHandler)(E=>console.error(E));const k=[];process.on("unhandledRejection",(E,v)=>{k.push(v),setTimeout(()=>{const D=k.indexOf(v);D>=0&&v.catch(T=>{k.splice(D,1),(0,I.isCancellationError)(T)||(console.warn(`rejected promise not handled within 1 second: ${T}`),T.stack&&console.warn(`stack trace: ${T.stack}`),E&&(0,I.onUnexpectedError)(E))})},1e3)}),process.on("rejectionHandled",E=>{const v=k.indexOf(E);v>=0&&k.splice(v,1)}),process.on("uncaughtException",E=>{(0,I.onUnexpectedError)(E)})}}e.default=b}),define(we[224],ye([0,1,14,20,6,2,13]),function(ie,e,I,t,b,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let E=class extends P.Disposable{constructor(D,T){super();this._logService=T,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new b.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=D===void 0?15e3:D}createRequest(D){return new Promise((T,R)=>{const C=++this._lastRequestId;this._pendingRequests.set(C,T),this._onCreateRequest.fire({requestId:C,...D});const y=new t.CancellationTokenSource;(0,I.timeout)(this._timeout,y.token).then(()=>R(`Request ${C} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(C,[(0,P.toDisposable)(()=>y.cancel())])})}acceptReply(D,T){const R=this._pendingRequests.get(D);R?(this._pendingRequests.delete(D),(0,P.dispose)(this._pendingRequestDisposables.get(D)||[]),this._pendingRequestDisposables.delete(D),R(T)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${D}`)}};E=Re([Fe(1,k.ILogService)],E),e.RequestStore=E}),define(we[107],ye([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var t;(function(h){h.Shell="terminal.integrated.shell.",h.ShellArgs="terminal.integrated.shellArgs.",h.DefaultProfile="terminal.integrated.defaultProfile.",h.Profiles="terminal.integrated.profiles."})(t=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var b;(function(h){h.ShellLinux="terminal.integrated.shell.linux",h.ShellMacOs="terminal.integrated.shell.osx",h.ShellWindows="terminal.integrated.shell.windows",h.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",h.AutomationShellLinux="terminal.integrated.automationShell.linux",h.AutomationShellMacOs="terminal.integrated.automationShell.osx",h.AutomationShellWindows="terminal.integrated.automationShell.windows",h.AutomationProfileLinux="terminal.integrated.automationProfile.linux",h.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",h.AutomationProfileWindows="terminal.integrated.automationProfile.windows",h.ShellArgsLinux="terminal.integrated.shellArgs.linux",h.ShellArgsMacOs="terminal.integrated.shellArgs.osx",h.ShellArgsWindows="terminal.integrated.shellArgs.windows",h.ProfilesWindows="terminal.integrated.profiles.windows",h.ProfilesMacOs="terminal.integrated.profiles.osx",h.ProfilesLinux="terminal.integrated.profiles.linux",h.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",h.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",h.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",h.UseWslProfiles="terminal.integrated.useWslProfiles",h.TabsEnabled="terminal.integrated.tabs.enabled",h.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",h.TabsHideCondition="terminal.integrated.tabs.hideCondition",h.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",h.TabsShowActions="terminal.integrated.tabs.showActions",h.TabsLocation="terminal.integrated.tabs.location",h.TabsFocusMode="terminal.integrated.tabs.focusMode",h.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",h.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",h.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",h.CopyOnSelection="terminal.integrated.copyOnSelection",h.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",h.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",h.FontFamily="terminal.integrated.fontFamily",h.FontSize="terminal.integrated.fontSize",h.LetterSpacing="terminal.integrated.letterSpacing",h.LineHeight="terminal.integrated.lineHeight",h.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",h.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",h.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",h.BellDuration="terminal.integrated.bellDuration",h.FontWeight="terminal.integrated.fontWeight",h.FontWeightBold="terminal.integrated.fontWeightBold",h.CursorBlinking="terminal.integrated.cursorBlinking",h.CursorStyle="terminal.integrated.cursorStyle",h.CursorWidth="terminal.integrated.cursorWidth",h.Scrollback="terminal.integrated.scrollback",h.DetectLocale="terminal.integrated.detectLocale",h.DefaultLocation="terminal.integrated.defaultLocation",h.GpuAcceleration="terminal.integrated.gpuAcceleration",h.TerminalTitleSeparator="terminal.integrated.tabs.separator",h.TerminalTitle="terminal.integrated.tabs.title",h.TerminalDescription="terminal.integrated.tabs.description",h.RightClickBehavior="terminal.integrated.rightClickBehavior",h.Cwd="terminal.integrated.cwd",h.ConfirmOnExit="terminal.integrated.confirmOnExit",h.ConfirmOnKill="terminal.integrated.confirmOnKill",h.EnableBell="terminal.integrated.enableBell",h.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",h.AllowChords="terminal.integrated.allowChords",h.AllowMnemonics="terminal.integrated.allowMnemonics",h.EnvMacOs="terminal.integrated.env.osx",h.EnvLinux="terminal.integrated.env.linux",h.EnvWindows="terminal.integrated.env.windows",h.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",h.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",h.ShowExitAlert="terminal.integrated.showExitAlert",h.SplitCwd="terminal.integrated.splitCwd",h.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",h.WordSeparators="terminal.integrated.wordSeparators",h.EnableFileLinks="terminal.integrated.enableFileLinks",h.UnicodeVersion="terminal.integrated.unicodeVersion",h.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",h.LocalEchoEnabled="terminal.integrated.localEchoEnabled",h.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",h.LocalEchoStyle="terminal.integrated.localEchoStyle",h.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",h.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",h.CustomGlyphs="terminal.integrated.customGlyphs",h.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",h.InheritEnv="terminal.integrated.inheritEnv",h.ShowLinkHover="terminal.integrated.showLinkHover",h.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",h.AutoReplies="terminal.integrated.autoReplies",h.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",h.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",h.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",h.ShellIntegrationDecorationIcon="terminal.integrated.shellIntegration.decorationIcon",h.ShellIntegrationDecorationIconError="terminal.integrated.shellIntegration.decorationIconError",h.ShellIntegrationDecorationIconSuccess="terminal.integrated.shellIntegration.decorationIconSuccess",h.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history"})(b=e.TerminalSettingId||(e.TerminalSettingId={}));var P;(function(h){h.PowerShell="pwsh",h.Bash="bash",h.Fish="fish",h.Sh="sh",h.Csh="csh",h.Ksh="ksh",h.Zsh="zsh"})(P=e.PosixShellType||(e.PosixShellType={}));var k;(function(h){h.CommandPrompt="cmd",h.PowerShell="pwsh",h.Wsl="wsl",h.GitBash="gitbash"})(k=e.WindowsShellType||(e.WindowsShellType={}));var E;(function(h){h[h.Api=0]="Api",h[h.Process=1]="Process",h[h.Sequence=2]="Sequence",h[h.Config=3]="Config"})(E=e.TitleEventSource||(e.TitleEventSource={}));var v;(function(h){h.LocalPty="localPty",h.PtyHost="ptyHost",h.Log="log",h.Heartbeat="heartbeat"})(v=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,I.createDecorator)("ptyService");var D;(function(h){h.Cwd="cwd",h.InitialCwd="initialCwd",h.FixedDimensions="fixedDimensions",h.Title="title",h.ShellType="shellType",h.HasChildProcesses="hasChildProcesses",h.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",h.OverrideDimensions="overrideDimensions",h.FailedShellIntegrationActivation="failedShellIntegrationActivation"})(D=e.ProcessPropertyType||(e.ProcessPropertyType={}));var T;(function(h){h[h.BeatInterval=5e3]="BeatInterval",h[h.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",h[h.SecondWaitMultiplier=1]="SecondWaitMultiplier",h[h.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(T=e.HeartbeatConstants||(e.HeartbeatConstants={}));var R;(function(h){h[h.Panel=1]="Panel",h[h.Editor=2]="Editor"})(R=e.TerminalLocation||(e.TerminalLocation={}));var C;(function(h){h.TerminalView="view",h.Editor="editor"})(C=e.TerminalLocationString||(e.TerminalLocationString={}));var y;(function(h){h[h.GraceTime=6e4]="GraceTime",h[h.ShortGraceTime=6e3]="ShortGraceTime"})(y=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var d;(function(h){h[h.HighWatermarkChars=1e5]="HighWatermarkChars",h[h.LowWatermarkChars=5e3]="LowWatermarkChars",h[h.CharCountAckSize=5e3]="CharCountAckSize"})(d=e.FlowControlConstants||(e.FlowControlConstants={}));var S;(function(h){h.GitBash="Git Bash",h.Pwsh="PowerShell"})(S=e.ProfileSource||(e.ProfileSource={}))}),define(we[225],ye([0,1,28,8,21,5,3,26,15,12,22]),function(ie,e,I,t,b,P,k,E,v,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function R(){const l=/(\d+)\.(\d+)\.(\d+)/g.exec(I.release());let u=0;return l&&l.length===4&&(u=parseInt(l[3])),u}e.getWindowsBuildNumber=R;async function C(l,u,n,s=E.env,i=T.Promises.exists){if(P.isAbsolute(l))return await i(l)?l:void 0;if(u===void 0&&(u=E.cwd()),P.dirname(l)!=="."){const c=P.join(u,l);return await i(c)?c:void 0}const r=(0,b.getCaseInsensitive)(s,"PATH");if(n===void 0&&(0,D.isString)(r)&&(n=r.split(P.delimiter)),n===void 0||n.length===0){const c=P.join(u,l);return await i(c)?c:void 0}for(let c of n){let f;if(P.isAbsolute(c)?f=P.join(c,l):f=P.join(u,c,l),await i(f))return f;if(k.isWindows){let w=f+".com";if(await i(w)||(w=f+".exe",await i(w)))return w}}const a=P.join(u,l);return await i(a)?a:void 0}e.findExecutable=C;function y(l,u,n){if(!u.enabled||!l.executable||l.isFeatureTerminal||l.hideFromUser)return;const s=l.args,i=E.platform==="win32"?P.basename(l.executable).toLowerCase():P.basename(l.executable),o=P.dirname(t.FileAccess.asFileUri("",ie).fsPath);let r;if(k.isWindows){if(i==="pwsh.exe")return!s||p(s)?r=e.shellIntegrationArgs.get(d.WindowsPwsh):g(s)&&(r=e.shellIntegrationArgs.get(d.WindowsPwshLogin)),r?(r&&(r=[...r],r[r.length-1]=(0,v.format)(r[r.length-1],o,"")),{newArgs:r}):void 0;n.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args);return}const a={};switch(i){case"bash":return!s||s.length===0?r=e.shellIntegrationArgs.get(d.Bash):m(s)&&(a.VSCODE_SHELL_LOGIN="1",r=e.shellIntegrationArgs.get(d.Bash)),r?(r=[...r],r[r.length-1]=(0,v.format)(r[r.length-1],o),{newArgs:r,envMixin:a}):void 0;case"pwsh":return!s||p(s)?r=e.shellIntegrationArgs.get(d.Pwsh):g(s)&&(r=e.shellIntegrationArgs.get(d.PwshLogin)),r?(r=[...r],r[r.length-1]=(0,v.format)(r[r.length-1],o,""),{newArgs:r}):void 0;case"zsh":{if(!s||s.length===0?r=e.shellIntegrationArgs.get(d.Zsh):m(s)?r=e.shellIntegrationArgs.get(d.ZshLogin):(s===e.shellIntegrationArgs.get(d.Zsh)||s===e.shellIntegrationArgs.get(d.ZshLogin))&&(r=s),!r)return;r=[...r],r[r.length-1]=(0,v.format)(r[r.length-1],o);const c=P.join(I.tmpdir(),"vscode-zsh");a.ZDOTDIR=c;const f=[];return f.push({source:P.join(o,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:P.join(c,".zshrc")}),f.push({source:P.join(o,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:P.join(c,".zprofile")}),f.push({source:P.join(o,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:P.join(c,".zshenv")}),f.push({source:P.join(o,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:P.join(c,".zlogin")}),{newArgs:r,envMixin:a,filesToCopy:f}}}n.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args)}e.getShellIntegrationInjection=y;var d;(function(l){l.WindowsPwsh="windows-pwsh",l.WindowsPwshLogin="windows-pwsh-login",l.Pwsh="pwsh",l.PwshLogin="pwsh-login",l.Zsh="zsh",l.ZshLogin="zsh-login",l.Bash="bash"})(d=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(d.WindowsPwsh,["-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.WindowsPwshLogin,["-l","-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(d.Zsh,["-i"]),e.shellIntegrationArgs.set(d.ZshLogin,["-il"]),e.shellIntegrationArgs.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const S=["-login","-l"],h=["-nol","-nologo"];function g(l){return typeof l=="string"?S.includes(l.toLowerCase()):l.length===1&&S.includes(l[0].toLowerCase())||l.length===2&&(S.includes(l[0].toLowerCase())||S.includes(l[1].toLowerCase()))&&(h.includes(l[0].toLowerCase())||h.includes(l[1].toLowerCase()))}function p(l){return typeof l=="string"?h.includes(l.toLowerCase()):l.length===0||l?.length===1&&h.includes(l[0].toLowerCase())}function m(l){return l==="string"&&S.includes(l.toLowerCase())||typeof l!="string"&&l.length===1&&S.includes(l[0].toLowerCase())}}),define(we[226],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var I;(function(P){P.DARK="dark",P.LIGHT="light",P.HIGH_CONTRAST_DARK="hcDark",P.HIGH_CONTRAST_LIGHT="hcLight"})(I=e.ColorScheme||(e.ColorScheme={}));function t(P){return P===I.HIGH_CONTRAST_DARK||P===I.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function b(P){return P===I.DARK||P===I.HIGH_CONTRAST_DARK}e.isDark=b}),define(we[108],ye([0,1,37,6,2,7,34,226]),function(ie,e,I,t,b,P,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,P.createDecorator)("themeService");var v;(function(h){function g(p){return p&&typeof p=="object"&&typeof p.id=="string"}h.isThemeColor=g})(v=e.ThemeColor||(e.ThemeColor={}));function D(h){return{id:h}}e.themeColorFromId=D;var T;(function(h){function g(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color=="undefined"||v.isThemeColor(o.color))}h.isThemeIcon=g;const p=new RegExp(`^\\$\\((${I.CSSIcon.iconNameExpression}(?:${I.CSSIcon.iconModifierExpression})?)\\)$`);function m(o){const r=p.exec(o);if(!r)return;let[,a]=r;return{id:a}}h.fromString=m;function l(o){return{id:o}}h.fromId=l;function u(o,r){let a=o.id;const c=a.lastIndexOf("~");return c!==-1&&(a=a.substring(0,c)),r&&(a=`${a}~${r}`),{id:a}}h.modify=u;function n(o){const r=o.id.lastIndexOf("~");if(r!==-1)return o.id.substring(r+1)}h.getModifier=n;function s(o,r){return o.id===r.id&&o.color?.id===r.color?.id}h.isEqual=s;function i(o,r){return{id:o.id,color:r?D(r):void 0}}h.asThemeIcon=i,h.asClassNameArray=I.CSSIcon.asClassNameArray,h.asClassName=I.CSSIcon.asClassName,h.asCSSSelector=I.CSSIcon.asCSSSelector})(T=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=I.Codicon.file,e.FolderThemeIcon=I.Codicon.folder;function R(h){switch(h){case E.ColorScheme.DARK:return"vs-dark";case E.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case E.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=R,e.Extensions={ThemingContribution:"base.contributions.theming"};class C{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(g){return this.themingParticipants.push(g),this.onThemingParticipantAddedEmitter.fire(g),(0,b.toDisposable)(()=>{const p=this.themingParticipants.indexOf(g);this.themingParticipants.splice(p,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let y=new C;k.Registry.add(e.Extensions.ThemingContribution,y);function d(h){return y.onColorThemeChange(h)}e.registerThemingParticipant=d;class S extends b.Disposable{constructor(g){super();this.themeService=g,this.theme=g.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(p=>this.onThemeChange(p)))}onThemeChange(g){this.theme=g,this.updateStyles()}updateStyles(){}getColor(g,p){let m=this.theme.getColor(g);return m&&p&&(m=p(m,this.theme)),m?m.toString():null}}e.Themable=S}),define(we[227],ye([0,1,37,4,175,108]),function(ie,e,I,t,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function k(C,y){const d=[{name:null,description:(0,b.localize)(0,null)}];return d.push(...C.map(S=>({name:S.profileName,description:E(S)}))),y&&d.push(...y.map(S=>({name:S.title,description:v(S)}))),{values:d.map(S=>S.name),markdownDescriptions:d.map(S=>S.description)}}e.createProfileSchemaEnums=k;function E(C){let y=`$(${P.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:I.Codicon.terminal.id}) ${C.profileName}
- path: ${C.path}`;return C.args&&(typeof C.args=="string"?y+=`
- args: "${C.args}"`:y+=`
- args: [${C.args.length===0?"":`'${C.args.join("','")}'`}]`),C.overrideName!==void 0&&(y+=`
- overrideName: ${C.overrideName}`),C.color&&(y+=`
- color: ${C.color}`),C.env&&(y+=`
- env: ${JSON.stringify(C.env)}`),y}function v(C){return`$(${P.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:I.Codicon.terminal.id}) ${C.title}
- extensionIdentifier: ${C.extensionIdentifier}`}function D(C,y){if(!C&&!y)return!0;if(typeof C=="string"&&typeof y=="string")return C===y;if(Array.isArray(C)&&Array.isArray(y)){if(C.length!==y.length)return!1;for(let d=0;d<C.length;d++)if(C[d]!==y[d])return!1;return!0}return!1}e.terminalProfileArgsMatch=D;function T(C,y){if(!C&&!y)return!0;if(!C||!y)return!1;if(P.ThemeIcon.isThemeIcon(C)&&P.ThemeIcon.isThemeIcon(y))return C.id===y.id&&C.color===y.color;if(typeof C=="object"&&C&&"light"in C&&"dark"in C&&typeof y=="object"&&y&&"light"in y&&"dark"in y){const d=C,S=y;if((t.URI.isUri(d.light)||R(d.light))&&(t.URI.isUri(d.dark)||R(d.dark))&&(t.URI.isUri(S.light)||R(S.light))&&(t.URI.isUri(S.dark)||R(S.dark)))return d.light.path===S.light.path&&d.dark.path===S.dark.path}if(t.URI.isUri(C)&&t.URI.isUri(y)||R(C)||R(y)){const d=C,S=y;return d.path===S.path&&d.scheme===S.scheme}return!1}e.terminalIconsEqual=T;function R(C){return C?typeof C.path=="string"&&typeof C.scheme=="string":!1}e.isUriComponents=R}),define(we[228],ye([0,1,37,174,49,34,227]),function(ie,e,I,t,b,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const E={args:{description:(0,t.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,t.localize)(1,null),type:"boolean"},icon:{description:(0,t.localize)(2,null),type:"string",enum:Array.from(I.Codicon.getAll(),l=>l.id),markdownEnumDescriptions:Array.from(I.Codicon.getAll(),l=>`$(${l.id})`)},color:{description:(0,t.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,t.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},v={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(5,null),type:["string","array"],items:{type:"string"}},...E}},D={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(6,null),type:["string"],items:{type:"string"}},...E}},T=(0,t.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),R=(0,t.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),C=(0,t.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),y=(0,t.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),d=(0,t.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),S=(0,t.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),h={id:"terminal",order:100,title:(0,t.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(17,null,"`#terminal.integrated.automationShell.linux#`"),type:["object","null"],default:null,anyOf:[{type:"null"},D],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(18,null,"`#terminal.integrated.automationShell.osx#`"),type:["object","null"],default:null,anyOf:[{type:"null"},D],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(19,null,"`#terminal.integrated.automationShell.windows#`"),type:["object","null"],default:null,anyOf:[{type:"null"},D],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:T},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:R},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:T},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:R},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,t.localize)(26,null)}},{type:"string",markdownDescription:(0,t.localize)(27,null)}],default:[],markdownDeprecationMessage:C},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,t.localize)(29,null),enum:["PowerShell","Git Bash"]},...E}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(30,null),type:"string"},id:{description:(0,t.localize)(31,null),type:"string"},title:{description:(0,t.localize)(32,null),type:"string"},...E}},{type:"null"},v]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(34,null),type:"string"},id:{description:(0,t.localize)(35,null),type:"string"},title:{description:(0,t.localize)(36,null),type:"string"},...E}},{type:"null"},v]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(38,null),type:"string"},id:{description:(0,t.localize)(39,null),type:"string"},title:{description:(0,t.localize)(40,null),type:"string"},...E}},{type:"null"},v]}},["terminal.integrated.useWslProfiles"]:{description:(0,t.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,t.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,t.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,t.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,t.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function g(){P.Registry.as(b.Extensions.Configuration).registerConfiguration(h),m()}e.registerTerminalPlatformConfiguration=g;let p;function m(l,u){const n=P.Registry.as(b.Extensions.Configuration);let s;l&&(s=(0,k.createProfileSchemaEnums)(l?.profiles,u));const i=p;p={id:"terminal",order:100,title:(0,t.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:l?.os===3?s?.values:void 0,markdownEnumDescriptions:l?.os===3?s?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:l?.os===2?s?.values:void 0,markdownEnumDescriptions:l?.os===2?s?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:l?.os===1?s?.values:void 0,markdownEnumDescriptions:l?.os===1?s?.markdownDescriptions:void 0}}},n.updateConfigurations({add:[p],remove:i?[i]:[]})}e.registerTerminalDefaultProfileConfiguration=m}),define(we[229],ye([0,1,38,37,5,3,22,88,225,108]),function(ie,e,I,t,b,P,k,E,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let T,R=!0;function C(s,i,o,r,a=process.env,c,f,w,A){return c=c||{existsFile:k.SymlinkSupport.existsFile,readFile:k.Promises.readFile},P.isWindows?y(o,c,a,f,r.getValue("terminal.integrated.useWslProfiles")!==!1,s&&typeof s=="object"?{...s}:r.getValue("terminal.integrated.profiles.windows"),typeof i=="string"?i:r.getValue("terminal.integrated.defaultProfile.windows"),A,w):l(c,f,o,s&&typeof s=="object"?{...s}:r.getValue(P.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof i=="string"?i:r.getValue(P.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),A,w,a)}e.detectAvailableProfiles=C;async function y(s,i,o,r,a,c,f,w,A){const U=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),x=`${process.env.windir}\\${U?"Sysnative":"System32"}`;let Q=!1;(0,v.getWindowsBuildNumber)()>=16299&&(Q=!0),await h(w);const _=new Map;s&&(_.set("PowerShell",{source:"PowerShell",icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),_.set("Windows PowerShell",{path:`${x}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),_.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),_.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),_.set("Command Prompt",{path:`${x}\\cmd.exe`,icon:t.Codicon.terminalCmd,isAutoDetected:!0})),u(c,_);const Y=await d(_.entries(),f,i,o,r,A);if(s||!s&&a)try{const O=await p(`${x}\\${Q?"wsl":"bash"}.exe`,f);for(const B of O)(!c||!(B.profileName in c))&&Y.push(B)}catch{R&&(r?.info("WSL is not installed, so could not detect WSL profiles"),R=!1)}return Y}async function d(s,i,o,r=process.env,a,c){const f=[];for(const[w,A]of s){if(A===null)continue;let U,x,Q;if("source"in A){const O=T?.get(A.source);if(!O)continue;U=O.paths,x=A.args||O.args,A.icon?Q=S(A.icon):O.icon&&(Q=O.icon)}else U=Array.isArray(A.path)?A.path:[A.path],x=P.isWindows||Array.isArray(A.args)?A.args:void 0,Q=S(A.icon);const _=await c?.(U)||U.slice(),Y=await n(w,i,_,o,r,x,A.env,A.overrideName,A.isAutoDetected,a);Y?(Y.isAutoDetected=A.isAutoDetected,Y.icon=Q,Y.color=A.color,f.push(Y)):a?.trace("profile not validated",w,U)}return f}function S(s){return typeof s=="string"?{id:s}:s}async function h(s){T&&!s||(T=new Map,T.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),T.set("PowerShell",{profileName:"PowerShell",paths:s||await g(),icon:D.ThemeIcon.asThemeIcon(t.Codicon.terminalPowershell)}))}async function g(){const s=[];for await(const i of(0,E.enumeratePowerShellInstallations)())s.push(i.exePath);return s}async function p(s,i){const o=[],r=await new Promise((f,w)=>{I.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(A,U)=>{if(A)return w("Problem occurred when getting wsl distros");f(U)})});if(!r)return[];const a=new RegExp(/[\r?\n]/),c=r.split(a).filter(f=>f.trim().length>0&&f!=="");for(const f of c){if(f===""||f.startsWith("docker-desktop"))continue;const w=`${f} (WSL)`,A={profileName:w,path:s,args:["-d",`${f}`],isDefault:w===i,icon:m(f),isAutoDetected:!1};o.push(A)}return o}function m(s){return s.includes("Ubuntu")?D.ThemeIcon.asThemeIcon(t.Codicon.terminalUbuntu):s.includes("Debian")?D.ThemeIcon.asThemeIcon(t.Codicon.terminalDebian):D.ThemeIcon.asThemeIcon(t.Codicon.terminalLinux)}async function l(s,i,o,r,a,c,f,w){const A=new Map;if(o){const U=(await s.readFile("/etc/shells")).toString(),x=c||U.split(`
`).filter(_=>_.trim().indexOf("#")!==0&&_.trim().length>0),Q=new Map;for(const _ of x){let Y=(0,b.basename)(_),O=Q.get(Y)||0;O++,O>1&&(Y=`${Y} (${O})`),Q.set(Y,O),A.set(Y,{path:_,isAutoDetected:!0})}}return u(r,A),await d(A.entries(),a,s,w,i,f)}function u(s,i){if(!!s)for(const[o,r]of Object.entries(s))r===null||!("path"in r)&&!("source"in r)?i.delete(o):(r.icon=r.icon||i.get(o)?.icon,i.set(o,r))}async function n(s,i,o,r,a,c,f,w,A,U){if(o.length===0)return Promise.resolve(void 0);const x=o.shift();if(x==="")return n(s,i,o,r,a,c,f,w,A);const Q={profileName:s,path:x,args:c,env:f,overrideName:w,isAutoDetected:A,isDefault:s===i};if((0,b.basename)(x)===x){const Y=a.PATH?a.PATH.split(b.delimiter):void 0,O=await(0,v.findExecutable)(x,void 0,Y,void 0,r.existsFile);return O?(Q.path=O,Q.isFromPath=!0,Q):n(s,i,o,r,a,c)}return await r.existsFile((0,b.normalize)(x))?Q:n(s,i,o,r,a,c,f,w,A)}}),define(we[230],ye([0,1,6,2,8,3,39,93,23,24,94,77,13,99,224,107,228,229]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C,y,d,S,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var p;(function(u){u[u.MaxRestarts=5]="MaxRestarts"})(p||(p={}));let m=0,l=class extends t.Disposable{constructor(n,s,i,o){super();this._reconnectConstants=n,this._configurationService=s,this._environmentService=i,this._logService=o,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new I.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new I.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new I.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new I.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new I.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new I.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new I.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new I.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new I.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new I.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new I.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new I.Emitter),this.onProcessExit=this._onProcessExit.event,(0,h.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,t.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new d.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async r=>{r.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(P.isWindows)return process.env;try{return await(0,R.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(n){return this._logService.error("ptyHost was unable to resolve shell environment",n),{}}}_startPtyHost(){const n={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:m,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},s=(0,T.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);s&&(s.break&&s.port?n.debugBrk=s.port:!s.break&&s.port&&(n.debug=s.port));const i=new E.Client(b.FileAccess.asFileUri("bootstrap-fork",ie).fsPath,n);this._onPtyHostStart.fire(),k.ProxyChannel.toService(i.getChannel(S.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(i.onDidProcessExit(c=>{this._onPtyHostExit.fire(c.code),this._isDisposed||(this._restartCount<=p.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${c.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${c.code}, giving up`))}));const r=i.getChannel(S.TerminalIpcChannels.Log);y.LogLevelChannelClient.setLevel(r,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{y.LogLevelChannelClient.setLevel(r,this._logService.getLevel())}));const a=k.ProxyChannel.toService(i.getChannel(S.TerminalIpcChannels.PtyHost));return this._register(a.onProcessData(c=>this._onProcessData.fire(c))),this._register(a.onProcessReady(c=>this._onProcessReady.fire(c))),this._register(a.onProcessExit(c=>this._onProcessExit.fire(c))),this._register(a.onDidChangeProperty(c=>this._onDidChangeProperty.fire(c))),this._register(a.onProcessReplay(c=>this._onProcessReplay.fire(c))),this._register(a.onProcessOrphanQuestion(c=>this._onProcessOrphanQuestion.fire(c))),this._register(a.onDidRequestDetach(c=>this._onDidRequestDetach.fire(c))),[i,a]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(n,s,i,o,r,a,c,f,w,A,U){const x=setTimeout(()=>this._handleUnresponsiveCreateProcess(),S.HeartbeatConstants.CreateProcessTimeout),Q=await this._proxy.createProcess(n,s,i,o,r,a,c,f,w,A,U);return clearTimeout(x),m=Math.max(m,Q),Q}updateTitle(n,s,i){return this._proxy.updateTitle(n,s,i)}updateIcon(n,s,i){return this._proxy.updateIcon(n,s,i)}attachToProcess(n){return this._proxy.attachToProcess(n)}detachFromProcess(n){return this._proxy.detachFromProcess(n)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(n){return this._proxy.start(n)}shutdown(n,s){return this._proxy.shutdown(n,s)}input(n,s){return this._proxy.input(n,s)}processBinary(n,s){return this._proxy.processBinary(n,s)}resize(n,s,i){return this._proxy.resize(n,s,i)}acknowledgeDataEvent(n,s){return this._proxy.acknowledgeDataEvent(n,s)}setUnicodeVersion(n,s){return this._proxy.setUnicodeVersion(n,s)}getInitialCwd(n){return this._proxy.getInitialCwd(n)}getCwd(n){return this._proxy.getCwd(n)}getLatency(n){return this._proxy.getLatency(n)}orphanQuestionReply(n){return this._proxy.orphanQuestionReply(n)}installAutoReply(n,s){return this._proxy.installAutoReply(n,s)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(n){return this._proxy.uninstallAutoReply(n)}getDefaultSystemShell(n){return this._proxy.getDefaultSystemShell(n)}async getProfiles(n,s,i,o=!1){const r=await this._shellEnv;return(0,g.detectAvailableProfiles)(s,i,o,this._configurationService,r,void 0,this._logService,this._resolveVariables.bind(this,n))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(n){return this._proxy.getWslPath(n)}setTerminalLayoutInfo(n){return this._proxy.setTerminalLayoutInfo(n)}async getTerminalLayoutInfo(n){return await this._proxy.getTerminalLayoutInfo(n)}async requestDetachInstance(n,s){return this._proxy.requestDetachInstance(n,s)}async acceptDetachInstanceReply(n,s){return this._proxy.acceptDetachInstanceReply(n,s)}async serializeTerminalState(n){return this._proxy.serializeTerminalState(n)}async reviveTerminalProcesses(n,s){return this._proxy.reviveTerminalProcesses(n,s)}async refreshProperty(n,s){return this._proxy.refreshProperty(n,s)}async updateProperty(n,s,i){return this._proxy.updateProperty(n,s,i)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier+S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${S.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(n,s){return this._resolveVariablesRequestStore.createRequest({workspaceId:n,originalText:s})}async acceptPtyHostResolvedVariables(n,s){this._resolveVariablesRequestStore.acceptReply(n,s)}};l=Re([Fe(1,v.IConfigurationService),Fe(2,D.IEnvironmentService),Fe(3,C.ILogService)],l),e.PtyHostService=l}),define(we[52],ye([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,I.createDecorator)("IUriIdentityService")}),define(we[231],ye([0,1,6,2,4,24,35,18,13,52]),function(ie,e,I,t,b,P,k,E,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let T=class extends t.Disposable{constructor(C,y,d,S,h){super();this.extensionsManagementService=C,this.logService=S,this.uriIdentityService=h,this._onDidChangeExtensionsByAnotherSource=this._register(new I.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(p=>{this.installedExtensions=p.map(m=>m.identifier),this.startTimestamp=Date.now()}),this._register(C.onInstallExtension(p=>this.onInstallExtension(p))),this._register(C.onDidInstallExtensions(p=>this.onDidInstallExtensions(p))),this._register(C.onDidUninstallExtension(p=>this.onDidUninstallExtension(p)));const g=b.URI.file(d.extensionsPath);this._register(y.watch(g)),this._register(I.Event.filter(y.onDidFilesChange,p=>p.rawChanges.some(m=>this.doesChangeAffects(m,g)))(()=>this.onDidChange()))}doesChangeAffects(C,y){return C.type!==1&&C.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(C.resource),y)?!1:this.uriIdentityService.extUri.isEqual(C.resource,this.uriIdentityService.extUri.joinPath(y,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(C.resource).startsWith(".")}onInstallExtension(C){this.addInstallingExtension(C.identifier)}onDidInstallExtensions(C){for(const y of C)this.removeInstallingExtension(y.identifier),y.local&&this.addInstalledExtension(y.identifier)}onDidUninstallExtension(C){C.error||this.removeInstalledExtension(C.identifier)}addInstallingExtension(C){this.removeInstallingExtension(C),this.installingExtensions.push(C)}removeInstallingExtension(C){this.installingExtensions=this.installingExtensions.filter(y=>!(0,k.areSameExtensions)(y,C))}addInstalledExtension(C){this.installedExtensions&&(this.removeInstalledExtension(C),this.installedExtensions.push(C))}removeInstalledExtension(C){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(y=>!(0,k.areSameExtensions)(y,C)))}async onDidChange(){if(this.installedExtensions){const C=await this.extensionsManagementService.getInstalled(),y=C.filter(S=>[...this.installingExtensions,...this.installedExtensions].some(h=>(0,k.areSameExtensions)(h,S.identifier))?!1:S.installedTimestamp&&S.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",S.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",S.identifier.id),!1)),d=this.installedExtensions.filter(S=>this.installingExtensions.some(h=>(0,k.areSameExtensions)(h,S))?!1:C.every(h=>!(0,k.areSameExtensions)(h.identifier,S))?(this.logService.info("Detected extension removed from another source",S.id),!0):!1);this.installedExtensions=C.map(S=>S.identifier),(y.length||d.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:y,removed:d})}}};T=Re([Fe(1,E.IFileService),Fe(2,P.INativeEnvironmentService),Fe(3,v.ILogService),Fe(4,D.IUriIdentityService)],T),e.ExtensionsWatcher=T}),define(we[109],ye([0,1,52,189,18,19,133,6,2]),function(ie,e,I,t,b,P,k,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class D{constructor(C){this.uri=C,this.time=D._clock++}touch(){return this.time=D._clock++,this}}D._clock=0;let T=class{constructor(C){this._fileService=C,this._dispooables=new v.DisposableStore,this._limit=2**16;const y=new Map,d=S=>{let h=y.get(S.scheme);return h===void 0&&(h=C.hasProvider(S)&&!this._fileService.hasCapability(S,1024),y.set(S.scheme,h)),h};this._dispooables.add(E.Event.any(C.onDidChangeFileSystemProviderRegistrations,C.onDidChangeFileSystemProviderCapabilities)(S=>{y.delete(S.scheme)})),this.extUri=new P.ExtUri(d),this._canonicalUris=new k.SkipList((S,h)=>this.extUri.compare(S,h,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(C){this._fileService.hasProvider(C)&&(C=(0,P.normalizePath)(C));let y=this._canonicalUris.get(C);return y?y.touch().uri.with({fragment:C.fragment}):(this._canonicalUris.set(C,new D(C)),this._checkTrim(),C)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const C=[...this._canonicalUris.entries()].sort((d,S)=>d[1].touch<S[1].touch?1:d[1].touch>S[1].touch?-1:0);D._clock=0,this._canonicalUris.clear();const y=this._limit*.5;for(let d=0;d<y;d++)this._canonicalUris.set(C[d][0],C[d][1].touch())}};T=Re([Fe(0,b.IFileService)],T),e.UriIdentityService=T,(0,t.registerSingleton)(I.IUriIdentityService,T,!0)}),define(we[110],ye([0,1,176,5,29,19,4,7,8]),function(ie,e,I,t,b,P,k,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,E.createDecorator)("contextService");function D(i){const o=i;return typeof o?.id=="string"&&k.URI.isUri(o.uri)}e.isSingleFolderWorkspaceIdentifier=D;function T(i){if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=T;function R(i){const o=i;return typeof o?.id=="string"&&k.URI.isUri(o.configPath)}e.isWorkspaceIdentifier=R;function C(i){const o=i;if(o?.uri)return{id:o.id,uri:k.URI.revive(o.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:k.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=C;var y;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function d(i){const o=i;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.isWorkspace=d;function S(i){const o=i;return!!(o&&typeof o=="object"&&k.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.isWorkspaceFolder=S;class h{constructor(o,r,a,c,f){this._id=o,this._transient=a,this._configuration=c,this._ignorePathCasing=f,this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(o){this._id=o.id,this._configuration=o.configuration,this._transient=o.transient,this._ignorePathCasing=o._ignorePathCasing,this.folders=o.folders}get folders(){return this._folders}set folders(o){this._folders=o,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(o){this._configuration=o}getFolder(o){return o&&this._foldersMap.findSubstr(o)||null}updateFoldersMap(){this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const o of this.folders)this._foldersMap.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class g{constructor(o,r){this.raw=r,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,P.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function p(i){return new g({uri:i,index:0,name:(0,P.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=p,e.WORKSPACE_EXTENSION="code-workspace";const m=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function l(i,o){return P.extUriBiasedIgnorePathCase.isEqualOrParent(i,o.untitledWorkspacesHome)}e.isUntitledWorkspace=l;function u(i){let o;return k.URI.isUri(i)?o=i:o=i.configuration,o?.scheme===v.Schemas.tmp}e.isTemporaryWorkspace=u;function n(i,o){return!l(i,o)&&!u(i)}e.isSavedWorkspace=n;function s(i){return(typeof i=="string"?(0,t.extname)(i):(0,P.extname)(i))===m}e.hasWorkspaceFileExtension=s}),define(we[111],ye([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStatusService=e.IExtensionHostStatusService=void 0,e.IExtensionHostStatusService=(0,I.createDecorator)("extensionHostStatusService");class t{constructor(){this._exitInfo=new Map}setExitInfo(P,k){this._exitInfo.set(P,k)}getExitInfo(P){return this._exitInfo.get(P)||null}}e.ExtensionHostStatusService=t}),define(we[232],ye([0,1,6,14]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=e.printTime=void 0;function b(k){let E=0,v=0,D=0;k>=1e3&&(D=Math.floor(k/1e3),k-=D*1e3),D>=60&&(v=Math.floor(D/60),D-=v*60),v>=60&&(E=Math.floor(v/60),v-=E*60);const T=E?`${E}h`:"",R=v?`${v}m`:"",C=D?`${D}s`:"",y=k?`${k}ms`:"";return`${T}${R}${C}${y}`}e.printTime=b;class P{constructor(E,v,D,T){this._logService=E,this._reconnectionToken=v,this._onClose=new I.Emitter,this.onClose=this._onClose.event,this._reconnectionGraceTime=108e5,this._reconnectionShortGraceTime=3e5,this._remoteAddress=D,this.protocol=T,this._disposed=!1,this._disconnectRunner1=new t.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection grace time of ${b(this._reconnectionGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionGraceTime),this._disconnectRunner2=new t.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection short grace time of ${b(this._reconnectionShortGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionShortGraceTime),this.protocol.onDidDispose(()=>{this._log("The client has disconnected gracefully, so the connection will be disposed."),this._cleanResources()}),this.protocol.onSocketClose(()=>{this._log(`The client has disconnected, will wait for reconnection ${b(this._reconnectionGraceTime)} before disposing...`),this._disconnectRunner1.schedule()}),this._log("New connection established.")}_log(E){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ManagementConnection] ${E}`)}shortenReconnectionGraceTimeIfNecessary(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&(this._log(`Another client has connected, will shorten the wait for reconnection ${b(this._reconnectionShortGraceTime)} before disposing...`),this._disconnectRunner2.schedule())}_cleanResources(){if(this._disposed)return;this._disposed=!0,this._disconnectRunner1.dispose(),this._disconnectRunner2.dispose();const E=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),E.end(),this._onClose.fire(void 0)}acceptReconnection(E,v,D){this._remoteAddress=E,this._log("The client has reconnected."),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel(),this.protocol.beginAcceptReconnection(v,D),this.protocol.endAcceptReconnection()}}e.ManagementConnection=P}),define(we[112],ye([0,1,30,8,5,140,48]),function(ie,e,I,t,b,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const E=b.join(t.FileAccess.asFileUri("",ie).fsPath,"nls.metadata.json"),v=new Map;function D(C){return new Promise(y=>I.exists(C,y))}function T(C,y){return D(E).then(d=>{if(!d||!k.default.commit)return Promise.resolve({locale:"en",availableLanguages:{}});let S=`${C}||${y}`,h=v.get(S);return h||(h=P.getNLSConfiguration(k.default.commit,y,E,C).then(g=>(R.is(g)&&(g._languagePackSupport=!0),g)),v.set(S,h)),h})}e.getNLSConfiguration=T;var R;(function(C){function y(d){let S=d;return S&&typeof S._languagePackId=="string"}C.is=y})(R=e.InternalNLSConfiguration||(e.InternalNLSConfiguration={}))}),define(we[113],ye([0,1,19,4,24,50,40,18,13,25,112]),function(ie,e,I,t,b,P,k,E,v,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let R=class extends P.AbstractExtensionsScannerService{constructor(y,d,S,h){super(t.URI.file(S.builtinExtensionsPath),t.URI.file(S.extensionsPath),(0,I.joinPath)(S.userHome,".vscode-oss-dev","extensions","control.json"),(0,I.joinPath)(t.URI.file(S.userDataPath),k.MANIFEST_CACHE_FOLDER),y,d,S,h);this.nativeEnvironmentService=S}async getTranslations(y){const d=await(0,T.getNLSConfiguration)(y,this.nativeEnvironmentService.userDataPath);if(T.InternalNLSConfiguration.is(d))try{const S=await this.fileService.readFile(t.URI.file(d._translationsConfigFile));return JSON.parse(S.value.toString())}catch{}return Object.create(null)}};R=Re([Fe(0,E.IFileService),Fe(1,v.ILogService),Fe(2,b.INativeEnvironmentService),Fe(3,D.IProductService)],R),e.ExtensionsScannerService=R}),define(we[233],ye([0,1,234,30,5,27,8,22]),function(ie,e,I,t,b,P,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.requestHasValidConnectionToken=e.determineServerConnectionToken=e.parseServerConnectionToken=e.ServerConnectionTokenParseError=e.MandatoryServerConnectionToken=e.OptionalServerConnectionToken=e.NoneServerConnectionToken=e.ServerConnectionTokenType=void 0;const v=/^[0-9A-Za-z-]+$/;var D;(function(g){g[g.None=0]="None",g[g.Optional=1]="Optional",g[g.Mandatory=2]="Mandatory"})(D=e.ServerConnectionTokenType||(e.ServerConnectionTokenType={}));class T{constructor(){this.type=0}validate(p){return!0}}e.NoneServerConnectionToken=T;class R{constructor(p){this.value=p,this.type=1}validate(p){return p===this.value}}e.OptionalServerConnectionToken=R;class C{constructor(p){this.value=p,this.type=2}validate(p){return p===this.value}}e.MandatoryServerConnectionToken=C;class y{constructor(p){this.message=p}}e.ServerConnectionTokenParseError=y;async function d(g,p){const m=g["without-connection-token"],l=g["connection-token"],u=g["connection-token-file"],n=g.compatibility==="1.63";if(m)return typeof l!="undefined"||typeof u!="undefined"?new y("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new T;if(typeof u!="undefined"){if(typeof l!="undefined")return new y("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let s;try{s=t.readFileSync(u).toString().replace(/\r?\n$/,"")}catch{return new y(`Unable to read the connection token file at '${u}'.`)}return v.test(s)?new C(s):new y(`The connection token defined in '${u} does not adhere to the characters 0-9, a-z, A-Z or -.`)}return typeof l!="undefined"?v.test(l)?n?new R(l):new C(l):new y(`The connection token '${l} does not adhere to the characters 0-9, a-z, A-Z or -.`):n?(console.log("Breaking change in the next release: Please use one of the following arguments: '--connection-token', '--connection-token-file' or '--without-connection-token'."),new R(await p())):new C(await p())}e.parseServerConnectionToken=d;async function S(g){return d(g,async()=>{if(!g["user-data-dir"])return(0,P.generateUuid)();const m=b.join(g["user-data-dir"],"token");try{const n=(await E.Promises.readFile(m)).toString().replace(/\r?\n$/,"");if(v.test(n))return n}catch{}const l=(0,P.generateUuid)();try{await E.Promises.writeFile(m,l,{mode:384})}catch{}return l})}e.determineServerConnectionToken=S;function h(g,p,m){if(g.validate(m.query[k.connectionTokenQueryName]))return!0;const l=I.parse(p.headers.cookie||"");return g.validate(l[k.connectionTokenCookieName])}e.requestHasValidConnectionToken=h}),define(we[42],ye([0,1,178,187,54,7,24]),function(ie,e,I,t,b,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={host:{type:"string",cat:"o",args:"ip-address",description:I.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:I.localize(1,null)},"pick-port":{type:"string",deprecationMessage:"Use the range notation in 'port' instead."},"socket-path":{type:"string",cat:"o",args:"path",description:I.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:I.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:I.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:I.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:I.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:I.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:I.localize(8,null)},"user-data-dir":b.OPTIONS["user-data-dir"],"enable-smoke-test-driver":b.OPTIONS["enable-smoke-test-driver"],"disable-telemetry":b.OPTIONS["disable-telemetry"],"disable-workspace-trust":b.OPTIONS["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:b.OPTIONS.log,logsPath:b.OPTIONS.logsPath,"force-disable-user-env":b.OPTIONS["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:I.localize(9,null)},"default-workspace":{type:"string",description:I.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"extensions-dir":b.OPTIONS["extensions-dir"],"extensions-download-dir":b.OPTIONS["extensions-download-dir"],"builtin-extensions-dir":b.OPTIONS["builtin-extensions-dir"],"install-extension":b.OPTIONS["install-extension"],"install-builtin-extension":b.OPTIONS["install-builtin-extension"],"uninstall-extension":b.OPTIONS["uninstall-extension"],"list-extensions":b.OPTIONS["list-extensions"],"locate-extension":b.OPTIONS["locate-extension"],"show-versions":b.OPTIONS["show-versions"],category:b.OPTIONS.category,force:b.OPTIONS.force,"do-not-sync":b.OPTIONS["do-not-sync"],"pre-release":b.OPTIONS["pre-release"],"start-server":{type:"boolean",cat:"e",description:I.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:b.OPTIONS.help,version:b.OPTIONS.version,compatibility:{type:"string"},_:b.OPTIONS._},e.IServerEnvironmentService=(0,P.refineServiceDecorator)(k.IEnvironmentService);class E extends t.NativeEnvironmentService{get args(){return super.args}}e.ServerEnvironmentService=E}),define(we[235],ye([0,1,30,86,76,234,75,33,64,3,13,42,5,8,27,25,51,20,4,16,12,74]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C,y,d,S,h,g,p,m,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebClientServer=e.serveFile=e.CacheControl=e.serveError=void 0;const n={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function s(c,f,w,A){f.writeHead(w,{"Content-Type":"text/plain"}),f.end(A)}e.serveError=s;var i;(function(c){c[c.NO_CACHING=0]="NO_CACHING",c[c.ETAG=1]="ETAG",c[c.NO_EXPIRY=2]="NO_EXPIRY"})(i=e.CacheControl||(e.CacheControl={}));async function o(c,f,w,A,U,x){try{const Q=await I.promises.stat(c);if(f===1){const _=`W/"${[Q.ino,Q.size,Q.mtime.getTime()].join("-")}"`;if(A.headers["if-none-match"]===_)return U.writeHead(304),U.end();x.Etag=_}else f===2?x["Cache-Control"]="public, max-age=31536000":f===0&&(x["Cache-Control"]="no-store");x["Content-Type"]=n[(0,C.extname)(c)]||(0,v.getMediaMime)(c)||"text/plain",U.writeHead(200,x),(0,I.createReadStream)(c).pipe(U)}catch(Q){return Q.code!=="ENOENT"?(w.error(Q),console.error(Q.toString())):console.error(`File not found: ${c}`),U.writeHead(404,{"Content-Type":"text/plain"}),U.end("Not found")}}e.serveFile=o;const r=(0,C.dirname)(y.FileAccess.asFileUri("",ie).fsPath);let a=class{constructor(f,w,A,U,x){this._connectionToken=f,this._environmentService=w,this._logService=A,this._requestService=U,this._productService=x,this._webExtensionResourceUrlTemplate=this._productService.extensionsGallery?.resourceUrlTemplate?p.URI.parse(this._productService.extensionsGallery.resourceUrlTemplate):void 0;const Q=(0,u.getRemoteServerRootPath)(x);this._staticRoute=`${Q}/static`,this._callbackRoute=`${Q}/callback`,this._webExtensionRoute=`${Q}/web-extension-resource`}async handle(f,w,A){try{const U=A.pathname;return U.startsWith(this._staticRoute)&&U.charCodeAt(this._staticRoute.length)===47?this._handleStatic(f,w,A):U==="/"?this._handleRoot(f,w,A):U===this._callbackRoute?this._handleCallback(w):U.startsWith(this._webExtensionRoute)&&U.charCodeAt(this._webExtensionRoute.length)===47?this._handleWebExtensionResource(f,w,A):s(f,w,404,"Not found.")}catch(U){return this._logService.error(U),console.error(U.toString()),s(f,w,500,"Internal Server Error.")}}async _handleStatic(f,w,A){const U=Object.create(null),Q=decodeURIComponent(A.pathname).substring(this._staticRoute.length+1),_=(0,C.join)(r,Q);return(0,E.isEqualOrParent)(_,r,!D.isLinux)?o(_,this._environmentService.isBuilt?2:1,this._logService,f,w,U):s(f,w,400,"Bad request.")}_getResourceURLTemplateAuthority(f){const w=f.authority.indexOf(".");return w!==-1?f.authority.substring(w+1):void 0}async _handleWebExtensionResource(f,w,A){if(!this._webExtensionResourceUrlTemplate)return s(f,w,500,"No extension gallery service configured.");const U=decodeURIComponent(A.pathname),x=(0,C.normalize)(U.substring(this._webExtensionRoute.length+1)),Q=p.URI.parse(x).with({scheme:this._webExtensionResourceUrlTemplate.scheme,authority:x.substring(0,x.indexOf("/")),path:x.substring(x.indexOf("/")+1)});if(this._getResourceURLTemplateAuthority(this._webExtensionResourceUrlTemplate)!==this._getResourceURLTemplateAuthority(Q))return s(f,w,403,"Request Forbidden");const _={},Y=F=>{const M=f.headers[F];M&&((0,l.isString)(M)||M[0])?_[F]=(0,l.isString)(M)?M:M[0]:F!==F.toLowerCase()&&Y(F.toLowerCase())};Y("X-Client-Name"),Y("X-Client-Version"),Y("X-Machine-Id"),Y("X-Client-Commit");const O=await this._requestService.request({type:"GET",url:Q.toString(!0),headers:_},g.CancellationToken.None),B=O.res.statusCode||500;if(B!==200){let F=null;try{F=await(0,h.asTextOrError)(O)}catch{}return s(f,w,B,F||`Request failed with status ${B}`)}const ue=Object.create(null),V=F=>{const M=O.res.headers[F];M?ue[F]=M:F!==F.toLowerCase()&&V(F.toLowerCase())};V("Cache-Control"),V("Content-Type"),w.writeHead(200,ue);const $=await(0,m.streamToBuffer)(O.stream);return w.end($.buffer)}async _handleRoot(f,w,A){const U=A.query[y.connectionTokenQueryName];if(typeof U=="string"){const oe=Object.create(null);oe["Set-Cookie"]=P.serialize(y.connectionTokenCookieName,U,{sameSite:"lax",maxAge:60*60*24*7});const ge=Object.create(null);for(let q in A.query)q!==y.connectionTokenQueryName&&(ge[q]=A.query[q]);const he=b.format({pathname:"/",query:ge});return oe.Location=he,w.writeHead(302,oe),w.end()}let x=f.headers["x-original-host"];Array.isArray(x)&&(x=x[0]);const Q=x||f.headers.host;if(!Q)return s(f,w,400,"Bad request.");function _(oe){return JSON.stringify(oe).replace(/"/g,"&quot;")}let Y;this._environmentService.args["enable-smoke-test-driver"]&&(Y=!1);const O=oe=>oe&&p.URI.file(t.resolve(oe)).with({scheme:y.Schemas.vscodeRemote,authority:Q}),B=y.FileAccess.asFileUri(this._environmentService.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html",ie).fsPath,ue=!this._environmentService.isBuilt&&this._environmentService.args["github-auth"]?{id:(0,d.generateUuid)(),providerId:"github",accessToken:this._environmentService.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,V={remoteAuthority:Q,_wrapWebWorkerExtHostInIframe:Y,developmentOptions:{enableSmokeTestDriver:this._environmentService.args["enable-smoke-test-driver"]?!0:void 0},settingsSyncOptions:!this._environmentService.isBuilt&&this._environmentService.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this._environmentService.args["disable-workspace-trust"],folderUri:O(this._environmentService.args["default-folder"]),workspaceUri:O(this._environmentService.args["default-workspace"]),productConfiguration:{embedderIdentifier:"server-distro",extensionsGallery:this._webExtensionResourceUrlTemplate?{...this._productService.extensionsGallery,resourceUrlTemplate:this._webExtensionResourceUrlTemplate.with({scheme:"http",authority:Q,path:`${this._webExtensionRoute}/${this._webExtensionResourceUrlTemplate.authority}${this._webExtensionResourceUrlTemplate.path}`}).toString(!0)}:void 0},callbackRoute:this._callbackRoute};let $=this._productService.extensionsGallery?.nlsBaseUrl;$?.endsWith("/")||($+="/");const F={WORKBENCH_WEB_CONFIGURATION:_(V),WORKBENCH_AUTH_SESSION:ue?_(ue):"",WORKBENCH_WEB_BASE_URL:this._staticRoute,WORKBENCH_NLS_BASE_URL:$?`${$}${this._productService.commit}/${this._productService.version}/`:""};let M;try{M=(await I.promises.readFile(B)).toString().replace(/\{\{([^}]+)\}\}/g,(ge,he)=>F[he]??"undefined")}catch{return w.writeHead(404,{"Content-Type":"text/plain"}),w.end("Not found")}const j=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this._getScriptCspHashes(M).join(" ")} 'sha256-fh3TwPMflhsEIpR8g1OYTIMVWhXTLcjQ9kh2tIpmv54=' http://${Q} ${$??""};`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" "),Z={"Content-Type":"text/html","Content-Security-Policy":j};return this._connectionToken.type!==0&&(Z["Set-Cookie"]=P.serialize(y.connectionTokenCookieName,this._connectionToken.value,{sameSite:"lax",maxAge:60*60*24*7})),w.writeHead(200,Z),w.end(M)}_getScriptCspHashes(f){const w=/<script>([\s\S]+?)<\/script>/img,A=[];let U;for(;U=w.exec(f);){const x=k.createHash("sha256"),Q=U[1].replace(/\r\n/g,`
`),_=x.update(Buffer.from(Q)).digest().toString("base64");A.push(`'sha256-${_}'`)}return A}async _handleCallback(f){const w=y.FileAccess.asFileUri("vs/code/browser/workbench/callback.html",ie).fsPath,A=(await I.promises.readFile(w)).toString(),U=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this._getScriptCspHashes(A).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return f.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":U}),f.end(A)}};a=Re([Fe(1,R.IServerEnvironmentService),Fe(2,T.ILogService),Fe(3,h.IRequestService),Fe(4,S.IProductService)],a),e.WebClientServer=a}),define(we[236],ye([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,I.createDecorator)("IExtHostRpcService");class t{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=t});var St=this&&this.__classPrivateFieldSet||function(ie,e,I,t,b){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!b:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?b.call(ie,I):b?b.value=I:e.set(ie,I),I},et=this&&this.__classPrivateFieldGet||function(ie,e,I,t){if(I==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!t:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return I==="m"?t:I==="a"?t.call(ie):t?t.value:e.get(ie)};define(we[114],ye([0,1,17,9,84,29,64,15,12,4,27,18,103]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C){"use strict";var y,d,S,h,g,p,m,l,u,n,s,i,o,r,a,c,f,w,A,U,x,Q;Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function _(N){function L(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(L,N),Object.setPrototypeOf(L.prototype,N.prototype),L}let Y=p=class{constructor(L){y.set(this,void 0),St(this,y,L,"f")}static from(...L){let ne=L;return new p(function(){if(ne){for(const Se of ne)Se&&typeof Se.dispose=="function"&&Se.dispose();ne=void 0}})}dispose(){typeof et(this,y,"f")=="function"&&(et(this,y,"f").call(this),St(this,y,void 0,"f"))}};y=new WeakMap,Y=p=Re([_],Y),e.Disposable=Y;let O=m=class{constructor(L,ne){if(L<0)throw(0,t.illegalArgument)("line must be non-negative");if(ne<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=L,this._character=ne}static Min(...L){if(L.length===0)throw new TypeError;let ne=L[0];for(let Se=1;Se<L.length;Se++){const $e=L[Se];$e.isBefore(ne)&&(ne=$e)}return ne}static Max(...L){if(L.length===0)throw new TypeError;let ne=L[0];for(let Se=1;Se<L.length;Se++){const $e=L[Se];$e.isAfter(ne)&&(ne=$e)}return ne}static isPosition(L){if(!L)return!1;if(L instanceof m)return!0;let{line:ne,character:Se}=L;return typeof ne=="number"&&typeof Se=="number"}static of(L){if(L instanceof m)return L;if(this.isPosition(L))return new m(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,ne=0){if(L===null||ne===null)throw(0,t.illegalArgument)();let Se;return typeof L=="undefined"?Se=0:typeof L=="number"?Se=L:(Se=typeof L.lineDelta=="number"?L.lineDelta:0,ne=typeof L.characterDelta=="number"?L.characterDelta:0),Se===0&&ne===0?this:new m(this.line+Se,this.character+ne)}with(L,ne=this.character){if(L===null||ne===null)throw(0,t.illegalArgument)();let Se;return typeof L=="undefined"?Se=this.line:typeof L=="number"?Se=L:(Se=typeof L.line=="number"?L.line:this.line,ne=typeof L.character=="number"?L.character:this.character),Se===this.line&&ne===this.character?this:new m(Se,ne)}toJSON(){return{line:this.line,character:this.character}}};O=m=Re([_],O),e.Position=O;let B=l=class{constructor(L,ne,Se,$e){let Ge,Je;if(typeof L=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof $e=="number"?(Ge=new O(L,ne),Je=new O(Se,$e)):O.isPosition(L)&&O.isPosition(ne)&&(Ge=O.of(L),Je=O.of(ne)),!Ge||!Je)throw new Error("Invalid arguments");Ge.isBefore(Je)?(this._start=Ge,this._end=Je):(this._start=Je,this._end=Ge)}static isRange(L){return L instanceof l?!0:L?O.isPosition(L.start)&&O.isPosition(L.end):!1}static of(L){if(L instanceof l)return L;if(this.isRange(L))return new l(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(L){return l.isRange(L)?this.contains(L.start)&&this.contains(L.end):O.isPosition(L)?!(O.of(L).isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const ne=O.Max(L.start,this._start),Se=O.Min(L.end,this._end);if(!ne.isAfter(Se))return new l(ne,Se)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const ne=O.Min(L.start,this._start),Se=O.Max(L.end,this.end);return new l(ne,Se)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,ne=this.end){if(L===null||ne===null)throw(0,t.illegalArgument)();let Se;return L?O.isPosition(L)?Se=L:(Se=L.start||this.start,ne=L.end||this.end):Se=this.start,Se.isEqual(this._start)&&ne.isEqual(this.end)?this:new l(Se,ne)}toJSON(){return[this.start,this.end]}};B=l=Re([_],B),e.Range=B;let ue=u=class extends B{constructor(L,ne,Se,$e){let Ge,Je;if(typeof L=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof $e=="number"?(Ge=new O(L,ne),Je=new O(Se,$e)):O.isPosition(L)&&O.isPosition(ne)&&(Ge=O.of(L),Je=O.of(ne)),!Ge||!Je)throw new Error("Invalid arguments");super(Ge,Je);this._anchor=Ge,this._active=Je}static isSelection(L){return L instanceof u?!0:L?B.isRange(L)&&O.isPosition(L.anchor)&&O.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};ue=u=Re([_],ue),e.Selection=ue;class V{constructor(L,ne,Se){if(typeof L!="string"||L.length===0)throw(0,t.illegalArgument)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,t.illegalArgument)("port");if(typeof Se!="undefined"&&(typeof Se!="string"||Se.length===0||!/^[0-9A-Za-z\-]+$/.test(Se)))throw(0,t.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(ne),this.connectionToken=Se}}e.ResolvedAuthority=V;class $ extends Error{constructor(L,ne=C.RemoteAuthorityResolverErrorCode.Unknown,Se){super(L);this._message=L,this._code=ne,this._detail=Se,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,$.prototype)}static NotAvailable(L,ne){return new $(L,C.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(L){return new $(L,C.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=$;var F;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(F=e.EndOfLine||(e.EndOfLine={}));var M;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(M=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let j=n=class{constructor(L,ne){this._range=L,this._newText=ne}static isTextEdit(L){return L instanceof n?!0:L?B.isRange(L)&&typeof L.newText=="string":!1}static replace(L,ne){return new n(L,ne)}static insert(L,ne){return n.replace(new B(L,L),ne)}static delete(L){return n.replace(L,"")}static setEndOfLine(L){const ne=new n(new B(new O(0,0),new O(0,0)),"");return ne.newEol=L,ne}get range(){return this._range}set range(L){if(L&&!B.isRange(L))throw(0,t.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,t.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,t.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};j=n=Re([_],j),e.TextEdit=j;let Z=s=class{constructor(L,ne){this.range=L,this.newCells=ne}static isNotebookCellEdit(L){return L instanceof s?!0:L?Et.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,ne){return new s(L,ne)}static insertCells(L,ne){return new s(new Et(L,L),ne)}static deleteCells(L){return new s(L,[])}static updateCellMetadata(L,ne){const Se=new s(new Et(L,L),[]);return Se.newCellMetadata=ne,Se}static updateNotebookMetadata(L){const ne=new s(new Et(0,0),[]);return ne.newNotebookMetadata=L,ne}};Z=s=Re([_],Z),e.NotebookEdit=Z;class oe{constructor(L,ne){this.range=L,this.snippet=ne}}e.SnippetTextEdit=oe;var ge;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace"})(ge=e.FileEditType||(e.FileEditType={}));let he=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,ne,Se,$e){this._edits.push({_type:1,from:L,to:ne,options:Se,metadata:$e})}createFile(L,ne,Se){this._edits.push({_type:1,from:void 0,to:L,options:ne,metadata:Se})}deleteFile(L,ne,Se){this._edits.push({_type:1,from:L,to:void 0,options:ne,metadata:Se})}replaceNotebookMetadata(L,ne,Se){this._edits.push({_type:3,metadata:Se,uri:L,edit:{editType:5,metadata:ne},notebookMetadata:ne})}replaceNotebookCells(L,ne,Se,$e,Ge){let Je,Ze,ot=[],lt;if(Et.isNotebookRange(ne)&&kt.isNotebookCellDataArray(Se)&&!kt.isNotebookCellDataArray($e)?(Je=ne.start,Ze=ne.end,ot=Se,lt=$e):typeof ne=="number"&&typeof Se=="number"&&kt.isNotebookCellDataArray($e)&&(Je=ne,Ze=Se,ot=$e,lt=Ge),Je===void 0||Ze===void 0)throw new Error("Invalid arguments");(Je!==Ze||ot.length>0)&&this._edits.push({_type:5,uri:L,index:Je,count:Ze-Je,cells:ot,metadata:lt})}replaceNotebookCellMetadata(L,ne,Se,$e){this._edits.push({_type:3,metadata:$e,uri:L,edit:{editType:8,index:ne,metadata:Se}})}replace(L,ne,Se,$e){this._edits.push({_type:2,uri:L,edit:new j(ne,Se),metadata:$e})}insert(L,ne,Se,$e){this.replace(L,new B(ne,ne),Se,$e)}delete(L,ne,Se){this.replace(L,ne,"",Se)}has(L){return this._edits.some(ne=>ne._type===2&&ne.uri.toString()===L.toString())}set(L,ne){if(ne)for(const Se of ne)Se&&(Z.isNotebookCellEdit(Se)?Se.newCellMetadata?this.replaceNotebookCellMetadata(L,Se.range.start,Se.newCellMetadata):Se.newNotebookMetadata?this.replaceNotebookMetadata(L,Se.newNotebookMetadata):this.replaceNotebookCells(L,Se.range,Se.newCells):this._edits.push({_type:2,uri:L,edit:Se}));else{for(let Se=0;Se<this._edits.length;Se++){const $e=this._edits[Se];$e._type===2&&$e.uri.toString()===L.toString()&&(this._edits[Se]=void 0)}(0,I.coalesceInPlace)(this._edits)}}get(L){const ne=[];for(let Se of this._edits)Se._type===2&&Se.uri.toString()===L.toString()&&ne.push(Se.edit);return ne}entries(){const L=new P.ResourceMap;for(let ne of this._edits)if(ne._type===2){let Se=L.get(ne.uri);Se||(Se=[ne.uri,[]],L.set(ne.uri,Se)),Se[1].push(ne.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};he=Re([_],he),e.WorkspaceEdit=he;let q=i=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof i?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=i._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,ne=this._tabstop++){if(typeof L=="function"){const Se=new i;Se._tabstop=this._tabstop,L(Se),this._tabstop=Se._tabstop,L=Se.value}else L=i._escape(L);return this.value+="${",this.value+=ne,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,ne=this._tabstop++){const Se=L.map($e=>$e.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(L,ne){if(typeof ne=="function"){const Se=new i;Se._tabstop=this._tabstop,ne(Se),this._tabstop=Se._tabstop,ne=Se.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};q=i=Re([_],q),e.SnippetString=q;var ee;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(ee=e.DiagnosticTag||(e.DiagnosticTag={}));var G;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(G=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let z=o=class{constructor(L,ne){if(this.uri=L,ne)if(B.isRange(ne))this.range=B.of(ne);else if(O.isPosition(ne))this.range=new B(ne,ne);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof o?!0:L?B.isRange(L.range)&&D.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};z=o=Re([_],z),e.Location=z;let te=class{constructor(L,ne){this.location=L,this.message=ne}static is(L){return L?typeof L.message=="string"&&L.location&&B.isRange(L.location.range)&&D.URI.isUri(L.location.uri):!1}static isEqual(L,ne){return L===ne?!0:!L||!ne?!1:L.message===ne.message&&L.location.range.isEqual(ne.location.range)&&L.location.uri.toString()===ne.location.uri.toString()}};te=Re([_],te),e.DiagnosticRelatedInformation=te;let ce=class{constructor(L,ne,Se=G.Error){if(!B.isRange(L))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=L,this.message=ne,this.severity=Se}toJSON(){return{severity:G[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,ne){return L===ne?!0:!L||!ne?!1:L.message===ne.message&&L.severity===ne.severity&&L.code===ne.code&&L.severity===ne.severity&&L.source===ne.source&&L.range.isEqual(ne.range)&&(0,I.equals)(L.tags,ne.tags)&&(0,I.equals)(L.relatedInformation,ne.relatedInformation,te.isEqual)}};ce=Re([_],ce),e.Diagnostic=ce;let J=class{constructor(L,ne){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=ne}};J=Re([_],J),e.Hover=J;var se;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(se=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let me=class{constructor(L,ne=se.Text){this.range=L,this.kind=ne}toJSON(){return{range:this.range,kind:se[this.kind]}}};me=Re([_],me),e.DocumentHighlight=me;var X;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(X=e.SymbolKind||(e.SymbolKind={}));var re;(function(N){N[N.Deprecated=1]="Deprecated"})(re=e.SymbolTag||(e.SymbolTag={}));let W=r=class{constructor(L,ne,Se,$e,Ge){this.name=L,this.kind=ne,this.containerName=Ge,typeof Se=="string"&&(this.containerName=Se),$e instanceof z?this.location=$e:Se instanceof B&&(this.location=new z($e,Se)),r.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:X[this.kind],location:this.location,containerName:this.containerName}}};W=r=Re([_],W),e.SymbolInformation=W;let K=a=class{constructor(L,ne,Se,$e,Ge){this.name=L,this.detail=ne,this.kind=Se,this.range=$e,this.selectionRange=Ge,this.children=[],a.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(a.validate)}};K=a=Re([_],K),e.DocumentSymbol=K;var le;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(le=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ve=class{constructor(L,ne){this.title=L,this.kind=ne}};ve=Re([_],ve),e.CodeAction=ve;let De=c=class{constructor(L){this.value=L}append(L){return new c(this.value?this.value+c.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+c.sep)}};De.sep=".",De=c=Re([_],De),e.CodeActionKind=De,De.Empty=new De(""),De.QuickFix=De.Empty.append("quickfix"),De.Refactor=De.Empty.append("refactor"),De.RefactorExtract=De.Refactor.append("extract"),De.RefactorInline=De.Refactor.append("inline"),De.RefactorRewrite=De.Refactor.append("rewrite"),De.Source=De.Empty.append("source"),De.SourceOrganizeImports=De.Source.append("organizeImports"),De.SourceFixAll=De.Source.append("fixAll");let Te=class{constructor(L,ne){if(this.range=L,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Te=Re([_],Te),e.SelectionRange=Te;class Oe{constructor(L,ne,Se,$e,Ge,Je){this.kind=L,this.name=ne,this.detail=Se,this.uri=$e,this.range=Ge,this.selectionRange=Je}}e.CallHierarchyItem=Oe;class Ue{constructor(L,ne){this.fromRanges=ne,this.from=L}}e.CallHierarchyIncomingCall=Ue;class de{constructor(L,ne){this.fromRanges=ne,this.to=L}}e.CallHierarchyOutgoingCall=de;var be;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})(be=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let pe=class{constructor(L,ne){this.range=L,this.command=ne}get isResolved(){return!!this.command}};pe=Re([_],pe),e.CodeLens=pe;let _e=f=class{constructor(L,ne=!1){d.set(this,void 0),St(this,d,new b.MarkdownString(L,{supportThemeIcons:ne}),"f")}static isMarkdownString(L){return L instanceof f?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return et(this,d,"f").value}set value(L){et(this,d,"f").value=L}get isTrusted(){return et(this,d,"f").isTrusted}set isTrusted(L){et(this,d,"f").isTrusted=L}get supportThemeIcons(){return et(this,d,"f").supportThemeIcons}set supportThemeIcons(L){et(this,d,"f").supportThemeIcons=L}get supportHtml(){return et(this,d,"f").supportHtml}set supportHtml(L){et(this,d,"f").supportHtml=L}get baseUri(){return et(this,d,"f").baseUri}set baseUri(L){et(this,d,"f").baseUri=L}appendText(L){return et(this,d,"f").appendText(L),this}appendMarkdown(L){return et(this,d,"f").appendMarkdown(L),this}appendCodeblock(L,ne){return et(this,d,"f").appendCodeblock(ne??"",L),this}};d=new WeakMap,_e=f=Re([_],_e),e.MarkdownString=_e;let Ne=class{constructor(L,ne){this.label=L,this.documentation=ne}};Ne=Re([_],Ne),e.ParameterInformation=Ne;let qe=class{constructor(L,ne){this.label=L,this.documentation=ne,this.parameters=[]}};qe=Re([_],qe),e.SignatureInformation=qe;let ze=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ze=Re([_],ze),e.SignatureHelp=ze;var He;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(He=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Qe;(function(N){N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(Qe=e.InlayHintKind||(e.InlayHintKind={}));let Ve=class{constructor(L){this.value=L}};Ve=Re([_],Ve),e.InlayHintLabelPart=Ve;let ae=class{constructor(L,ne,Se){this.position=L,this.label=ne,this.kind=Se}};ae=Re([_],ae),e.InlayHint=ae;var Ce;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ke;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(ke=e.CompletionItemKind||(e.CompletionItemKind={}));var Le;(function(N){N[N.Deprecated=1]="Deprecated"})(Le=e.CompletionItemTag||(e.CompletionItemTag={}));let Be=class{constructor(L,ne){this.label=L,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&ke[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Be=Re([_],Be),e.CompletionItem=Be;let Me=class{constructor(L=[],ne=!1){this.items=L,this.isIncomplete=ne}};Me=Re([_],Me),e.CompletionList=Me;let je=class{constructor(L,ne,Se){this.insertText=L,this.range=ne,this.command=Se}};je=Re([_],je),e.InlineSuggestion=je;let Ke=class{constructor(L){this.commands=void 0,this.items=L}};Ke=Re([_],Ke),e.InlineSuggestionList=Ke;let Xe=class{constructor(L,ne,Se){this.insertText=L,this.range=ne,this.command=Se}};Xe=Re([_],Xe),e.InlineSuggestionNew=Xe;let xe=class{constructor(L,ne){this.items=L,this.commands=ne}};xe=Re([_],xe),e.InlineSuggestionsNew=xe;var tt;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(tt=e.ViewColumn||(e.ViewColumn={}));var nt;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(nt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var st;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(st=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var pt;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(pt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Tt;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(Tt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var at;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(at=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ut;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(ut=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var ft;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(ft=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function L(ne){switch(ne){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=L}(at=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let vt=class{constructor(L,ne){if(ne&&!D.URI.isUri(ne))throw(0,t.illegalArgument)("target");if(!B.isRange(L)||L.isEmpty)throw(0,t.illegalArgument)("range");this.range=L,this.target=ne}};vt=Re([_],vt),e.DocumentLink=vt;let yt=class{constructor(L,ne,Se,$e){this.red=L,this.green=ne,this.blue=Se,this.alpha=$e}};yt=Re([_],yt),e.Color=yt;let It=class{constructor(L,ne){if(ne&&!(ne instanceof yt))throw(0,t.illegalArgument)("color");if(!B.isRange(L)||L.isEmpty)throw(0,t.illegalArgument)("range");this.range=L,this.color=ne}};It=Re([_],It),e.ColorInformation=It;let Dt=class{constructor(L){if(!L||typeof L!="string")throw(0,t.illegalArgument)("label");this.label=L}};Dt=Re([_],Dt),e.ColorPresentation=Dt;var _t;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(_t=e.ColorFormat||(e.ColorFormat={}));var Lt;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(Lt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Ft{constructor(L,ne,Se){if(this.startIndex=L,this.length=ne,this.tooltip=Se,typeof L!="number"||L<0)throw(0,t.illegalArgument)("startIndex");if(typeof ne!="number"||ne<1)throw(0,t.illegalArgument)("length");if(Se!==void 0&&typeof Se!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Ft;var Mt;(function(N){N[N.Panel=1]="Panel",N[N.Editor=2]="Editor"})(Mt=e.TerminalLocation||(e.TerminalLocation={}));class $t{constructor(L){if(this.options=L,typeof L!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=$t;var Ee;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(Ee=e.TaskRevealKind||(e.TaskRevealKind={}));var Ie;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(Ie=e.TaskPanelKind||(e.TaskPanelKind={}));let fe=w=class{constructor(L,ne){if(this.label=ne,typeof L!="string"||typeof ne!="string")throw(0,t.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return w.Clean;case"build":return w.Build;case"rebuild":return w.Rebuild;case"test":return w.Test;default:return}}get id(){return this._id}};fe.Clean=new w("clean","Clean"),fe.Build=new w("build","Build"),fe.Rebuild=new w("rebuild","Rebuild"),fe.Test=new w("test","Test"),fe=w=Re([_],fe),e.TaskGroup=fe;function H(N){let L="";for(let ne=0;ne<N.length;ne++)L+=N[ne].replace(/,/g,",,")+",";return L}let Pe=class{constructor(L,ne,Se){if(typeof L!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=L,ne!==void 0&&(Array.isArray(ne)?(this._args=ne,this._options=Se):this._options=ne)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,t.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let ne of this._args)L.push(ne);return H(L)}};Pe=Re([_],Pe),e.ProcessExecution=Pe;let Ae=class{constructor(L,ne,Se){if(this._args=[],Array.isArray(ne)){if(!L)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,t.illegalArgument)("command");this._command=L,this._args=ne,this._options=Se}else{if(typeof L!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=L,this._options=ne}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,t.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ne of this._args)L.push(typeof ne=="string"?ne:ne.value);return H(L)}};Ae=Re([_],Ae),e.ShellExecution=Ae;var Ye;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(Ye=e.ShellQuoting||(e.ShellQuoting={}));var We;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(We=e.TaskScope||(e.TaskScope={}));class it{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=it;let rt=A=class{constructor(L,ne,Se,$e,Ge,Je){this.__deprecated=!1,this._definition=this.definition=L;let Ze;typeof ne=="string"?(this._name=this.name=ne,this._source=this.source=Se,this.execution=$e,Ze=Ge,this.__deprecated=!0):ne===We.Global||ne===We.Workspace?(this.target=ne,this._name=this.name=Se,this._source=this.source=$e,this.execution=Ge,Ze=Je):(this.target=ne,this._name=this.name=Se,this._source=this.source=$e,this.execution=Ge,Ze=Je),typeof Ze=="string"?(this._problemMatchers=[Ze],this._hasDefinedMatchers=!0):Array.isArray(Ze)?(this._problemMatchers=Ze,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Pe?this._definition={type:A.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ae?this._definition={type:A.ShellType,id:this._execution.computeId()}:this._execution instanceof it?this._definition={type:A.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:A.EmptyType,id:(0,T.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const ne=this._definition.type;(A.EmptyType===ne||A.ProcessType===ne||A.ShellType===ne||A.ExtensionCallbackType===ne)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};rt.ExtensionCallbackType="customExecution",rt.ProcessType="process",rt.ShellType="shell",rt.EmptyType="$empty",rt=A=Re([_],rt),e.Task=rt;var Pt;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(Pt=e.ProgressLocation||(e.ProgressLocation={}));let ht=class{constructor(L,ne=ct.None){this.collapsibleState=ne,D.URI.isUri(L)?this.resourceUri=L:this.label=L}};ht=Re([_],ht),e.TreeItem=ht;var ct;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(ct=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let dt=class{constructor(L){this.value=L}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}};dt=Re([_],dt),e.DataTransferItem=dt;let Wt=class{constructor(L){S.set(this,new Map);for(const[ne,Se]of L??[]){const $e=et(this,S,"f").get(ne);$e?$e.push(Se):et(this,S,"f").set(ne,[Se])}}get(L){return et(this,S,"f").get(L)?.[0]}set(L,ne){et(this,S,"f").set(L,[ne])}forEach(L){for(const[ne,Se]of et(this,S,"f"))Se.forEach($e=>L($e,ne))}};S=new WeakMap,Wt=Re([_],Wt),e.DataTransfer=Wt;let Ct=class{constructor(L,ne){this.id=L,this.color=ne}};Ct=Re([_],Ct),e.ThemeIcon=Ct,Ct.File=new Ct("file"),Ct.Folder=new Ct("folder");let jt=class{constructor(L){this.id=L}};jt=Re([_],jt),e.ThemeColor=jt;var vn;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(vn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ht=class{constructor(L,ne){if(typeof L!="string"&&(!L||!D.URI.isUri(L)&&!D.URI.isUri(L.uri)))throw(0,t.illegalArgument)("base");if(typeof ne!="string")throw(0,t.illegalArgument)("pattern");typeof L=="string"?this.baseUri=D.URI.file(L):D.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=ne}get base(){return this._base}set base(L){this._base=L,this._baseUri=D.URI.file(L)}get baseUri(){return this._baseUri}set baseUri(L){this._baseUri=L,this._base=L.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Ht=Re([_],Ht),e.RelativePattern=Ht;let Rt=class{constructor(L,ne,Se,$e){this.enabled=typeof L=="boolean"?L:!0,typeof ne=="string"&&(this.condition=ne),typeof Se=="string"&&(this.hitCondition=Se),typeof $e=="string"&&(this.logMessage=$e)}get id(){return this._id||(this._id=(0,T.generateUuid)()),this._id}};Rt=Re([_],Rt),e.Breakpoint=Rt;let qt=class extends Rt{constructor(L,ne,Se,$e,Ge){super(ne,Se,$e,Ge);if(L===null)throw(0,t.illegalArgument)("location");this.location=L}};qt=Re([_],qt),e.SourceBreakpoint=qt;let Vt=class extends Rt{constructor(L,ne,Se,$e,Ge){super(ne,Se,$e,Ge);this.functionName=L}};Vt=Re([_],Vt),e.FunctionBreakpoint=Vt;let xt=class extends Rt{constructor(L,ne,Se,$e,Ge,Je,Ze){super($e,Ge,Je,Ze);if(!ne)throw(0,t.illegalArgument)("dataId");this.label=L,this.dataId=ne,this.canPersist=Se}};xt=Re([_],xt),e.DataBreakpoint=xt;let Gt=class{constructor(L,ne,Se){this.command=L,this.args=ne||[],this.options=Se}};Gt=Re([_],Gt),e.DebugAdapterExecutable=Gt;let Kt=class{constructor(L,ne){this.port=L,this.host=ne}};Kt=Re([_],Kt),e.DebugAdapterServer=Kt;let Qt=class{constructor(L){this.path=L}};Qt=Re([_],Qt),e.DebugAdapterNamedPipeServer=Qt;let Xt=class{constructor(L){this.implementation=L}};Xt=Re([_],Xt),e.DebugAdapterInlineImplementation=Xt;let Yt=class{constructor(L,ne){this.range=L,this.expression=ne}};Yt=Re([_],Yt),e.EvaluatableExpression=Yt;var wn;(function(N){N[N.Invoke=0]="Invoke",N[N.Automatic=1]="Automatic"})(wn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var yn;(function(N){N[N.Invoke=0]="Invoke",N[N.Automatic=1]="Automatic"})(yn=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let Jt=class{constructor(L,ne){this.range=L,this.text=ne}};Jt=Re([_],Jt),e.InlineValueText=Jt;let Zt=class{constructor(L,ne,Se=!0){this.range=L,this.variableName=ne,this.caseSensitiveLookup=Se}};Zt=Re([_],Zt),e.InlineValueVariableLookup=Zt;let en=class{constructor(L,ne){this.range=L,this.expression=ne}};en=Re([_],en),e.InlineValueEvaluatableExpression=en;let tn=class{constructor(L,ne){this.frameId=L,this.stoppedLocation=ne}};tn=Re([_],tn),e.InlineValueContext=tn;var En;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(En=e.FileChangeType||(e.FileChangeType={}));let nn=U=class extends Error{constructor(L,ne=R.FileSystemProviderErrorCode.Unknown,Se){super(D.URI.isUri(L)?L.toString(!0):L);this.code=Se?.name??"Unknown",(0,R.markAsFileSystemProviderError)(this,ne),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,U.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}static FileExists(L){return new U(L,R.FileSystemProviderErrorCode.FileExists,U.FileExists)}static FileNotFound(L){return new U(L,R.FileSystemProviderErrorCode.FileNotFound,U.FileNotFound)}static FileNotADirectory(L){return new U(L,R.FileSystemProviderErrorCode.FileNotADirectory,U.FileNotADirectory)}static FileIsADirectory(L){return new U(L,R.FileSystemProviderErrorCode.FileIsADirectory,U.FileIsADirectory)}static NoPermissions(L){return new U(L,R.FileSystemProviderErrorCode.NoPermissions,U.NoPermissions)}static Unavailable(L){return new U(L,R.FileSystemProviderErrorCode.Unavailable,U.Unavailable)}};nn=U=Re([_],nn),e.FileSystemError=nn;let rn=class{constructor(L,ne,Se){this.start=L,this.end=ne,this.kind=Se}};rn=Re([_],rn),e.FoldingRange=rn;var bn;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(bn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Sn;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(Sn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Cn;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(Cn=e.CommentMode||(e.CommentMode={}));var In;(function(N){N[N.Unresolved=0]="Unresolved",N[N.Resolved=1]="Resolved"})(In=e.CommentThreadState||(e.CommentThreadState={}));class Dn{constructor(L,ne=[]){this.tokenTypes=L,this.tokenModifiers=ne}}e.SemanticTokensLegend=Dn;function Pn(N){return typeof N=="undefined"||(0,v.isStringArray)(N)}class sn{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let ne=0,Se=L.tokenTypes.length;ne<Se;ne++)this._tokenTypeStrToInt.set(L.tokenTypes[ne],ne);for(let ne=0,Se=L.tokenModifiers.length;ne<Se;ne++)this._tokenModifierStrToInt.set(L.tokenModifiers[ne],ne)}}push(L,ne,Se,$e,Ge){if(typeof L=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof $e=="number"&&(typeof Ge=="number"||typeof Ge=="undefined"))return typeof Ge=="undefined"&&(Ge=0),this._pushEncoded(L,ne,Se,$e,Ge);if(B.isRange(L)&&typeof ne=="string"&&Pn(Se))return this._push(L,ne,Se);throw(0,t.illegalArgument)()}_push(L,ne,Se){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ne))throw new Error("`tokenType` is not in the provided legend");const $e=L.start.line,Ge=L.start.character,Je=L.end.character-L.start.character,Ze=this._tokenTypeStrToInt.get(ne);let ot=0;if(Se)for(const lt of Se){if(!this._tokenModifierStrToInt.has(lt))throw new Error("`tokenModifier` is not in the provided legend");const gt=this._tokenModifierStrToInt.get(lt);ot|=1<<gt>>>0}this._pushEncoded($e,Ge,Je,Ze,ot)}_pushEncoded(L,ne,Se,$e,Ge){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&ne<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const ot=this._data.length/5|0;let lt=0,gt=0;for(let wt=0;wt<ot;wt++){let bt=this._data[5*wt],Ot=this._data[5*wt+1];bt===0?(bt=lt,Ot+=gt):bt+=lt,this._data[5*wt]=bt,this._data[5*wt+1]=Ot,lt=bt,gt=Ot}}let Je=L,Ze=ne;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Je-=this._prevLine,Je===0&&(Ze-=this._prevChar)),this._data[this._dataLen++]=Je,this._data[this._dataLen++]=Ze,this._data[this._dataLen++]=Se,this._data[this._dataLen++]=$e,this._data[this._dataLen++]=Ge,this._prevLine=L,this._prevChar=ne}static _sortAndDeltaEncode(L){let ne=[];const Se=L.length/5|0;for(let Ze=0;Ze<Se;Ze++)ne[Ze]=Ze;ne.sort((Ze,ot)=>{const lt=L[5*Ze],gt=L[5*ot];if(lt===gt){const wt=L[5*Ze+1],bt=L[5*ot+1];return wt-bt}return lt-gt});const $e=new Uint32Array(L.length);let Ge=0,Je=0;for(let Ze=0;Ze<Se;Ze++){const ot=5*ne[Ze],lt=L[ot+0],gt=L[ot+1],wt=L[ot+2],bt=L[ot+3],Ot=L[ot+4],pn=lt-Ge,ai=pn===0?gt-Je:gt,Nt=5*Ze;$e[Nt+0]=pn,$e[Nt+1]=ai,$e[Nt+2]=wt,$e[Nt+3]=bt,$e[Nt+4]=Ot,Ge=lt,Je=gt}return $e}build(L){return this._dataIsSortedAndDeltaEncoded?new on(new Uint32Array(this._data),L):new on(sn._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=sn;class on{constructor(L,ne){this.resultId=ne,this.data=L}}e.SemanticTokens=on;class kn{constructor(L,ne,Se){this.start=L,this.deleteCount=ne,this.data=Se}}e.SemanticTokensEdit=kn;class Tn{constructor(L,ne){this.resultId=ne,this.edits=L}}e.SemanticTokensEdits=Tn;var Rn;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(Rn=e.DebugConsoleMode||(e.DebugConsoleMode={}));let Ut=class{constructor(){}};Ut.Back={iconPath:new Ct("arrow-left")},Ut=Re([_],Ut),e.QuickInputButtons=Ut;var An;(function(N){N[N.Separator=-1]="Separator",N[N.Default=0]="Default"})(An=e.QuickPickItemKind||(e.QuickPickItemKind={}));var _n;(function(N){N[N.Info=1]="Info",N[N.Warning=2]="Warning",N[N.Error=3]="Error"})(_n=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Ln;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Ln=e.ExtensionKind||(e.ExtensionKind={}));class Fn{constructor(L,ne,Se){this.badge=L,this.tooltip=ne,this.color=Se}static validate(L){if(L.badge){let ne=(0,E.nextCharLength)(L.badge,0);if(ne<L.badge.length&&(ne+=(0,E.nextCharLength)(L.badge,ne)),L.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Fn;let an=class{constructor(L){this.kind=L}};an=Re([_],an),e.ColorTheme=an;var On;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast",N[N.HighContrastLight=4]="HighContrastLight"})(On=e.ColorThemeKind||(e.ColorThemeKind={}));class Et{constructor(L,ne){if(L<0)throw(0,t.illegalArgument)("start must be positive");if(ne<0)throw(0,t.illegalArgument)("end must be positive");L<=ne?(this._start=L,this._end=ne):(this._start=ne,this._end=L)}static isNotebookRange(L){return L instanceof Et?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let ne=this._start,Se=this._end;return L.start!==void 0&&(ne=L.start),L.end!==void 0&&(Se=L.end),ne===this._start&&Se===this._end?this:new Et(ne,Se)}}e.NotebookRange=Et;class kt{constructor(L,ne,Se,$e,Ge,Je,Ze){this.kind=L,this.value=ne,this.languageId=Se,this.mime=$e,this.outputs=Ge??[],this.metadata=Je,this.executionSummary=Ze,kt.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(ne=>kt.isNotebookCellData(ne))}static isNotebookCellData(L){return!0}}e.NotebookCellData=kt;class Nn{constructor(L){this.cells=L}}e.NotebookData=Nn;class mt{constructor(L,ne){this.data=L,this.mime=ne;const Se=(0,k.normalizeMimeType)(ne,!0);if(!Se)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}static isNotebookCellOutputItem(L){return L instanceof mt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const ne={name:L.name,message:L.message,stack:L.stack};return mt.json(ne,"application/vnd.code.notebook.error")}static stdout(L){return mt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return mt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,ne="application/octet-stream"){return new mt(L,ne)}static text(L,ne=k.Mimes.text){const Se=et(mt,h,"f",g).encode(String(L));return new mt(Se,ne)}static json(L,ne="text/x-json"){const Se=JSON.stringify(L,void 0,"	");return mt.text(Se,ne)}}e.NotebookCellOutputItem=mt,h=mt,g={value:new TextEncoder};class Bt{constructor(L,ne,Se){this.items=Bt.ensureUniqueMimeTypes(L,!0),typeof ne=="string"?(this.id=ne,this.metadata=Se):(this.id=(0,T.generateUuid)(),this.metadata=ne??Se)}static isNotebookCellOutput(L){return L instanceof Bt?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&(0,v.isArray)(L.items)}static ensureUniqueMimeTypes(L,ne=!1){const Se=new Set,$e=new Set;for(let Ge=0;Ge<L.length;Ge++){const Je=L[Ge],Ze=(0,k.normalizeMimeType)(Je.mime);if(!Se.has(Ze)){Se.add(Ze);continue}$e.add(Ge),ne&&console.warn(`DUPLICATED mime type '${Je.mime}' will be dropped`)}return $e.size===0?L:L.filter((Ge,Je)=>!$e.has(Je))}}e.NotebookCellOutput=Bt;var Mn;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(Mn=e.NotebookCellKind||(e.NotebookCellKind={}));var Un;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(Un=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Bn;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(Bn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var zn;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(zn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class $n{constructor(L,ne){this.text=L,this.alignment=ne}}e.NotebookCellStatusBarItem=$n;var Wn;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(Wn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class jn{constructor(L,ne=[]){this.uri=L,this.provides=(0,I.asArray)(ne)}}e.NotebookRendererScript=jn;let ln=class{constructor(L,ne){this.label=L,this.timestamp=ne}};ln=Re([_],ln),e.TimelineItem=ln;var Hn;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(Hn=e.ExtensionMode||(e.ExtensionMode={}));var qn;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(qn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Vn;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=3]="RegEx"})(Vn=e.StandardTokenType||(e.StandardTokenType={}));class xn{constructor(L,ne){this.ranges=L,this.wordPattern=ne}}e.LinkedEditingRanges=xn;class Gn{constructor(L,ne){this._port=L,this._autoForwardAction=ne}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Gn;var Kn;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(Kn=e.TestResultState||(e.TestResultState={}));var Qn;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(Qn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let cn=class{constructor(L=void 0,ne=void 0,Se=void 0){this.include=L,this.exclude=ne,this.profile=Se}};cn=Re([_],cn),e.TestRunRequest=cn;let un=x=class{constructor(L){this.message=L}static diff(L,ne,Se){const $e=new x(L);return $e.expectedOutput=ne,$e.actualOutput=Se,$e}};un=x=Re([_],un),e.TestMessage=un;let fn=class{constructor(L){this.id=L}};fn=Re([_],fn),e.TestTag=fn;let At=class{constructor(L,ne){this.covered=L,this.total=ne}};At=Re([_],At),e.CoveredCount=At;let hn=Q=class{constructor(L,ne,Se,$e){this.uri=L,this.statementCoverage=ne,this.branchCoverage=Se,this.functionCoverage=$e}static fromDetails(L,ne){const Se=new At(0,0),$e=new At(0,0),Ge=new At(0,0);for(const Ze of ne)if("branches"in Ze){Se.total+=1,Se.covered+=Ze.executionCount>0?1:0;for(const ot of Ze.branches)$e.total+=1,$e.covered+=ot.executionCount>0?1:0}else Ge.total+=1,Ge.covered+=Ze.executionCount>0?1:0;const Je=new Q(L,Se,$e.total>0?$e:void 0,Ge.total>0?Ge:void 0);return Je.detailedCoverage=ne,Je}};hn=Q=Re([_],hn),e.FileCoverage=hn;let dn=class{constructor(L,ne,Se=[]){this.executionCount=L,this.location=ne,this.branches=Se}};dn=Re([_],dn),e.StatementCoverage=dn;let mn=class{constructor(L,ne){this.executionCount=L,this.location=ne}};mn=Re([_],mn),e.BranchCoverage=mn;let gn=class{constructor(L,ne){this.executionCount=L,this.location=ne}};gn=Re([_],gn),e.FunctionCoverage=gn;var Xn;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(Xn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Yn;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(Yn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Jn;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(Jn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Zn{constructor(L,ne,Se,$e,Ge,Je){this.kind=L,this.name=ne,this.detail=Se,this.uri=$e,this.range=Ge,this.selectionRange=Je}}e.TypeHierarchyItem=Zn;class ei{constructor(L){this.uri=L}}e.TextTabInput=ei;class ti{constructor(L,ne){this.original=L,this.modified=ne}}e.TextDiffTabInput=ti;class ni{constructor(L,ne){this.uri=L,this.viewType=ne}}e.CustomEditorTabInput=ni;class ii{constructor(L){this.viewType=L}}e.WebviewEditorTabInput=ii;class ri{constructor(L,ne){this.uri=L,this.notebookType=ne}}e.NotebookEditorTabInput=ri;class si{constructor(L,ne,Se){this.original=L,this.modified=ne,this.notebookType=Se}}e.NotebookDiffEditorTabInput=si;class oi{constructor(){}}e.TerminalEditorTabInput=oi}),define(we[60],ye([0,1,67]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(P){return{transformIncoming:k=>k.scheme==="vscode-remote"?{scheme:"file",path:k.path,query:k.query,fragment:k.fragment}:k.scheme==="file"?{scheme:"vscode-local",path:k.path,query:k.query,fragment:k.fragment}:k,transformOutgoing:k=>k.scheme==="file"?{scheme:"vscode-remote",authority:P,path:k.path,query:k.query,fragment:k.fragment}:k.scheme==="vscode-local"?{scheme:"file",path:k.path,query:k.query,fragment:k.fragment}:k,transformOutgoingScheme:k=>k==="file"?"vscode-remote":k==="vscode-local"?"file":k}}function b(P){return new I.URITransformer(t(P))}e.createURITransformer=b}),define(we[237],ye([0,1,3,46,4,60,177,8,40,67,95,89,217,5,26,50]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C,y,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;class h{constructor(p,m,l,u,n,s){if(this._connectionToken=p,this._environmentService=m,this._logService=u,this._extensionHostStatusService=n,this._extensionsScannerService=s,m.args["install-builtin-extension"]){const o={isMachineScoped:!!m.args["do-not-sync"],installPreReleaseVersion:!!m.args["pre-release"]};this.whenExtensionsReady=l.installExtensions([],m.args["install-builtin-extension"],o,!!m.args.force).then(null,r=>{u.error(r)})}else this.whenExtensionsReady=Promise.resolve();const i=m.args["install-extension"];if(i){const o=i.map(r=>/\.vsix$/i.test(r)?b.URI.file((0,y.isAbsolute)(r)?r:(0,y.join)((0,d.cwd)(),r)):r);this.whenExtensionsReady.then(()=>l.installExtensions(o,[],{isMachineScoped:!!m.args["do-not-sync"],installPreReleaseVersion:!!m.args["pre-release"]},!!m.args.force)).then(null,r=>{u.error(r)})}}async call(p,m,l){switch(m){case"getEnvironmentData":{const u=l,n=(0,P.createURITransformer)(u.remoteAuthority);let s=await this._getEnvironmentData();return s=(0,D.transformOutgoingURIs)(s,n),s}case"getExtensionHostExitInfo":{const u=l;return this._extensionHostStatusService.getExitInfo(u.reconnectionToken)}case"whenExtensionsReady":{await this.whenExtensionsReady;return}case"scanExtensions":{await this.whenExtensionsReady;const u=l,n=u.language;this._logService.trace(`Scanning extensions using UI language: ${n}`);const s=(0,P.createURITransformer)(u.remoteAuthority),i=u.extensionDevelopmentPath&&u.extensionDevelopmentPath.map(a=>b.URI.revive(s.transformIncoming(a))),o=i?i.filter(a=>a.scheme===E.Schemas.file).map(a=>a.fsPath):void 0;let r=await this._scanExtensions(n,o);return r=(0,D.transformOutgoingURIs)(r,s),this._logService.trace("Scanned Extensions",r),h._massageWhenConditions(r),r}case"scanSingleExtension":{await this.whenExtensionsReady;const u=l,n=u.language,s=u.isBuiltin,i=(0,P.createURITransformer)(u.remoteAuthority),o=b.URI.revive(i.transformIncoming(u.extensionLocation)),r=o.scheme===E.Schemas.file?o.fsPath:null;if(!r)return null;let a=await this._scanSingleExtension(r,s,n);return a?(a=(0,D.transformOutgoingURIs)(a,i),h._massageWhenConditions([a]),a):null}case"getDiagnosticInfo":{const u=l,n={machineInfo:(0,C.getMachineInfo)()},s=u.includeProcesses?(0,R.listProcesses)(process.pid):Promise.resolve();let i=[];const o={};if(u.folders){const r=(0,P.createURITransformer)("");i=u.folders.map(c=>b.URI.revive(r.transformIncoming(c))).filter(c=>c.scheme==="file").map(c=>(0,C.collectWorkspaceStats)(c.fsPath,["node_modules",".git"]).then(f=>{o[(0,y.basename)(c.fsPath)]=f}))}return Promise.all([s,...i]).then(([r,a])=>(n.processes=r||void 0,n.workspaceMetadata=u.folders?o:void 0,n))}}throw new Error(`IPC Command ${m} not found`)}listen(p,m,l){throw new Error("Not supported")}static _massageWhenConditions(p){const m=(o,r)=>o.replace(/file/g,"vscode-remote"),l=o=>{let r="";return r+=o.global?"g":"",r+=o.ignoreCase?"i":"",r+=o.multiline?"m":"",new RegExp(m(o.source,!0),r)},u=new class{mapDefined(o){return T.ContextKeyDefinedExpr.create(o)}mapNot(o){return T.ContextKeyNotExpr.create(o)}mapEquals(o,r){return o==="resourceScheme"&&typeof r=="string"?T.ContextKeyEqualsExpr.create(o,m(r,!1)):T.ContextKeyEqualsExpr.create(o,r)}mapNotEquals(o,r){return o==="resourceScheme"&&typeof r=="string"?T.ContextKeyNotEqualsExpr.create(o,m(r,!1)):T.ContextKeyNotEqualsExpr.create(o,r)}mapGreater(o,r){return T.ContextKeyGreaterExpr.create(o,r)}mapGreaterEquals(o,r){return T.ContextKeyGreaterEqualsExpr.create(o,r)}mapSmaller(o,r){return T.ContextKeySmallerExpr.create(o,r)}mapSmallerEquals(o,r){return T.ContextKeySmallerEqualsExpr.create(o,r)}mapRegex(o,r){return o==="resourceScheme"&&r?T.ContextKeyRegexExpr.create(o,l(r)):T.ContextKeyRegexExpr.create(o,r)}mapIn(o,r){return T.ContextKeyInExpr.create(o,r)}},n=o=>{if(!o||!o.when||!/resourceScheme/.test(o.when))return;const r=T.ContextKeyExpr.deserialize(o.when);if(!r)return;const a=r.map(u);o.when=a.serialize()},s=o=>{if(Array.isArray(o))for(let r of o)n(r);else n(o)},i=o=>{for(let r in o)s(o[r])};p.forEach(o=>{o.contributes&&(o.contributes.menus&&i(o.contributes.menus),o.contributes.keybindings&&s(o.contributes.keybindings),o.contributes.views&&i(o.contributes.views))})}async _getEnvironmentData(){return{pid:process.pid,connectionToken:this._connectionToken.type!==0?this._connectionToken.value:"",appRoot:b.URI.file(this._environmentService.appRoot),settingsPath:this._environmentService.machineSettingsResource,logsPath:b.URI.file(this._environmentService.logsPath),extensionsPath:b.URI.file(this._environmentService.extensionsPath),extensionHostLogsPath:b.URI.file((0,y.join)(this._environmentService.logsPath,`exthost${h._namePool++}`)),globalStorageHome:this._environmentService.globalStorageHome,workspaceStorageHome:this._environmentService.workspaceStorageHome,localHistoryHome:this._environmentService.localHistoryHome,userHome:this._environmentService.userHome,os:I.OS,arch:process.arch,marks:t.getMarks(),useHostProxy:!!this._environmentService.args["use-host-proxy"]}}async _scanExtensions(p,m){const[l,u,n]=await Promise.all([this._scanBuiltinExtensions(p),this._scanInstalledExtensions(p),this._scanDevelopedExtensions(p,m)]);let s=new Map;l.forEach(o=>{!o||s.set(v.ExtensionIdentifier.toKey(o.identifier),o)}),u.forEach(o=>{!o||(s.has(v.ExtensionIdentifier.toKey(o.identifier))&&console.warn(k.localize(0,null,s.get(v.ExtensionIdentifier.toKey(o.identifier)).extensionLocation.fsPath,o.extensionLocation.fsPath)),s.set(v.ExtensionIdentifier.toKey(o.identifier),o))}),n.forEach(o=>{!o||s.set(v.ExtensionIdentifier.toKey(o.identifier),o)});const i=[];return s.forEach(o=>i.push(o)),i}async _scanDevelopedExtensions(p,m){return m?(await Promise.all(m.map(l=>this._extensionsScannerService.scanOneOrMultipleExtensions(b.URI.file((0,y.resolve)(l)),1,{language:p})))).flat().map(l=>(0,S.toExtensionDescription)(l,!0)):[]}async _scanBuiltinExtensions(p){return(await this._extensionsScannerService.scanSystemExtensions({language:p,useCache:!0})).map(l=>(0,S.toExtensionDescription)(l,!1))}async _scanInstalledExtensions(p){return(await this._extensionsScannerService.scanUserExtensions({language:p,useCache:!0})).map(l=>(0,S.toExtensionDescription)(l,!1))}async _scanSingleExtension(p,m,l){const u=b.URI.file((0,y.resolve)(p)),n=m?0:1,s=await this._extensionsScannerService.scanExistingExtension(u,n,{language:l});return s?(0,S.toExtensionDescription)(s,!1):null}}e.RemoteAgentEnvironmentChannel=h,h._namePool=1}),define(we[238],ye([0,1,4,60,58,5,203]),function(ie,e,I,t,b,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemProviderChannel=void 0;class E extends k.AbstractDiskFileSystemProviderChannel{constructor(T,R){super(new b.DiskFileSystemProvider(T),T);this.environmentService=R,this.uriTransformerCache=new Map,this._register(this.provider)}getUriTransformer(T){let R=this.uriTransformerCache.get(T.remoteAuthority);return R||(R=(0,t.createURITransformer)(T.remoteAuthority),this.uriTransformerCache.set(T.remoteAuthority,R)),R}transformIncoming(T,R,C=!1){if(C&&R.path==="/vscode-resource"&&R.query){const y=JSON.parse(R.query).requestResourcePath;return I.URI.from({scheme:"file",path:y})}return I.URI.revive(T.transformIncoming(R))}createSessionFileWatcher(T,R){return new v(T,R,this.logService,this.environmentService)}}e.RemoteAgentFileSystemProviderChannel=E;class v extends k.AbstractSessionFileWatcher{constructor(T,R,C,y){super(T,R,C,y)}getRecursiveWatcherOptions(T){const R=T.args["file-watcher-polling"];if(R){const C=R.split(P.delimiter),y=Number(C[0]);if(y>0)return{usePolling:C.length>1?C.slice(1):!0,pollingInterval:y}}}getExtraExcludes(T){if(T.extensionsPath)return[P.posix.join(T.extensionsPath,"**")]}}}),define(we[115],ye([0,1,179,12,4,2,7,34,18,17,8]),function(ie,e,I,t,b,P,k,E,v,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,I.localize)(0,null),providerDisplayName:(0,I.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var R;(function(V){V[V.PROGRAMMATIC=1]="PROGRAMMATIC",V[V.USER=2]="USER",V[V.EDIT=3]="EDIT",V[V.NAVIGATION=4]="NAVIGATION",V[V.JUMP=5]="JUMP"})(R=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var C;(function(V){V[V.IDENTICAL=1]="IDENTICAL",V[V.SIMILAR=2]="SIMILAR",V[V.DIFFERENT=3]="DIFFERENT"})(C=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function y(V){const $=V;return!!$&&typeof $.getSelection=="function"&&!!$.onDidChangeSelection}e.isEditorPaneWithSelection=y;function d(V,$,F){for(const M of F.visibleEditorPanes)if(M.group.id===$&&V.matches(M.input))return M.getViewState()}e.findViewStateForEditor=d;function S(V){if(i(V))return!1;const $=V;return b.URI.isUri($?.resource)}e.isResourceEditorInput=S;function h(V){if(i(V))return!1;const $=V;return $?.original!==void 0&&$.modified!==void 0}e.isResourceDiffEditorInput=h;function g(V){if(i(V)||h(V))return!1;const $=V;return $?.primary!==void 0&&$.secondary!==void 0}e.isResourceSideBySideEditorInput=g;function p(V){if(i(V))return!1;const $=V;return $?$.resource===void 0||$.resource.scheme===T.Schemas.untitled||$.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=p;var m;(function(V){V[V.SHORT=0]="SHORT",V[V.MEDIUM=1]="MEDIUM",V[V.LONG=2]="LONG"})(m=e.Verbosity||(e.Verbosity={}));var l;(function(V){V[V.EXPLICIT=1]="EXPLICIT",V[V.AUTO=2]="AUTO",V[V.FOCUS_CHANGE=3]="FOCUS_CHANGE",V[V.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l=e.SaveReason||(e.SaveReason={}));class u{constructor(){this.mapIdToSaveSource=new Map}registerSource($,F){let M=this.mapIdToSaveSource.get($);return M||(M={source:$,label:F},this.mapIdToSaveSource.set($,M)),M.source}getSourceLabel($){return this.mapIdToSaveSource.get($)?.label??$}}e.SaveSourceRegistry=new u;var n;(function(V){V[V.None=0]="None",V[V.Readonly=2]="Readonly",V[V.Untitled=4]="Untitled",V[V.Singleton=8]="Singleton",V[V.RequiresTrust=16]="RequiresTrust",V[V.CanSplitInGroup=32]="CanSplitInGroup",V[V.ForceDescription=64]="ForceDescription",V[V.CanDropIntoEditor=128]="CanDropIntoEditor"})(n=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class s extends P.Disposable{}e.AbstractEditorInput=s;function i(V){return V instanceof s}e.isEditorInput=i;function o(V){const $=V;return b.URI.isUri($?.preferredResource)}function r(V){const $=V;return i($?.primary)&&i($?.secondary)}e.isSideBySideEditorInput=r;function a(V){const $=V;return i($?.modified)&&i($?.original)}e.isDiffEditorInput=a;function c(V){return i(V?.editor)}e.isEditorInputWithOptions=c;function f(V){const $=V;return c(V)&&$?.group!==void 0}e.isEditorInputWithOptionsAndGroup=f;function w(V){const $=V;return typeof $?.groupId=="number"&&i($.editor)}e.isEditorIdentifier=w;var A;(function(V){V[V.UNKNOWN=0]="UNKNOWN",V[V.REPLACE=1]="REPLACE",V[V.MOVE=2]="MOVE",V[V.UNPIN=3]="UNPIN"})(A=e.EditorCloseContext||(e.EditorCloseContext={}));var U;(function(V){V[V.GROUP_ACTIVE=0]="GROUP_ACTIVE",V[V.GROUP_INDEX=1]="GROUP_INDEX",V[V.GROUP_LOCKED=2]="GROUP_LOCKED",V[V.EDITOR_OPEN=3]="EDITOR_OPEN",V[V.EDITOR_CLOSE=4]="EDITOR_CLOSE",V[V.EDITOR_MOVE=5]="EDITOR_MOVE",V[V.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",V[V.EDITOR_LABEL=7]="EDITOR_LABEL",V[V.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",V[V.EDITOR_PIN=9]="EDITOR_PIN",V[V.EDITOR_STICKY=10]="EDITOR_STICKY",V[V.EDITOR_DIRTY=11]="EDITOR_DIRTY",V[V.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(U=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var x;(function(V){V[V.PRIMARY=1]="PRIMARY",V[V.SECONDARY=2]="SECONDARY",V[V.BOTH=3]="BOTH",V[V.ANY=4]="ANY"})(x=e.SideBySideEditor||(e.SideBySideEditor={}));class Q{getOriginalUri($,F){if(!$)return;if(F?.supportSideBySide){const{primary:j,secondary:Z}=this.getSideEditors($);if(j&&Z){if(F?.supportSideBySide===x.BOTH)return{primary:this.getOriginalUri(j,{filterByScheme:F.filterByScheme}),secondary:this.getOriginalUri(Z,{filterByScheme:F.filterByScheme})};if(F?.supportSideBySide===x.ANY)return this.getOriginalUri(j,{filterByScheme:F.filterByScheme})??this.getOriginalUri(Z,{filterByScheme:F.filterByScheme});$=F.supportSideBySide===x.PRIMARY?j:Z}}if(h($)||g($))return;const M=o($)?$.preferredResource:$.resource;return!M||!F||!F.filterByScheme?M:this.filterUri(M,F.filterByScheme)}getSideEditors($){return r($)||g($)?{primary:$.primary,secondary:$.secondary}:a($)||h($)?{primary:$.modified,secondary:$.original}:{primary:void 0,secondary:void 0}}getCanonicalUri($,F){if(!$)return;if(F?.supportSideBySide){const{primary:j,secondary:Z}=this.getSideEditors($);if(j&&Z){if(F?.supportSideBySide===x.BOTH)return{primary:this.getCanonicalUri(j,{filterByScheme:F.filterByScheme}),secondary:this.getCanonicalUri(Z,{filterByScheme:F.filterByScheme})};if(F?.supportSideBySide===x.ANY)return this.getCanonicalUri(j,{filterByScheme:F.filterByScheme})??this.getCanonicalUri(Z,{filterByScheme:F.filterByScheme});$=F.supportSideBySide===x.PRIMARY?j:Z}}if(h($)||g($))return;const M=$.resource;return!M||!F||!F.filterByScheme?M:this.filterUri(M,F.filterByScheme)}filterUri($,F){if(Array.isArray(F)){if(F.some(M=>$.scheme===M))return $}else if(F===$.scheme)return $}}e.EditorResourceAccessor=new Q;var _;(function(V){V[V.LEFT=0]="LEFT",V[V.RIGHT=1]="RIGHT"})(_=e.CloseDirection||(e.CloseDirection={}));class Y{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start($){const F=this.instantiationService=$.get(k.IInstantiationService);for(const[M,j]of this.editorSerializerConstructors)this.createEditorSerializer(M,j,F);this.editorSerializerConstructors.clear()}createEditorSerializer($,F,M){const j=M.createInstance(F);this.editorSerializerInstances.set($,j)}registerFileEditorFactory($){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=$}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer($,F){if(this.editorSerializerConstructors.has($)||this.editorSerializerInstances.has($))throw new Error(`A editor serializer with type ID '${$}' was already registered.`);return this.instantiationService?this.createEditorSerializer($,F,this.instantiationService):this.editorSerializerConstructors.set($,F),(0,P.toDisposable)(()=>{this.editorSerializerConstructors.delete($),this.editorSerializerInstances.delete($)})}getEditorSerializer($){return this.editorSerializerInstances.get(typeof $=="string"?$:$.typeId)}}E.Registry.add(e.EditorExtensions.EditorFactory,new Y);async function O(V,$){if(!V||!V.length)return[];const F=await Promise.all(V.map(async M=>{const j=b.URI.revive(M.fileUri);if(!j||!await $.canHandleResource(j))return;let oe=M.exists,ge=M.type;if(typeof oe!="boolean"||typeof ge!="number")try{ge=(await $.stat(j)).isDirectory?v.FileType.Directory:v.FileType.Unknown,oe=!0}catch{oe=!1}if(!oe&&M.openOnlyIfExists||ge===v.FileType.Directory)return;const he={...M.options,pinned:!0};let q;return oe?q={resource:j,options:he}:q={resource:j,options:he,forceUntitled:!0},q}));return(0,D.coalesce)(F)}e.pathsToEditors=O;var B;(function(V){V[V.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",V[V.SEQUENTIAL=1]="SEQUENTIAL"})(B=e.EditorsOrder||(e.EditorsOrder={}));function ue(V){const $=V;if(!$)return!1;const F=$;if(F.modified)return ue(F.modified);const M=$;return!!(M.contributionsState&&M.viewState&&Array.isArray(M.cursorState))}e.isTextEditorViewState=ue}),define(we[239],ye([0,1,66,43,64,8,5,3,95]),function(ie,e,I,t,b,P,k,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var D;(function(r){r[r.Markup=1]="Markup",r[r.Code=2]="Code"})(D=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",b.Mimes.latex,b.Mimes.markdown,"image/png","image/jpeg",b.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[b.Mimes.latex,b.Mimes.markdown,"application/json",b.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var T;(function(r){r[r.Running=1]="Running",r[r.Idle=2]="Idle"})(T=e.NotebookRunState||(e.NotebookRunState={}));var R;(function(r){r[r.Unconfirmed=1]="Unconfirmed",r[r.Pending=2]="Pending",r[r.Executing=3]="Executing"})(R=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var C;(function(r){r[r.WithHardKernelDependency=0]="WithHardKernelDependency",r[r.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",r[r.Pure=2]="Pure",r[r.Never=3]="Never"})(C=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var y;(function(r){r.Always="always",r.Never="never",r.Optional="optional"})(y=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var d;(function(r){r[r.ModelChange=1]="ModelChange",r[r.Move=2]="Move",r[r.ChangeCellLanguage=5]="ChangeCellLanguage",r[r.Initialize=6]="Initialize",r[r.ChangeCellMetadata=7]="ChangeCellMetadata",r[r.Output=8]="Output",r[r.OutputItem=9]="OutputItem",r[r.ChangeCellContent=10]="ChangeCellContent",r[r.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",r[r.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",r[r.ChangeCellMime=13]="ChangeCellMime",r[r.Unknown=100]="Unknown"})(d=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var S;(function(r){r[r.Handle=0]="Handle",r[r.Index=1]="Index"})(S=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(r){r[r.Replace=1]="Replace",r[r.Output=2]="Output",r[r.Metadata=3]="Metadata",r[r.CellLanguage=4]="CellLanguage",r[r.DocumentMetadata=5]="DocumentMetadata",r[r.Move=6]="Move",r[r.OutputItems=7]="OutputItems",r[r.PartialMetadata=8]="PartialMetadata",r[r.PartialInternalMetadata=9]="PartialInternalMetadata"})(h=e.CellEditType||(e.CellEditType={}));var g;(function(r){r.scheme=P.Schemas.vscodeNotebookCell;const a=/^ch(\d{7,})/;function c(Q,_){return Q.with({scheme:r.scheme,fragment:`ch${_.toString().padStart(7,"0")}${Q.scheme!==P.Schemas.file?Q.scheme:""}`})}r.generate=c;function f(Q){if(Q.scheme!==r.scheme)return;const _=a.exec(Q.fragment);return _?{handle:Number(_[1]),notebook:Q.with({scheme:Q.fragment.substring(_[0].length)||P.Schemas.file,fragment:null})}:void 0}r.parse=f;function w(Q,_){return Q.with({scheme:P.Schemas.vscodeNotebookCellOutput,fragment:`op${_??""},${Q.scheme!==P.Schemas.file?Q.scheme:""}`})}r.generateCellOutputUri=w;function A(Q){if(Q.scheme!==P.Schemas.vscodeNotebookCellOutput)return;const _=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Q.fragment);if(!_)return;const Y=_[1]&&_[1]!==""?_[1]:void 0,O=_[2];return{outputId:Y,notebook:Q.with({scheme:O||P.Schemas.file,fragment:null})}}r.parseCellOutputUri=A;function U(Q,_,Y){return Q.with({scheme:Y,fragment:`ch${_.toString().padStart(7,"0")}${Q.scheme!==P.Schemas.file?Q.scheme:""}`})}r.generateCellUri=U;function x(Q,_){if(Q.scheme!==_)return;const Y=a.exec(Q.fragment);return Y?{handle:Number(Y[1]),notebook:Q.with({scheme:Q.fragment.substring(Y[0].length)||P.Schemas.file,fragment:null})}:void 0}r.parseCellUri=x})(g=e.CellUri||(e.CellUri={}));const p=r=>E.isWindows?r.replace(/\//g,"\\"):r;class m{constructor(a=[],c=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=c,this.order=[...new Set(a)].map(f=>({pattern:f,matches:I.parse(p(f))}))}sort(a){const c=new Map(t.Iterable.map(a,w=>[w,p(w)]));let f=[];for(const{matches:w}of this.order)for(const[A,U]of c)if(w(U)){f.push(A),c.delete(A);break}return c.size&&(f=f.concat([...c.keys()].sort((w,A)=>this.defaultOrder.indexOf(w)-this.defaultOrder.indexOf(A)))),f}prioritize(a,c){const f=this.findIndex(a);if(f===-1){this.order.unshift({pattern:a,matches:I.parse(p(a))});return}const w=new Set(c.map(U=>this.findIndex(U,f)));w.delete(-1);const A=Array.from(w).sort();this.order.splice(f+1,0,...A.map(U=>this.order[U]));for(let U=A.length-1;U>=0;U--)this.order.splice(A[U],1)}toArray(){return this.order.map(a=>a.pattern)}findIndex(a,c=this.order.length){const f=p(a);for(let w=0;w<c;w++)if(this.order[w].matches(f))return w;return-1}}e.MimeTypeDisplayOrder=m;function l(r,a,c,f=(w,A)=>w===A){const w=[];function A(Q,_,Y){if(_===0&&Y.length===0)return;const O=w[w.length-1];O&&O.start+O.deleteCount===Q?(O.deleteCount+=_,O.toInsert.push(...Y)):w.push({start:Q,deleteCount:_,toInsert:Y})}let U=0,x=0;for(;;){if(U===r.length){A(U,0,a.slice(x));break}if(x===a.length){A(U,r.length-U,[]);break}const Q=r[U],_=a[x];if(f(Q,_)){U+=1,x+=1;continue}c(_)?(A(U,1,[]),U+=1):(A(U,0,[_]),x+=1)}return w}e.diff=l,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new v.RawContextKey("notebookEditorCursorAtBoundary","none");var u;(function(r){r.default="default",r.option="option"})(u=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function n(r){const a=r;return!!((typeof a.include=="string"||I.isRelativePattern(a.include))&&(typeof a.exclude=="string"||I.isRelativePattern(a.exclude)))}e.isDocumentExcludePattern=n;function s(r,a,c){if(Array.isArray(r.viewType)&&r.viewType.indexOf(a)>=0||r.viewType===a)return!0;if(r.filenamePattern){const f=n(r.filenamePattern)?r.filenamePattern.include:r.filenamePattern,w=n(r.filenamePattern)?r.filenamePattern.exclude:void 0;if(I.match(f,(0,k.basename)(c.fsPath).toLowerCase()))return!(w&&I.match(w,(0,k.basename)(c.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",interactiveWindowAlwaysScrollOnNewCell:"interactiveWindow.alwaysScrollOnNewCell"};var i;(function(r){r[r.Left=1]="Left",r[r.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class o{static create(a){return`${o._prefix}${a}`}static parse(a){if(a.startsWith(o._prefix))return a.substring(o._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=o,o._prefix="notebook/"}),define(we[116],ye([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,I.createDecorator)("environmentVariableService");var t;(function(b){b[b.Replace=1]="Replace",b[b.Append=2]="Append",b[b.Prepend=3]="Prepend"})(t=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(we[240],ye([0,1,3,116]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class b{constructor(v){this.map=new Map,v.forEach((D,T)=>{const R=D.map.entries();let C=R.next();for(;!C.done;){const y=C.value[0];let d=this.map.get(y);if(d||(d=[],this.map.set(y,d)),d.length>0&&d[0].type===t.EnvironmentVariableMutatorType.Replace){C=R.next();continue}const S=C.value[1];d.unshift({extensionIdentifier:T,value:S.value,type:S.type}),C=R.next()}})}async applyToProcessEnvironment(v,D){let T;I.isWindows&&(T={},Object.keys(v).forEach(R=>T[R.toLowerCase()]=R));for(const[R,C]of this.map){const y=I.isWindows&&T[R.toLowerCase()]||R;for(const d of C){const S=D?await D(d.value):d.value;switch(d.type){case t.EnvironmentVariableMutatorType.Append:v[y]=(v[y]||"")+S;break;case t.EnvironmentVariableMutatorType.Prepend:v[y]=S+(v[y]||"");break;case t.EnvironmentVariableMutatorType.Replace:v[y]=S;break}}}}diff(v){const D=new Map,T=new Map,R=new Map;if(v.map.forEach((C,y)=>{const d=this.map.get(y),S=P(C,d);S&&D.set(y,S)}),this.map.forEach((C,y)=>{const d=v.map.get(y),S=P(C,d);S&&R.set(y,S)}),this.map.forEach((C,y)=>{const d=v.map.get(y),S=k(C,d);S&&T.set(y,S)}),!(D.size===0&&T.size===0&&R.size===0))return{added:D,changed:T,removed:R}}}e.MergedEnvironmentVariableCollection=b;function P(E,v){if(!v)return E;const D=new Set;v.forEach(R=>D.add(R.extensionIdentifier));const T=[];return E.forEach(R=>{D.has(R.extensionIdentifier)||T.push(R)}),T.length===0?void 0:T}function k(E,v){if(!v)return;const D=new Map;v.forEach(R=>D.set(R.extensionIdentifier,R));const T=[];return E.forEach(R=>{const C=D.get(R.extensionIdentifier);C&&(R.type!==C.type||R.value!==C.value)&&T.push(C)}),T.length===0?void 0:T}}),define(we[117],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function I(b){return[...b.entries()]}e.serializeEnvironmentVariableCollection=I;function t(b){return new Map(b)}e.deserializeEnvironmentVariableCollection=t}),define(we[241],ye([0,1,5,53,3]),function(ie,e,I,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function P(l,u){if(!!u)if(b.isWindows)for(const n in u){let s=n;for(const o in l)if(n.toLowerCase()===o.toLowerCase()){s=o;break}const i=u[n];i!==void 0&&k(l,s,i)}else Object.keys(u).forEach(n=>{const s=u[n];s!==void 0&&k(l,n,s)})}e.mergeEnvironments=P;function k(l,u,n){typeof n=="string"?l[u]=n:delete l[u]}function E(l,u,n,s){l.TERM_PROGRAM="vscode",u&&(l.TERM_PROGRAM_VERSION=u),T(l,s)&&(l.LANG=R(n)),l.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=E;function v(l,u){if(!!u)for(const n of Object.keys(u)){const s=u[n];s&&(l[n]=s)}}async function D(l,u){return await Promise.all(Object.entries(u).map(async([n,s])=>{if(typeof s=="string")try{u[n]=await l(s)}catch{u[n]=s}})),u}function T(l,u){if(u==="on")return!0;if(u==="auto"){const n=l.LANG;return!n||n.search(/\.UTF\-8$/)===-1&&n.search(/\.utf8$/)===-1&&n.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=T;function R(l){const u=l?l.split("-"):[],n=u.length;if(n===0)return"en_US.UTF-8";if(n===1){const s={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};u[0]in s&&u.push(s[u[0]])}else u[1]=u[1].toUpperCase();return u.join("_")+".UTF-8"}e.getLangEnvVariable=R;async function C(l,u,n,s,i,o){if(l.cwd){const a=typeof l.cwd=="object"?l.cwd.fsPath:l.cwd,c=await y(a,n);return d(c||a)}let r;return!l.ignoreConfigurationCwd&&i&&(n&&(i=await y(i,n,o)),i&&(I.isAbsolute(i)?r=i:s&&(r=I.join(s.fsPath,i)))),r||(r=s?s.fsPath:u||""),d(r)}e.getCwd=C;async function y(l,u,n){if(u)try{return await u(l)}catch(s){n?.error("Could not resolve terminal cwd",s);return}return l}function d(l){return b.OS===1&&l&&l[1]===":"?l[0].toUpperCase()+l.substr(1):l}function S(l,u,n){if(!!n)return s=>n.resolveWithEnvironment(u,l,s)}e.createVariableResolver=S;async function h(l,u,n,s,i,o,r,a=b.platform){let c;r&&(c=p(l,"automationShell",a)),c||(c=p(l,"shell",a));let f=c||u;if(a===3&&!n&&s){const w=I.join(s,"Sysnative").replace(/\//g,"\\").toLowerCase();f&&f.toLowerCase().indexOf(w)===0&&(f=I.join(s,"System32",f.substr(w.length+1)))}if(f&&a===3&&(f=f.replace(/\//g,"\\")),i)try{f=await i(f)}catch(w){o.error("Could not resolve shell",w)}return f}e.getDefaultShell=h;async function g(l,u,n,s,i=b.platform){if(u&&p(l,"automationShell",i))return[];const o=i===3?"windows":i===1?"osx":"linux";let r=l(`terminal.integrated.shellArgs.${o}`);if(!r)return[];if(typeof r=="string"&&i===3)return n?await n(r):r;if(n){const a=[];for(const c of r)try{a.push(await n(c))}catch(f){s.error(`Could not resolve terminal.integrated.shellArgs.${o}`,f),a.push(c)}r=a}return r}e.getDefaultShellArgs=g;function p(l,u,n=b.platform){return l(`terminal.integrated.${u}.${n===3?"windows":n===1?"osx":"linux"}`)}async function m(l,u,n,s,i,o){const r={};if(l.strictEnv)v(r,l.env);else{v(r,o);const a={...u};n&&(a&&await D(n,a),l.env&&await D(n,l.env)),(0,t.sanitizeProcessEnvironment)(r,"VSCODE_IPC_HOOK_CLI"),P(r,a),P(r,l.env),E(r,s,b.locale,i)}return r}e.createTerminalEnvironment=m}),define(we[78],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var I;(function(P){P.Delimiter="\0"})(I=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class b{constructor(k,E=k.length){if(this.path=k,this.viewEnd=E,k.length===0||E<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(k,E,v=k.parent){if(k.id===E)return new b([E]);let D=[k.id];for(let T=v;T&&T.id!==E;T=T.parent)D.push(T.id);return D.push(E),new b(D.reverse())}static isRoot(k){return!k.includes("\0")}static root(k){const E=k.indexOf("\0");return E===-1?k:k.slice(0,E)}static fromString(k){return new b(k.split("\0"))}static join(k,E){return new b([...k.path,E])}static joinToString(k,E){return k.toString()+"\0"+E}static compare(k,E){return k===E?0:E.startsWith(k+"\0")?2:k.startsWith(E+"\0")?3:1}get parentId(){return this.viewEnd>1?new b(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let k=1;k<=this.viewEnd;k++)yield new b(this.path,k)}compare(k){if(typeof k=="string")return b.compare(this.toString(),k);for(let E=0;E<k.viewEnd&&E<this.viewEnd;E++)if(k.path[E]!==this.path[E])return 1;return k.viewEnd>this.viewEnd?2:k.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let k=1;k<this.viewEnd;k++)this.stringifed+="\0",this.stringifed+=this.path[k]}return this.stringifed}}e.TestId=b}),define(we[79],ye([0,1,4,47]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var b;(function(r){r[r.Unset=0]="Unset",r[r.Queued=1]="Queued",r[r.Running=2]="Running",r[r.Passed=3]="Passed",r[r.Failed=4]="Failed",r[r.Skipped=5]="Skipped",r[r.Errored=6]="Errored"})(b=e.TestResultState||(e.TestResultState={}));var P;(function(r){r[r.Run=2]="Run",r[r.Debug=4]="Debug",r[r.Coverage=8]="Coverage",r[r.HasNonDefaultProfile=16]="HasNonDefaultProfile",r[r.HasConfigurable=32]="HasConfigurable"})(P=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var k;(function(r){r.serialize=a=>({range:a.range.toJSON(),uri:a.uri.toJSON()}),r.deserialize=a=>({range:t.Range.lift(a.range),uri:I.URI.revive(a.uri)})})(k=e.IRichLocation||(e.IRichLocation={}));var E;(function(r){r[r.Error=0]="Error",r[r.Output=1]="Output"})(E=e.TestMessageType||(e.TestMessageType={}));var v;(function(r){r.serialize=a=>({message:a.message,type:0,expected:a.expected,actual:a.actual,location:a.location&&k.serialize(a.location)}),r.deserialize=a=>({message:a.message,type:0,expected:a.expected,actual:a.actual,location:a.location&&k.deserialize(a.location)})})(v=e.ITestErrorMessage||(e.ITestErrorMessage={}));var D;(function(r){r.serialize=a=>({message:a.message,type:1,offset:a.offset,location:a.location&&k.serialize(a.location)}),r.deserialize=a=>({message:a.message,type:1,offset:a.offset,location:a.location&&k.deserialize(a.location)})})(D=e.ITestOutputMessage||(e.ITestOutputMessage={}));var T;(function(r){r.serialize=a=>a.type===0?v.serialize(a):D.serialize(a),r.deserialize=a=>a.type===0?v.deserialize(a):D.deserialize(a)})(T=e.ITestMessage||(e.ITestMessage={}));var R;(function(r){r.serialize=a=>({state:a.state,duration:a.duration,messages:a.messages.map(T.serialize)}),r.deserialize=a=>({state:a.state,duration:a.duration,messages:a.messages.map(T.deserialize)})})(R=e.ITestTaskState||(e.ITestTaskState={}));const C="\0",y=(r,a)=>r+C+a;e.namespaceTestTag=y;const d=r=>{const a=r.indexOf(C);return{ctrlId:r.slice(0,a),tagId:r.slice(a+1)}};e.denamespaceTestTag=d;var S;(function(r){r.serialize=a=>({extId:a.extId,label:a.label,tags:a.tags,busy:a.busy,children:void 0,uri:a.uri?.toJSON(),range:a.range?.toJSON()||null,description:a.description,error:a.error,sortText:a.sortText}),r.deserialize=a=>({extId:a.extId,label:a.label,tags:a.tags,busy:a.busy,children:void 0,uri:a.uri?I.URI.revive(a.uri):void 0,range:a.range?t.Range.lift(a.range):null,description:a.description,error:a.error,sortText:a.sortText})})(S=e.ITestItem||(e.ITestItem={}));var h;(function(r){r[r.NotExpandable=0]="NotExpandable",r[r.Expandable=1]="Expandable",r[r.BusyExpanding=2]="BusyExpanding",r[r.Expanded=3]="Expanded"})(h=e.TestItemExpandState||(e.TestItemExpandState={}));var g;(function(r){r.serialize=a=>({controllerId:a.controllerId,expand:a.expand,parent:a.parent,item:S.serialize(a.item)}),r.deserialize=a=>({controllerId:a.controllerId,expand:a.expand,parent:a.parent,item:S.deserialize(a.item)})})(g=e.InternalTestItem||(e.InternalTestItem={}));var p;(function(r){r.serialize=a=>{let c;return a.item&&(c={},a.item.label!==void 0&&(c.label=a.item.label),a.item.tags!==void 0&&(c.tags=a.item.tags),a.item.busy!==void 0&&(c.busy=a.item.busy),a.item.uri!==void 0&&(c.uri=a.item.uri?.toJSON()),a.item.range!==void 0&&(c.range=a.item.range?.toJSON()),a.item.description!==void 0&&(c.description=a.item.description),a.item.error!==void 0&&(c.error=a.item.error),a.item.sortText!==void 0&&(c.sortText=a.item.sortText)),{extId:a.extId,expand:a.expand,item:c}},r.deserialize=a=>{let c;return a.item&&(c={},a.item.label!==void 0&&(c.label=a.item.label),a.item.tags!==void 0&&(c.tags=a.item.tags),a.item.busy!==void 0&&(c.busy=a.item.busy),a.item.range!==void 0&&(c.range=a.item.range?t.Range.lift(a.item.range):null),a.item.description!==void 0&&(c.description=a.item.description),a.item.error!==void 0&&(c.error=a.item.error),a.item.sortText!==void 0&&(c.sortText=a.item.sortText)),{extId:a.extId,expand:a.expand,item:c}}})(p=e.ITestItemUpdate||(e.ITestItemUpdate={}));const m=(r,a)=>{a.expand!==void 0&&(r.expand=a.expand),a.item!==void 0&&(r.item=r.item?Object.assign(r.item,a.item):a.item)};e.applyTestItemUpdate=m;var l;(function(r){r.serialize=(a,c)=>({...g.serialize(a),children:c,ownComputedState:a.ownComputedState,computedState:a.computedState,tasks:a.tasks.map(R.serialize)})})(l=e.TestResultItem||(e.TestResultItem={}));var u;(function(r){r[r.Function=0]="Function",r[r.Statement=1]="Statement"})(u=e.DetailType||(e.DetailType={}));var n;(function(r){r[r.Add=0]="Add",r[r.Update=1]="Update",r[r.Remove=2]="Remove",r[r.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",r[r.Retire=4]="Retire",r[r.AddTag=5]="AddTag",r[r.RemoveTag=6]="RemoveTag"})(n=e.TestDiffOpType||(e.TestDiffOpType={}));var s;(function(r){r.deserialize=a=>a.op===0?{op:a.op,item:g.deserialize(a.item)}:a.op===1?{op:a.op,item:p.deserialize(a.item)}:a,r.serialize=a=>a.op===0?{op:a.op,item:g.serialize(a.item)}:a.op===1?{op:a.op,item:p.serialize(a.item)}:a})(s=e.TestsDiffOp||(e.TestsDiffOp={}));class i{add(a){}update(a){}remove(a,c){}complete(){}}e.IncrementalChangeCollector=i;class o{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(a){const c=this.createChangeCollector();for(const f of a)switch(f.op){case 0:{const w=g.deserialize(f.item);if(w.parent){if(this.items.has(w.parent)){const A=this.items.get(w.parent);A.children.add(w.item.extId);const U=this.createItem(w,A);this.items.set(w.item.extId,U),c.add(U)}}else{const A=this.createItem(w);this.roots.add(A),this.items.set(w.item.extId,A),c.add(A)}w.expand===2&&this.busyControllerCount++;break}case 1:{const w=p.deserialize(f.item),A=this.items.get(w.extId);if(!A)break;w.expand!==void 0&&(A.expand===2&&this.busyControllerCount--,w.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(A,w),c.update(A);break}case 2:{const w=this.items.get(f.itemId);if(!w)break;w.parent?this.items.get(w.parent).children.delete(w.item.extId):this.roots.delete(w);const A=[[f.itemId]];for(;A.length;)for(const U of A.pop()){const x=this.items.get(U);x&&(A.push(x.children),this.items.delete(U),c.remove(x,x!==w),x.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(f.itemId);break;case 3:this.updatePendingRoots(f.amount);break;case 5:this._tags.set(f.tag.id,f.tag);break;case 6:this._tags.delete(f.id);break}c.complete()}retireTest(a){}updatePendingRoots(a){this.pendingRootCount+=a}createChangeCollector(){return new i}}e.AbstractIncrementalTestCollection=o}),define(we[118],ye([0,1,14,6,2,12,79,78]),function(ie,e,I,t,b,P,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var v;(function(g){g[g.Upsert=0]="Upsert",g[g.SetTags=1]="SetTags",g[g.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",g[g.RemoveChild=3]="RemoveChild",g[g.SetProp=4]="SetProp",g[g.Bulk=5]="Bulk"})(v=e.TestItemEventOp||(e.TestItemEventOp={}));const D=(g,p)=>g===p,T={range:(g,p)=>g===p?!0:!g||!p?!1:g.equalsRange(p),busy:D,label:D,description:D,error:D,tags:(g,p)=>!(g.length!==p.length||g.some(m=>!p.includes(m)))},R=(g,p)=>{let m;for(const[l,u]of Object.entries(T))u(g[l],p[l])||(m?m[l]=p[l]:m={[l]:p[l]});return m};class C extends b.Disposable{constructor(p){super();this.options=p,this.debounceSendDiff=this._register(new I.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}get root(){return this.options.root}set resolveHandler(p){this._resolveHandler=p;for(const m of this.tree.values())this.updateExpandability(m)}collectDiff(){const p=this.diff;return this.diff=[],p}pushDiff(p){const m=this.diff[this.diff.length-1];if(m&&p.op===1){if(m.op===1&&m.item.extId===p.item.extId){(0,k.applyTestItemUpdate)(m.item,p.item);return}if(m.op===0&&m.item.item.extId===p.item.extId){(0,k.applyTestItemUpdate)(m.item,p.item);return}}this.diff.push(p),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(p,m){const l=this.tree.get(p);if(!!l){if((l.expandLevels===void 0||m>l.expandLevels)&&(l.expandLevels=m),l.expand===1){const u=this.resolveChildren(l);return u.isOpen()?this.expandChildren(l,m-1):u.wait().then(()=>this.expandChildren(l,m-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.expandChildren(l,m-1)):this.expandChildren(l,m-1)}}dispose(){for(const p of this.tree.values())this.options.getApiFor(p.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(p,m){switch(m.op){case 3:this.removeItem(E.TestId.joinToString(p.fullId,m.id));break;case 0:this.upsertItem(m.item,p);break;case 5:for(const l of m.ops)this.onTestItemEvent(p,l);break;case 1:this.diffTagRefs(m.new,m.old,p.fullId.toString());break;case 2:this.updateExpandability(p);break;case 4:this.pushDiff({op:1,item:{extId:p.fullId.toString(),item:m.update}});break;default:(0,P.assertNever)(m)}}upsertItem(p,m){const l=E.TestId.fromExtHostTestItem(p,this.root.id,m?.actual),u=this.options.getApiFor(p);u.parent&&u.parent!==m?.actual&&this.options.getChildren(u.parent).delete(p.id);let n=this.tree.get(l.toString());if(!n){n={fullId:l,actual:p,parent:m?l.parentId:null,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},p.tags.forEach(this.incrementTagRefs,this),this.tree.set(n.fullId.toString(),n),this.setItemParent(p,m),this.pushDiff({op:0,item:{parent:n.parent&&n.parent.toString(),controllerId:this.options.controllerId,expand:n.expand,item:this.options.toITestItem(p)}}),this.connectItemAndChildren(p,n,m);return}if(n.actual===p){this.connectItem(p,n,m);return}const s=this.options.getChildren(n.actual),i=n.actual,o=R(this.options.toITestItem(i),this.options.toITestItem(p));this.options.getApiFor(i).listener=void 0,n.actual=p,n.expand=0,o&&(o.hasOwnProperty("tags")&&(this.diffTagRefs(p.tags,i.tags,l.toString()),delete o.tags),this.onTestItemEvent(n,{op:4,update:o})),this.connectItemAndChildren(p,n,m);for(const r of s)this.options.getChildren(p).get(r.id)||this.removeItem(E.TestId.joinToString(l,r.id))}diffTagRefs(p,m,l){const u=new Set(m.map(n=>n.id));for(const n of p)u.delete(n.id)||this.incrementTagRefs(n);this.pushDiff({op:1,item:{extId:l,item:{tags:p.map(n=>(0,k.namespaceTestTag)(this.options.controllerId,n.id))}}}),u.forEach(this.decrementTagRefs,this)}incrementTagRefs(p){const m=this.tags.get(p.id);m?m.refCount++:(this.tags.set(p.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,k.namespaceTestTag)(this.options.controllerId,p.id)}}))}decrementTagRefs(p){const m=this.tags.get(p);m&&!--m.refCount&&(this.tags.delete(p),this.pushDiff({op:6,id:(0,k.namespaceTestTag)(this.options.controllerId,p)}))}setItemParent(p,m){this.options.getApiFor(p).parent=m&&m.actual!==this.root?m.actual:void 0}connectItem(p,m,l){this.setItemParent(p,l);const u=this.options.getApiFor(p);u.parent=l?.actual,u.listener=n=>this.onTestItemEvent(m,n),this.updateExpandability(m)}connectItemAndChildren(p,m,l){this.connectItem(p,m,l);for(const u of this.options.getChildren(p))this.upsertItem(u,m)}updateExpandability(p){let m;this._resolveHandler?p.resolveBarrier?m=p.resolveBarrier.isOpen()?3:2:m=p.actual.canResolveChildren?1:0:m=0,m!==p.expand&&(p.expand=m,this.pushDiff({op:1,item:{extId:p.fullId.toString(),expand:m}}),m===1&&p.expandLevels!==void 0&&this.resolveChildren(p))}expandChildren(p,m){if(m<0)return;const l=[];for(const u of this.options.getChildren(p.actual)){const n=this.expand(E.TestId.joinToString(p.fullId,u.id),m);(0,I.isThenable)(n)&&l.push(n)}if(l.length)return Promise.all(l).then(()=>{})}resolveChildren(p){if(p.resolveBarrier)return p.resolveBarrier;if(!this._resolveHandler){const n=new I.Barrier;return n.open(),n}p.expand=2,this.pushExpandStateUpdate(p);const m=p.resolveBarrier=new I.Barrier,l=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,n)};let u;try{u=this._resolveHandler(p.actual===this.root?void 0:p.actual)}catch(n){l(n)}return(0,I.isThenable)(u)?u.catch(l).then(()=>{m.open(),this.updateExpandability(p)}):(m.open(),this.updateExpandability(p)),p.resolveBarrier}pushExpandStateUpdate(p){this.pushDiff({op:1,item:{extId:p.fullId.toString(),expand:p.expand}})}removeItem(p){const m=this.tree.get(p);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:p});const l=[m];for(;l.length;){const u=l.pop();if(!!u){this.options.getApiFor(u.actual).listener=void 0;for(const n of u.actual.tags)this.decrementTagRefs(n.id);this.tree.delete(u.fullId.toString());for(const n of this.options.getChildren(u.actual))l.push(this.tree.get(E.TestId.joinToString(u.fullId,n.id)))}}}flushDiff(){const p=this.collectDiff();p.length&&this.diffOpEmitter.fire(p)}}e.TestItemCollection=C;class y extends Error{constructor(p){super(`Attempted to insert a duplicate test item ID ${p}`)}}e.DuplicateTestItemError=y;class d extends Error{constructor(p){super(`TestItem with ID "${p}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=d;class S extends Error{constructor(p,m,l){super(`TestItem with ID "${p}" is from controller "${m}" and cannot be added as a child of an item from controller "${l}".`)}}e.MixedTestItemController=S;const h=(g,p,m)=>{let l=new Map;return{get size(){return l.size},forEach(u,n){for(const s of l.values())u.call(n,s,this)},replace(u){const n=new Map,s=new Set(l.keys()),i={op:5,ops:[]};for(const o of u){if(!(o instanceof m))throw new d(o.id);const r=p(o).controllerId;if(r!==g.controllerId)throw new S(o.id,r,g.controllerId);if(n.has(o.id))throw new y(o.id);n.set(o.id,o),s.delete(o.id),i.ops.push({op:0,item:o})}for(const o of s.keys())i.ops.push({op:3,id:o});g.listener?.(i),l=n},add(u){if(!(u instanceof m))throw new d(u.id);l.set(u.id,u),g.listener?.({op:0,item:u})},delete(u){l.delete(u)&&g.listener?.({op:3,id:u})},get(u){return l.get(u)},toJSON(){return Array.from(l.values())},[Symbol.iterator](){return l.values()}}};e.createTestItemChildren=h}),define(we[119],ye([0,1,118]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,b=(k,E)=>{const v={controllerId:E};return t.set(k,v),v};e.createPrivateApiFor=b;const P=k=>{const E=t.get(k);if(!E)throw new I.InvalidTestItemError(k?.id||"<unknown>");return E};e.getPrivateApiFor=P}),define(we[242],ye([0,1,23,7]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.LOCAL_MACHINE_SCOPES=[1,3,4,5],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=(0,t.refineServiceDecorator)(I.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(we[243],ye([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,I.createDecorator)("configurationResolverService")}),define(we[244],ye([0,1,5,26,12,21,3,85,180,15]),function(ie,e,I,t,b,P,k,E,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(C,y,d,S){this._contributedVariables=new Map,this._context=C,this._labelService=y,this._userHomePromise=d,S&&(this._envVariablesPromise=S.then(h=>this.prepareEnv(h)))}prepareEnv(C){if(k.isWindows){const y=Object.create(null);return Object.keys(C).forEach(d=>{y[d.toLowerCase()]=C[d]}),y}return C}resolveWithEnvironment(C,y,d){return this.recursiveResolve({env:this.prepareEnv(C),userHome:void 0},y?y.uri:void 0,d)}async resolveAsync(C,y){const d={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(d,C?C.uri:void 0,y)}async resolveAnyBase(C,y,d,S){const h=P.deepClone(y);k.isWindows&&h.windows?Object.keys(h.windows).forEach(p=>h[p]=h.windows[p]):k.isMacintosh&&h.osx?Object.keys(h.osx).forEach(p=>h[p]=h.osx[p]):k.isLinux&&h.linux&&Object.keys(h.linux).forEach(p=>h[p]=h.linux[p]),delete h.windows,delete h.osx,delete h.linux;const g={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(g,C?C.uri:void 0,h,d,S)}async resolveAnyAsync(C,y,d){return this.resolveAnyBase(C,y,d)}async resolveAnyMap(C,y,d){const S=new Map;return{newConfig:await this.resolveAnyBase(C,y,d,S),resolvedVariables:S}}resolveWithInteractionReplace(C,y,d,S){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,y,d,S){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,y){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,y)}async recursiveResolve(C,y,d,S,h){if(b.isString(d))return this.resolveString(C,y,d,S,h);if(b.isArray(d))return Promise.all(d.map(g=>this.recursiveResolve(C,y,g,S,h)));if(b.isObject(d)){let g=Object.create(null);const p=await Promise.all(Object.keys(d).map(async m=>[await this.resolveString(C,y,m,S,h),await this.recursiveResolve(C,y,d[m],S,h)]));for(const[m,l]of p)g[m]=l;return g}return d}resolveString(C,y,d,S,h){return(0,D.replaceAsync)(d,T.VARIABLE_REGEXP,async(g,p)=>{if(p.includes(T.VARIABLE_LHS))return g;let m=await this.evaluateSingleVariable(C,g,p,y,S);return h&&h.set(p,m),m!==g&&b.isString(m)&&m.match(T.VARIABLE_REGEXP)&&(m=await this.resolveString(C,y,m,S,h)),m})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}async evaluateSingleVariable(C,y,d,S,h){let g;const p=d.split(":");p.length>1&&(d=p[0],g=p[1]);const m=()=>{const n=this._context.getFilePath();if(n)return n;throw new Error((0,v.localize)(0,null,y))},l=()=>{const n=m();if(this._context.getWorkspaceFolderPathForFile){const s=this._context.getWorkspaceFolderPathForFile();if(s)return s}throw new Error((0,v.localize)(1,null,y,I.basename(n)))},u=()=>{if(g){const n=this._context.getFolderUri(g);if(n)return n;throw new Error((0,v.localize)(2,null,y,g))}if(S)return S;throw this._context.getWorkspaceFolderCount()>1?new Error((0,v.localize)(3,null,y)):new Error((0,v.localize)(4,null,y))};switch(d){case"env":if(g){if(C.env){const n=C.env[k.isWindows?g.toLowerCase():g];if(b.isString(n))return n}return""}throw new Error((0,v.localize)(5,null,y));case"config":if(g){const n=this._context.getConfigurationValue(S,g);if(b.isUndefinedOrNull(n))throw new Error((0,v.localize)(6,null,y,g));if(b.isObject(n))throw new Error((0,v.localize)(7,null,y,g));return n}throw new Error((0,v.localize)(8,null,y));case"command":return this.resolveFromMap(y,g,h,"command");case"input":return this.resolveFromMap(y,g,h,"input");case"extensionInstallFolder":if(g){const n=await this._context.getExtension(g);if(!n)throw new Error((0,v.localize)(9,null,y,g));return this.fsPath(n.extensionLocation)}throw new Error((0,v.localize)(10,null,y));default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,E.normalizeDriveLetter)(this.fsPath(u()));case"cwd":return S||g?(0,E.normalizeDriveLetter)(this.fsPath(u())):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return I.basename(this.fsPath(u()));case"userHome":{if(C.userHome)return C.userHome;throw new Error((0,v.localize)(11,null,y))}case"lineNumber":{const n=this._context.getLineNumber();if(n)return n;throw new Error((0,v.localize)(12,null,y))}case"selectedText":{const n=this._context.getSelectedText();if(n)return n;throw new Error((0,v.localize)(13,null,y))}case"file":return m();case"fileWorkspaceFolder":return l();case"relativeFile":return S||g?I.relative(this.fsPath(u()),m()):m();case"relativeFileDirname":{const n=I.dirname(m());if(S||g){const s=I.relative(this.fsPath(u()),n);return s.length===0?".":s}return n}case"fileDirname":return I.dirname(m());case"fileExtname":return I.extname(m());case"fileBasename":return I.basename(m());case"fileBasenameNoExtension":{const n=I.basename(m());return n.slice(0,n.length-I.extname(n).length)}case"fileDirnameBasename":return I.basename(I.dirname(m()));case"execPath":{const n=this._context.getExecPath();return n||y}case"execInstallFolder":{const n=this._context.getAppRoot();return n||y}case"pathSeparator":return I.sep;default:try{const n=g?`${d}:${g}`:d;return this.resolveFromMap(y,n,h,void 0)}catch{return y}}}}resolveFromMap(C,y,d,S){if(y&&d){const h=S===void 0?d[y]:d[S+":"+y];if(typeof h=="string")return h;throw new Error((0,v.localize)(14,null,C))}return C}}e.AbstractVariableResolverService=T,T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[245],ye([0,1,7,115]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,I.createDecorator)("editorGroupsService");var b;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(b=e.GroupDirection||(e.GroupDirection={}));var P;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(P=e.GroupOrientation||(e.GroupOrientation={}));var k;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(k=e.GroupLocation||(e.GroupLocation={}));var E;(function(d){d[d.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",d[d.EVEN=1]="EVEN",d[d.TOGGLE=2]="TOGGLE"})(E=e.GroupsArrangement||(e.GroupsArrangement={}));var v;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(v=e.MergeGroupMode||(e.MergeGroupMode={}));function D(d){const S=d;return(0,t.isEditorInput)(S?.editor)&&(0,t.isEditorInput)(S?.replacement)}e.isEditorReplacement=D;var T;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T=e.GroupsOrder||(e.GroupsOrder={}));var R;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(R=e.OpenEditorContext||(e.OpenEditorContext={}));function C(d){const S=d;return!!S&&typeof S.id=="number"&&Array.isArray(S.editors)}e.isEditorGroup=C;function y(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=y}),define(we[120],ye([0,1,7,245]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,I.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function b(P){const k=P;return typeof P=="number"||(0,t.isEditorGroup)(k)}e.isPreferredGroup=b}),define(we[121],ye([0,1,17,16,84,29,132,45,21,12,4,47,146,183,204,119,239,78,79,120,114,62]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C,y,d,S,h,g,p,m,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.SnippetTextEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var n;(function(Ee){function Ie(H){const{selectionStartLineNumber:Pe,selectionStartColumn:Ae,positionLineNumber:Ye,positionColumn:We}=H,it=new l.Position(Pe-1,Ae-1),rt=new l.Position(Ye-1,We-1);return new l.Selection(it,rt)}Ee.to=Ie;function fe(H){const{anchor:Pe,active:Ae}=H;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Ae.line+1,positionColumn:Ae.character+1}}Ee.from=fe})(n=e.Selection||(e.Selection={}));var s;(function(Ee){function Ie(H){if(!H)return;const{start:Pe,end:Ae}=H;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Ae.line+1,endColumn:Ae.character+1}}Ee.from=Ie;function fe(H){if(!H)return;const{startLineNumber:Pe,startColumn:Ae,endLineNumber:Ye,endColumn:We}=H;return new l.Range(Pe-1,Ae-1,Ye-1,We-1)}Ee.to=fe})(s=e.Range||(e.Range={}));var i;(function(Ee){function Ie(fe){switch(fe){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}Ee.to=Ie})(i=e.TokenType||(e.TokenType={}));var o;(function(Ee){function Ie(H){return new l.Position(H.lineNumber-1,H.column-1)}Ee.to=Ie;function fe(H){return{lineNumber:H.line+1,column:H.character+1}}Ee.from=fe})(o=e.Position||(e.Position={}));var r;(function(Ee){function Ie(Pe,Ae){return(0,I.coalesce)((0,I.asArray)(Pe).map(Ye=>fe(Ye,Ae)))}Ee.from=Ie;function fe(Pe,Ae){if(typeof Pe=="string")return{$serialized:!0,language:Pe};if(Pe)return{$serialized:!0,language:Pe.language,scheme:H(Pe.scheme,Ae),pattern:ke.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType}}function H(Pe,Ae){return Ae&&typeof Pe=="string"?Ae.transformOutgoingScheme(Pe):Pe}})(r=e.DocumentSelector||(e.DocumentSelector={}));var a;(function(Ee){function Ie(H){switch(H){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}Ee.from=Ie;function fe(H){switch(H){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}Ee.to=fe})(a=e.DiagnosticTag||(e.DiagnosticTag={}));var c;(function(Ee){function Ie(H){let Pe;return H.code&&((0,D.isString)(H.code)||(0,D.isNumber)(H.code)?Pe=String(H.code):Pe={value:String(H.code.value),target:H.code.target}),{...s.from(H.range),message:H.message,source:H.source,code:Pe,severity:w.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(f.from),tags:Array.isArray(H.tags)?(0,I.coalesce)(H.tags.map(a.from)):void 0}}Ee.from=Ie;function fe(H){const Pe=new l.Diagnostic(s.to(H),H.message,w.to(H.severity));return Pe.source=H.source,Pe.code=(0,D.isString)(H.code)?H.code:H.code?.value,Pe.relatedInformation=H.relatedInformation&&H.relatedInformation.map(f.to),Pe.tags=H.tags&&(0,I.coalesce)(H.tags.map(a.to)),Pe}Ee.to=fe})(c=e.Diagnostic||(e.Diagnostic={}));var f;(function(Ee){function Ie(H){return{...s.from(H.location.range),message:H.message,resource:H.location.uri}}Ee.from=Ie;function fe(H){return new l.DiagnosticRelatedInformation(new l.Location(H.resource,s.to(H)),H.message)}Ee.to=fe})(f=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var w;(function(Ee){function Ie(H){switch(H){case l.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}Ee.from=Ie;function fe(H){switch(H){case d.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}Ee.to=fe})(w=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var A;(function(Ee){function Ie(H){return typeof H=="number"&&H>=l.ViewColumn.One?H-1:H===l.ViewColumn.Beside?m.SIDE_GROUP:m.ACTIVE_GROUP}Ee.from=Ie;function fe(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=fe})(A=e.ViewColumn||(e.ViewColumn={}));function U(Ee){return typeof Ee.range!="undefined"}function x(Ee){return Ee.length===0?!0:!!U(Ee[0])}e.isDecorationOptionsArr=x;var Q;(function(Ee){function Ie(We){return We.map(Ee.from)}Ee.fromMany=Ie;function fe(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function H(We){let it;if(fe(We)){const{language:ct,value:dt}=We;it={value:"```"+ct+`
`+dt+"\n```\n"}}else l.MarkdownString.isMarkdownString(We)?it={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?it={value:We}:it={value:""};const rt=Object.create(null);it.uris=rt;const Pt=ct=>{try{let dt=T.URI.parse(ct,!0);dt=dt.with({query:Pe(dt.query,rt)}),rt[ct]=dt}catch{}return""},ht=new k.marked.Renderer;return ht.link=Pt,ht.image=ct=>typeof ct=="string"?Pt(b.parseHrefAndDimensions(ct).href):"",(0,k.marked)(it.value,{renderer:ht}),it}Ee.from=H;function Pe(We,it){if(!We)return We;let rt;try{rt=(0,E.parse)(We)}catch{}if(!rt)return We;let Pt=!1;return rt=(0,v.cloneAndChange)(rt,ht=>{if(T.URI.isUri(ht)){const ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[ct]=ht,Pt=!0,ct}else return}),Pt?JSON.stringify(rt):We}function Ae(We){const it=new l.MarkdownString(We.value,We.supportThemeIcons);return it.isTrusted=We.isTrusted,it.supportHtml=We.supportHtml,it.baseUri=We.baseUri?T.URI.from(We.baseUri):void 0,it}Ee.to=Ae;function Ye(We){if(!!We)return typeof We=="string"?We:Ee.from(We)}Ee.fromStrict=Ye})(Q=e.MarkdownString||(e.MarkdownString={}));function _(Ee){return x(Ee)?Ee.map(Ie=>({range:s.from(Ie.range),hoverMessage:Array.isArray(Ie.hoverMessage)?Q.fromMany(Ie.hoverMessage):Ie.hoverMessage?Q.from(Ie.hoverMessage):void 0,renderOptions:Ie.renderOptions})):Ee.map(Ie=>({range:s.from(Ie)}))}e.fromRangeOrRangeWithMessage=_;function Y(Ee){return typeof Ee=="undefined"?Ee:typeof Ee=="string"?T.URI.file(Ee):Ee}e.pathOrURIToURI=Y;var O;(function(Ee){function Ie(fe){return typeof fe=="undefined"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?Y(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}Ee.from=Ie})(O=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var B;(function(Ee){function Ie(fe){return typeof fe=="undefined"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?Y(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?O.from(fe.before):void 0,after:fe.after?O.from(fe.after):void 0}}Ee.from=Ie})(B=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var ue;(function(Ee){function Ie(fe){if(typeof fe=="undefined")return fe;switch(fe){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=Ie})(ue=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var V;(function(Ee){function Ie(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?ue.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?B.from(fe.light):void 0,dark:fe.dark?B.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?Y(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?O.from(fe.before):void 0,after:fe.after?O.from(fe.after):void 0}}Ee.from=Ie})(V=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var $;(function(Ee){function Ie(H){return{text:H.newText,eol:H.newEol&&He.from(H.newEol),range:s.from(H.range)}}Ee.from=Ie;function fe(H){const Pe=new l.TextEdit(s.to(H.range),H.text);return Pe.newEol=typeof H.eol=="undefined"?void 0:He.to(H.eol),Pe}Ee.to=fe})($=e.TextEdit||(e.TextEdit={}));var F;(function(Ee){function Ie(fe){return{range:s.from(fe.range),snippet:fe.snippet.value}}Ee.from=Ie})(F=e.SnippetTextEdit||(e.SnippetTextEdit={}));var M;(function(Ee){function Ie(H,Pe){const Ae={edits:[]};if(H instanceof l.WorkspaceEdit){const Ye=new P.ResourceSet;for(const We of H._allEntries())We._type===1&&T.URI.isUri(We.to)&&We.from===void 0&&Ye.add(We.to);for(const We of H._allEntries())We._type===1?Ae.edits.push({_type:1,oldUri:We.from,newUri:We.to,options:We.options,metadata:We.metadata}):We._type===2?Ae.edits.push({_type:2,resource:We.uri,edit:$.from(We.edit),modelVersionId:Ye.has(We.uri)?void 0:Pe?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?Ae.edits.push({_type:3,metadata:We.metadata,resource:We.uri,edit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(We.uri)}):We._type===5&&Ae.edits.push({_type:3,metadata:We.metadata,resource:We.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(We.uri),edit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(xe.from)}})}return Ae}Ee.from=Ie;function fe(H){const Pe=new l.WorkspaceEdit;for(const Ae of H.edits)Ae.edit?Pe.replace(T.URI.revive(Ae.resource),s.to(Ae.edit.range),Ae.edit.text):Pe.renameFile(T.URI.revive(Ae.oldUri),T.URI.revive(Ae.newUri),Ae.options);return Pe}Ee.to=fe})(M=e.WorkspaceEdit||(e.WorkspaceEdit={}));var j;(function(Ee){const Ie=Object.create(null);Ie[l.SymbolKind.File]=0,Ie[l.SymbolKind.Module]=1,Ie[l.SymbolKind.Namespace]=2,Ie[l.SymbolKind.Package]=3,Ie[l.SymbolKind.Class]=4,Ie[l.SymbolKind.Method]=5,Ie[l.SymbolKind.Property]=6,Ie[l.SymbolKind.Field]=7,Ie[l.SymbolKind.Constructor]=8,Ie[l.SymbolKind.Enum]=9,Ie[l.SymbolKind.Interface]=10,Ie[l.SymbolKind.Function]=11,Ie[l.SymbolKind.Variable]=12,Ie[l.SymbolKind.Constant]=13,Ie[l.SymbolKind.String]=14,Ie[l.SymbolKind.Number]=15,Ie[l.SymbolKind.Boolean]=16,Ie[l.SymbolKind.Array]=17,Ie[l.SymbolKind.Object]=18,Ie[l.SymbolKind.Key]=19,Ie[l.SymbolKind.Null]=20,Ie[l.SymbolKind.EnumMember]=21,Ie[l.SymbolKind.Struct]=22,Ie[l.SymbolKind.Event]=23,Ie[l.SymbolKind.Operator]=24,Ie[l.SymbolKind.TypeParameter]=25;function fe(Pe){return typeof Ie[Pe]=="number"?Ie[Pe]:6}Ee.from=fe;function H(Pe){for(const Ae in Ie)if(Ie[Ae]===Pe)return Number(Ae);return l.SymbolKind.Property}Ee.to=H})(j=e.SymbolKind||(e.SymbolKind={}));var Z;(function(Ee){function Ie(H){switch(H){case l.SymbolTag.Deprecated:return 1}}Ee.from=Ie;function fe(H){switch(H){case 1:return l.SymbolTag.Deprecated}}Ee.to=fe})(Z=e.SymbolTag||(e.SymbolTag={}));var oe;(function(Ee){function Ie(H){return{name:H.name,kind:j.from(H.kind),tags:H.tags&&H.tags.map(Z.from),containerName:H.containerName,location:G.from(H.location)}}Ee.from=Ie;function fe(H){const Pe=new l.SymbolInformation(H.name,j.to(H.kind),H.containerName,G.to(H.location));return Pe.tags=H.tags&&H.tags.map(Z.to),Pe}Ee.to=fe})(oe=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var ge;(function(Ee){function Ie(H){const Pe={name:H.name||"!!MISSING: name!!",detail:H.detail,range:s.from(H.range),selectionRange:s.from(H.selectionRange),kind:j.from(H.kind),tags:H.tags?.map(Z.from)??[]};return H.children&&(Pe.children=H.children.map(Ie)),Pe}Ee.from=Ie;function fe(H){const Pe=new l.DocumentSymbol(H.name,H.detail,j.to(H.kind),s.to(H.range),s.to(H.selectionRange));return(0,I.isNonEmptyArray)(H.tags)&&(Pe.tags=H.tags.map(Z.to)),H.children&&(Pe.children=H.children.map(fe)),Pe}Ee.to=fe})(ge=e.DocumentSymbol||(e.DocumentSymbol={}));var he;(function(Ee){function Ie(H){const Pe=new l.CallHierarchyItem(j.to(H.kind),H.name,H.detail||"",T.URI.revive(H.uri),s.to(H.range),s.to(H.selectionRange));return Pe._sessionId=H._sessionId,Pe._itemId=H._itemId,Pe}Ee.to=Ie;function fe(H,Pe,Ae){if(Pe=Pe??H._sessionId,Ae=Ae??H._itemId,Pe===void 0||Ae===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Ae,name:H.name,detail:H.detail,kind:j.from(H.kind),uri:H.uri,range:s.from(H.range),selectionRange:s.from(H.selectionRange),tags:H.tags?.map(Z.from)}}Ee.from=fe})(he=e.CallHierarchyItem||(e.CallHierarchyItem={}));var q;(function(Ee){function Ie(fe){return new l.CallHierarchyIncomingCall(he.to(fe.from),fe.fromRanges.map(H=>s.to(H)))}Ee.to=Ie})(q=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ee;(function(Ee){function Ie(fe){return new l.CallHierarchyOutgoingCall(he.to(fe.to),fe.fromRanges.map(H=>s.to(H)))}Ee.to=Ie})(ee=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var G;(function(Ee){function Ie(H){return{range:H.range&&s.from(H.range),uri:H.uri}}Ee.from=Ie;function fe(H){return new l.Location(T.URI.revive(H.uri),s.to(H.range))}Ee.to=fe})(G=e.location||(e.location={}));var z;(function(Ee){function Ie(H){const Pe=H,Ae=H;return{originSelectionRange:Pe.originSelectionRange?s.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Ae.uri,range:s.from(Pe.targetRange?Pe.targetRange:Ae.range),targetSelectionRange:Pe.targetSelectionRange?s.from(Pe.targetSelectionRange):void 0}}Ee.from=Ie;function fe(H){return{targetUri:T.URI.revive(H.uri),targetRange:s.to(H.range),targetSelectionRange:H.targetSelectionRange?s.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?s.to(H.originSelectionRange):void 0}}Ee.to=fe})(z=e.DefinitionLink||(e.DefinitionLink={}));var te;(function(Ee){function Ie(H){return{range:s.from(H.range),contents:Q.fromMany(H.contents)}}Ee.from=Ie;function fe(H){return new l.Hover(H.contents.map(Q.to),s.to(H.range))}Ee.to=fe})(te=e.Hover||(e.Hover={}));var ce;(function(Ee){function Ie(H){return{range:s.from(H.range),expression:H.expression}}Ee.from=Ie;function fe(H){return new l.EvaluatableExpression(s.to(H.range),H.expression)}Ee.to=fe})(ce=e.EvaluatableExpression||(e.EvaluatableExpression={}));var J;(function(Ee){function Ie(H){if(H instanceof l.InlineValueText)return{type:"text",range:s.from(H.range),text:H.text};if(H instanceof l.InlineValueVariableLookup)return{type:"variable",range:s.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:s.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=Ie;function fe(H){switch(H.type){case"text":return{range:s.to(H.range),text:H.text};case"variable":return{range:s.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:s.to(H.range),expression:H.expression}}}Ee.to=fe})(J=e.InlineValue||(e.InlineValue={}));var se;(function(Ee){function Ie(H){return{frameId:H.frameId,stoppedLocation:s.from(H.stoppedLocation)}}Ee.from=Ie;function fe(H){return new l.InlineValueContext(H.frameId,s.to(H.stoppedLocation))}Ee.to=fe})(se=e.InlineValueContext||(e.InlineValueContext={}));var me;(function(Ee){function Ie(H){return{range:s.from(H.range),kind:H.kind}}Ee.from=Ie;function fe(H){return new l.DocumentHighlight(s.to(H.range),H.kind)}Ee.to=fe})(me=e.DocumentHighlight||(e.DocumentHighlight={}));var X;(function(Ee){function Ie(fe){switch(fe){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}Ee.to=Ie})(X=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var re;(function(Ee){function Ie(fe){return{triggerKind:X.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}Ee.to=Ie})(re=e.CompletionContext||(e.CompletionContext={}));var W;(function(Ee){function Ie(H){switch(H){case l.CompletionItemTag.Deprecated:return 1}}Ee.from=Ie;function fe(H){switch(H){case 1:return l.CompletionItemTag.Deprecated}}Ee.to=fe})(W=e.CompletionItemTag||(e.CompletionItemTag={}));var K;(function(Ee){const Ie=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function fe(Ae){return Ie.get(Ae)??9}Ee.from=fe;const H=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Pe(Ae){return H.get(Ae)??l.CompletionItemKind.Property}Ee.to=Pe})(K=e.CompletionItemKind||(e.CompletionItemKind={}));var le;(function(Ee){function Ie(fe,H){const Pe=new l.CompletionItem(fe.label);return Pe.insertText=fe.insertText,Pe.kind=K.to(fe.kind),Pe.tags=fe.tags?.map(W.to),Pe.detail=fe.detail,Pe.documentation=b.isMarkdownString(fe.documentation)?Q.to(fe.documentation):fe.documentation,Pe.sortText=fe.sortText,Pe.filterText=fe.filterText,Pe.preselect=fe.preselect,Pe.commitCharacters=fe.commitCharacters,R.Range.isIRange(fe.range)?Pe.range=s.to(fe.range):typeof fe.range=="object"&&(Pe.range={inserting:s.to(fe.range.insert),replacing:s.to(fe.range.replace)}),Pe.keepWhitespace=typeof fe.insertTextRules=="undefined"?!1:Boolean(fe.insertTextRules&1),typeof fe.insertTextRules!="undefined"&&fe.insertTextRules&4?Pe.insertText=new l.SnippetString(fe.insertText):(Pe.insertText=fe.insertText,Pe.textEdit=Pe.range instanceof l.Range?new l.TextEdit(Pe.range,Pe.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Pe.additionalTextEdits=fe.additionalTextEdits.map(Ae=>$.to(Ae))),Pe.command=H&&fe.command?H.fromInternal(fe.command):void 0,Pe}Ee.to=Ie})(le=e.CompletionItem||(e.CompletionItem={}));var ve;(function(Ee){function Ie(H){return{label:H.label,documentation:Q.fromStrict(H.documentation)}}Ee.from=Ie;function fe(H){return{label:H.label,documentation:b.isMarkdownString(H.documentation)?Q.to(H.documentation):H.documentation}}Ee.to=fe})(ve=e.ParameterInformation||(e.ParameterInformation={}));var De;(function(Ee){function Ie(H){return{label:H.label,documentation:Q.fromStrict(H.documentation),parameters:Array.isArray(H.parameters)?H.parameters.map(ve.from):[],activeParameter:H.activeParameter}}Ee.from=Ie;function fe(H){return{label:H.label,documentation:b.isMarkdownString(H.documentation)?Q.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(ve.to):[],activeParameter:H.activeParameter}}Ee.to=fe})(De=e.SignatureInformation||(e.SignatureInformation={}));var Te;(function(Ee){function Ie(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(De.from):[]}}Ee.from=Ie;function fe(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(De.to):[]}}Ee.to=fe})(Te=e.SignatureHelp||(e.SignatureHelp={}));var Oe;(function(Ee){function Ie(fe,H){const Pe=new l.InlayHint(o.to(H.position),typeof H.label=="string"?H.label:H.label.map(Ue.to.bind(void 0,fe)),H.kind&&de.to(H.kind));return Pe.textEdits=H.textEdits&&H.textEdits.map($.to),Pe.tooltip=b.isMarkdownString(H.tooltip)?Q.to(H.tooltip):H.tooltip,Pe.paddingLeft=H.paddingLeft,Pe.paddingRight=H.paddingRight,Pe}Ee.to=Ie})(Oe=e.InlayHint||(e.InlayHint={}));var Ue;(function(Ee){function Ie(fe,H){const Pe=new l.InlayHintLabelPart(H.label);return Pe.tooltip=b.isMarkdownString(H.tooltip)?Q.to(H.tooltip):H.tooltip,C.Command.is(H.command)&&(Pe.command=fe.fromInternal(H.command)),H.location&&(Pe.location=G.to(H.location)),Pe}Ee.to=Ie})(Ue=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var de;(function(Ee){function Ie(H){return H}Ee.from=Ie;function fe(H){return H}Ee.to=fe})(de=e.InlayHintKind||(e.InlayHintKind={}));var be;(function(Ee){function Ie(H){return{range:s.from(H.range),url:H.target,tooltip:H.tooltip}}Ee.from=Ie;function fe(H){let Pe;if(H.url)try{Pe=typeof H.url=="string"?T.URI.parse(H.url,!0):T.URI.revive(H.url)}catch{}return new l.DocumentLink(s.to(H.range),Pe)}Ee.to=fe})(be=e.DocumentLink||(e.DocumentLink={}));var pe;(function(Ee){function Ie(H){const Pe=new l.ColorPresentation(H.label);return H.textEdit&&(Pe.textEdit=$.to(H.textEdit)),H.additionalTextEdits&&(Pe.additionalTextEdits=H.additionalTextEdits.map(Ae=>$.to(Ae))),Pe}Ee.to=Ie;function fe(H){return{label:H.label,textEdit:H.textEdit?$.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(Pe=>$.from(Pe)):void 0}}Ee.from=fe})(pe=e.ColorPresentation||(e.ColorPresentation={}));var _e;(function(Ee){function Ie(H){return new l.Color(H[0],H[1],H[2],H[3])}Ee.to=Ie;function fe(H){return[H.red,H.green,H.blue,H.alpha]}Ee.from=fe})(_e=e.Color||(e.Color={}));var Ne;(function(Ee){function Ie(H){return{range:s.from(H.range)}}Ee.from=Ie;function fe(H){return new l.SelectionRange(s.to(H.range))}Ee.to=fe})(Ne=e.SelectionRange||(e.SelectionRange={}));var qe;(function(Ee){function Ie(fe){switch(fe){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}Ee.to=Ie})(qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ze;(function(Ee){function Ie(H){switch(H){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=Ie;function fe(H){switch(H){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}Ee.to=fe})(ze=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var He;(function(Ee){function Ie(H){if(H===l.EndOfLine.CRLF)return 1;if(H===l.EndOfLine.LF)return 0}Ee.from=Ie;function fe(H){if(H===1)return l.EndOfLine.CRLF;if(H===0)return l.EndOfLine.LF}Ee.to=fe})(He=e.EndOfLine||(e.EndOfLine={}));var Qe;(function(Ee){function Ie(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=Ie})(Qe=e.ProgressLocation||(e.ProgressLocation={}));var Ve;(function(Ee){function Ie(fe){const H={start:fe.start+1,end:fe.end+1};return fe.kind&&(H.kind=ae.from(fe.kind)),H}Ee.from=Ie})(Ve=e.FoldingRange||(e.FoldingRange={}));var ae;(function(Ee){function Ie(fe){if(fe)switch(fe){case l.FoldingRangeKind.Comment:return C.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return C.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return C.FoldingRangeKind.Region}}Ee.from=Ie})(ae=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ce;(function(Ee){function Ie(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?s.from(fe.selection):void 0,override:typeof fe.override=="boolean"?y.EditorResolution.DISABLED:void 0}}Ee.from=Ie})(Ce=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ke;(function(Ee){function Ie(Ae){return Ae instanceof l.RelativePattern?Ae.toJSON():typeof Ae=="string"?Ae:fe(Ae)||H(Ae)?new l.RelativePattern(Ae.baseUri??Ae.base,Ae.pattern).toJSON():Ae}Ee.from=Ie;function fe(Ae){const Ye=Ae;return Ye?T.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function H(Ae){const Ye=Ae;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function Pe(Ae){return typeof Ae=="string"?Ae:new l.RelativePattern(T.URI.revive(Ae.baseUri),Ae.pattern)}Ee.to=Pe})(ke=e.GlobPattern||(e.GlobPattern={}));var Le;(function(Ee){function Ie(fe){if(fe){if(Array.isArray(fe))return fe.map(Ie);if(typeof fe=="string")return fe;{const H=fe;return{language:H.language,scheme:H.scheme,pattern:ke.from(H.pattern),exclusive:H.exclusive,notebookType:H.notebookType}}}else return}Ee.from=Ie})(Le=e.LanguageSelector||(e.LanguageSelector={}));var Be;(function(Ee){function Ie(H){return{start:H.start,end:H.end}}Ee.from=Ie;function fe(H){return new l.NotebookRange(H.start,H.end)}Ee.to=fe})(Be=e.NotebookRange||(e.NotebookRange={}));var Me;(function(Ee){function Ie(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}Ee.to=Ie;function fe(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}Ee.from=fe})(Me=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var je;(function(Ee){function Ie(fe){if(fe===h.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;if(fe===h.NotebookCellExecutionState.Pending)return l.NotebookCellExecutionState.Pending;if(fe===h.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;throw new Error(`Unknown state: ${fe}`)}Ee.to=Ie})(je=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ke;(function(Ee){function Ie(H){switch(H){case l.NotebookCellKind.Markup:return h.CellKind.Markup;case l.NotebookCellKind.Code:default:return h.CellKind.Code}}Ee.from=Ie;function fe(H){switch(H){case h.CellKind.Markup:return l.NotebookCellKind.Markup;case h.CellKind.Code:default:return l.NotebookCellKind.Code}}Ee.to=fe})(Ke=e.NotebookCellKind||(e.NotebookCellKind={}));var Xe;(function(Ee){function Ie(H){const Pe={metadata:H.metadata??Object.create(null),cells:[]};for(let Ae of H.cells)l.NotebookCellData.validate(Ae),Pe.cells.push(xe.from(Ae));return Pe}Ee.from=Ie;function fe(H){const Pe=new l.NotebookData(H.cells.map(xe.to));return(0,D.isEmptyObject)(H.metadata)||(Pe.metadata=H.metadata),Pe}Ee.to=fe})(Xe=e.NotebookData||(e.NotebookData={}));var xe;(function(Ee){function Ie(H){return{cellKind:Ke.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:Me.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(nt.from):[]}}Ee.from=Ie;function fe(H){return new l.NotebookCellData(Ke.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(nt.to):void 0,H.metadata,H.internalMetadata?Me.to(H.internalMetadata):void 0)}Ee.to=fe})(xe=e.NotebookCellData||(e.NotebookCellData={}));var tt;(function(Ee){function Ie(H){return{mime:H.mime,valueBytes:t.VSBuffer.wrap(H.data)}}Ee.from=Ie;function fe(H){return new l.NotebookCellOutputItem(H.valueBytes.buffer,H.mime)}Ee.to=fe})(tt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var nt;(function(Ee){function Ie(H){return{outputId:H.id,items:H.items.map(tt.from),metadata:H.metadata}}Ee.from=Ie;function fe(H){const Pe=H.items.map(tt.to);return new l.NotebookCellOutput(Pe,H.outputId,H.metadata)}Ee.to=fe})(nt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var st;(function(Ee){function Ie(Pe){return H(Pe)?{include:(0,D.withNullAsUndefined)(ke.from(Pe.include)),exclude:(0,D.withNullAsUndefined)(ke.from(Pe.exclude))}:(0,D.withNullAsUndefined)(ke.from(Pe))}Ee.from=Ie;function fe(Pe){return H(Pe)?{include:ke.to(Pe.include),exclude:ke.to(Pe.exclude)}:ke.to(Pe)}Ee.to=fe;function H(Pe){const Ae=Pe;return Ae?!(0,D.isUndefinedOrNull)(Ae.include)&&!(0,D.isUndefinedOrNull)(Ae.exclude):!1}})(st=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var pt;(function(Ee){function Ie(fe){return{backgroundColor:fe.backgroundColor,borderColor:fe.borderColor,top:fe.top?O.from(fe.top):void 0}}Ee.from=Ie})(pt=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Tt;(function(Ee){function Ie(fe,H,Pe){const Ae=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:H.toInternal(Ae,Pe),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}Ee.from=Ie})(Tt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var at;(function(Ee){function Ie(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{}}}Ee.from=Ie})(at=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ut;(function(Ee){function Ie(H){return{uri:H.uri,provides:H.provides}}Ee.from=Ie;function fe(H){return new l.NotebookRendererScript(T.URI.revive(H.uri),H.provides)}Ee.to=fe})(ut=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ft;(function(Ee){function Ie(H){return{message:Q.fromStrict(H.message)||"",type:0,expected:H.expectedOutput,actual:H.actualOutput,location:H.location&&{range:s.from(H.location.range),uri:H.location.uri}}}Ee.from=Ie;function fe(H){const Pe=new l.TestMessage(typeof H.message=="string"?H.message:Q.to(H.message));return Pe.actualOutput=H.actual,Pe.expectedOutput=H.expected,Pe.location=H.location?G.to(H.location):void 0,Pe}Ee.to=fe})(ft=e.TestMessage||(e.TestMessage={}));var vt;(function(Ee){Ee.namespace=p.namespaceTestTag,Ee.denamespace=p.denamespaceTestTag})(vt=e.TestTag||(e.TestTag={}));var yt;(function(Ee){function Ie(H){const Pe=(0,S.getPrivateApiFor)(H).controllerId;return{extId:g.TestId.fromExtHostTestItem(H,Pe).toString(),label:H.label,uri:T.URI.revive(H.uri),busy:!1,tags:H.tags.map(Ae=>vt.namespace(Pe,Ae.id)),range:R.Range.lift(s.from(H.range)),description:H.description||null,sortText:H.sortText||null,error:H.error&&Q.fromStrict(H.error)||null}}Ee.from=Ie;function fe(H){return{parent:void 0,error:void 0,id:g.TestId.fromString(H.extId).localId,label:H.label,uri:T.URI.revive(H.uri),tags:(H.tags||[]).map(Pe=>{const{tagId:Ae}=vt.denamespace(Pe);return new l.TestTag(Ae)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},get:()=>{},replace:()=>{},size:0},range:s.to(H.range||void 0),canResolveChildren:!1,busy:!1,description:H.description||void 0,sortText:H.sortText||void 0}}Ee.toPlain=fe})(yt=e.TestItem||(e.TestItem={})),function(Ee){function Ie(H){return{id:H.id}}Ee.from=Ie;function fe(H){return new l.TestTag(H.id)}Ee.to=fe}(vt=e.TestTag||(e.TestTag={}));var It;(function(Ee){const Ie=(H,Pe)=>{const Ae={...yt.toPlain(H.item),parent:void 0,taskStates:H.tasks.map(Ye=>({state:Ye.state,duration:Ye.duration,messages:Ye.messages.filter(We=>We.type===0).map(ft.to)})),children:H.children.map(Ye=>Pe.get(Ye)).filter(D.isDefined).map(Ye=>Ie(Ye,Pe))};for(const Ye of Ae.children)Ye.parent=Ae;return Ae};function fe(H){const Pe=[],Ae=new Map;for(const Ye of H.items)Ae.set(Ye.item.extId,Ye),H.request.targets.some(We=>We.controllerId===Ye.controllerId&&We.testIds.includes(Ye.item.extId))&&Pe.push(Ye);return{completedAt:H.completedAt,results:Pe.map(Ye=>Ie(Ye,Ae))}}Ee.to=fe})(It=e.TestResults||(e.TestResults={}));var Dt;(function(Ee){function Ie(Ae){return{covered:Ae.covered,total:Ae.covered}}function fe(Ae){return"line"in Ae?o.from(Ae):s.from(Ae)}function H(Ae){return"branches"in Ae?{count:Ae.executionCount,location:fe(Ae.location),type:1,branches:Ae.branches.length?Ae.branches.map(Ye=>({count:Ye.executionCount,location:Ye.location&&fe(Ye.location)})):void 0}:{type:0,count:Ae.executionCount,location:fe(Ae.location)}}Ee.fromDetailed=H;function Pe(Ae){return{uri:Ae.uri,statement:Ie(Ae.statementCoverage),branch:Ae.branchCoverage&&Ie(Ae.branchCoverage),function:Ae.functionCoverage&&Ie(Ae.functionCoverage),details:Ae.detailedCoverage?.map(H)}}Ee.fromFile=Pe})(Dt=e.TestCoverage||(e.TestCoverage={}));var _t;(function(Ee){function Ie(fe){switch(fe){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}Ee.to=Ie})(_t=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Lt;(function(Ee){function Ie(H){const Pe=new l.TypeHierarchyItem(j.to(H.kind),H.name,H.detail||"",T.URI.revive(H.uri),s.to(H.range),s.to(H.selectionRange));return Pe._sessionId=H._sessionId,Pe._itemId=H._itemId,Pe}Ee.to=Ie;function fe(H,Pe,Ae){if(Pe=Pe??H._sessionId,Ae=Ae??H._itemId,Pe===void 0||Ae===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Ae,kind:j.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:s.from(H.range),selectionRange:s.from(H.selectionRange),tags:H.tags?.map(Z.from)}}Ee.from=fe})(Lt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ft;(function(Ee){function Ie(fe){if(!!fe)return{value:fe.value,tooltip:fe.tooltip}}Ee.from=Ie})(Ft=e.ViewBadge||(e.ViewBadge={}));var Mt;(function(Ee){function Ie(fe,H){const Pe=fe.fileData;return Pe?new class extends l.DataTransferItem{asFile(){return{name:Pe.name,uri:T.URI.revive(Pe.uri),data:(0,u.once)(()=>H())}}}(""):new l.DataTransferItem(fe.asString)}Ee.toDataTransferItem=Ie})(Mt=e.DataTransferItem||(e.DataTransferItem={}));var $t;(function(Ee){function Ie(H,Pe){const Ae=H.items.map(([Ye,We],it)=>[Ye,Mt.toDataTransferItem(We,()=>Pe(it))]);return new l.DataTransfer(Ae)}Ee.toDataTransfer=Ie;async function fe(H){const Pe={items:[]},Ae=[];return H.forEach((Ye,We)=>{Ae.push((async()=>{const it=await Ye.asString(),rt=Ye.asFile();Pe.items.push([We,{asString:it,fileData:rt?{name:rt.name,uri:rt.uri}:void 0}])})())}),await Promise.all(Ae),Pe}Ee.toDataTransferDTO=fe})($t=e.DataTransfer||(e.DataTransfer={}))}),define(we[246],ye([0,1,47,119,78,118,79,121,4]),function(ie,e,I,t,b,P,k,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const D=(m,l,u,n)=>{let s=l;return{enumerable:!0,configurable:!1,get(){return s},set(i){if(!u(s,i)){const o=s;s=i,m.listener?.(n(i,o))}}}},T=(m,l)=>m===l,R={range:(m,l)=>m===l?!0:!m||!l?!1:m.isEqual(l),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(m,l)=>!(m.length!==l.length||m.some(u=>!l.find(n=>u.id===n.id)))},C=m=>l=>({op:4,update:m(l)}),y=(m,l)=>({range:D(m,void 0,R.range,C(u=>({range:I.Range.lift(E.Range.from(u))}))),label:D(m,l,R.label,C(u=>({label:u}))),description:D(m,void 0,R.description,C(u=>({description:u}))),sortText:D(m,void 0,R.sortText,C(u=>({sortText:u}))),canResolveChildren:D(m,!1,R.canResolveChildren,u=>({op:2,state:u})),busy:D(m,!1,R.busy,C(u=>({busy:u}))),error:D(m,void 0,R.error,C(u=>({error:E.MarkdownString.fromStrict(u)||null}))),tags:D(m,[],R.tags,(u,n)=>({op:1,new:u.map(E.TestTag.from),old:n.map(E.TestTag.from)}))}),d=m=>{const l=b.TestId.fromString(m.extId),u=new h(l.controllerId,l.localId,m.label,v.URI.revive(m.uri)||void 0);return u.range=E.Range.to(m.range||void 0),u.description=m.description||void 0,u.sortText=m.sortText||void 0,u.tags=m.tags.map(n=>E.TestTag.to({id:(0,k.denamespaceTestTag)(n).tagId})),u},S=m=>{let l;for(const u of m.tests){const n=d(u.item);(0,t.getPrivateApiFor)(n).parent=l,l=n}return l};e.toItemFromContext=S;class h{constructor(l,u,n,s){if(u.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(u)} symbol`);const i=(0,t.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:u,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return i.parent instanceof g?void 0:i.parent}},children:{value:(0,P.createTestItemChildren)(i,t.getPrivateApiFor,h),enumerable:!0,writable:!1},...y(i,n)})}}e.TestItemImpl=h;class g extends h{constructor(l,u){super(l,l,u,void 0)}}e.TestItemRootImpl=g;class p extends P.TestItemCollection{constructor(l,u){super({controllerId:l,getApiFor:t.getPrivateApiFor,getChildren:n=>n.children,root:new g(l,u),toITestItem:E.TestItem.from})}}e.ExtHostTestItemCollection=p}),define(we[247],ye([0,1,12,242,13,103,110,117,243,115,120,8,199,116]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let d=class{constructor(h,g,p,m,l,u,n,s,i,o){this._remoteAuthority=h,this._channel=g,this._configurationService=p,this._workspaceContextService=m,this._resolverService=l,this._environmentVariableService=u,this._remoteAuthorityResolverService=n,this._logService=s,this._editorService=i,this._labelService=o}get onPtyHostExit(){return this._channel.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this._channel.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this._channel.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this._channel.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this._channel.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this._channel.listen("$onProcessDataEvent")}get onProcessExit(){return this._channel.listen("$onProcessExitEvent")}get onProcessReady(){return this._channel.listen("$onProcessReadyEvent")}get onProcessReplay(){return this._channel.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this._channel.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this._channel.listen("$onExecuteCommand")}get onDidRequestDetach(){return this._channel.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this._channel.listen("$onDidChangeProperty")}restartPtyHost(){return this._channel.call("$restartPtyHost",[])}async createProcess(h,g,p,m,l,u,n,s){await this._configurationService.whenRemoteConfigurationLoaded();const i=Object.create(null),o=p?(0,I.withNullAsUndefined)(this._workspaceContextService.getWorkspaceFolder(p)):void 0;let r;try{r=(await this._resolverService.resolveAnyMap(o,{shellLaunchConfig:h,configuration:g})).resolvedVariables}catch(_){this._logService.error(_)}if(r)for(const[_,Y]of r.entries())(/^config:/.test(_)||_==="selectedText"||_==="lineNumber")&&(i[_]=Y);const a=[];for(const[_,Y]of this._environmentVariableService.collections.entries())a.push([_,(0,E.serializeEnvironmentVariableCollection)(Y.map)]);const c=await this._remoteAuthorityResolverService.resolveAuthority(this._remoteAuthority),f=c.options&&c.options.extensionHostEnv,w=this._workspaceContextService.getWorkspace(),A=w.folders,U=p?this._workspaceContextService.getWorkspaceFolder(p):null,x=D.EditorResourceAccessor.getOriginalUri(this._editorService.activeEditor,{supportSideBySide:D.SideBySideEditor.PRIMARY,filterByScheme:[R.Schemas.file,R.Schemas.vscodeUserData,R.Schemas.vscodeRemote]}),Q={configuration:g,resolvedVariables:i,envVariableCollections:a,shellLaunchConfig:h,workspaceId:w.id,workspaceName:this._labelService.getWorkspaceLabel(w),workspaceFolders:A,activeWorkspaceFolder:U,activeFileResource:x,shouldPersistTerminal:l,options:m,cols:u,rows:n,unicodeVersion:s,resolverEnv:f};return await this._channel.call("$createProcess",Q)}requestDetachInstance(h,g){return this._channel.call("$requestDetachInstance",[h,g])}acceptDetachInstanceReply(h,g){return this._channel.call("$acceptDetachInstanceReply",[h,g])}attachToProcess(h){return this._channel.call("$attachToProcess",[h])}detachFromProcess(h){return this._channel.call("$detachFromProcess",[h])}listProcesses(){return this._channel.call("$listProcesses")}reduceConnectionGraceTime(){return this._channel.call("$reduceConnectionGraceTime")}processBinary(h,g){return this._channel.call("$processBinary",[h,g])}start(h){return this._channel.call("$start",[h])}input(h,g){return this._channel.call("$input",[h,g])}acknowledgeDataEvent(h,g){return this._channel.call("$acknowledgeDataEvent",[h,g])}setUnicodeVersion(h,g){return this._channel.call("$setUnicodeVersion",[h,g])}shutdown(h,g){return this._channel.call("$shutdown",[h,g])}resize(h,g,p){return this._channel.call("$resize",[h,g,p])}getInitialCwd(h){return this._channel.call("$getInitialCwd",[h])}getCwd(h){return this._channel.call("$getCwd",[h])}orphanQuestionReply(h){return this._channel.call("$orphanQuestionReply",[h])}sendCommandResult(h,g,p){return this._channel.call("$sendCommandResult",[h,g,p])}installAutoReply(h,g){return this._channel.call("$installAutoReply",[h,g])}uninstallAllAutoReplies(){return this._channel.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(h){return this._channel.call("$getDefaultSystemShell",[h])}getProfiles(h,g,p){return this._channel.call("$getProfiles",[this._workspaceContextService.getWorkspace().id,h,g,p])}acceptPtyHostResolvedVariables(h,g){return this._channel.call("$acceptPtyHostResolvedVariables",[h,g])}getEnvironment(){return this._channel.call("$getEnvironment")}getWslPath(h){return this._channel.call("$getWslPath",[h])}setTerminalLayoutInfo(h){const p={workspaceId:this._workspaceContextService.getWorkspace().id,tabs:h?h.tabs:[]};return this._channel.call("$setTerminalLayoutInfo",p)}updateTitle(h,g,p){return this._channel.call("$updateTitle",[h,g,p])}updateIcon(h,g,p){return this._channel.call("$updateIcon",[h,g,p])}refreshProperty(h,g){return this._channel.call("$refreshProperty",[h,g])}updateProperty(h,g,p){return this._channel.call("$updateProperty",[h,g,p])}getTerminalLayoutInfo(){const g={workspaceId:this._workspaceContextService.getWorkspace().id};return this._channel.call("$getTerminalLayoutInfo",g)}reviveTerminalProcesses(h,g){return this._channel.call("$reviveTerminalProcesses",[h,g])}serializeTerminalState(h){return this._channel.call("$serializeTerminalState",[h])}};d=Re([Fe(2,t.IWorkbenchConfigurationService),Fe(3,k.IWorkspaceContextService),Fe(4,v.IConfigurationResolverService),Fe(5,y.IEnvironmentVariableService),Fe(6,P.IRemoteAuthorityResolverService),Fe(7,b.ILogService),Fe(8,T.IEditorService),Fe(9,C.ILabelService)],d),e.RemoteTerminalChannelClient=d}),define(we[122],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class I{constructor(v){this._proxyIdentifierBrand=void 0,this.sid=v,this.nid=++I.count}}e.ProxyIdentifier=I,I.count=0;const t=[];function b(E){const v=new I(E);return t[v.nid]=v,v}e.createProxyIdentifier=b;function P(E){return t[E].sid}e.getStringIdentifierForProxy=P;class k{constructor(v){this.value=v}}e.SerializableObjectWithBuffers=k}),define(we[248],ye([0,1,45,4,122]),function(ie,e,I,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var P;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})(P=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(m){m[m.UnknownInput=0]="UnknownInput",m[m.TextInput=1]="TextInput",m[m.TextDiffInput=2]="TextDiffInput",m[m.NotebookInput=3]="NotebookInput",m[m.NotebookDiffInput=4]="NotebookDiffInput",m[m.CustomEditorInput=5]="CustomEditorInput",m[m.WebviewEditorInput=6]="WebviewEditorInput",m[m.TerminalEditorInput=7]="TerminalEditorInput"})(k=e.TabInputKind||(e.TabInputKind={}));var E;(function(m){m[m.TAB_OPEN=0]="TAB_OPEN",m[m.TAB_CLOSE=1]="TAB_CLOSE",m[m.TAB_UPDATE=2]="TAB_UPDATE",m[m.TAB_MOVE=3]="TAB_MOVE"})(E=e.TabModelOperationKind||(e.TabModelOperationKind={}));var v;(function(m){m[m.Editable=0]="Editable",m[m.SupportsHotExit=1]="SupportsHotExit"})(v=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(m){m[m.Int8Array=1]="Int8Array",m[m.Uint8Array=2]="Uint8Array",m[m.Uint8ClampedArray=3]="Uint8ClampedArray",m[m.Int16Array=4]="Int16Array",m[m.Uint16Array=5]="Uint16Array",m[m.Int32Array=6]="Int32Array",m[m.Uint32Array=7]="Uint32Array",m[m.Float32Array=8]="Float32Array",m[m.Float64Array=9]="Float64Array",m[m.BigInt64Array=10]="BigInt64Array",m[m.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var T;(function(m){m[m.Text=1]="Text",m[m.Error=2]="Error",m[m.Rich=3]="Rich"})(T=e.CellOutputKind||(e.CellOutputKind={}));var R;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})(R=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var C;(function(m){m[m.None=0]="None",m[m.Process=1]="Process",m[m.Output=2]="Output"})(C=e.CandidatePortSource||(e.CandidatePortSource={}));class y{static mixin(l){return l._id=y._n++,l}}e.IdObject=y,y._n=0;var d;(function(m){m.label="a",m.kind="b",m.detail="c",m.documentation="d",m.sortText="e",m.filterText="f",m.preselect="g",m.insertText="h",m.insertTextRules="i",m.range="j",m.commitCharacters="k",m.additionalTextEdits="l",m.command="m",m.kindModifier="n"})(d=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var S;(function(m){m.defaultRanges="a",m.completions="b",m.isIncomplete="c",m.duration="d"})(S=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var h;(function(m){m[m.File=1]="File",m[m.Text=2]="Text",m[m.Cell=3]="Cell"})(h=e.WorkspaceEditType||(e.WorkspaceEditType={}));function g(m){if(m&&m.edits)for(const l of m.edits)typeof l.resource=="object"?l.resource=t.URI.revive(l.resource):(l.newUri=t.URI.revive(l.newUri),l.oldUri=t.URI.revive(l.oldUri)),l.metadata&&l.metadata.iconPath&&(l.metadata=(0,I.revive)(l.metadata));return m}e.reviveWorkspaceEditDto=g;var p;(function(m){m[m.Workspace=0]="Workspace",m[m.TextDocument=1]="TextDocument"})(p=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,b.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,b.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,b.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,b.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,b.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,b.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,b.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,b.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,b.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,b.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,b.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,b.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,b.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,b.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,b.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,b.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,b.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,b.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,b.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,b.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,b.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,b.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,b.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,b.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,b.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,b.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,b.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,b.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,b.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,b.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,b.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,b.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,b.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,b.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,b.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,b.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,b.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,b.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,b.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,b.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,b.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,b.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,b.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,b.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,b.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,b.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,b.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,b.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,b.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,b.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,b.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,b.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,b.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,b.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,b.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,b.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,b.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,b.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,b.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,b.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,b.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,b.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,b.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,b.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,b.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,b.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,b.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,b.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,b.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,b.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,b.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,b.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,b.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,b.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,b.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,b.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,b.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,b.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,b.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,b.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,b.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,b.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,b.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,b.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,b.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,b.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,b.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,b.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,b.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,b.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,b.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,b.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,b.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,b.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,b.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,b.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,b.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,b.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,b.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,b.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,b.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,b.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,b.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,b.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,b.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,b.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,b.createProxyIdentifier)("ExtHostTelemetry")}});var St=this&&this.__classPrivateFieldSet||function(ie,e,I,t,b){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!b:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?b.call(ie,I):b?b.value=I:e.set(ie,I),I},et=this&&this.__classPrivateFieldGet||function(ie,e,I,t){if(I==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!t:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return I==="m"?t:I==="a"?t.call(ie):t?t.value:e.get(ie)};define(we[249],ye([0,1,12,114,121,21,248,17,13,45,47,91,4,2,7,236,246,16,122,36]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C,y,d,S,h,g,p,m){"use strict";var l,u;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let n=class{constructor(c,f){l.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,u.set(this,void 0),St(this,l,c.getProxy(k.MainContext.MainThreadCommands),"f"),this._logService=f,St(this,u,c.getProxy(k.MainContext.MainThreadTelemetry),"f"),this.converter=new s(this,w=>{const A=this._apiCommands.get(w);return A?.result===o.Void?A:void 0},f),this._argumentProcessors=[{processArgument(w){return(0,D.revive)(w)}},{processArgument(w){return(0,P.cloneAndChange)(w,function(A){if(T.Range.isIRange(A))return b.Range.to(A);if(R.Position.isIPosition(A))return b.Position.to(A);if(T.Range.isIRange(A.range)&&C.URI.isUri(A.uri))return b.location.to(A);if(A instanceof g.VSBuffer)return A.buffer.buffer;if(!Array.isArray(A))return A})}}]}registerArgumentProcessor(c){this._argumentProcessors.push(c)}registerApiCommand(c){const f=this.registerCommand(!1,c.id,async(...w)=>{const A=c.args.map((x,Q)=>{if(!x.validate(w[Q]))throw new Error(`Invalid argument '${x.name}' when running '${c.id}', received: ${w[Q]}`);return x.convert(w[Q])}),U=await this.executeCommand(c.internalId,...A);return c.result.convert(U,w,this.converter)},void 0,{description:c.description,args:c.args,returns:c.result.description});return this._apiCommands.set(c.id,c),new t.Disposable(()=>{f.dispose(),this._apiCommands.delete(c.id)})}registerCommand(c,f,w,A,U,x){if(this._logService.trace("ExtHostCommands#registerCommand",f),!f.trim().length)throw new Error("invalid id");if(this._commands.has(f))throw new Error(`command '${f}' already exists`);return this._commands.set(f,{callback:w,thisArg:A,description:U,extension:x}),c&&et(this,l,"f").$registerCommand(f),new t.Disposable(()=>{this._commands.delete(f)&&c&&et(this,l,"f").$unregisterCommand(f)})}executeCommand(c,...f){return this._logService.trace("ExtHostCommands#executeCommand",c),this._doExecuteCommand(c,f,!0)}async _doExecuteCommand(c,f,w){if(this._commands.has(c))return this._executeContributedCommand(c,f,!1);{let A=!1;const U=(0,P.cloneAndChange)(f,function(x){if(x instanceof t.Position)return b.Position.from(x);if(x instanceof t.Range)return b.Range.from(x);if(x instanceof t.Location)return b.location.from(x);if(t.NotebookRange.isNotebookRange(x))return b.NotebookRange.from(x);if(x instanceof ArrayBuffer)return A=!0,g.VSBuffer.wrap(new Uint8Array(x));if(x instanceof Uint8Array)return A=!0,g.VSBuffer.wrap(x);if(x instanceof g.VSBuffer)return A=!0,x;if(!Array.isArray(x))return x});try{const x=await et(this,l,"f").$executeCommand(c,A?new p.SerializableObjectWithBuffers(U):U,w);return(0,D.revive)(x)}catch(x){if(x instanceof Error&&x.message==="$executeCommand:retry")return this._doExecuteCommand(c,f,!1);throw x}}}async _executeContributedCommand(c,f,w){const A=this._commands.get(c);if(!A)throw new Error("Unknown command");this._reportTelemetry(A,c);let{callback:U,thisArg:x,description:Q}=A;if(Q)for(let _=0;_<Q.args.length;_++)try{(0,I.validateConstraint)(f[_],Q.args[_].constraint)}catch{throw new Error(`Running the contributed command: '${c}' failed. Illegal argument '${Q.args[_].name}' - ${Q.args[_].description}`)}try{return await U.apply(x,f)}catch(_){if(c===this.converter.delegatingCommandId){const Y=this.converter.getActualCommand(...f);Y&&(c=Y.command)}throw this._logService.error(_,c,A.extension?.identifier),w?new class extends Error{constructor(){super((0,m.toErrorMessage)(_));this.id=c,this.source=A.extension?.displayName??A.extension?.name}}:_}}_reportTelemetry(c,f){!c.extension||c.extension.isBuiltin||et(this,u,"f").$publicLog2("Extension:ActionExecuted",{extensionId:c.extension.identifier.value,id:f})}$executeContributedCommand(c,...f){return this._logService.trace("ExtHostCommands#$executeContributedCommand",c),this._commands.has(c)?(f=f.map(w=>this._argumentProcessors.reduce((A,U)=>U.processArgument(A),w)),this._executeContributedCommand(c,f,!0)):Promise.reject(new Error(`Contributed command '${c}' does not exist.`))}getCommands(c=!1){return this._logService.trace("ExtHostCommands#getCommands",c),et(this,l,"f").$getCommands().then(f=>(c&&(f=f.filter(w=>w[0]!=="_")),f))}$getContributedCommandHandlerDescriptions(){const c=Object.create(null);for(let[f,w]of this._commands){let{description:A}=w;A&&(c[f]=A)}return Promise.resolve(c)}};l=new WeakMap,u=new WeakMap,n=Re([Fe(0,S.IExtHostRpcService),Fe(1,v.ILogService)],n),e.ExtHostCommands=n,e.IExtHostCommands=(0,d.createDecorator)("IExtHostCommands");class s{constructor(c,f,w){this._commands=c,this._lookupApiCommand=f,this._logService=w,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(c,f){if(!c)return;const w={$ident:void 0,id:c.command,title:c.title,tooltip:c.tooltip};if(!c.command)return w;const A=this._lookupApiCommand(c.command);if(A)w.id=A.internalId,w.arguments=A.args.map((U,x)=>U.convert(c.arguments&&c.arguments[x]));else if((0,E.isNonEmptyArray)(c.arguments)){const U=++this._cachIdPool;this._cache.set(U,c),f.add((0,y.toDisposable)(()=>{this._cache.delete(U),this._logService.trace("CommandsConverter#DISPOSE",U)})),w.$ident=U,w.id=this.delegatingCommandId,w.arguments=[U],this._logService.trace("CommandsConverter#CREATE",c.command,U)}return w}fromInternal(c){return typeof c.$ident=="number"?this._cache.get(c.$ident):{command:c.id,title:c.title,arguments:c.arguments}}getActualCommand(...c){return this._cache.get(c[0])}_executeConvertedCommand(...c){const f=this.getActualCommand(...c);return this._logService.trace("CommandsConverter#EXECUTE",c[0],f?f.command:"MISSING"),f?this._commands.executeCommand(f.command,...f.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=s;class i{constructor(c,f,w,A){this.name=c,this.description=f,this.validate=w,this.convert=A}optional(){return new i(this.name,`(optional) ${this.description}`,c=>c==null||this.validate(c),c=>c===void 0?void 0:c===null?null:this.convert(c))}with(c,f){return new i(c??this.name,f??this.description,this.validate,this.convert)}}e.ApiCommandArgument=i,i.Uri=new i("uri","Uri of a text document",a=>C.URI.isUri(a),a=>a),i.Position=new i("position","A position in a text document",a=>t.Position.isPosition(a),b.Position.from),i.Range=new i("range","A range in a text document",a=>t.Range.isRange(a),b.Range.from),i.Selection=new i("selection","A selection in a text document",a=>t.Selection.isSelection(a),b.Selection.from),i.Number=new i("number","",a=>typeof a=="number",a=>a),i.String=new i("string","",a=>typeof a=="string",a=>a),i.CallHierarchyItem=new i("item","A call hierarchy item",a=>a instanceof t.CallHierarchyItem,b.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",a=>a instanceof t.TypeHierarchyItem,b.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",a=>a instanceof h.TestItemImpl,b.TestItem.from);class o{constructor(c,f){this.description=c,this.convert=f}}e.ApiCommandResult=o,o.Void=new o("no result",a=>a);class r{constructor(c,f,w,A,U){this.id=c,this.internalId=f,this.description=w,this.args=A,this.result=U}}e.ApiCommand=r}),define(we[250],ye([0,1,83]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logRemoteEntryIfError=e.logRemoteEntry=void 0;function t(P,k,E=null){const v=(0,I.parse)(k).args;let D=v.shift();if(typeof D=="string")switch(k.severity||(k.severity="info"),E&&(/^\[/.test(E)||(E=`[${E}]`),/ $/.test(E)||(E=`${E} `),D=E+D),k.severity){case"log":case"info":P.info(D,...v);break;case"warn":P.warn(D,...v);break;case"error":P.error(D,...v);break}}e.logRemoteEntry=t;function b(P,k,E){const v=(0,I.parse)(k).args,D=v.shift();typeof D!="string"||k.severity!=="error"||(/^\[/.test(E)||(E=`[${E}]`),/ $/.test(E)||(E=`${E} `),P.error(E+D,...v))}e.logRemoteEntryIfError=b}),define(we[123],ye([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,I.createDecorator)("remoteAgentService")}),define(we[251],ye([0,1,9,2,8,194]),function(ie,e,I,t,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProviderClient=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remoteFilesystem";class k extends P.DiskFileSystemProviderClient{static register(v,D,T){const R=v.getConnection();if(!R)return t.Disposable.None;const C=new t.DisposableStore,y=(async()=>{try{const d=await v.getRawEnvironment();d?D.registerProvider(b.Schemas.vscodeRemote,C.add(new k(d,R))):T.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(d){T.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,I.getErrorMessage)(d))}})();return C.add(D.onWillActivateFileSystemProvider(d=>{d.scheme===b.Schemas.vscodeRemote&&d.join(y)})),C}constructor(v,D){super(D.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:v.os===3})}}e.RemoteFileSystemProviderClient=k}),define(we[124],ye([0,1,30,14,5,12,22,154,265,266]),function(ie,e,I,t,b,P,k,E,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class T extends Error{constructor(n,s){let i=s.message;switch(n){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=n,this.cause=s}}e.ExtractError=T;function R(u){const n=u.externalFileAttributes>>16||33188;return[448,56,7].map(s=>n&s).reduce((s,i)=>s+i,n&61440)}function C(u){if(u instanceof T)return u;let n;return/end of central directory record signature not found/.test(u.message)&&(n="CorruptZip"),new T(n,u)}function y(u,n,s,i,o,r){const a=b.dirname(n),c=b.join(i,a);if(!c.startsWith(i))return Promise.reject(new Error(E.localize(0,null,n)));const f=b.join(i,n);let w;return r.onCancellationRequested(()=>{w&&w.destroy()}),Promise.resolve(k.Promises.mkdir(c,{recursive:!0})).then(()=>new Promise((A,U)=>{if(!r.isCancellationRequested)try{w=(0,I.createWriteStream)(f,{mode:s}),w.once("close",()=>A()),w.once("error",U),u.once("error",U),u.pipe(w)}catch(x){U(x)}}))}function d(u,n,s,i){let o=(0,t.createCancelablePromise)(()=>Promise.resolve()),r=0;return i.onCancellationRequested(()=>{o.cancel(),u.close()}),new Promise((a,c)=>{const f=new t.Sequencer,w=A=>{A.isCancellationRequested||(r++,u.readEntry())};u.once("error",c),u.once("close",()=>o.then(()=>{i.isCancellationRequested||u.entryCount===r?a():c(new T("Incomplete",new Error(E.localize(1,null,r,u.entryCount))))},c)),u.readEntry(),u.on("entry",A=>{if(i.isCancellationRequested)return;if(!s.sourcePathRegex.test(A.fileName)){w(i);return}const U=A.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(U)){const _=b.join(n,U);o=(0,t.createCancelablePromise)(Y=>k.Promises.mkdir(_,{recursive:!0}).then(()=>w(Y)).then(void 0,c));return}const x=h(u,A),Q=R(A);o=(0,t.createCancelablePromise)(_=>f.queue(()=>x.then(Y=>y(Y,U,Q,n,s,_).then(()=>w(_)))).then(null,c))})})}function S(u,n=!1){return new Promise((s,i)=>{(0,v.open)(u,n?{lazyEntries:!0}:void 0,(o,r)=>{o?i(C(o)):s((0,P.assertIsDefined)(r))})})}function h(u,n){return new Promise((s,i)=>{u.openReadStream(n,(o,r)=>{o?i(C(o)):s((0,P.assertIsDefined)(r))})})}function g(u,n){return new Promise((s,i)=>{const o=new D.ZipFile;n.forEach(a=>{a.contents?o.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&o.addFile(a.localPath,a.path)}),o.end();const r=(0,I.createWriteStream)(u);o.outputStream.pipe(r),o.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>s(u))})}e.zip=g;function p(u,n,s={},i){const o=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let r=S(u,!0);return s.overwrite&&(r=r.then(a=>k.Promises.rm(n).then(()=>a))),r.then(a=>d(a,n,{sourcePathRegex:o},i))}e.extract=p;function m(u,n){return S(u).then(s=>new Promise((i,o)=>{s.on("entry",r=>{r.fileName===n&&h(s,r).then(a=>i(a),a=>o(a))}),s.once("close",()=>o(new Error(E.localize(2,null,n))))}))}function l(u,n){return m(u,n).then(s=>new Promise((i,o)=>{const r=[];s.once("error",o),s.on("data",a=>r.push(a)),s.on("end",()=>i(Buffer.concat(r)))}))}e.buffer=l}),define(we[252],ye([0,1,124,163]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function b(P){return(0,I.buffer)(P,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch{throw new Error((0,t.localize)(0,null))}})}e.getManifest=b}),define(we[125],ye([0,1,14,36,9,2,8,5,3,19,55,12,4,27,22,124,162,71,24,218,31,35,50,208,201,252,209,231,69,18,7,13,25,32,52]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C,y,d,S,h,g,p,m,l,u,n,s,i,o,r,a,c,f,w,A,U,x,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let _=class extends m.AbstractExtensionManagementService{constructor(F,M,j,Z,oe,ge,he,q,ee){super(F,M,j,q);this.environmentService=Z,this.downloadService=oe,this.fileService=he;const G=this._register(ge.createInstance(i.ExtensionsLifecycle));this.extensionsScanner=this._register(ge.createInstance(Y,te=>G.postUninstall(te))),this.manifestCache=this._register(new r.ExtensionsManifestCache(Z,this)),this.extensionsDownloader=this._register(ge.createInstance(s.ExtensionsDownloader));const z=this._register(new a.ExtensionsWatcher(this,he,Z,j,ee));this._register(z.onDidChangeExtensionsByAnotherSource(({added:te,removed:ce})=>{te.length&&this._onDidInstallExtensions.fire(te.map(J=>({identifier:J.identifier,operation:1,local:J}))),ce.forEach(J=>this._onDidUninstallExtension.fire({identifier:J}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,u.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(F){this.logService.trace("ExtensionManagementService#zip",F.identifier.id);const M=await this.collectFiles(F),j=await(0,S.zip)((0,D.joinPath)(this.environmentService.tmpDir,(0,y.generateUuid)()).fsPath,M);return C.URI.file(j)}async unzip(F){return this.logService.trace("ExtensionManagementService#unzip",F.toString()),(await this.install(F)).identifier}async getManifest(F){const M=await this.downloadVsix(F),j=E.resolve(M.fsPath);return(0,o.getManifest)(j)}getInstalled(F=null){return this.extensionsScanner.scanExtensions(F)}async install(F,M={}){this.logService.trace("ExtensionManagementService#install",F.toString());const j=await this.downloadVsix(F),Z=await(0,o.getManifest)(E.resolve(j.fsPath));if(Z.engines&&Z.engines.vscode&&!(0,c.isEngineValid)(Z.engines.vscode,this.productService.version,this.productService.date))throw new Error(h.localize(0,null,(0,u.getGalleryExtensionId)(Z.publisher,Z.name),this.productService.version));return this.installExtension(Z,j,M)}async updateMetadata(F,M){this.logService.trace("ExtensionManagementService#updateMetadata",F.identifier.id);const j={...M};return M.isPreReleaseVersion&&(j.preRelease=!0),F=await this.extensionsScanner.updateMetadata(F,j),this.manifestCache.invalidate(),F}async updateExtensionScope(F,M){return this.logService.trace("ExtensionManagementService#updateExtensionScope",F.identifier.id),F=await this.extensionsScanner.updateMetadata(F,{isMachineScoped:M}),this.manifestCache.invalidate(),F}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(F){if(F.scheme===k.Schemas.file)return F;const M=(0,D.joinPath)(this.environmentService.tmpDir,(0,y.generateUuid)());return await this.downloadService.download(F,M),M}createInstallExtensionTask(F,M,j){return C.URI.isUri(M)?new ue(F,M,j,this.galleryService,this.extensionsScanner,this.logService):new B(M,j,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(F,M){return new V(F,M,this.extensionsScanner)}async collectFiles(F){const M=async Z=>{let oe=await d.Promises.readdir(Z);oe=oe.map(q=>E.join(Z,q));const ge=await Promise.all(oe.map(q=>d.Promises.stat(q)));let he=Promise.resolve([]);return ge.forEach((q,ee)=>{const G=oe[ee];q.isFile()&&(he=he.then(z=>[...z,G])),q.isDirectory()&&(he=he.then(z=>M(G).then(te=>[...z,...te])))}),he};return(await M(F.location.fsPath)).map(Z=>({path:`extension/${E.relative(F.location.fsPath,Z)}`,localPath:Z}))}};_=Re([Fe(0,l.IExtensionGalleryService),Fe(1,x.ITelemetryService),Fe(2,A.ILogService),Fe(3,p.INativeEnvironmentService),Fe(4,g.IDownloadService),Fe(5,w.IInstantiationService),Fe(6,f.IFileService),Fe(7,U.IProductService),Fe(8,Q.IUriIdentityService)],_),e.ExtensionManagementService=_;let Y=class extends P.Disposable{constructor(F,M,j,Z){super();this.beforeRemovingExtension=F,this.fileService=M,this.extensionsScannerService=j,this.logService=Z,this.uninstalledPath=(0,D.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new I.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(F){const M={includeInvalid:!0};let j=[];return F===null||F===0?j.push(...await this.extensionsScannerService.scanAllExtensions(M)):F===1&&j.push(...await this.extensionsScannerService.scanUserExtensions(M)),j=F!==null?j.filter(Z=>Z.type===F):j,Promise.all(j.map(Z=>this.toLocalExtension(Z)))}async scanUserExtensions(F){const M=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!F,includeInvalid:!0});return Promise.all(M.map(j=>this.toLocalExtension(j)))}async extractUserExtension(F,M,j,Z){const oe=F.toString(),ge=E.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,y.generateUuid)()}`),he=E.join(this.extensionsScannerService.userExtensionsLocation.fsPath,oe);try{await d.Promises.rm(he)}catch{throw new l.ExtensionManagementError(h.localize(1,null,he,F.id),l.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(F,M,ge,Z),await this.extensionsScannerService.updateMetadata(C.URI.file(ge),{...j,installedTimestamp:Date.now()});try{await this.rename(F,ge,he,Date.now()+2*60*1e3),this.logService.info("Renamed to",he)}catch(q){try{await d.Promises.rm(ge)}catch{}if(q.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);else throw this.logService.info(`Rename failed because of ${(0,b.getErrorMessage)(q)}. Deleted from extracted location`,ge),q}return this.scanLocalExtension(C.URI.file(he),1)}async updateMetadata(F,M){return await this.extensionsScannerService.updateMetadata(F.location,M),this.scanLocalExtension(F.location,F.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...F){const M=F.map(j=>u.ExtensionKey.create(j));await this.withUninstalledExtensions(j=>{M.forEach(Z=>j[Z.toString()]=!0)})}async setInstalled(F){await this.withUninstalledExtensions(Z=>delete Z[F.toString()]);const j=(await this.scanUserExtensions(!0)).find(Z=>u.ExtensionKey.create(Z).equals(F))||null;return j?this.updateMetadata(j,{installedTimestamp:Date.now()}):null}async removeExtension(F,M){this.logService.trace(`Deleting ${M} extension from disk`,F.identifier.id,F.location.fsPath),await d.Promises.rm(F.location.fsPath),this.logService.info("Deleted from disk",F.identifier.id,F.location.fsPath)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.withUninstalledExtensions(M=>delete M[u.ExtensionKey.create(F).toString()])}async withUninstalledExtensions(F){return this.uninstalledFileLimiter.queue(async()=>{let M;try{M=await d.Promises.readFile(this.uninstalledPath,"utf8")}catch(Z){if(Z.code!=="ENOENT")throw Z}let j={};if(M)try{j=JSON.parse(M)}catch{}return F&&(F(j),Object.keys(j).length?await d.Promises.writeFile(this.uninstalledPath,JSON.stringify(j)):await d.Promises.rm(this.uninstalledPath)),j})}async extractAtLocation(F,M,j,Z){this.logService.trace(`Started extracting the extension from ${M} to ${j}`);try{await d.Promises.rm(j)}catch(oe){throw new l.ExtensionManagementError(this.joinErrors(oe).message,l.ExtensionManagementErrorCode.Delete)}try{await(0,S.extract)(M,j,{sourcePath:"extension",overwrite:!0},Z),this.logService.info(`Extracted extension to ${j}:`,F.id)}catch(oe){try{await d.Promises.rm(j)}catch{}let ge=l.ExtensionManagementErrorCode.Extract;throw oe instanceof S.ExtractError&&(oe.type==="CorruptZip"?ge=l.ExtensionManagementErrorCode.CorruptZip:oe.type==="Incomplete"&&(ge=l.ExtensionManagementErrorCode.IncompleteZip)),new l.ExtensionManagementError(oe.message,ge)}}async rename(F,M,j,Z){try{await d.Promises.rename(M,j)}catch(oe){if(v.isWindows&&oe&&oe.code==="EPERM"&&Date.now()<Z)return this.logService.info(`Failed renaming ${M} to ${j} with 'EPERM' error. Trying again...`,F.id),this.rename(F,M,j,Z);throw new l.ExtensionManagementError(oe.message||h.localize(2,null,M,j),oe.code||l.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(F,M){const j=await this.extensionsScannerService.scanExistingExtension(F,M,{includeInvalid:!0});if(j)return this.toLocalExtension(j);throw new Error(h.localize(3,null,F.path))}async toLocalExtension(F){const M=await this.fileService.resolve(F.location);let j,Z;return M.children&&(j=M.children.find(({name:oe})=>/^readme(\.txt|\.md|)$/i.test(oe))?.resource,Z=M.children.find(({name:oe})=>/^changelog(\.txt|\.md|)$/i.test(oe))?.resource),{identifier:F.identifier,type:F.type,isBuiltin:F.isBuiltin||!!F.metadata?.isBuiltin,location:F.location,manifest:F.manifest,targetPlatform:F.targetPlatform,validations:F.validations,isValid:F.isValid,readmeUrl:j,changelogUrl:Z,publisherDisplayName:F.metadata?.publisherDisplayName||null,publisherId:F.metadata?.publisherId||null,isMachineScoped:!!F.metadata?.isMachineScoped,isPreReleaseVersion:!!F.metadata?.isPreReleaseVersion,preRelease:!!F.metadata?.preRelease,installedTimestamp:F.metadata?.installedTimestamp,updated:!!F.metadata?.updated}}async removeUninstalledExtensions(){const F=await this.getUninstalledExtensions(),M=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),j=new Set;for(const ge of M)F[u.ExtensionKey.create(ge).toString()]||j.add(ge.identifier.id.toLowerCase());const Z=(0,u.groupByExtension)(M,ge=>ge.identifier);await I.Promises.settled(Z.map(async ge=>{const he=ge.sort((q,ee)=>T.rcompare(q.manifest.version,ee.manifest.version))[0];j.has(he.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(he))}));const oe=M.filter(ge=>F[u.ExtensionKey.create(ge).toString()]);await I.Promises.settled(oe.map(ge=>this.removeUninstalledExtension(ge)))}async removeOutdatedExtensions(){const F=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),M=[],j=await this.extensionsScannerService.getTargetPlatform(),Z=(0,u.groupByExtension)(F,oe=>oe.identifier);M.push(...Z.map(oe=>oe.sort((ge,he)=>{const q=T.rcompare(ge.manifest.version,he.manifest.version);return q!==0?q:ge.targetPlatform===j?-1:1}).slice(1)).flat()),await I.Promises.settled(M.map(oe=>this.removeExtension(oe,"outdated")))}joinErrors(F){const M=Array.isArray(F)?F:[F];return M.length===1?M[0]instanceof Error?M[0]:new Error(M[0]):M.reduce((j,Z)=>new Error(`${j.message}${j.message?",":""}${Z instanceof Error?Z.message:Z}`),new Error(""))}};Y=Re([Fe(1,f.IFileService),Fe(2,n.IExtensionsScannerService),Fe(3,A.ILogService)],Y);class O extends m.AbstractExtensionTask{constructor(F,M,j,Z,oe){super();this.identifier=F,this.source=M,this.options=j,this.extensionsScanner=Z,this.logService=oe,this._operation=2}get operation(){return(0,R.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(F,M){try{const j=await this.unsetUninstalledAndGetLocal(F.key);if(j)return F.metadata?this.extensionsScanner.updateMetadata(j,F.metadata):j}catch{throw v.isMacintosh?new l.ExtensionManagementError(h.localize(4,null),l.ExtensionManagementErrorCode.Internal):new l.ExtensionManagementError(h.localize(5,null),l.ExtensionManagementErrorCode.Internal)}return this.extract(F,M)}async unsetUninstalledAndGetLocal(F){if(!await this.isUninstalled(F))return null;this.logService.trace("Removing the extension from uninstalled list:",F.id);const j=await this.extensionsScanner.setInstalled(F);return this.logService.info("Removed the extension from uninstalled list:",F.id),j}async isUninstalled(F){return!!(await this.extensionsScanner.getUninstalledExtensions())[F.toString()]}async extract({zipPath:F,key:M,metadata:j},Z){let oe=await this.extensionsScanner.extractUserExtension(M,F,j,Z);return this.logService.info("Extracting completed.",M.id),oe}}class B extends O{constructor(F,M,j,Z,oe){super(F.identifier,F,M,Z,oe);this.gallery=F,this.extensionsDownloader=j}async doRun(F){const j=(await this.extensionsScanner.scanExtensions(null)).find(oe=>(0,u.areSameExtensions)(oe.identifier,this.gallery.identifier));j&&(this._operation=3);const Z=await this.downloadInstallableExtension(this.gallery,this._operation);Z.metadata.isMachineScoped=this.options.isMachineScoped||j?.isMachineScoped,Z.metadata.isBuiltin=this.options.isBuiltin||j?.isBuiltin,Z.metadata.isSystem=j?.type===0?!0:void 0,Z.metadata.updated=!!j,Z.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,Z.metadata.preRelease=this.gallery.properties.isPreReleaseVersion||((0,R.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:j?.preRelease);try{const oe=await this.installExtension(Z,F);return j&&(j.targetPlatform!==oe.targetPlatform||T.neq(j.manifest.version,oe.manifest.version))&&await this.extensionsScanner.setUninstalled(j),oe}catch(oe){throw await this.deleteDownloadedVSIX(Z.zipPath),oe}}async deleteDownloadedVSIX(F){try{await this.extensionsDownloader.delete(C.URI.file(F))}catch(M){this.logService.warn("Error while deleting the downloaded vsix",F.toString(),(0,b.getErrorMessage)(M))}}async downloadInstallableExtension(F,M){const j={id:F.identifier.uuid,publisherId:F.publisherId,publisherDisplayName:F.publisherDisplayName,targetPlatform:F.properties.targetPlatform};let Z;try{this.logService.trace("Started downloading extension:",F.identifier.id),Z=(await this.extensionsDownloader.downloadExtension(F,M)).fsPath,this.logService.info("Downloaded extension:",F.identifier.id,Z)}catch(oe){throw new l.ExtensionManagementError((0,m.joinErrors)(oe).message,l.ExtensionManagementErrorCode.Download)}try{return await(0,o.getManifest)(Z),{zipPath:Z,key:u.ExtensionKey.create(F),metadata:j}}catch(oe){throw await this.deleteDownloadedVSIX(Z),new l.ExtensionManagementError((0,m.joinErrors)(oe).message,l.ExtensionManagementErrorCode.Invalid)}}}class ue extends O{constructor(F,M,j,Z,oe,ge){super({id:(0,u.getGalleryExtensionId)(F.publisher,F.name)},M,j,oe,ge);this.manifest=F,this.location=M,this.galleryService=Z}async doRun(F){const M=new u.ExtensionKey(this.identifier,this.manifest.version),Z=(await this.extensionsScanner.scanExtensions(1)).find(ge=>(0,u.areSameExtensions)(this.identifier,ge.identifier)),oe=await this.getMetadata(this.identifier.id,this.manifest.version,F);if(oe.isMachineScoped=this.options.isMachineScoped||Z?.isMachineScoped,oe.isBuiltin=this.options.isBuiltin||Z?.isBuiltin,Z)if(this._operation=3,M.equals(new u.ExtensionKey(Z.identifier,Z.manifest.version)))try{await this.extensionsScanner.removeExtension(Z,"existing")}catch{throw new Error(h.localize(6,null,this.manifest.displayName||this.manifest.name))}else T.gt(Z.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(Z);else{const ge=await this.unsetUninstalledAndGetLocal(M);if(ge)try{await this.extensionsScanner.removeExtension(ge,"existing")}catch{throw new Error(h.localize(7,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:E.resolve(this.location.fsPath),key:M,metadata:oe},F)}async getMetadata(F,M,j){try{let[Z]=await this.galleryService.getExtensions([{id:F,version:M}],j);if(Z||([Z]=await this.galleryService.getExtensions([{id:F}],j)),Z)return{id:Z.identifier.uuid,publisherDisplayName:Z.publisherDisplayName,publisherId:Z.publisherId,isPreReleaseVersion:Z.properties.isPreReleaseVersion,preRelease:Z.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class V extends m.AbstractExtensionTask{constructor(F,M,j){super();this.extension=F,this.options=M,this.extensionsScanner=j}async doRun(F){const M=[],j=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const Z=u.ExtensionKey.create(this.extension);M.push(...j.filter(oe=>Z.equals(u.ExtensionKey.create(oe))))}else M.push(...j.filter(Z=>(0,u.areSameExtensions)(Z.identifier,this.extension.identifier)));if(!M.length)throw new Error(h.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...M),this.options.remove)for(const Z of M)try{F.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(Z)}catch(oe){throw new Error(h.localize(9,null,(0,t.toErrorMessage)(oe)))}}}}),define(we[61],ye([0,1,75,68,28,16,9,6,2,5,3,27,39,90,253]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class S{constructor(A,U=""){this.debugLabel=U,this.socket=A,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=x=>{if(this.traceSocketEvent("error",{code:x?.code,message:x?.message}),x){if(x.code==="EPIPE")return;(0,k.onUnexpectedError)(x)}},this.socket.on("error",this._errorListener)}traceSocketEvent(A,U){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,A,U)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(A){const U=x=>{this.traceSocketEvent("read",x),A(P.VSBuffer.wrap(x))};return this.socket.on("data",U),{dispose:()=>this.socket.off("data",U)}}onClose(A){const U=x=>{this.traceSocketEvent("close",{hadError:x}),A({type:0,hadError:x,error:void 0})};return this.socket.on("close",U),{dispose:()=>this.socket.off("close",U)}}onEnd(A){const U=()=>{this.traceSocketEvent("nodeEndReceived"),A()};return this.socket.on("end",U),{dispose:()=>this.socket.off("end",U)}}write(A){if(!this.socket.destroyed)try{this.traceSocketEvent("write",A),this.socket.write(A.buffer,U=>{if(U){if(U.code==="EPIPE")return;(0,k.onUnexpectedError)(U)}})}catch(U){if(U.code==="EPIPE")return;(0,k.onUnexpectedError)(U)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((A,U)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),A();return}const x=()=>{this.socket.off("close",x),this.socket.off("end",x),this.socket.off("error",x),this.socket.off("timeout",x),this.socket.off("drain",x),this.traceSocketEvent("nodeDrainEnd"),A()};this.socket.on("close",x),this.socket.on("end",x),this.socket.on("error",x),this.socket.on("timeout",x),this.socket.on("drain",x)})}}e.NodeSocket=S;var h;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize"})(h||(h={}));var g;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(g||(g={}));class p extends v.Disposable{constructor(A,U,x,Q){super();this._onData=this._register(new E.Emitter),this._onClose=this._register(new E.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=A,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:U,inflateBytesLength:x?.byteLength||0,recordInflateBytes:Q}),this._flowManager=this._register(new m(this,U,x,Q,this._onData,(_,Y)=>this._write(_,Y))),this._register(this._flowManager.onError(_=>{console.error(_),(0,k.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})})),this._incomingData=new y.ChunkStream,this._register(this.socket.onData(_=>this._acceptChunk(_))),this._register(this.socket.onClose(_=>this._onClose.fire(_)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(A,U){this.socket.traceSocketEvent(A,U)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(A){return this._onData.event(A)}onClose(A){return this._onClose.event(A)}onEnd(A){return this.socket.onEnd(A)}write(A){this._flowManager.writeMessage(A)}_write(A,U){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",A);let x=2;A.byteLength<126?x+=0:A.byteLength<2**16?x+=2:x+=8;const Q=P.VSBuffer.alloc(x);if(U?Q.writeUInt8(194,0):Q.writeUInt8(130,0),A.byteLength<126)Q.writeUInt8(A.byteLength,1);else if(A.byteLength<2**16){Q.writeUInt8(126,1);let _=1;Q.writeUInt8(A.byteLength>>>8&255,++_),Q.writeUInt8(A.byteLength>>>0&255,++_)}else{Q.writeUInt8(127,1);let _=1;Q.writeUInt8(0,++_),Q.writeUInt8(0,++_),Q.writeUInt8(0,++_),Q.writeUInt8(0,++_),Q.writeUInt8(A.byteLength>>>24&255,++_),Q.writeUInt8(A.byteLength>>>16&255,++_),Q.writeUInt8(A.byteLength>>>8&255,++_),Q.writeUInt8(A.byteLength>>>0&255,++_)}this.socket.write(P.VSBuffer.concat([Q,A]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(A){if(A.byteLength!==0){for(this._incomingData.acceptChunk(A);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const U=this._incomingData.peek(this._state.readLen),x=U.readUInt8(0),Q=(x&128)>>>7,_=(x&64)>>>6,Y=U.readUInt8(1),O=(Y&128)>>>7,B=Y&127;this._state.state=2,this._state.readLen=2+(O?4:0)+(B===126?2:0)+(B===127?8:0),this._state.fin=Q,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(_)),this._state.firstFrameOfMessage=Boolean(Q),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const U=this._incomingData.read(this._state.readLen),x=U.readUInt8(1),Q=(x&128)>>>7;let _=x&127,Y=1;_===126?_=U.readUInt8(++Y)*2**8+U.readUInt8(++Y):_===127&&(_=U.readUInt8(++Y)*0+U.readUInt8(++Y)*0+U.readUInt8(++Y)*0+U.readUInt8(++Y)*0+U.readUInt8(++Y)*2**24+U.readUInt8(++Y)*2**16+U.readUInt8(++Y)*2**8+U.readUInt8(++Y));let O=0;Q&&(O=U.readUInt8(++Y)*2**24+U.readUInt8(++Y)*2**16+U.readUInt8(++Y)*2**8+U.readUInt8(++Y)),this._state.state=3,this._state.readLen=_,this._state.mask=O,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const U=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",U),n(U,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",U),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(U,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await E.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=p;class m extends v.Disposable{constructor(A,U,x,Q,_,Y){super();this._tracer=A,this._onData=_,this._writeFn=Y,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new E.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,U?(this._zlibInflateStream=this._register(new l(this._tracer,Q,x,{windowBits:15})),this._zlibDeflateStream=this._register(new u(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(O=>this._onError.fire(O))),this._register(this._zlibDeflateStream.onError(O=>this._onError.fire(O)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:P.VSBuffer.alloc(0)}writeMessage(A){this._writeQueue.push(A),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const A=this._writeQueue.shift();if(this._zlibDeflateStream){const U=await this._deflateMessage(this._zlibDeflateStream,A);this._writeFn(U,!0)}else this._writeFn(A,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(A,U){return new Promise((x,Q)=>{A.write(U),A.flush(_=>x(_))})}acceptFrame(A,U,x){this._readQueue.push({data:A,isCompressed:U,isLastFrameOfMessage:x}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const A=this._readQueue.shift();if(this._zlibInflateStream&&A.isCompressed){const U=await this._inflateFrame(this._zlibInflateStream,A.data,A.isLastFrameOfMessage);this._onData.fire(U)}else this._onData.fire(A.data)}this._isProcessingReadQueue=!1}}_inflateFrame(A,U,x){return new Promise((Q,_)=>{A.write(U),x&&A.write(P.VSBuffer.fromByteArray([0,0,255,255])),A.flush(Y=>Q(Y))})}}class l extends v.Disposable{constructor(A,U,x,Q){super();this._tracer=A,this._recordInflateBytes=U,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=d.createInflateRaw(Q),this._zlibInflate.on("error",_=>{this._tracer.traceSocketEvent("zlibInflateError",{message:_?.message,code:_?.code}),this._onError.fire(_)}),this._zlibInflate.on("data",_=>{this._tracer.traceSocketEvent("zlibInflateData",_),this._pendingInflateData.push(P.VSBuffer.wrap(_))}),x&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",x.buffer),this._zlibInflate.write(x.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?P.VSBuffer.concat(this._recordedInflateBytes):P.VSBuffer.alloc(0)}write(A){this._recordInflateBytes&&this._recordedInflateBytes.push(A.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",A),this._zlibInflate.write(A.buffer)}flush(A){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const U=P.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,A(U)})}}class u extends v.Disposable{constructor(A,U){super();this._tracer=A,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=d.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",x=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:x?.message,code:x?.code}),this._onError.fire(x)}),this._zlibDeflate.on("data",x=>{this._tracer.traceSocketEvent("zlibDeflateData",x),this._pendingDeflateData.push(P.VSBuffer.wrap(x))})}write(A){this._tracer.traceSocketEvent("zlibDeflateWrite",A.buffer),this._zlibDeflate.write(A.buffer)}flush(A){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let U=P.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,U=U.slice(0,U.byteLength-4),A(U)})}}function n(w,A){if(A===0)return;let U=w.byteLength>>>2;for(let B=0;B<U;B++){const ue=w.readUInt32BE(B*4);w.writeUInt32BE(ue^A,B*4)}let x=U*4,Q=w.byteLength-x;const _=A>>>24&255,Y=A>>>16&255,O=A>>>8&255;Q>=1&&w.writeUInt8(w.readUInt8(x)^_,x),Q>=2&&w.writeUInt8(w.readUInt8(x+1)^Y,x+1),Q>=3&&w.writeUInt8(w.readUInt8(x+2)^O,x+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const s={[2]:107,[1]:103};function i(){const w=(0,R.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;let A;return e.XDG_RUNTIME_DIR?A=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${w}.sock`):A=(0,D.join)((0,b.tmpdir)(),`vscode-ipc-${w}.sock`),r(A),A}e.createRandomIPCHandle=i;function o(w,A,U){const x=(0,I.createHash)("md5").update(w).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${x}-${U}-${A}-sock`;let Q;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?Q=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${x.substr(0,8)}-${U}-${A}.sock`):Q=(0,D.join)(w,`${U}-${A}.sock`),r(Q),Q}e.createStaticIPCHandle=o;function r(w){const A=s[T.platform];typeof A=="number"&&w.length>=A&&console.warn(`WARNING: IPC handle "${w}" is longer than ${A} chars, try a shorter --user-data-dir`)}class a extends C.IPCServer{constructor(A){super(a.toClientConnectionEvent(A));this.server=A}static toClientConnectionEvent(A){const U=E.Event.fromNodeEventEmitter(A,"connection");return E.Event.map(U,x=>({protocol:new y.Protocol(new S(x,"ipc-server-connection")),onDidClientDisconnect:E.Event.once(E.Event.fromNodeEventEmitter(x,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=a;function c(w){return new Promise((A,U)=>{const x=(0,t.createServer)();x.on("error",U),x.listen(w,()=>{x.removeListener("error",U),A(new a(x))})})}e.serve=c;function f(w,A){return new Promise((U,x)=>{const Q=(0,t.createConnection)(w,()=>{Q.removeListener("error",x),U(y.Client.fromSocket(new S(Q,`ipc-client${A}`),A))});Q.once("error",x)})}e.connect=f}),define(we[126],ye([0,1,76,14,16,9,2,12,23,24,77,13,212,253]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let d=class extends k.Disposable{constructor(h,g,p){super();this.environmentService=g,this.logService=p,this.configure(h.getValue()),this._register(h.onDidChangeConfiguration(()=>this.configure(h.getValue()),this))}configure(h){this.proxyUrl=h.http&&h.http.proxy,this.strictSSL=!!(h.http&&h.http.proxyStrictSSL),this.authorization=h.http&&h.http.proxyAuthorization}async request(h,g){this.logService.trace("RequestService#request (node) - begin",h.url);const{proxyUrl:p,strictSSL:m}=this;let l;try{l=await(0,T.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(s){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",s))}const u={...process.env,...l},n=h.agent?h.agent:await(0,C.getProxyAgent)(h.url||"",u,{proxyUrl:p,strictSSL:m});h.agent=n,h.strictSSL=m,this.authorization&&(h.headers={...h.headers||{},"Proxy-Authorization":this.authorization});try{const s=await this._request(h,g);return this.logService.trace("RequestService#request (node) - success",h.url),s}catch(s){throw this.logService.trace("RequestService#request (node) - error",h.url,s),s}}async getNodeRequest(h){return((0,I.parse)(h.url).protocol==="https:"?await new Promise((m,l)=>{ie(["https"],m,l)}):await new Promise((m,l)=>{ie(["http"],m,l)})).request}_request(h,g){return t.Promises.withAsyncBody(async(p,m)=>{let l;const u=(0,I.parse)(h.url),n=h.getRawRequest?h.getRawRequest(h):await this.getNodeRequest(h),s={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,E.isBoolean)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(s.auth=h.user+":"+h.password),l=n(s,i=>{const o=(0,E.isNumber)(h.followRedirects)?h.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&o>0&&i.headers.location)this._request({...h,url:i.headers.location,followRedirects:o-1},g).then(p,m);else{let r=i;i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,y.createGunzip)())),p({res:i,stream:(0,b.streamToBufferReadableStream)(r)})}}),l.on("error",m),h.timeout&&l.setTimeout(h.timeout),h.data&&typeof h.data=="string"&&l.write(h.data),l.end(),g.onCancellationRequested(()=>{l.abort(),m((0,P.canceled)())})})}async resolveProxy(h){}};d=Re([Fe(0,v.IConfigurationService),Fe(1,D.INativeEnvironmentService),Fe(2,R.ILogService)],d),e.RequestService=d}),define(we[127],ye([0,1,38,68,112,8,5,16,6,61,77,13,42,3,250,53,111,2]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C,y,d,S,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function p(i={},o,r,a,c,f){const w=await(0,b.getNLSConfiguration)(r,c.userDataPath);let A={};if(o)try{A=await(0,T.getResolvedShellEnv)(f,c.args,process.env)}catch(O){f.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",O)}const x={...process.env,...A,VSCODE_LOG_NATIVE:String(a),VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_LOG_STACK:"false",VSCODE_NLS_CONFIG:JSON.stringify(w,void 0,0),...i},Q=c.isBuilt?(0,k.join)(c.appRoot,"bin"):(0,k.join)(c.appRoot,"resources","server","bin-dev"),_=(0,k.join)(Q,"remote-cli");let Y=u(x,"PATH");return Y?Y=_+k.delimiter+Y:Y=_,n(x,"PATH",Y),c.args["without-browser-env-var"]||(x.BROWSER=(0,k.join)(Q,"helpers",y.isWindows?"browser.cmd":"browser.sh")),s(x),x}e.buildUserEnvironment=p;class m{constructor(o,r){this.socket=o,this.initialDataChunk=r}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let o,r,a;return this.socket instanceof D.NodeSocket?(o=!0,r=!1,a=E.VSBuffer.alloc(0)):(o=!1,r=this.socket.permessageDeflate,a=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:o,permessageDeflate:r,inflateBytes:a.buffer.toString("base64")}}}let l=class{constructor(o,r,a,c,f,w,A){this._reconnectionToken=o,this._environmentService=f,this._logService=w,this._extensionHostStatusService=A,this._onClose=new v.Emitter,this.onClose=this._onClose.event,this._canSendSocket=!y.isWindows||!this._environmentService.args["socket-path"],this._disposed=!1,this._remoteAddress=r,this._extensionHostProcess=null,this._connectionData=new m(a,c),this._log("New connection established.")}get _logPrefix(){return`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] `}_log(o){this._logService.info(`${this._logPrefix}${o}`)}_logError(o){this._logService.error(`${this._logPrefix}${o}`)}async _pipeSockets(o,r){const a=new g.DisposableStore;a.add(r.socket),a.add((0,g.toDisposable)(()=>{o.destroy()}));const c=()=>{a.dispose()};a.add(r.socket.onEnd(c)),a.add(r.socket.onClose(c)),a.add(v.Event.fromNodeEventEmitter(o,"end")(c)),a.add(v.Event.fromNodeEventEmitter(o,"close")(c)),a.add(v.Event.fromNodeEventEmitter(o,"error")(c)),a.add(r.socket.onData(f=>o.write(f.buffer))),a.add(v.Event.fromNodeEventEmitter(o,"data")(f=>{r.socket.write(E.VSBuffer.wrap(f))})),r.initialDataChunk.byteLength>0&&o.write(r.initialDataChunk.buffer)}async _sendSocketToExtensionHost(o,r){await r.socketDrain();const a=r.toIExtHostSocketMessage();let c;r.socket instanceof D.NodeSocket?c=r.socket.socket:c=r.socket.socket.socket,o.send(a,c)}shortenReconnectionGraceTimeIfNecessary(){if(!this._extensionHostProcess)return;const o={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this._extensionHostProcess.send(o)}acceptReconnection(o,r,a){this._remoteAddress=o,this._log("The client has reconnected.");const c=new m(r,a);if(!this._extensionHostProcess){this._connectionData=c;return}this._sendSocketToExtensionHost(this._extensionHostProcess,c)}_cleanResources(){this._disposed||(this._disposed=!0,this._connectionData&&(this._connectionData.socket.end(),this._connectionData=null),this._extensionHostProcess&&(this._extensionHostProcess.kill(),this._extensionHostProcess=null),this._onClose.fire(void 0))}async start(o){try{let r=[];o.port&&!process.pkg&&(r=[`--inspect${o.break?"-brk":""}=${o.port}`]);const a=await p(o.env,!0,o.language,!!o.debugId,this._environmentService,this._logService);(0,S.removeDangerousEnvVariables)(a);let c;if(this._canSendSocket)a.VSCODE_EXTHOST_WILL_SEND_SOCKET="true",c=null;else{const{namedPipeServer:_,pipeName:Y}=await this._listenOnPipe();a.VSCODE_IPC_HOOK_EXTHOST=Y,c=_}const f={env:a,execArgv:r,silent:!0},w=["--type=extensionHost","--transformURIs"],A=this._environmentService.args["use-host-proxy"];w.push(`--useHostProxy=${A?"true":"false"}`),this._extensionHostProcess=I.fork(P.FileAccess.asFileUri("bootstrap-fork",ie).fsPath,w,f);const U=this._extensionHostProcess.pid;this._log(`<${U}> Launched Extension Host Process.`),this._extensionHostProcess.stdout.setEncoding("utf8"),this._extensionHostProcess.stderr.setEncoding("utf8");const x=v.Event.fromNodeEventEmitter(this._extensionHostProcess.stdout,"data"),Q=v.Event.fromNodeEventEmitter(this._extensionHostProcess.stderr,"data");if(x(_=>this._log(`<${U}> ${_}`)),Q(_=>this._log(`<${U}><stderr> ${_}`)),this._extensionHostProcess.on("message",_=>{_&&_.type==="__$console"&&(0,d.logRemoteEntry)(this._logService,_,`${this._logPrefix}<${U}>`)}),this._extensionHostProcess.on("error",_=>{this._logError(`<${U}> Extension Host Process had an error`),this._logService.error(_),this._cleanResources()}),this._extensionHostProcess.on("exit",(_,Y)=>{this._extensionHostStatusService.setExitInfo(this._reconnectionToken,{code:_,signal:Y}),this._log(`<${U}> Extension Host Process exited with code: ${_}, signal: ${Y}.`),this._cleanResources()}),c)c.on("connection",_=>{c.close(),this._pipeSockets(_,this._connectionData)});else{const _=Y=>{Y.type==="VSCODE_EXTHOST_IPC_READY"&&(this._extensionHostProcess.removeListener("message",_),this._sendSocketToExtensionHost(this._extensionHostProcess,this._connectionData),this._connectionData=null)};this._extensionHostProcess.on("message",_)}}catch(r){console.error("ExtensionHostConnection errored"),r&&console.error(r)}}_listenOnPipe(){return new Promise((o,r)=>{const a=(0,D.createRandomIPCHandle)(),c=t.createServer();c.on("error",r),c.listen(a,()=>{c&&c.removeListener("error",r),o({pipeName:a,namedPipeServer:c})})})}};l=Re([Fe(4,C.IServerEnvironmentService),Fe(5,R.ILogService),Fe(6,h.IExtensionHostStatusService)],l),e.ExtensionHostConnection=l;function u(i,o){const r=Object.keys(i).filter(c=>c.toLowerCase()===o.toLowerCase()),a=r.length>0?r[0]:o;return i[a]}function n(i,o,r){const a=Object.keys(i).filter(f=>f.toLowerCase()===o.toLowerCase()),c=a.length>0?a[0]:o;i[c]=r}function s(i){for(let o of Object.keys(i))i[o]===null&&delete i[o]}}),define(we[254],ye([0,1,72,13,56,102,23,51,126,41,32,31,106,125,97,48,2,98,58,8,18,25,100,123,42,104,73,105,9,4,5,26,210,71,52,109,54,3,50,113,59]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C,y,d,S,h,g,p,m,l,u,n,s,i,o,r,a,c,f,w,A,U,x,Q,_,Y,O,B,ue,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class $ extends h.Disposable{constructor(Z,oe){super();this.args=Z,this.remoteDataFolder=oe,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){await(await this.initServices()).invokeFunction(async oe=>{const ge=oe.get(t.ILogService),he=oe.get(R.IExtensionManagementCLIService);try{await this.doRun(he)}catch(q){throw ge.error(q),console.error((0,c.getErrorMessage)(q)),q}})}async initServices(){const Z=new I.ServiceCollection,oe={_serviceBrand:void 0,...S.default};Z.set(u.IProductService,oe);const ge=new i.ServerEnvironmentService(this.args,oe);Z.set(i.IServerEnvironmentService,ge);const he=new t.LogService(new n.SpdLogLogger(s.RemoteExtensionLogFileName,(0,w.join)(ge.logsPath,`${s.RemoteExtensionLogFileName}.log`),!0,!1,(0,t.getLogLevel)(ge)));Z.set(t.ILogService,he),he.trace(`Remote configuration data at ${this.remoteDataFolder}`),he.trace("process arguments:",this.args);const q=this._register(new g.FileService(he));Z.set(l.IFileService,q),q.registerProvider(m.Schemas.file,this._register(new p.DiskFileSystemProvider(he)));const ee=this._register(new P.ConfigurationService(ge.settingsResource,q,new V.NullPolicyService,he));return await ee.initialize(),Z.set(k.IConfigurationService,ee),Z.set(Q.IUriIdentityService,new _.UriIdentityService(q)),Z.set(E.IRequestService,new b.SyncDescriptor(v.RequestService)),Z.set(x.IDownloadService,new b.SyncDescriptor(U.DownloadService)),Z.set(T.ITelemetryService,D.NullTelemetryService),Z.set(R.IExtensionGalleryService,new b.SyncDescriptor(C.ExtensionGalleryServiceWithNoStorageService)),Z.set(B.IExtensionsScannerService,new b.SyncDescriptor(ue.ExtensionsScannerService)),Z.set(R.IExtensionManagementService,new b.SyncDescriptor(y.ExtensionManagementService)),Z.set(R.IExtensionManagementCLIService,new b.SyncDescriptor(o.ExtensionManagementCLIService)),Z.set(r.ILanguagePackService,new b.SyncDescriptor(a.NativeLanguagePackService)),new d.InstantiationService(Z)}async doRun(Z){if(this.args["list-extensions"])return Z.listExtensions(!!this.args["show-versions"],this.args.category);if(this.args["install-extension"]||this.args["install-builtin-extension"]){const oe={isMachineScoped:!!this.args["do-not-sync"],installPreReleaseVersion:!!this.args["pre-release"]};return Z.installExtensions(this.asExtensionIdOrVSIX(this.args["install-extension"]||[]),this.args["install-builtin-extension"]||[],oe,!!this.args.force)}else{if(this.args["uninstall-extension"])return Z.uninstallExtensions(this.asExtensionIdOrVSIX(this.args["uninstall-extension"]),!!this.args.force);if(this.args["locate-extension"])return Z.locateExtension(this.args["locate-extension"])}}asExtensionIdOrVSIX(Z){return Z.map(oe=>/\.vsix$/i.test(oe)?f.URI.file((0,w.isAbsolute)(oe)?oe:(0,w.join)((0,A.cwd)(),oe)):oe)}}function F(j){setTimeout(()=>process.exit(j),0)}async function M(j,Z,oe){if(j.help){const he=S.default.serverApplicationName+(O.isWindows?".cmd":"");console.log((0,Y.buildHelpMessage)(S.default.nameLong,he,S.default.version,oe,{noInputFiles:!0,noPipe:!0}));return}if(j.version){console.log((0,Y.buildVersionMessage)(S.default.version,S.default.commit));return}const ge=new $(j,Z);try{await ge.run(),F(0)}catch{F(1)}finally{ge.dispose()}}e.run=M}),define(we[255],ye([0,1,61,267,30,249,4,13,110]),function(ie,e,I,t,b,P,k,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class D{constructor(C,y,d){this._commands=C,this.logService=y,this._ipcHandlePath=d,this._server=t.createServer((S,h)=>this.onRequest(S,h)),this.setup().catch(S=>(y.error(S),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",C=>this.logService.error(C))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(C,y){const d=(h,g)=>{y.writeHead(h,{"content-type":"application/json"}),y.end(JSON.stringify(g||null),p=>p&&this.logService.error(p))},S=[];C.setEncoding("utf8"),C.on("data",h=>S.push(h)),C.on("end",async()=>{try{const h=JSON.parse(S.join(""));let g;switch(h.type){case"open":g=await this.open(h);break;case"openExternal":g=await this.openExternal(h);break;case"status":g=await this.getStatus(h);break;case"extensionManagement":g=await this.manageExtensions(h);break;default:d(404,`Unknown message type: ${h.type}`);break}d(200,g)}catch(h){const g=h instanceof Error?h.message:JSON.stringify(h);d(500,g),this.logService.error("Error while processing pipe request",h)}})}async open(C){const{fileURIs:y,folderURIs:d,forceNewWindow:S,diffMode:h,addMode:g,forceReuseWindow:p,gotoLineMode:m,waitMarkerFilePath:l,remoteAuthority:u}=C,n=[];if(Array.isArray(d))for(const r of d)try{n.push({folderUri:k.URI.parse(r)})}catch{}if(Array.isArray(y))for(const r of y)try{(0,v.hasWorkspaceFileExtension)(r)?n.push({workspaceUri:k.URI.parse(r)}):n.push({fileUri:k.URI.parse(r)})}catch{}const s=l?k.URI.file(l):void 0,o={forceNewWindow:S,diffMode:h,addMode:g,gotoLineMode:m,forceReuseWindow:p,preferNewWindow:!p&&!s&&!g,waitMarkerFileURI:s,remoteAuthority:u};return this._commands.executeCommand("_remoteCLI.windowOpen",n,o),""}async openExternal(C){for(const y of C.uris){const d=k.URI.parse(y),S=d.scheme==="file"?d:y;await this._commands.executeCommand("_remoteCLI.openExternal",S)}}async manageExtensions(C){const y=S=>S?.map(h=>/\.vsix$/i.test(h)?k.URI.parse(h):h),d={list:C.list,install:y(C.install),uninstall:y(C.uninstall),force:C.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",d)}async getStatus(C){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&b.existsSync(this._ipcHandlePath)&&b.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=D;let T=class extends D{constructor(C,y){super(C,y,(0,I.createRandomIPCHandle)())}};T=Re([Fe(0,P.IExtHostCommands),Fe(1,E.ILogService)],T),e.CLIServer=T}),define(we[256],ye([0,1,28,6,21,2,5,3,4,61,60,255,240,117,241,244,127]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C,y,d,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class g extends S.AbstractVariableResolverService{constructor(l,u,n,s,i){super({getFolderUri:o=>{const r=u.filter(a=>a.name===o);if(r&&r.length>0)return r[0].uri},getWorkspaceFolderCount:()=>u.length,getConfigurationValue:(o,r)=>s[`config:${r}`],getExecPath:()=>l.VSCODE_EXEC_PATH,getAppRoot:()=>l.VSCODE_CWD,getFilePath:()=>{if(n)return k.normalize(n.fsPath)},getSelectedText:()=>s.selectedText,getLineNumber:()=>s.lineNumber,getExtension:async o=>{const a=(await i.getInstalled()).find(c=>c.identifier.id===o);return a&&{extensionLocation:a.location}}},void 0,Promise.resolve(I.homedir()),Promise.resolve(l))}}class p extends P.Disposable{constructor(l,u,n,s,i){super();this._environmentService=l,this._logService=u,this._ptyService=n,this._productService=s,this._extensionManagementService=i,this._lastReqId=0,this._pendingCommands=new Map,this._onExecuteCommand=this._register(new t.Emitter),this.onExecuteCommand=this._onExecuteCommand.event}async call(l,u,n){switch(u){case"$restartPtyHost":return this._ptyService.restartPtyHost?.apply(this._ptyService,n);case"$createProcess":{const s=(0,T.createURITransformer)(l.remoteAuthority);return this._createProcess(s,n)}case"$attachToProcess":return this._ptyService.attachToProcess.apply(this._ptyService,n);case"$detachFromProcess":return this._ptyService.detachFromProcess.apply(this._ptyService,n);case"$listProcesses":return this._ptyService.listProcesses.apply(this._ptyService,n);case"$orphanQuestionReply":return this._ptyService.orphanQuestionReply.apply(this._ptyService,n);case"$acceptPtyHostResolvedVariables":return this._ptyService.acceptPtyHostResolvedVariables?.apply(this._ptyService,n);case"$start":return this._ptyService.start.apply(this._ptyService,n);case"$input":return this._ptyService.input.apply(this._ptyService,n);case"$acknowledgeDataEvent":return this._ptyService.acknowledgeDataEvent.apply(this._ptyService,n);case"$shutdown":return this._ptyService.shutdown.apply(this._ptyService,n);case"$resize":return this._ptyService.resize.apply(this._ptyService,n);case"$getInitialCwd":return this._ptyService.getInitialCwd.apply(this._ptyService,n);case"$getCwd":return this._ptyService.getCwd.apply(this._ptyService,n);case"$processBinary":return this._ptyService.processBinary.apply(this._ptyService,n);case"$sendCommandResult":return this._sendCommandResult(n[0],n[1],n[2]);case"$installAutoReply":return this._ptyService.installAutoReply.apply(this._ptyService,n);case"$uninstallAllAutoReplies":return this._ptyService.uninstallAllAutoReplies.apply(this._ptyService,n);case"$getDefaultSystemShell":return this._getDefaultSystemShell.apply(this,n);case"$getProfiles":return this._getProfiles.apply(this,n);case"$getEnvironment":return this._getEnvironment();case"$getWslPath":return this._getWslPath(n[0]);case"$getTerminalLayoutInfo":return this._ptyService.getTerminalLayoutInfo(n);case"$setTerminalLayoutInfo":return this._ptyService.setTerminalLayoutInfo(n);case"$serializeTerminalState":return this._ptyService.serializeTerminalState.apply(this._ptyService,n);case"$reviveTerminalProcesses":return this._ptyService.reviveTerminalProcesses.apply(this._ptyService,n);case"$setUnicodeVersion":return this._ptyService.setUnicodeVersion.apply(this._ptyService,n);case"$reduceConnectionGraceTime":return this._reduceConnectionGraceTime();case"$updateIcon":return this._ptyService.updateIcon.apply(this._ptyService,n);case"$updateTitle":return this._ptyService.updateTitle.apply(this._ptyService,n);case"$updateProperty":return this._ptyService.updateProperty.apply(this._ptyService,n);case"$refreshProperty":return this._ptyService.refreshProperty.apply(this._ptyService,n);case"$requestDetachInstance":return this._ptyService.requestDetachInstance(n[0],n[1]);case"$acceptDetachedInstance":return this._ptyService.acceptDetachInstanceReply(n[0],n[1])}throw new Error(`IPC Command ${u} not found`)}listen(l,u,n){switch(u){case"$onPtyHostExitEvent":return this._ptyService.onPtyHostExit||t.Event.None;case"$onPtyHostStartEvent":return this._ptyService.onPtyHostStart||t.Event.None;case"$onPtyHostUnresponsiveEvent":return this._ptyService.onPtyHostUnresponsive||t.Event.None;case"$onPtyHostResponsiveEvent":return this._ptyService.onPtyHostResponsive||t.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this._ptyService.onPtyHostRequestResolveVariables||t.Event.None;case"$onProcessDataEvent":return this._ptyService.onProcessData;case"$onProcessReadyEvent":return this._ptyService.onProcessReady;case"$onProcessExitEvent":return this._ptyService.onProcessExit;case"$onProcessReplayEvent":return this._ptyService.onProcessReplay;case"$onProcessOrphanQuestion":return this._ptyService.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this._ptyService.onDidRequestDetach||t.Event.None;case"$onDidChangeProperty":return this._ptyService.onDidChangeProperty;default:break}throw new Error("Not supported")}async _createProcess(l,u){const n={name:u.shellLaunchConfig.name,executable:u.shellLaunchConfig.executable,args:u.shellLaunchConfig.args,cwd:typeof u.shellLaunchConfig.cwd=="string"||typeof u.shellLaunchConfig.cwd=="undefined"?u.shellLaunchConfig.cwd:v.URI.revive(l.transformIncoming(u.shellLaunchConfig.cwd)),env:u.shellLaunchConfig.env,useShellEnvironment:u.shellLaunchConfig.useShellEnvironment},s=await(0,h.buildUserEnvironment)(u.resolverEnv,!!u.shellLaunchConfig.useShellEnvironment,E.language,!1,this._environmentService,this._logService);this._logService.trace("baseEnv",s);const i=B=>({uri:v.URI.revive(l.transformIncoming(B.uri)),name:B.name,index:B.index,toResource:()=>{throw new Error("Not implemented")}}),o=u.workspaceFolders.map(i),r=u.activeWorkspaceFolder?i(u.activeWorkspaceFolder):void 0,a=u.activeFileResource?v.URI.revive(l.transformIncoming(u.activeFileResource)):void 0,c=new g(s,o,a,u.resolvedVariables,this._extensionManagementService),f=d.createVariableResolver(r,process.env,c),w=await d.getCwd(n,I.homedir(),f,r?.uri,u.configuration["terminal.integrated.cwd"],this._logService);n.cwd=w;const A=E.isWindows?"terminal.integrated.env.windows":E.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",U=u.configuration[A],x=await d.createTerminalEnvironment(n,U,f,this._productService.version,u.configuration["terminal.integrated.detectLocale"],s);if(!n.strictEnv){const B=[];for(const[$,F]of u.envVariableCollections)B.push([$,{map:(0,y.deserializeEnvironmentVariableCollection)(F)}]);const ue=new Map(B);await new C.MergedEnvironmentVariableCollection(ue).applyToProcessEnvironment(x,f)}this._logService.debug("Terminal process launching on remote agent",{shellLaunchConfig:n,initialCwd:w,cols:u.cols,rows:u.rows,env:x});const Q=(0,D.createRandomIPCHandle)();x.VSCODE_IPC_HOOK_CLI=Q;const _={executeCommand:(B,...ue)=>this._executeCommand(B,ue,l)},Y=new R.CLIServerBase(_,this._logService,Q),O=await this._ptyService.createProcess(n,w,u.cols,u.rows,u.unicodeVersion,x,s,u.options,u.shouldPersistTerminal,u.workspaceId,u.workspaceName);return this._ptyService.onProcessExit(B=>B.id===O&&Y.dispose()),{persistentTerminalId:O,resolvedShellLaunchConfig:n}}_executeCommand(l,u,n){let s,i;const o=new Promise((c,f)=>{s=c,i=f}),r=++this._lastReqId;this._pendingCommands.set(r,{resolve:s,reject:i,uriTransformer:n});const a=(0,b.cloneAndChange)(u,c=>{if(c&&c.$mid===1)return n.transformOutgoing(c);if(c&&c instanceof v.URI)return n.transformOutgoingURI(c)});return this._onExecuteCommand.fire({reqId:r,commandId:l,commandArgs:a}),o}_sendCommandResult(l,u,n){const s=this._pendingCommands.get(l);if(!s)return;this._pendingCommands.delete(l);const i=(0,b.cloneAndChange)(n,o=>{if(o&&o.$mid===1)return s.uriTransformer.transformIncoming(o)});u?s.reject(i):s.resolve(i)}_getDefaultSystemShell(l){return this._ptyService.getDefaultSystemShell(l)}async _getProfiles(l,u,n,s){return this._ptyService.getProfiles?.(l,u,n,s)||[]}_getEnvironment(){return{...process.env}}_getWslPath(l){return this._ptyService.getWslPath(l)}_reduceConnectionGraceTime(){return this._ptyService.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=p}),define(we[257],ye([0,1,28,6,2,8,5,87,22,39,23,102,70,205,181,71,182,192,184,24,106,31,104,193,125,18,98,58,56,97,72,73,105,13,99,100,48,25,51,211,126,214,32,41,222,223,107,230,52,109,237,238,216,221,256,60,42,247,123,251,111,50,113,59]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C,y,d,S,h,g,p,m,l,u,n,s,i,o,r,a,c,f,w,A,U,x,Q,_,Y,O,B,ue,V,$,F,M,j,Z,oe,ge,he,q,ee,G,z,te,ce,J,se,me,X,re,W,K,le,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SocketServer=e.setupServerServices=void 0;const De="monacoworkbench";async function Te(qe,ze,He,Qe){const Ve=new w.ServiceCollection,ae=new de,Ce={_serviceBrand:void 0,...Y.default};Ve.set(O.IProductService,Ce);const ke=new se.ServerEnvironmentService(ze,Ce);Ve.set(m.IEnvironmentService,ke),Ve.set(m.INativeEnvironmentService,ke);const Le=new x.LogService(new _.SpdLogLogger(X.RemoteExtensionLogFileName,k.join(ke.logsPath,`${X.RemoteExtensionLogFileName}.log`),!0,!1,(0,x.getLogLevel)(ke))),Be=new x.MultiplexLogService([new be((0,x.getLogLevel)(ke)),Le]);Ve.set(x.ILogService,Be),setTimeout(()=>Ne(ke.logsPath).then(null,at=>Be.error(at)),1e4),Be.trace(`Remote configuration data at ${He}`),Be.trace("process arguments:",ke.args),Array.isArray(Ce.serverGreeting)&&Le.info(`

${Ce.serverGreeting.join(`
`)}

`),ae.registerChannel(d.ExtensionHostDebugBroadcastChannel.ChannelName,new d.ExtensionHostDebugBroadcastChannel);const Me=new D.StaticRouter(at=>at.clientId==="renderer");ae.registerChannel("logger",new Q.LogLevelChannel(Be));const je=Qe.add(new r.FileService(Be));Ve.set(o.IFileService,je),je.registerProvider(P.Schemas.file,Qe.add(new a.DiskFileSystemProvider(Be)));const Ke=new R.ConfigurationService(ke.machineSettingsResource,je,new ve.NullPolicyService,Be);Ve.set(T.IConfigurationService,Ke);const Xe=new W.ExtensionHostStatusService;Ve.set(W.IExtensionHostStatusService,Xe),Ve.set(he.IUriIdentityService,new q.UriIdentityService(je)),Ve.set(B.IRequestService,new c.SyncDescriptor(V.RequestService));let xe=M.NullAppender;const tt=await(0,E.getMachineId)();if((0,M.supportsTelemetry)(Ce,ke)){Ce.aiConfig&&Ce.aiConfig.asimovKey&&(xe=new j.AppInsightsAppender(De,null,Ce.aiConfig.asimovKey),Qe.add((0,b.toDisposable)(()=>xe.flush())));const at={appenders:[xe],commonProperties:(0,$.resolveCommonProperties)(je,(0,I.release)(),(0,I.hostname)(),process.arch,Ce.commit,Ce.version+"-remote",tt,Ce.msftInternalDomains,ke.installSourcePath,"remoteAgent"),piiPaths:(0,M.getPiiPathsFromEnvironment)(ke)},ut=ke.args["telemetry-level"];let ft=3;ut==="all"?ft=3:ut==="error"?ft=2:ut==="crash"?ft=1:ut!==void 0&&(ft=0),Ve.set(te.IServerTelemetryService,new c.SyncDescriptor(te.ServerTelemetryService,[at,ft]))}else Ve.set(te.IServerTelemetryService,te.ServerNullTelemetryService);Ve.set(u.IExtensionGalleryService,new c.SyncDescriptor(l.ExtensionGalleryServiceWithNoStorageService));const nt=ae.getChannel("download",Me);Ve.set(S.IDownloadService,new h.DownloadServiceChannelClient(nt,()=>Ue("renderer"))),Ve.set(K.IExtensionsScannerService,new c.SyncDescriptor(le.ExtensionsScannerService)),Ve.set(u.IExtensionManagementService,new c.SyncDescriptor(i.ExtensionManagementService));const st=new f.InstantiationService(Ve);Ve.set(A.ILanguagePackService,st.createInstance(U.NativeLanguagePackService));const pt=st.createInstance(n.ExtensionManagementCLIService);Ve.set(u.IExtensionManagementCLIService,pt);const Tt=st.createInstance(ge.PtyHostService,{graceTime:108e5,shortGraceTime:3e5,scrollback:Ke.getValue("terminal.integrated.persistentSessionScrollback")??100});return Ve.set(oe.IPtyService,Tt),Ve.set(g.IEncryptionMainService,new c.SyncDescriptor(p.EncryptionMainService,[tt])),Ve.set(C.ICredentialsMainService,new c.SyncDescriptor(y.CredentialsWebMainService)),st.invokeFunction(at=>{const ut=at.get(u.IExtensionManagementService),ft=at.get(K.IExtensionsScannerService),vt=new ee.RemoteAgentEnvironmentChannel(qe,ke,pt,Be,Xe,ft);ae.registerChannel("remoteextensionsenvironment",vt);const yt=new z.ServerTelemetryChannel(at.get(te.IServerTelemetryService),xe);ae.registerChannel("telemetry",yt),ae.registerChannel(me.REMOTE_TERMINAL_CHANNEL_NAME,new ce.RemoteTerminalChannel(ke,Be,Tt,Ce,ut));const It=new G.RemoteAgentFileSystemProviderChannel(Be,ke);ae.registerChannel(re.REMOTE_FILE_SYSTEM_CHANNEL_NAME,It),ae.registerChannel("request",new ue.RequestChannel(at.get(B.IRequestService)));const Dt=new s.ExtensionManagementChannel(ut,Ft=>Ue(Ft.remoteAuthority));ae.registerChannel("extensions",Dt);const _t=D.ProxyChannel.fromService(at.get(g.IEncryptionMainService));ae.registerChannel("encryption",_t);const Lt=D.ProxyChannel.fromService(at.get(C.ICredentialsMainService));return ae.registerChannel("credentials",Lt),ut.removeDeprecatedExtensions(),Qe.add(new Z.default(at.get(F.ITelemetryService))),{telemetryService:at.get(F.ITelemetryService)}}),{socketServer:ae,instantiationService:st}}e.setupServerServices=Te;const Oe=Object.create(null);function Ue(qe){return Oe[qe]||(Oe[qe]=(0,J.createURITransformer)(qe)),Oe[qe]}class de extends D.IPCServer{constructor(){const ze=new t.Emitter;super(ze.event);this._onDidConnectEmitter=ze}acceptConnection(ze,He){this._onDidConnectEmitter.fire({protocol:ze,onDidClientDisconnect:He})}}e.SocketServer=de;class be extends x.AbstractLogger{constructor(ze=x.DEFAULT_LOG_LEVEL){super();this.setLevel(ze),this.useColors=Boolean(process.stdout.isTTY)}trace(ze,...He){this.getLevel()<=x.LogLevel.Trace&&(this.useColors?console.log(`[90m[${pe()}][0m`,ze,...He):console.log(`[${pe()}]`,ze,...He))}debug(ze,...He){this.getLevel()<=x.LogLevel.Debug&&(this.useColors?console.log(`[90m[${pe()}][0m`,ze,...He):console.log(`[${pe()}]`,ze,...He))}info(ze,...He){this.getLevel()<=x.LogLevel.Info&&(this.useColors?console.log(`[90m[${pe()}][0m`,ze,...He):console.log(`[${pe()}]`,ze,...He))}warn(ze,...He){this.getLevel()<=x.LogLevel.Warning&&(this.useColors?console.warn(`[93m[${pe()}][0m`,ze,...He):console.warn(`[${pe()}]`,ze,...He))}error(ze,...He){this.getLevel()<=x.LogLevel.Error&&(this.useColors?console.error(`[91m[${pe()}][0m`,ze,...He):console.error(`[${pe()}]`,ze,...He))}critical(ze,...He){this.getLevel()<=x.LogLevel.Critical&&(this.useColors?console.error(`[90m[${pe()}][0m`,ze,...He):console.error(`[${pe()}]`,ze,...He))}dispose(){}flush(){}}function pe(){const qe=new Date;return`${_e(qe.getHours())}:${_e(qe.getMinutes())}:${_e(qe.getSeconds())}`}function _e(qe){return qe<10?`0${qe}`:String(qe)}async function Ne(qe){const ze=k.basename(qe),He=k.dirname(qe),ae=(await v.Promises.readdir(He)).filter(ke=>/^\d{8}T\d{6}$/.test(ke)).sort().filter(ke=>ke!==ze),Ce=ae.slice(0,Math.max(0,ae.length-9));await Promise.all(Ce.map(ke=>v.Promises.rm(k.join(He,ke))))}}),define(we[258],ye([0,1,75,30,68,259,76,128,16,9,33,2,8,5,46,3,15,4,27,143,90,61,7,13,25,74,32,127,232,233,42,257,235]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C,y,d,S,h,g,p,m,l,u,n,s,i,o,r,a,c,f,w,A,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.RemoteExtensionHostAgentServer=void 0;const x=5*60*1e3;let Q=class extends R.Disposable{constructor(B,ue,V,$,F,M,j,Z){super();this._socketServer=B,this._connectionToken=ue,this._vsdaMod=V,this._environmentService=F,this._productService=M,this._logService=j,this._instantiationService=Z,this._webEndpointOriginChecker=Y.create(this._productService),this._serverRootPath=(0,o.getRemoteServerRootPath)(M),this._extHostConnections=Object.create(null),this._managementConnections=Object.create(null),this._allReconnectionTokens=new Set,this._webClientServer=$?this._instantiationService.createInstance(U.WebClientServer,this._connectionToken):null,this._logService.info("Extension host agent started.")}async handleRequest(B,ue){if(B.method!=="GET")return(0,U.serveError)(B,ue,405,`Unsupported method ${B.method}`);if(!B.url)return(0,U.serveError)(B,ue,400,"Bad request.");const V=k.parse(B.url,!0);let $=V.pathname;if(!$)return(0,U.serveError)(B,ue,400,"Bad request.");if($.startsWith(this._serverRootPath)&&$.charCodeAt(this._serverRootPath.length)===47&&($=$.substring(this._serverRootPath.length)),$==="/version")return ue.writeHead(200,{"Content-Type":"text/plain"}),ue.end(this._productService.commit||"");if($==="/delay-shutdown")return this._delayShutdown(),ue.writeHead(200),ue.end("OK");if(!(0,f.requestHasValidConnectionToken)(this._connectionToken,B,V))return(0,U.serveError)(B,ue,403,"Forbidden.");if($==="/vscode-remote-resource"){const F=V.query.path;if(typeof F!="string")return(0,U.serveError)(B,ue,400,"Bad request.");let M;try{M=g.URI.from({scheme:C.Schemas.file,path:F}).fsPath}catch{return(0,U.serveError)(B,ue,400,"Bad request.")}const j=Object.create(null);this._environmentService.isBuilt&&((0,T.isEqualOrParent)(M,this._environmentService.builtinExtensionsPath,!S.isLinux)||(0,T.isEqualOrParent)(M,this._environmentService.extensionsPath,!S.isLinux))&&(j["Cache-Control"]="public, max-age=31536000"),j.Vary="Origin";const Z=B.headers.origin;return Z&&this._webEndpointOriginChecker.matches(Z)&&(j["Access-Control-Allow-Origin"]=Z),(0,U.serveFile)(M,1,this._logService,B,ue,j)}if(this._webClientServer){this._webClientServer.handle(B,ue,V);return}return ue.writeHead(404,{"Content-Type":"text/plain"}),ue.end("Not found")}handleUpgrade(B,ue){let V=(0,p.generateUuid)(),$=!1,F=!1;if(B.url){const he=k.parse(B.url,!0).query;typeof he.reconnectionToken=="string"&&(V=he.reconnectionToken),he.reconnection==="true"&&($=!0),he.skipWebSocketFrames==="true"&&(F=!0)}if(B.headers.upgrade===void 0||B.headers.upgrade.toLowerCase()!=="websocket"){ue.end("HTTP/1.1 400 Bad Request");return}const M=B.headers["sec-websocket-key"],j=I.createHash("sha1");j.update(M+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const Z=j.digest("base64"),oe=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${Z}`];let ge=!1;if(!F&&!this._environmentService.args["disable-websocket-compression"]&&B.headers["sec-websocket-extensions"]){const he=Array.isArray(B.headers["sec-websocket-extensions"])?B.headers["sec-websocket-extensions"]:[B.headers["sec-websocket-extensions"]];for(const q of he)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(q)){if(/\b(permessage-deflate)\b/.test(q)){ge=!0,oe.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(q)){ge=!0,oe.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}ue.write(oe.join(`\r
`)+`\r
\r
`),ue.setTimeout(0),ue.setNoDelay(!0),F?this._handleWebSocketConnection(new u.NodeSocket(ue,`server-connection-${V}`),$,V):this._handleWebSocketConnection(new u.WebSocketNodeSocket(new u.NodeSocket(ue,`server-connection-${V}`),ge,null,!0),$,V)}handleServerError(B){this._logService.error("Error occurred in server"),this._logService.error(B)}_getRemoteAddress(B){let ue;return B instanceof u.NodeSocket?ue=B.socket:ue=B.socket.socket,ue.remoteAddress||"<unknown>"}async _rejectWebSocketConnection(B,ue,V){const $=ue.getSocket();this._logService.error(`${B} ${V}.`);const F={type:"error",reason:V};ue.sendControl(v.VSBuffer.fromString(JSON.stringify(F))),ue.dispose(),await $.drain(),$.dispose()}_handleWebSocketConnection(B,ue,V){const $=this._getRemoteAddress(B),F=`[${$}][${V.substr(0,8)}]`,M=new l.PersistentProtocol(B),j=this._vsdaMod?new this._vsdaMod.validator:null,Z=this._vsdaMod?new this._vsdaMod.signer:null;let oe;(function(ee){ee[ee.WaitingForAuth=0]="WaitingForAuth",ee[ee.WaitingForConnectionType=1]="WaitingForConnectionType",ee[ee.Done=2]="Done",ee[ee.Error=3]="Error"})(oe||(oe={}));let ge=0;const he=ee=>{ge=3,q.dispose(),this._rejectWebSocketConnection(F,M,ee)},q=M.onControlMessage(ee=>{if(ge===0){let G;try{G=JSON.parse(ee.toString())}catch{return he("Malformed first message")}if(G.type!=="auth")return he("Invalid first message");if(this._connectionToken.type===2&&!this._connectionToken.validate(G.auth))return he("Unauthorized client refused: auth mismatch");let z=(0,p.generateUuid)();if(Z)try{z=Z.sign(G.data)}catch{}let te=(0,p.generateUuid)();if(j)try{te=j.createNewMessage(te)}catch{}const ce={type:"sign",data:te,signedData:z};M.sendControl(v.VSBuffer.fromString(JSON.stringify(ce))),ge=1}else if(ge===1){let G;try{G=JSON.parse(ee.toString())}catch{return he("Malformed second message")}if(G.type!=="connectionType")return he("Invalid second message");if(typeof G.signedData!="string")return he("Invalid second message field type");const z=G.commit,te=this._productService.commit;if(z&&te&&z!==te)return he("Client refused: version mismatch");let ce=!1;if(!j)ce=!0;else if(this._connectionToken.validate(G.signedData))ce=!0;else try{ce=j.validate(G.signedData)==="ok"}catch{}if(!ce){if(this._environmentService.isBuilt)return he("Unauthorized client refused");this._logService.error(`${F} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(let J in this._managementConnections)this._managementConnections[J].shortenReconnectionGraceTimeIfNecessary();for(let J in this._extHostConnections)this._extHostConnections[J].shortenReconnectionGraceTimeIfNecessary();ge=2,q.dispose(),this._handleConnectionType($,F,M,B,ue,V,G)}})}async _handleConnectionType(B,ue,V,$,F,M,j){const Z=j.desiredConnectionType===1?`${ue}[ManagementConnection]`:j.desiredConnectionType===2?`${ue}[ExtensionHostConnection]`:ue;if(j.desiredConnectionType===1)if(F){if(!this._managementConnections[M])return this._allReconnectionTokens.has(M)?this._rejectWebSocketConnection(Z,V,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(Z,V,"Unknown reconnection token (never seen)");V.sendControl(v.VSBuffer.fromString(JSON.stringify({type:"ok"})));const oe=V.readEntireBuffer();V.dispose(),this._managementConnections[M].acceptReconnection(B,$,oe)}else{if(this._managementConnections[M])return this._rejectWebSocketConnection(Z,V,"Duplicate reconnection token");V.sendControl(v.VSBuffer.fromString(JSON.stringify({type:"ok"})));const oe=new c.ManagementConnection(this._logService,M,B,V);this._socketServer.acceptConnection(oe.protocol,oe.onClose),this._managementConnections[M]=oe,this._allReconnectionTokens.add(M),oe.onClose(()=>{delete this._managementConnections[M]})}else if(j.desiredConnectionType===2){const oe=j.args||{language:"en"},ge=await this._updateWithFreeDebugPort(oe);if(ge.port&&this._logService.trace(`${Z} - startParams debug port ${ge.port}`),this._logService.trace(`${Z} - startParams language: ${ge.language}`),this._logService.trace(`${Z} - startParams env: ${JSON.stringify(ge.env)}`),F){if(!this._extHostConnections[M])return this._allReconnectionTokens.has(M)?this._rejectWebSocketConnection(Z,V,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(Z,V,"Unknown reconnection token (never seen)");V.sendPause(),V.sendControl(v.VSBuffer.fromString(JSON.stringify(ge.port?{debugPort:ge.port}:{})));const he=V.readEntireBuffer();V.dispose(),this._extHostConnections[M].acceptReconnection(B,$,he)}else{if(this._extHostConnections[M])return this._rejectWebSocketConnection(Z,V,"Duplicate reconnection token");V.sendPause(),V.sendControl(v.VSBuffer.fromString(JSON.stringify(ge.port?{debugPort:ge.port}:{})));const he=V.readEntireBuffer();V.dispose();const q=this._instantiationService.createInstance(a.ExtensionHostConnection,M,B,$,he);this._extHostConnections[M]=q,this._allReconnectionTokens.add(M),q.onClose(()=>{delete this._extHostConnections[M],this._onDidCloseExtHostConnection()}),q.start(ge)}}else if(j.desiredConnectionType===3){const oe=j.args;this._createTunnel(V,oe)}else return this._rejectWebSocketConnection(Z,V,"Unknown initial data received")}async _createTunnel(B,ue){const V=B.getSocket().socket,$=B.readEntireBuffer();B.dispose(),V.pause();const F=await this._connectTunnelSocket(ue.host,ue.port);$.byteLength>0&&F.write($.buffer),F.on("end",()=>V.end()),F.on("close",()=>V.end()),F.on("error",()=>V.destroy()),V.on("end",()=>F.end()),V.on("close",()=>F.end()),V.on("error",()=>F.destroy()),F.pipe(V),V.pipe(F)}_connectTunnelSocket(B,ue){return new Promise((V,$)=>{const F=b.createConnection({host:B,port:ue},()=>{F.removeListener("error",$),F.pause(),V(F)});F.once("error",$)})}_updateWithFreeDebugPort(B){return typeof B.port=="number"?(0,m.findFreePort)(B.port,10,5e3).then(ue=>(B.port=ue,B)):(B.debugId=void 0,B.port=void 0,B.break=void 0,Promise.resolve(B))}async _onDidCloseExtHostConnection(){if(!this._environmentService.args["enable-remote-auto-shutdown"])return;this._cancelShutdown(),!!Object.keys(this._extHostConnections).length||(console.log("Last EH closed, waiting before shutting down"),this._logService.info("Last EH closed, waiting before shutting down"),this._waitThenShutdown())}_waitThenShutdown(){!this._environmentService.args["enable-remote-auto-shutdown"]||(this._environmentService.args["remote-auto-shutdown-without-delay"]?this._shutdown():this.shutdownTimer=setTimeout(()=>{this.shutdownTimer=void 0,this._shutdown()},x))}_shutdown(){if(!!Object.keys(this._extHostConnections).length){console.log("New EH opened, aborting shutdown"),this._logService.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this._logService.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}_delayShutdown(){this.shutdownTimer&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this._logService.info("Got delay-shutdown request while in shutdown timeout, delaying"),this._cancelShutdown(),this._waitThenShutdown())}_cancelShutdown(){this.shutdownTimer&&(console.log("Cancelling previous shutdown timeout"),this._logService.info("Cancelling previous shutdown timeout"),clearTimeout(this.shutdownTimer),this.shutdownTimer=void 0)}};Q=Re([Fe(4,w.IServerEnvironmentService),Fe(5,i.IProductService),Fe(6,s.ILogService),Fe(7,n.IInstantiationService)],Q),e.RemoteExtensionHostAgentServer=Q;async function _(O,B,ue){const V=await(0,f.determineServerConnectionToken)(B);V instanceof f.ServerConnectionTokenParseError&&(console.warn(V.message),process.exit(1));const $=new R.DisposableStore,{socketServer:F,instantiationService:M}=await(0,A.setupServerServices)(V,B,ue,$);M.invokeFunction(G=>{const z=G.get(s.ILogService);(0,D.setUnexpectedErrorHandler)(te=>{te&&te.code==="EPIPE"&&te.syscall==="write"&&te.stack&&/unexpectedErrorHandler/.test(te.stack)||z.error(te)}),process.on("SIGPIPE",()=>{(0,D.onUnexpectedError)(new Error("Unexpected SIGPIPE"))})}),M.invokeFunction(G=>{const z=G.get(s.ILogService);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const te=(0,y.join)(process.env.HOMEDRIVE,"node_modules"),ce=(0,y.dirname)((0,y.join)(process.env.HOMEDRIVE,process.env.HOMEPATH)),J=(0,y.join)(ce,"node_modules");if(t.existsSync(te)||t.existsSync(J)){const se=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${te}
* ${J}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;z.warn(se),console.warn(se),process.exit(0)}}});const j=M.invokeFunction(G=>{const z=G.get(s.ILogService);if(t.existsSync((0,y.join)(C.FileAccess.asFileUri("",ie).fsPath,"../node_modules/vsda")))try{return ie.__$__nodeRequire("vsda")}catch(ce){z.error(ce)}return null}),Z=t.existsSync(C.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html",ie).fsPath);if(Z&&O&&typeof O!="string"){const G=V.type!==0?`?${C.connectionTokenQueryName}=${V.value}`:"";console.log(`Web UI available at http://localhost${O.port===80?"":`:${O.port}`}/${G}`)}const oe=M.createInstance(Q,F,V,j,Z);d.mark("code/server/ready");const ge=P.performance.now(),he=global.vscodeServerStartTime,q=global.vscodeServerListenTime,ee=global.vscodeServerCodeLoadedTime;if(M.invokeFunction(G=>{G.get(r.ITelemetryService).publicLog2("serverStart",{startTime:he,startedTime:q,codeLoadedTime:ee,readyTime:ge})}),B["print-startup-performance"]){const G=E.LoaderStats.get();let z="";z+=`

### Load AMD-module
`,z+=E.LoaderStats.toMarkdownTable(["Module","Duration"],G.amdLoad),z+=`

### Load commonjs-module
`,z+=E.LoaderStats.toMarkdownTable(["Module","Duration"],G.nodeRequire),z+=`

### Invoke AMD-module factory
`,z+=E.LoaderStats.toMarkdownTable(["Module","Duration"],G.amdInvoke),z+=`

### Invoke commonjs-module
`,z+=E.LoaderStats.toMarkdownTable(["Module","Duration"],G.nodeEval),z+=`Start-up time: ${q-he}
`,z+=`Code loading time: ${ee-he}
`,z+=`Initialized time: ${ge-he}
`,z+=`
`,console.log(z)}return oe}e.createServer=_;class Y{constructor(B){this._originRegExp=B}static create(B){const ue=B.webEndpointUrlTemplate,V=B.commit,$=B.quality;if(!ue||!V||!$)return new Y(null);const F=(0,p.generateUuid)(),j=new URL(ue.replace("{{uuid}}",F).replace("{{commit}}",V).replace("{{quality}}",$)).origin,Z=(0,h.escapeRegExpCharacters)(j).replace(F,"[a-zA-Z0-9\\-]+");try{const oe=(0,h.createRegExp)(`^${Z}$`,!0,{matchCase:!1});return new Y(oe)}catch{return new Y(null)}}matches(B){return this._originRegExp?this._originRegExp.test(B):!1}}}),define(we[268],ye([0,1,28,30,8,254,258,54,5,259,42,48,46]),function(ie,e,I,t,b,P,k,E,v,D,T,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,C.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=D.performance.now();const y={onMultipleValues:(o,r)=>{console.error(`Option '${o}' can only be defined once. Using value ${r}.`)},onEmptyValue:o=>{console.error(`Ignoring option '${o}': Value must not be empty.`)},onUnknownOption:o=>{console.error(`Ignoring option '${o}': not supported for server.`)},onDeprecatedOption:(o,r)=>{console.warn(`Option '${o}' is deprecated: ${r}`)}},d=(0,E.parseArgs)(process.argv.slice(2),T.serverOptions,y),S=d["server-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,v.join)(I.homedir(),R.default.serverDataFolderName||".vscode-remote"),h=(0,v.join)(S,"data"),g=(0,v.join)(h,"User"),p=(0,v.join)(g,"globalStorage"),m=(0,v.join)(g,"History"),l=(0,v.join)(h,"Machine");d["user-data-dir"]=h;const u=(0,v.dirname)(b.FileAccess.asFileUri("",ie).fsPath),n=(0,v.join)(u,"extensions");d["builtin-extensions-dir"]=n,d["extensions-dir"]=d["extensions-dir"]||(0,v.join)(S,"extensions"),[S,d["extensions-dir"],h,g,l,p,m].forEach(o=>{try{t.existsSync(o)||t.mkdirSync(o,{mode:448})}catch(r){console.error(r)}});function s(){(0,P.run)(d,S,T.serverOptions)}e.spawnCli=s;function i(o){return(0,k.createServer)(o,d,S)}e.createServer=i})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/30d9c6cd9483b2cc586687151bcbcd635f373630/core/vs/server/node/server.main.js.map
